#!/usr/bin/php
<?php
	
    require(__DIR__.DIRECTORY_SEPARATOR."Curl.php");
    
    for ($i=1; $i < $argc; $i++) {parse_str($argv[$i]);}
    
    $routesDir = __DIR__.DIRECTORY_SEPARATOR.'routes.json';
    try {
        $routes = json_decode(file_get_contents($routesDir));
    }
    catch(\Exception $e) {
        throw new \Exception("Arquivo de rotas não encontrado!");
    }
    
    $data = new \StdClass();
    
    $requiredParameters = array();
    $optionalParameters = array();
    
    if(isset($url)) {

	$rota = explode('index.php', $url)[1];
        foreach ($routes as $route) {
            if($route->uri == $rota) {
                $requiredParameters = isset($route->requiredParameters) ? $route->requiredParameters : array();
                $optionalParameters = isset($route->optionalParameters) ? $route->optionalParameters : array();
            }
        }
        if(count($requiredParameters) > 0) {
            foreach($requiredParameters as $requiredParameter) {
                if(isset($$requiredParameter)) {
                    $data->$requiredParameter = $$requiredParameter;
                }
                else {
                    throw new \Exception("Parametro obrigatório '$requiredParameter' não informado");
                }
            } 
        }
        if(count($optionalParameters) > 0) {
            foreach($optionalParameters as $parameter) {
                if(isset($$parameter)) {
                    $data->$parameter = $$parameter;
                } 
				else {
                    throw new \Exception("Parametro obrigatório '$parameter' não informado");
                }
            } 
        }
        if(isset($data)) {
            $callService = new CallService($url, $data);
			//var_dump($data);die;
			
        }
        else throw new \Exception("Dados para requisição não informados.");
    }
    else throw new \Exception("Rota não informada");

    class CallService {
        
        private $url;
        private $data;
        
        public function __construct($url, $data) {
            $this->url  = $url;
            $this->data = $data;
            $this->curlRequest();
        }
        
        public function curlRequest() {
            try {
                $curl = new Curl($this->url);
                $curl->setPost($this->data);
                echo $curl->createCurl();
                echo $curl->__tostring();
            }
            catch (\Exception $e) {
                throw $e;
            }
        }
    }
?>
