'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

// FILE: ./assets/js/utilities/Messages_fiscal.js
var Messages_fiscal = function Messages_fiscal() {

    /* + ----------------------------------- +
     * | Error messages                      |
     * + ----------------------------------- + */
    this.CATCH_EXCEPTION_ERROR = function (error) {
        return 'Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + error + '<br><br>';
    };

    this.SAVE_ROW_ERROR = 'Erro ao salvar o registro';
    this.REMOVE_ROW_ERROR = 'Erro ao excluir o registro';

    this.IMPORTACAO_ERROR = 'Erro ao realizar importação';
    this.DELETE_IMPORTA_TIPO_ITEM_ERROR = 'Não foi possível realizar a importação. Existem registros relacionados na tela "Livro Magnético -> Gênero/Item por Produto"';

    this.TIMEOUT_ERROR = 'Timeout';

    this.DADOS_NAO_ENCONTRADOS_ERROR = 'Dados não encontrados';

    this.DTINI_POST_DTFIM_ERROR = 'A data final deve ser igual ou posterior à data inicial';
    this.DATA_POST_DTATUAL_ERROR = 'Data deve ser igual ou posterior à data atual';

    this.INTERVALO_INV_PRODUTO_ERROR = 'O produto final deve ser maior ou igual ao produto inicial';

    this.EXCL_LIVRO_PADRAO_ERROR = 'Não é possível excluir o livro padrão';
    this.EXISTE_LIVRO_PADRAO_ERROR = 'Deve existir um livro padrão';
    this.LIVRO_ORIG_SEM_DADOS = 'Não existem dados para replicação no livro de origem';

    this.PARAMETROS_GERAIS_NAO_INFORMADOS_ERROR = 'Parâmetros gerais devem ser informados.';
    this.EMPRESA_NAO_INFORMADA_ERROR = 'Empresa deve ser informada';
    this.INSCRICAO_NAO_INFORMADA_ERROR = 'Inscrição estadual deve ser informada';
    this.FILTRO_INVALIDO_ERROR = 'Existem campos não preenchidos ou inválidos no filtro';

    this.PARAM_IMPOSTO_RELAC_ERROR = 'Os impostos relacionados devem possuir as mesmas parametrizações para Orgão Arrecadador, Imposto Recuperável e Forma de Apuração';
    this.MAPA_REGIME_EMPRESA_ERROR = 'Regime da empresa não permite inserir/alterar as informações para esse tipo de apuração';
    this.PERIODO_APURADCAO = 'Período de apuração deve estar compreendido no mesmo mês.';
    this.MAPA_ANTERIOR_APURADO = 'Mapa anterior deve estar apurado.';
    this.MAPA_POSTERIOR_BLOQUEADO = 'Mapa posterior deve estar desbloqueado.';
    this.MAPA_ANTERIOR_BLOQUEADO = 'Mapa anterior deve estar bloqueado.';
    this.SEQUENCIAL_JA_CADASTRADO = 'Sequencial já cadastrado.';
    this.AJUSTE_CREDITO_CUMULATIVO_ERROR = 'Tipo de Ajuste de Crédito só pode ser gerado para o Regime não Cumulativo.';
    this.COMPOR_ITENS = 'Para Compor Valor dos Itens, Nota Fiscal deve ser Informada.';
    this.REPLICAR_INFORMACOES_ADICIONAIS = 'Todos os itens serão sobrepostos pelos itens do mês anterior. Confirma importação?';
    /* + ----------------------------------- +
     * | Successful messages                 |
     * + ----------------------------------- + */
    this.CADASTRO_AUTOMATICO_SUCCESS = 'Cadastro automático realizado com sucesso';

    this.SAVE_ROW_SUCCESS = 'Registro salvo com sucesso';
    this.REMOVE_ROW_SUCCESS = 'Registro excluído com sucesso';

    this.IMPORTACAO_SUCCESS = 'Importação realizada com sucesso';
    this.EXPORTACAO_SUCCESS = 'Exportação realizada com sucesso';
    this.REPLICACAO_SUCESS = 'Replicação realizada com sucesso';
    this.APURACAO_SUCCESS = 'Apuração realizada com sucesso';
    this.MAPA_BLOQUEADO_SUCESSO = 'Mapa bloqueado com sucesso.';
    this.MAPA_DESBLOQUEADO_SUCESSO = 'Mapa desbloqueado com sucesso.';
    /* + ----------------------------------- +
     * | Alert messages                      |
     * + ----------------------------------- + */
    this.DELETE_ROW = 'Deseja realmente excluir o registro?';
    this.DELETE_FILHOS = 'O registro possui registros filhos. Tem certeza que deseja excluir?';
    this.CONFIRMA_IMPORTACAO = 'Todos os dados serão sobrescritos. Deseja realmente realizar a importação?';
    this.CONFIRMA_REPLICACAO_LIVRO = 'Todos os dados do livro de destino serão sobrescritos pelo livro de origem. Deseja realmente realizar a replicação?';
    this.OBRIGATORIO_INFOSUSP = 'É necessário cadastras ao menos uma Informação de Suspensão para esse processo, para que ele possa ser utilizado.';

    /* + ----------------------------------- +
     * | General messages                    |
     * + ----------------------------------- + */
    this.INFORMAR_DADOS_REGISTRO1400 = 'Devem ser informados os dados para geração do registro 1400 - Informação sobre valores agregados.';
    this.INVENTARIO_SEM_INFORMACOES = 'Bloco H - Inventário Fiscal gerado sem informações.';
    this.EXPORTANDO = 'Exportando...';
    this.EXPORTANDO_GIA = 'Exportando GIA...';
    this.EXPORTANDO_SINTEGRA = 'Exportando SINTEGRA...';
    this.EXPORTANDO_SPED = 'Exportando SPED...';
    this.EXPORTANDO_LIVRO_ELETRONICO = 'Exportando Livro Eletronico...';
    this.EXPORTANDO_DIEF = 'Exportando DIEF...';
    this.EXPORTANDO_DAC_AL = 'Exportando DAC-AL...';
    this.EXPORTANDO_SEF_II = 'Exportando SEF II...';
    this.EXPORTANDO_DMA_BA = 'Exportando DMA-BA...';
    this.EXPORTANDO_DOT_GI_ICMS = 'Exportando DOT/GI-ICMS...';
    this.EXPORTANDO_GIA_RJ = 'Exportando GIA-RJ...';
    this.EXPORTANDO_GIM_PB = 'Exportando GIM-PB...';
    this.EXPORTANDO_VALIDA_PR = 'Exportando ValidaPR...';
    this.EXPORTANDO_DIME_SC = 'Exportando DIME-SC...';
    this.EXPORTANDO_GI_ICMS = 'Exportando GI/ICMS...';
    this.EXPORTANDO_COMPRA_LEGAL_BA = 'Exportando Compra LEGAL - BA...';
    this.EXPORTANDO_DES = 'Exportando DES...';

    /**************************************
    *    Mensagens REINF                  * 
    **************************************/
    this.PARAMETROS_REINF = 'Empresa não possui parâmetros para envio do Reinf cadastrados.';
    this.TAMANHO_LOTE_ENVIO_REINF = 'O lote pode ser composto, no máximo, por 100 eventos.';
    this.LOTE_STATUS_ERROR = "O lote só pode ser transmitido com eventos pendentes ou com erro.";
    this.LOTE_VERSAO_ERROR = "O lote só pode ser transmitido com eventos na mesma versão.";
    this.LOTE_AMBIENTE_ERROR = "O lote só pode ser transmitido com eventos no mesmo ambiente.";
    this.LOTE_COMPETENCIA_ERROR = "O lote só pode ser transmitido com eventos na mesma competência.";
    this.OPERACAO_DIFERENTE = "Foram selecionados eventos com operações diferentes. Só é permitido envio de mais de um evento quando os mesmos tem a mesma operação. Selecione apenas os eventos com mesma operação.";
    this.OEPRACAO_SEM_ROTA = "Não foi encontrado opção de rota para esse tipo de operação.";
    this.TIPO_OPERACAO_INVALIDA_PARA_R1000 = "Só é permitido adiconar eventos R-1000 com operação de Exclusão ou Inclusão.";
    this.EVENTOS_NAO_PODE_SER_EXCLUIDO = "So podem ser excluídos eventos que não tenham recibo, que não estejam concluidos, que não estejam em processamento e que não estejam reabertos.";
    this.EVENTO_DIFERENTE_ERROR = "Somente envios pertencentes a um mesmo evento podem ser enviados em um lote.";

    /**************************************
    * Mensagens Documento de Arrecação    * 
    **************************************/
    this.UNIDADE_PAGAMENTO = "Unidade de Pagamento deve ser informada.";
    this.VENCIMENTO_PAGAMENTO = "Data de Vencimento deve ser informada.";
    this.LIMITE_PAGAMENTO = "Data de Limite para Pagamento deve ser informada.";
    this.CDRECEITA_PAGAMENTO = "Código da Receita deve ser informada.";
    this.NATUREZA_RJ = "Natureza deve ser informada.";
    this.SUCESSO_PREPARACAO = "Preparação de Pagamento realizada com sucesso.";
    this.SUCESSO_CANCELAMENTO = "Cancelamento Financeiro concluído.";
    this.RELATORIO_NAO_ENCONTRADO = "Relatório não encontrado.";
    this.RELATORIO_NAO_DISPONIVEL = "Relatório ainda não disponível.";
    this.OPCAO_INVALIDA_GUIA = "Opção de Tipo de Guia inválida.";
    this.LOTE_INVALIDO = "Lote não consultado ou processado com erros.";
    this.LOTE_CONSULTADO = "Lote já consultado.";
    this.GUIA_VENCIDA = "A guia está vencida.";
    this.GUIAS_VENCIDAS_SITE_BIRT = "Uma ou mais guias encontra(m)-se vencida(s). Deseja emiti-las pelo site da Receita Federal? Caso contrário as DARFs serão emitidas pelo sistema sem código de barras.";
    this.GUIA_NAO_TRANS = "A guia não foi transmitida.";
    this.EMITIR_DARF = "Deseja emitir a DARF via site do Ministério da Fazenda?";
    this.EMITIR_GARE = "Deseja emitir a GARE via site da Secretaria da Fazenda do Estado de São Paulo?";
    this.EMITIR_GRPR = "Deseja emitir a GRPR via site da Secretaria da Fazenda do Estado do Paraná?";
    this.EMITIR_DARE_SC = "Deseja emitir a DARE-SC via site da Secretaria de Estado da Fazenda do Estado de Santa Catarina?";
    this.EMITIR_DAEMS = "Deseja emitir a DAEMS via site da Secretaria da Fazenda do Estado do Mato Grosso do Sul?";
    this.EMITIR_GNRE_SP = "Deseja emitir a GNRE via site da Secretaria da Fazenda e Planejamento do Estado de São Paulo?";
    this.SELECIONE_LINHAS = 'Uma ou mais linhas devem ser selecionadas.';
    this.LIMITE_LINHAS_GNRE = 'Selecione no máximo 50 linhas.';

    /*****************************************************
    * Mensagens Parametrização de Expotação Municipal    * 
    *****************************************************/
    this.SEM_FILTRO_EXPORTACAO_MUNI = "É necessário filtrar uma empresa e inscrição municipal para realizar essa operação.";
    this.PERGUNTA_CADASTRAMENTO_AUTOMTICO = "O que deseja fazer?";
    /**********************************
    * Mensagens Conferência Fiscal    * 
    ***********************************/
    this.IMPOSTO_REL_SEM_PARAM = "Os impostos relacionados (#1) devem possuir as mesmas parametrizações para Órgão Arrecadador e Forma de Apuração.";
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Messages_fiscal', Messages_fiscal);
});

// FILE: ./assets/js/utilities/VersionDataLibs.js
function VersionDataLibs(templateManager, eventAggregator, requestDataSourceEngine, ZHPromise) {
    var self = this;

    this.showErrorMessage = function (error) {
        var message = error;
        if ((typeof error === 'undefined' ? 'undefined' : _typeof(error)) === 'object') {
            if (error.message) {
                message = error.message;
            } else if (error.data && error.data.error) {
                message = error.data.error;
            }
        }

        if (!message) {
            message = 'Ocorreu um erro inesperado. Entre em contato com o administrador do sistema.';
        } else if (message.indexOf('Exception: Exception: ') != -1) {
            message = message.replace('Exception: Exception: ', '');
        }

        ScreenService.showMessage(message, 'error');
    };

    self.buildVersion = function () {
        var deferred = ZHPromise.defer();
        if (!templateManager.versionData) {
            templateManager.versionData = true;
            var filter = [{
                name: 'CURRENT_MODULE',
                operator: '=',
                value: 'fis'
            }];
            return requestDataSourceEngine.getDataSource('fis#/lib_getVersionInfo', filter).then(function (response) {
                templateManager.versionData = response.dataset.versionInfo;
                templateManager.versionData.dependencies.changeCurrentVersion = function (newVersion) {
                    templateManager.versionData.dependencies.current = templateManager.versionData.dependencies[newVersion];
                };
            }).catch(function () {
                deferred.reject(self.showErrorMessage);
            });
        } else {
            deferred.resolve();
        }
        return deferred.promise;
    };

    /*Esta função foi temporariamente criada para corrigir erros na geração do
    reporte em ambiente de produção para corrigir erros de incompatibilidade 
    entre o framework e a libs. Devendo posteriormente ser retirada.*/
    eventAggregator.subscribe("AboutOnClick", this.buildVersion);

    eventAggregator.subscribe("beforeProjectStartup", function () {
        templateManager.updateVersionData = self.buildVersion;
    });
}
Configuration(function (ContextRegister) {
    ContextRegister.register("VersionDataLibs", VersionDataLibs);
});

// FILE: ./assets/modules/acessorias/assets/js/utilities/Fis91000_ObrigacoesAcessorias_Controller.js
var ObrigacoesAcessoriasUtil = function ObrigacoesAcessoriasUtil(ScreenService, templateManager, ZHPromise, Messages_fiscal, General, restEngine) {

    // Variável para guardar o escopo atual nas funções.
    var self = this;
    // Variável de controle para o armazenamento da widget atualmente aberta.
    var windowCurrentlyOpen = false;

    /*
     * Função para atualizar um field select conforme necessidade.
     * Caso algum filtro deste select seja alterado, por exemplo, a propriedade
     * "needReload" do field será setada pra true, indicando que o campo precisa
     * ser atualizado. Alterar a propriedade para false depois impede que o campo
     * sempre seja atualizado sem necessidade.
     */
    this.checkFieldNeedReload = function (field) {
        // Verifica se a propriedade não foi setada como false.
        if (field.needReload !== false) {
            // Caso não tenha, recarrega o field e seta a propriedade como false.
            field.reload();
            field.needReload = false;
        }
    };

    /*
     * Função para sair de uma "tela" e retornar à widget principal.
     */
    this.closeSwipe = function (widget) {
        // Prepara uma promise para esta função.
        var deferred = ZHPromise.defer();
        var mainWidget = templateManager.container.getWidget("mainWidget");

        // Desativa a widget atualmente aberta.
        widget.deactivate();

        // Limpa a variável que indica qual a widget atualmente aberta.
        windowCurrentlyOpen = false;

        // Fecha o swipe.
        ScreenService.goBack().then(function () {
            // Ativa a widget principal.
            mainWidget.activate();
            // Finaliza a promise retornada.
            deferred.resolve();
        });
        // Retorna a promise preparada.
        return deferred.promise;
    };

    /*
     * Função que altera a propriedade readOnly do campo de inscrição conforme
     * a inserção de empresa. Também reseta qualquer valor previamente preenchido.
     */
    this.empresaOnChange = function (widget) {
        // Variável booleana que é setada como true caso alguma empresa tenha sido selecionada.
        //blabla
        var empresaIsSelected = !!widget.currentRow.CDEMPRESA;
        var inscricaoField = widget.getField('CDINSCESTA');

        // Altera as propriedades do field de inscrição e reseta seu valor.
        inscricaoField.readOnly = !empresaIsSelected;
        inscricaoField.setValue(null);
        inscricaoField.needReload = true;
    };
    this.empresaOnChangedis = function (widget) {
        // Variável booleana que é setada como true caso alguma empresa tenha sido selecionada.
        //blabla
        var empresaIsSelected = !!widget.currentRow.CDEMPRESADISTR;
        var inscricaoField = widget.getField('CDINSCESTADISTR');

        // Altera as propriedades do field de inscrição e reseta seu valor.
        inscricaoField.readOnly = !empresaIsSelected;
        inscricaoField.setValue(null);
        inscricaoField.needReload = true;
    };

    this.empresaOnChangeInsc = function (widget) {
        // Variável booleana que é setada como true caso alguma empresa tenha sido selecionada.
        //blabla
        var empresaIsSelected = !!widget.currentRow.CDEMPRESA;
        var inscricaoField = widget.getField('CDINSCRICAO');

        // Altera as propriedades do field de inscrição e reseta seu valor.
        inscricaoField.readOnly = !empresaIsSelected;
        inscricaoField.setValue(null);
        inscricaoField.needReload = true;
    };

    /*
     * Função auxiliar para a chamada da função de exportação no backend.
     * Criada para uma padronização nas exportações das telas.
     */
    this.exportarArquivo = function (row, route, message) {
        // Inicializa uma promise.
        var deferred = ZHPromise.defer();
        message = message || Messages_fiscal.EXPORTANDO;

        // Muda a mensagem de carregamento para uma mensagem personalizada.
        ScreenService.changeLoadingMessage(message);

        // Chama a rota para efetuar a exportação.
        restEngine.request(route, { "requestType": "Row", "row": row }, undefined, undefined, undefined, undefined, 99999999999999999999).then(function (response) {
            // Cria a rota a ser chamada para o download do arquivo exportado.
            var downloadRoute = window.serviceUrls.filter(function (x) {
                return x.package == 'fis';
            })[0].baseUrl + "/downloadArquivo?requestType=Row&row[DSARQUIVO]=";
            var fileName = response.dataset.columnsToReturn.fileName;

            // Abre a rota em uma nova janela, permitindo que o arquivo seja baixado.
            window.open(downloadRoute + fileName);

            // Finaliza a promise com sucesso.
            deferred.resolve(response);
        }).catch(function (error) {
            // Mensagem padrão em caso de timeout.
            var errorMessage = Messages_fiscal.TIMEOUT_ERROR;

            // Verifica se houve alguma resposta da requisição.
            if (error.data && error.data.error) {
                // Caso haja alguma resposta, atribui a mensagem de erro.
                errorMessage = error.data.error;
            }

            // Imprime a mensagem.
            ScreenService.showMessage(errorMessage);

            // Finaliza a promise retornando o objeto de erro.
            deferred.reject(error);
        }).finally(function () {
            // Restaura a mensagem original.
            ScreenService.restoreDefaultLoadingMessage();
        });

        // Retorna a promise a ser finalizada.
        return deferred;
    };

    this.exportarArquivoGiam = function (row, param, route, message) {
        // Inicializa uma promise.
        var deferred = ZHPromise.defer();
        message = message || Messages_fiscal.EXPORTANDO;

        // Muda a mensagem de carregamento para uma mensagem personalizada.
        ScreenService.changeLoadingMessage(message);

        // Chama a rota para efetuar a exportação.
        restEngine.request(route, { "requestType": "Row", "row": row }, undefined, undefined, undefined, undefined, 99999999999999999999).then(function (response) {
            // Cria a rota a ser chamada para o download do arquivo exportado.
            var downloadRoute = window.serviceUrls.filter(function (x) {
                return x.package == 'fis';
            })[0].baseUrl + "/downloadArquivo?requestType=Row&row[DSARQUIVO]=";
            var fileName = response.dataset.columnsToReturn.fileName;

            // Abre a rota em uma nova janela, permitindo que o arquivo seja baixado.
            window.open(downloadRoute + fileName);

            // Finaliza a promise com sucesso.
            deferred.resolve(response);
        }).catch(function (error) {
            // Mensagem padrão em caso de timeout.
            var errorMessage = Messages_fiscal.TIMEOUT_ERROR;

            // Verifica se houve alguma resposta da requisição.
            if (error.data && error.data.error) {
                // Caso haja alguma resposta, atribui a mensagem de erro.
                errorMessage = error.data.error;
            }

            // Imprime a mensagem.
            ScreenService.showMessage(errorMessage);

            // Finaliza a promise retornando o objeto de erro.
            deferred.reject(error);
        }).finally(function () {
            // Restaura a mensagem original.
            ScreenService.restoreDefaultLoadingMessage();
        });

        // Retorna a promise a ser finalizada.
        return deferred;
    };

    this.findLastRowData = function (widgetName, row) {
        return restEngine.post("fis_acessorias#/" + widgetName + "/findLastRowData", {
            "requestType": "Row",
            "row": row
        });
    };

    /*
     * Função para o retorno da data atual.
     */
    this.getCurrentDate = function () {
        return moment().format("DD/MM/YYYY");
    };

    /*
     * Função para o retorno do primeiro dia do mês da data atual.
     */
    this.getFirstDayOfMonth = function () {
        return moment().startOf('month').format("DD/MM/YYYY");
    };

    /*
     * Função para o retorno do último dia do mês da data atual.
     */
    this.getLastDayOfMonth = function () {
        return moment().endOf('month').format("DD/MM/YYYY");
    };

    /*
     * Função que verifica o clique em uma das opções disponíveis na widget
     * principal. Determina se um swipe será aberto ou não, dependendo da
     * opção selecionada.
     */
    this.mainWidgetAfterMoveRow = function (widget) {
        // Guarda o nome da widget relacionada à opção clicada, se houver.
        var windowToOpen = widget.currentRow.WINDOW;
        // Guarda a propriedade "ENABLED" da opção selecionada.
        var windowEnabled = widget.currentRow.ENABLED;

        // Verifica se há uma widget associada (não for um submenu) e se esta
        // está habilitada (a tela estiver disponível para ser utilizada).
        if (windowToOpen && windowEnabled) {
            // Verifica se já há uma widget aberta e se esta é diferente da
            // selecionada.
            if (windowCurrentlyOpen && windowCurrentlyOpen != windowToOpen) {
                // Fecha o swipe com a widget já aberta.
                self.closeSwipe(templateManager.container.getWidget(windowCurrentlyOpen)).then(function () {
                    // Abre o swipe na widget selecionada.
                    ScreenService.openSwipe(templateManager.container.getWidget(windowToOpen));
                });
            }
            // Senão, abre o swipe na opção selecionada.
            else {
                    // Abre o swipe na widget selecionada.
                    ScreenService.openSwipe(templateManager.container.getWidget(windowToOpen));
                }
            // Altera a variável de controle da widget atualmente aberta.
            windowCurrentlyOpen = windowToOpen;
        }
        // Senão, verifica se não há a propriedade "ENABLED" na opção
        // selecionada, indicando que é um submenu.
        else if (windowEnabled !== false) {
                // Altera o estado aberto/fechado do submenu.
                widget.currentRow._opened = !widget.currentRow._opened;
            }
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('ObrigacoesAcessoriasUtil', ObrigacoesAcessoriasUtil);
});

// FILE: ./assets/js/repositories/Fis00800_InventarioFiscal_Repository.js
var Fis00800_InventarioFiscal_Repository = function Fis00800_InventarioFiscal_Repository(restEngine) {

    this.importInventFisc = function (Row) {
        return restEngine.post('fis#/inventfisc_invfisc/import', {
            "requestType": "Row",
            "row": Row
        });
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis00800_InventarioFiscal_Repository', Fis00800_InventarioFiscal_Repository);
});

// FILE: ./assets/js/repositories/Fis01000_ClassificacaoFiscalProduto_Repository.js
var Fis01000_ClassificacaoFiscalProduto_Repository = function Fis01000_ClassificacaoFiscalProduto_Repository(restEngine) {
    this.cadastramentoAutomatico = function (row) {
        return restEngine.post('fis#/cadastramentoAutomaticoClassificaoFiscalProduto', {
            "requestType": "Row",
            "row": row
        });
    };
};
Configuration(function (ContextRegister) {
    ContextRegister.register('Fis01000_ClassificacaoFiscalProduto_Repository', Fis01000_ClassificacaoFiscalProduto_Repository);
});

// FILE: ./assets/js/repositories/Fis07200_LivroMagnetico_Repository.js
var Fis07200_LivroMagnetico_Repository = function Fis07200_LivroMagnetico_Repository(restEngine) {

    this.deletaLayoutCFOPLivroMag = function (Row) {
        return restEngine.post('fis#/livromagnetico_layout_cfop/delete', {
            "requestType": "Row",
            "row": Row
        });
    };
    this.deletaCadastroTipo = function (Row) {
        return restEngine.post('fis#/livromagnetico_tipo_cfop/delete', {
            "requestType": "Row",
            "row": Row
        });
    };
    this.deletaCadastroLayout = function (Row) {
        return restEngine.post('fis#/livromagnetico_layout/delete', {
            "requestType": "Row",
            "row": Row
        });
    };
    this.replicaTipoDocumentoCFOP = function (Row) {
        return restEngine.post('fis#/livromagnetico_layout_cfop/replica', {
            "requestType": "Row",
            "row": Row
        });
    };
    this.replicaCadastroTipo = function (Row) {
        return restEngine.post('fis#/livromagnetico_tipo_cfop/replica', {
            "requestType": "Row",
            "row": Row
        });
    };
    this.importaLayoutCFOPLivroMag = function (Row) {
        return restEngine.post('fis#/livromagnetico_layout_cfop/import', {
            "requestType": "Row",
            "row": Row
        });
    };

    this.deletaGeneroItemProduto = function (Row) {
        return restEngine.post('fis#/livromagnetico_genero_item_produto/deleta', {
            "requestType": "Row",
            "row": Row
        });
    };

    this.replicaGeneroTipoItemProduto = function (Row) {
        return restEngine.post('fis#/livromagnetico_genero_item/replicaGen', {
            "requestType": "Row",
            "row": Row
        });
    };

    this.cadastraGenTipoItemAutomatico = function (Row) {
        return restEngine.post('fis#/livromagnetico_genero_item_produto/cadAuto', {
            "requestType": "Row",
            "row": Row
        });
    };
    this.generoProd = function (Row) {
        return restEngine.post('fis#/livromagnetico_genero_item_produto/generoProd', {
            "requestType": "Row",
            "row": Row
        });
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis07200_LivroMagnetico_Repository', Fis07200_LivroMagnetico_Repository);
});

// FILE: ./assets/js/repositories/Fis08600_ParametrosIntegracaoFechamentoCupom_Repository.js
var Fis08600_ParametrosIntegracaoFechamentoCupom_Repository = function Fis08600_ParametrosIntegracaoFechamentoCupom_Repository(restEngine) {

    this.verificaFilialParavend = function (Row) {
        return restEngine.post('fis#/verificaFilialParavend', {
            "requestType": "Row",
            "row": Row
        });
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis08600_ParametrosIntegracaoFechamentoCupom_Repository', Fis08600_ParametrosIntegracaoFechamentoCupom_Repository);
});

// FILE: ./assets/js/repositories/Fis09200_ParametrosEmissaoGuias_Repository.js
var Fis09200_ParametrosEmissaoGuias_Repository = function Fis09200_ParametrosEmissaoGuias_Repository(restEngine) {

    this.salvarBeneficiario = function (Row) {
        return restEngine.post('fis#/salvarBeneficiario', {
            "requestType": "Row",
            "row": Row
        });
    };

    this.salvarCertificado = function (row) {
        return restEngine.post('fis#/salvarCertificado', {
            "requestType": "Row",
            "row": row
        });
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis09200_ParametrosEmissaoGuias_Repository', Fis09200_ParametrosEmissaoGuias_Repository);
});

// FILE: ./assets/js/repositories/Fis22000_PreValidacaoDeclaracoesAcessorias_Repository.js
var Fis22000_PreValidacaoDeclaracoesAcessorias_Repository = function Fis22000_PreValidacaoDeclaracoesAcessorias_Repository(restEngine) {

    this.validarNF = function (row) {
        return restEngine.post('fis#/validarNF', {
            "requestType": "Row",
            "row": row
        });
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis22000_PreValidacaoDeclaracoesAcessorias_Repository', Fis22000_PreValidacaoDeclaracoesAcessorias_Repository);
});

// FILE: ./assets/js/repositories/Fis25000_ParametrizacaoContribuicoes_Repository.js
var Fis25000_ParametrizacaoContribuicoes_Repository = function Fis25000_ParametrizacaoContribuicoes_Repository(restEngine) {

    this.salvarOutrasContribuicoes = function (row) {
        return restEngine.post('fis#/salvarOutrasContribuicoes', {
            "requestType": "Row",
            "row": row
        });
    };

    this.deletarOutrasContribuicoes = function (row) {
        return restEngine.post('fis#/deletarOutrasContribuicoes', {
            "requestType": "Row",
            "row": row
        });
    };

    this.salvarContaContabil = function (row) {
        return restEngine.post('fis#/salvarContaContabilOutrasContribuicoes', {
            "requestType": "Row",
            "row": row
        });
    };

    this.salvarBenfeitoria = function (row) {
        return restEngine.post('fis#/salvarBenfeitoria', {
            "requestType": "Row",
            "row": row
        });
    };

    this.salvarImportacao = function (row) {
        return restEngine.post('fis#/salvarImportacaoTabelasContribuicoes', {
            "requestType": "Row",
            "row": row
        });
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis25000_ParametrizacaoContribuicoes_Repository', Fis25000_ParametrizacaoContribuicoes_Repository);
});

// FILE: ./assets/js/repositories/Fis27100_Relacionamento_de_Codigo_da_Receita_Repository.js
function Fis27100_Relacionamento_de_Codigo_da_Receita_Repository(restEngine) {

    this.save = function (row) {
        return restEngine.post('fis#/save', {
            "requestType": "Row",
            "row": row
        });
    };

    this.update = function (row) {
        return restEngine.post('fis#/update', {
            "requestType": "Row",
            "row": row
        });
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis27100_Relacionamento_de_Codigo_da_Receita_Repository', Fis27100_Relacionamento_de_Codigo_da_Receita_Repository);
});

// FILE: ./assets/js/repositories/Fis46000_ParametrizacaoCodigosApuracao_Repository.js
function Fis46000_ParametrizacaoCodigosApuracao_Repository(restEngine) {

    //dataSet: primeira linha do array deve ser a linha antiga e a segunda, a nova 

    this.updateCodigoDaReceita = function (dataSet) {
        return restEngine.post("fis#/codreceitacontr/updateCodigoDaReceita", {
            "requestType": "DataSet",
            "dataset": dataSet
        });
    };

    this.salvarCodigoAjuste = function (row) {
        return restEngine.post('fis#/saveCodigoAjuste', {
            "requestType": "Row",
            "row": row
        });
    };

    this.salvarImportacaoTabelas = function (row) {
        return restEngine.post('fis#/salvarImportacaoTabelasSped', {
            "requestType": "Row",
            "row": row
        });
    };

    this.salvarCodigoReceitaEstadual = function (row) {
        return restEngine.post('fis#/salvarCodigoReceitaEstadual', {
            "requestType": "Row",
            "row": row
        });
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis46000_ParametrizacaoCodigosApuracao_Repository', Fis46000_ParametrizacaoCodigosApuracao_Repository);
});

// FILE: ./assets/js/repositories/Fis55000_ParametrizacaoExportacaoMunicipal_Repository.js
var Fis55000_ParametrizacaoExportacaoMunicipal_Repository = function Fis55000_ParametrizacaoExportacaoMunicipal_Repository(restEngine, localStorageEngine) {

    this.buscaFilial = function () {
        var filter = [{
            "name": "CDFILIAL",
            "operator": "=",
            "value": "FILIAL_LOGADA"
        }];
        return restEngine.post("fis#/crud/filial", {
            "requestType": "FilterData",
            'filter': filter
        });
    };

    this.buscaEmpresa = function (cdempresa) {
        return restEngine.post('fis#/crud/empresa', {
            "requestType": "FilterData",
            "filter": [{
                "name": "CDEMPRESA",
                "operator": "=",
                "value": cdempresa
            }]
        });
    };

    this.buscaParammuniserv = function (cdempresa, cdinscmuni, iddeclaracao, cdprodserv) {
        return restEngine.post('fis#/crud/parammuniserv', {
            "requestType": "FilterData",
            "filter": [{
                "name": "CDEMPRESA",
                "operator": "=",
                "value": cdempresa
            }, {
                "name": "CDINSCMUNI",
                "operator": "=",
                "value": cdinscmuni
            }, {
                "name": "IDDECLARACAO",
                "operator": "=",
                "value": iddeclaracao
            }, {
                "name": "CDPRODSERV",
                "operator": "=",
                "value": cdprodserv
            }]
        });
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis55000_ParametrizacaoExportacaoMunicipal_Repository', Fis55000_ParametrizacaoExportacaoMunicipal_Repository);
});

// FILE: ./assets/js/repositories/Fis91000_RelacaoFuncionariosEmpresa_Repository.js
var Fis91000_RelacaoFuncionariosEmpresa_Repository = function Fis91000_RelacaoFuncionariosEmpresa_Repository(restEngine, localStorageEngine) {

    this.buscaFilialLogada = function () {
        var filter = [{
            "name": "CDFILIAL",
            "operator": "=",
            "value": "FILIAL_LOGADA"
        }];
        return localStorageEngine.download("fis#/crud/filial", filter);
    };

    this.buscaEmpresaLogada = function (cdempresa) {
        return restEngine.post('fis#/crud/empresa', {
            "requestType": "FilterData",
            "filter": [{
                "name": "CDEMPRESA",
                "operator": "=",
                "value": cdempresa
            }]
        });
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis91000_RelacaoFuncionariosEmpresa_Repository', Fis91000_RelacaoFuncionariosEmpresa_Repository);
});

// FILE: ./assets/js/repositories/Ger00200_Empresa_Repository.js
function Ger00200_Empresa_Repository(restEngine) {

    this.save = function (row) {
        return restEngine.post('fis#/empresaDadosAdicionais/save', {
            "requestType": "DataSet",
            "dataset": [row]
        });
    };

    this.saveInscricao = function (row) {
        return restEngine.post('fis#/saveInscricaoEstadual', {
            "requestType": "Row",
            "row": row
        });
    };

    this.saveNew = function (row) {
        return restEngine.post('fis#/salvarNovaEmpresa/save', {
            "requestType": "Row",
            "row": row
        });
    };
}
Configuration(function (ContextRegister) {
    ContextRegister.register('Ger00200_Empresa_Repository', Ger00200_Empresa_Repository);
});

// FILE: ./assets/js/repositories/Ger00250_ParametrizacaoInscricaoEstadual_Repository.js
function Ger00250_ParametrizacaoInscricaoEstadual_Repository(restEngine) {

    this.saveMensagem = function (row) {
        return restEngine.post('fis#/salvarMensagemInscricao', {
            "requestType": "Row",
            "row": row
        });
    };

    this.saveSubstitutoTributario = function (row) {
        return restEngine.post('fis#/salvarSubstitutoTributario', {
            "requestType": "Row",
            "row": row
        });
    };

    this.saveMensagemSubstituto = function (row) {
        return restEngine.post('fis#/salvarMensagemSubstituto', {
            "requestType": "Row",
            "row": row
        });
    };
}
Configuration(function (ContextRegister) {
    ContextRegister.register('Ger00250_ParametrizacaoInscricaoEstadual_Repository', Ger00250_ParametrizacaoInscricaoEstadual_Repository);
});

// FILE: ./assets/js/repositories/Ger01200_Estado_Repository.js
function Ger01200_Estado_Repository(restEngine) {

    this.save = function (row) {
        return restEngine.post('fis#/saveEstado', {
            "requestType": "Row",
            "row": row
        });
    };
}
Configuration(function (ContextRegister) {
    ContextRegister.register('Ger01200_Estado_Repository', Ger01200_Estado_Repository);
});

// FILE: ./assets/js/repositories/Ger01300_Pais_Repository.js
function Ger01300_Pais_Repository(restEngine) {

    this.save = function (row) {
        return restEngine.post('fis#/savePais', {
            "requestType": "Row",
            "row": row
        });
    };
}
Configuration(function (ContextRegister) {
    ContextRegister.register('Ger01300_Pais_Repository', Ger01300_Pais_Repository);
});

// FILE: ./assets/js/repositories/Ger01500_Municipio_Repository.js
function Ger01500_Municipio_Repository(restEngine) {

    this.save = function (row) {
        return restEngine.post('fis#/saveMunicipio', {
            "requestType": "Row",
            "row": row
        });
    };

    this.novoCodigoBairro = function (row) {
        return restEngine.post('fis#/novoCodigoBairro', {
            "requestType": "Row",
            "row": row
        });
    };

    this.novoCodigoRegiao = function (row) {
        return restEngine.post('fis#/novoCodigoRegiao', {
            "requestType": "Row",
            "row": row
        });
    };
}
Configuration(function (ContextRegister) {
    ContextRegister.register('Ger01500_Municipio_Repository', Ger01500_Municipio_Repository);
});

// FILE: ./assets/js/repositories/Ger58000_Apuracao_IRPJ_CSLL_Repository.js
var Ger58000_Apuracao_IRPJ_CSLL_Repository = function Ger58000_Apuracao_IRPJ_CSLL_Repository(restEngine) {

    this.getContctblMask = function () {
        return restEngine.post("fis#/crud/paramgeral", {
            "requestType": "FilterData",
            "filter": [] });
    };

    this.getParamImposto = function () {

        return restEngine.post('fis#/paramimposto_aliq', {
            "requestType": "FilterData"
        });
    };

    this.saveParamImposto = function (Row) {

        return restEngine.post('fis#/paramimposto_aliq/save', {
            "requestType": "Row",
            "row": Row
        });
    };

    this.saveDefaultAliqIRPJCSLL = function (rows) {

        return restEngine.post('fis#/aliqirpjcsll_apuirpj/saveDefaultAliqIRPJCSLL', {
            "requestType": "DataSet",
            "dataset": rows
        });
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Ger58000_Apuracao_IRPJ_CSLL_Repository', Ger58000_Apuracao_IRPJ_CSLL_Repository);
});

// FILE: ./assets/js/repositories/Ger99100_RelacionamentoImpostosFiscais_Repository.js
var Ger99100_RelacionamentoImpostosFiscais_Repository = function Ger99100_RelacionamentoImpostosFiscais_Repository(restEngine) {
    this.removeNfeRelationship = function (row) {
        return restEngine.post('fis#/impostonfe/remove', {
            "requestType": "Row",
            "row": row
        });
    };

    this.saveNfeRelationship = function (row) {
        return restEngine.post('fis#/impostonfe/save', {
            "requestType": "Row",
            "row": row
        });
    };

    this.saveXmlRelationship = function (row) {
        return restEngine.post('fis#/impostonfe_imposto/save', {
            "requestType": "Row",
            "row": row
        });
    };

    this.incluirImpostos = function (row) {
        return restEngine.post('fis#/impostonfe/incluirImpostos', {
            "requestType": "Row",
            "row": row
        });
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Ger99100_RelacionamentoImpostosFiscais_Repository', Ger99100_RelacionamentoImpostosFiscais_Repository);
});

// FILE: ./assets/js/repositories/fis02600_classificacaoFiscalRepository.js
var fis02600_classificacaoFiscalRepository = function fis02600_classificacaoFiscalRepository(restEngine) {
    this.consulta = function () {
        return restEngine.post('fis#/dtsParamgeralClassFiscal', {
            "requestType": "FilterData",
            "filter": []
        });
    };
};
Configuration(function (ContextRegister) {
    ContextRegister.register('fis02600_classificacaoFiscalRepository', fis02600_classificacaoFiscalRepository);
});

// FILE: ./assets/modules/apuracoes/assets/js/repositories/Fis00100_ApuracaoDeImposto_Repository.js
var Fis00100_ApuracaoDeImposto_Repository = function Fis00100_ApuracaoDeImposto_Repository(restEngine) {
    this.vdImpostoRelac = function (row) {
        return restEngine.post('fis#/apuracao_de_imposto/vdImpostoRelac', {
            "requestType": "Row",
            "row": row
        });
    };

    this.buscaPrxDataIniECodigoMapa = function (row) {
        return restEngine.post('fis#/apuracao_de_imposto/prxDataIni', {
            "requestType": "Row",
            "row": row
        });
    };

    this.saveMapa = function (row) {
        return restEngine.post('fis#/apuracao_de_imposto/saveMapa', {
            "requestType": "Row",
            "row": row
        });
    };

    this.saveArrecadacaoContribuicoes = function (row) {
        return restEngine.post('fis#/apuracao_de_imposto/saveArrecadacaoContribuicoes', {
            "requestType": "Row",
            "row": row
        });
    };

    this.validaImpostoApurac = function (row) {
        return restEngine.post('fis#/apuracao_de_imposto/validaImpostoApurac', {
            "requestType": "Row",
            "row": row
        });
    };

    this.checkUltimoMapa = function (row) {
        return restEngine.post('fis#/apuracao_de_imposto/checkUltimoMapa', {
            "requestType": "Row",
            "row": row
        });
    };

    this.checkValidSequencialDetalhamento = function (row) {
        return restEngine.post('fis#/apuracao_de_imposto/checkValidSequencialDetalhamento', {
            "requestType": "Row",
            "row": row
        });
    };

    this.apurarMapa = function (row) {
        return restEngine.post('fis#/apuracao_de_imposto/apurarMapa', {
            "requestType": "Row",
            "row": row
        });
    };

    this.desbloquearMapa = function (row) {
        return restEngine.post('fis#/apuracao_de_imposto/desbloquearMapa', {
            "requestType": "Row",
            "row": row
        });
    };

    this.bloquearMapa = function (row) {
        return restEngine.post('fis#/apuracao_de_imposto/bloquearMapa', {
            "requestType": "Row",
            "row": row
        });
    };

    this.deleteMapa = function (row) {
        return restEngine.post('fis#/apuracao_de_imposto/deleteMapa', {
            "requestType": "Row",
            "row": row
        });
    };

    this.getNextSequencialAjusteContribuicoes = function (row) {
        return restEngine.post('fis_apuracoes#/getNextSequencialAjusteContribuicoes', {
            "requestType": "Row",
            "row": row
        });
    };

    this.saveAjusteContribuicoes = function (row) {
        return restEngine.post('fis_apuracoes#/saveAjusteContribuicoes', {
            "requestType": "Row",
            "row": row
        });
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis00100_ApuracaoDeImposto_Repository', Fis00100_ApuracaoDeImposto_Repository);
});

// FILE: ./assets/js/services/Fis00800_InventarioFiscal_Service.js
var Fis00800_InventarioFiscal_Service = function Fis00800_InventarioFiscal_Service(Fis00800_InventarioFiscal_Repository) {

    this.importInventFisc = function (formRow) {
        return Fis00800_InventarioFiscal_Repository.importInventFisc(formRow);
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis00800_InventarioFiscal_Service', Fis00800_InventarioFiscal_Service);
});

// FILE: ./assets/js/services/Fis01000_ClassificacaoFiscalProduto_Service.js
var Fis01000_ClassificacaoFiscalProduto_Service = function Fis01000_ClassificacaoFiscalProduto_Service(Fis01000_ClassificacaoFiscalProduto_Repository) {

    this.cadastramentoAutomatico = function (row) {
        return Fis01000_ClassificacaoFiscalProduto_Repository.cadastramentoAutomatico(row);
    };
};
Configuration(function (ContextRegister) {
    ContextRegister.register('Fis01000_ClassificacaoFiscalProduto_Service', Fis01000_ClassificacaoFiscalProduto_Service);
});

// FILE: ./assets/js/services/Fis07200_LivroMagnetico_Service.js
var Fis07200_LivroMagnetico_Service = function Fis07200_LivroMagnetico_Service(Fis07200_LivroMagnetico_Repository, ZHPromise, ScreenService) {
    this.validaLivroPadrao = function (idLivroPadrao) {
        return idLivroPadrao === 'S';
    };

    this.deletaLayoutCFOPLivroMag = function (row) {
        return Fis07200_LivroMagnetico_Repository.deletaLayoutCFOPLivroMag(row);
    };

    this.deletaCadastroTipo = function (row) {
        return Fis07200_LivroMagnetico_Repository.deletaCadastroTipo(row);
    };

    this.deletaCadastroLayout = function (row) {
        return Fis07200_LivroMagnetico_Repository.deletaCadastroLayout(row);
    };

    this.deletaTipoDocumentoCFOP = function (row) {
        return Fis07200_LivroMagnetico_Repository.deletaTipoDocumentoCFOP(row);
    };

    this.replicaTipoDocumentoCFOP = function (row) {
        return Fis07200_LivroMagnetico_Repository.replicaTipoDocumentoCFOP(row);
    };

    this.replicaCadastroTipo = function (row) {
        return Fis07200_LivroMagnetico_Repository.replicaCadastroTipo(row);
    };

    this.importaLayoutCFOPLivroMag = function (row) {
        return Fis07200_LivroMagnetico_Repository.importaLayoutCFOPLivroMag(row);
    };

    this.deletaGeneroItemProduto = function (row) {
        return Fis07200_LivroMagnetico_Repository.deletaGeneroItemProduto(row);
    };

    this.replicaGeneroTipoItemProduto = function (row) {
        return Fis07200_LivroMagnetico_Repository.replicaGeneroTipoItemProduto(row);
    };

    this.validaIntervaloProduto = function (cdProdIni, cdProdfin) {
        return cdProdIni <= cdProdfin;
    };

    this.cadastraGenTipoItemAutomatico = function (row) {
        return Fis07200_LivroMagnetico_Repository.cadastraGenTipoItemAutomatico(row);
    };
    this.generoProd = function (row) {
        return Fis07200_LivroMagnetico_Repository.generoProd(row);
    };

    this.deleteCrud = function (widget) {
        var deferred = ZHPromise.defer();

        widget.removeRow().then(function () {
            ScreenService.closeSwipe().then(function () {
                widget.activate();
                deferred.resolve();
            });
        }, function (error) {
            if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
            } else {
                ScreenService.showMessage(error.data.error);
            }
            deferred.reject();
        });
        return deferred.promise;
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis07200_LivroMagnetico_Service', Fis07200_LivroMagnetico_Service);
});

// FILE: ./assets/js/services/Fis08600_ParametrosIntegracaoFechamentoCupom_Service.js
function Fis08600_ParametrosIntegracaoFechamentoCupom_Service(Fis08600_ParametrosIntegracaoFechamentoCupom_Repository) {

    //caso o indice financeiro seja não, todos os campos sao apagaods
    this.validaIndiceFinanceiro = function (fields, camposExecao) {
        fields.forEach(function (field) {
            if (camposExecao.indexOf(field.name) == -1) {
                field.setValue('');
            }
        });
    };

    this.verificaFilialParavend = function (row) {
        return Fis08600_ParametrosIntegracaoFechamentoCupom_Repository.verificaFilialParavend(row);
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis08600_ParametrosIntegracaoFechamentoCupom_Service', Fis08600_ParametrosIntegracaoFechamentoCupom_Service);
});

// FILE: ./assets/js/services/Fis09200_ParametrosEmissaoGuias_Service.js
function Fis09200_ParametrosEmissaoGuias_Service(Fis09200_ParametrosEmissaoGuias_Repository) {

    this.salvarBeneficiario = function (row) {
        return Fis09200_ParametrosEmissaoGuias_Repository.salvarBeneficiario(row);
    };

    this.salvarCertificado = function (widget) {
        var row = widget.currentRow;
        row.__backupRow = widget.backupRow; //Usada para detectar alterações na senha em caso de edição
        return Fis09200_ParametrosEmissaoGuias_Repository.salvarCertificado(row);
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis09200_ParametrosEmissaoGuias_Service', Fis09200_ParametrosEmissaoGuias_Service);
});

// FILE: ./assets/js/services/Fis22000_PreValidacaoDeclaracoesAcessorias_Service.js
function Fis22000_PreValidacaoDeclaracoesAcessorias_Service(Fis22000_PreValidacaoDeclaracoesAcessorias_Repository) {

    this.validarNF = function (row) {
        return Fis22000_PreValidacaoDeclaracoesAcessorias_Repository.validarNF(row);
    };

    this.validaEstadoIscricao = function (row) {
        if (row.P_DSTIPOVALIDA === 'DAPI') {
            if (row.SGESTADO !== 'MG') {
                return false;
            } else {
                return true;
            }
        } else {
            return true;
        }
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis22000_PreValidacaoDeclaracoesAcessorias_Service', Fis22000_PreValidacaoDeclaracoesAcessorias_Service);
});

// FILE: ./assets/js/services/Fis22100_PrametrosPreValidacao_Service.js
function Fis22100_PrametrosPreValidacao_Service() {

    this.concatenarTipoOperacao = function (row) {
        var campoChave = row.CHAVE;
        if (campoChave) {
            if (campoChave.length === 0) {
                row.CDTIPOOPER = null;
            } else {
                var valor = '_';
                for (var i = 0; i < campoChave.length; i++) {
                    valor = valor + campoChave[i] + '_';
                }
                row.CDTIPOOPER = valor;
            }
        }
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis22100_PrametrosPreValidacao_Service', Fis22100_PrametrosPreValidacao_Service);
});

// FILE: ./assets/js/services/Fis25000_ParametrizacaoContribuicoes_Service.js
function Fis25000_ParametrizacaoContribuicoes_Service(Fis25000_ParametrizacaoContribuicoes_Repository) {

    this.salvarOutrasContribuicoes = function (row) {
        return Fis25000_ParametrizacaoContribuicoes_Repository.salvarOutrasContribuicoes(row);
    };

    this.deletarOutrasContribuicoes = function (row) {
        return Fis25000_ParametrizacaoContribuicoes_Repository.deletarOutrasContribuicoes(row);
    };

    this.salvarContaContabil = function (row) {
        return Fis25000_ParametrizacaoContribuicoes_Repository.salvarContaContabil(row);
    };

    this.salvarBenfeitoria = function (row) {
        return Fis25000_ParametrizacaoContribuicoes_Repository.salvarBenfeitoria(row);
    };

    this.salvarImportacao = function (row) {
        return Fis25000_ParametrizacaoContribuicoes_Repository.salvarImportacao(row);
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis25000_ParametrizacaoContribuicoes_Service', Fis25000_ParametrizacaoContribuicoes_Service);
});

// FILE: ./assets/js/services/Fis27100_Relacionamento_de_Codigo_da_Receita_Service.js
function Fis27100_Relacionamento_de_Codigo_da_Receita_Service(Fis27100_Relacionamento_de_Codigo_da_Receita_Repository) {

    this.save = function (row) {
        return Fis27100_Relacionamento_de_Codigo_da_Receita_Repository.save(row);
    };
    this.update = function (row) {
        return Fis27100_Relacionamento_de_Codigo_da_Receita_Repository.update(row);
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis27100_Relacionamento_de_Codigo_da_Receita_Service', Fis27100_Relacionamento_de_Codigo_da_Receita_Service);
});

// FILE: ./assets/js/services/Fis46000_ParametrizacaoCodigosApuracao_Service.js
function Fis46000_ParametrizacaoCodigosApuracao_Service(Fis46000_ParametrizacaoCodigosApuracao_Repository) {

    this.updateCodigoDaReceita = function (dataSet) {
        return Fis46000_ParametrizacaoCodigosApuracao_Repository.updateCodigoDaReceita(dataSet);
    };

    this.salvarCodigoAjuste = function (row) {
        return Fis46000_ParametrizacaoCodigosApuracao_Repository.salvarCodigoAjuste(row);
    };

    this.salvarImportacaoTabelas = function (row) {
        return Fis46000_ParametrizacaoCodigosApuracao_Repository.salvarImportacaoTabelas(row);
    };

    this.salvarCodigoReceitaEstadual = function (row) {
        return Fis46000_ParametrizacaoCodigosApuracao_Repository.salvarCodigoReceitaEstadual(row);
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis46000_ParametrizacaoCodigosApuracao_Service', Fis46000_ParametrizacaoCodigosApuracao_Service);
});

// FILE: ./assets/js/services/Fis55000_ParametrizacaoExportacaoMunicipal_Service.js
var Fis55000_ParametrizacaoExportacaoMunicipal_Service = function Fis55000_ParametrizacaoExportacaoMunicipal_Service(Fis55000_ParametrizacaoExportacaoMunicipal_Repository) {

    this.buscaFilial = function () {
        return Fis55000_ParametrizacaoExportacaoMunicipal_Repository.buscaFilial();
    };

    this.buscaEmpresa = function (cdempresa) {
        return Fis55000_ParametrizacaoExportacaoMunicipal_Repository.buscaEmpresa(cdempresa);
    };

    this.buscaParammuniserv = function (cdempresa, cdinscmuni, iddeclaracao, cdprodserv) {
        return Fis55000_ParametrizacaoExportacaoMunicipal_Repository.buscaParammuniserv(cdempresa, cdinscmuni, iddeclaracao, cdprodserv);
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis55000_ParametrizacaoExportacaoMunicipal_Service', Fis55000_ParametrizacaoExportacaoMunicipal_Service);
});

// FILE: ./assets/js/services/Fis91000_RelacaoFuncionariosEmpresa_Service.js
var Fis91000_RelacaoFuncionariosEmpresa_Service = function Fis91000_RelacaoFuncionariosEmpresa_Service(Fis91000_RelacaoFuncionariosEmpresa_Repository) {

    this.buscaFilialLogada = function () {
        return Fis91000_RelacaoFuncionariosEmpresa_Repository.buscaFilialLogada();
    };

    this.buscaEmpresaLogada = function (cdempresa) {
        return Fis91000_RelacaoFuncionariosEmpresa_Repository.buscaEmpresaLogada(cdempresa);
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis91000_RelacaoFuncionariosEmpresa_Service', Fis91000_RelacaoFuncionariosEmpresa_Service);
});

// FILE: ./assets/js/services/Ger00200_Empresa_Service.js
function Ger00200_Empresa_Service(Ger00200_Empresa_Repository, General) {

    this.salvarEmpresa = function (row) {
        return Ger00200_Empresa_Repository.save(row);
    };

    this.salvarInscricao = function (row) {
        return Ger00200_Empresa_Repository.saveInscricao(row);
    };

    this.salvarNovaEmpresa = function (row) {
        return Ger00200_Empresa_Repository.saveNew(row);
    };

    this.validateNumeroDeInscricao = function (inputValue) {
        var inscricao = General.inscricaoFormat(inputValue);
        if (!inscricao.valid) {
            //build appropriated error messages
            inscricao.error = {};
            switch (inscricao.tipo.cod) {
                case 'J':
                    inscricao.error.msg = "CNPJ \"" + inscricao.value + "\" inválido!";
                    break;
                case 'F':
                    inscricao.error.msg = "CPF \"" + inscricao.value + "\" inválido!";
                    break;
                case null:
                    break;
                case 'I':
                /* falls through */
                default:
                    inscricao.error.msg = inscricao.tipo.desc + " \"" + inscricao.value + "\" inválida!";
            }
        }
        return inscricao;
    };

    this.concatenaCamposInscricaoEstadual = function (row) {
        if (!row.DSLOGRADOURO) {
            row.DSENDEIEST = row.DSENDEIESTSEP + ', ' + row.NRENDEIESTSEP;
        } else {
            row.DSENDEIEST = row.DSLOGRADOURO + ' ' + row.DSENDEIESTSEP + ', ' + row.NRENDEIESTSEP;
        }

        row.NRTELEIEST = row.NRDDDTELEIEST + row.NRTELEIESTSEP;
        if (row.NRTELEIEST) {
            row.NRTELEIEST = row.NRTELEIEST.replace(/[^0-9]/g, '');
        }
        if (row.NRTELEIESTSEP) {
            row.NRTELEIESTSEP = row.NRTELEIESTSEP.replace(/[^0-9]/g, '');
        }

        row.NRFAXIEST = row.NRDDDFAXIEST + row.NRFAXIESTSEP;
        if (row.NRFAXIEST) {
            row.NRFAXIEST = row.NRFAXIEST.replace(/[^0-9]/g, '');
        }
        if (row.NRFAXIESTSEP) {
            row.NRFAXIESTSEP = row.NRFAXIESTSEP.replace(/[^0-9]/g, '');
        }
    };

    this.concatenaCamposEmpresa = function (row) {
        if (!row.DSLOGRADOURO) {
            row.DSENDEEMPR = row.DSENDEEMPSEP + ', ' + row.NRENDEEMPSEP;
        } else {
            row.DSENDEEMPR = row.DSLOGRADOURO + ' ' + row.DSENDEEMPSEP + ', ' + row.NRENDEEMPSEP;
        }

        row.NRTELEFOEMPR = row.NRDDDTELEEMP + row.NRTELEEMPSEP;
        if (row.NRTELEFOEMPR) {
            row.NRTELEFOEMPR = row.NRTELEFOEMPR.replace(/[^0-9]/g, '');
        }
        if (row.NRTELEEMPSEP) {
            row.NRTELEEMPSEP = row.NRTELEEMPSEP.replace(/[^0-9]/g, '');
        }

        row.NRFAXEMP = row.NRDDDFAXEMP + row.NRFAXEMPSEP;
        if (row.NRFAXEMP) {
            row.NRFAXEMP = row.NRFAXEMP.replace(/[^0-9]/g, '');
        }
        if (row.NRFAXEMPSEP) {
            row.NRFAXEMPSEP = row.NRFAXEMPSEP.replace(/[^0-9]/g, '');
        }
    };

    this.concatenaCamposInscricaoMunicipal = function (row) {
        if (!row.DSLOGRADOURO) {
            row.DSENDEIMUN = row.DSENDEIMUNSEP;
        } else {
            row.DSENDEIMUN = row.DSLOGRADOURO + ' ' + row.DSENDEIMUNSEP;
        }

        if (row.NRTELEIMUN) {
            row.NRTELEIMUN = row.NRTELEIMUN.replace(/[^0-9]/g, '');
        }

        if (row.NRFAXIMUN) {
            row.NRFAXIMUN = row.NRFAXIMUN.replace(/[^0-9]/g, '');
        }
    };
}
Configuration(function (ContextRegister) {
    ContextRegister.register('Ger00200_Empresa_Service', Ger00200_Empresa_Service);
});

// FILE: ./assets/js/services/Ger00250_ParametrizacaoInscricaoEstadual_Service.js
function Ger00250_ParametrizacaoInscricaoEstadual_Service(Ger00250_ParametrizacaoInscricaoEstadual_Repository, General) {

    this.salvarSubstitutoTributario = function (row) {
        return Ger00250_ParametrizacaoInscricaoEstadual_Repository.saveSubstitutoTributario(row);
    };

    this.salvarMensagem = function (row) {
        return Ger00250_ParametrizacaoInscricaoEstadual_Repository.saveMensagem(row);
    };

    this.salvarMensagemSubstituto = function (row) {
        return Ger00250_ParametrizacaoInscricaoEstadual_Repository.saveMensagemSubstituto(row);
    };

    this.concatenaCampoTipoOperacao = function (row) {
        var campoCodigo = row.CDTIPOOPER;
        if (campoCodigo) {
            if (campoCodigo.length === 0) {
                row.CDTIPOPERCREDP = null;
            } else {
                var campoES = row.IDENTRSAIDOP;
                var valor = '_';
                for (var i = 0; i < campoCodigo.length; i++) {
                    valor = valor + campoES[i] + campoCodigo[i] + '_';
                }
                row.CDTIPOPERCREDP = valor;
            }
        }
    };

    this.validaAliquota = function (row) {
        var aliquotaSaida = row.VRALIQTOTALSAIDA;
        var aliquotaImposto = row.VRALIQIMPOSREC;

        if (parseFloat(aliquotaSaida) !== 0) {
            if (parseFloat(aliquotaSaida) > 100) {
                return false;
            }
        }
        if (parseFloat(aliquotaImposto) !== 0) {
            if (parseFloat(aliquotaImposto) > 100) {
                return false;
            }
        }
        return true;
    };

    this.controlaValorCargaTributaria = function (row) {
        if (row.IDCARGA == '1') {
            row.IDCREDDEBNORM = 'S';
            row.IDOUTCREDDEB = 'N';
            row.CDAJSTCREDCARGA = null;
            row.DSOUTCREDCARGA = null;
            row.CDAJSTDEBICARGA = null;
            row.DSOUTDEBICARGA = null;
        } else if (row.IDCARGA == '2') {
            row.IDCREDDEBNORM = 'N';
            row.IDOUTCREDDEB = 'S';
        } else {
            row.IDCREDDEBNORM = 'N';
            row.IDOUTCREDDEB = 'N';
            row.CDAJSTCREDCARGA = null;
            row.DSOUTCREDCARGA = null;
            row.CDAJSTDEBICARGA = null;
            row.DSOUTDEBICARGA = null;
        }
    };

    this.validateNumeroDeInscricao = function (inputValue) {
        var inscricao = General.inscricaoFormat(inputValue);
        if (!inscricao.valid) {
            //build appropriated error messages
            inscricao.error = {};
            switch (inscricao.tipo.cod) {
                case 'J':
                    inscricao.error.msg = "CNPJ \"" + inscricao.value + "\" inválido!";
                    break;
                case 'F':
                    inscricao.error.msg = "CPF \"" + inscricao.value + "\" inválido!";
                    break;
                case null:
                    break;
                case 'I':
                /* falls through */
                default:
                    inscricao.error.msg = inscricao.tipo.desc + " \"" + inscricao.value + "\" inválida!";
            }
        }
        return inscricao;
    };
}
Configuration(function (ContextRegister) {
    ContextRegister.register('Ger00250_ParametrizacaoInscricaoEstadual_Service', Ger00250_ParametrizacaoInscricaoEstadual_Service);
});

// FILE: ./assets/js/services/Ger01200_Estado_Service.js
function Ger01200_Estado_Service(Ger01200_Estado_Repository) {

    this.salvarEstado = function (row) {
        return Ger01200_Estado_Repository.save(row);
    };
}
Configuration(function (ContextRegister) {
    ContextRegister.register('Ger01200_Estado_Service', Ger01200_Estado_Service);
});

// FILE: ./assets/js/services/Ger01300_Pais_Service.js
function Ger01300_Pais_Service(Ger01300_Pais_Repository) {

    this.salvarPais = function (row) {
        return Ger01300_Pais_Repository.save(row);
    };
}
Configuration(function (ContextRegister) {
    ContextRegister.register('Ger01300_Pais_Service', Ger01300_Pais_Service);
});

// FILE: ./assets/js/services/Ger01500_Municipio_Service.js
function Ger01500_Municipio_Service(Ger01500_Municipio_Repository) {

    this.salvarMunicipio = function (row) {
        return Ger01500_Municipio_Repository.save(row);
    };

    this.novoCodigoBairro = function (row) {
        return Ger01500_Municipio_Repository.novoCodigoBairro(row);
    };

    this.novoCodigoRegiao = function (row) {
        return Ger01500_Municipio_Repository.novoCodigoRegiao(row);
    };
}
Configuration(function (ContextRegister) {
    ContextRegister.register('Ger01500_Municipio_Service', Ger01500_Municipio_Service);
});

// FILE: ./assets/js/services/Ger58000_Apuracao_IRPJ_CSLL_Service.js
var Ger58000_Apuracao_IRPJ_CSLL_Service = function Ger58000_Apuracao_IRPJ_CSLL_Service(Ger58000_Apuracao_IRPJ_CSLL_Repository, ScreenService, ZHPromise) {

    this.getContctblMask = function () {
        return Ger58000_Apuracao_IRPJ_CSLL_Repository.getContctblMask();
    };

    this.getParamImposto = function () {
        return Ger58000_Apuracao_IRPJ_CSLL_Repository.getParamImposto();
    };

    this.saveParamImposto = function (Row) {
        return Ger58000_Apuracao_IRPJ_CSLL_Repository.saveParamImposto(Row);
    };

    this.saveDefaultAliqIRPJCSLL = function (rows) {
        return Ger58000_Apuracao_IRPJ_CSLL_Repository.saveDefaultAliqIRPJCSLL(rows);
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Ger58000_Apuracao_IRPJ_CSLL_Service', Ger58000_Apuracao_IRPJ_CSLL_Service);
});

// FILE: ./assets/js/services/Ger99100_RelacionamentoImpostosFiscais_Service.js
var Ger99100_RelacionamentoImpostosFiscais_Service = function Ger99100_RelacionamentoImpostosFiscais_Service(localStorageEngine, ZHPromise, Ger99100_RelacionamentoImpostosFiscais_Repository) {
    this.removeNfeRelationship = function (row) {
        return Ger99100_RelacionamentoImpostosFiscais_Repository.removeNfeRelationship(row);
    };

    this.saveNfeRelationship = function (row) {
        return Ger99100_RelacionamentoImpostosFiscais_Repository.saveNfeRelationship(row);
    };

    this.saveXmlRelationship = function (row) {
        return Ger99100_RelacionamentoImpostosFiscais_Repository.saveXmlRelationship(row);
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Ger99100_RelacionamentoImpostosFiscais_Service', Ger99100_RelacionamentoImpostosFiscais_Service);
});

// FILE: ./assets/js/services/fis02600_classificacaoFiscalService.js
var fis02600_classificacaoFiscalService = function fis02600_classificacaoFiscalService(fis02600_classificacaoFiscalRepository) {

    this.consulta = function () {
        return fis02600_classificacaoFiscalRepository.consulta();
    };
};
Configuration(function (ContextRegister) {
    ContextRegister.register('fis02600_classificacaoFiscalService', fis02600_classificacaoFiscalService);
});

// FILE: ./assets/js/services/tabela_de_processos_adm_jud_service.js
var Fis74000_TabelaProcessosAdmJud_Service = function Fis74000_TabelaProcessosAdmJud_Service(localStorageEngine, ZHPromise) {

    this.validaDtIniMenorIgualDtFin = function (dtIni, dtFin) {
        var today = new Date();
        return !(moment(dtIni, 'DD/MM/YYYY').unix() > moment(dtFin, 'DD/MM/YYYY').unix() || moment(dtFin, 'DD/MM/YYYY').unix() < moment(dtIni, 'DD/MM/YYYY').unix());
    };

    this.CATCH_EXCEPTION_ERROR = function (error) {
        var msgError = error.replace(/[<>]/g, '');
        return 'Ocorreu um erro inesperado, contate o administrador informando o trecho abaixo: <br><br>' + msgError + '<br><br>';
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis74000_TabelaProcessosAdmJud_Service', Fis74000_TabelaProcessosAdmJud_Service);
});

// FILE: ./assets/modules/acessorias/assets/js/services/Fis75000_Efd_Reinf_Service.js
var Fis75000_Efd_Reinf_Service = function Fis75000_Efd_Reinf_Service(General, Messages_fiscal, ScreenService) {

    // Operações do EFD-REINF
    this.IDTRANSENVIO = 'ENVIAR'; //Enviar Evento
    this.IDTRANSCONSU = 'CONSULTAR'; //Consultar Status do evento
    this.IDTRANSREENV = 'REENVIAR'; //Reenviar Evento
    this.IDTRANSEXCLU = 'EXCLUSAO'; //Excluir Evento

    // Nomes dos Eventos
    this.R1000 = 'R-1000';
    this.R1070 = 'R-1070';
    this.R2010 = 'R-2010';
    this.R2020 = 'R-2020';
    this.R2060 = 'R-2060';
    this.R2098 = 'R-2098';
    this.R2099 = 'R-2099';
    this.R5001 = 'R-5001';
    this.R5011 = 'R-5011';
    this.R9000 = 'R-9000';

    // Ids de ambiente
    this.ID_AMBIENTE_PRODUCAO = '1';
    this.ID_AMBIENTE_PRODRESTRITA = '2';

    //Regras exclusao
    this.idNaoPodeExcluir = ['C', 'M', 'R'];
    this.msgObsNaoExcluir = ['MS1089']; //Codigos de mesagem que significam que foram enviados e aceitos pela receita

    this.transmissao = function (arrEventos) {
        var operacao;

        if (arrEventos[0].IDOPERACAO === 'C') {
            operacao = this.IDTRANSCONSU;
        } else if (arrEventos[0].IDOPERACAO === 'I' || arrEventos[0].IDOPERACAO === 'A' || arrEventos[0].IDOPERACAO == 'R') {
            operacao = this.IDTRANSENVIO;
        } else if (arrEventos[0].IDOPERACAO === 'E') {
            operacao = this.IDTRANSEXCLU;
        } else {
            ScreenService.showMessage(Messages_fiscal.OEPRACAO_SEM_ROTA, 'error');
        }

        return General.callRestEngine('fis_acessorias#/setTransmissaoReinf/' + operacao, 'DataSet', arrEventos);
    };

    this.validaTransmissaoLote = function (rows) {

        if (rows.length > 100) {
            ScreenService.showMessage(Messages_fiscal.TAMANHO_LOTE_ENVIO_REINF, 'error');
            return false;
        }

        var lotePendente = true;
        var versaoDiferente = false;
        var ambienteDiferente = false;
        var mesDiferente = false;
        var eventoDiferente = rows[0].NMEVENTO;

        var ambiente = rows[0].IDAMBIENTE;
        var versao = rows[0].DSVERSAO;
        var mesCompetencia = rows[0].DTMESCOMPETENC;

        rows.forEach(function (row) {
            if (row.IDSTATUS !== 'P' && row.IDSTATUS !== 'E') lotePendente = false;

            /*if (row.NMEVENTO == 'R-2099' && row.IDSTATUS == 'R') 
                lotePendente = true;
            */
            if (row.IDAMBIENTE !== ambiente) ambienteDiferente = true;

            if (row.DSVERSAO !== versao) versaoDiferente = true;

            if (row.NMEVENTO !== eventoDiferente) eventoDiferente = true;

            if (row.DTMESCOMPETENC !== mesCompetencia) mesDiferente = true;
        });

        if (!lotePendente) {
            ScreenService.showMessage(Messages_fiscal.LOTE_STATUS_ERROR, 'error');
            return false;
        }

        if (ambienteDiferente) {
            ScreenService.showMessage(Messages_fiscal.LOTE_AMBIENTE_ERROR, 'error');
            return false;
        }

        if (eventoDiferente === true) {
            ScreenService.showMessage(Messages_fiscal.EVENTO_DIFERENTE_ERROR, 'error');
            return false;
        }

        if (versaoDiferente) {
            ScreenService.showMessage(Messages_fiscal.LOTE_VERSAO_ERROR, 'error');
            return false;
        }

        if (mesDiferente) {
            ScreenService.showMessage(Messages_fiscal.LOTE_COMPETENCIA_ERROR, 'error');
            return false;
        }

        if (rows.length != rows.filter(function (evento) {
            return evento.IDOPERACAO === rows[0].IDOPERACAO;
        }).length) {
            ScreenService.showMessage(Messages_fiscal.OPERACAO_DIFERENTE, 'error');
            return false;
        }
        return true;
    };

    this.verificarPodeExcluir = function (evento) {
        /*if (evento.IDAMBIENTE == this.ID_AMBIENTE_PRODRESTRITA) {
            return true;
        } else*/
        if (evento.IDSTATUS == 'E' && evento.NRRECIBO || evento.IDSTATUS == 'R') {
            return false;
        } else if (evento.IDSTATUS == 'E' && !evento.NRRECIBO) {
            //Cairá nessa condição se um evento for enviado e aceito pela receita, 
            //porém, por instabilidade de algum servidor o recibo não seja gravado,
            //dessa forma o evento não pode ser excluído, pois ID não pode ser
            //perdido. A variável msgObsNaoExcluir armazena os codigos de mensagens
            //que identificam esses problemas. Esses códigos podem ser acrescidos com
            //o tempo, caso identique outros erros que caem na mesma situação, ou 
            //situação parecida.
            return this.vericiaObsParaExcluir(evento.DSOBSERVACAO);
        } else {
            return this.idNaoPodeExcluir.indexOf(evento.IDSTATUS) == -1;
        }
    };

    this.vericiaObsParaExcluir = function (message) {
        //Se existir algum código, que identifica que o evento não pode ser exclído,
        //dentro do valor da observação daquele evento, a função retornará false,
        //caso não exista rertornará true;
        return this.msgObsNaoExcluir.filter(function (codErro) {
            return message && message.indexOf(codErro) != -1;
        }).length == 0;
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis75000_Efd_Reinf_Service', Fis75000_Efd_Reinf_Service);
});

// FILE: ./assets/modules/apuracoes/assets/js/services/Fis00100_ApuracaoDeImposto_Service.js
var Fis00100_ApuracaoDeImposto_Service = function Fis00100_ApuracaoDeImposto_Service(Fis00100_ApuracaoDeImposto_Repository) {

    this.vdImpostoRelac = function (row) {
        return Fis00100_ApuracaoDeImposto_Repository.vdImpostoRelac(row);
    };

    /*
     * Na apuração do Simples Nacional somente podem realizar alterações
     * empresas que pertençam ao regime do Simples Nacional (cdsitucrt != '3')
     * Nas apurações do regime normal, empresas com regime Simples Nacional
     * somente poderão realizar alterações se estiver marcado o parâmetro no
     * imposto que permite apurar na tela do regime normal, mesmo sendo
     * empresa do simples
     */
    this.bloqueiaMapaRegime = function (idtipoapura, cdsitucrt, idapuimpgersn) {
        if (idtipoapura == 'S' && cdsitucrt == '3') {
            return true;
        } else if (idtipoapura != 'S' && cdsitucrt != '3' && idapuimpgersn == 'N') {
            return true;
        } else {
            return false;
        }
    };

    this.buscaPrxDataIniECodigoMapa = function (row) {
        return Fis00100_ApuracaoDeImposto_Repository.buscaPrxDataIniECodigoMapa(row);
    };

    this.saveMapa = function (row) {
        return Fis00100_ApuracaoDeImposto_Repository.saveMapa(row);
    };

    this.saveArrecadacaoContribuicoes = function (row) {
        return Fis00100_ApuracaoDeImposto_Repository.saveArrecadacaoContribuicoes(row);
    };

    this.checkUltimoMapa = function (row) {
        return Fis00100_ApuracaoDeImposto_Repository.checkUltimoMapa(row);
    };

    this.validaImpostoApurac = function (row) {
        return Fis00100_ApuracaoDeImposto_Repository.validaImpostoApurac(row);
    };

    this.checkValidSequencialDetalhamento = function (row) {
        return Fis00100_ApuracaoDeImposto_Repository.checkValidSequencialDetalhamento(row);
    };

    this.apurarMapa = function (row) {
        return Fis00100_ApuracaoDeImposto_Repository.apurarMapa(row);
    };

    this.desbloquearMapa = function (row) {
        return Fis00100_ApuracaoDeImposto_Repository.desbloquearMapa(row);
    };

    this.bloquearMapa = function (row) {
        return Fis00100_ApuracaoDeImposto_Repository.bloquearMapa(row);
    };

    this.deleteMapa = function (row) {
        return Fis00100_ApuracaoDeImposto_Repository.deleteMapa(row);
    };

    this.getNextSequencialAjusteContribuicoes = function (row) {
        return Fis00100_ApuracaoDeImposto_Repository.getNextSequencialAjusteContribuicoes(row);
    };

    this.saveAjusteContribuicoes = function (row) {
        return Fis00100_ApuracaoDeImposto_Repository.saveAjusteContribuicoes(row);
    };

    /*
     * Função para o cálculo do valor do detalhamento de Simples Nacional
     * conforme widget passada.
     */
    this.calculaValorTotalDetalhamento = function (row, nomeWidget) {
        switch (nomeWidget) {
            case 'widgetFatuMensalTributadoSt':
                row.VRIMPOSTOST = (parseFloat(row.VRBCFATUST) + parseFloat(row.VRCOMPBCST) - parseFloat(row.VRDEDUZBCST)) * (parseFloat(row.VRALIQST) / 100);
                break;

            case 'widgetFatuMensalNaoTributadoSt':
                row.VRIMPOSTOSEMST = (parseFloat(row.VRBCFATUSEMST) + parseFloat(row.VRCOMPBCSEMST) - parseFloat(row.VRDEDUZBCSEMST)) * (parseFloat(row.VRALIQFAIXA) / 100);
                break;

            case 'widgetFatuMensalIsentoIcms':
                row.VRIMPOISENTO = (parseFloat(row.VRBCFATUISEN) + parseFloat(row.VRCOMPBCISENTO) - parseFloat(row.VRDEDUZBCISENTO)) * (parseFloat(row.VRALIQISENTO) / 100);
                break;

            case 'widgetFatuExportacao':
                row.VRIMPOSTOEXP = (parseFloat(row.VRBCFATUEXP) + parseFloat(row.VRCOMPBCEXP) - parseFloat(row.VRDEDUZBCEXP)) * (parseFloat(row.VRALIQEXP) / 100);
                break;

            case 'widgetFatuMensalRetido':
                row.VRIMPOSTORET = parseFloat(row.VRBCFATURET) * (parseFloat(row.VRALIQRET) / 100) + parseFloat(row.VRRETIDONPROV);
                break;

            case 'widgetMajoracao':
                row.VRIMPOSTOEXCED = parseFloat(row.VRALIQMAJORADA) / 100 * parseFloat(row.VRPARCELAEXCED);
                break;
        }
        row.VRIMPOSTOREC = row.VRIMPOSTOST + row.VRIMPOSTOSEMST + row.VRIMPOISENTO + row.VRIMPOSTOEXP + row.VRIMPOSTOEXCED - row.VRIMPOSTORET;
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis00100_ApuracaoDeImposto_Service', Fis00100_ApuracaoDeImposto_Service);
});

// FILE: ./assets/modules/guias/assets/js/services/Fis00200_DocumentoDeArrecadacao_Service.js
var Fis00200_DocumentoDeArrecadacao_Service = function Fis00200_DocumentoDeArrecadacao_Service(Messages_fiscal, ScreenService, General) {

    // Configuração dos campos e dataset da widget (para guia apuração ou documento)
    var configFields = [{
        "name": "DTINIPERIODO",
        "A": {
            "isVisible": true,
            "readOnly": true,
            "validations": {}
        },
        "D": {
            "isVisible": false,
            "readOnly": false,
            "validations": {}
        }
    }, {
        "name": "DTFIMPERIODO",
        "A": {
            "isVisible": true,
            "readOnly": true,
            "validations": {}
        },
        "D": {
            "isVisible": false,
            "readOnly": false,
            "validations": {}
        }
    },
    /*{
    	"name": "VRTOTAL",
    	"A": {
    		"isVisible": true,
    		"readOnly": true,
    		"validations": {}
    	},
    	"D": {
    		"name": "VRTOTAL",
    		"isVisible": false,
    		"readOnly": false,
    		"validations": {}
    	}
      	},*/

    {
        "name": "CDNATUREZA",
        "A": {
            "isVisible": true,
            "readOnly": false,
            "validations": {
                "required": true
            }
        },
        "D": {
            "isVisible": false,
            "readOnly": false,
            "validations": {}
        }
    }, {
        "name": "CDRECEITA",
        "A": {
            "isVisible": true,
            "readOnly": false,
            "validations": {
                "required": true
            }
        },
        "D": {
            "isVisible": true,
            "readOnly": false,
            "validations": {
                "required": true
            }
        }
    }, {
        "name": "NMMAPAAPUR",
        "A": {
            "isVisible": true,
            "readOnly": false,
            "validations": {}
        },
        "D": {
            "isVisible": false,
            "readOnly": false,
            "validations": {}
        }
    }, {
        "name": "IDBLOQMAPAPU",
        "A": {
            "isVisible": true,
            "readOnly": true,
            "validations": {}
        },
        "D": {
            "isVisible": false,
            "readOnly": false,
            "validations": {}
        }
    }, {
        "name": "IDTIPOGUIA",
        "A": {
            "isVisible": true,
            "readOnly": true,
            "validations": {}
        },
        "D": {
            "isVisible": true,
            "readOnly": true,
            "validations": {}
        }
    }, {
        "name": "FILIAL_DOC",
        "A": {
            "isVisible": false,
            "readOnly": false,
            "validations": {}
        },
        "D": {
            "isVisible": true,
            "readOnly": true,
            "validations": {}
        }
    }, {
        "name": "NMFILIAL_DOC",
        "A": {
            "isVisible": false,
            "readOnly": false,
            "validations": {}
        },
        "D": {
            "isVisible": true,
            "readOnly": true,
            "validations": {}
        }
    }, {
        "name": "OPERACAO_DOC",
        "A": {
            "isVisible": false,
            "readOnly": false,
            "validations": {}
        },
        "D": {
            "isVisible": true,
            "readOnly": true,
            "validations": {}
        }
    }, {
        "name": "NMDESTEMIT_DOC",
        "A": {
            "isVisible": false,
            "readOnly": false,
            "validations": {}
        },
        "D": {
            "isVisible": true,
            "readOnly": true,
            "validations": {}
        }
    }, {
        "name": "NRNOTAFISC_DOC",
        "A": {
            "isVisible": false,
            "readOnly": false,
            "validations": {}
        },
        "D": {
            "isVisible": true,
            "readOnly": true,
            "validations": {}
        }
    }, {
        "name": "DTENTRSAID_DOC",
        "A": {
            "isVisible": false,
            "readOnly": false,
            "validations": {}
        },
        "D": {
            "isVisible": true,
            "readOnly": true,
            "validations": {}
        }
    }, {
        "name": "DTEMISSAO_DOC",
        "A": {
            "isVisible": false,
            "readOnly": false,
            "validations": {}
        },
        "D": {
            "isVisible": true,
            "readOnly": true,
            "validations": {}
        }
    }, {
        "name": "VRNOTAFISC_DOC",
        "A": {
            "isVisible": false,
            "readOnly": false,
            "validations": {}
        },
        "D": {
            "isVisible": true,
            "readOnly": true,
            "validations": {}
        }
    }, {
        "name": "NRLANCTONFPAG",
        "A": {
            "isVisible": false,
            "readOnly": false,
            "validations": {}
        },
        "D": {
            "isVisible": false,
            "readOnly": false,
            "validations": {}
        }
    }];

    //Função que ajusta a widget parea funcionar como 'Apuração' ou 'Documento', conforme selecionado no filter.
    this.ajustaCamposApuracaoOuDocumento = function (id, widget) {
        var field;

        for (var i = 0; i < configFields.length; ++i) {
            field = widget.getField(configFields[i].name);

            field.isVisible = configFields[i][id].isVisible;
            field.readOnly = configFields[i][id].readOnly;
            field.validations = configFields[i][id].validations;
        }
    };

    /*VALIDAÇÕES GERAIS********************************************************/

    this.validaPreparacaoPagamento = function (dadosPagamento, row) {
        if (!row.DTVENCIMENTO) return Messages_fiscal.VENCIMENTO_PAGAMENTO;

        if (row.SGESTADO === 'RJ' && row.IDORGARRECADNFE === 'E') {
            if (!row.CDNATUREZA) return Messages_fiscal.NATUREZA_RJ;
        } else if (row.SGESTADO !== 'RJ') {
            if (row.CDIMPOSTO != 'SN') {
                //Para Simples Nacional 
                if (!row.CDRECEITA) return Messages_fiscal.CDRECEITA_PAGAMENTO;
            }
        }

        if (!dadosPagamento.CDFILIAL) return Messages_fiscal.UNIDADE_PAGAMENTO;

        return true;
    };

    this.validaEmiisaoGuia = function (row) {

        if (!row.DTVENCIMENTO) {
            return Messages_fiscal.VENCIMENTO_PAGAMENTO;
        }

        if (row.SGESTADO === 'RJ' && row.IDORGARRECADNFE === 'E') {
            if (!row.CDNATUREZA) return Messages_fiscal.NATUREZA_RJ;

            if (row.IDTRANSMISSAO !== 'E' && row.IDTRANSMISSAO !== 'S') return Messages_fiscal.LOTE_INVALIDO;
        } else {
            if (!row.CDRECEITA) return Messages_fiscal.CDRECEITA_PAGAMENTO;
        }
        if (row.NRLANCTONFPAG && row.NRLANCTONFPAG != '' || row.CDFILIALPAG && row.CDFILIALPAG != '') {
            return ScreenService.showMessage('Preparação de Pagamento já realizada. Desfaça a preparação de pagamento antes de emitir a guia.');
        }

        return true;
    };

    this.validaTransmissaoLoteRj = function (rows) {
        var dtVencimento = false;
        var cdnatureza = false;
        var dtPagamento = false;

        rows.forEach(function (row) {
            if (!row.DTVENCIMENTO) dtVencimento = true;

            if (!row.CDNATUREZA) cdnatureza = true;

            if (!row.DTLIMITEPAG) dtPagamento = true;
        });

        if (dtVencimento) return Messages_fiscal.VENCIMENTO_PAGAMENTO;else if (cdnatureza) return Messages_fiscal.NATUREZA_RJ;else if (dtPagamento) return Messages_fiscal.LIMITE_PAGAMENTO;else return true;
    };

    this.preparaRow = function (row) {
        var ignoredKeys = ["__rightActions", "__leftActions", "_children", "_parent", "__groupHeaders", "__index", "__isSelected", "__notSelectable", "$$hashKey"];
        // Verifica se é um array de rows;
        if (Array.isArray(row)) {
            var rows = [];
            row.forEach(function (linhaSelecionada) {
                rows.push(Util.clone(linhaSelecionada, ignoredKeys));
            });
            return rows;
        } else {
            return Util.clone(row, ignoredKeys);
        }
    };

    //Valida se todos os campos necessários para a GNRE TXT estão preenchidos
    this.validaCamposGnreTxt = function (rows, estado) {
        //Verifica se houve seleção de row
        if (rows.length == 0) {
            ScreenService.showMessage(Messages_fiscal.SELECIONE_LINHAS);
            return false;
        }

        //Verifica se houve seleção de 50 ou mais rows
        if (rows.length > 50) {
            ScreenService.showMessage(Messages_fiscal.LIMITE_LINHAS_GNRE);
            return false;
        }

        //Verifica se demais campos obrigatórios forma preenchidos
        for (var i = 0; i < rows.length; ++i) {
            if (!rows[i].DTVENCIMENTO) {
                ScreenService.showMessage(Messages_fiscal.VENCIMENTO_PAGAMENTO);
                return false;
            }
            if (!rows[i].DTLIMITEPAG) {
                ScreenService.showMessage(Messages_fiscal.LIMITE_PAGAMENTO);
                return false;
            }
            if (estado === 'RJ') {
                if (!rows[i].CDNATUREZA) {
                    ScreenService.showMessage(Messages_fiscal.NATUREZA_RJ);
                    return false;
                }
            } else {
                if (!rows[i].CDRECEITA) {
                    ScreenService.showMessage(Messages_fiscal.CDRECEITA_PAGAMENTO);
                    return false;
                }
            }
            if (rows[i].NRLANCTONFPAG && rows[i].NRLANCTONFPAG !== '' || rows[i].CDFILIALPAG && rows[i].CDFILIALPAG !== '') {
                ScreenService.showMessage('Preparação de Pagamento já realizada. Desfaça a preparação de pagamento antes de emitir a guia.');
                return false;
            }
        }
        return true;
    };

    /*UTILIDADES***************************************************************/

    //Retorna um nome de arquivo a data e hora no formato NOME_AAAAMMDD_HHMMSS.TXT conforme os parametros nomeArquivo, separador e extensao
    this.nomeArquivoDatetime = function (nomeArquivo, separador, extensao) {
        var hoje = new Date();
        return nomeArquivo + separador + hoje.getFullYear().toString() + (hoje.getMonth() + 1).toString().padStart(2, '0') + hoje.getDate().toString().padStart(2, '0') + separador + hoje.getHours().toString().padStart(2, '0') + hoje.getMinutes().toString().padStart(2, '0') + hoje.getSeconds().toString().padStart(2, '0') + '.' + extensao;
    };

    //Funções necessárias para retornar parâmetros necessário para gerar a DARF no servidor da Receita
    this.DataHoraFim = function (h, m, s) {
        var oneSecond = 1000;
        var oneMinute = 60 * oneSecond;
        var oneHour = 60 * oneMinute;
        var dataHoraInvertida, dataInvertidaDia, dataInvertidaMes, dataInvertidaAno, dataInvertidaHora, dataInvertidaMinuto, dataInvertidaSegundo;
        var dataAtual = new Date();

        var dataInMS = dataAtual.getTime();
        dataInMS = dataInMS + oneHour * h + oneMinute * m + oneSecond * s;

        dataAtual.setTime(dataInMS);

        dataInvertidaDia = FormataDataHora(dataAtual.getDate());
        dataInvertidaMes = FormataDataHora(dataAtual.getMonth() + 1);
        dataInvertidaAno = dataAtual.getYear();
        dataInvertidaHora = FormataDataHora(dataAtual.getHours());
        dataInvertidaMinuto = FormataDataHora(dataAtual.getMinutes());
        dataInvertidaSegundo = FormataDataHora(dataAtual.getSeconds());

        dataHoraInvertida = dataInvertidaAno.toString() + dataInvertidaMes.toString() + dataInvertidaDia.toString() + dataInvertidaHora.toString() + dataInvertidaMinuto.toString() + dataInvertidaSegundo.toString();

        return dataHoraInvertida;
    };

    function FormataDataHora(x) {
        var valor = "0" + x;
        var ValorF = String(valor);
        ValorF = ValorF.substr(ValorF.length - 2, 2);
        return ValorF;
    }

    /*DIRECIONAMENTO DE EMISSÃO DE GUIAS PARA OS SITES / BIRT******************/

    this.AcessaSiteGnreSp = function () {
        window.open('https://www.fazenda.sp.gov.br/guiasinternet/Gare/Paginas/Gare.aspx', '_blank');
    };

    //Emissão das guias pelo sistema (birt)
    /*this.EmiteGuiaGnreSp = function(widget, row) {
        //Para garantir que a DOCARRECADPAG está atualizada para a emissão da GRPR
        General.callRestEngine('fis_guias#/salvarEdicaoGuia', 'Row', this.preparaRow(widget.currentRow)).then(
            function(response) {
                //Atualização do nrseqdocarrecad da row para a correta emissão do relatório
                row.NRSEQDOCARRECAD = response.dataset.nrseqdocarrecad[0];
                //Emissão da guia DAEMS via birt
                General.openReport('fis_guias#/emissaoGuiaBirt', 'gnre-sp', row);
            },
            function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            }  
        );
       };*/

    //Emissão de guia via site da fazenda ou via birt (sistema)
    this.emitirGuia = function (widget, row, message, reportName, urlSite) {
        var preparaRow = this.preparaRow;

        var abrirSiteReceita = function abrirSiteReceita() {
            window.open(urlSite, '_blank');
        };
        var emitirGuiaBirt = function emitirGuiaBirt() {
            //Para garantir que a DOCARRECADPAG está atualizada para a emissão da GARE
            General.callRestEngine('fis_guias#/salvarEdicaoGuia', 'Row', preparaRow(widget.currentRow)).then(function (response) {
                //Atualização do nrseqdocarrecad da row para a correta emissão do relatório
                row.NRSEQDOCARRECAD = response.dataset.nrseqdocarrecad[0];
                //Emissão da guia GARE via birt
                General.openReport('fis_guias#/emissaoGuiaBirt', reportName, row);
            }, function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        };

        //Se não houver mensagem a função irá abrir o site ou emitir o relatório birt diretamente
        if (message != null) {
            //Questiona se deve abrir o site ou o relatório birt
            ScreenService.confirmMessage(message, "question").then(abrirSiteReceita, emitirGuiaBirt);
        } else {
            //Verifica se abrirá, sem questionar, o site ou o relatório
            if (reportName != null) {
                emitirGuiaBirt();
            } else {
                abrirSiteReceita();
            }
        }
    };

    //Emissão da guia DARF via sistema da receita, caso a guia esteja vencida este encaminha para o site/birt
    this.guiaDarfReceitaOuBirt = function (widgetGuia, widget, row, filteredData) {
        var preparaRow = this.preparaRow;
        var multiRows = widget.getCheckedRows();

        //Emissão simples
        //Faz a emissão da DARF via sistema da receita caso esta esteja vencida
        var emitirViaReceita = function emitirViaReceita(response) {
            if (response.dataset.relatorio[0].resultado) {
                //Gera a DARF via Receita
                window.open("about:blank", "_blank").document.write(response.dataset.relatorio[0].relatorio);
            } else {
                ScreenService.showMessage(Messages_fiscal.RELATORIO_NAO_ENCONTRADO);
            }
        };

        //Questiona o usuário se deseja emitir a guia vencida via site da Receita ou via Birt
        var emitirViaReceitaOuBirt = function emitirViaReceitaOuBirt(callback) {
            if (callback.data) {
                //Verifica se a guia está vencida
                if (callback.data.errorCode == 1) {
                    ScreenService.confirmMessage(callback.data.error, "question").then(
                    //Questiona se deve gerar a DARF via sistema da receita ou relatório birt
                    function () {
                        window.open("http://www.receita.fazenda.gov.br/Aplicacoes/ATSPO/SicalcWeb/default.asp?TipTributo=2&FormaPagto=1", "_blank");
                    }, emitirViaBirt);
                }
            }
        };

        //Faz a emissão via Birt
        var emitirViaBirt = function emitirViaBirt() {
            //Para garantir que a DOCARRECADPAG está atualizada
            General.callRestEngine('fis_guias#/salvarEdicaoGuia', 'Row', preparaRow(widget.currentRow)).then(function (response) {
                //Atualização do nrseqdocarrecad da row para a correta emissão do relatório
                row.NRSEQDOCARRECAD = response.dataset.nrseqdocarrecad[0];
                //Emissão da guia DARF via birt
                General.openReport('fis_guias#/emissaoGuiaBirt', 'darf', row);
            }, function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        };

        //Emissão múltipla
        var promises = []; //Armazena todas as requisições das guias
        var i;
        var aux;

        //Faz a emissão via Birt de múltiplas guias
        var emitirViaBirtMult = function emitirViaBirtMult() {
            //Percorre as rows selecionadas validando e montando os parâmetros para a emissão da guia
            aux = [];

            for (i = 0; i < multiRows.length; ++i) {
                //Monta array de NRSEQDOCARRECAD selecionados
                aux.push(multiRows[i].NRSEQDOCARRECAD);
            }
            //monta row com as opções 
            row = { "NRORG": multiRows[0].NRORG, "NRSEQDOCARRECAD": aux.join(',') };

            //Emissão da guia DARF via birt
            General.openReport('fis_guias#/emissaoGuiaBirt', 'darf', row);
        };

        //Recolhe o conteúdo de todas as guias
        var promiseResolve = function promiseResolve(response) {
            for (i = 0; i < response.length; ++i) {
                window.open("about:blank", "_blank").document.write(response[i].dataset.relatorio[0].relatorio);
            }
        };

        //Sinaliza erro, provavelmente guia vencida
        var promiseReject = function promiseReject(response) {
            ScreenService.confirmMessage(Messages_fiscal.GUIAS_VENCIDAS_SITE_BIRT, "question").then(function () {
                window.open("http://www.receita.fazenda.gov.br/Aplicacoes/ATSPO/SicalcWeb/default.asp?TipTributo=2&FormaPagto=1", "_blank");
            }, emitirViaBirtMult);
        };

        //Verifica se é emissão simples ou múltipla
        if (multiRows.length < 2) {
            //Emissão simples
            General.callRestEngine('fis_guias#/emitirGuia', 'Row', this.preparaRow(widgetGuia.currentRow)).then(emitirViaReceita, //Emitirá o documento pelo site caso não esteja vencida
            emitirViaReceitaOuBirt //Se estiver vencida poderá ser emitida via formulário do site ou por relatório birt
            );
        } else {
            //Emissão múltipla
            for (i = 0; i < multiRows.length; ++i) {
                aux = this.preparaRow(multiRows[i]);
                //Valida datas e códigos necessários
                if (!multiRows[i].DTVENCIMENTO) {
                    ScreenService.showMessage(Messages_fiscal.VENCIMENTO_PAGAMENTO);
                    return;
                }
                if (!multiRows[i].CDRECEITA) {
                    ScreenService.showMessage(Messages_fiscal.CDRECEITA_PAGAMENTO);
                    return;
                }
                //Inclusão de informações do filtro
                aux.CDMUNICIPIO = filteredData.CDMUNICIPIO;
                aux.SGESTADO = filteredData.SGESTADO;
                aux.IDTIPOEMISSAO = filteredData.IDTIPOEMISSAO;
                aux.CDINSCESTA = filteredData.CDINSCESTA;
                aux.CDINSCMUNI = filteredData.CDINSCMUNI;
                aux.IDORGARRECADNFE = filteredData.IDORGARRECADNFE;
                aux.UFFAVORECIDO = filteredData.UFFAVORECIDO;
                aux.OPCGUIA = filteredData.OPCGUIA;
                aux.CDIMPOSTO = filteredData.CDIMPOSTO;
                promises.push(General.callRestEngine('fis_guias#/emitirGuia', 'Row', aux));
            }
            Promise.all(promises).then(promiseResolve, promiseReject);
        }
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis00200_DocumentoDeArrecadacao_Service', Fis00200_DocumentoDeArrecadacao_Service);
});

// FILE: ./assets/js/controllers/Dashboard_Controller.js
var Dashboard_Controller = function Dashboard_Controller(General, ScreenService, ZhFilterPreferences, templateManager, Fis00800_InventarioFiscal_Service) {

    var self = this;

    self.setStripeData = function (widget) {
        var stripeWidget = templateManager.container.getWidget("stripe");

        var filterFilial = [{
            "name": "CDFILIAL",
            "operator": "=",
            "value": "FILIAL_LOGADA"
        }];

        General.callRestEngine('fis#/crud/filial', 'FilterData', filterFilial).then(function (filial) {
            var filterEmpresa = [{
                "name": "CDEMPRESA",
                "operator": "=",
                "value": filial.dataset.filial[0].CDEMPRESA
            }];
            General.callRestEngine('fis#/crud/empresa', 'FilterData', filterEmpresa).then(function (empresa) {
                stripeWidget.currentRow = {};
                stripeWidget.currentRow.NMEMPRESA = empresa.dataset.empresa[0].CDEMPRESA + ' - ' + empresa.dataset.empresa[0].NMEMPRESA;
                stripeWidget.currentRow.DATA = 'De ' + moment().subtract(1, 'months').format('DD/MM/YYYY') + ' até ' + moment().format('DD/MM/YYYY');
                var data = {
                    "start": moment().subtract(1, 'months').format('DD/MM/YYYY'),
                    "end": moment().format('DD/MM/YYYY')
                };
                templateManager.container.getWidget('widgetDashboard').active = true;
                templateManager.container.getWidget('widgetDashboard').activate();
                self.setFilter(empresa.dataset.empresa[0].CDEMPRESA, data);
            });
        });
    };

    self.setFilter = function (cdempresa, data) {
        templateManager.container.getWidget('fechCupomPendente').dataSourceFilter.forEach(function (filter) {
            if (filter.name == 'P_CDEMPRESA') {
                filter.value = cdempresa;
            }
            if (filter.name == 'P_DTINICIAL') {
                filter.value = data.start;
            }
            if (filter.name == 'P_DTFINAL') {
                filter.value = data.end;
            }
            if (filter.name == 'P_IDAPROVACAONFCE') {
                filter.value = "P_E";
            }
        });
        templateManager.container.getWidget('notaFiscalPendente').dataSourceFilter.forEach(function (filter) {
            if (filter.name == 'P_CDEMPRESA') {
                filter.value = cdempresa;
            }
            if (filter.name == 'P_DTINICIAL') {
                filter.value = data.start;
            }
            if (filter.name == 'P_DTFINAL') {
                filter.value = data.end;
            }
        });

        var filterEmpresa = [{
            "name": "CDEMPRESA",
            "operator": "=",
            "value": cdempresa
        }];

        templateManager.container.getWidget('fechCupomPendente').reload();
        templateManager.container.getWidget('notaFiscalPendente').reload();
    };

    self.changeStripe = function () {
        var widget = templateManager.container.getWidget('popUpStripe');
        ScreenService.openPopup(widget);
        var arrayEmpresa = templateManager.container.getWidget('stripe').currentRow.NMEMPRESA.split(" - ");
        var arrayVencimento = templateManager.container.getWidget('stripe').currentRow.DATA.split(" ");
        widget.currentRow.CDEMPRESA = arrayEmpresa[0];
        widget.currentRow.NMEMPRESA = arrayEmpresa[1];
        widget.currentRow.DATA = {
            "start": arrayVencimento[1],
            "end": arrayVencimento[3]
        };
        widget.reload();
    };

    self.comfirmChangeStripe = function (widget) {
        var widgetStripe = templateManager.container.getWidget('stripe');
        widgetStripe.currentRow = {};
        widgetStripe.currentRow.NMEMPRESA = widget.currentRow.CDEMPRESA + ' - ' + widget.currentRow.NMEMPRESA;
        widgetStripe.currentRow.DATA = 'De ' + widget.currentRow.DATA.start + ' até ' + widget.currentRow.DATA.end;
        ScreenService.closePopup();
        self.setFilter(widget.currentRow.CDEMPRESA, widget.currentRow.DATA);
        templateManager.container.getWidget('widgetDashboard').active = true;
        templateManager.container.getWidget('widgetDashboard').activate();
    };

    self.updateNotificationsValue = function (widget) {
        if (!!widget.dataSource.data) widget.notification = widget.dataSource.data.shift().COUNT;
    };

    self.openFechamentoPendente = function () {
        var widget = templateManager.container.getWidget('fechCupomPendente');

        widget.dataSourceFilter.forEach(function (filter) {
            if (filter.name == 'P_CDEMPRESA') {
                sessionStorage.setItem('P_CDEMPRESA', filter.value);
            }
            if (filter.name == 'P_DTINICIAL') {
                sessionStorage.setItem('P_DTINICIAL', filter.value);
            }
            if (filter.name == 'P_DTFINAL') {
                sessionStorage.setItem('P_DTFINAL', filter.value);
            }
            if (filter.name == 'P_IDAPROVACAONFCE') {
                sessionStorage.setItem('P_IDAPROVACAONFCE', filter.value);
            }
        });

        ScreenService.openWindow('fis#dashboard_fechCupomPendente');
    };

    self.openNFPendente = function () {
        var widget = templateManager.container.getWidget('notaFiscalPendente');

        widget.dataSourceFilter.forEach(function (filter) {
            if (filter.name == 'P_CDEMPRESA') {
                sessionStorage.setItem('P_CDEMPRESA', filter.value);
            }
            if (filter.name == 'P_DTINICIAL') {
                sessionStorage.setItem('P_DTINICIAL', filter.value);
            }
            if (filter.name == 'P_DTFINAL') {
                sessionStorage.setItem('P_DTFINAL', filter.value);
            }
        });

        ScreenService.openWindow('fis#dashboard_notaFiscalPendente');
    };

    /*******************************************
      *                                           *
      *     Tela Fechamento de Cupons Pendentes   *
      *                                           *
      ********************************************/

    self.setDataSourceFechCupomPendente = function () {
        var widget = templateManager.container.getWidget('dashboard_fechCupomPendente');

        widget.dataSourceFilter = [{
            'name': 'NRORG',
            'operator': '=',
            'value': getLocalVar('NRORG')
        }, {
            'name': 'P_CDEMPRESA',
            'operator': '=',
            'value': sessionStorage.getItem('P_CDEMPRESA')
        }, {
            'name': 'P_DTINICIAL',
            'operator': '=',
            'value': sessionStorage.getItem('P_DTINICIAL')
        }, {
            'name': 'P_DTFINAL',
            'operator': '=',
            'value': sessionStorage.getItem('P_DTFINAL')
        }, {
            'name': 'P_IDAPROVACAONFCE',
            'operator': '=',
            'value': sessionStorage.getItem('P_IDAPROVACAONFCE')
        }];
        widget.reload();
    };

    /*******************************************
      *                                           *
      *     Tela Notas Fiscais Pendentes          *
      *                                           *
      ********************************************/

    self.setDataSourceNFPendente = function () {
        var widget = templateManager.container.getWidget('dashboard_notaFiscalPendente');

        widget.dataSourceFilter = [{
            'name': 'NRORG',
            'operator': '=',
            'value': getLocalVar('NRORG')
        }, {
            'name': 'P_CDEMPRESA',
            'operator': '=',
            'value': sessionStorage.getItem('P_CDEMPRESA')
        }, {
            'name': 'P_DTINICIAL',
            'operator': '=',
            'value': sessionStorage.getItem('P_DTINICIAL')
        }, {
            'name': 'P_DTFINAL',
            'operator': '=',
            'value': sessionStorage.getItem('P_DTFINAL')
        }];
        widget.reload();
    };
};

/* global Configuration */
Configuration(function (ContextRegister) {
    ContextRegister.register('Dashboard_Controller', Dashboard_Controller);
});

// FILE: ./assets/js/controllers/FIS01500_ParametrosDeFiscal_Controller.js
var FIS01500_ParametrosDeFiscal_Controller = function FIS01500_ParametrosDeFiscal_Controller(templateManager, ScreenService, fis02600_classificacaoFiscalService, General, Fis01000_ClassificacaoFiscalProduto_Service) {

    this.backOrCancel = function (args) {
        General.backOrCancel(args).then(function () {
            General.formWidgetSwitchTemplate(args.owner.widget);
        });
    };

    this.widgetEdit = function (widget) {
        if (!Util.isEmptyOrBlank(widget.dataSource.data)) {
            General.widgetEdit(widget);
        } else {
            widget.newRow();
            General.formWidgetSwitchTemplate(widget);
        }
    };

    this.salvar = function (widget) {
        if (widget.isValid()) {
            if (widget.currentRow.DTININFFORPER.charAt(11) != "0") {
                widget.currentRow.DTININFFORPER = widget.currentRow.DTININFFORPER.concat(" 00:00:00");
            }
            var route = 'fis#/salvarParametrosDeFiscal';
            General.callRestEngine(route, 'Row', widget.currentRow).then(function (Success) {
                General.formWidgetSwitchTemplate(widget);
                widget.list();
            }).catch(function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }

        var realizavalidacao = localStorage.getItem('realizavalidacao');
        localStorage.setItem("realizavalidacao", widget.currentRow.IDREAPREVALAUT);
    };
};
Configuration(function (ContextRegister) {
    ContextRegister.register('FIS01500_ParametrosDeFiscal_Controller', FIS01500_ParametrosDeFiscal_Controller);
});

// FILE: ./assets/js/controllers/Fis00800_InventarioFiscal_Controller.js
var Fis00800_InventarioFiscal_Controller = function Fis00800_InventarioFiscal_Controller(ScreenService, ZhFilterPreferences, templateManager, Fis00800_InventarioFiscal_Service, General) {

    var self = this;

    var NAME_GRID_INVENTARIO = 'grid_inventario_fiscal';

    this.preparaFiltro = function (widget, preference) {
        var filterRow = preference.FILTER_ROW;

        widget.dataSourceFilter = [{
            "name": "CDEMPRESA",
            "operator": "=",
            "value": filterRow.CDEMPRESA
        }, {
            "name": "CDINSCESTA",
            "operator": "=",
            "value": filterRow.CDINSCESTA
        }, {
            "name": "DTINVEFISCAL",
            "operator": "=",
            "value": formatDTINVEFISCAL(filterRow.DTINVEFISCAL)
        }];

        preference.FILTER_ROW.DTINVEFISCAL = formatDTINVEFISCAL(filterRow.DTINVEFISCAL);
        this.setStripeData(filterRow);
        widget.redraw(true);
    };

    this.setStripeData = function (filterRow) {
        var stripeWidget = templateManager.container.getWidget("stripe");

        stripeWidget.currentRow = {};
        stripeWidget.currentRow.CDEMPRESA = filterRow.CDEMPRESA.toString();
        stripeWidget.currentRow.CDINSCESTA = filterRow.CDINSCESTA.toString();
        stripeWidget.currentRow.DTINVEFISCAL = filterRow.DTINVEFISCAL.toString();
    };

    this.loadCDINSCESTA = function (widget) {

        if (widget.currentRow.CDEMPRESA && widget.currentRow.NMRAZSOCEMPR) {
            widget.getField('CDINSCESTA').dataSourceFilter = [{
                name: "CDEMPRESA",
                operator: "=",
                value: widget.currentRow.CDEMPRESA
            }, {
                "name": [{
                    "name": "CDINSCESTA",
                    "direction": "ASC"
                }],
                "operator": "ORDER_BY"
            }];
        } else {
            widget.currentRow.CDINSCESTA = null;
        }
        //Se o campo empresa não estiver selecionado, 
        //o campo de inscrição estadual é desabilitado.
        widget.getField('CDINSCESTA').readOnly = !(widget.currentRow.CDEMPRESA && widget.currentRow.NMRAZSOCEMPR);
    };

    this.openFormImportInventFisc = function (formWidget) {

        formWidget.isVisible = true;
        ScreenService.openPopup(formWidget);
        setSuggestedFormValues(formWidget);
    };

    this.importInventFisc = function (formWidget) {
        if (formWidget.isValid()) {
            formWidget.currentRow.IDCONSIDINVENT = 'P';
            Fis00800_InventarioFiscal_Service.importInventFisc(formWidget.currentRow).then(function (success) {
                var successMessage = getImportMessage(success);

                ScreenService.closePopup(formWidget);
                formWidget.isVisible = false;
                ScreenService.showMessage(successMessage);
                formWidget.getParent().reload();
            }, function (error) {
                var errorMessage = 'Timeout';

                if (error.data) {
                    errorMessage = error.data.error;
                }

                ScreenService.closePopup(formWidget);
                formWidget.isVisible = false;
                ScreenService.showMessage(errorMessage);
            });
        } else {}
    };

    var formatDTINVEFISCAL = function formatDTINVEFISCAL(DTINVEFISCAL) {
        return moment(DTINVEFISCAL, 'DD/MM/YYYY').endOf('month').format('DD/MM/YYYY');
    };

    var getImportMessage = function getImportMessage(response) {
        var successMessage = "";
        var successfulImports = response.dataset.inventfisc_invfisc.successfulImports;
        var noImports = response.dataset.inventfisc_invfisc.noImports;

        successfulImports.forEach(function (CDINSCESTA) {
            successMessage += "I.E. " + CDINSCESTA + ": Inventário importado com sucesso.";
        });
        noImports.forEach(function (CDINSCESTA) {
            successMessage += "I.E. " + CDINSCESTA + ": Não existem informações para importação do inventário.";
        });

        return successMessage;
    };

    var setSuggestedFormValues = function setSuggestedFormValues(formWidget) {

        var dataSourceFilter = formWidget.getParent().dataSourceFilter;

        var filterNMRAZSOCEMPR = formWidget.getParent().appliedFilter.FILTER_ROW.NMRAZSOCEMPR;
        var filterCDEMPRESA = getValueByName("CDEMPRESA", dataSourceFilter);
        var filterDTINVEFISCAL = getValueByName("DTINVEFISCAL", dataSourceFilter);
        var filterCDINSCESTA = getValueByName("CDINSCESTA", dataSourceFilter);

        formWidget.currentRow.CDEMPRESA = filterCDEMPRESA;
        formWidget.currentRow.NMRAZSOCEMPR = filterNMRAZSOCEMPR;
        formWidget.currentRow.CDINSCESTA = [filterCDINSCESTA];
        formWidget.currentRow.DTINVEFISCAL = filterDTINVEFISCAL;

        self.loadCDINSCESTA(formWidget);
    };

    var getValueByName = function getValueByName(name, array) {
        var found = array.find(function (element) {
            return element.name == name;
        });
        if (found) return found.value;else return null;
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis00800_InventarioFiscal_Controller', Fis00800_InventarioFiscal_Controller);
});

// FILE: ./assets/js/controllers/Fis01000_ClassificacaoFiscalProduto_Controller.js
var Fis01000_ClassificacaoFiscalProduto_Controller = function Fis01000_ClassificacaoFiscalProduto_Controller(templateManager, ScreenService, fis02600_classificacaoFiscalService, General, Fis01000_ClassificacaoFiscalProduto_Service) {

    this.preparaFiltroClassificacaoFiscal = function (widget, preference) {
        var filterRow = preference.FILTER_ROW;
        widget.dataSourceFilter.forEach(function (filter) {
            switch (filter.name) {
                case 'P_PRODINI':
                    filter.value = filterRow.P_PRODINI ? filterRow.P_PRODINI : '0';
                    break;
                case 'P_PRODFIN':
                    filter.value = filterRow.P_PRODFIN ? filterRow.P_PRODFIN : 'zzzzzzzzzzzzzzzzzzzz';
                    break;
                case 'P_NIVEL':
                    filter.value = General.getLevelByMask('GER_CDPICTPROD', '1').length;
                    break;
            }
        });
    };

    this.setLevelByMask = function () {
        var nivel = General.getLevelByMask('GER_CDPICTPROD', '1').length;
        var gridClassificacaoFiscalProduto = templateManager.container.getWidget('gridClassificacaoFiscalProduto');
        var cadastramentoAutomatico = templateManager.container.getWidget('cadastramentoAutomatico');
        gridClassificacaoFiscalProduto.getField('NMPRODUTOINI').dataSourceFilter[0].value = nivel;
        gridClassificacaoFiscalProduto.getField('NMPRODUTOFIN').dataSourceFilter[0].value = nivel;
        gridClassificacaoFiscalProduto.getField('P_NIVEL').defaultValue = nivel;
        cadastramentoAutomatico.getField('NMPRODUTOINI').dataSourceFilter[0].value = nivel;
        cadastramentoAutomatico.getField('NMPRODUTOFIN').dataSourceFilter[0].value = nivel;
    };

    this.aplicarMascara = function (args) {
        fis02600_classificacaoFiscalService.consulta().then(function (callback) {
            var widget = templateManager.container.getWidget('gridClassificacaoFiscalProduto');
            var resultado = callback.dataset.dtsParamgeralClassFiscal;
            var mascara = resultado[0].CDPICTCFIS;
            var campoCodigo = widget.getField('CDCLASFISC');
            if (mascara) {
                mascara = '?' + mascara;
                campoCodigo.mask.params.mask = mascara;
            }
        }, function (callback) {
            if (callback.data) {
                ScreenService.showMessage(callback.data.error);
            }
        });
    };

    this.salvar = function (args) {
        var widget = args.owner.widget;
        General.saveCrud(widget).then(function (Success) {
            this.controlaActionCadastramento(args, true);
        }.bind(this), function (callback) {
            if (callback.data) {
                ScreenService.showMessage(callback.data.error);
            }
        });
    };

    this.controlaActionCadastramento = function (args, visibilidade) {
        var widget = args.owner.widget;
        widget.getAction('cadastramentoAutomatico').isVisible = visibilidade;
    };

    this.realizaCadastramentoAutomatoco = function (args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (!widget.currentRow.CDCLASFISC) {
                widget.currentRow.CDCLASFISC = null;
            }
            if (!widget.currentRow.CDCEST) {
                widget.currentRow.CDCEST = null;
            }
            widget.currentRow.P_NIVEL = General.getLevelByMask('GER_CDPICTPROD', '1').length;
            Fis01000_ClassificacaoFiscalProduto_Service.cadastramentoAutomatico(widget.currentRow).then(function (Success) {
                var widgetClassificacao = templateManager.container.getWidget('gridClassificacaoFiscalProduto');
                ScreenService.closePopup();
                ScreenService.closeSwipe();
                widgetClassificacao.activate();
                widgetClassificacao.reload();
                ScreenService.showMessage('Cadastramento Automático Realizado com Sucesso!');
            }.bind(this), function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };

    this.verficarProdutoInicialFinal = function (args) {
        var widget = args.owner.owner.widget;
        if (widget.currentRow.P_PRODINI && widget.currentRow.P_PRODFIN) {
            var resultado = General.comparaPratoProduto(widget.currentRow.P_PRODINI, widget.currentRow.P_PRODFIN, getLocalVar('GER_CDPICTPROD'));
            if (!resultado) {
                ScreenService.showMessage('Produto Inicial deve ser Menor que o Produto Final.');
                widget.currentRow.P_PRODFIN = null;
            }
        }
    };
};
Configuration(function (ContextRegister) {
    ContextRegister.register('Fis01000_ClassificacaoFiscalProduto_Controller', Fis01000_ClassificacaoFiscalProduto_Controller);
});

// FILE: ./assets/js/controllers/Fis06900_TipoDeItem_Controller.js
var Fis06900_TipoDeItem_Controller = function Fis06900_TipoDeItem_Controller(ScreenService, templateManager, General, restEngine, ZhFilterPreferences, Messages_fiscal) {
    var livroMagnetico = {};

    this.openFilter = function (widget) {
        var rowFilter = { "CDLIVROMAG": livroMagnetico.CDLIVROMAG,
            "NMLIVROMAG": livroMagnetico.NMLIVROMAG };
        ZhFilterPreferences.openFilterWidget(templateManager.container.getWidget('tipoDeItem'), rowFilter);
    };

    this.saveTipoItemProdLivroMag = function (widget) {
        if (widget.isValid()) {
            widget.currentRow.CDLIVROMAG = widget.appliedFilter.FILTER_ROW.CDLIVROMAG;
            General.saveCrud(widget);
        }
    };

    this.importaTipoItemPadrao = function (widget) {
        if (widget.isValid()) {
            if (widget.currentRow.IDTIPODECLARA === 'SPED') {
                ScreenService.confirmMessage(ScreenService.i18n(Messages_fiscal.CONFIRMA_IMPORTACAO), 'question', function () {
                    var widgetTipodeItem = templateManager.container.getWidget('tipoDeItem');
                    var cdlivromag = widgetTipodeItem.appliedFilter.FILTER_ROW.CDLIVROMAG;
                    General.callRestEngine('fis#/tipoitem_livromag/delete', 'Row', { "CDLIVROMAG": cdlivromag }).then(function (success) {
                        var nmarquivoimporta = "TipoDeItem_" + widget.currentRow.IDTIPODECLARA + ".json";
                        restEngine.requestMetaData("json/import/" + nmarquivoimporta, {}).then(function (response) {
                            var data = response.data;
                            General.callRestEngine('fis#/tipoitem_livromag/import', 'Row', { "DATA": data, "CDLIVROMAG": cdlivromag }).then(function (success) {
                                ScreenService.showMessage(Messages_fiscal.IMPORTACAO_SUCCESS);
                                widgetTipodeItem.reload();
                            });
                        });
                    }).catch(function (erroImportTipoItem) {
                        if (erroImportTipoItem.data && erroImportTipoItem.data.error.indexOf('ORA-02292') !== -1) {
                            ScreenService.showMessage(Messages_fiscal.DELETE_IMPORTA_TIPO_ITEM_ERROR);
                        } else {
                            var errorMessage = 'Timeout';
                            if (erroImportTipoItem.data) {
                                errorMessage = erroImportTipoItem.data.error;
                            }
                            ScreenService.showMessage(errorMessage);
                        }
                    }).finally(function () {
                        ScreenService.closePopup();
                    });
                });
            }
        }
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis06900_TipoDeItem_Controller', Fis06900_TipoDeItem_Controller);
});

// FILE: ./assets/js/controllers/Fis07200_LivroMagnetico_Controller.js
var Fis07200_LivroMagnetico_Controller = function Fis07200_LivroMagnetico_Controller(templateManager, ScreenService, General, restEngine, Fis07200_LivroMagnetico_Service, Fis06900_TipoDeItem_Controller, Messages_fiscal, ZhFilterPreferences) {

    this.deleteLivroMagnetico = function (widget) {
        var tipoDeDoc = widget.widgets[0];
        var generoProd = widget.widgets[1];
        var tipoDeItem = widget.widgets[2];

        //valida se o livro é um livro padrão
        if (Fis07200_LivroMagnetico_Service.validaLivroPadrao(widget.currentRow.IDPADRAOLIVRO)) {
            //se for, mostra mensagem de erro e nao deixa excluir
            ScreenService.showMessage(Messages_fiscal.EXCL_LIVRO_PADRAO_ERROR);
            //valida se o livro contém registros filhos
        } else if (tipoDeDoc.dataSource.data.length != 0 || generoProd.dataSource.data.length != 0 || tipoDeItem.dataSource.data.length != 0) {
            //se tiver, mostra mensagem de confirmação
            ScreenService.confirmMessage("O registro possui registros filhos. Tem certeza que deseja excluir?", "question").then(function () {

                General.callRestEngine('fis#/deletarLivMag', 'Row', { 'Row': widget.currentRow }).then(function (success) {
                    ScreenService.showMessage('Registro excluido com sucesso');
                    ScreenService.goBack();
                    widget.reload();
                });
            });
        } else {
            General.deleteCrud(widget);
        }
    };

    this.deletaTipoDocumentoCfopLayout = function (widget) {
        var layoutCfop = widget.widgets[0];
        //valida se o livro contém registros filhos
        layoutCfop.reload();
        if (layoutCfop.dataSource.data.length != 0) {
            //se tiver, mostra mensagem de confirmação
            ScreenService.confirmMessage("O registro possui registros filhos. Tem certeza que deseja excluir?", "question").then(function () {

                General.callRestEngine('fis#/deletarCfopLayout', 'Row', { 'Row': widget.currentRow }).then(function (success) {
                    Fis07200_LivroMagnetico_Service.deleteCrud(widget);
                    ScreenService.showMessage('Registro excluido com sucesso');
                    widget.reload();
                    widget.widgets[0].reload();
                });
            });
        } else {
            Fis07200_LivroMagnetico_Service.deleteCrud(widget);
        }
    };

    this.deletaTipoDocumentoCfopTipo = function (widget) {
        var tipoCfop = widget.widgets[0];
        //valida se o livro contém registros filhos
        tipoCfop.reload();
        if (tipoCfop.dataSource.data.length != 0) {
            //se tiver, mostra mensagem de confirmação
            ScreenService.confirmMessage("O registro possui registros filhos. Tem certeza que deseja excluir?", "question").then(function () {

                General.callRestEngine('fis#/deletarCfopTipo', 'Row', { 'Row': widget.currentRow }).then(function (success) {
                    Fis07200_LivroMagnetico_Service.deleteCrud(widget);
                    ScreenService.showMessage('Registro excluido com sucesso');
                    widget.reload();
                    widget.widgets[0].reload();
                });
            });
        } else {
            Fis07200_LivroMagnetico_Service.deleteCrud(widget);
        }
    };

    this.saveLivroMagnetico = function (widget) {
        if (widget.isValid()) {
            var qtdRegistros = widget.dataSource.data.length;
            var isLivroPadrao = Fis07200_LivroMagnetico_Service.validaLivroPadrao(widget.currentRow.IDPADRAOLIVRO);
            var isNewRow = widget.currentRow.__is_new;
            var existeLivroPadrao = isLivroPadrao;

            if (qtdRegistros == 1 && isNewRow && !isLivroPadrao) {
                return ScreenService.showMessage(Messages_fiscal.EXISTE_LIVRO_PADRAO_ERROR);
            }

            if (!isNewRow && widget.backupRow.IDPADRAOLIVRO != widget.currentRow.IDPADRAOLIVRO || isNewRow && isLivroPadrao) {
                if (widget.dataSource.data.length > 1) {
                    widget.dataSource.data.forEach(function vdLivro(livro, index) {
                        var paramIsLivroPadrao = Fis07200_LivroMagnetico_Service.validaLivroPadrao(livro.IDPADRAOLIVRO);
                        if (isLivroPadrao && paramIsLivroPadrao && widget.dataSource.data[index] != widget.currentRow) {
                            widget.dataSource.data[index].IDPADRAOLIVRO = 'N';
                            widget.dataSource.data[index].changed = true;

                            ScreenService.confirmMessage("Já existe um livro padrão, tem certeza que deseja mudar?", "question").then(function () {
                                General.saveCrud(widget).then(function (success) {
                                    ScreenService.showMessage('Novo Livro livro padrão definido com sucesso');
                                });
                            });
                        }
                        if (paramIsLivroPadrao) {
                            existeLivroPadrao = true;
                        }
                    });
                    //caso seja o primeiro registro  e seja o padrao                    
                } else {
                    General.saveCrud(widget).then(function (success) {
                        ScreenService.showMessage('Novo Livro livro padrão definido com sucesso');
                    });
                }
                if (!isLivroPadrao && !existeLivroPadrao) {
                    return ScreenService.showMessage(Messages_fiscal.EXISTE_LIVRO_PADRAO_ERROR);
                }
            } else {
                General.saveCrud(widget);
            }
            this.habilitaWidgets(templateManager.container.getWidget('livro_magnetico'), widget.name, true);
        }
    };

    this.add = function (mainwidget, widget) {
        this.habilitaWidgets(mainwidget, widget.name, false);
        widget.newRow();
    };

    this.edit = function (mainwidget, widget) {
        this.habilitaWidgets(mainwidget, widget.name, false);
        General.edit(widget);
    };

    this.cancel = function (mainwidget, args) {
        this.habilitaWidgets(mainwidget, args.owner.widget.name, true);
        General.backOrCancel(args);
    };
    this.voltar = function (mainWidget, args) {
        this.habilitaWidgets(mainWidget, args.owner.widget.name, true);
        mainWidget.reload();
    };

    this.saveLayoutLivroMag = function (widget) {
        if (widget.currentRow.__is_new) {
            widget.currentRow.CDLIVROMAG = General.getFieldValue('CDLIVROMAG', 'livro_magnetico');
        }
        General.saveCrud(widget);
        this.habilitaWidgets(templateManager.container.getWidget('layout_cfops'), widget.name, true);
        this.habilitaWidgets(templateManager.container.getWidget('tipo_cfops'), widget.name, true);
    };

    this.saveCFOPLayoutLivroMag = function (widget) {
        if (widget.currentRow.__is_new) {
            widget.currentRow.CDLIVROMAG = General.getFieldValue('CDLIVROMAG', 'livro_magnetico');
            widget.currentRow.CDLAYOUTLMAG = General.getFieldValue('CDLAYOUTLMAG', 'cadastro_layout');
        }
        General.saveCrud(widget);
    };
    this.saveCFOPoperacaoLivroMag = function (widget) {
        if (widget.currentRow.__is_new) {
            widget.currentRow.CDLIVROMAG = General.getFieldValue('CDLIVROMAG', 'livro_magnetico');
            widget.currentRow.IDENTRSAIDOP = General.getFieldValue('IDENTRSAIDOP', 'cadastro_tipo');
            widget.currentRow.CDTIPOOPER = General.getFieldValue('CDTIPOOPER', 'cadastro_tipo');
        }
        General.saveCrud(widget);
    };

    this.saveGenItProdLivroMag = function (widget) {
        widget.currentRow.CDLIVROMAG = General.getFieldValue('CDLIVROMAG', 'livro_magnetico');
        Fis07200_LivroMagnetico_Service.generoProd(widget.currentRow).then(function (success) {
            General.saveCrud(widget);
        });
    };
    this.filtrarTela = function (widget) {
        widget.dataSourceFilter = [{
            name: "IDPADRAOLIVRO",
            operator: "=",
            value: "S"
        }];
    };

    this.saveTipoItemProdLivroMag = function (widget) {
        if (widget.currentRow.__is_new) {
            widget.currentRow.CDLIVROMAG = General.getFieldValue('CDLIVROMAG', 'livro_magnetico');
        }
        General.saveCrud(widget);
    };

    this.nivelCompletoProduto = function () {
        return General.getLevelByMask('GER_CDPICTPROD', '1').length;
    };

    this.habilitaWidgets = function (mainWidget, nomeWidgetAtual, status) {
        mainWidget.widgets.forEach(function (widg) {
            if (nomeWidgetAtual !== widg.name) widg.enabled = status;
        });
        if (mainWidget.name !== nomeWidgetAtual) mainWidget.enabled = status;
    };

    this.buscaLivroOrig = function (cdlivromagorigField, nmlivromagorigField) {
        var widgetLivroMagnetico = templateManager.container.getWidget('livro_magnetico');
        cdlivromagorigField.setValue(widgetLivroMagnetico.currentRow.CDLIVROMAG);
        nmlivromagorigField.setValue(widgetLivroMagnetico.currentRow.NMLIVROMAG);
    };

    this.apagaLivroDest = function (cdlivromagdestField, nmlivromagdestField) {
        cdlivromagdestField.setValue('');
        nmlivromagdestField.setValue('');
    };

    this.replicaTipoDocumentoCFOP = function (widget) {
        if (widget.isValid()) {
            ScreenService.confirmMessage(ScreenService.i18n(Messages_fiscal.CONFIRMA_REPLICACAO_LIVRO), 'question', function () {
                var widgetCadastro_layout = templateManager.container.getWidget('cadastro_layout');
                var cdlivromagorig = widget.currentRow.CDLIVROMAGORIG;
                var cdlivromagdest = widget.currentRow.CDLIVROMAG;
                if (widgetCadastro_layout.dataSource.data.length === 0) {
                    return ScreenService.showMessage(Messages_fiscal.LIVRO_ORIG_SEM_DADOS);
                } else {
                    Fis07200_LivroMagnetico_Service.deletaCadastroLayout({ "CDLIVROMAG": cdlivromagdest }).then(function (success) {
                        Fis07200_LivroMagnetico_Service.replicaTipoDocumentoCFOP({ "CDLIVROMAGORIG": cdlivromagorig, "CDLIVROMAGDEST": cdlivromagdest }).then(function (succes) {
                            ScreenService.showMessage(Messages_fiscal.REPLICACAO_SUCESS);
                            widgetCadastro_layout.reload();
                        });
                    }).catch(function (erroReplicaTipoDocumento) {
                        var errorMessage = 'Timeout';
                        if (erroReplicaTipoDocumento.data) {
                            errorMessage = erroReplicaTipoDocumento.data.error;
                        }
                        ScreenService.showMessage(errorMessage);
                    }).finally(function () {
                        ScreenService.closePopup();
                    });
                }
            });
        }
    };
    this.replicaCadastroTipo = function (widget) {
        if (widget.isValid()) {
            ScreenService.confirmMessage(ScreenService.i18n(Messages_fiscal.CONFIRMA_REPLICACAO_LIVRO), 'question', function () {
                var widgetCadastro_tipo = templateManager.container.getWidget('cadastro_tipo');
                var cdlivromagorig = widget.currentRow.CDLIVROMAGORIG;
                var cdlivromagdest = widget.currentRow.CDLIVROMAG;
                if (widgetCadastro_tipo.dataSource.data.length === 0) {
                    return ScreenService.showMessage(Messages_fiscal.LIVRO_ORIG_SEM_DADOS);
                } else {
                    Fis07200_LivroMagnetico_Service.deletaCadastroTipo({ "CDLIVROMAG": cdlivromagdest }).then(function (success) {
                        Fis07200_LivroMagnetico_Service.replicaCadastroTipo({ "CDLIVROMAGORIG": cdlivromagorig, "CDLIVROMAGDEST": cdlivromagdest }).then(function (succes) {
                            ScreenService.showMessage(Messages_fiscal.REPLICACAO_SUCESS);
                            widgetCadastro_tipo.reload();
                        });
                    }).catch(function (erroReplicaTipoDocumento) {
                        var errorMessage = 'Timeout';
                        if (erroReplicaTipoDocumento.data) {
                            errorMessage = erroReplicaTipoDocumento.data.error;
                        }
                        ScreenService.showMessage(errorMessage);
                    }).finally(function () {
                        ScreenService.closePopup();
                    });
                }
            });
        }
    };

    this.importaTipoDocumentoCFOP = function (widget) {
        if (widget.isValid()) {
            ScreenService.confirmMessage(ScreenService.i18n(Messages_fiscal.CONFIRMA_IMPORTACAO), 'question', function () {
                var widgetCadastro_layout = templateManager.container.getWidget('cadastro_layout');
                var widgetLivroMagnetico = templateManager.container.getWidget('livro_magnetico');
                var cdlivromag = widgetLivroMagnetico.currentRow.CDLIVROMAG;
                Fis07200_LivroMagnetico_Service.deletaLayoutCFOPLivroMag({ "CDLIVROMAG": cdlivromag }).then(function (success) {
                    var nmarquivoimporta = "configura_" + widget.currentRow.IDTIPODECLARA + ".json";
                    restEngine.requestMetaData("json/import/" + nmarquivoimporta, {}).then(function (response) {
                        var data = response.data;
                        Fis07200_LivroMagnetico_Service.importaLayoutCFOPLivroMag({ "DATA": data, "CDLIVROMAG": cdlivromag }).then(function (success) {
                            ScreenService.showMessage(Messages_fiscal.IMPORTACAO_SUCCESS);
                            widgetCadastro_layout.reload();
                        });
                    });
                }).catch(function (erroImportaLayoutCFOP) {
                    var errorMessage = 'Timeout';
                    if (erroImportaLayoutCFOP.data) {
                        errorMessage = erroImportaLayoutCFOP.data.error;
                    }
                    ScreenService.showMessage(errorMessage);
                }).finally(function () {
                    ScreenService.closePopup();
                    //este close popup é utilizado para fechar o conjunto de action localizados no never
                    ScreenService.closePopup();
                });
            });
        }
    };

    this.replicaGeneroTipoItemProduto = function (widget) {
        if (widget.isValid()) {
            ScreenService.confirmMessage(ScreenService.i18n(Messages_fiscal.CONFIRMA_REPLICACAO_LIVRO), 'question', function () {
                var widgetGeneroItemProduto = templateManager.container.getWidget('genero_item_por_produto');
                var cdlivromagorig = widget.currentRow.CDLIVROMAGORIG;
                var cdlivromagdest = widget.currentRow.CDLIVROMAG;
                if (widgetGeneroItemProduto.dataSource.data.length === 0) {
                    return ScreenService.showMessage(Messages_fiscal.LIVRO_ORIG_SEM_DADOS);
                } else {
                    Fis07200_LivroMagnetico_Service.deletaGeneroItemProduto({ "CDLIVROMAG": cdlivromagdest }).then(function (success) {
                        Fis07200_LivroMagnetico_Service.replicaGeneroTipoItemProduto({ "CDLIVROMAGORIG": cdlivromagorig, "CDLIVROMAGDEST": cdlivromagdest }).then(function (succes) {
                            ScreenService.showMessage(Messages_fiscal.REPLICACAO_SUCESS);
                            widgetGeneroItemProduto.reload();
                        });
                    }).catch(function (erroReplicaGeneroItemProduto) {
                        var errorMessage = 'Timeout';
                        if (erroReplicaGeneroItemProduto.data) {
                            errorMessage = erroReplicaGeneroItemProduto.data.error;
                        }
                        ScreenService.showMessage(errorMessage);
                    }).finally(function () {
                        ScreenService.closePopup();
                    });
                }
            });
        }
    };

    this.verificaIntervaloProduto = function (widget) {
        if (widget.currentRow.CDPRODINI && widget.currentRow.CDPRODFIN) {
            if (!Fis07200_LivroMagnetico_Service.validaIntervaloProduto(widget.currentRow.CDPRODINI, widget.currentRow.CDPRODFIN)) {
                return ScreenService.showMessage(Messages_fiscal.INTERVALO_INV_PRODUTO_ERROR);
            }
        }
    };

    this.openCadastroAutomatico = function () {
        var widgetCadastroAutomatico = templateManager.container.getWidget('cadastro_automatico_genero_item_produto');
        widgetCadastroAutomatico.currentRow.CDGENPROD = '';
        widgetCadastroAutomatico.currentRow.DSGENPROD = '';
        widgetCadastroAutomatico.currentRow.CDTPITEMPROD = '';
        widgetCadastroAutomatico.currentRow.NMTPITEMPROD = '';
        ScreenService.openPopup(widgetCadastroAutomatico);
    };

    this.realizaCadastroAutomaticoGeneroTipoItemProduto = function (widget) {
        if (widget.isValid()) {
            if (!Fis07200_LivroMagnetico_Service.validaIntervaloProduto(widget.currentRow.CDPRODINI, widget.currentRow.CDPRODFIN)) {
                return ScreenService.showMessage(Messages_fiscal.INTERVALO_INV_PRODUTO_ERROR);
            }
            var WidgetGenero = templateManager.container.getWidget('genero_item_por_produto');
            var widgetLivroMagnetico = templateManager.container.getWidget('livro_magnetico');
            var cdlivromag = widgetLivroMagnetico.currentRow.CDLIVROMAG;
            Fis07200_LivroMagnetico_Service.cadastraGenTipoItemAutomatico({ "CDLIVROMAG": cdlivromag, "ROW": widget.currentRow }).then(function (success) {
                ScreenService.showMessage(Messages_fiscal.CADASTRO_AUTOMATICO_SUCCESS);
                WidgetGenero.reload();
            }).catch(function (erroCadastroAutomatico) {
                var errorMessage = 'Timeout';
                if (erroCadastroAutomatico.data) {
                    errorMessage = erroCadastroAutomatico.data.error;
                }
                ScreenService.showMessage(errorMessage);
            }).finally(function () {
                ScreenService.closePopup();
                //este close popup é utilizado para fechar o conjunto de action localizados no never
                ScreenService.closePopup();
            });
        }
    };

    this.setLivroMagnetico = function () {
        Fis06900_TipoDeItem_Controller.setLivroMagnetico({
            "CDLIVROMAG": General.getFieldValue('CDLIVROMAG', 'livro_magnetico'),
            "NMLIVROMAG": General.getFieldValue('NMLIVROMAG', 'livro_magnetico')
        });
    };

    this.saveTipoItemProdLivroMag = function (widget) {
        if (widget.isValid()) {
            widget.currentRow.CDLIVROMAG = templateManager.container.getWidget('livro_magnetico').currentRow.CDLIVROMAG;
            General.saveCrud(widget);
        }
    };

    this.importaTipoItemPadrao = function (widget) {
        if (widget.isValid()) {
            if (widget.currentRow.IDTIPODECLARA === 'SPED') {
                ScreenService.confirmMessage(ScreenService.i18n(Messages_fiscal.CONFIRMA_IMPORTACAO), 'question', function () {
                    var widgetTipodeItem = templateManager.container.getWidget('tipoDeItem');
                    var widgetlivro = templateManager.container.getWidget('livro_magnetico');
                    var cdlivromag = widgetlivro.currentRow.CDLIVROMAG;
                    General.callRestEngine('fis#/tipoitem_livromag/delete', 'Row', { "CDLIVROMAG": cdlivromag }).then(function (success) {
                        var nmarquivoimporta = "TipoDeItem_" + widget.currentRow.IDTIPODECLARA + ".json";
                        restEngine.requestMetaData("json/import/" + nmarquivoimporta, {}).then(function (response) {
                            var data = response.data;
                            General.callRestEngine('fis#/tipoitem_livromag/import', 'Row', { "DATA": data, "CDLIVROMAG": cdlivromag }).then(function (success) {
                                ScreenService.showMessage(Messages_fiscal.IMPORTACAO_SUCCESS);
                                widgetTipodeItem.reload();
                            });
                        });
                    }).catch(function (erroImportTipoItem) {
                        if (erroImportTipoItem.data && erroImportTipoItem.data.error.indexOf('ORA-02292') !== -1) {
                            ScreenService.showMessage(Messages_fiscal.DELETE_IMPORTA_TIPO_ITEM_ERROR);
                        } else {
                            var errorMessage = 'Timeout';
                            if (erroImportTipoItem.data) {
                                errorMessage = erroImportTipoItem.data.error;
                            }
                            ScreenService.showMessage(errorMessage);
                        }
                    }).finally(function () {
                        ScreenService.closePopup();
                    });
                });
            }
        }
    };

    this.active = function (widget) {
        var widgetlivro = templateManager.container.getWidget('livro_magnetico');
        var tipodoc = widgetlivro.widgets[0];
        var cadastro_layout = tipodoc.widgets[3];
        cadastro_layout.activate();
    };

    /*Ativa/desabilita campo com filtro dependente de outros campos*/
    this.setEnableField = function (args, IDENTRSAIDOP, CDTIPOOPER) {
        args.owner.field.widget.getField(CDTIPOOPER).clearValue();
        if (args.owner.field.widget.currentRow[IDENTRSAIDOP] != "") {
            args.owner.field.widget.getField(CDTIPOOPER).readOnly = false;
            args.owner.field.widget.getField(CDTIPOOPER).reload();
        } else args.owner.field.widget.getField(CDTIPOOPER).readOnly = true;
    };

    this.carregaFilhos = function (widget) {
        var widgetlivro = templateManager.container.getWidget('livro_magnetico');
        var tipodoc = widgetlivro.widgets[0];
        var cadastro_layout = tipodoc.widgets[3];
        var layoutCfop = cadastro_layout.widgets[0];
        layoutCfop.reload();
    };

    this.carregaFilhosTipo = function (widget) {
        var widgetlivro = templateManager.container.getWidget('livro_magnetico');
        var tipodoc = widgetlivro.widgets[0];
        var cadastro_tipo = tipodoc.widgets[4];
        var TipoCfop = cadastro_tipo.widgets[0];
        TipoCfop.reload();
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis07200_LivroMagnetico_Controller', Fis07200_LivroMagnetico_Controller);
});

// FILE: ./assets/js/controllers/Fis08600_ParametrosIntegracaoFechamentoCupom_Controller.js
var Fis08600_ParametrosIntegracaoFechamentoCupom_Controller = function Fis08600_ParametrosIntegracaoFechamentoCupom_Controller(Fis08600_ParametrosIntegracaoFechamentoCupom_Service, ScreenService, General, templateManager, ZhFilterPreferences) {

    // controla os valores permitidos para a taxa administrativa
    this.validaValorTaxaAdministrativa = function (field) {
        if (field.value) {
            field.value(field.value().replace(",", "."));
            if (parseFloat(field.value()) > 100 || parseFloat(field.value()) < 0) {
                field.setValue('');
                ScreenService.showMessage('O valor da taxa administrativa deve estar entre 0 e 100.');
            }
        }
    };

    // controla bloqueio de campos referente ao campo taxa administrativa
    this.validaTaxaAdministrativa = function (field) {
        var widget = field.widget;
        var tipoAjusteCtReceber = widget.getField('CDAJTXADMREC');
        var descricao = widget.getField('DSAJUCTREC');
        if (parseFloat(field.value()) > 0) {
            tipoAjusteCtReceber.readOnly = false;
            tipoAjusteCtReceber.validations.required = true;
            descricao.validations.required = true;
        } else {
            tipoAjusteCtReceber.readOnly = true;
            delete tipoAjusteCtReceber.validations.required;
            tipoAjusteCtReceber.setValue('');
            delete descricao.validations.required;
            descricao.setValue('');
        }
    };

    // controla bloqueio de campos referente ao campo taxa gera baixa automatica
    this.controlaGeraBaixaAutomatica = function (field) {
        var widget = field.widget;
        var tipoBaixa = widget.getField('CDTPBAIXAREC');
        var descricao = widget.getField('NMTPBAIXAREC');
        if (field.value() == 'S') {
            tipoBaixa.readOnly = false;
            tipoBaixa.validations.required = true;
            descricao.validations.required = true;
        } else {
            tipoBaixa.readOnly = true;
            delete tipoBaixa.validations.required;
            tipoBaixa.setValue('');
            delete descricao.validations.required;
            descricao.setValue('');
        }
    };

    // controla bloqueio de campos referente ao campo indice financeiro
    this.controlaIndiceFinanceiro = function (widget, taxaAdiministrativa) {
        var indiceFinanceiro;
        if (widget.name == 'widgetTipoRecebimentoUnidade') {
            indiceFinanceiro = widget.currentRow.IDGERAFINFIL;
        } else if (widget.name == 'widgetTipoRecebimento') {
            indiceFinanceiro = widget.currentRow.IDGERAFIN;
        }
        var camposExecao = ['CDTIPORECE', 'NMTIPORECE', 'IDGERAFIN', 'IDGERAFINFIL', 'VRTAXAADMI', 'VRTAXAADMFIL', 'CDAJTXADMREC', 'IDBAIXAAUTCNC'];
        var camposObrigatoriosFilial = ['NRINSJURCLIE', 'NMRAZSOCCLIE', 'CDTPCTRECEB', 'DSTPCTRECEB', 'CDREDUCONT', 'DSCONTCORR', 'IDCONTAREPFOS'];
        var camposObrigatorios = ['IDCONSVRDEBCONS', 'IDGERABAIXAUTO', 'IDCONTAPREVCNC'];
        var camposLivres = ['NRINSJURCLIE', 'CDFORMPGTO', 'NRDIASADMI', 'NRDIASADMIFIL', 'CDTPCTRECEB', 'CDREDUCONT', 'IDCONSVRDEBCONS', 'VRTAXAADMI', 'VRTAXAADMFIL', 'IDGERABAIXAUTO', 'CDTPAJUSANGRACR', 'CDTPAJUSANGRRED', 'IDCONTAPREVCNC', 'IDCONTAREPFOS']; //campos que são liberados para o usario digitar
        //bloqueia todos os fields quando o indicia financeiro for N;

        widget.fields.forEach(function (field) {
            if (camposExecao.indexOf(field.name) == -1) {
                field.readOnly = true;
                if (field.validations) {
                    delete field.validations.required;
                }
            }
        });
        if (indiceFinanceiro == 'S') {
            widget.fields.forEach(function (field) {
                if (camposLivres.indexOf(field.name) !== -1) {
                    field.readOnly = false;
                }
                if (camposObrigatorios.indexOf(field.name) !== -1) {
                    field.validations.required = true;
                }
                if (camposObrigatoriosFilial.indexOf(field.name) !== -1 && widget.name == 'widgetTipoRecebimentoUnidade') {
                    field.validations.required = true;
                }
            });

            this.validaTaxaAdministrativa(widget.getField(taxaAdiministrativa));
            this.controlaGeraBaixaAutomatica(widget.getField('IDGERABAIXAUTO'));
            if (widget.name == 'widgetTipoRecebimentoUnidade') {
                this.verificaValoresRecebimento(widget);
            }
        } else {
            if (widget.name == 'widgetTipoRecebimentoUnidade') {
                widget.getField('IDCONTAREPFOS').setValue('N');
            } else {
                widget.getField('IDCONTAPREVCNC').setValue('N');
            }
        }
        return templateManager.updateTemplate();
    };

    this.editarTipoRecebimento = function (widget, taxaAdiministrativa) {
        this.controlaIndiceFinanceiro(widget, taxaAdiministrativa).then(function () {
            General.edit(widget);
            widget.activate();
        });
    };

    this.salvarTipoRecebimento = function (widget) {
        if (widget.isValid()) {
            if (widget.currentRow.IDGERAFIN == 'N') {
                var camposExecao = ['CDTIPORECE', 'NMTIPORECE', 'IDGERAFIN', 'VRTAXAADMI', 'CDAJTXADMREC', 'DSAJUCTREC', 'IDBAIXAAUTCNC'];
                Fis08600_ParametrosIntegracaoFechamentoCupom_Service.validaIndiceFinanceiro(widget.fields, camposExecao);
                widget.currentRow.CDCLIENTE = '';
                widget.currentRow.IDGERABAIXAUTO = 'N';
                widget.currentRow.IDCONSVRDEBCONS = 'N';
            }
            if (!widget.currentRow.VRTAXAADMI) {
                widget.currentRow.VRTAXAADMI = 0;
            }
            if (!widget.currentRow.IDCONTAPREVCNC) {
                widget.currentRow.IDCONTAPREVCNC = 'N';
            }
            General.saveCrud(widget);
        }
    };

    this.salvarTipoRecebimentoUnidade = function (widget) {

        if (widget.isValid()) {
            if (widget.currentRow.__is_new) {
                widget.currentRow.CDFILIAL = widget.getParent().currentRow.CDFILIAL;
            }
            if (widget.currentRow.IDGERAFINFIL == 'N') {
                var camposExecao = ['CDTIPORECE', 'NMTIPORECE', 'IDGERAFINFIL', 'VRTAXAADMFIL', 'CDAJTXADMREC', 'DSAJUCTREC', 'IDBAIXAAUTCNC'];
                Fis08600_ParametrosIntegracaoFechamentoCupom_Service.validaIndiceFinanceiro(widget.fields, camposExecao);
                widget.currentRow.CDCLIENTE = '';
                widget.currentRow.IDGERABAIXAUTO = 'N';
                widget.currentRow.IDCONSVRDEBCONS = 'N';
            }
            if (!widget.currentRow.VRTAXAADMFIL) {
                widget.currentRow.VRTAXAADMFIL = 0;
            }
            if (!widget.currentRow.IDCONTAREPFOS) {
                widget.currentRow.IDCONTAREPFOS = 'N';
            }

            General.saveCrud(widget);
        }
    };

    this.salvarParametrosUnidade = function (widget) {
        if (!widget.currentRow.VRTAXAADMISERV) {
            widget.currentRow.VRTAXAADMISERV = 0;
        }
        General.saveCrud(widget);
    };

    this.afterMoveRowUnidade = function (widget) {
        //verifica se ja existe a filial cadastrada na Paravend
        Fis08600_ParametrosIntegracaoFechamentoCupom_Service.verificaFilialParavend(widget.currentRow).then(function (sucess) {
            var novo = sucess.dataset.resultado.NOVO;
            if (novo) {
                widget.reload();
            }
        }, function (callback) {
            if (callback.data) {
                ScreenService.showMessage(callback.data.error);
            }
        });
        widget.widgets[0].reload();
    };

    this.addTipoRecebimentoUnidade = function (widget) {
        widget.newRow();
        General.justInteger('#NRDIASADMIFIL');
        this.controlaIndiceFinanceiro(widget, 'VRTAXAADMFIL');
    };

    // controla bloqueio de campos referente ao fechamento cupom referente ao paremtros por unidade
    this.controlaFechamentoCupom = function (widget) {
        var camposExecao = ['CDFILIAL', 'NMFILIAL', 'IDFECHACUPOM', 'IDGERALANCREDSAN', 'DSTPCREDBANCSAN', 'DSCONTCORRSAN'];
        var camposObrigatorios = ['IDUTFECHAUTO', 'IDUTLIBERAPROV', 'IDPREVALIDCUPOM', 'CDTPOPERCNTREC', 'NMTIPOOPERCNTREC', 'CDSERIECNTREC', 'DSSERIECNTREC', 'NRINSJURCLIEPADFIS', 'NMRAZSOCCLIEPADFIS', 'IDGERAMRNUMREDZ', 'IDTPAPUFIL', 'CDTPAJUSANGRACR', 'DSAJUSANGRACR', 'CDTPAJUSANGRRED', 'DSAJUSANGRRED', 'IDUTILCONTAB', 'IDCONTTXSERVSEP', 'CDTPAJTXSERV', 'DSTPAJTXSERV', 'CDTPAJTXADMSERV', 'DSTPAJTXTXADM'];
        var camposLivres = ['IDUTFECHAUTO', 'IDUTLIBERAPROV', 'IDPREVALIDCUPOM', 'CDTPOPERCNTREC', 'CDSERIECNTREC', 'NRINSJURCLIEPADFIS', 'IDGERAMRNUMREDZ', 'IDTPAPUFIL', 'CDTPAJUSANGRACR', 'CDTPAJUSANGRRED', 'IDUTILCONTAB', 'IDCONTTXSERVSEP', 'CDTPAJTXSERV', 'VRTAXAADMISERV', 'CDTPAJTXADMSERV', 'IDFECHLOJA']; //campos que são liberados para o usario digitar
        //bloqueia todos os fields quando o indicia financeiro for N;
        if (widget.currentRow.IDFECHACUPOM == 'N') {
            widget.fields.forEach(function (field) {
                if (camposExecao.indexOf(field.name) == -1) {
                    field.readOnly = true;
                    if (field.validations) {
                        delete field.validations.required;
                    }
                }
            });
        } else {
            widget.fields.forEach(function (field) {
                if (camposLivres.indexOf(field.name) !== -1) {
                    field.readOnly = false;
                }
                if (camposObrigatorios.indexOf(field.name) !== -1) {
                    field.validations.required = true;
                }
            });
            this.controlaAprovacaoAutomatica(widget);
            this.controlaValoresRecebimento(widget);
            this.controlaTaxaAdmServico(widget);
            this.controlaContabilizaTaxaServico(widget);
            this.controlaGeraLancamentoCredito(widget);
        }
    };

    // controla bloqueio de campos referente ao campo controla aprovação automática
    this.controlaAprovacaoAutomatica = function (widget) {
        var aprovacaoAtomatica = widget.getField('IDUTFECHAUTO');
        var utilizaLiberacao = widget.getField('IDUTLIBERAPROV');

        if (aprovacaoAtomatica.value() === 'S') {
            utilizaLiberacao.readOnly = false;
            utilizaLiberacao.validations.required = true;
        } else {
            utilizaLiberacao.readOnly = true;
            delete utilizaLiberacao.validations.required;
            utilizaLiberacao.setValue('N');
        }
    };

    // controla bloqueio de campos referente ao campo valores de recebimento
    this.controlaValoresRecebimento = function (widget) {
        var valorRecebimento = widget.getField('IDTPAPUFIL');
        var codigoAcrescimo = widget.getField('CDTPAJUSANGRACR');
        var descricaoAcrescimo = widget.getField('DSAJUSANGRACR');
        var codigoReducao = widget.getField('CDTPAJUSANGRRED');
        var descricaoReducao = widget.getField('DSAJUSANGRRED');

        if (valorRecebimento.value() === 'V') {
            codigoAcrescimo.readOnly = true;
            codigoReducao.readOnly = true;

            delete codigoAcrescimo.validations.required;
            delete descricaoAcrescimo.validations.required;
            delete codigoReducao.validations.required;
            delete descricaoReducao.validations.required;
        } else {
            codigoAcrescimo.readOnly = false;
            codigoReducao.readOnly = false;

            codigoAcrescimo.validations.required = true;
            descricaoAcrescimo.validations.required = true;
            codigoReducao.validations.required = true;
            descricaoReducao.validations.required = true;
        }
    };

    // controla bloqueio de campos referente ao campo taxa administrativa sobre taxa de serviço
    this.controlaTaxaAdmServico = function (widget) {
        var taxa = widget.getField('VRTAXAADMISERV');
        var codigoAjuste = widget.getField('CDTPAJTXADMSERV');
        var descricaoAjuste = widget.getField('DSTPAJTXTXADM');

        if (parseFloat(taxa.value()) > 0) {
            codigoAjuste.readOnly = false;
            codigoAjuste.validations.required = true;
            descricaoAjuste.validations.required = true;
        } else {
            codigoAjuste.readOnly = true;
            delete codigoAjuste.validations.required;
            codigoAjuste.setValue('');
            delete descricaoAjuste.validations.required;
            descricaoAjuste.setValue('');
        }
    };

    // controla bloqueio de campos referente ao campo taxa administrativa sobre taxa de serviço
    this.controlaContabilizaTaxaServico = function (widget) {
        var contabiliza = widget.getField('IDCONTTXSERVSEP');
        var codigoAjuste = widget.getField('CDTPAJTXSERV');
        var descricaoAjuste = widget.getField('DSTPAJTXSERV');
        var taxa = widget.getField('VRTAXAADMISERV');
        var codigoAjusteAdm = widget.getField('CDTPAJTXADMSERV');
        var descricaoAjusteAdm = widget.getField('DSTPAJTXTXADM');

        if (contabiliza.value() === 'S') {
            codigoAjuste.readOnly = false;
            codigoAjuste.validations.required = true;
            descricaoAjuste.validations.required = true;

            taxa.readOnly = false;
            codigoAjusteAdm.readOnly = false;
            codigoAjusteAdm.validations.required = true;
            descricaoAjusteAdm.validations.required = true;
        } else {
            codigoAjuste.readOnly = true;
            delete codigoAjuste.validations.required;
            codigoAjuste.setValue('');
            codigoAjusteAdm.readOnly = true;
            delete codigoAjusteAdm.validations.required;
            codigoAjusteAdm.setValue('');

            taxa.readOnly = true;
            taxa.value(0);
            delete descricaoAjuste.validations.required;
            descricaoAjuste.setValue('');
            delete descricaoAjusteAdm.validations.required;
            descricaoAjusteAdm.setValue('');
        }
        this.controlaTaxaAdmServico(widget);
    };

    // verifica se o valor de recebimento da unidade e Vendas ou Sangrias para controlar campos do Tipo de Recebimento por Unidade
    this.verificaValoresRecebimento = function (widget) {
        var widgetUnidade = widget.getParent();
        var ajusteAcrescimo = widget.getField('CDTPAJUSANGRACR');
        var ajusteReducao = widget.getField('CDTPAJUSANGRRED');

        if (widgetUnidade.currentRow.IDTPAPUFIL == 'V') {
            ajusteAcrescimo.readOnly = true;
            ajusteReducao.readOnly = true;
        } else {
            ajusteAcrescimo.readOnly = false;
            ajusteReducao.readOnly = false;
        }
    };

    this.openFilterRelacaoTiposRecebimentos = function (widget) {
        var filter = [{
            "name": "CDFILIAL",
            "operator": "=",
            "value": getLocalVar('CDFILIAL')
        }];

        General.callRestEngine('fin#/crud/filial', 'FilterData', filter).then(function (result) {
            var filial = result.dataset.filial;
            var rowSetFilter = null;

            if (filial.length > 0) {
                rowSetFilter = {
                    'CDFILIAL': filial[0].CDFILIAL,
                    'NMFILIAL': filial[0].NMFILIAL
                };
            }

            ZhFilterPreferences.setOriginalFilter(widget.id, rowSetFilter);
            ZhFilterPreferences.openFilterWidget(widget, rowSetFilter);
        });
    };

    this.reloadRelacaoTiposRecebimentos = function (widget) {
        if (widget.appliedFilter) widget.reload();
    };

    this.afterMoveRowUnidadeSetDataSourceFilter = function (widget) {
        var filter = [{
            "name": "CDFILIAL",
            "operator": "=",
            "value": widget.currentRow.CDFILIAL
        }];

        General.callRestEngine('fin#/crud/filial', 'FilterData', filter).then(function (result) {
            var filial = result.dataset.filial;
            var field = widget.getField('CDSERIECNTREC');
            field.dataSourceFilter = [{
                'name': 'CDEMPRESA',
                'operator': '=',
                'value': filial[0].CDEMPRESA
            }, {
                'name': 'CDINSCESTA',
                'operator': '=',
                'value': filial[0].CDINSCESTA
            }, {
                'name': 'CDINSCMUNI',
                'operator': '=',
                'value': filial[0].CDINSCMUNI
            }];
            field.reload();
        });
    };

    // Controla bloqueio de campos referente ao campo Gera Lançamento de Crédito
    this.controlaGeraLancamentoCredito = function (widget) {
        var idgeralancredsan = widget.getField('IDGERALANCREDSAN');
        var dstpcredbancsan = widget.getField('DSTPCREDBANCSAN');
        var dscontcorrsan = widget.getField('DSCONTCORRSAN');

        if (idgeralancredsan.value() === 'S') {
            dstpcredbancsan.readOnly = false;
            dscontcorrsan.readOnly = false;
            dstpcredbancsan.validations.required = true;
            dscontcorrsan.validations.required = true;
        } else {
            dstpcredbancsan.readOnly = true;
            dscontcorrsan.readOnly = true;
            delete dstpcredbancsan.validations.required;
            delete dscontcorrsan.validations.required;
        }
    };
};
Configuration(function (ContextRegister) {
    ContextRegister.register('Fis08600_ParametrosIntegracaoFechamentoCupom_Controller', Fis08600_ParametrosIntegracaoFechamentoCupom_Controller);
});

// FILE: ./assets/js/controllers/Fis09200_ParametrosEmissaoGuias_Controller.js
var Fis09200_ParametrosEmissaoGuias_Controller = function Fis09200_ParametrosEmissaoGuias_Controller(ScreenService, General, templateManager, Fis09200_ParametrosEmissaoGuias_Service, restEngine) {

    this.controlaWidgets = function (widget) {
        var widgetImposto = templateManager.container.getWidget('tabbedImposto');
        var widgetBeneficiario = templateManager.container.getWidget('tabbedBeneficiario');
        if (widget.currentRow.IDGERCONPAGGUIA === 'S') {
            widgetImposto.enabled = true;
            widgetBeneficiario.enabled = true;
        } else {
            widgetImposto.enabled = false;
            widgetBeneficiario.enabled = false;
        }
    };

    this.saveGeral = function (widget) {
        General.widgetSave(widget).then(function (sucess) {
            this.controlaWidgets(widget);
        }.bind(this), function (callback) {
            if (callback.data) {
                ScreenService.showMessage(callback.data.error);
            }
        });
    };

    this.setarDataSource = function (args) {
        var widget = args.owner;
        if (widget.dataSource.data.length == 0) {
            widget.currentRow = { "__is_new": true, "CDPARFISCAL": 1 };
        } else {
            widget.currentRow = widget.dataSource.data[0];
        }
        this.controlaWidgets(widget);
    };

    this.setarDataSourceImposto = function (args) {
        var widget = args.owner;
        if (widget.dataSource.data.length == 0) {
            widget.currentRow = { "__is_new": true, "CDIMPOSTO": widget.getParent().currentRow.CDIMPOSTONFE };
        } else {
            widget.currentRow = widget.dataSource.data[0];
        }
    };

    //realiza o controle de campos que dependem  campo 'gera conta a pagar' da tabbed geral
    this.controlaCampoGeraConta = function (widget) {
        var tipoOperacao = widget.getField('CDTIPOOPERPREPAG');
        if (widget.currentRow.IDGERCONPAGGUIA === 'S') {
            tipoOperacao.readOnly = false;
        } else {
            tipoOperacao.readOnly = true;
        }
    };

    //on change campo  'gera conta a pagar'
    this.onChangeGeraContaPagar = function (widget) {
        if (widget.currentRow.IDGERCONPAGGUIA !== 'S') {
            widget.currentRow.CDTIPOOPERPREPAG = '';
            widget.currentRow.NMTIPOOPERPREPAG = '';
        }
        this.controlaCampoGeraConta(widget);
    };

    this.salvarBeneficiario = function (widget) {
        if (widget.isValid()) {
            if (widget.currentRow.__is_new) {
                this.setaValoresBeneficiario(widget);
            }
            Fis09200_ParametrosEmissaoGuias_Service.salvarBeneficiario(widget.currentRow).then(function (sucess) {
                if (widget.currentRow.__is_new) {
                    widget.list(true);
                    ScreenService.goBack();
                    widget.reload();
                } else {
                    widget.computeDescriptionOrder();
                    widget.view();
                }
            }, function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };

    //seta valores quando vai inserir um novo beneficiario
    this.setaValoresBeneficiario = function (widget) {
        widget.currentRow.NRSEQPARAMBENIMP = '';
        switch (widget.name) {
            case 'widgetFederal':
                widget.currentRow.IDTPPARAMBENEF = 'F';
                break;
            case 'widgetEstadual':
                widget.currentRow.IDTPPARAMBENEF = 'E';
                widget.currentRow.CDPAIS = widget.getParent().currentRow.CDPAIS;
                break;
            case 'widgetMunicipal':
                widget.currentRow.IDTPPARAMBENEF = 'M';
                widget.currentRow.CDPAIS = widget.getParent().currentRow.CDPAIS;
                widget.currentRow.SGESTADO = widget.getParent().currentRow.SGESTADO;
                break;

        }
    };

    // controla filtro da aba Estadual (Beneficiário)
    this.controlaFiltroBeneficiarioEstadual = function (widget) {
        var widgetEstadual = widget.widgets[0];
        var actionAdd = widgetEstadual.getAction('adicionarRow');
        if (widget.currentRow.CDPAIS) {
            actionAdd.readOnly = false;
        } else {
            actionAdd.readOnly = true;
        }
        widgetEstadual.reload();
    };

    this.verificaFiltro = function (widget) {
        var tabbedEstadual = widget.getParent();
        if (!tabbedEstadual.currentRow.CDPAIS) {
            widget.dataSource.data = [];
        }
    };

    this.controlaCampoPaisEstado = function (widget) {
        var estado = widget.getField('NMESTADO');
        estado.value('');
        widget.currentRow.SGESTADO = '';
        if (widget.currentRow.CDPAIS) {
            estado.readOnly = false;
        } else {
            estado.readOnly = true;
        }
        this.controlaFiltroBeneficiarioMunicipal(widget);
    };

    // controla filtro da aba Estadual (Beneficiário)
    this.controlaFiltroBeneficiarioMunicipal = function (widget) {
        var widgetMunicipal = widget.widgets[0];
        var actionAdd = widgetMunicipal.getAction('adicionarRow');
        if (widget.currentRow.CDPAIS && widget.currentRow.SGESTADO) {
            actionAdd.readOnly = false;
        } else {
            actionAdd.readOnly = true;
        }
        widgetMunicipal.reload();
    };

    this.verificaFiltroMunicipal = function (widget) {
        var tabbedMunicipal = widget.getParent();
        if (!tabbedMunicipal.currentRow.CDPAIS || !tabbedMunicipal.currentRow.SGESTADO) {
            widget.dataSource.data = [];
        }
    };

    // controla filtro da aba Imposto
    this.controlaFiltroImposto = function (widget) {
        var widgetImposto = widget.widgets[0];
        var actionEdit = widgetImposto.getAction('editar');
        if (widget.currentRow.CDIMPOSTONFE) {
            actionEdit.readOnly = false;
        } else {
            actionEdit.readOnly = true;
        }
        widgetImposto.reload([], false);
    };

    this.editarImposto = function (widget) {
        var widgetFiltro = widget.getParent();
        widgetFiltro.getField('SGIMPOSTONFE').readOnly = true;

        widget.template = widget.templateToForm;
        General.edit(widget);
        this.controlaStatusWidgets(widgetFiltro.getParent(), 'tabbedImposto', false);
        this.controlaDia(widget.getField('NRDIAFIXVENC'));
        this.controlaCampoLancamentoNota(widget.getField('IDGERACTLANCTONF'));
    };

    this.cancelarImposto = function (widget) {
        var widgetFiltro = widget.getParent();
        for (var i in widget.backupRow) {
            widget.currentRow[i] = widget.backupRow[i];
        }
        widget.template = widget.templateToView;
        widget.view();
        widgetFiltro.getField('SGIMPOSTONFE').readOnly = false;
        this.controlaStatusWidgets(widgetFiltro.getParent(), 'tabbedImposto', true);
    };

    this.salvarImposto = function (widget) {
        if (widget.isValid()) {
            var widgetFiltro = widget.getParent();
            widget.saveRow().then(function () {
                this.controlaStatusWidgets(widgetFiltro.getParent(), 'tabbedImposto', true);
                widget.currentRow.__is_new = false;
                widget.template = widget.templateToView;
                widget.view();
                widgetFiltro.getField('SGIMPOSTONFE').readOnly = false;
            }.bind(this), function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };

    this.controlaStatusWidgets = function (mainWidget, nomeWidgetAtual, status) {
        mainWidget.widgets.forEach(function (widg) {
            if (nomeWidgetAtual !== widg.name) widg.enabled = status;
        });

        if (mainWidget.name !== nomeWidgetAtual) mainWidget.enabled = status;
    };

    this.controlaDia = function (field) {
        if (field.value()) {
            field.validations.range = { "min": 1, "max": 31 };
        } else {
            delete field.validations.range;
        }
    };

    this.controlaCampoLancamentoNota = function (field) {
        var widget = field.widget;
        var campoTipoConta = widget.getField('IDTPCONTGERA');
        if (field.value() === "S") {
            campoTipoConta.readOnly = false;
            campoTipoConta.validations.required = true;
        } else {
            campoTipoConta.readOnly = true;
            delete campoTipoConta.validations.required;
            campoTipoConta.value('P');
        }
    };

    this.statusFiltro = function (widget, status) {
        var widgetFiltro = widget.getParent();
        if (!widget.currentRow.__is_new) {

            widgetFiltro.fields.forEach(function (field) {
                field.readOnly = status;
            });
        }
    };

    /*Certificado*/
    this.widgetNewCertificado = function (widget) {
        General.widgetEdit(widget);
        widget.getField('UPLOADCERT').showOnForm = true;
        widget.getField('UPLOADCERT').validations = {
            "extensions": {
                "value": ["", ".pfx", ".p12"]
            },
            "required": true
        };
    };

    this.salvarCertificado = function (widget) {
        if (widget.isValid()) {
            widget.getField('UPLOADCERT').validations = {}; //Oculta o campo de upload do certificado para as demais operações
            widget.getField('UPLOADCERT').showOnForm = false;
            Fis09200_ParametrosEmissaoGuias_Service.salvarCertificado(widget).then(function (sucess) {
                widget.list();
                widget.reload();
                widget.view();
                ScreenService.goBack();
            }, function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };

    this.desativaField = function (widget, nmField) {
        widget.getField(nmField).validations = {};
        widget.getField(nmField).showOnForm = false;
    };

    /*Ativa/desabilita campo com filtro dependente de outros campos*/
    this.setEnableField = function (args, nmFieldRef, nmFieldDest) {
        args.owner.field.widget.getField(nmFieldDest).clearValue();
        if (args.owner.field.widget.currentRow[nmFieldRef] != "") {
            args.owner.field.widget.getField(nmFieldDest).readOnly = false;
            args.owner.field.widget.getField(nmFieldDest).reload();
        } else args.owner.field.widget.getField(nmFieldDest).readOnly = true;
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis09200_ParametrosEmissaoGuias_Controller', Fis09200_ParametrosEmissaoGuias_Controller);
});

// FILE: ./assets/js/controllers/Fis22000_PreValidacaoDeclaracoesAcessorias_Controller.js
var Fis22000_PreValidacaoDeclaracoesAcessorias_Controller = function Fis22000_PreValidacaoDeclaracoesAcessorias_Controller(ScreenService, General, templateManager, Fis22000_PreValidacaoDeclaracoesAcessorias_Service) {

    this.preenchercampos = function (widget) {
        var imposto = localStorage.getItem('imposto');
        var empresa = localStorage.getItem('empresa');
        var nomeempr = localStorage.getItem('nomeempr');
        var inscricao = localStorage.getItem('inscricao');
        var mapa = localStorage.getItem('mapa');
        var nomemapa = localStorage.getItem('nomemapa');

        if (imposto == '00' || imposto == '80' || imposto == '10') {
            widget.getField('P_DSTIPOVALIDA').value('SPED');
        } else if (imposto == '50' || imposto == '60') {
            var data = widget.getField('DATA');
            var mapacont = widget.getField('NMMAPAAPUR');
            var inscricaoEstadual = widget.getField('CDINSCESTA');
            widget.getField('P_DSTIPOVALIDA').value('SPED_CONTRIB');
            data.value({ start: moment().format('DD/MM/YYYY'), end: moment().format('DD/MM/YYYY') });
            data.validations.required = true;
            data.isVisible = true;

            mapacont.isVisible = false;
            mapacont.value('');
            widget.currentRow.NRSEQUMAPAPU = '';
            delete mapacont.validations.required;

            inscricaoEstadual.readOnly = true;
            inscricaoEstadual.value('');
            if (inscricao == null) {
                inscricao.value('');
            }
            delete inscricaoEstadual.validations.required;
        } else if (imposto == '41' || imposto == '42') {
            widget.getField('P_DSTIPOVALIDA').value('EFD_Reinf');
        }
        widget.getField('CDEMPRESA').value(empresa);
        widget.getField('NMEMPRESA').value(nomeempr);
        widget.getField('CDINSCESTA').value(inscricao);
        widget.getField('NMMAPAAPUR').value(nomemapa);
        widget.getField('NRSEQUMAPAPU').value(mapa);

        widget.reload();
    };
    this.preencher = function (widget) {
        var imposto = localStorage.getItem('imposto');
        var empresa = localStorage.getItem('empresa');
        var nomeempr = localStorage.getItem('nomeempr');
        var inscricao = localStorage.getItem('inscricao');
        var mapa = localStorage.getItem('mapa');
        var nomemapa = localStorage.getItem('nomemapa');

        if (imposto == '00' || imposto == '80' || imposto == '10') {
            widget.getField('P_DSTIPOVALIDA').value('SPED');
        } else if (imposto == '50' || imposto == '60') {
            var data = widget.getField('DATA');
            var mapacont = widget.getField('NMMAPAAPUR');
            var inscricaoEstadual = widget.getField('CDINSCESTA');
            widget.getField('P_DSTIPOVALIDA').value('SPED_CONTRIB');
            data.value({ start: moment().format('DD/MM/YYYY'), end: moment().format('DD/MM/YYYY') });
            data.validations.required = true;
            data.isVisible = true;

            mapacont.isVisible = false;
            mapacont.value('');
            widget.currentRow.NRSEQUMAPAPU = '';
            delete mapacont.validations.required;

            inscricaoEstadual.readOnly = true;
            inscricaoEstadual.value('');
            if (inscricao == null) {
                inscricao.value('');
            }
            delete inscricaoEstadual.validations.required;
        } else if (imposto == '41' || imposto == '42') {
            widget.getField('P_DSTIPOVALIDA').value('EFD_Reinf');
        }
        widget.getField('CDEMPRESA').value(empresa);
        widget.getField('NMEMPRESA').value(nomeempr);
        widget.getField('CDINSCESTA').value(inscricao);
        widget.getField('NMMAPAAPUR').value(nomemapa);
        widget.getField('NRSEQUMAPAPU').value(mapa);

        widget.reload();
    };
    /*
    this.controlaInscricao = function (widget){
        var inscricaoEstadual  = widget.getField('CDINSCESTA');
        var inscricaoMunicipal = widget.getField('CDINSCMUNI');
         if(widget.currentRow.CDIMPOSTO){
            switch(widget.currentRow.IDORGARRECAD) {
                case 'E':
                    inscricaoMunicipal.value('');
                     inscricaoEstadual.readOnly  = false;
                    inscricaoMunicipal.readOnly = true;
                     inscricaoEstadual.isVisible  = true;
                    inscricaoMunicipal.isVisible = false;
                     delete(inscricaoMunicipal.validations.required);
                    inscricaoEstadual.validations.required = true;
                     this.controlaValorMapa(widget);
                    break;
                case 'M':
                    inscricaoEstadual.value('');
                     inscricaoEstadual.readOnly  = true;
                    inscricaoMunicipal.readOnly = false;
                     inscricaoEstadual.isVisible  = false;
                    inscricaoMunicipal.isVisible = true;
                     delete(inscricaoEstadual.validations.required);
                    inscricaoMunicipal.validations.required = true;
                     this.controlaValorMapa(widget);
                    break;
                case 'F':
                    inscricaoMunicipal.value('');
                    inscricaoEstadual.value('');
                     widget.currentRow.NRSEQUMAPAPU ='';
                    widget.currentRow.NMMAPAAPUR ='';
                     inscricaoEstadual.readOnly  = true;
                    inscricaoMunicipal.readOnly = true;
                     inscricaoEstadual.isVisible  = true;
                    inscricaoMunicipal.isVisible = false;
                     delete(inscricaoMunicipal.validations.required);
                    delete(inscricaoEstadual.validations.required);
                    break;
            }
        }
        else{
            inscricaoMunicipal.value('');
            inscricaoEstadual.value('');
             inscricaoEstadual.readOnly  = true;
            inscricaoMunicipal.readOnly = true;
             inscricaoEstadual.isVisible  = true;
            inscricaoMunicipal.isVisible = false;
             delete(inscricaoMunicipal.validations.required);
            inscricaoEstadual.validations.required = true;
             widget.currentRow.NRSEQUMAPAPU ='';
            widget.currentRow.NMMAPAAPUR ='';
        }
    };
    */
    this.controlaValorMapa = function (widget) {
        switch (widget.currentRow.IDORGARRECAD) {
            case 'E':
                if (!widget.currentRow.CDINSCESTA) {
                    widget.currentRow.NRSEQUMAPAPU = '';
                    widget.currentRow.NMMAPAAPUR = '';
                }
                break;
            case 'M':
                if (!widget.currentRow.CDINSCMUNI) {
                    widget.currentRow.NRSEQUMAPAPU = '';
                    widget.currentRow.NMMAPAAPUR = '';
                }
                break;
        }
    };

    this.verificaDataField = function (field, msgVazio) {
        field.reload().then(function () {
            if (field.dataSource.data.length == 0) {
                ScreenService.showMessage(msgVazio);
            }
        });
    };

    this.apagarCampos = function (widget, camposApagar) {
        camposApagar.forEach(function (campo) {
            widget.currentRow[campo] = '';
        });
    };
    /*
    this.filtroMapaApuracao = function (field){
        var widget = field.widget;
        var filtroInscricao;
        switch(widget.currentRow.IDORGARRECAD) {
            case 'E':
                filtroInscricao =
                    {
                        "name":"P_INSCRICAO",
                        "operator":"=",
                        "value":widget.currentRow.CDINSCESTA
                    };
                break;
            case 'M':
                filtroInscricao =
                    {
                        "name":"P_INSCRICAO",
                        "operator":"=",
                        "value": widget.currentRow.CDINSCMUNI
                    };
                 break;
            case 'F':
                filtroInscricao =
                    {
                        "name":"P_INSCRICAO",
                        "operator":"=",
                        "value":null
                    };
                break;
            default:
                filtroInscricao =
                    {
                        "name":"P_INSCRICAO",
                        "operator":"=",
                        "value":null
                    };
                break;
        }
        var filtro = [
            {
                "name":"P_IDORGARRECAD",
                "operator":"=",
                "value":widget.currentRow.IDORGARRECAD
            },
            {
                "name":"P_CDIMPOSTO",
                "operator":"=",
                "value":widget.currentRow.CDIMPOSTO
            }
        ];
        filtro.push(filtroInscricao);
        field.dataSourceFilter = filtro;
        this.verificaDataField(field, 'Não há mapa cadastrado.')
    };
    */
    this.controlaTipoValidacao = function (field) {
        var widget = field.widget;
        //var imposto            = widget.getField('SGIMPOSTO');
        var inscricaoEstadual = widget.getField('CDINSCESTA');
        //var inscricaoMunicipal = widget.getField('CDINSCMUNI');
        var data = widget.getField('DATA');
        var mapa = widget.getField('NMMAPAAPUR');

        switch (field.value()) {
            case 'SPED':
                data.value('');
                delete data.validations.required;
                data.isVisible = false;

                mapa.isVisible = true;
                mapa.validations.required = true;

                //imposto.readOnly = false;
                //imposto.validations.required = true;

                //this.controlaInscricao(widget);
                inscricaoEstadual.readOnly = false;
                inscricaoEstadual.isVisible = true;
                inscricaoEstadual.validations.required = true;
                break;

            case 'SPED_CONTRIB':
                data.value({ start: moment().format('DD/MM/YYYY'), end: moment().format('DD/MM/YYYY') });
                data.validations.required = true;
                data.isVisible = true;

                mapa.isVisible = false;
                mapa.value('');
                widget.currentRow.NRSEQUMAPAPU = '';
                delete mapa.validations.required;

                inscricaoEstadual.readOnly = true;
                inscricaoEstadual.value('');
                delete inscricaoEstadual.validations.required;

                //inscricaoMunicipal.readOnly = true;
                //inscricaoMunicipal.value('');
                //delete(inscricaoMunicipal.validations.required);

                //imposto.value('');
                //widget.currentRow.IDORGARRECAD ='';
                //widget.currentRow.CDIMPOSTO='';
                //imposto.readOnly = true;
                //delete(imposto.validations.required);
                break;

            case 'DAPI':
                data.value('');
                delete data.validations.required;
                data.isVisible = false;

                mapa.isVisible = true;
                mapa.validations.required = true;

                //imposto.readOnly = false;
                //imposto.validations.required = true;

                inscricaoEstadual.readOnly = false;
                inscricaoEstadual.isVisible = true;
                inscricaoEstadual.validations.required = true;
                //this.controlaInscricao(widget);
                break;
        }
    };

    this.validarNF = function (widget) {
        if (widget.isValid()) {
            widget.currentRow.CDIMPOSTO = '00';
            widget.currentRow.IDORGARRECAD = 'E';
            if (Fis22000_PreValidacaoDeclaracoesAcessorias_Service.validaEstadoIscricao(widget.currentRow)) {
                var widgetNF = templateManager.container.getWidget('widgetNotaFiscal');
                var widgetErros = templateManager.container.getWidget('widgetErros');
                Fis22000_PreValidacaoDeclaracoesAcessorias_Service.validarNF(widget.currentRow).then(function (sucess) {
                    widgetNF.dataSource.data = sucess.dataset.resul.notas;
                    widgetErros.dataSource.data = sucess.dataset.resul.erros;
                    var imposto = localStorage.removeItem('imposto');
                    var empresa = localStorage.removeItem('empresa');
                    var nomeempr = localStorage.removeItem('nomeempr');
                    var inscricao = localStorage.removeItem('inscricao');
                    var mapa = localStorage.removeItem('mapa');
                    var nomemapa = localStorage.removeItem('nomemapa');
                }, function (callback) {
                    if (callback.data) {
                        ScreenService.showMessage(callback.data.error);
                    }
                });
            } else {
                ScreenService.showMessage('Para validar o DAPI-MG a inscrição estadual deve ser de Minas Gerais.');
            }
        }
    };

    this.setFiltroErrosNF = function (widget) {
        var widgetFiltro = widget.getParent();
        var widgetErrosNotas = widget.widgets[0];
        var errosAvisos = this.retornaErrosAvisos(widgetFiltro.currentRow);
        var filtro = [{
            "name": "P_CDFILIAL",
            "operator": "=",
            "value": widget.currentRow.CDFILIAL
        }, {
            "name": "P_NRLANCTONF",
            "operator": "=",
            "value": widget.currentRow.NRLANCTONF
        }, {
            "name": "P_ERROS",
            "operator": "=",
            "value": errosAvisos
        }, {
            "name": "P_DSTIPOVALIDA",
            "operator": "=",
            "value": widgetFiltro.currentRow.P_DSTIPOVALIDA
        }];
        widgetErrosNotas.dataSourceFilter = filtro;
        widgetErrosNotas.reload();
    };

    this.retornaErrosAvisos = function (row) {
        if (row.P_ERROS == 'T') {
            return null;
        } else {
            return row.P_ERROS;
        }
    };

    this.apagarDataSource = function () {
        var widgetNotas = templateManager.container.getWidget('widgetNotaFiscal');
        var widgetErros = templateManager.container.getWidget('widgetErros');

        widgetNotas.dataSource.data = [];
        widgetErros.dataSource.data = [];
    };

    this.controlaActionParametrizacao = function (field) {
        var widgetNotas = templateManager.container.getWidget('widgetNotaFiscal');
        var widgetErros = templateManager.container.getWidget('widgetErros');
        if (field.value() === 'SPED_CONTRIB') {
            widgetNotas.getAction('parametrosPreValidacao').isVisible = true;
            widgetErros.getAction('parametrosPreValidacao').isVisible = true;
        } else {
            widgetNotas.getAction('parametrosPreValidacao').isVisible = false;
            widgetErros.getAction('parametrosPreValidacao').isVisible = false;
        }
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis22000_PreValidacaoDeclaracoesAcessorias_Controller', Fis22000_PreValidacaoDeclaracoesAcessorias_Controller);
});

// FILE: ./assets/js/controllers/Fis22100_PrametrosPreValidacao_Controller.js
var Fis22100_PrametrosPreValidacao_Controller = function Fis22100_PrametrosPreValidacao_Controller(ScreenService, General, templateManager, Fis22100_PrametrosPreValidacao_Service) {

    this.setaTipoOperacaoSelecionado = function (widget) {
        var chave = widget.getField('CHAVE');
        var tipoOperacao = chave.value();
        if (tipoOperacao) {
            chave.reload().then(function (Success) {
                var data = chave.dataSource.data;
                data.forEach(function (row) {
                    if (tipoOperacao.indexOf(row.CHAVE) !== -1) {
                        row.__isSelected = true;
                    }
                });
            });
        }
    };

    this.salvar = function (widget) {
        if (widget.isValid()) {
            Fis22100_PrametrosPreValidacao_Service.concatenarTipoOperacao(widget.currentRow);
            General.saveCrud(widget);
        }
    };

    this.controlaCampoValidacao = function (widget) {
        var campoValidacao = widget.getField('IDVALIDA');
        var campoChave = widget.getField('CHAVE');

        if (campoValidacao.value() == 'S') {
            campoChave.readOnly = false;
        } else {
            campoChave.readOnly = true;
        }
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis22100_PrametrosPreValidacao_Controller', Fis22100_PrametrosPreValidacao_Controller);
});

// FILE: ./assets/js/controllers/Fis25000_ParametrizacaoContribuicoes_Controller.js
var Fis25000_ParametrizacaoContribuicoes_Controller = function Fis25000_ParametrizacaoContribuicoes_Controller(ScreenService, General, templateManager, Fis25000_ParametrizacaoContribuicoes_Service) {

    this.recarregarWidgetsFilhas = function (widget) {
        if (!widget.currentRow.__is_new) {
            widget.widgets.forEach(function (w) {
                w.reload();
            });
        }
    };

    this.setaValorTpOperacao = function (widget) {
        if (["01", "02", "03", "05"].indexOf(widget.currentRow.CDSITUTRIBPICO) != -1) {
            widget.currentRow.IDOPERPICO = '1';
        } else {
            widget.currentRow.IDOPERPICO = '2';
        }
    };

    this.valoresMinMaxData = function (widget) {
        var dataInicial = widget.getField('DTINIVALID');
        var dataFinal = widget.getField('DTFIMVALID');

        dataInicial.maxDate = dataFinal.value() || '0';
        dataFinal.minDate = dataInicial.value() || '0';
    };

    this.salvarOutrasContribuicoes = function (widget) {
        var widgetEmpresa = templateManager.container.getWidget('parametrosEmpresa'),
            currentRow = widget.currentRow;
        currentRow.dataSourceName = widget.dataSource.name;

        if (widget.isValid()) {
            if (currentRow.__is_new) {
                currentRow.CDEMPRESA = widgetEmpresa.currentRow.CDEMPRESA;
                if (currentRow.dataSourceName == "fis#/crud/outcrecont") {
                    currentRow.CDOUTCRECONT = 'new';
                } else {
                    currentRow.CDOUTRECCONT = 'new';
                }
            }
            this.formataAliquota(widget);
            Fis25000_ParametrizacaoContribuicoes_Service.salvarOutrasContribuicoes(currentRow).then(function (sucess) {
                widget.widgets[0].enabled = true;
                if (currentRow.__is_new) {
                    widget.list(true);
                    ScreenService.goBack();
                    widget.reload();
                } else {
                    widget.view();
                }
            }, function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };

    this.formataAliquota = function (widget) {
        var pis = String(widget.currentRow.VRALIQPIS);
        var cofins = String(widget.currentRow.VRALIQCOFINS);
        widget.currentRow.VRALIQPIS = pis.replace(',', '.');
        widget.currentRow.VRALIQCOFINS = cofins.replace(',', '.');
    };

    this.addOutrasContribuicoes = function (widget) {
        widget.newRow();
        if (widget.name == 'widgetOutrasReceitas') {
            General.justInteger('#CDNATUREC');
        } else {
            General.justInteger('#CDNATUBCALC');
        }
        this.valoresMinMaxData(widget);
        widget.widgets[0].enabled = false;
    };

    this.deletarOutrasContribuicoes = function (widget) {
        widget.currentRow.dataSourceName = widget.dataSource.name;
        ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
            Fis25000_ParametrizacaoContribuicoes_Service.deletarOutrasContribuicoes(widget.currentRow).then(function (sucess) {
                ScreenService.closeSwipe().then(function () {
                    widget.reload();
                    widget.activate();
                });
            }, function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        });
    };

    this.salvarContaContabil = function (widget) {
        if (widget.isValid()) {
            var widgetOutrasReceitas;
            widget.currentRow.dataSourceName = widget.dataSource.name;
            if (widget.currentRow.dataSourceName == "fis#/crud/outcrecontctbl_contctbl") {
                widgetOutrasReceitas = templateManager.container.getWidget('widgetOutrosCreditos');
                widget.currentRow.CDOUTCRECONT = widgetOutrasReceitas.currentRow.CDOUTCRECONT;
            } else {
                widgetOutrasReceitas = templateManager.container.getWidget('widgetOutrasReceitas');
                widget.currentRow.CDOUTRECCONT = widgetOutrasReceitas.currentRow.CDOUTRECCONT;
            }

            widget.currentRow.CDEMPRESA = widgetOutrasReceitas.currentRow.CDEMPRESA;
            widgetOutrasReceitas.currentRow.dataSourceName = widgetOutrasReceitas.dataSource.name;
            widget.currentRow.rowOutrasContribuicoes = widgetOutrasReceitas.currentRow;
            Fis25000_ParametrizacaoContribuicoes_Service.salvarContaContabil(widget.currentRow).then(function (sucess) {
                if (widget.currentRow.__is_new) {
                    widget.list(true);
                    ScreenService.goBack();
                    widget.reload();
                } else {
                    widget.view();
                }
            }, function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
        widget.reload();
    };

    this.salvarBenfeitoria = function (widget) {
        var widgetEmpresa = templateManager.container.getWidget('parametrosEmpresa');
        if (widget.isValid()) {
            if (widget.currentRow.__is_new) {
                widget.currentRow.CDEMPRESA = widgetEmpresa.currentRow.CDEMPRESA;
                widget.currentRow.NRSEQBENFEITORIA = '';
            }
            this.formataAliquota(widget);
            Fis25000_ParametrizacaoContribuicoes_Service.salvarBenfeitoria(widget.currentRow).then(function (sucess) {
                if (widget.currentRow.__is_new) {
                    widget.list(true);
                    ScreenService.goBack();
                    widget.reload();
                } else {
                    widget.view();
                }
            }, function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };

    this.deletarTipoOperacao = function (widget) {
        ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
            widget.currentRow.IDTPFATAPURA = null;
            widget.saveRow().then(function (sucess) {
                ScreenService.goBack();
                widget.reload();
            }, function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        });
    };

    this.salvarTipoOperacao = function (widget) {
        var dateInicial = widget.currentRow.DTINIVALIDFAT;
        var dateFinal = widget.currentRow.DTFINIVALIDFAT;
        var inicial = dateInicial.split('/'); // separa a data pelo caracter '/'
        var final = dateFinal.split('/'); // separa a data pelo caracter '/'
        dateInicial = new Date(inicial[2], inicial[1] - 1, inicial[0]); // formata 'date'
        dateFinal = new Date(final[2], final[1] - 1, final[0]); // formata 'date'
        if (widget.isValid()) {
            widget.currentRow.__is_new = false;
            if (widget.name == 'widgetCompoeReceita') {
                widget.currentRow.IDTPFATAPURA = 'C';
            } else if (widget.name == 'widgetDeduzReceita') {
                widget.currentRow.IDTPFATAPURA = 'D';
            }
            if (dateFinal >= dateInicial) {
                widget.saveRow().then(function (sucess) {
                    widget.list(true);
                    ScreenService.goBack();
                    widget.reload();
                }, function (callback) {
                    if (callback.data) {
                        ScreenService.showMessage(callback.data.error);
                    }
                });
            } else {
                ScreenService.showMessage("Data Final não pode ser menor que a Data Inicial");
            }
        }
    };

    this.carregaDataSource = function (args) {
        var widget = args.owner;
        var data = args.owner.dataSource.data;
        if (data.length == 0) {
            widget.currentRow = { "CDPARFISCAL": 1, "__is_new": true };
        } else {
            widget.currentRow = data[0];
            widget.currentRow.__is_new = false;
        }
    };

    this.verificaAjuste = function (widget) {
        var campoDescricao = widget.getField('DSGERAJUSAUTSPED');
        var campoCodigo = widget.getField('CDAJUSTE');

        if (widget.currentRow.IDGERAJUSAUTSPED == 'S') {
            campoCodigo.readOnly = false;
            campoDescricao.readOnly = false;
            campoCodigo.validations.required = true;
        } else {
            campoCodigo.readOnly = true;
            campoDescricao.readOnly = true;
            delete campoCodigo.validations.required;
        }
    };

    this.salvarParametrosGerais = function (args) {
        var widget = args.owner.widget;
        General.saveCrud(widget).then(function (Success) {
            widget.view(true);
            widget.template = widget.templateToView;
            General.changeWidgetAcessibility(widget.getParent().widgets, true);
        }.bind(this), function (callback) {
            if (callback.data) {
                ScreenService.showMessage(callback.data.error);
            }
        });
    };

    this.aplicarFiltroTabelas = function (widget) {
        var widgetTabelas = widget.widgets[0];
        this.recarregarWidgetsFilhas(widget);
        if (widget.currentRow.CDTABELASPED) {
            widgetTabelas.getAction("importar").readOnly = false;
        } else {
            widgetTabelas.getAction("importar").readOnly = true;
        }
    };

    this.abrirImportacaoTabelas = function (widget) {
        var widgetPopup = templateManager.container.getWidget('importarTabelas');
        ScreenService.openPopup(widgetPopup);
        widgetPopup.currentRow.CDTABELASPED = widget.getParent().currentRow.CDTABELASPED;
        widgetPopup.currentRow.TABELA = '';
    };
    this.validaData = function (widget, date) {
        var dateInicial = widget.currentRow.DTINIVALIDFAT;
        var dateFinal = widget.currentRow.DTFINIVALIDFAT;
        var inicial = dateInicial.split('/'); // separa a data pelo caracter '/'
        var final = dateFinal.split('/'); // separa a data pelo caracter '/'
        dateInicial = new Date(inicial[2], inicial[1] - 1, inicial[0]); // formata 'date'
        dateFinal = new Date(final[2], final[1] - 1, final[0]); // formata 'date'

        if (dateFinal >= dateInicial) {
            ScreenService.showMessage("Data valida");
        } else {
            ScreenService.showMessage("Data Final não pode ser menor que a Data Inicial");
        }
    };

    this.salvarImportacao = function (widget) {
        if (widget.isValid()) {
            Fis25000_ParametrizacaoContribuicoes_Service.salvarImportacao(widget.currentRow).then(function (sucess) {
                ScreenService.showMessage('Importação realizada com sucesso.');
                ScreenService.closePopup();
                widget.getParent().reload();
            }, function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };

    this.desbloqueia = function (widget) {
        var campo01 = widget.currentRow.IDREDUZBCICMS;
        var campo02 = widget.getField('CDCSTAJBCICMS');
        var campo03 = widget.getField('CDCONTCTBLAJICMS');

        if (campo01 == 'N') {
            campo02.readOnly = true;
            campo03.readOnly = true;
            campo02.required = false;
            campo02.validations = false;
            campo03.required = false;
            campo03.validations = false;
        } else {
            campo02.readOnly = false;
            campo03.readOnly = false;
            campo02.required = true;
            campo02.validations = true;
            campo03.required = true;
            campo03.validations = true;
        }
    };
    this.desbloqueiacampo = function (widget) {
        var campo01 = widget.currentRow.IDGERANFESTDD;
        var campo02 = widget.getField('DSDEDUCAOEST');

        if (campo01 == 'N') {
            campo02.readOnly = true;
            campo02.required = false;
            campo02.validations = false;
        } else {
            campo02.readOnly = false;
            campo02.required = true;
            campo02.validations = true;
        }
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis25000_ParametrizacaoContribuicoes_Controller', Fis25000_ParametrizacaoContribuicoes_Controller);
});

// FILE: ./assets/js/controllers/Fis27100_Relacionamento_de_Codigo_da_Receita_Controller.js
var Fis27100_Relacionamento_de_Codigo_da_Receita_Controller = function Fis27100_Relacionamento_de_Codigo_da_Receita_Controller(ScreenService, General, templateManager, Fis27100_Relacionamento_de_Codigo_da_Receita_Service) {

    this.save = function (args) {
        var widget = args.widget;
        if (widget.isValid()) {
            if (widget.currentRow.__is_new) {
                Fis27100_Relacionamento_de_Codigo_da_Receita_Service.save(widget.currentRow).then(function (success) {
                    widget.view();
                    widget.reload();
                }, function (error) {
                    var errorMessage = 'Timeout';
                    if (error.data) {
                        errorMessage = error.data.error;
                    }
                    ScreenService.showMessage(errorMessage);
                });
            } else {
                Fis27100_Relacionamento_de_Codigo_da_Receita_Service.update(widget.currentRow).then(function (success) {
                    widget.view();
                    widget.reload();
                }, function (error) {
                    var errorMessage = 'Timeout';
                    if (error.data) {
                        errorMessage = error.data.error;
                    }
                    ScreenService.showMessage(errorMessage);
                });
            }
        }
    };

    this.saveimposto = function (args) {
        var widget = args.widget;
        if (widget.isValid()) {
            widget.currentRow.CDRECEITA = widget.currentRow.CDRECEITACONTR;
            General.saveCrud(widget);
        }
    };
    this.tipo = function (args) {
        var widget = args.widget;

        if (widget.currentRow.IDTIPO == "F") {} else if (widget.currentRow.IDTIPO == "L") {} else {}
    };

    this.openCadastroAutomatico = function () {
        var widgetCadastroAutomatico = templateManager.container.getWidget('cadastro_automatico');
        widgetCadastroAutomatico.currentRow.CDGENPROD = '';
        widgetCadastroAutomatico.currentRow.DSGENPROD = '';
        widgetCadastroAutomatico.currentRow.CDTPITEMPROD = '';
        widgetCadastroAutomatico.currentRow.NMTPITEMPROD = '';
        ScreenService.openPopup(widgetCadastroAutomatico);
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis27100_Relacionamento_de_Codigo_da_Receita_Controller', Fis27100_Relacionamento_de_Codigo_da_Receita_Controller);
});

// FILE: ./assets/js/controllers/Fis46000_ParametrizacaoCodigosApuracao_Controller.js
var Fis46000_ParametrizacaoCodigosApuracao_Controller = function Fis46000_ParametrizacaoCodigosApuracao_Controller(Fis46000_ParametrizacaoCodigosApuracao_Service, ScreenService, General, ZhFilterPreferences, templateManager) {

    /********************************************************************
    *                  Funções Referentes a aba                         *
    *                  Código da Receita                                *
    ********************************************************************/

    var editCodigoDaReceita = false; // identifica se um novo resgistro está sendo criado
    var backupRow = null; // guarda a linha a ser editada para passar ao update do backend


    //funcao usada para voltar do view
    this.back = function (widget) {
        ScreenService.closeSwipe();
        editCodigoDaReceita = false;
    };

    //funcao usada para voltar do edit ou save que trata as mudanças na linha
    this.cancel = function (args) {
        General.backOrCancel(args);
        editCodigoDaReceita = false;
    };

    // Funcao chamada ao mudar o field SGIMPOSTONFE que atualiza o filtro do CDRECEITACONTR
    this.changeFieldImposto = function (nomeWidget) {
        var widget = templateManager.container.getWidget(nomeWidget);
        widget.reload();
        var field = widget.getField("CDRECEITACONTR");
        if (editCodigoDaReceita) {
            this.updateFilter(field, ["CDIMPOSTONFE"], "=", [widget.currentRow.CDIMPOSTO]);
            //unlockPrimaryFields();
        } else {
            var widgetPopup = widget.appliedFilter.FILTER_ROW;
            this.updateFilter(field, ["CDIMPOSTONFE"], "=", [widgetPopup.CDIMPOSTO]);
            //unlockPrimaryFields(true);
        }

        widget.currentRow.CDRECEITACONTR = '';
        widget.currentRow.IDPERIODICREC = 'M';
        widget.currentRow.IDDEBSCPINC = '0';
        widget.currentRow.CDVARIACAO = '01';
        this.controlaCamposVisiveis(widget);
    };

    this.edit = function (widget) {
        editCodigoDaReceita = true;
        backupRow = Util.clone(widget.currentRow);
        blockFields(widget, ["SGIMPOSTONFE", "CDRECEITACONTR"]);
        General.edit(widget);
    };

    this.new = function (widget) {
        var cdrecepadrao = widget.getField('CDRECEPADRAO');
        widget.getParent().currentRow.CDIMPOSTONFE = widget.getParent().currentRow.CDIMPOSTO;
        var CDIMPOSTONFE = widget.getParent().currentRow.CDIMPOSTONFE;

        if (CDIMPOSTONFE != null) {
            cdrecepadrao.dataSourceFilter = [{
                "name": "CDIMPOSTONFE",
                "operator": "=",
                "value": CDIMPOSTONFE
            }];
        } else {
            cdrecepadrao.dataSourceFilter = [];
        }

        cdrecepadrao.reload();
        widget.newRow();

        //unlockPrimaryFields();
    };

    this.save = function (widget) {
        if (widget.currentRow.__is_new === true) {
            if (!CodigoDaFaixaHasVariation(widget)) {
                widget.currentRow.CDVARIACAO = "01";
                widget.currentRow.IDPERIODICREC = "M";
                widget.currentRow.IDDEBSCPINC = "0";
            }
        }
        if (widget.isValid()) {
            if (widget.currentRow.__is_new === true) {
                widget.currentRow.CDRECEITACONTR = widget.currentRow.CDRECEPADRAO;
                widget.currentRow.NMRECEITACONTR = widget.currentRow.DSRECEPADRAO;
                widget.currentRow.CDIMPOSTO = widget.getParent().currentRow.CDIMPOSTONFE;
                General.saveCrud(widget);
            } else {
                var dataSet = [backupRow, widget.currentRow];
                Fis46000_ParametrizacaoCodigosApuracao_Service.updateCodigoDaReceita(dataSet).then(function (success) {
                    widget.activate();
                    widget.computeDescriptionOrder();
                    widget.view();
                    widget.reload();
                }, function (error) {
                    var errorMessage = 'Timeout';
                    if (error.data) {
                        errorMessage = error.data.error;
                    }
                    ScreenService.showMessage(errorMessage);
                    widget.reload();
                });
            }
            editCodigoDaReceita = false;
        }
    };

    this.controlaCamposVisiveis = function (widget) {
        var impostos = ['10', '21', '22', '25', '40', '50', '60', '70'];
        var campos = ['IDPERIODICREC', 'CDVARIACAO', 'IDDEBSCPINC'];
        var actionEdit = widget.getAction('edit');
        if (impostos.indexOf(widget.currentRow.CDIMPOSTO) != -1) {
            alterarPropiedadeCampos(widget, campos, 'showOnView', true);
            alterarPropiedadeCampos(widget, campos, 'showOnForm', true);
            actionEdit.readOnly = false;
        } else {
            alterarPropiedadeCampos(widget, campos, 'showOnView', false);
            alterarPropiedadeCampos(widget, campos, 'showOnForm', false);
            actionEdit.readOnly = true;
        }
    };

    var alterarPropiedadeCampos = function alterarPropiedadeCampos(widget, campos, propriedade, status) {
        campos.forEach(function (field) {
            widget.getField(field)[propriedade] = status;
            if (status) widget.getField(field).validations.required = true;else delete widget.getField(field).validations.required;
        });
    };

    function CodigoDaFaixaHasVariation(widget) {
        return !(widget.currentRow.CDIMPOSTO === "41" || widget.currentRow.CDIMPOSTO === "42");
    }

    this.filtro = function (widget) {
        var a = 1;
    };

    /*function impostoIsEmpty(widget){
        if(widget.currentRow && widget.currentRow.SGIMPOSTONF && widget.currentRow.SGIMPOSTONF.Elength < 1){
            return true;
        }
        else{
            return false;
        }
    }
    */
    this.updateFilter = function (object, fieldNames, operator, values) {
        var dataSourceFilter = object.dataSourceFilter;
        for (var i = 0; i < fieldNames.length; i++) {
            if (values[i] !== "") {
                dataSourceFilter = dataSourceFilter.concat({
                    "name": fieldNames[i],
                    "operator": operator,
                    "value": values[i]
                });
            }
        }
        object.dataSourceFilter = dataSourceFilter;
        object.reload();
    };

    function blockFields(widget, fieldNames) {
        for (var i = 0; i < fieldNames.length; i++) {
            widget.getField(fieldNames[i]).readOnly = true;
        }
    }

    this.salvarCodigoReceitaEstadual = function (widget) {
        if (widget.isValid()) {
            if (widget.currentRow.__is_new) {
                widget.currentRow.SGESTADO = widget.getParent().currentRow.SGESTADO;
                widget.currentRow.CDPAIS = widget.getParent().currentRow.CDPAIS;
                widget.currentRow.NRSEQCODRECEEST = '';
            }
            Fis46000_ParametrizacaoCodigosApuracao_Service.salvarCodigoReceitaEstadual(widget.currentRow).then(function (sucess) {
                if (widget.currentRow.__is_new) {
                    widget.list(true);
                    ScreenService.goBack();
                    widget.reload();
                } else {
                    widget.view();
                }
            }, function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };

    this.deletarCodigoReceitaFederal = function (widget) {
        if (!widget.currentRow.IDDEBSCPINC) widget.currentRow.IDDEBSCPINC = '0';
        if (!widget.currentRow.IDPERIODICREC) widget.currentRow.IDPERIODICREC = 'M';
        if (!widget.currentRow.CDVARIACAO) widget.currentRow.CDVARIACAO = '01';
        General.deleteCrud(widget);
    };

    /********************************************************************
    *                  Funções Referentes a aba                         *
    *                  Código de Ajuste                                 *
    ********************************************************************/

    this.verficaTipoApuracao = function (widget) {
        var widgetAjuste = widget.widgets[0];
        var widgetDescricaoMotivo = widget.widgets[1];
        if (widget.currentRow.IDTPAJUSTE == 'A') {
            widgetDescricaoMotivo.enabled = false;
            widgetAjuste.activate();
        } else {
            widgetDescricaoMotivo.enabled = true;
        }
    };

    this.salvarDescricaoMotivoAjuste = function (widget) {
        var widgetFiltro = widget.getParent().getParent();
        if (widget.currentRow.__is_new) {
            widget.currentRow.SGESTADO = widgetFiltro.currentRow.SGESTADO;
            widget.currentRow.CDPAIS = widgetFiltro.currentRow.CDPAIS;
        }
        General.saveCrud(widget);
    };

    this.salvarCodigoAjuste = function (widget) {
        if (widget.isValid()) {
            if (widget.currentRow.__is_new) {
                setaValoresNovoAjuste(widget);
            }
            Fis46000_ParametrizacaoCodigosApuracao_Service.salvarCodigoAjuste(widget.currentRow).then(function (sucess) {
                if (widget.currentRow.__is_new) {
                    widget.list(true);
                    ScreenService.goBack();
                    widget.reload();
                } else {
                    widget.view();
                }
            }, function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };

    this.salvarImportacaoTabelas = function (widget) {
        var dataset = { row: widget.currentRow, dataset: widget.getParent().dataSource.data };

        if (widget.isValid()) {
            Fis46000_ParametrizacaoCodigosApuracao_Service.salvarImportacaoTabelas(dataset).then(function (sucess) {
                ScreenService.showMessage('Importação realizada com sucesso.');
                ScreenService.closePopup();
                widget.getParent().reload();
            }, function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };

    this.valoresMinMaxData = function (widget) {
        var dataInicial = widget.getField('DTINIVALID');
        var dataFinal = widget.getField('DTFIMVALID');

        dataInicial.maxDate = dataFinal.value() || '0';
        dataFinal.minDate = dataInicial.value() || '0';
    };

    this.converteMaiusculoCodigo = function (field) {
        if (field.value()) {
            field.value(field.value().toUpperCase());
        }
    };

    /********************************************************************
    *                  Funções Referentes controle                      *
    *                           de Tela                                 *
    ********************************************************************/

    var reloadWidgets = function reloadWidgets(nomesWidgets) {
        nomesWidgets.forEach(function (widget) {
            templateManager.container.getWidget(widget).reload();
        });
    };

    var verificaActionAdd = function verificaActionAdd(widget) {
        var widgetAjuste = '';
        var widgetDescricaoMotivo = '';
        var estado = '';
        var ajuste = '';

        widgetAjuste = widget.widgets[0];
        widgetDescricaoMotivo = widget.widgets[1];

        estado = widget.getParent().currentRow.SGESTADO;
        ajuste = widget.currentRow.IDTPAJUSTE;

        if (estado && ajuste) {
            widgetAjuste.getAction('importar').readOnly = false;
            widgetAjuste.getAction('adicionarRow').readOnly = false;
            widgetDescricaoMotivo.getAction('adicionarRow').readOnly = false;
        } else {
            widgetAjuste.getAction('importar').readOnly = true;
            widgetAjuste.getAction('adicionarRow').readOnly = true;
            widgetDescricaoMotivo.getAction('adicionarRow').readOnly = true;
        }
    };

    var verificaActionReceita = function verificaActionReceita(widget) {
        var estado = widget.currentRow.SGESTADO;
        var widgetNatureza = widget.widgets[0];
        if (estado) {
            widgetNatureza.getAction('adicionarRow').readOnly = false;
            widgetNatureza.getAction('importar').readOnly = false;
        } else {
            widgetNatureza.getAction('adicionarRow').readOnly = true;
            widgetNatureza.getAction('importar').readOnly = true;
        }
    };

    this.onChangeEstado = function (widget, widgetsRecarregar) {
        reloadWidgets(widgetsRecarregar);
        var isEstadual = widget.name === 'tabbedEstadual' ? true : false;
        verificaActionAdd(widget.widgets[1], isEstadual);
        verificaActionReceita(widget);
    };

    this.onChangeTipoAjuste = function (widget, widgetsRecarregar) {
        reloadWidgets(widgetsRecarregar);
        verificaActionAdd(widget);
        this.verficaTipoApuracao(widget);
    };

    /*this.recaregarWidgetsFilha = function (widget){
        var widgetAjuste          = widget.widgets[0];
        var widgetDescricaoMotivo = widget.widgets[1];
        widgetAjuste.reload();
        widgetDescricaoMotivo.reload();
        var estado = widget.getParent().currentRow.SGESTADO;
        var ajuste = widget.currentRow.IDTPAJUSTE;
         if(estado && ajuste){
            widgetAjuste.getAction('importar').readOnly = false;
            widgetAjuste.getAction('adicionarRow').readOnly = false;
            widgetDescricaoMotivo.getAction('adicionarRow').readOnly = false;
        }else{
            widgetAjuste.getAction('importar').readOnly = true;
            widgetAjuste.getAction('adicionarRow').readOnly = true;
            widgetDescricaoMotivo.getAction('adicionarRow').readOnly = true;
        }
    };
    */

    this.realizaImportacaoTabelas = function (widget) {
        //var widgetImportacao = templateManager.container.getWidget('importarTabelas');
        var widgetImportacao = widget.widgets[0];
        ScreenService.openPopup(widgetImportacao);
        setaValoresImportacao(widget.name, widget.widgets[0]);
    };

    var setaValoresImportacao = function setaValoresImportacao(nomeWidget, widget) {
        var filtroEstadual = templateManager.container.getWidget('tabbedEstadual');
        switch (nomeWidget) {
            case 'codigo_receita_estadual':
                widget.currentRow.SGESTADO = filtroEstadual.currentRow.SGESTADO;
                widget.currentRow.NMESTADO = filtroEstadual.currentRow.NMESTADO;
                widget.currentRow.TIPO = 'RECEITAESTADUAL';
                break;
            case 'widgetCodigoAjusteEstadual':
                widget.currentRow.SGESTADO = filtroEstadual.currentRow.SGESTADO;
                widget.currentRow.NMESTADO = filtroEstadual.currentRow.NMESTADO;
                widget.currentRow.IDTPAJUSTE = templateManager.container.getWidget('tabbedCodigoAjusteEstadual').currentRow.IDTPAJUSTE;
                widget.currentRow.TIPO = 'AJUSTEESTADUAL';
                widget.currentRow.IDTPCODRECEITA = 'E';
                break;
            case 'widgetCodigoAjusteFederal':
                widget.currentRow.SGESTADO = null;
                widget.currentRow.CDPAIS = null;
                widget.currentRow.TIPO = 'AJUSTEFEDERAL';
                widget.currentRow.IDTPCODRECEITA = 'F';
                break;
        }
        widget.currentRow.TABELA = '';
    };

    var setaValoresNovoAjuste = function setaValoresNovoAjuste(widget) {
        var widgetFiltro = widget.getParent();
        if (widget.name === 'widgetCodigoAjusteEstadual') {
            widget.currentRow.CDPAIS = widgetFiltro.getParent().currentRow.CDPAIS;
            widget.currentRow.SGESTADO = widgetFiltro.getParent().currentRow.SGESTADO;
            widget.currentRow.IDTPAJUSTE = widgetFiltro.currentRow.IDTPAJUSTE;
            widget.currentRow.IDTPCODRECEITA = 'E';
        } else if (widget.name === 'widgetCodigoAjusteFederal') {
            widget.currentRow.IDTPAJUSTE = 'A';
            widget.currentRow.CDPAIS = null;
            widget.currentRow.SGESTADO = null;
            widget.currentRow.IDTPCODRECEITA = 'F';
        }
        widget.currentRow.NRSEQCODAJUSTE = '';
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis46000_ParametrizacaoCodigosApuracao_Controller', Fis46000_ParametrizacaoCodigosApuracao_Controller);
});

// FILE: ./assets/js/controllers/Fis55000_ParametrizacaoExportacaoMunicipal_Controller.js
var Fis55000_ParametrizacaoExportacaoMunicipal_Controller = function Fis55000_ParametrizacaoExportacaoMunicipal_Controller(Messages_fiscal, ScreenService, General, templateManager, ZhFilterPreferences, Fis55000_ParametrizacaoExportacaoMunicipal_Service) {

    var filtrou = function filtrou(widget) {
        if (!widget.appliedFilter.FILTER_ROW.CDEMPRESA || !widget.appliedFilter.FILTER_ROW.CDINSCMUNI) {
            ScreenService.showMessage(Messages_fiscal.SEM_FILTRO_EXPORTACAO_MUNI);
            return false;
        } else {
            return true;
        }
    };

    /** Variáveis de Inicialização */
    var self = this;

    /**
     * Busca Filial
     * @return filialLogada
     */
    self.buscaFilial = function () {
        return Fis55000_ParametrizacaoExportacaoMunicipal_Service.buscaFilial();
    };

    /**
     * Busca Parâmetros de Estoque
     * @return dataProcessamento
     */
    self.buscaEmpresa = function (cdempresa) {
        return Fis55000_ParametrizacaoExportacaoMunicipal_Service.buscaEmpresa(cdempresa);
    };

    /**
     * Busca Padrão Empresa
     * @param widget
     */
    self.buscaPadraoEmpresa = function (widget) {
        var prefilter = {};
        ScreenService.showLoader();
        self.buscaFilial().then(function (response_filial) {
            var filial = response_filial.dataset.filial[0];
            var cdempresa = filial.CDEMPRESA;

            self.buscaEmpresa(cdempresa).then(function (response_empresa) {
                var empresa = response_empresa.dataset.empresa[0];

                var cdempresa = empresa.CDEMPRESA;
                var nmempresa = empresa.NMEMPRESA;
                self.alteraEmpresa(widget, true);
                prefilter = { "CDEMPRESA": cdempresa,
                    "NMEMPRESA": nmempresa
                };

                ZhFilterPreferences.setOriginalFilter(templateManager.container.getWidget('parametrosPorServico').id, prefilter);
                ZhFilterPreferences.openFilterWidget(templateManager.container.getWidget('parametrosPorServico'), prefilter);
                ScreenService.hideLoader();
            });
        });
    };

    /**
     * Altera Empresa
     * @param widget
     */
    self.alteraEmpresa = function (widget, callTojs) {
        widget.getField('CDINSCMUNI').readOnly = callTojs ? !callTojs : !widget.getField('CDEMPRESA').value();
        widget.getField('CDINSCMUNI').value('');
        widget.getField('CDINSCMUNI').reload();
    };

    /**
     * Busca Empresa Selecionada
     * @param widget
     */
    self.buscaEmpresaSelecionada = function (widget) {
        widget.getField('CDINSCMUNI').dataSourceFilter[0].value = widget.getField('CDEMPRESA').value();
        widget.getField('CDINSCMUNI').reload();
    };

    /**
     * Salva Parametros de Exportação Municipal
     * @param widget
     */
    self.salvaParametrosExportacaoMunicipal = function (widget) {
        // Valida Campos Obrigatórios
        if (widget.isValid()) {

            // Variáveis de Inicialização
            var cdempresa = widget.getField('CDEMPRESA').value();
            var cdinscmuni = widget.getField('CDINSCMUNI').value();
            var iddeclaracao = widget.getField('IDDECLARACAO').value();
            var cdprodserv = widget.getField('CDPRODSERV').value();

            // Busca 
            Fis55000_ParametrizacaoExportacaoMunicipal_Service.buscaParammuniserv(cdempresa, cdinscmuni, iddeclaracao, cdprodserv).then(function (parammuniserv) {
                if (parammuniserv.dataset.parammuniserv.length < 1 || !widget.currentRow.__is_new) {
                    // Gera Novo Código
                    var paramsNewCode = widget.paramsNewCode;
                    var keysParamsNewCode = Object.keys(paramsNewCode);
                    keysParamsNewCode.forEach(function (value) {
                        widget.currentRow[value] = paramsNewCode[value];
                    });

                    if (widget.currentRow.IDENTRSAIDOP == 'T') {

                        widget.currentRow.IDENTRSAIDOP = 'S';
                        General.saveCrud(widget).then(function (success) {
                            ScreenService.showMessage('Registro salvo com sucesso.');
                        }, function (callback) {
                            if (callback.data) {
                                ScreenService.showMessage(callback.data.error);
                            }
                        });
                        widget.currentRow.IDENTRSAIDOP = 'E';
                        // Salva Paramentros de Exportação Municipal
                        General.saveCrud(widget).then(function (success) {
                            ScreenService.showMessage('Registro salvo com sucesso.');
                        }, function (callback) {
                            if (callback.data) {
                                ScreenService.showMessage(callback.data.error);
                            }
                        });
                    } else {
                        General.saveCrud(widget).then(function (success) {
                            ScreenService.showMessage('Registro salvo com sucesso.');
                        }, function (callback) {
                            if (callback.data) {
                                ScreenService.showMessage(callback.data.error);
                            }
                        });
                    }
                } else ScreenService.showMessage('Operação bloqueada. Informação já cadastrada.');
            });
        }
    };

    /**
     * Controla o estado do campo CDCNO conforme valor do campo IDSERVOBRCCIVIL,
     * se o valor dele é 0, o campo CDCNO é null e não pode ser inserido, se é 
     * 1 ou 2, CDCNO é obrigátorio.
     * @param widget
     */
    self.controlaEstadoCampoCNO = function (widget) {
        var CNOField = widget.getField('CDCNO');
        if (widget.currentRow.IDSERVOBRCCIVIL == 0) {
            widget.currentRow.CDCNO = null;
            delete CNOField.validations.required;
            CNOField.readOnly = true;
        } else {
            widget.currentRow.CDCNO = null;
            CNOField.validations.required = true;
            CNOField.readOnly = false;
        }
    };

    self.rulesToNewRow = function (widget) {
        widget.currentRow.CDEMPRESA = widget.appliedFilter.FILTER_ROW.CDEMPRESA;
        widget.currentRow.CDINSCMUNI = widget.appliedFilter.FILTER_ROW.CDINSCMUNI;
    };

    self.novoSerico = function (widget) {
        if (filtrou(widget)) {
            General.widgetNewRow(widget);
        }
    };

    self.abrePopupCadastramento = function (widget) {
        if (filtrou(widget)) {
            var widgetPopup = templateManager.container.getWidget('cadastramentoAutomatico');
            ScreenService.openPopup(widgetPopup).then(function () {
                widgetPopup.getField('selectProdutos').dataSourceFilter[0].value = widget.appliedFilter.FILTER_ROW.CDINSCMUNI;
                widgetPopup.getField('selectProdutos').dataSourceFilter[1].value = widget.appliedFilter.FILTER_ROW.CDEMPRESA;
                widgetPopup.getField('selectInscricoes').dataSourceFilter[0].value = widget.appliedFilter.FILTER_ROW.CDINSCMUNI;

                widgetPopup.currentRow = { todasIncricoes: 'T', todosProdutos: 'T' };
                widgetPopup.getField('selectProdutos').readOnly = true;
                delete widgetPopup.getField('selectProdutos').validations.required;
                widgetPopup.getField('selectInscricoes').readOnly = true;
                delete widgetPopup.getField('selectInscricoes').validations.required;
            });
        }
    };

    self.mudaVisibilidade = function (condicao, nomeField) {
        var widget = templateManager.container.getWidget('cadastramentoAutomatico');
        var field = widget.getField(nomeField);
        field.readOnly = condicao == 'T';
        if (condicao == 'T') {
            delete field.validations.required;
        } else {
            field.validations.required = true;
        }
        delete widget.currentRow[nomeField];
    };

    /*self.cadastra = function(widget) {
        if (widget.isValid()) {
            var modo = arguments[1] ? arguments[1] : '';
            
            var fieldProdutos = widget.getField('selectProdutos');
            
            var todosProdutos = widget.currentRow.todosProdutos;
            var todasIncricoes = widget.currentRow.todasIncricoes;
            
            var produtos = todosProdutos == 'T' ? 
                ['T', {
                    "CDINSCMUNI" : fieldProdutos.dataSourceFilter[0].value,
                    "CDEMPRESA" : fieldProdutos.dataSourceFilter[1].value
                }]
                : widget.getField('selectProdutos').dataSource.getCheckedRows();
                
            var inscricoes = todasIncricoes == 'T' ? 
                ['T', {
                    "CDINSCMUNI" : fieldProdutos.dataSourceFilter[0].value,
                    "CDEMPRESA" : fieldProdutos.dataSourceFilter[1].value
                }]
                : widget.getField('selectInscricoes').dataSource.getCheckedRows();
             General.callRestEngine(
                'fis#/cadastro_automatico_servico/'+modo,
                'Row',
                {
                    "INSCRICOES": inscricoes,
                    "PRODUTOS": produtos
                }
            ).then(function(reponse) {
                if (!reponse.messages) {
                    ScreenService.showMessage('Cadastro realizado com sucesso');
                    ScreenService.closePopup();
                } else if (reponse.messages[0].type == 'W') {
                    self.darOpcaoDeImportacao(reponse.messages[0], widget);
                }
            }, self.trataErro);
        }
    };*/

    self.cadastra = function (widget) {
        if (widget.isValid()) {
            var modo = arguments[1] ? arguments[1] : '';

            var fieldProdutos = widget.getField('selectProdutos');

            var todosProdutos = widget.currentRow.todosProdutos;
            var todasIncricoes = widget.currentRow.todasIncricoes;

            var produtos = todosProdutos == 'T' ? ['T', {
                "CDINSCMUNI": fieldProdutos.dataSourceFilter[0].value,
                "CDEMPRESA": fieldProdutos.dataSourceFilter[1].value
            }] : widget.getField('selectProdutos').dataSource.getCheckedRows();

            var inscricoes = todasIncricoes == 'T' ? ['T', {
                "CDINSCMUNI": fieldProdutos.dataSourceFilter[0].value,
                "CDEMPRESA": fieldProdutos.dataSourceFilter[1].value
            }] : widget.getField('selectInscricoes').dataSource.getCheckedRows();

            var route = 'fis#/validaProdutosParametrizados';
            var row = { "INSCRICOES": inscricoes, "PRODUTOS": produtos };
            General.callRestEngine(route, 'Row', row).then(function (response) {
                if (response.hasOwnProperty('messages')) {
                    self.darOpcaoDeImportacao(response.messages[0].message, widget, row);
                } else {
                    self.cadastroAutomatico(widget, 'NAOSOBREESCREVER', row);
                }
            }).catch(function (erro) {
                ScreenService.showMessage(erro.data.error);
            });
        }
    };

    self.darOpcaoDeImportacao = function (responseMessage, widget, row) {
        ScreenService.showCustomDialog(responseMessage + ' ' + Messages_fiscal.PERGUNTA_CADASTRAMENTO_AUTOMTICO, 'CONFIRMATION', null, [{
            label: "Sobreencrever a parametrização.",
            code: function code() {
                self.cadastroAutomatico(widget, 'SOBREESCREVER', row);
            }
        }, {
            label: "Cadastrar apenas os que não existem.",
            code: function code() {
                self.cadastroAutomatico(widget, 'NAOSOBREESCREVER', row);
            }
        }, {
            label: "Cancelar",
            code: function code() {}
        }]);
    };

    self.cadastroAutomatico = function (widget, tipoCadastramento, row) {
        General.callRestEngine('fis#/cadastro_automatico_servico/' + tipoCadastramento, 'Row', {
            "INSCRICOES": row.INSCRICOES,
            "PRODUTOS": row.PRODUTOS
        }).then(function (reponse) {
            ScreenService.showMessage('Cadastro realizado com sucesso');
            ScreenService.closePopup();
        }, self.trataErro);
    };

    /*self.darOpcaoDeImportacao = function(responseMessage, widget) {
        ScreenService.showCustomDialog(
            responseMessage.message+' '+Messages_fiscal.PERGUNTA_CADASTRAMENTO_AUTOMTICO,
            'CONFIRMATION',
            null,
            [
                {
                    label: "Sobreencrever a parametrização.",
                    code: function() {
                        self.cadastra(widget, 'SOBREESCREVER');
                    }
                },
                {
                    label: "Cadastrar apenas os que não existem.",
                    code: function() {
                        self.cadastra(widget, 'NAOSOBREESCREVER');
                    }
                },
                {
                    label: "Cancelar",
                    code: function(){}
                }
            ]
        );
    };*/

    self.trataErro = function (erro) {
        if (erro.data && erro.data.error) {
            ScreenService.showMessage(erro.data.error);
        } else {
            ScreenService.showMessage(erro);
        }
    };

    self.visibilidadeDeActionCad = function (widget) {
        widget.getAction('cadastramentoAutomatico').isVisible = widget.appliedFilter.FILTER_ROW.IDDECLARACAO == 'RE';
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis55000_ParametrizacaoExportacaoMunicipal_Controller', Fis55000_ParametrizacaoExportacaoMunicipal_Controller);
});

// FILE: ./assets/js/controllers/Fis74000_TabelaProcessosAdmJud_Controller.js
function Fis74000_TabelaProcessosAdmJud_Controller(ScreenService, templateManager, localStorageEngine, ZhUtil, restEngine, General, Fis74000_TabelaProcessosAdmJud_Service, Messages_fiscal, ZHPromise) {

    var self = this;
    var service = Fis74000_TabelaProcessosAdmJud_Service;

    this.setFilter = function (widget) {
        widget.dataSourceFilter = [{
            "name": "CDPROCESSO",
            "operator": "=",
            "value": widget.getParent().currentRow.CDPROCESSO
        }, {
            "name": "CDEMPRESA",
            "operator": "=",
            "value": widget.getParent().currentRow.CDEMPRESA
        }];

        widget.reload();
    };

    this.mudarVisibilidadeWidgets = function (widgets, value) {
        widgets.forEach(function (widget) {
            widget.enabled = value;
        });
    };

    this.filtraEmpresa = function (widget) {
        var cdempresa;
        if (widget === undefined) {
            widget = templateManager.container.getActiveWidget();
            cdempresa = widget.dataSourceFilter[0].value;
            widget.currentRow.CDEMPRESA = cdempresa;
            widget.currentRow.CDPAIS = '0055';
            widget.currentRow.NMPAIS = 'Brasil';
            widget.getField('SGESTADO').readOnly = false;
        } else {
            cdempresa = widget.row.CDEMPRESA;
        }
        var widgetToFilter = templateManager.container.getWidget('procAdminJud');
        widgetToFilter.getField('CDEMPRESA').setValue(cdempresa);
        widgetToFilter.dataSourceFilter[0].value = cdempresa;
        if (cdempresa === "") {
            widgetToFilter.actions[0].readOnly = true;
        } else {
            widgetToFilter.actions[0].readOnly = false;
        }
    };

    this.filtraProcesso = function (widget) {
        var cdprocesso = templateManager.container.getWidget('procAdminJud').currentRow.CDPROCESSO;
        var widgetToFilter = templateManager.container.getWidget('infoSuspExib');
        widgetToFilter.dataSourceFilter = [{
            name: "CDPROCESSO",
            operator: "=",
            value: cdprocesso
        }];
    };

    this.voltarList = function (widget) {
        widget.list();
        ScreenService.closeSwipe();
        widget.activate();
    };

    this.MaskCNPJ = function (widget) {
        service.setMaskCNPJ(widget);
    };

    this.adicionarRow = function (args) {
        var widget = args.owner.widget;
        widget.currentRow = {};
        widget.backupRow = undefined;
        widget.newRow();
    };

    this.masterDetailEdit = function () {
        var widget = templateManager.container.getActiveWidget();
        self.mudarVisibilidadeWidgets(widget.widgets, false);
        widget.backupRow = Util.clone(widget.currentRow);
        widget.edit();
    };

    this.masterDetailVoltarList = function (widget) {
        widget.list();
        ScreenService.closeSwipe();
        widget.activate();
    };

    this.masterDetailCancelaEdicao = function (widget) {
        self.mudarVisibilidadeWidgets(widget.widgets, true);
        if (widget.currentRow.__is_new) {
            var indexOfCurrentRow = widget.dataSource.data.indexOf(widget.currentRow);
            if (indexOfCurrentRow !== -1) {
                widget.dataSource.data.pop();
            }
            widget.list();
            ScreenService.closeSwipe();
            widget.activate();
        } else {
            Util.extend(widget.currentRow, widget.backupRow);
            widget.view();
        }
    };

    this.filtrarEstadoMunicipioPorPais = function (args) {
        var widget = args.owner.field.widget;

        if (args.owner.field.name === 'NMPAIS') {
            widget.getField('SGESTADO').dataSourceFilter[0].value = widget.currentRow.CDPAIS;
            widget.getField('SGESTADO').dataSourceFilter[0].operator = "=";
            widget.currentRow.SGESTADO = "";
            if (!widget.currentRow.NMPAIS) {
                widget.currentRow.SGESTADO = "";
                widget.getField('SGESTADO').readOnly = true;
                widget.getField('SGESTADO').dataSourceFilter[0].value = 0;
                widget.getField('SGESTADO').dataSourceFilter[0].operator = ">";
            } else {
                widget.getField('SGESTADO').readOnly = false;
                widget.getField('SGESTADO').dataSource.data = [];
                widget.getField('SGESTADO').reload();
            }
        } else {
            widget.getField('NMMUNICIPIO').dataSourceFilter[1].value = widget.currentRow.SGESTADO;
            widget.getField('NMMUNICIPIO').dataSourceFilter[1].operator = "=";
            widget.currentRow.NMMUNICIPIO = "";
            if (!widget.currentRow.SGESTADO) {
                widget.currentRow.NMMUNICIPIO = "";
                widget.getField('NMMUNICIPIO').readOnly = true;
                widget.getField('NMMUNICIPIO').dataSourceFilter[0].value = 0;
                widget.getField('NMMUNICIPIO').dataSourceFilter[1].value = 0;
                widget.getField('NMMUNICIPIO').dataSourceFilter[0].operator = ">";
                widget.getField('NMMUNICIPIO').dataSourceFilter[1].operator = ">";
            } else {
                widget.getField('NMMUNICIPIO').readOnly = false;
                widget.getField('NMMUNICIPIO').reload();
            }
        }
    };

    this.setProcesso = function (widget) {
        if (widget.isValid()) {
            //  Caso o processo seja Administrativo, o campo de Indicativo da Autoria deve ser vazio.
            widget.currentRow.IDAUTORIA = widget.currentRow.IDAUTORIA == null ? '0' : widget.currentRow.IDAUTORIA;
            if (service.validaDtIniMenorIgualDtFin(widget.currentRow.DTINIVALID, widget.currentRow.DTFIMVALID)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }

                this.saveCrud(widget).then(function (data) {
                    self.mudarVisibilidadeWidgets(widget.widgets, true);
                    if (widget.currentRow.__is_new) {
                        widget.view();
                        ScreenService.showMessage(Messages_fiscal.OBRIGATORIO_INFOSUSP).then(function () {
                            widget.widgets[0].activate();
                        });
                    } else {
                        widget.backupRow = null;
                    }
                }, function (error) {
                    if (error.indexOf('ORA-00001') !== -1) {
                        ScreenService.showMessage('Erro: Este numero de processo já existe.');
                    } else {
                        ScreenService.showMessage(error.data.error);
                    }
                });
            } else {
                ScreenService.showMessage('A data final deve ser igual ou posterior à data inicial');
                return false;
            }
        }
    };

    this.validaDeposito = function () {
        var widget = templateManager.container.getWidget('infoSuspExib');
        widget.getField('IDDEPOSITO').readOnly = false;
        if (widget.currentRow.CDINDISUSPEN === "02" || widget.currentRow.CDINDISUSPEN === "03") {
            widget.currentRow.IDDEPOSITO = "S";
            widget.getField('IDDEPOSITO').readOnly = true;
        } else if (widget.currentRow.CDINDISUSPEN === "90") {
            widget.currentRow.IDDEPOSITO = "N";
            widget.getField('IDDEPOSITO').readOnly = true;
        }

        widget.reload();
    };

    this.setSuspensao = function (widget) {
        widget.currentRow.CDPROCESSO = widget.getParent().currentRow.CDPROCESSO;
        widget.currentRow.CDEMPRESA = widget.getParent().currentRow.CDEMPRESA;
        if (widget.isValid()) {
            if (service.validaDtIniMenorIgualDtFin(widget.getParent().currentRow.DTINIVALID, widget.currentRow.DTDECISAO)) {
                if (!widget.backupRow) {
                    widget.currentRow.__is_new = true;
                } else {
                    widget.currentRow.__is_new = false;
                }
                self.mudarVisibilidadeWidgets(widget.widgets, false);
                General.saveCrud(widget).then(function () {
                    if (widget.currentRow.__is_new) {
                        widget.list();
                        widget.activate();
                        widget.reload();
                    } else {
                        widget.backupRow = null;
                        widget.view();
                    }
                    self.mudarVisibilidadeWidgets(widget.widgets, true);
                }, function (error) {
                    if (error.indexOf('ORA-00001') !== -1) {
                        ScreenService.showMessage('Erro: Este código de Suspensão já existe.');
                    }
                });
            } else {
                ScreenService.showMessage('A data de decisão deve ser igual ou posterior à data inicial do processo');
                return false;
            }
        }
    };

    this.delete = function (args) {
        var widget = args.owner.widget;
        ScreenService.confirmMessage('Deseja realmente excluir o registro?', 'CONFIRMATION', function () {
            General.deleteCrud(widget).then(function (data) {
                widget.reload();
            }).catch(function (e) {
                var error;
                if (e.data.error === undefined) error = e;else error = e.data.error;

                ScreenService.showMessage(service.CATCH_EXCEPTION_ERROR(error), 'ERROR');
            });
        });
    };

    this.controlaIndicativoSuspensaoProcesso = function (widget) {
        var dataJudicial = [{
            "CDINDISUSPEN": "01",
            "NMINDISUSPEN": "01 - Liminar em Mandado de Segurança"
        }, {
            "CDINDISUSPEN": "02",
            "NMINDISUSPEN": "02 - Depósito Judicial do Montante Integral"
        }, {
            "CDINDISUSPEN": "04",
            "NMINDISUSPEN": "04 - Antecipação de Tutela"
        }, {
            "CDINDISUSPEN": "05",
            "NMINDISUSPEN": "05 - Liminar em Medida Cautelar"
        }, {
            "CDINDISUSPEN": "08",
            "NMINDISUSPEN": "08 - Sentença em Mandado de Segurança Favorável ao Contribuinte"
        }, {
            "CDINDISUSPEN": "09",
            "NMINDISUSPEN": "09 - Sentença em Ação Ordinária Favorável ao Contribuinte e Confirmada pelo TRF"
        }, {
            "CDINDISUSPEN": "10",
            "NMINDISUSPEN": "10 - Acórdão do TRF Favorável ao Contribuinte"
        }, {
            "CDINDISUSPEN": "11",
            "NMINDISUSPEN": "11 - Acórdão do STJ em Recurso Especial Favorável ao Contribuinte"
        }, {
            "CDINDISUSPEN": "12",
            "NMINDISUSPEN": "12 - Acórdão do STF em Recurso Extraordinário Favorável ao Contribuinte"
        }, {
            "CDINDISUSPEN": "13",
            "NMINDISUSPEN": "13 - Sentença 1ª instância não transitada em julgado com efeito suspensivo"
        }, {
            "CDINDISUSPEN": "90",
            "NMINDISUSPEN": "90 - Decisão Definitiva a favor do contribuinte"
        }, {
            "CDINDISUSPEN": "92",
            "NMINDISUSPEN": "92 - Sem suspensão da exigibilidade"
        }];
        var dataAdministrativo = [{
            "CDINDISUSPEN": "03",
            "NMINDISUSPEN": "03 - Depósito Administrativo do Montante Integral"
        }, {
            "CDINDISUSPEN": "90",
            "NMINDISUSPEN": "90 - Decisão Definitiva a favor do contribuinte"
        }, {
            "CDINDISUSPEN": "92",
            "NMINDISUSPEN": "92 - Sem suspensão da exigibilidade"
        }];
        var tipoProcesso = widget.getParent().currentRow.TPPROCESSO;
        var campoIndicativo = widget.getField('CDINDISUSPEN');

        campoIndicativo.dataSource.data = tipoProcesso === '2' ? dataJudicial : dataAdministrativo;
    };

    this.controlaNaturezaDaAcao = function (widget) {
        var dataJudicial = [{
            "IDNATUACAO": "01",
            "NMIDNATUACAO": "01 - Decisão judicial transitada em julgado, a favor da pessoa jurídica"
        }, {
            "IDNATUACAO": "02",
            "NMIDNATUACAO": "02 - Decisão judicial não transitada em julgado, a favor da pessoa jurídica"
        }, {
            "IDNATUACAO": "03",
            "NMIDNATUACAO": "03 - Decisão judicial oriunda de liminar em mandado de segurança"
        }, {
            "IDNATUACAO": "04",
            "NMIDNATUACAO": "04 - Decisão judicial oriunda de liminar em medida cautelar"
        }, {
            "IDNATUACAO": "05",
            "NMIDNATUACAO": "05 - Decisão judicial oriunda de antecipação de tutela"
        }, {
            "IDNATUACAO": "06",
            "NMIDNATUACAO": "06 - Decisão judicial vinculada a depósito administrativo ou judicial em montante integral"
        }, {
            "IDNATUACAO": "07",
            "NMIDNATUACAO": "07 - Medida judicial em que a pessoa jurídica não é o autor"
        }, {
            "IDNATUACAO": "08",
            "NMIDNATUACAO": "08 - Súmula vinculante aprovada pelo STF ou STJ"
        }, {
            "IDNATUACAO": "09",
            "NMIDNATUACAO": "09 - Decisão judicial oriunda de liminar em mandado de segurança coletivo"
        }, {
            "IDNATUACAO": "12",
            "NMIDNATUACAO": "12 – Decisão judicial não transitada em julgado, a favor da pessoa jurídica - Exigibilidade suspensa de contribuição."
        }, {
            "IDNATUACAO": "13",
            "NMIDNATUACAO": "13 – Decisão judicial oriunda de liminar em mandado de segurança - Exigibilidade suspensa de contribuição."
        }, {
            "IDNATUACAO": "14",
            "NMIDNATUACAO": "14 – Decisão judicial oriunda de liminar em medida cautelar - Exigibilidade suspensa de contribuição."
        }, {
            "IDNATUACAO": "15",
            "NMIDNATUACAO": "15 – Decisão judicial oriunda de antecipação de tutela - Exigibilidade suspensa de contribuição."
        }, {
            "IDNATUACAO": "16",
            "NMIDNATUACAO": "16 - Decisão judicial vinculada a depósito administrativo ou judicial em montante integral - Exigibilidade suspensa de contribuição."
        }, {
            "IDNATUACAO": "17",
            "NMIDNATUACAO": "17 – Medida judicial em que a pessoa jurídica não é o autor - Exigibilidade suspensa de contribuição. "
        }, {
            "IDNATUACAO": "19",
            "NMIDNATUACAO": "19 – Decisão judicial oriunda de liminar em mandado de segurança coletivo - Exigibilidade suspensa de contribuição."
        }, {
            "IDNATUACAO": "99",
            "NMIDNATUACAO": "99 - Outros"
        }];
        var dataAdministrativo = [{
            "IDNATUACAO": "01",
            "NMIDNATUACAO": "01 - Processo Administrativos"
        }, {
            "IDNATUACAO": "02",
            "NMIDNATUACAO": "02 - Despacho Decisório"
        }, {
            "IDNATUACAO": "03",
            "NMIDNATUACAO": "03 - Ato Declaratório Executivo"
        }, {
            "IDNATUACAO": "04",
            "NMIDNATUACAO": "04 - Ato Declaratório Interpretativo"
        }, {
            "IDNATUACAO": "05",
            "NMIDNATUACAO": "05 - Decisão Administrativa de DRJ ou do CARF"
        }, {
            "IDNATUACAO": "06",
            "NMIDNATUACAO": "06 - Auto de Infração"
        }, {
            "IDNATUACAO": "99",
            "NMIDNATUACAO": "99 - Outros"
        }];
        var tipoProcesso = widget.currentRow.TPPROCESSO;
        var campoIndicativo = widget.getField('IDNATUACAO');

        if (tipoProcesso === '2') {
            campoIndicativo.dataSource.data = dataJudicial;
        } else {
            campoIndicativo.dataSource.data = dataAdministrativo;
        }
    };

    this.controlaFieldsPorTipoProcesso = function (widget) {
        var uf = widget.getField('SGESTADO');
        var municipio = widget.getField('NMMUNICIPIO');
        var secao = widget.getField('CDSECAO');
        var vara = widget.getField('CDVARA');
        var decisao = widget.getField('DTDECISAO');
        var pais = widget.getField('NMPAIS');

        if (widget.currentRow.TPPROCESSO === '2') {
            uf.readOnly = false;
            municipio.readOnly = false;
            secao.readOnly = false;
            vara.readOnly = false;
            pais.readOnly = false;
            decisao.readOnly = true;
            decisao.setValue("");
        } else {
            uf.readOnly = true;
            municipio.readOnly = true;
            secao.readOnly = true;
            vara.readOnly = true;
            pais.readOnly = true;
            decisao.readOnly = false;
            uf.setValue("");
            municipio.setValue("");
            secao.setValue("");
            vara.setValue("");
            pais.setValue("");
        }
    };

    this.addProcesso = function (args) {
        this.mudarVisibilidadeWidgets(args.owner.widget.widgets, false);
        this.adicionarRow(args);
        this.filtraEmpresa();
        this.controlaFieldsPorTipoProcesso(args.owner.widget);
        this.controlaNaturezaDaAcao(args.owner.widget);
    };

    this.saveCrud = function (widget) {
        var deferred = ZHPromise.defer();
        if (widget.isValid()) {

            var paramsNewCode = widget.paramsNewCode;
            if (paramsNewCode && paramsNewCode.__is_new_code) {
                widget.currentRow.__using_unit = paramsNewCode.__using_unit || false;
                widget.currentRow.__new_code_pk = paramsNewCode.__new_code_pk;
                widget.currentRow.__table_pk = paramsNewCode.__table_pk;
                widget.currentRow.__new_code_column_size = paramsNewCode.__new_code_column_size || 5;
                widget.currentRow.__cast_number = paramsNewCode.__cast_number || false;
            }
            if (paramsNewCode && paramsNewCode.__columns_to_return) {
                widget.currentRow.__columns_to_return = paramsNewCode.__columns_to_return;
            }

            widget.saveRow().then(function (success) {
                widget.activate();
                if (success.dataset && success.dataset.columnsToReturn) {
                    success.dataset.columnsToReturn.forEach(function (element) {
                        for (var columnName in element) {
                            widget.currentRow[columnName] = element[columnName];
                        }
                    });
                }
                if (widget.currentRow.__is_new) {
                    widget.reload().then(function () {
                        deferred.resolve(success);
                    });
                } else {
                    widget.computeDescriptionOrder();
                    widget.view();
                    deferred.resolve(success);
                }
            }, function (error) {
                var errorMessage = 'Timeout';
                if (error.data) {
                    errorMessage = error.data.error;
                }
                ScreenService.showMessage(errorMessage);
                deferred.reject(errorMessage);
            });
        } else {
            // @todo create messages class
            deferred.reject("Preencha todos os campos corretamente!");
        }

        return deferred.promise;
    };

    this.saveImposto = function (args) {
        var widgetProcAdminJud = templateManager.container.getWidget('procAdminJud');
        var widget = args.owner.widget;

        widget.currentRow.CDEMPRESA = widgetProcAdminJud.currentRow.CDEMPRESA;
        widget.currentRow.CDPROCESSO = widgetProcAdminJud.currentRow.CDPROCESSO;
        General.saveCrud(args.owner.widget);
        widget.reload();
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis74000_TabelaProcessosAdmJud_Controller', Fis74000_TabelaProcessosAdmJud_Controller);
});

// FILE: ./assets/js/controllers/Fis91000_RelacaoFuncionariosEmpresa_Controller.js
var Fis91000_RelacaoFuncionariosEmpresa_Controller = function Fis91000_RelacaoFuncionariosEmpresa_Controller(ScreenService, General, templateManager, ZHPromise, Fis91000_RelacaoFuncionariosEmpresa_Service) {

    this.relacionarFuncionariosVinculosEmpresa = function (widget) {
        if (widget.isValid()) {
            var matches = [];
            for (var i = 0; i < widget.dataSource.data.length; i++) {

                if (widget.dataSource.data[i].DTMES === widget.currentRow.DTMES) widget.dataSource.data[i].QTFUNCIONARIO = widget.currentRow.QTFUNCIONARIO_inline;

                for (var key in widget.dataSource.data[i]) {
                    if (key.includes('changed_')) {
                        matches.push(widget.dataSource.data[i]);
                    }
                }
            }
            matches.forEach(function (row) {
                row.CDEMPRESA = widget.dataSourceFilter[0].value;
                row.NRTIPOVINCULOH = widget.dataSourceFilter[1].value;
                row.NRORG = widget.dataSourceFilter[4].value;
                row.DTCOMPETENCIA = '01/' + row.DTMES + widget.dataSourceFilter[2].value.substring(5, 10);
            });
            General.callRestEngine('fis#/relacionarFuncionariosVinculosEmpresa', 'DataSet', matches).then(function (success) {
                widget.currentRow.changed = false;
                delete widget.backupRow;
                General.changeWidgetAcessibility(widget.widgets, true);
                widget.reload();
                widget.list();
                this.setReadOnlyOnFilter(widget, false);
            }.bind(this), function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };

    this.openSwipeVinculosPorEmpresa = function () {
        var widgetVinculoAno = templateManager.container.getWidget('widgetVinculoAno');
        ScreenService.openSwipe(widgetVinculoAno.getParent()).then(function () {
            this.buscaPadraoEmpresa(widgetVinculoAno.getParent()).then(function () {
                this.redefineGridVinculo(widgetVinculoAno);
                if (widgetVinculoAno.getParent().currentRow.NRTIPOVINCULOH != widgetVinculoAno.getParent().getParent().currentRow.NRTIPOVINCULOH) {
                    widgetVinculoAno.dataSource.data = [];
                }
            }.bind(this));
        }.bind(this));
    };

    this.redefineGridVinculo = function (widgetVinculoAno) {
        if (widgetVinculoAno.getParent().getField('DTCOMPETENCIA').value() && widgetVinculoAno.getParent().getField('CDEMPRESA').value() && widgetVinculoAno.getParent().getField('NRTIPOVINCULOH').value()) {
            this.setFiltroWidgetVinculoAno(widgetVinculoAno).then(function () {
                this.carregaGridVinculoMensal(widgetVinculoAno);
            }.bind(this));
        } else {
            widgetVinculoAno.dataSource.data = [];
        }
    };

    this.setFiltroWidgetVinculoAno = function (widgetVinculoAno) {
        var deferred = ZHPromise.defer();
        var dtmes = widgetVinculoAno.getParent().currentRow.DTCOMPETENCIA;
        widgetVinculoAno.dataSourceFilter = [{
            "name": "CDEMPRESA",
            "operator": "=",
            "value": widgetVinculoAno.getParent().currentRow.CDEMPRESA
        }, {
            "name": "NRTIPOVINCULOH",
            "operator": "=",
            "value": widgetVinculoAno.getParent().currentRow.NRTIPOVINCULOH
        }, {
            "name": "ANOINI",
            "operator": "=",
            "value": '01/01/' + dtmes
        }, {
            "name": "ANOFIM",
            "operator": "=",
            "value": '31/12/' + dtmes
        }, {
            "name": "NRORG",
            "operator": "=",
            "value": getLocalVar('NRORG')
        }];
        deferred.resolve();
        return deferred.promise;
    };

    this.carregaGridVinculoMensal = function (widgetVinculoAno) {
        if (widgetVinculoAno.getParent().isValid()) {
            widgetVinculoAno.reload();
        }
    };

    this.buscaPadraoEmpresa = function (widget) {
        var deferred = ZHPromise.defer();
        if (!widget.getField('DTCOMPETENCIA').value() || widget.currentRow.NRTIPOVINCULOH != widget.getParent().currentRow.NRTIPOVINCULOH) {
            widget.getField('DTCOMPETENCIA').value(parseInt(moment().format('YYYY')));
            widget.currentRow.NRTIPOVINCULOH = widget.getParent().currentRow.NRTIPOVINCULOH;
            widget.currentRow.CDEMPRESA = '';
            widget.currentRow.NMEMPRESA = '';
        }
        deferred.resolve();
        return deferred.promise;
    };

    this.setReadOnlyOnFilter = function (widgetVinculoAno, boolean) {
        widgetVinculoAno.getParent().fields.forEach(function (field) {
            field.reload();
        });
    };

    this.cancelInlineEdit = function (widgetVinculoAno) {
        var matches = [];
        for (var i = 0; i < widgetVinculoAno.dataSource.data.length; i++) {
            for (var key in widgetVinculoAno.dataSource.data[i]) {
                if (key.includes('changed_')) {
                    matches.push(widgetVinculoAno.dataSource.data[i]);
                }
            }
        }
        matches.forEach(function (row) {
            row.QTFUNCIONARIO = row.changed_QTFUNCIONARIO;
            delete row.changed_QTFUNCIONARIO;
            delete row.QTFUNCIONARIO_inline;
        });
        widgetVinculoAno.list();
        this.setReadOnlyOnFilter(widgetVinculoAno, false);
    };

    /**
     * Busca Filial Logada
     * @return filialLogada
     */
    this.buscaFilialLogada = function () {
        return Fis91000_RelacaoFuncionariosEmpresa_Service.buscaFilialLogada().then(function (filial) {
            return { dataset: { filial: filial } };
        }.bind(this));
    };

    /**
     * Busca Empresa Logada
     * @return dataProcessamento
     */
    this.buscaEmpresaLogada = function (cdempresa) {
        return Fis91000_RelacaoFuncionariosEmpresa_Service.buscaEmpresaLogada(cdempresa).then(function (empresa) {
            return empresa;
        }.bind(this));
    };

    /**
     * Busca Padrão Empresa Logada
     */
    this.buscaPadraoEmpresaLogada = function () {
        var widget = templateManager.container.getWidget('widget_tabbed_vinculo');
        this.buscaFilialLogada().then(function (response_filial) {
            var filial = response_filial.dataset.filial[0];
            var cdempresa = filial.CDEMPRESA;

            this.buscaEmpresaLogada(cdempresa).then(function (response_empresa) {
                var empresa = response_empresa.dataset.empresa[0];

                var cdempresa = empresa.CDEMPRESA;
                var nmempresa = empresa.NMEMPRESA;

                if (cdempresa && nmempresa) {
                    widget.currentRow.CDEMPRESA = cdempresa;
                    widget.currentRow.NMEMPRESA = nmempresa;

                    this.redefineGridVinculo(templateManager.container.getWidget('widgetVinculoAno'));
                }
            }.bind(this));
        }.bind(this));
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis91000_RelacaoFuncionariosEmpresa_Controller', Fis91000_RelacaoFuncionariosEmpresa_Controller);
});

// FILE: ./assets/js/controllers/Ger00200_Empresa_Controller.js
var Ger00200_Empresa_Controller = function Ger00200_Empresa_Controller(Ger00200_Empresa_Service, ScreenService, General, templateManager, restEngine, localStorageEngine, Endereco) {
    var self = this;
    var empresaSelecionada = null;

    this.recarregarWidgets = function (widget) {
        if (!widget.currentRow.__is_new) {
            widget.widgets.forEach(function (widg) {
                if (widg.widgets) {
                    widg.widgets.forEach(function (widgFilhas) {
                        widgFilhas.reload();
                    });
                }
                widg.reload();
            });
        }
    };

    self.newRow = function (widget) {
        widget.backupRow = Util.clone(widget.currentRow);
        widget.edit();
        widget.newRow();
        ScreenService.openSwipe(widget);
    };

    this.setFieldsAddress = function (widgetName, fieldName) {
        return General.getFieldValue(fieldName, widgetName);
    };

    this.excluir = function (widget) {
        General.deleteCrud(widget);
    };

    this.excluirSignatario = function (widget) {
        var msg = "Deseja excluir o signatário " + widget.currentRow.NMSIGESCSPED + "?";
        ScreenService.confirmMessage(msg, "question", function () {
            widget.remove(widget.currentRow).then(function success(success) {
                ScreenService.goBack();
                widget.reload();
            }, function error(error) {
                if (error.data) {
                    msg = ScreenService.i18n(error.data.error);
                    ScreenService.showMessage(msg);
                } else {
                    msg = ScreenService.i18n("Verifique sua conexão e tente novamente");
                    ScreenService.showMessage(msg);
                }
            });
        }, function () {
            templateManager.updateTemplate();
        });
    };

    this.empresaWidgetOnEnter = function (widget) {
        widget.currentRow = empresaSelecionada;
    };

    this.empresaFormWidgetOnEnter = function (widget) {
        //dataSourceFilter[0].value = widget.currentRow['SGESTADO'];
    };

    this.empresaWidgetAfterMoveRow = function (widget) {
        empresaSelecionada = widget.currentRow;
        this.recarregarWidgets(widget);
    };

    this.novo = function (widget) {
        var parentRow = widget.getParent().currentRow;
        widget.template = "widget/form.html";
        widget.edit();
        widget.newRow();
        widget.currentRow.CDEMPRESA = parentRow.CDEMPRESA;
    };

    this.novoSignatario = function (widget) {
        var parentRow = widget.getParent().currentRow;
        widget.edit();
        widget.newRow();
        widget.currentRow.CDEMPRESA = parentRow.CDEMPRESA;
    };

    this.editar = function (widget) {
        widget.template = widget.templateToForm;
        General.edit(widget);
    };

    this.salvar = function (widget, nomeWidgetAtual) {
        widget.saveRow().then(function () {
            var widgetPrincial = templateManager.container.getWidget('EmpresaWidget');
            this.controlaStatusWidgets(widgetPrincial, nomeWidgetAtual, true);
            if (widget.name === 'EmpresaParametrizacaoNFEWidget') {
                var widgetTabbed = templateManager.container.getWidget('DadosFiscais');
                this.controlaStatusWidgets(widgetTabbed, 'EmpresaParametrizacaoNFEWidget', true);
            }
            widget.template = "widget/form-view.html";
            widget.list();
            //ScreenService.showMessage(ScreenService.i18n('Salvo com sucesso.'));
        }.bind(this), function (callback) {
            ScreenService.showMessage(callback.data.error);
        });
    };

    this.salvarDadosAdicionais = function (widget, nomeWidgetAtual) {
        if (widget.currentRow.valorInicialRegimeApuracao !== widget.currentRow.IDCUMUPICOEMP) {
            ScreenService.confirmMessage(ScreenService.i18n('Todas as Filiais que pertecem a empresa, serão alteradas para o mesmo regime de apuração selecionado.Confirma Operacão? '), 'question', function (success) {
                Ger00200_Empresa_Service.salvarEmpresa(widget.currentRow).then(function (Success) {
                    var widgetPrincial = templateManager.container.getWidget('EmpresaWidget');
                    this.controlaStatusWidgets(widgetPrincial, nomeWidgetAtual, true);
                    widget.template = widget.templateToView;
                    widget.view();
                    widget.activate();
                    widget.list();
                }.bind(this), function (callback) {
                    if (callback.data) {
                        ScreenService.showMessage(callback.data.error);
                    }
                }.bind(this));
            }.bind(this), function (error) {
                widget.currentRow.IDCUMUPICOEMP = widget.currentRow.valorInicialRegimeApuracao;
                this.salvar(widget, 'EmpresaDadosAdicionaisWidget');
            }.bind(this));
        } else {
            this.salvar(widget, 'EmpresaDadosAdicionaisWidget');
        }
    };

    this.salvarEmpresa = function (widget) {
        //widget.saveRow().then(
        if (widget.currentRow.NRCEPEMPR) {
            widget.currentRow.NRCEPEMPR = widget.currentRow.NRCEPEMPR.replace(/[^0-9]/g, '');
        }
        if (widget.isValid()) {
            widget.currentRow.NRINSJUREMPR = widget.currentRow.NRINSJUREMPR.replace(/[^0-9]/g, '');
            Ger00200_Empresa_Service.concatenaCamposEmpresa(widget.currentRow);
            Ger00200_Empresa_Service.salvarNovaEmpresa(widget.currentRow).then(function success(success) {
                this.controlaStatusWidgets(widget, 'EmpresaWidget', true);
                if (widget.currentRow.__is_new) {
                    widget.list(true);
                    ScreenService.goBack();
                    widget.reload();
                } else {
                    widget.view();
                }
            }.bind(this), function error(error) {
                if (error.data && error.data.error.indexOf('ORA-00001') !== -1) {
                    ScreenService.showMessage(ScreenService.i18n("Informação já cadastrada."));
                } else if (error.data && error.data.error.indexOf('ORA-01400') !== -1) {
                    ScreenService.showMessage(ScreenService.i18n("Existem campos em branco que precisam ser preenchidos."));
                } else if (error.data.error) {
                    ScreenService.showMessage(ScreenService.i18n(error.data.error));
                } else {
                    ScreenService.showMessage(ScreenService.i18n("Verifique sua conexão e tente novamente"));
                }
            });
        }
    };

    this.salvarSignatario = function (widget) {
        widget.currentRow.CDEMPRESA = General.getFieldValue('CDEMPRESA', 'EmpresaWidget');
        widget.currentRow.NRCPFSIGESCSPED = widget.currentRow.NRCPFSIGESCSPED.replace(/[^0-9]/g, '');
        if (widget.isValid()) {
            widget.dataSource.name = 'fis#/crud/signatarios_empresa';
            widget.saveRow().then(function success(success) {
                ScreenService.goBack();
                widget.reload().then(function () {
                    if (widget.isNewRow()) {
                        widget.reload();
                    }
                });
                widget.dataSource.name = 'fis#/signatarios_empresa';
            }, function error(error) {
                console.log(error.data.error.indexOf('ORA-01400'));
                if (error.data && error.data.error.indexOf('ORA-00001') !== -1) {
                    ScreenService.showMessage(ScreenService.i18n("Informação já cadastrada."));
                } else if (error.data && error.data.error.indexOf('ORA-01400') !== -1) {
                    ScreenService.showMessage(ScreenService.i18n("Existem campos em branco que precisam ser preenchidos."));
                } else if (error.data.error) {
                    ScreenService.showMessage(ScreenService.i18n(error.data.error));
                } else {
                    ScreenService.showMessage(ScreenService.i18n("Verifique sua conexão e tente novamente"));
                }
            });
        }
    };

    this.salvarParametrizacao = function (widget) {
        General.saveCrud(widget).then(function (sucesso) {
            var currentRow = widget.currentRow;
            widget.view();
            currentRow.__is_new = false;
            currentRow.changed = true;
            widget.template = widget.templateToView;
            widget.getAction('editarParametrizacao').isVisible = true;
        }.bind(this), function (callback) {
            if (callback.data) {
                ScreenService.showMessage(callback.data.error);
            }
        });
    };

    this.cancelar = function (widget) {
        for (var i in widget.backupRow) {
            widget.currentRow[i] = widget.backupRow[i];
        }
        widget.template = widget.templateToView;
        widget.view();
        widget.activate();
        widget.list();
    };

    this.buscaEndereco = function (row) {};

    this.validarCepEnd = function (args) {
        var widget = args.owner.owner.widget;
        var CEP = '';
        if (widget.name == 'EmpresaWidget') {
            CEP = widget.currentRow.NRCEPEMPR;
        }
        if (widget.name == 'widgetInscricaoEstadual') {
            CEP = widget.currentRow.NRCEPIEST;
        }
        if (widget.name == 'widgetInscricaoMunicipal') {
            CEP = widget.currentRow.NRCEPIMUN;
        }
        if (CEP) {
            Endereco.buscarCep(CEP).then(function (response) {
                var endereco = response.dataset.ENDERECO;
                if (endereco) {
                    if (widget.name == 'EmpresaWidget') {
                        widget.currentRow.NRCEPEMPR = CEP;
                        widget.currentRow.DSENDEEMPSEP = endereco.DSENDERECO ? endereco.DSENDERECO : '';
                        widget.currentRow.NMBAIRRO = endereco.NMBAIRRO ? endereco.NMBAIRRO : '';
                    }

                    if (widget.name == 'widgetInscricaoEstadual') {
                        widget.currentRow.NRCEPIEST = CEP;
                        widget.currentRow.DSENDEIESTSEP = endereco.DSENDERECO ? endereco.DSENDERECO : '';
                        widget.currentRow.NMBAIRIEST = endereco.NMBAIRRO ? endereco.NMBAIRRO : '';
                    }

                    if (widget.name == 'widgetInscricaoMunicipal') {
                        widget.currentRow.NRCEPIMUN = CEP;
                        widget.currentRow.DSENDEIMUNSEP = endereco.DSENDERECO ? endereco.DSENDERECO : '';
                        widget.currentRow.NMBAIRRO = endereco.NMBAIRRO ? endereco.NMBAIRRO : '';
                    }

                    widget.currentRow.CDPAIS = endereco.CDPAIS ? endereco.CDPAIS : '';
                    widget.currentRow.NMPAIS = endereco.NMPAIS ? endereco.NMPAIS : '';
                    widget.currentRow.SGESTADO = endereco.SGESTADO ? endereco.SGESTADO : '';
                    widget.currentRow.NMESTADO = endereco.NMESTADO ? endereco.NMESTADO : '';
                    widget.currentRow.CDMUNICIPIO = endereco.CDMUNICIPIO ? endereco.CDMUNICIPIO : '';
                    widget.currentRow.NMMUNICIPIO = endereco.NMMUNICIPIO ? endereco.NMMUNICIPIO : '';
                    widget.currentRow.CDBAIRRO = endereco.CDBAIRRO ? endereco.CDBAIRRO : '';
                    widget.currentRow.CDLOGRADOURO = endereco.CDLOGRADOURO ? endereco.CDLOGRADOURO : '';
                    widget.currentRow.DSLOGRADOURO = endereco.DSLOGRADOURO ? endereco.DSLOGRADOURO : '';

                    if (widget.name == 'EmpresaWidget') {
                        this.verificaFieldOnChangePais(endereco);
                    } else {
                        if (widget.name == 'widgetInscricaoEstadual') {
                            this.controlaVisibilidadeCampoPaisEstadoMunicipioBairro('widgetInscricaoEstadual');
                        } else {
                            this.controlaVisibilidadeCampoPaisEstadoMunicipioBairro('widgetInscricaoMunicipal');
                        }
                    }
                }
                if (response.dataset.ERRO) ScreenService.showMessage(response.dataset.ERRO.MESSAGE, "warning");
            }.bind(self));
        }
    };

    this.editarCadastro = function (args) {
        var widget = args.owner.widget;
        widget.backupRow = angular.copy(widget.currentRow);
        widget.edit();
        widget.getField('NMESTADO').readOnly = false;
        widget.getField('NMMUNICIPIO').readOnly = false;
        widget.getField('NMBAIRRO').readOnly = false;
    };

    this.adicionar = function (args) {
        var widget = args.owner.widget;
        widget.newRow();
        widget.getField('NMESTADO').readOnly = true;
        widget.getField('NMMUNICIPIO').readOnly = true;
        widget.getField('NMBAIRRO').readOnly = true;
        this.controlaStatusWidgets(widget, 'EmpresaWidget', false);
    };

    this.limparValorPais = function () {
        var widget = templateManager.container.getActiveWidget();
        var pais = widget.getField('NMPAIS');
        if (pais.value()) {
            widget.getField('NMESTADO').value("");
            widget.getField('NMMUNICIPIO').value("");
            widget.getField('NMBAIRRO').value("");
            widget.getField('SGESTADO').value("");
            widget.getField('CDBAIRRO').value("");
            widget.getField('CDMUNICIPIO').value("");
            widget.getField('NMESTADO').readOnly = false;
            widget.getField('NMMUNICIPIO').readOnly = true;
            widget.getField('NMBAIRRO').readOnly = true;
            widget.getField('NMESTADO').reload();
        } else {
            widget.getField('NMESTADO').value("");
            widget.getField('NMMUNICIPIO').value("");
            widget.getField('NMBAIRRO').value("");
            widget.getField('SGESTADO').value("");
            widget.getField('CDBAIRRO').value("");
            widget.getField('CDMUNICIPIO').value("");
            widget.getField('NMESTADO').readOnly = true;
            widget.getField('NMMUNICIPIO').readOnly = true;
            widget.getField('NMBAIRRO').readOnly = true;
            widget.getField('NMESTADO').reload();
        }
    };

    this.limparValorEstado = function () {
        var widget = templateManager.container.getActiveWidget();
        var estado = widget.getField('NMESTADO');
        if (estado.value()) {
            widget.getField('NMMUNICIPIO').value("");
            widget.getField('NMBAIRRO').value("");
            widget.getField('CDBAIRRO').value("");
            widget.getField('CDMUNICIPIO').value("");
            widget.getField('NMMUNICIPIO').readOnly = false;
            widget.getField('NMBAIRRO').readOnly = true;
            widget.getField('NMMUNICIPIO').reload();
        } else {
            widget.getField('NMMUNICIPIO').value("");
            widget.getField('NMBAIRRO').value("");
            widget.getField('CDBAIRRO').value("");
            widget.getField('CDMUNICIPIO').value("");
            widget.getField('NMMUNICIPIO').readOnly = true;
            widget.getField('NMBAIRRO').readOnly = true;
            widget.getField('NMMUNICIPIO').reload();
        }
    };

    this.limparValorMunicipio = function () {
        var widget = templateManager.container.getActiveWidget();
        var municipio = widget.getField('NMMUNICIPIO');
        if (municipio.value()) {
            widget.getField('NMBAIRRO').value("");
            widget.getField('CDBAIRRO').value("");
            widget.getField('NMBAIRRO').readOnly = false;
            widget.getField('NMBAIRRO').reload();
        } else {
            widget.getField('NMBAIRRO').value("");
            widget.getField('CDBAIRRO').value("");
            widget.getField('NMBAIRRO').readOnly = true;
            widget.getField('NMBAIRRO').reload();
        }
    };

    this.verificaFieldOnChangePais = function (endereco) {
        var widget = templateManager.container.getWidget('EmpresaWidget');
        if (!endereco) {
            widget.getField('NMPAIS').value('');
            widget.getField('CDPAIS').value('');

            widget.getField('NMESTADO').readOnly = true;
            widget.getField('NMESTADO').value('');
            widget.getField('SGESTADO').value('');

            widget.getField('NMMUNICIPIO').readOnly = true;
            widget.getField('NMMUNICIPIO').value('');
            widget.getField('CDMUNICIPIO').value('');

            widget.getField('NMBAIRRO').readOnly = true;
            widget.getField('NMBAIRRO').value('');
            widget.getField('CDBAIRRO').value('');
        } else {
            var pais = endereco.NMPAIS;
            var estado = endereco.NMESTADO;
            var municipio = endereco.NMMUNICIPIO;
            if (!pais) {
                widget.getField('NMESTADO').readOnly = true;
                widget.getField('NMMUNICIPIO').readOnly = true;
                widget.getField('NMBAIRRO').readOnly = true;
            } else {
                if (!estado) {
                    widget.getField('NMESTADO').readOnly = false;
                    widget.getField('NMMUNICIPIO').readOnly = true;
                    widget.getField('NMBAIRRO').readOnly = true;
                } else {
                    widget.getField('NMESTADO').readOnly = false;
                    if (!municipio) {
                        widget.getField('NMMUNICIPIO').readOnly = false;
                        widget.getField('NMBAIRRO').readOnly = true;
                    } else {
                        widget.getField('NMMUNICIPIO').readOnly = false;
                        widget.getField('NMBAIRRO').readOnly = false;
                    }
                }
            }
        }
    };

    this.controlaStatusWidgets = function (mainWidget, nomeWidgetAtual, status) {
        mainWidget.widgets.forEach(function (widg) {
            if (nomeWidgetAtual !== widg.name) widg.enabled = status;
        });

        if (mainWidget.name !== nomeWidgetAtual) mainWidget.enabled = status;
    };

    this.verficaTipoempresa = function (args) {
        var widget = templateManager.container.getWidget('EmpresaDadosAdicionaisWidget');
        if (widget.currentRow.IDTIPOEMPR !== '3') {
            widget.getField('IDOPTSIMPLES').readOnly = false;
            if (widget.currentRow.IDTIPOEMPR === null) {
                widget.getField('IDOPTSIMPLES').readOnly = true;
                widget.getField('IDOPTSIMPLES').value('');
            }
        } else {
            widget.getField('IDOPTSIMPLES').readOnly = true;
            widget.getField('IDOPTSIMPLES').value('');
        }
    };

    this.criaCampoRegimeApuracao = function (args) {
        var widget = args.owner.widget;
        widget.currentRow.valorInicialRegimeApuracao = widget.currentRow.IDCUMUPICOEMP;
    };

    this.controlaVisibilidadeCampoPaisEstadoMunicipioBairro = function (nomeWidget) {
        var widget = templateManager.container.getWidget(nomeWidget);
        var pais = widget.getField('NMPAIS');
        var estado = widget.getField('NMESTADO');
        var municipio = widget.getField('NMMUNICIPIO');
        var bairro = '';
        if (widget.name == 'widgetInscricaoMunicipal') {
            bairro = widget.getField('NMBAIRRO');
        } else {
            bairro = widget.getField('NMBAIRIEST');
        }
        if (widget.currentRow.NMPAIS) {
            estado.readOnly = false;
            municipio.readOnly = true;
            bairro.readOnly = true;
            if (widget.currentRow.NMESTADO) {
                municipio.readOnly = false;
                bairro.readOnly = true;
                if (widget.currentRow.NMMUNICIPIO) {
                    bairro.readOnly = false;
                } else {
                    bairro.readOnly = true;
                }
            } else {
                municipio.readOnly = true;
                bairro.readOnly = true;
            }
        } else {
            estado.readOnly = true;
            municipio.readOnly = true;
            bairro.readOnly = true;
        }
    };

    this.controlaValorCampoPaisEstadoMunicipioBairro = function (nomeCampoAtual, nomeWidget) {
        var widget = templateManager.container.getWidget(nomeWidget);
        var pais = widget.getField('NMPAIS');
        var estado = widget.getField('NMESTADO');
        var municipio = widget.getField('NMMUNICIPIO');
        var bairro = '';
        if (widget.name == 'widgetInscricaoMunicipal') {
            bairro = widget.getField('NMBAIRRO');
        } else {
            bairro = widget.getField('NMBAIRIEST');
        }
        switch (nomeCampoAtual) {
            case 'Pais':

                widget.currentRow.SGESTADO = null;
                estado.value('');

                widget.currentRow.CDMUNICIPIO = null;
                municipio.value('');

                widget.currentRow.CDBAIRRO = null;
                bairro.value('');
                break;
            case 'Estado':

                widget.currentRow.CDMUNICIPIO = null;
                municipio.value('');

                widget.currentRow.CDBAIRRO = null;
                bairro.value('');
                break;
            case 'Municipio':

                widget.currentRow.CDBAIRRO = null;
                bairro.value('');
                break;
            default:
                break;
        }
    };

    this.recarregarCampo = function (nomeWidget, nomeCampo) {
        var widget = templateManager.container.getWidget(nomeWidget);
        widget.getField(nomeCampo).reload();
    };

    this.recarregarWidget = function (nomeWidget) {
        var widget = templateManager.container.getWidget(nomeWidget);
        widget.reload();
    };

    this.saveIncricao = function (widget) {
        if (widget.isValid()) {
            if (widget.currentRow.__is_new) {
                var widgetEmpresa = templateManager.container.getWidget('EmpresaWidget');
                widget.currentRow.CDEMPRESA = widgetEmpresa.currentRow.CDEMPRESA;
            }
            if (widget.currentRow.NRINSJURIEST) {
                widget.currentRow.NRINSJURIEST = widget.currentRow.NRINSJURIEST.replace(/[^0-9]/g, '');
            }
            if (widget.currentRow.NRCEPIEST) {
                widget.currentRow.NRCEPIEST = widget.currentRow.NRCEPIEST.replace(/[^0-9]/g, '');
            }
            if (!widget.currentRow.CERTIFICADO) {
                widget.currentRow.CERTIFICADO = [];
            }
            Ger00200_Empresa_Service.concatenaCamposInscricaoEstadual(widget.currentRow);
            Ger00200_Empresa_Service.salvarInscricao(widget.currentRow).then(function (Success) {
                widget.currentRow.CERTIFICADO = null;
                widget.getAction('abrirParametrizacao').isVisible = true;
                widget.activate();
                if (widget.currentRow.__is_new) {
                    widget.list(true);
                    ScreenService.goBack();
                    widget.reload().then(function () {});
                } else {
                    widget.view();
                }
            }.bind(this), function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };

    this.salvarInscricaoMunicipal = function (args) {
        var widgetEmpresa = templateManager.container.getWidget('EmpresaWidget');
        var widget = args.owner.widget;
        if (widget.isValid()) {
            if (widget.currentRow.__is_new) {
                widget.currentRow.CDEMPRESA = widgetEmpresa.currentRow.CDEMPRESA;
                widget.currentRow.CDFILIAL = '';
            }
            if (widget.currentRow.NRINSJURIMUNI) {
                widget.currentRow.NRINSJURIMUNI = widget.currentRow.NRINSJURIMUNI.replace(/[^0-9]/g, '');
            }
            if (widget.currentRow.NRCEPIMUN) {
                widget.currentRow.NRCEPIMUN = widget.currentRow.NRCEPIMUN.replace(/[^0-9]/g, '');
            }
            Ger00200_Empresa_Service.concatenaCamposInscricaoMunicipal(widget.currentRow);
            widget.dataSource.name = 'fis#/crud/inscrmunicip';
            General.saveCrud(widget).then(function (Success) {
                widget.dataSource.name = 'fis#/inscrmunicip_completa';
            }, function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };

    this.checkNumeroDeInscricao = function (field) {
        var validatedInscricao = Ger00200_Empresa_Service.validateNumeroDeInscricao(field.widget.currentRow[field.descriptionField]);
        var widget = field.widget;

        if (validatedInscricao.valid) {
            //if input is valid, builds unformatted data to save
            switch (validatedInscricao.tipo.cod) {
                case 'O':
                    //Código genérico
                    validatedInscricao.rawValue = General.fill(validatedInscricao.parameter, 5);
                    break;
                case 'I':
                    //Inscrição genérica
                    validatedInscricao.rawValue = General.fill(validatedInscricao.parameter, 20);
                    break;
                default:
                    //CPF && CNPJ
                    validatedInscricao.rawValue = validatedInscricao.parameter;
            }

            //sets data in the currentRow
            if (widget.name == 'widgetInscricaoEstadual') {
                widget.currentRow.IDTPIJURIEST = validatedInscricao.tipo.cod;
            }
            if (widget.name == 'EmpresaWidget') {
                widget.currentRow.IDTPIJUREMPR = validatedInscricao.tipo.cod;
            }
            widget.currentRow[field.valueField] = validatedInscricao.rawValue;
            widget.currentRow[field.descriptionField] = validatedInscricao.value;
        } else {
            //if message exists, throws warning popup
            if (validatedInscricao.error.msg) ScreenService.showMessage(validatedInscricao.error.msg, "warning");

            //cleans data
            widget.currentRow[field.valueField] = null;
            widget.currentRow[field.descriptionField] = null;
        }
    };

    this.visibilidadeAction = function (widget, nomeAction, visibilidade) {
        var action = widget.getAction(nomeAction);
        action.isVisible = visibilidade;
    };

    this.setarNomeCertificado = function (widget) {
        //var certificado = widget.getField('CERTIFICADO');
        if (widget.currentRow.CERTIFICADO) {
            if (widget.currentRow.CERTIFICADO.length === 0) {
                widget.currentRow.NMCERTIFICADO = null;
            } else {
                var nomeCertificado = widget.currentRow.CERTIFICADO[0].name;
                var pos = nomeCertificado.indexOf('.');
                nomeCertificado = nomeCertificado.substring(0, pos);
                widget.currentRow.NMCERTIFICADO = nomeCertificado;
            }
        }
        this.controlaCampoSenha(widget);
    };

    this.controlaCampoSenha = function (widget) {
        var campoNome = widget.getField('NMCERTIFICADO');
        var campoSenha = widget.getField('CDSENHACERTIF');

        if (campoNome.value()) {
            campoSenha.readOnly = false;
        } else {
            campoSenha.readOnly = true;
            campoSenha.value('');
        }
    };

    this.validarCpnjInscricaoMunicipal = function (widget) {
        var cnpjFormantado = widget.currentRow.NRINSJURIMUNI;
        if (cnpjFormantado) {
            cnpj = widget.currentRow.NRINSJURIMUNI.replace(/[^0-9]/g, '');
            if (!General.validateCNPJ(cnpj)) {
                ScreenService.showMessage("Inscrição " + "'" + cnpjFormantado + "'" + " Inválida");
                widget.currentRow.NRINSJURIMUNI = null;
            }
        }
    };

    this.cancel = function (args, widget) {
        General.backOrCancel(args);
        widget.template = "widget/form-view.html";
        widget.list();
    };

    this.validaEmail = function (widget, nomeWidgetAtual) {
        var email = templateManager.container.getWidget('widgetParametrizacaoDFE').getField('DSEMAILCCNFE').value();
        if (email) {
            var ponto = '.com';
            var arroba = '@';
            if (email.search(ponto) == -1 || email.search(arroba) == -1 || email.search(ponto) < email.search(arroba)) {
                ScreenService.showMessage("Informe um email válido no campo 'Cc'");
                templateManager.container.getWidget('widgetParametrizacaoDFE').getField('DSEMAILCCNFE').setValue('');
            } else {
                this.salvar(widget, nomeWidgetAtual);
            }
        } else {
            this.salvar(widget, nomeWidgetAtual);
        }
    };

    this.openParametrizacaoIE = function () {
        ScreenService.openWindow('fis#ger00250_parametrizacaoInscricaoEstadual').then(function (response) {
            //filtroPreDefinido = empresaSelecionada;
            setTimeout(function () {

                var widget = templateManager.container.getWidget('gridInscricaoEstadual');
                var filterRow = widget.appliedFilter.FILTER_ROW;
                filterRow.CDEMPRESA = empresaSelecionada.CDEMPRESA;
                filterRow.CDINSCESTA = empresaSelecionada.CDINSCESTA;
                filterRow.NMEMPRESA = empresaSelecionada.NMEMPRESA;
            }, 1000);
        });
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Ger00200_Empresa_Controller', Ger00200_Empresa_Controller);
});

// FILE: ./assets/js/controllers/Ger00250_ParametrizacaoInscricaoEstadual_Controller.js
var Ger00250_ParametrizacaoInscricaoEstadual_Controller = function Ger00250_ParametrizacaoInscricaoEstadual_Controller(ZhFilterPreferences, Ger00250_ParametrizacaoInscricaoEstadual_Service, ScreenService, General, templateManager, localStorageEngine, Endereco) {
    var filtroPreDefinido;

    this.validateFiltroInscricaoEstadual = function (widget) {
        var popup = widget.appliedFilter;
        widget.dataSourceFilter = [{
            "name": "CDEMPRESA",
            "operator": "=",
            "value": popup.FILTER_ROW.CDEMPRESA
        }];
        popup.CUSTUM_FILTER_ROW = { "CDEMPRESA": popup.FILTER_ROW.CDEMPRESA };
    };

    this.setFiltro = function () {
        var filterRow = {
            "CDEMPRESA": filtroPreDefinido.CDEMPRESA,
            "CDINSCESTA": filtroPreDefinido.CDINSCESTA,
            "NMEMPRESA": filtroPreDefinido.NMEMPRESA
        };
        return filterRow;
    };

    this.editarParametrosGerais = function (widget) {
        this.controlarCampoEncargo(widget);
        this.verificaVigencia(widget);
        this.editar(widget);
    };

    this.controlarCampoFiltro = function (args) {
        var widget = args.owner.owner.widget;
        var empresa = widget.getField('NMEMPRESA');
        var inscricao = widget.getField('NMREPRINSEST');
        inscricao.value('');
        widget.getField('CDINSCESTA').value('');
        if (empresa.value()) {
            inscricao.readOnly = false;
        } else {
            inscricao.readOnly = true;
        }
    };

    this.controlaStatusWidgets = function (mainWidget, nomeWidgetAtual, status) {
        mainWidget.widgets.forEach(function (widg) {
            if (nomeWidgetAtual !== widg.name) widg.enabled = status;
        });
        if (mainWidget.name !== nomeWidgetAtual) mainWidget.enabled = status;
    };

    this.WidgetOnEnter = function (args) {
        args.owner.currentRow = args.owner.dataSource.data[0];
    };

    this.editar = function (widget) {
        widget.template = widget.templateToForm;
        General.edit(widget);
        var widgetPrincial = templateManager.container.getWidget('gridInscricaoEstadual');
        if (widget.name == 'tabbedCargaTributaria') {
            this.controlaStatusWidgets(widgetPrincial, widget.name, false);
            this.controlaCargaTributaria(widget);
            //this.controlaTipoCargaTributaria(widget);
        } else if (widget.name == 'gridApuracao') {
            var widgetPresumido = templateManager.container.getWidget('tabbedCreditoPresumido');
            this.controlaStatusWidgets(widgetPresumido, widget.name, false);
            this.controlaStatusWidgets(widgetPrincial, 'tabbedCreditoPresumido', false);
            this.controlaCampoApurcaoCredito(widget);
            widgetPresumido.enabled = true;
        } else {
            this.controlaStatusWidgets(widgetPrincial, widget.name, false);
        }
    };

    this.cancelar = function (widget) {
        for (var i in widget.backupRow) {
            widget.currentRow[i] = widget.backupRow[i];
        }
        widget.template = widget.templateToView;
        widget.view();
        widget.activate();
        var widgetPrincial = templateManager.container.getWidget('gridInscricaoEstadual');

        if (widget.name == 'gridApuracao') {
            var widgetPresumido = templateManager.container.getWidget('tabbedCreditoPresumido');
            this.controlaStatusWidgets(widgetPresumido, widget.name, true);
            this.controlaStatusWidgets(widgetPrincial, 'tabbedCreditoPresumido', true);
            this.verificaTipoOperacao(widget);
        } else {
            this.controlaStatusWidgets(widgetPrincial, widget.name, true);
        }
    };

    this.recarregarWidgets = function (args) {
        var widget = args.owner;
        widget.widgets.forEach(function (widg) {
            if (widg.widgets) {
                widg.widgets.forEach(function (widgFilhas) {
                    widgFilhas.reload();
                });
            }
            widg.reload();
        });
    };

    this.controlarCampoEncargo = function (widget) {
        var campoVerifica = widget.getField('IDSUGREGSTENTR');
        var campoEncargo = widget.getField('NMENCARGO');
        if (campoVerifica.value() == 'S') {
            campoEncargo.readOnly = false;
        } else {
            campoEncargo.value('');
            widget.currentRow.CDENCARGOST = null;
            campoEncargo.readOnly = true;
        }
    };

    this.verificaVigencia = function (widget) {
        var dateInicial = widget.getField('DTINIVIGIEST');
        var dateFinal = widget.getField('DTFIMVIGIEST');
        dateFinal.minDate = dateInicial.value();
        dateInicial.maxDate = dateFinal.value();
    };

    this.salvar = function (args) {
        var widgetPrincial = templateManager.container.getWidget('gridInscricaoEstadual');
        var widget = args.owner.widget;
        General.saveCrud(widget).then(function (Success) {
            widget.currentRow.__is_new = false;
            widget.currentRow.changed = false;
            widget.template = widget.templateToView;
            widget.view();
            widget.reload();
            this.controlaStatusWidgets(widgetPrincial, widget.name, true);
            //widget.list();
        }.bind(this), function (callback) {
            if (callback.data) {
                ScreenService.showMessage(callback.data.error);
            }
        });
    };

    this.salvarMensagem = function (args) {
        var widgetPrincial = templateManager.container.getWidget('gridInscricaoEstadual');
        var widget = args.owner.widget;
        if (widget.currentRow.__is_new) {
            widget.currentRow.CDINSCESTA = widgetPrincial.currentRow.CDINSCESTA;
            widget.currentRow.CDEMPRESA = widgetPrincial.currentRow.CDEMPRESA;
        }
        if (widget.isValid()) {
            Ger00250_ParametrizacaoInscricaoEstadual_Service.salvarMensagem(widget.currentRow).then(function (Success) {
                widget.activate();
                if (widget.currentRow.__is_new) {
                    widget.list(true);
                    ScreenService.goBack();
                    widget.reload().then(function () {});
                } else {
                    widget.view();
                }
            }.bind(this), function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };

    this.verificaTipoOperacao = function (widget) {
        var campoVerificaTipoOpercao = widget.getField('IDTIPOOPERCREDP');
        var campoTipoOperacao = widget.getField('CDTIPOPERCREDP');
        var campoCodigo = widget.currentRow.CDTIPOOPER;
        var campoES = widget.currentRow.IDENTRSAIDOP;
        if (campoVerificaTipoOpercao.value() !== 'L') {
            campoTipoOperacao.isVisible = false;
            campoTipoOperacao.value('');
            if (campoCodigo) {
                campoCodigo.splice(0, campoCodigo.length);
            }
            if (campoES) {
                campoES.splice(0, campoES.length);
            }
            delete campoTipoOperacao.validations.required;
        } else {
            campoTipoOperacao.isVisible = true;
            campoTipoOperacao.validations.required = true;
        }
    };

    this.dataTipoOperacao = function (args) {
        var widget = args.owner;
        var data = widget.dataSource.data[0];
        if (data.CDTIPOPERCREDP) {
            widget.currentRow.IDTIPOOPERCREDP = 'L';
            var campoTipoOperacao = widget.getField('CDTIPOPERCREDP');
            var tipoOperacaoData = campoTipoOperacao.dataSource.data;
            var tipoOpercao = data.CDTIPOPERCREDP.split('_');

            //a ultima e a primeira posicao está vazio;
            tipoOpercao.shift();
            tipoOpercao.pop();
            var rowsChecadas = [];

            tipoOperacaoData.forEach(function (row) {
                if (tipoOpercao.indexOf(row.IDENTRSAIDOP + row.CDTIPOOPER) != -1) {
                    row.__isSelected = true;
                    rowsChecadas.push(row);
                }
            });

            widget.currentRow.CDTIPOPERCREDP = [];
            widget.currentRow.CDTIPOOPER = [];
            widget.currentRow.IDENTRSAIDOP = [];

            rowsChecadas.forEach(function (rowCheck) {
                widget.currentRow.CDTIPOPERCREDP.push(rowCheck.NMTIPOOPER);
                widget.currentRow.CDTIPOOPER.push(rowCheck.CDTIPOOPER);
                widget.currentRow.IDENTRSAIDOP.push(rowCheck.IDENTRSAIDOP);
            });
        } else {
            widget.currentRow.IDTIPOOPERCREDP = 'T';
        }
        this.verificaTipoOperacao(args.owner);
    };

    this.verficaApurarCrecidoPresumido = function (args) {
        var widget = args.owner;
        var widgetCfop = templateManager.container.getWidget('gridCfop');
        var apurar = widget.getField('IDAPURLUCPRE');
        if (apurar.value() == 'N') {
            widgetCfop.enabled = false;
        } else {
            widgetCfop.enabled = true;
        }
    };

    this.controlaCampoApurcaoCredito = function (widget) {
        var apurar = widget.getField('IDAPURLUCPRE');
        if (apurar.value() == 'N') {
            widget.fields.forEach(function (fields) {
                if (fields.name !== 'IDAPURLUCPRE') {
                    fields.readOnly = true;
                }
            });
        } else {
            widget.fields.forEach(function (fields) {
                if (fields.name !== 'IDAPURLUCPRE') {
                    fields.readOnly = false;
                }
            });
            this.controlaAliquotaUnica(widget);
        }
    };

    this.afterLoadDataSourceCreditoPresumido = function (args) {
        this.WidgetOnEnter(args);
        this.dataTipoOperacao(args);
        this.verficaApurarCrecidoPresumido(args);
        this.verificaTipoOperacao(args.owner);
    };

    this.afterLoadDataSourceCargatributaria = function (args) {
        this.WidgetOnEnter(args);
        this.dataCargaTributaria(args);
    };

    this.salvarCreditoPresumido = function (args) {
        var widgetPrincial = templateManager.container.getWidget('gridInscricaoEstadual');
        var widget = args.owner.widget;

        if (widget.isValid()) {

            if (widget.currentRow.CDTIPOPERCREDP) {
                if (widget.currentRow.CDTIPOPERCREDP.length === 0) {
                    widget.currentRow.CDTIPOPERCREDP = null;
                    widget.currentRow.CDTIPOOPER = null;
                    widget.currentRow.IDENTRSAIDOP = null;
                }
            }

            if (Ger00250_ParametrizacaoInscricaoEstadual_Service.validaAliquota(widget.currentRow)) {
                Ger00250_ParametrizacaoInscricaoEstadual_Service.concatenaCampoTipoOperacao(widget.currentRow);
                General.saveCrud(widget).then(function (Success) {
                    widget.currentRow.__is_new = false;
                    widget.currentRow.changed = false;
                    widget.template = widget.templateToView;
                    widget.view();
                    widget.reload();
                    var widgetPresumido = templateManager.container.getWidget('tabbedCreditoPresumido');
                    this.controlaStatusWidgets(widgetPresumido, widget.name, true);
                    this.controlaStatusWidgets(widgetPrincial, 'tabbedCreditoPresumido', true);
                }.bind(this), function (callback) {
                    if (callback.data) {
                        ScreenService.showMessage(callback.data.error);
                    }
                });
            } else {
                ScreenService.showMessage('Valor inválido.A alíquota deve estar entre 0% e 100%.');
            }
        }
    };

    this.salvarPorCfop = function (args) {
        var widgetPrincial = templateManager.container.getWidget('gridInscricaoEstadual');
        var widget = args.owner.widget;
        if (widget.currentRow.__is_new) {
            widget.currentRow.CDINSCESTA = widgetPrincial.currentRow.CDINSCESTA;
            widget.currentRow.CDEMPRESA = widgetPrincial.currentRow.CDEMPRESA;
        }
        General.saveCrud(widget).then(function (Success) {}.bind(this), function (callback) {
            if (callback.data) {
                ScreenService.showMessage(callback.data.error);
            }
        });
    };

    this.controlaAliquotaUnica = function (widget) {
        var aliquotaSaida = widget.getField('VRALIQTOTALSAIDA');
        var aliquotaImposto = widget.getField('VRALIQIMPOSREC');
        var descAliquotaSaida = widget.getField('DSOUTCREDTOTSAI');
        var descAliquotaImposto = widget.getField('DSOUTCREDIMPREC');

        if (aliquotaSaida.value() === "") {
            aliquotaSaida.value(0);
        }

        if (aliquotaImposto.value() === "") {
            aliquotaImposto.value(0);
        }

        if (parseFloat(aliquotaSaida.value()) !== 0) {
            descAliquotaSaida.readOnly = false;
            descAliquotaSaida.validations.required = true;

            aliquotaImposto.value(0);
            aliquotaImposto.readOnly = true;

            descAliquotaImposto.value('');
            descAliquotaImposto.readOnly = true;
            delete descAliquotaImposto.validations.required;
        } else if (parseFloat(aliquotaImposto.value()) !== 0) {
            descAliquotaImposto.readOnly = false;
            descAliquotaImposto.validations.required = true;

            aliquotaSaida.value(0);
            aliquotaSaida.readOnly = true;

            descAliquotaSaida.value('');
            descAliquotaSaida.readOnly = true;
            delete descAliquotaSaida.validations.required;
        } else {
            aliquotaImposto.readOnly = false;
            aliquotaSaida.readOnly = false;
            descAliquotaSaida.readOnly = true;
            descAliquotaSaida.value('');
            descAliquotaImposto.readOnly = true;
            descAliquotaImposto.value('');
            delete descAliquotaImposto.validations.required;
            delete descAliquotaSaida.validations.required;
        }
    };

    this.controlaCargaTributaria = function (widget) {
        var cargaTributaria = widget.getField('IDUTCARGATRIB');
        var tipocargaTributaria = widget.getField('IDCARGA');
        var codigoAjusteCredito = widget.getField('CDAJSTCREDCARGA');
        var descAjusteCredito = widget.getField('DSOUTCREDCARGA');
        var codigoAjusteDebito = widget.getField('CDAJSTDEBICARGA');
        var descAjusteDebito = widget.getField('DSOUTDEBICARGA');

        if (cargaTributaria.value() == 'N') {
            tipocargaTributaria.readOnly = true;

            tipocargaTributaria.isVisible = false;
            tipocargaTributaria.clearValue();
            tipocargaTributaria.isVisible = true;
            //templateManager.updateTemplate();
            delete tipocargaTributaria.validations.required;

            codigoAjusteCredito.readOnly = true;
            descAjusteCredito.readOnly = true;
            codigoAjusteDebito.readOnly = true;
            descAjusteDebito.readOnly = true;
        } else {
            tipocargaTributaria.readOnly = false;
            tipocargaTributaria.validations.required = true;
        }
        this.controlaTipoCargaTributaria(widget);
    };

    this.controlaTipoCargaTributaria = function (widget) {
        var tipocargaTributaria = widget.getField('IDCARGA');
        var codigoAjusteCredito = widget.getField('CDAJSTCREDCARGA');
        var descAjusteCredito = widget.getField('DSOUTCREDCARGA');
        var codigoAjusteDebito = widget.getField('CDAJSTDEBICARGA');
        var descAjusteDebito = widget.getField('DSOUTDEBICARGA');

        if (tipocargaTributaria.value() == '1' || tipocargaTributaria.value() === '' || !tipocargaTributaria.value()) {

            codigoAjusteCredito.readOnly = true;
            delete codigoAjusteCredito.validations.required;

            descAjusteCredito.readOnly = true;
            delete descAjusteCredito.validations.required;

            codigoAjusteDebito.readOnly = true;
            delete codigoAjusteDebito.validations.required;

            descAjusteDebito.readOnly = true;
            delete descAjusteDebito.validations.required;
        } else {
            codigoAjusteCredito.readOnly = true;
            codigoAjusteCredito.validations.required = true;

            descAjusteCredito.readOnly = false;
            descAjusteCredito.validations.required = true;

            codigoAjusteDebito.readOnly = true;
            codigoAjusteDebito.validations.required = true;

            descAjusteDebito.readOnly = false;
            descAjusteDebito.validations.required = true;
        }
    };

    this.dataCargaTributaria = function (args) {
        var widget = args.owner;
        var data = widget.dataSource.data[0];

        if (data.IDCREDDEBNORM == 'S') {
            data.IDCARGA = '1';
        } else if (data.IDOUTCREDDEB == 'S') {
            data.IDCARGA = '2';
        } else {
            data.IDCARGA = null;
        }
    };

    this.salvarCargaTributaria = function (args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            Ger00250_ParametrizacaoInscricaoEstadual_Service.controlaValorCargaTributaria(widget.currentRow);
            this.salvar(args);
        }
    };

    this.checkNumeroDeInscricao = function (field) {
        var validatedInscricao = Ger00250_ParametrizacaoInscricaoEstadual_Service.validateNumeroDeInscricao(field.widget.currentRow[field.descriptionField]);
        var widget = field.widget;

        if (validatedInscricao.valid) {
            //if input is valid, builds unformatted data to save
            switch (validatedInscricao.tipo.cod) {
                case 'O':
                    //Código genérico
                    validatedInscricao.rawValue = General.fill(validatedInscricao.parameter, 5);
                    break;
                case 'I':
                    //Inscrição genérica
                    validatedInscricao.rawValue = General.fill(validatedInscricao.parameter, 20);
                    break;
                default:
                    //CPF && CNPJ
                    validatedInscricao.rawValue = validatedInscricao.parameter;
            }

            //sets data in the currentRow
            widget.currentRow.IDTPIJURIEST = validatedInscricao.tipo.cod;
            widget.currentRow[field.valueField] = validatedInscricao.rawValue;
            widget.currentRow[field.descriptionField] = validatedInscricao.value;
        } else {
            //if message exists, throws warning popup
            if (validatedInscricao.error.msg) ScreenService.showMessage(validatedInscricao.error.msg, "warning");

            //cleans data
            widget.currentRow[field.valueField] = null;
            widget.currentRow[field.descriptionField] = null;
        }
    };

    this.validarCepEnd = function (args) {

        var widget = args.owner.owner.widget;
        CEP = widget.currentRow.NRCEPIEST;
        if (CEP) {
            Endereco.buscarCep(CEP).then(function (response) {
                var endereco = response.dataset.ENDERECO;
                if (endereco) {
                    widget.currentRow.NRCEPIEST = CEP;
                    widget.currentRow.CDPAIS = endereco.CDPAIS ? endereco.CDPAIS : '';
                    widget.currentRow.NMPAIS = endereco.NMPAIS ? endereco.NMPAIS : '';
                    widget.currentRow.SGESTADO = endereco.SGESTADO ? endereco.SGESTADO : '';
                    widget.currentRow.NMESTADO = endereco.NMESTADO ? endereco.NMESTADO : '';
                    widget.currentRow.CDMUNICIPIO = endereco.CDMUNICIPIO ? endereco.CDMUNICIPIO : '';
                    widget.currentRow.NMMUNICIPIO = endereco.NMMUNICIPIO ? endereco.NMMUNICIPIO : '';
                    widget.currentRow.NMBAIRIEST = endereco.NMBAIRRO ? endereco.NMBAIRRO : '';
                    widget.currentRow.CDLOGRADOURO = endereco.CDLOGRADOURO ? endereco.CDLOGRADOURO : '';
                    widget.currentRow.CDBAIRRO = endereco.CDBAIRRO ? endereco.CDBAIRRO : '';
                    widget.currentRow.DSENDEIEST = (endereco.DSLOGRADOURO ? endereco.DSLOGRADOURO : '') + " " + (endereco.DSENDERECO ? endereco.DSENDERECO : '');
                    //widget.currentRow.DSLOGRADOURO = (endereco.DSLOGRADOURO)? endereco.DSLOGRADOURO : '';

                    this.controlaVisibilidadeCampoPaisEstadoMunicipioBairro('gridSubstitutoTributario');
                }
                if (response.dataset.ERRO) ScreenService.showMessage(response.dataset.ERRO.MESSAGE, "warning");
            }.bind(this));
        }
    };

    this.controlaVisibilidadeCampoPaisEstadoMunicipioBairro = function (nomeWidget) {
        var widget = templateManager.container.getWidget(nomeWidget);
        var pais = widget.getField('NMPAIS');
        var estado = widget.getField('NMESTADO');
        var municipio = widget.getField('NMMUNICIPIO');
        var bairro = widget.getField('NMBAIRIEST');
        if (widget.currentRow.NMPAIS) {
            estado.readOnly = false;
            municipio.readOnly = true;
            bairro.readOnly = true;
            if (widget.currentRow.NMESTADO) {
                municipio.readOnly = false;
                bairro.readOnly = true;
                if (widget.currentRow.NMMUNICIPIO) {
                    bairro.readOnly = false;
                } else {
                    bairro.readOnly = true;
                }
            } else {
                municipio.readOnly = true;
                bairro.readOnly = true;
            }
        } else {
            estado.readOnly = true;
            municipio.readOnly = true;
            bairro.readOnly = true;
        }
    };

    this.controlaValorCampoPaisEstadoMunicipioBairro = function (nomeCampoAtual, nomeWidget) {
        var widget = templateManager.container.getWidget(nomeWidget);
        var pais = widget.getField('NMPAIS');
        var estado = widget.getField('NMESTADO');
        var municipio = widget.getField('NMMUNICIPIO');
        var bairro = widget.getField('NMBAIRIEST');
        switch (nomeCampoAtual) {
            case 'Pais':
                estado.value('');
                widget.currentRow.SGESTADO = null;

                municipio.value('');
                widget.currentRow.CDMUNICIPIO = null;

                bairro.value('');
                widget.currentRow.CDBAIRRO = null;

                break;
            case 'Estado':
                municipio.value('');
                widget.currentRow.CDMUNICIPIO = null;

                bairro.value('');
                widget.currentRow.CDBAIRRO = null;

                break;
            case 'Municipio':
                bairro.value('');
                widget.currentRow.CDBAIRRO = null;
                break;
            default:
                break;
        }
    };

    this.recarregarCampo = function (nomeWidget, nomeCampo) {
        var widget = templateManager.container.getWidget(nomeWidget);
        widget.getField(nomeCampo).reload();
    };

    this.setFieldsAddress = function (widgetName, fieldName) {
        return General.getFieldValue(fieldName, widgetName);
    };

    this.editarSubstitutoTributario = function (args) {
        this.controlaVisibilidadeCampoPaisEstadoMunicipioBairro('gridSubstitutoTributario');
        this.controlaStatusWidgets(args.owner.widget, 'gridSubstitutoTributario', false);
        General.edit(args.owner.widget);
    };

    this.salvarSubstitutoTributario = function (args) {
        var widget = args.owner.widget;
        var widgetPrincial = templateManager.container.getWidget('gridInscricaoEstadual');
        if (widget.isValid()) {
            widget.currentRow.NRINSJURIEST = widget.currentRow.NRINSJURIEST.replace(/[^0-9]/g, '');
            if (widget.currentRow.__is_new) {
                widget.currentRow.CDINSCESTA = widgetPrincial.currentRow.CDINSCESTA;
                widget.currentRow.CDEMPRESA = widgetPrincial.currentRow.CDEMPRESA;
                widget.currentRow.CDFILIAL = null;
            }
            Ger00250_ParametrizacaoInscricaoEstadual_Service.salvarSubstitutoTributario(widget.currentRow).then(function (Success) {
                widget.activate();
                if (widget.currentRow.__is_new) {
                    widget.list(true);
                    ScreenService.goBack();
                    widget.reload().then(function () {});
                } else {
                    widget.view();
                }

                this.controlaStatusWidgets(widget, widget.name, true);
            }.bind(this), function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };

    this.adicionarSubstituto = function (args) {
        args.owner.widget.newRow();
        this.controlaVisibilidadeCampoPaisEstadoMunicipioBairro('gridSubstitutoTributario');
        this.controlaStatusWidgets(args.owner.widget, 'gridSubstitutoTributario', false);
    };

    this.salvarMensagemSubstituto = function (args) {
        var widgetPrincial = templateManager.container.getWidget('gridSubstitutoTributario');
        var widget = args.owner.widget;
        if (widget.currentRow.__is_new) {
            widget.currentRow.CDINSCESTA = widgetPrincial.currentRow.CDINSCESTA;
            widget.currentRow.CDEMPRESA = widgetPrincial.currentRow.CDEMPRESA;
            widget.currentRow.CDINSCESTAST = widgetPrincial.currentRow.CDINSCESTAST;
        }
        if (widget.isValid()) {
            Ger00250_ParametrizacaoInscricaoEstadual_Service.salvarMensagemSubstituto(widget.currentRow).then(function (Success) {
                widget.activate();
                if (widget.currentRow.__is_new) {
                    widget.list(true);
                    ScreenService.goBack();
                    widget.reload().then(function () {});
                } else {
                    widget.view();
                }
            }.bind(this), function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };

    this.abrirFiltro = function () {
        var setFilter = {};
        var widget = templateManager.container.getWidget('gridInscricaoEstadual');
        if (filtroPreDefinido !== undefined) setFilter = this.setFiltro();

        ZhFilterPreferences.openFilterWidget(widget, setFilter);
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Ger00250_ParametrizacaoInscricaoEstadual_Controller', Ger00250_ParametrizacaoInscricaoEstadual_Controller);
});

// FILE: ./assets/js/controllers/Ger01300_Pais_Controller.js
function Ger01300_Pais_Controller(General, Ger01300_Pais_Service, ScreenService) {

    this.savePais = function (widget) {
        if (widget.isValid()) {
            Ger01300_Pais_Service.salvarPais(widget.currentRow).then(function (Success) {
                if (widget.currentRow.__is_new) {
                    widget.reload().then(function () {
                        widget.list(true);
                        ScreenService.closeSwipe();
                    });
                } else {
                    widget.view();
                }
            }.bind(this), function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('Ger01300_Pais_Controller', Ger01300_Pais_Controller);
});

// FILE: ./assets/js/controllers/Ger01500_municipio.js
function Ger01500_municipio(ScreenService, General, Ger01500_Municipio_Service) {

    this.filtraEstado = function (field) {
        var fieldEstado = field.widget.container.getWidget('municipio').getField('NMESTADO');
        var country = field.widget;
        var filter = [{
            "name": "CDPAIS",
            "operator": "=",
            "value": country.currentRow.CDPAIS
        }];
        fieldEstado.dataSourceFilter = filter;
        if (country.currentRow.CDPAIS) {
            field.getParent().getField('NMESTADO').readOnly = false;
        } else {
            field.getParent().getField('NMESTADO').readOnly = true;
        }
        field.getParent().getField('NMESTADO').value('');
        field.getParent().getField('NMMUNICIPIO').readOnly = true;
        country.currentRow.NMMUNICIPIO = '';
        country.currentRow.CDMUNICIPIO = '';

        country.currentRow.SGESTADO = '';
        fieldEstado.reload();
    };

    this.filtraMunicipio = function (field) {
        var state = field.widget;
        var fieldMunicipio = state.getField('NMMUNICIPIO');

        fieldMunicipio.value('');
        state.currentRow.CDMUNICIPIO = '';

        if (state.currentRow.SGESTADO) {
            fieldMunicipio.readOnly = false;
        } else {
            fieldMunicipio.readOnly = true;
        }
    };

    this.blockFields = function (args) {
        var widget = args.owner;
        widget.getField('NMPAIS').readOnly = true;
        widget.getField('NMESTADO').readOnly = true;
    };

    this.takeLocations = function (widget) {
        var popupCurrentRow = widget.appliedFilter.FILTER_ROW;
        widget.currentRow.NMPAIS = popupCurrentRow.NMPAIS;
        widget.currentRow.CDPAIS = popupCurrentRow.CDPAIS;
        widget.currentRow.NMESTADO = popupCurrentRow.NMESTADO;
        widget.currentRow.SGESTADO = popupCurrentRow.SGESTADO;
    };

    this.salvarMunicipio = function (widget) {
        if (widget.currentRow.CDPAIS && widget.currentRow.SGESTADO) {
            if (widget.isValid()) {
                Ger01500_Municipio_Service.salvarMunicipio(widget.currentRow).then(function (Success) {
                    this.controlaStatusWidgets(widget, 'municipio', true);
                    if (widget.currentRow.__is_new) {
                        widget.reload().then(function () {
                            widget.list(true);
                            ScreenService.closeSwipe();
                        });
                    } else {
                        widget.view();
                    }
                }.bind(this), function (callback) {
                    if (callback.data) {
                        ScreenService.showMessage(callback.data.error);
                    }
                });
            }
        } else {
            ScreenService.showMessage('Campos do filtro não preenchidos.');
        }
    };

    this.addBairro = function (widget) {
        var widgetMunicipio = widget.getParent();
        var filtro = {
            "CDPAIS": widgetMunicipio.currentRow.CDPAIS,
            "SGESTADO": widgetMunicipio.currentRow.SGESTADO,
            "CDMUNICIPIO": widgetMunicipio.currentRow.CDMUNICIPIO
        };
        widget.newRow();
        Ger01500_Municipio_Service.novoCodigoBairro(filtro).then(function (success) {
            var codigo = formatCdbairro(String(success.dataset.CDBAIRRO.CDBAIRRO[0].MAIORBAIRRO));
            widget.currentRow.CDBAIRRO = codigo.substring(0, 10);
            widget.currentRow.CDPAIS = widgetMunicipio.currentRow.CDPAIS;
            widget.currentRow.SGESTADO = widgetMunicipio.currentRow.SGESTADO;
            widget.currentRow.CDMUNICIPIO = widgetMunicipio.currentRow.CDMUNICIPIO;
        }, function (callback) {
            if (callback.data) {
                ScreenService.showMessage(callback.data.error);
            }
        });
    };

    function formatCdbairro(string) {
        switch (string.length) {
            case 1:
                return '000000000' + string;
            case 2:
                return '00000000' + string;
            case 3:
                return '0000000' + string;
            case 4:
                return '000000' + string;
            case 5:
                return '00000' + string;
            case 6:
                return '0000' + string;
            case 7:
                return '000' + string;
            case 8:
                return '00' + string;
            case 9:
                return '0' + string;
            case 10:
                return string;
        }
    }

    this.addMunicipio = function (widget) {
        var filtro = widget.appliedFilter.FILTER_ROW;
        widget.newRow();
        widget.currentRow.CDPAIS = filtro.CDPAIS;
        widget.currentRow.SGESTADO = filtro.SGESTADO;
        this.controlaStatusWidgets(widget, 'municipio', false);
    };

    this.controlaStatusWidgets = function (mainWidget, nomeWidgetAtual, status) {
        mainWidget.widgets.forEach(function (widg) {
            if (nomeWidgetAtual !== widg.name) widg.enabled = status;
        });

        if (mainWidget.name !== nomeWidgetAtual) mainWidget.enabled = status;
    };

    this.salvarBairro = function (widget) {
        if (widget.isValid()) {
            if (widget.currentRow.QTHORAENTREGA) widget.currentRow.QTHORAENTREGA = widget.currentRow.QTHORAENTREGA.replace(/[^0-9]/g, '');
            General.saveCrud(widget);
        }
    };

    this.addRegiao = function (widget) {
        var widgetMunicipio = widget.getParent();
        var filtro = {
            "CDPAIS": widgetMunicipio.currentRow.CDPAIS,
            "SGESTADO": widgetMunicipio.currentRow.SGESTADO,
            "CDMUNICIPIO": widgetMunicipio.currentRow.CDMUNICIPIO
        };
        widget.newRow();
        Ger01500_Municipio_Service.novoCodigoRegiao(filtro).then(function (success) {
            var codigo = formatCdregiaoMuni(String(success.dataset.CDREGIAOMUNI.CDREGIAOMUNI[0].MAIORREGIAO));
            widget.currentRow.CDREGIAOMUNI = codigo.substring(0, 4);
            widget.currentRow.CDPAIS = widgetMunicipio.currentRow.CDPAIS;
            widget.currentRow.SGESTADO = widgetMunicipio.currentRow.SGESTADO;
            widget.currentRow.CDMUNICIPIO = widgetMunicipio.currentRow.CDMUNICIPIO;
        }, function (callback) {
            if (callback.data) {
                ScreenService.showMessage(callback.data.error);
            }
        });
    };

    function formatCdregiaoMuni(string) {
        switch (string.length) {
            case 1:
                return '000' + string;
            case 2:
                return '00' + string;
            case 3:
                return '0' + string;
        }
    }

    this.recarrecarWidgetsFilhas = function (widget) {
        if (!widget.currentRow.__is_new) {
            widget.widgets.forEach(function (widg) {
                widg.reload();
            });
        }
    };

    this.filtraEstadoFilter = function (field) {
        var fieldEstado = field.widget.getField('NMESTADO');
        var country = field.widget;
        var filter = [{
            "name": "CDPAIS",
            "operator": "=",
            "value": country.currentRow.CDPAIS
        }];
        fieldEstado.dataSourceFilter = filter;
        if (country.currentRow.CDPAIS) {
            field.getParent().getField('NMESTADO').readOnly = false;
        } else {
            field.getParent().getField('NMESTADO').readOnly = true;
        }
        field.getParent().getField('NMESTADO').value('');
        field.getParent().getField('NMMUNICIPIO').readOnly = true;
        country.currentRow.NMMUNICIPIO = '';
        country.currentRow.CDMUNICIPIO = '';

        country.currentRow.SGESTADO = '';
        fieldEstado.reload();
        fieldEstado.dataSource.load();
    };

    this.filtraMunicipioFilter = function (field) {
        var fieldMunicipio = field.getParent().getField('NMMUNICIPIO');
        var country = field.widget;
        var filter = [{
            "name": "CDPAIS",
            "operator": "=",
            "value": country.currentRow.CDPAIS
        }, {
            "name": "SGESTADO",
            "operator": "=",
            "value": country.currentRow.SGESTADO
        }];
        fieldMunicipio.dataSourceFilter = filter;
        if (country.currentRow.CDPAIS && country.currentRow.SGESTADO) {
            field.getParent().getField('NMMUNICIPIO').readOnly = false;
        } else {
            field.getParent().getField('NMMUNICIPIO').readOnly = true;
        }
        fieldMunicipio.reload();
        fieldMunicipio.dataSource.load();
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('Ger01500_municipio', Ger01500_municipio);
});

// FILE: ./assets/js/controllers/Ger58000_Apuracao_IRPJ_CSLL_Controller.js
var Ger58000_Apuracao_IRPJ_CSLL_Controller = function Ger58000_Apuracao_IRPJ_CSLL_Controller(Ger58000_Apuracao_IRPJ_CSLL_Service, maskEngine, ScreenService, templateManager, General) {

    var self = this;

    var defaultArray = [{ "__is_new": true, "DSALIQIRPJCSLL": "Atividades em Geral(RIR/1999, art. 518)", "VRALIQPRESIRPJ": 8, "VRALIQPRESCSLL": 12 }, { "__is_new": true, "DSALIQIRPJCSLL": "Revenda de Combustíveis", "VRALIQPRESIRPJ": 1.6, "VRALIQPRESCSLL": 12 }, { "__is_new": true, "DSALIQIRPJCSLL": "Serviços de Transporte (Exceto o de Carga)", "VRALIQPRESIRPJ": 16, "VRALIQPRESCSLL": 12 }, { "__is_new": true, "DSALIQIRPJCSLL": "Serviços de Tranporte de Cargas", "VRALIQPRESIRPJ": 8, "VRALIQPRESCSLL": 12 }, { "__is_new": true, "DSALIQIRPJCSLL": "Serviços em geral(exceto serviços hospitalares)", "VRALIQPRESIRPJ": 32, "VRALIQPRESCSLL": 32 }, { "__is_new": true, "DSALIQIRPJCSLL": "Serviços hospitalares", "VRALIQPRESIRPJ": 8, "VRALIQPRESCSLL": 12 }, { "__is_new": true, "DSALIQIRPJCSLL": "Intermediação de negócios", "VRALIQPRESIRPJ": 32, "VRALIQPRESCSLL": 32 }, { "__is_new": true, "DSALIQIRPJCSLL": "Administração, Locação ou Cesso de Bens e Direitos", "VRALIQPRESIRPJ": 32, "VRALIQPRESCSLL": 32 }];

    this.setContctblMask = function () {

        Ger58000_Apuracao_IRPJ_CSLL_Service.getContctblMask().then(function (response) {

            var paramgeral = response.dataset.paramgeral[0];
            var contctblMask = paramgeral.CDPICTCCTB;

            templateManager.container.getWidget('grid_infoctbl_irpj').fields[2].fields[0].mask.params.mask = contctblMask;

            templateManager.container.getWidget('grid_infoctbl_csll').fields[2].fields[0].mask.params.mask = contctblMask;

            templateManager.container.getWidget('grid_infoctbl_lucrolqd').fields[2].fields[0].mask.params.mask = contctblMask;

            templateManager.updateTemplate();
        });
    };

    this.loadParamImposto = function (widget) {

        var VRALIQCSLL = widget.getField('VRALIQCSLL');
        var VRALIQIR = widget.getField('VRALIQIR');
        var VRLIMADICIRPJ = widget.getField('VRLIMADICIRPJ');
        var VRPERCADICIR = widget.getField('VRPERCADICIR');

        Ger58000_Apuracao_IRPJ_CSLL_Service.getParamImposto().then(function (response) {

            var data = response.dataset.paramimposto_aliq[0];

            if (data) {
                widget.fields.forEach(function (field) {
                    field.setValue(data[field.name]);
                });
            } else {
                widget.fields.forEach(function (field) {
                    field.setValue(0);
                });
            }
        }).catch(function (error) {
            var errorMessage = 'Timeout';
            if (error.data) {
                if (error.data.error) {
                    errorMessage = error.data.error;
                }
                ScreenService.showMessage(errorMessage);
            }
        });
    };

    this.loadInfoCtbl = function (widget) {

        if (widget.currentRow.NRSEQPARAMAPU) {

            widget.widgets[0].dataSourceFilter = [{

                name: "NRSEQPARAMAPU",
                operator: "=",
                value: widget.currentRow.NRSEQPARAMAPU

            }];
        } else {
            widget.widgets[0].dataSourceFilter = [{

                name: "NRSEQPARAMAPU",
                operator: "=",
                value: widget.currentRow.NRSEQPARAMAPU

            }];
        }
        widget.reload();
    };

    this.saveParamImposto = function (widget) {

        var row = widget.currentRow;

        Ger58000_Apuracao_IRPJ_CSLL_Service.saveParamImposto(row).then(function (success) {
            if (success.dataset) widget.currentRow.NRSEQPARAMIMPOSTO = success.dataset.paramimposto_aliq.NRSEQ;
        }, function (error) {
            var errorMessage = 'Timeout';
            if (error.data) {
                errorMessage = error.data.error;
            }

            ScreenService.showMessage(errorMessage);
        });
    };

    this.saveAliqIRPJCSLL = function (widget) {

        if (isNaN(widget.currentRow.VRALIQPRESCSLL)) {
            widget.currentRow.VRALIQPRESCSLL = 0;
        }
        if (isNaN(widget.currentRow.VRALIQPRESIRPJ)) {
            widget.currentRow.VRALIQPRESIRPJ = 0;
        }
        General.widgetSave(widget).then(function (response) {
            if (response.dataset.aliqirpjcsll_apuirpj) widget.currentRow.NRSEQALIQIRPJ = response.dataset.aliqirpjcsll_apuirpj.NRSEQ;
        });
    };

    this.importAliquotas = function (widget) {
        ScreenService.confirmMessage('Importar registros padrão da Receita Federal?', 'question', function (success) {
            Ger58000_Apuracao_IRPJ_CSLL_Service.saveDefaultAliqIRPJCSLL(defaultArray).then(function () {
                widget.reload();
            });
        });
    };

    this.loadChildrenWidgets = function (widget) {
        widget.widgets[0].widgets[0].reload();

        widget.widgets[0].widgets[0].dataSourceFilter = [{
            name: "CDEMPRESA",
            operator: "=",
            value: widget.currentRow.CDEMPRESA
        }];

        widget.widgets[1].widgets[0].dataSourceFilter = [{
            name: "CDEMPRESA",
            operator: "=",
            value: widget.currentRow.CDEMPRESA
        }, {
            name: "IDIMPOSTO",
            operator: "=",
            value: 'I'
        }];

        widget.widgets[2].widgets[0].dataSourceFilter = [{
            name: "CDEMPRESA",
            operator: "=",
            value: widget.currentRow.CDEMPRESA
        }, {
            name: "IDIMPOSTO",
            operator: "=",
            value: 'C'
        }];

        General.changeWidgetAcessibility(widget.widgets, true);

        widget.widgets[0].widgets[0].isVisible = true;

        widget.widgets[0].widgets[0].reload();
        widget.widgets[1].widgets[0].reload();
        widget.widgets[2].widgets[0].reload();
    };

    this.addParamapu = function (widget) {

        General.widgetNewRow(widget);

        widget.currentRow.VRPORCENTAGEM = 100;
    };

    this.saveParamapu = function (widget) {
        widget.currentRow.CDEMPRESA = widget.getParent().getParent().currentRow.CDEMPRESA;
        widget.currentRow.IDIMPOSTO = widget.dataSourceFilter[1].value;
        var route = 'fis#/saveParamapuirpj';
        General.callRestEngine(route, 'DataSet', [widget.currentRow]).then(function (response) {
            ScreenService.closeSwipe();
            widget.reload();
        }).catch(function (erro) {
            ScreenService.showMessage(erro.data.error);
        });
        var widcsll = templateManager.container.getWidget('grid_infoctbl_csll');
        var widirpj = templateManager.container.getWidget('grid_infoctbl_irpj');
        widcsll.enabled = true;
        widirpj.enabled = true;
    };

    this.saveLucrolqd = function (widget) {

        widget.currentRow.CDEMPRESA = widget.getParent().getParent().currentRow.CDEMPRESA;
        if (widget.currentRow.NRSEQALIQIRPJ == undefined) {
            widget.currentRow.NRSEQALIQIRPJ = "";
        }
        var route = 'fis#/saveRecdespirpjApuirpj';
        General.callRestEngine(route, 'DataSet', [widget.currentRow]).then(function (response) {
            General.changeWidgetAcessibility(widget.widgets, true);
            ScreenService.closeSwipe();
            widget.reload();
        }).catch(function (erro) {
            ScreenService.showMessage(erro.data.error);
        });
    };

    this.deleteLucrolqd = function (widget) {
        var route = 'fis#/saveRecdespirpjApuirpj';
        General.callRestEngine(route, 'DataSet', [widget.currentRow]).then(function (response) {
            ScreenService.closeSwipe();
            widget.reload();
        }).catch(function (erro) {
            ScreenService.showMessage(erro.data.error);
        });
    };

    this.loadInfoCtbl = function (widget) {

        var value = widget.currentRow.NRSEQPARAMAPU ? widget.currentRow.NRSEQPARAMAPU : widget.currentRow.NRSEQRECDESPIRPJ;

        widget.widgets[0].dataSourceFilter = [{
            name: "NRSEQPARAMAPU",
            operator: "=",
            value: value
        }];

        widget.widgets[0].reload();
    };

    this.addInfCtb = function (widget) {

        General.widgetNewRow(widget);

        widget.currentRow.NRSEQPARAMAPU = widget.getParent().currentRow.NRSEQPARAMAPU ? widget.getParent().currentRow.NRSEQPARAMAPU : widget.getParent().currentRow.NRSEQRECDESPIRPJ;

        self.loadInfCtbFields(widget);
    };

    //Função que exibe/omite campos de acordo com o tipo de informação contábil escolhi

    this.loadInfCtbFields = function (widget) {
        var validations = {
            "required": {
                "message": "Campo Obrigatório"
            }
        };
        if (widget.currentRow.IDINFCTBIRPJ === 'C') {
            widget.getField('CDINFCTBIRPJ').showOnForm = true;
            widget.currentRow.CDTIPODEMO = "";
            widget.getField('DSTIPOITEM').showOnForm = false;
            widget.getField('CDINFCTBIRPJ').validations = validations;
            delete widget.getField('DSTIPOITEM').validations;
        } else if (widget.currentRow.IDINFCTBIRPJ === 'I') {
            widget.getField('CDINFCTBIRPJ').showOnForm = false;
            widget.getField('DSTIPOITEM').showOnForm = true;
            widget.getField('DSTIPOITEM').validations = validations;
            delete widget.getField('CDINFCTBIRPJ').validations;
        } else {
            widget.getField('CDINFCTBIRPJ').showOnForm = false;
            widget.getField('DSTIPOITEM').showOnForm = false;
        }
    };

    this.saveInfCtb = function (widget) {

        General.widgetSave(widget).then(function () {

            widget.list();
            ScreenService.closeSwipe();
            widget.reload();
        });
    };

    this.controlaStatusWidgets = function (mainWidget, nomeWidgetAtual, status) {
        mainWidget.widgets.forEach(function (widg) {
            if (nomeWidgetAtual !== widg.name) widg.enabled = status;
        });
        if (mainWidget.name !== nomeWidgetAtual) mainWidget.enabled = status;
    };

    var maskCtCtblFunction = function maskCtCtblFunction(value, params) {
        if (!value) return "";
        value = value.replace(/^(\d)?(\d)?(\d{2})?(\d{2})?(\d{4})?/, "$1.$2.$3.$4.$5");
        return value;
    };

    maskEngine.registerMask('INFCTB_CTCTBL', function () {}, maskCtCtblFunction);
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Ger58000_Apuracao_IRPJ_CSLL_Controller', Ger58000_Apuracao_IRPJ_CSLL_Controller);
});

// FILE: ./assets/js/controllers/Ger81200_AliquotaValidaPorCstEImposto_Controller.js
function Ger81200_AliquotaValidaPorCstEImposto_Controller(General, ScreenService, ZhFilterPreferences, templateManager) {

    var self = this;

    this.back = function (widget) {
        ScreenService.closeSwipe();
    };

    this.cancel = function (args) {
        General.backOrCancel(args);
    };

    this.changeImposto = function (widget) {
        var field = widget.getField("CDSITUTRIBNFE");
        if (widget.currentRow.CDIMPOSTONFE && widget.currentRow.CDIMPOSTONFE.length > 0) {
            if (field.readOnly === true) {
                this.fieldsMethods(widget, "unlock", ["CDSITUTRIBNFE"]);
                this.updateFilter(field, ["CDIMPOSTO"], "=", [widget.currentRow.CDIMPOSTONFE]);
            }
        } else {
            this.fieldsMethods(widget, "block", ["CDSITUTRIBNFE"]);
            this.fieldsMethods(widget, "clear", ["CDSITUTRIBNFE"]);
        }
    };

    this.delete = function (widget) {
        widget.currentRow.CDIMPOSTO = widget.currentRow.CDIMPOSTONFE;
        General.deleteCrud(widget);
    };

    this.filter = function (widget) {
        if (widget.__filterPopup) {
            this.verifyFields(widget.__filterPopup);
        }
        ZhFilterPreferences.openFilterWidget(widget);
    };

    this.new = function (widget) {
        widget.newRow();
        this.fieldsMethods(widget, "fill");
        this.verifyFields(widget);
    };

    this.save = function (widget) {
        widget.currentRow.CDIMPOSTO = widget.currentRow.CDIMPOSTONFE;
        var aliquota = widget.currentRow.VRALIQUOTA.replace(',', '.');
        widget.currentRow.VRALIQUOTA = aliquota;
        if (aliquota > 100.00) {
            ScreenService.showMessage('Valor Inválido! O Valor da Alíquota Interna deve ser maior que 0 e menor que 100');
        } else {
            General.saveCrud(widget);
        }
    };

    this.fieldsMethods = function (widget, method, fieldNames) {
        switch (method) {
            case 'block':
                this.blockFields(widget, fieldNames);
                break;
            case 'clear':
                this.clearFields(widget, fieldNames);
                break;
            case 'fill':
                this.fillFields(widget, fieldNames);
                break;
            case 'hide':
                this.hideFields(widget, fieldNames);
                break;
            case 'show':
                this.showFields(widget, fieldNames);
                break;
            case 'unlock':
                this.unlockFields(widget, fieldNames);
                break;
            default:
            // code
        }
    };

    this.blockFields = function (widget, fieldNames) {
        for (var i = 0; i < fieldNames.length; i++) {
            widget.getField(fieldNames[i]).readOnly = true;
        }
    };

    this.clearFields = function (widget, fieldNames) {
        var row = widget.currentRow;
        for (var i = 0; i < fieldNames.length; i++) {
            row[fieldNames[i]] = "";
        }
    };

    this.fillFields = function (widget, fieldNames) {
        if (!fieldNames) {
            fieldNames = [];
            for (var i = 0; i < widget.fields.length; i++) {
                fieldNames[i] = widget.fields[i].name;
            }
        }
        var currentRow = widget.currentRow;
        var currentRowPopup = widget.appliedFilter.FILTER_ROW;
        for (var j = 0; j < fieldNames.length; j++) {
            var value = currentRowPopup[fieldNames[j]];
            if (value) {
                currentRow[fieldNames[j]] = value;
            }
        }
    };

    this.hideFields = function (widget, fieldNames) {
        for (var i = 0; i < fieldNames.length; i++) {
            widget.getField(fieldNames[i]).isVisible = false;
        }
    };

    this.showFields = function (widget, fieldNames) {
        for (var i = 0; i < fieldNames.length; i++) {
            widget.getField(fieldNames[i]).isVisible = true;
        }
    };

    this.unlockFields = function (widget, fieldNames) {
        for (var i = 0; i < fieldNames.length; i++) {
            widget.getField(fieldNames[i]).readOnly = false;
        }
    };

    this.updateFilter = function (object, fieldNames, operator, values) {
        var dataSourceFilter = [];
        for (var i = 0; i < fieldNames.length; i++) {
            if (values[i] !== "") {
                dataSourceFilter = dataSourceFilter.concat({
                    "name": fieldNames[i],
                    "operator": operator,
                    "value": values[i]
                });
            }
        }
        object.dataSourceFilter = dataSourceFilter;
        object.reload();
    };

    this.verifyFields = function (widget) {
        var unlockNames = [];
        var blockNames = [];
        if (widget.currentRow.CDIMPOSTONFE && widget.currentRow.CDIMPOSTONFE.length > 0) {
            unlockNames.push("CDSITUTRIBNFE");
        } else {
            blockNames.push("CDSITUTRIBNFE");
        }
        if (blockNames.length > 0) {
            this.fieldsMethods(widget, "block", blockNames);
        }
        if (unlockNames.length > 0) {
            this.fieldsMethods(widget, "unlock", unlockNames);
        }
    };

    self.validaAliquotaCfop = function (widget) {
        if (isNaN(parseFloat(widget.currentRow.VRALIQUOTA)) || parseFloat(widget.currentRow.VRALIQUOTA) < 0 || parseFloat(widget.currentRow.VRALIQUOTA) > 100.00) {
            widget.getField('VRALIQUOTA').clearValue();
            ScreenService.showMessage('Valor da Alíquota Interna deve ser maior que 0 e menor que 100');
        }
    };
}
Configuration(function (ContextRegister) {
    ContextRegister.register('Ger81200_AliquotaValidaPorCstEImposto_Controller', Ger81200_AliquotaValidaPorCstEImposto_Controller);
});

// FILE: ./assets/js/controllers/Ger99100_RelacionamentoImpostosFiscais_Controller.js
var Ger99100_RelacionamentoImpostosFiscais_Controller = function Ger99100_RelacionamentoImpostosFiscais_Controller(MessageService, ScreenService, templateManager, Ger99100_RelacionamentoImpostosFiscais_Service, ZhFilterPreferences, restEngine, General) {

    this.addImpostoFiscal = function (widget) {
        var impostoWidget = templateManager.container.getWidget("impostofiscal");
        var relacWidget = templateManager.container.getWidget("relacimpostosfiscais");
        widget.currentRow = {};
        impostoWidget.newRow();
        ScreenService.openSwipe(impostoWidget);
        impostoWidget.parentRow = relacWidget.currentRow;
    };

    this.checkToggleImport = function (widget) {
        var impostoField = widget.getField("CDIMPOSTO");
        var importField = widget.getField("IDIMPORTAIMPXML");
        var encargoimpxml = widget.getField("NMENCARGO");
        if (impostoField.value()) {
            encargoimpxml.readOnly = false;
            importField.readOnly = false;
            importField.validations.required = { message: "Campo obrigatório" };
        } else {
            widget.currentRow.CDENCARGOIMPXML = '';
            widget.currentRow.NMENCARGO = '';
            encargoimpxml.readOnly = true;
            importField.readOnly = true;
            importField.validations = {};
            widget.currentRow.IDIMPORTAIMPXML = null;
        }
    };

    this.openSwipeImposto = function (widget) {
        var impostoWidget = templateManager.container.getWidget('impostofiscal');
        ScreenService.openSwipe(impostoWidget);
        impostoWidget.currentRow = widget.currentRow;
        impostoWidget.view();
    };

    this.openSwipeRelationships = function (widget) {
        var relacWidget = templateManager.container.getWidget('relacionamentos');
        ScreenService.openSwipe(relacWidget);
        relacWidget.dataSourceFilter[0].value = widget.currentRow.CDIMPOSTONFE;
        relacWidget.list();
        relacWidget.reload();
    };

    this.removeNfeRelationship = function (widget) {
        MessageService.confirmMessageByCode("REGISTRO_EXCLUIR").then(function (success) {
            var relacWidget = templateManager.container.getWidget("relacimpostosfiscais");
            widget.currentRow.CDIMPOSTONFE = relacWidget.currentRow.CDIMPOSTONFE;
            Ger99100_RelacionamentoImpostosFiscais_Service.removeNfeRelationship(widget.currentRow).then(function () {
                ScreenService.closeSwipe();
                widget.getParent().activate();
                widget.getParent().getParent().reload();
                widget.getParent().reload();
            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });
        });
    };

    this.saveNfeRelationship = function (widget) {
        if (widget.isValid()) {
            widget.currentRow.CDIMPOSTONFE = widget.parentRow.CDIMPOSTONFE;
            Ger99100_RelacionamentoImpostosFiscais_Service.saveNfeRelationship(widget.currentRow).then(function (success) {
                ScreenService.closeSwipe();
                widget.view();
                widget.getParent().activate();
                widget.getParent().getParent().reload();
                widget.getParent().reload();
            }, function (error) {
                var errorMessage = 'Timeout';
                if (error.data) {
                    errorMessage = error.data.error;
                }
                ScreenService.showMessage(errorMessage);
            });
        }
    };

    this.saveXmlRelationship = function (widget) {
        if (widget.isValid()) {
            Ger99100_RelacionamentoImpostosFiscais_Service.saveXmlRelationship(widget.currentRow).then(function (success) {
                widget.view();
                widget.reload();
            }, function (error) {
                var errorMessage = 'Timeout';
                if (error.data) {
                    errorMessage = error.data.error;
                }
                ScreenService.showMessage(errorMessage);
            });
        }
    };

    this.incluir = function (widget) {
        General.callRestEngine('fis#/impostonfe/incluirImpostos', 'Row', { 'Row': [] }).then(function (success) {});
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Ger99100_RelacionamentoImpostosFiscais_Controller', Ger99100_RelacionamentoImpostosFiscais_Controller);
});

// FILE: ./assets/js/controllers/fis02600_classificacaoFiscalController.js
var fis02600_classificacaoFiscalController = function fis02600_classificacaoFiscalController(templateManager, ScreenService, fis02600_classificacaoFiscalService, General) {

    this.adicionarClassficiacao = function (widget) {
        widget = templateManager.container.getWidget('fis02600_classificacaoFiscal');
        var campoCodigo = widget.getField('CDCLASFISC');
        if (!campoCodigo.mask.params.mask) {
            ScreenService.showMessage('Máscara para classificação fiscal não cadastrada.');
        } else {
            widget.newRow();
            this.controlaAction(widget, false);
        }
    };
    this.editRow = function (widget) {
        General.edit(widget);
        this.controlaAction(widget, false);
    };

    this.save = function (widget) {
        General.saveCrud(widget).then(function (Success) {
            this.controlaAction(widget, true);
        }.bind(this), function (callback) {
            if (callback.data) {
                ScreenService.showMessage(callback.data.error);
            }
        });
    };
    this.cancel = function (args) {
        General.backOrCancel(args);
        this.controlaAction(args.owner.widget, true);
    };

    this.verificaNivel = function (widget) {
        if (widget.currentRow.__is_new) {
            if (widget.isValid()) {
                var banco = fis02600_classificacaoFiscalService.consulta().then(function (callback) {
                    var resultado = callback.dataset.dtsParamgeralClassFiscal;
                    var nivel = resultado[0].CDPICTCFIS;
                    if (nivel === null) {
                        ScreenService.showMessage('Máscara para classificação fiscal não cadastrada.');
                    } else {
                        var valorUsuario = widget.getField('CDCLASFISC').value().replace(/[^0-9]/g, '');
                        var mascara = widget.getField('CDCLASFISC').mask.params.mask.replace(/[^0-9]/g, '');
                        if (mascara.length != valorUsuario.length) {
                            ScreenService.showMessage('Classificação fiscal informada com preenchimento inválido de nível');
                        } else {
                            widget.currentRow.CDCLASFISC = widget.currentRow.CDCLASFISC.replace(/[^0-9]/g, '');
                            this.save(widget);
                        }
                    }
                }.bind(this));
            }
        } else {
            this.save(widget);
        }
    };

    this.aplicarMascara = function (args) {
        fis02600_classificacaoFiscalService.consulta().then(function (callback) {
            var widget = templateManager.container.getWidget('fis02600_classificacaoFiscal');
            var resultado = callback.dataset.dtsParamgeralClassFiscal;
            var mascara = resultado[0].CDPICTCFIS;
            var campoCodigo = widget.getField('CDCLASFISC');
            if (mascara) {
                mascara = '?' + mascara;
                campoCodigo.mask.params.mask = mascara;
            } else {
                campoCodigo.mask = {};
            }
        }, function (callback) {
            if (callback.data) {
                ScreenService.showMessage(callback.data.error);
            }
        });
    };

    this.aplicarMascaraAdicionar = function (args) {
        fis02600_classificacaoFiscalService.consulta().then(function (callback) {
            var widget = templateManager.container.getWidget('fis02600_classificacaoFiscal');
            var resultado = callback.dataset.dtsParamgeralClassFiscal;
            var mascara = resultado[0].CDPICTCFIS;
            var campoCodigo = widget.getField('CDCLASFISC');
            if (mascara) {
                $('#CDCLASFISC').mask('?' + mascara);
            }
        }, function (callback) {
            if (callback.data) {
                ScreenService.showMessage(callback.data.error);
            }
        });
    };

    this.verificaMascara = function () {
        var widget = templateManager.container.getWidget('fis02600_classificacaoFiscal');
        var campoCodigo = widget.getField('CDCLASFISC');
        if (!campoCodigo.mask.params.mask) {
            ScreenService.showMessage('Máscara para classificação fiscal não cadastrada.');
        }
    };

    this.controlaAction = function (widget, visibilidade) {
        var action = widget.getAction('abrirTelaClassificacao').isVisible = visibilidade;
    };

    this.removerMascarFiltro = function (args, preference) {
        var filtro = preference.FILTER_ROW;
        if (filtro.CDCLASFISC) {
            filtro.CDCLASFISC = filtro.CDCLASFISC.replace(/[^0-9]/g, '');
        }
    };
};
Configuration(function (ContextRegister) {
    ContextRegister.register('fis02600_classificacaoFiscalController', fis02600_classificacaoFiscalController);
});

// FILE: ./assets/js/controllers/ger01200_estadoController.js
function ger01200_estadoController(ScreenService, General, Ger01200_Estado_Service, templateManager) {

    this.salvar = function (widget) {
        if (widget.isValid()) {
            Ger01200_Estado_Service.salvarEstado(widget.currentRow).then(function (Success) {
                if (widget.currentRow.__is_new) {
                    widget.reload().then(function () {
                        widget.list(true);
                        ScreenService.closeSwipe();
                    });
                } else {
                    widget.view();
                }
            }.bind(this), function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };

    this.setCountryName = function (widget) {
        widget.dataSource.data.forEach(function (row) {
            row.NMPAIS = widget.appliedFilter.FILTER_ROW.NMPAIS;
        });
    };

    this.toAddCountry = function (args) {
        var arr = args.owner.widget.dataSourceFilter;
        var nm_pais = args.owner.widget.appliedFilter.FILTER_ROW.NMPAIS;
        var cd_pais = args.owner.widget.appliedFilter.FILTER_ROW.CDPAIS;
        args.owner.widget.newRow();
        args.owner.widget.currentRow.NMPAIS = nm_pais;
        args.owner.widget.currentRow.CDPAIS = cd_pais.toString();
        ScreenService.openSwipe(args.owner.widget);
    };

    this.controlaCampoEstado = function (widget) {
        var estado = widget.getField('NMESTADO');
        widget.currentRow.NMESTADO = '';
        widget.currentRow.SGESTADO = '';
        if (widget.currentRow.CDPAIS) {
            estado.readOnly = false;
        } else {
            estado.readOnly = true;
        }
    };

    this.setFiltroEstado = function (widget) {
        var estado = widget.getField('NMESTADO');
        estado.dataSourceFilter[0].value = widget.currentRow.CDPAIS;
        estado.reload();
    };

    this.converteSiglaEstadoMaisculo = function (field) {
        field.value(field.value().toUpperCase());
    };

    this.setFilterWebService = function (args) {
        var widget = args.owner;
        var SGESTADO = widget.currentRow.SGESTADO;
        var CDPAIS = widget.currentRow.CDPAIS;
        var widgetsWebService = templateManager.container.getWidget('webServiceSefazWidget').widgets;

        widgetsWebService.forEach(function (widget) {
            widget.widgets[0].dataSourceFilter[1].value = SGESTADO;
            widget.widgets[0].dataSourceFilter[2].value = CDPAIS;
            widget.widgets[1].dataSourceFilter[1].value = SGESTADO;
            widget.widgets[1].dataSourceFilter[2].value = CDPAIS;
        });
    };

    this.setDataFields = function (args) {
        var widget = args.owner;
        var data = widget.dataSource.data;

        if (data[0]) {
            var row = widget.currentRow;
            if (widget.getParent().name == 'nfe') {
                row.WSRECEPCAO = data[0].WSRECEPCAO;
                row.WSRETRECEPCAO = data[0].WSRETRECEPCAO;
                row.WSEVENTO = data[0].WSEVENTO;
                row.WSCONSULTACAD = data[0].WSCONSULTACAD;
                row.WSSTATUSSERVICO = data[0].WSSTATUSSERVICO;
                row.WSINUTILIZACAO = data[0].WSINUTILIZACAO;
                row.WSCONSULTAPRO = data[0].WSCONSULTAPRO;
                row.WSAUTORIZACAO = data[0].WSAUTORIZACAO;
                row.WSRETAUTORIZACAO = data[0].WSRETAUTORIZACAO;
                row.WSDOWNLOADNF = data[0].WSDOWNLOADNF;
                row.WSCONSULTADEST = data[0].WSCONSULTADEST;
            }
            if (widget.getParent().name == 'mdfe') {
                row.WSRECEPCAOMDF = data[0].WSRECEPCAOMDF;
                row.WSRETRECEPCAOMDF = data[0].WSRETRECEPCAOMDF;
                row.WSEVENTOMDF = data[0].WSEVENTOMDF;
                row.WSCONSULTAMDF = data[0].WSCONSULTAMDF;
                row.WSSTATUSSERVMDF = data[0].WSSTATUSSERVMDF;
                row.WSCONSMDFNAOENCE = data[0].WSCONSMDFNAOENCE;
            }
            if (widget.getParent().name == 'nfce') {
                row.WSAUTORIZACAONFC = data[0].WSAUTORIZACAONFC;
                row.WSRETAUTORIZACAONFC = data[0].WSRETAUTORIZACAONFC;
                row.WSINUTILIZACAONFC = data[0].WSINUTILIZACAONFC;
                row.WSEVENTONFC = data[0].WSEVENTONFC;
                row.WSSTATUSSERVNFC = data[0].WSSTATUSSERVNFC;
                row.WSCONSULTANFC = data[0].WSCONSULTANFC;
                row.WSLINKQRCODENFC = data[0].WSLINKQRCODENFC;
            }
            if (widget.getParent().name == 'cte') {
                row.WSRECEPCAOCTE = data[0].WSRECEPCAOCTE;
                row.WSRETRECEPCAOCTE = data[0].WSRETRECEPCAOCTE;
                row.WSEVENTOCTE = data[0].WSEVENTOCTE;
                row.WSCONSULTACADCTE = data[0].WSCONSULTACADCTE;
                row.WSSTATUSSERVCTE = data[0].WSSTATUSSERVCTE;
                row.WSINUTILIZACTE = data[0].WSINUTILIZACTE;
                row.WSCONSULTAPROCTE = data[0].WSCONSULTAPROCTE;
            }

            widget.getField('DSSVC').reload().then(function (response) {
                widget.getField('DSSVC').value(data[0].CDSVC);
            });
        }
    };

    this.checarCampoSVC = function (widget) {
        if (widget.getParent().name == 'mdfe' || widget.getParent().name == 'nfce') {
            widget.getField('DSSVC').readOnly = true;
            widget.getField('DSSVC').value('Não se aplica');
            widget.getField('CDSVC').value('0');
        } else {
            widget.getField('DSSVC').readOnly = false;
        }
        templateManager.updateTemplate();
    };

    this.colocarWidgetViewMode = function (widget) {
        var FORM_VIEW = 'widget/form-view.html';
        General.changeWidgetAcessibility(widget.widgets, true);
        widget.edit();
        widget.view();
        if (widget.template !== FORM_VIEW) {
            widget.template = FORM_VIEW;
        }
        widget.getParent().widgets.forEach(function (wid) {
            if (wid.name !== widget.name) wid.enabled = true;
        });

        widget.getParent().getParent().widgets.forEach(function (wid) {
            if (wid.name !== widget.getParent().name) wid.enabled = true;
        });

        templateManager.container.widgets.forEach(function (wid) {
            if (wid.name !== widget.getParent().getParent().name) wid.enabled = true;
        });

        widget.reload();

        templateManager.updateTemplate();
    };

    this.saveData = function (widget) {

        var SGESTADO = templateManager.container.getWidget('ger01200_estado_grid').currentRow.SGESTADO;
        var CDPAIS = templateManager.container.getWidget('ger01200_estado_grid').currentRow.CDPAIS;

        var data = widget.dataSource.data[0];
        var row = widget.currentRow;

        widget.currentRow.SGESTADO = SGESTADO;
        widget.currentRow.CDPAIS = CDPAIS;
        widget.currentRow.IDSERVICO = widget.dataSourceFilter[3].value;
        widget.currentRow.IDAMBIENTE = widget.dataSourceFilter[4].value;
        if (!isNaN(widget.getField('DSSVC').value())) {
            widget.currentRow.CDSVC = widget.getField('DSSVC').value();
        } else widget.currentRow.CDSVC = 0;

        if (data) widget.currentRow.__is_new = false;else {
            widget.currentRow.__is_new = true;
            if (widget.getParent().name != 'nfe') {
                row.WSRECEPCAO = row.WSRETRECEPCAO = row.WSEVENTO = row.WSCONSULTACAD = row.WSSTATUSSERVICO = row.WSINUTILIZACAO = row.WSCONSULTAPRO = row.WSAUTORIZACAO = row.WSRETAUTORIZACAO = row.WSDOWNLOADNF = row.WSCONSULTADEST = null;
            }
            if (widget.getParent().name != 'mdfe') {
                row.WSRECEPCAOMDF = row.WSRETRECEPCAOMDF = row.WSEVENTOMDF = row.WSCONSULTAMDF = row.WSSTATUSSERVMDF = row.WSCONSMDFNAOENCE = null;
            }
            if (widget.getParent().name != 'nfce') {
                row.WSAUTORIZACAONFC = row.WSRETAUTORIZACAONFC = row.WSINUTILIZACAONFC = row.WSEVENTONFC = row.WSSTATUSSERVNFC = row.WSCONSULTANFC = row.WSLINKQRCODENFC = null;
            }
            if (widget.getParent().name != 'cte') {
                row.WSRECEPCAOCTE = row.WSRETRECEPCAOCTE = row.WSEVENTOCTE = row.WSCONSULTACADCTE = row.WSSTATUSSERVCTE = row.WSINUTILIZACTE = row.WSCONSULTAPROCTE = null;
            }
        }

        widget.saveRow().then(function (response) {
            widget.activate();
        });
    };

    this.editMode = function (args) {

        var widget = args.owner.widget;

        var FORM_EDIT = 'widget/form.html';

        if (widget.template !== FORM_EDIT) {
            widget.template = FORM_EDIT;
        }

        widget.edit();

        widget.getParent().widgets.forEach(function (wid) {
            if (wid.name !== widget.name) wid.enabled = false;
        });

        widget.getParent().getParent().widgets.forEach(function (wid) {
            if (wid.name !== widget.getParent().name) wid.enabled = false;
        });

        templateManager.container.widgets.forEach(function (wid) {
            if (wid.name !== templateManager.container.getWidget('webServiceSefazWidget').name) wid.enabled = false;
        });

        templateManager.container.getActiveWidget().getField('DSSVC').reload();
    };

    this.setDataFieldSVC = function (args) {
        templateManager.container.getActiveWidget().getField('DSSVC').reload();
    };

    this.openPopup = function (args) {
        var widget = args.owner.widget.widgets[0];
        widget.dataSourceFilter[2].value = widget.getParent().currentRow.DSSVC;
        ScreenService.openPopup(widget);
        widget.activate();
        widget.reload();
    };

    this.cancelar = function () {
        ScreenService.closePopup();
        templateManager.container.getWidget('webServiceSefazWidget').activate();
    };

    this.editPopup = function (args) {

        var widget = args.owner.widget;

        var FORM_EDIT = 'widget/form.html';

        if (widget.template !== FORM_EDIT) {
            widget.template = FORM_EDIT;
        }

        widget.edit();

        widget.activate();
    };

    this.viewPopUp = function (widgetPai) {
        var widget = widgetPai.widgets[0];
        var row = widget.currentRow;
        var FORM_VIEW = 'widget/form-view.html';
        General.changeWidgetAcessibility(widget.widgets, true);
        widget.view();
        if (widget.template !== FORM_VIEW) {
            widget.template = FORM_VIEW;
        }

        row.IDAMBIENTE = getDataFilterValue(widgetPai, "IDAMBIENTE");
        row.IDSERVICO = getDataFilterValue(widgetPai, "IDSERVICO");
        row.DSSERVICO = widgetPai.getParent().label;
        widget.getField('DSSVC').value(widgetPai.getField('DSSVC').value());
        widget.getField('DSSVC').reload();

        widget.activate();
        templateManager.updateTemplate();
    };

    var getDataFilterValue = function getDataFilterValue(widget, campo) {
        var resultado = null;

        widget.dataSourceFilter.forEach(function (dataFilter) {
            if (dataFilter.name == campo) resultado = dataFilter.value;
        });

        return resultado;
    };

    this.setDataFieldsPopUp = function (args) {
        var widget = args.owner;
        var data = widget.dataSource.data[0];

        if (data) {
            var row = widget.currentRow;

            if (widget.getParent().getParent().name == 'nfe') {
                row.DSWSRECEPCAOSVC = data.DSWSRECEPCAOSVC;
                row.DSWSRETRECEPCAOSVC = data.DSWSRETRECEPCAOSVC;
                row.DSWSEVENTOSVC = data.DSWSEVENTOSVC;
                row.DSWSSTATUSSERVICOSVC = data.DSWSSTATUSSERVICOSVC;
                row.DSWSCONSULTAPROSVC = data.DSWSCONSULTAPROSVC;
                row.DSWSAUTORIZACAOSVC = data.DSWSAUTORIZACAOSVC;
                row.DSWSRETAUTORIZACAOSVC = data.DSWSRETAUTORIZACAOSVC;
            }

            if (widget.getParent().getParent().name == 'cte') {
                row.WSRECEPCAOCTE = data.WSRECEPCAOCTE;
                row.WSRETRECEPCAOCTE = data.WSRETRECEPCAOCTE;
                row.WSCONSULTAPROCTE = data.WSCONSULTAPROCTE;
                row.WSSTATUSSERVCTE = data.WSSTATUSSERVCTE;
                row.WSEVENTOCTE = data.WSEVENTOCTE;
            }
        }
    };

    this.savePopup = function (args) {
        var SGESTADO = templateManager.container.getWidget('ger01200_estado_grid').currentRow.SGESTADO;
        var CDPAIS = templateManager.container.getWidget('ger01200_estado_grid').currentRow.CDPAIS;
        var widget = args.owner.widget;

        var data = widget.dataSource.data[0];
        var row = widget.currentRow;

        if (widget.isValid()) {

            widget.currentRow.IDAMBIENTE = getDataFilterValue(widget, "IDAMBIENTE");

            if (!isNaN(widget.getField('DSSVC').value())) {
                widget.currentRow.CDSVC = widget.getField('DSSVC').value();
            } else widget.currentRow.CDSVC = 0;

            if (data) widget.currentRow.__is_new = false;else {
                widget.currentRow.__is_new = true;
                if (widget.getParent().name != 'nfe') {
                    row.DSWSRECEPCAOSVC = row.DSWSRETRECEPCAOSVC = row.DSWSEVENTOSVC = row.DSWSSTATUSSERVICOSVC = row.DSWSCONSULTAPROSVC = row.DSWSAUTORIZACAOSVC = row.DSWSRETAUTORIZACAOSVC = null;
                }

                if (widget.getParent().name != 'cte') {
                    row.WSRECEPCAOCTE = row.WSRETRECEPCAOCTE = row.WSCONSULTAPROCTE = row.WSSTATUSSERVCTE = row.WSEVENTOCTE = null;
                }
            }

            widget.saveRow().then(function (response) {
                widget.activate();
            });
        }
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('ger01200_estadoController', ger01200_estadoController);
});

/*global Util*/

// FILE: ./assets/js/controllers/zhFavorites.js
var ZeedhiFields = angular.module("ZeedhiFields");

ZeedhiFields.directive('zhNavbarDefaultHeader', function (templateManager, ScreenService, eventAggregator, $compile, ApplicationContext) {
    return {
        restrict: 'C',
        link: function link($scope, element) {
            $scope.favoritesList = [];
            $scope.lastDeletedItem = undefined;

            var favoritesText = 'Favoritos';
            var favoritesAddText = 'Adicionar aos Favoritos';
            var favoritesRemoveText = 'Remover dos Favoritos';
            var favoritesUndoText = 'DESFAZER';

            // TRANSLATE - Adicionar essas variaveis a lista da aplicação (words.jon)
            // var favoritesText = ScreenService.i18n('FAVORITES');
            // var favoritesAddText = ScreenService.i18n('ADD_TO_FAVORITES');
            // var favoritesRemoveText = ScreenService.i18n('REMOVE_FROM_FAVORITES');
            // var favoritesUndoText = ScreenService.i18n('UNDO');

            var favoritesContainer;

            var startHollowCode = '<svg version="1.1" id="Layer_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px" viewBox="0 0 30 30" style="enable-background:new 0 0 30 30;" xml:space="preserve">' + '	<style type="text/css">' + '		.st0{fill:#FFFFFF;}' + '	</style>' + '	<g>' + '		<path class="st0" d="M15,4.21l3.51,7.1l7.84,1.14l-5.67,5.53l1.34,7.81L15,22.1l-7.01,3.69l1.34-7.81l-5.67-5.53l7.84-1.14L15,4.21' + '			 M15,2.21c-0.76,0-1.46,0.43-1.79,1.11l-3.04,6.16l-6.8,0.99c-0.75,0.11-1.38,0.64-1.61,1.36c-0.24,0.72-0.04,1.52,0.51,2.05' + '			l4.92,4.8l-1.16,6.77c-0.13,0.75,0.18,1.51,0.8,1.96c0.35,0.25,0.76,0.38,1.18,0.38c0.32,0,0.64-0.08,0.93-0.23l6.08-3.2l6.08,3.2' + '			c0.29,0.15,0.61,0.23,0.93,0.23c0.41,0,0.83-0.13,1.18-0.38c0.62-0.45,0.92-1.21,0.8-1.96l-1.16-6.77l4.92-4.8' + '			c0.55-0.53,0.74-1.33,0.51-2.05c-0.24-0.72-0.86-1.25-1.61-1.36l-6.8-0.99l-3.04-6.16C16.46,2.64,15.76,2.21,15,2.21L15,2.21z"/>' + '	</g>' + '</svg>';
            var startFilledCode = '<svg version="1.1" id="Layer_1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px" viewBox="0 0 30 30" style="enable-background:new 0 0 30 30;" xml:space="preserve">' + '	<style type="text/css">' + '		.st0{fill:#FFFFFF;}' + '	</style>' + '	<g>' + '		<path class="st0" d="M28.25,11.83c-0.24-0.72-0.86-1.25-1.61-1.36l-6.8-0.99l-3.04-6.16C16.46,2.64,15.76,2.21,15,2.21' + '			s-1.46,0.43-1.79,1.11l-3.04,6.16l-6.8,0.99c-0.75,0.11-1.38,0.64-1.61,1.36c-0.24,0.72-0.04,1.52,0.51,2.05l4.92,4.8l-1.16,6.77' + '			c-0.13,0.75,0.18,1.51,0.8,1.96c0.35,0.25,0.76,0.38,1.18,0.38c0.32,0,0.64-0.08,0.93-0.23l6.08-3.2l6.08,3.2' + '			c0.29,0.15,0.61,0.23,0.93,0.23c0.41,0,0.83-0.13,1.18-0.38c0.62-0.45,0.92-1.21,0.8-1.96l-1.16-6.77l4.92-4.8' + '			C28.29,13.35,28.48,12.56,28.25,11.83z"/>' + '	</g>' + '</svg>';

            function createVisualElements() {
                var headerContainer = $(element).children()[0];
                headerContainer.style.width = 'calc(100% - 50px)';

                favoritesContainer = $('<div class="zh-favorites"></div>').appendTo(element);

                var favoritesButtonElement = $compile('<div class="zh-favorites-button" ng-click="toggleList()">' + '  <div class="zh-favorites-button-star" ng-if="!isFavorited">' + '    ' + startHollowCode + '  </div>' + '  <div class="zh-favorites-button-star" ng-if="isFavorited">' + '    ' + startFilledCode + '  </div>' + '  <div class="zh-favorites-button-text">' + favoritesText + '</div>' + '</div>')($scope);
                var favoritesButton = $(favoritesButtonElement).appendTo(favoritesContainer);

                var favoritesListElement = $compile('<div class="zh-favorites-list" ng-class="{\'opened\': opened}">' + '  <div class="zh-favorites-list-button" ng-if="!isFavorited" ng-click="addToFavorites()">' + favoritesAddText + '</div>' + '  <div class="zh-favorites-list-button" ng-if="isFavorited" ng-click="removeFromFavorites()">' + favoritesRemoveText + '</div>' + '  <div class="zh-favorites-list-undo" ng-show="lastDeletedItem" ng-click="undo()">' + favoritesUndoText + '</div>' + '  <div class="zh-favorites-list-items" ng-show="favoritesList.length > 0">' + '	 <div class="zh-favorites-list-item" ng-repeat="item in favoritesList track by item.id" ng-click="openItem(item)">' + '      {{ item.label }}' + '      <span class="zh-favorites-list-item-delete" data-zh-icon="trash icon-white no-border" ng-click="deleteItem(item, $index, $event)"></span>' + '    </div>' + '  </div>' + '</div>')($scope);
                var favoritesList = $(favoritesListElement).appendTo(favoritesContainer);
            }

            function checkIsFavorited(containerId) {
                var oldIsFavorited = $scope.isFavorited;
                $scope.isFavorited = $scope.favoritesList.findIndex(function (item) {
                    return item.id === containerId;
                }) !== -1;
                if (oldIsFavorited !== $scope.isFavorited) {
                    templateManager.updateTemplate();
                }
            }

            $scope.addToFavorites = function () {
                var item = {
                    id: templateManager.container.id,
                    name: templateManager.container.fileName.split('.json')[0],
                    label: templateManager.container.label
                };
                $scope.favoritesList.push(item);
                $scope.isFavorited = true;
                eventAggregator.publish('ZhFavoritesOnChange', { fullList: $scope.favoritesList, changed: { item: item, status: 'add' } });
            };

            $scope.removeFromFavorites = function () {
                var index = $scope.favoritesList.findIndex(function (item) {
                    return item.id === templateManager.container.id;
                });
                if (index > -1) {
                    var item = $scope.favoritesList.splice(index, 1);
                    $scope.isFavorited = false;
                    eventAggregator.publish('ZhFavoritesOnChange', { fullList: $scope.favoritesList, changed: { item: item, status: 'delete' } });
                }
            };

            $scope.openItem = function (item) {
                ApplicationContext.LibUtilities.openWindow(item.name);
                $scope.opened = false;
            };

            var undoTimeout;

            $scope.deleteItem = function (item, index, event) {
                $scope.favoritesList.splice(index, 1);
                $scope.lastDeletedItem = { item: item, index: index };

                clearTimeout(undoTimeout);
                undoTimeout = setTimeout(function () {
                    $scope.lastDeletedItem = undefined;
                    templateManager.updateTemplate();
                }, 10000);

                eventAggregator.publish('ZhFavoritesOnChange', { fullList: $scope.favoritesList, changed: { item: item, status: 'delete' } });

                if (item.id === templateManager.container.id) {
                    $scope.isFavorited = false;
                }

                event.stopImmediatePropagation();
            };

            $scope.undo = function () {
                if ($scope.lastDeletedItem) {
                    $scope.favoritesList.splice($scope.lastDeletedItem.index, 0, $scope.lastDeletedItem.item);
                }
                $scope.lastDeletedItem = undefined;
            };

            $scope.toggleList = function () {
                $scope.opened = !$scope.opened;
            };

            document.addEventListener('mousedown', function (evt) {
                if ($(favoritesContainer).find(evt.target).length === 0 && $scope.opened) {
                    $scope.opened = false;
                    templateManager.updateTemplate();
                }
            });

            eventAggregator.subscribe(eventAggregator.ON_CONTAINER_OPEN, function (args) {
                checkIsFavorited(args.container.id);
            });

            eventAggregator.subscribe('ZhFavoritesOnLoad', function (favorites) {

                $scope.favoritesList = favorites;
                if (templateManager.container) {
                    checkIsFavorited(templateManager.container.id);
                }
            });

            createVisualElements();
        }
    };
});

// FILE: ./assets/modules/acessorias/assets/js/controllers/Fis01600_Sintegra_Controller.js
var Fis01600_Sintegra_Controller = function Fis01600_Sintegra_Controller(General, ScreenService, Messages_fiscal, ObrigacoesAcessoriasUtil) {

    var self = this;

    self.addAgendamento = function (widget) {
        widget.newRow();
        widget.getField('DTREFINI').isVisible = true;
    };

    self.cancelAgendamento = function (args) {
        General.backOrCancel(args);
        General.changeWidgetAcessibility(args.owner.widget.widgets, true);
        args.owner.widget.getField('DTREFINI').isVisible = true;
    };

    self.editAgendamento = function (widget) {
        General.edit(widget);
        this.periodicidadeOnChange(widget);
    };

    self.saveAgendamento = function (widget) {
        if (widget.isValid()) {
            var d1 = new Date(moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY HH:mm').format('MM/DD/YYYY HH:mm'));
            var d2 = new Date(moment().format('MM/DD/YYYY HH:mm'));

            if (d1.getTime() > d2.getTime()) {
                if ((widget.currentRow.CDINSCESTA == '' || widget.currentRow.CDINSCESTA == null) && widget.currentRow.CDEMPRESA) {
                    widget.currentRow.CDINSCESTA = "T";
                }

                widget.currentRow.NRORG = getLocalVar('NRORG');

                General.callRestEngine('fis_acessorias#/saveAgendamentoSintegra', 'Row', widget.currentRow).then(function (success) {
                    General.changeWidgetAcessibility(widget.widgets, true);
                    ScreenService.showMessage('Agendado com sucesso.');
                    ScreenService.goBack();
                    widget.getField('DTREFINI').isVisible = true;
                    widget.reload();
                }, function (error) {
                    ScreenService.showMessage(error.data.error);
                });
            } else {
                ScreenService.showMessage('A Data de Agendamento deve ser maior que a data atual, e não pode ser igual a hora atual!');
            }
        } else {
            // @todo create messages class
            ScreenService.showMessage("Preencha todos os campos corretamente!");
        }
    };

    self.downloadArquivoAgendado = function (spedWidget) {
        var downloadRoute;
        var fileName;

        if (spedWidget.hasCheckedRows()) {
            var rows = spedWidget.getCheckedRows();
            rows.forEach(function (row) {
                downloadRoute = window.serviceUrls.filter(function (x) {
                    return x.package == 'fis';
                })[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
                fileName = row.NMARQUIVO;

                window.open(downloadRoute + fileName);
            });
        } else {
            var row = spedWidget.currentRow;
            downloadRoute = window.serviceUrls.filter(function (x) {
                return x.package == 'fis';
            })[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
            fileName = row.NMARQUIVO;

            window.open(downloadRoute + fileName);
        }
    };

    self.deleteAgendamento = function (widget) {
        widget.currentRow.NRORG = getLocalVar('NRORG');

        ScreenService.confirmMessage(ScreenService.i18n('Deletar Agendamento?'), 'question', function (success) {
            General.callRestEngine('fis_acessorias#/deleteAgendamentoSintegra', 'Row', widget.currentRow).then(function (success) {
                ScreenService.showMessage('Deletado com sucesso.');
                ScreenService.goBack();
                widget.reload();
            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });
        });
    };

    self.periodicidadeOnChange = function (widget) {
        if (widget.currentRow.IDPERIAGEN == 0) {
            widget.getField('DTREFINI').isVisible = true;
        } else if (widget.currentRow.IDPERIAGEN == 1) {
            widget.getField('DTREFINI').isVisible = false;
            if (widget.currentRow.DTAGENDAMENTO && widget.currentRow.DTAGENDAMENTO != "") {
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').format('DD/MM/YYYY');
            }
        } else if (widget.currentRow.IDPERIAGEN == 2) {
            widget.getField('DTREFINI').isVisible = false;
            if (widget.currentRow.DTAGENDAMENTO && widget.currentRow.DTAGENDAMENTO != "") {
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').subtract(1, 'M').format('DD/MM/YYYY');
            }
        }
        widget.getField('DTREFINI').reload();
    };

    /*
     * Função para a chamada da função de exportação.
     */
    this.exportarSintegra = function (sintegraWidget) {
        if (sintegraWidget.isValid()) {
            var row = sintegraWidget.currentRow;
            var route = "fis#/exportarSintegra";
            var message = Messages_fiscal.EXPORTANDO_SINTEGRA;
            ObrigacoesAcessoriasUtil.exportarArquivo(row, route, message);
        }
    };

    /*
     * Função para alterar a propriedade readOnly dos campos de inscrição,
     * conforme a inserção da empresa.
     */
    this.empresaOnChange = function (sintegraWidget) {
        // Valida inscrição estadual.
        ObrigacoesAcessoriasUtil.empresaOnChange(sintegraWidget);
        // Valida inscrição do substituto.
        this.inscricaoEstadualOnChange(sintegraWidget);
    };

    /*
     * Função para alterar a propriedade readOnly do campo de inscrição do
     * substituto, conforme a inserção da inscrição estadual.
     */
    this.inscricaoEstadualOnChange = function (sintegraWidget) {
        // Variável booleana que é setada como true caso alguma inscrição estadual
        // tenha sido selecionada.
        var inscricaoEstadualIsSelected = !!sintegraWidget.currentRow.CDINSCESTA;
        var inscricaoSubstitutoField = sintegraWidget.getField('CDINSCESTAST');

        // Altera as propriedades do field de inscrição do substituto e
        // reseta seu valor.
        inscricaoSubstitutoField.readOnly = !inscricaoEstadualIsSelected;
        inscricaoSubstitutoField.setValue(null);
        inscricaoSubstitutoField.needReload = true;
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis01600_Sintegra_Controller', Fis01600_Sintegra_Controller);
});

// FILE: ./assets/modules/acessorias/assets/js/controllers/Fis01800_GiaSP_Controller.js
var Fis01800_GiaSP_Controller = function Fis01800_GiaSP_Controller(ScreenService, Messages_fiscal, ObrigacoesAcessoriasUtil, General) {

    var self = this;

    self.addAgendamento = function (widget) {
        widget.newRow();
        widget.getField('DTREFINI').isVisible = true;
    };

    self.cancelAgendamento = function (args) {
        General.backOrCancel(args);
        General.changeWidgetAcessibility(args.owner.widget.widgets, true);
        args.owner.widget.getField('DTREFINI').isVisible = true;
    };

    self.editAgendamento = function (widget) {
        General.edit(widget);
        this.periodicidadeOnChange(widget);
    };

    self.saveAgendamento = function (widget) {
        if (widget.isValid()) {
            var d1 = new Date(moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY HH:mm').format('MM/DD/YYYY HH:mm'));
            var d2 = new Date(moment().format('MM/DD/YYYY HH:mm'));

            if (d1.getTime() > d2.getTime()) {
                if ((widget.currentRow.CDINSCESTA == '' || widget.currentRow.CDINSCESTA == null) && widget.currentRow.CDEMPRESA) {
                    widget.currentRow.CDINSCESTA = "T";
                }

                widget.currentRow.NRORG = getLocalVar('NRORG');

                General.callRestEngine('fis_acessorias#/saveAgendamentoGIASP', 'Row', widget.currentRow).then(function (success) {
                    General.changeWidgetAcessibility(widget.widgets, true);
                    ScreenService.showMessage('Agendado com sucesso.');
                    ScreenService.goBack();
                    widget.getField('DTREFINI').isVisible = true;
                    widget.reload();
                }, function (error) {
                    ScreenService.showMessage(error.data.error);
                });
            } else {
                ScreenService.showMessage('A Data de Agendamento deve ser maior que a data atual, e não pode ser igual a hora atual!');
            }
        } else {
            // @todo create messages class
            ScreenService.showMessage("Preencha todos os campos corretamente!");
        }
    };

    self.downloadArquivoAgendado = function (spedWidget) {
        var downloadRoute;
        var fileName;

        if (spedWidget.hasCheckedRows()) {
            var rows = spedWidget.getCheckedRows();
            rows.forEach(function (row) {
                downloadRoute = window.serviceUrls.filter(function (x) {
                    return x.package == 'fis';
                })[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
                fileName = row.NMARQUIVO;

                window.open(downloadRoute + fileName);
            });
        } else {
            var row = spedWidget.currentRow;
            downloadRoute = window.serviceUrls.filter(function (x) {
                return x.package == 'fis';
            })[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
            fileName = row.NMARQUIVO;

            window.open(downloadRoute + fileName);
        }
    };

    self.deleteAgendamento = function (widget) {
        widget.currentRow.NRORG = getLocalVar('NRORG');

        ScreenService.confirmMessage(ScreenService.i18n('Deletar Agendamento?'), 'question', function (success) {
            General.callRestEngine('fis_acessorias#/deleteAgendamentoGiaSp', 'Row', widget.currentRow).then(function (success) {
                ScreenService.showMessage('Deletado com sucesso.');
                ScreenService.goBack();
                widget.reload();
            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });
        });
    };

    self.periodicidadeOnChange = function (widget) {
        if (widget.currentRow.IDPERIAGEN == 0) {
            widget.getField('DTREFINI').isVisible = true;
        } else if (widget.currentRow.IDPERIAGEN == 1) {
            widget.getField('DTREFINI').isVisible = false;
            if (widget.currentRow.DTAGENDAMENTO && widget.currentRow.DTAGENDAMENTO != "") {
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').format('DD/MM/YYYY');
            }
        } else if (widget.currentRow.IDPERIAGEN == 2) {
            widget.getField('DTREFINI').isVisible = false;
            if (widget.currentRow.DTAGENDAMENTO && widget.currentRow.DTAGENDAMENTO != "") {
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').subtract(1, 'M').format('DD/MM/YYYY');
            }
        }
        widget.getField('DTREFINI').reload();
    };

    /*
     * Função para a chamada da função de exportação.
     */
    this.exportarGia = function (giaspWidget) {
        if (giaspWidget.isValid()) {
            var row = giaspWidget.currentRow;
            var route = "fis#/exportarGiaSp";
            var message = Messages_fiscal.EXPORTANDO_GIA;
            ObrigacoesAcessoriasUtil.exportarArquivo(row, route, message);
        }
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis01800_GiaSP_Controller', Fis01800_GiaSP_Controller);
});

// FILE: ./assets/modules/acessorias/assets/js/controllers/Fis01900_GiaRj_Controller.js
var Fis01900_GiaRj_Controller = function Fis01900_GiaRj_Controller(General, ScreenService, templateManager, Messages_fiscal, ObrigacoesAcessoriasUtil) {

    var self = this;

    self.addAgendamento = function (widget) {
        widget.newRow();
        widget.getField('DTREFINI').isVisible = true;
    };

    self.cancelAgendamento = function (args) {
        General.backOrCancel(args);
        General.changeWidgetAcessibility(args.owner.widget.widgets, true);
        args.owner.widget.getField('DTREFINI').isVisible = true;
    };

    self.editAgendamento = function (widget) {
        General.edit(widget);
        this.periodicidadeOnChange(widget);
    };

    self.saveAgendamento = function (widget) {
        if (widget.isValid()) {
            var d1 = new Date(moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY HH:mm').format('MM/DD/YYYY HH:mm'));
            var d2 = new Date(moment().format('MM/DD/YYYY HH:mm'));

            if (d1.getTime() > d2.getTime()) {
                if ((widget.currentRow.CDINSCESTA == '' || widget.currentRow.CDINSCESTA == null) && widget.currentRow.CDEMPRESA) {
                    widget.currentRow.CDINSCESTA = "T";
                }

                widget.currentRow.NRORG = getLocalVar('NRORG');

                General.callRestEngine('fis_acessorias#/saveAgendamentoGiaRj', 'Row', widget.currentRow).then(function (success) {
                    General.changeWidgetAcessibility(widget.widgets, true);
                    ScreenService.showMessage('Agendado com sucesso.');
                    ScreenService.goBack();
                    widget.getField('DTREFINI').isVisible = true;
                    widget.reload();
                }, function (error) {
                    ScreenService.showMessage(error.data.error);
                });
            } else {
                ScreenService.showMessage('A Data de Agendamento deve ser maior que a data atual, e não pode ser igual a hora atual!');
            }
        } else {
            // @todo create messages class
            ScreenService.showMessage("Preencha todos os campos corretamente!");
        }
    };

    self.downloadArquivoAgendado = function (giaRjWidget) {
        var downloadRoute;
        var fileName;

        if (giaRjWidget.hasCheckedRows()) {
            var rows = giaRjWidget.getCheckedRows();
            rows.forEach(function (row) {
                downloadRoute = window.serviceUrls.filter(function (x) {
                    return x.package == 'fis';
                })[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
                fileName = row.NMARQUIVO;

                window.open(downloadRoute + fileName);
            });
        } else {
            var row = giaRjWidget.currentRow;
            downloadRoute = window.serviceUrls.filter(function (x) {
                return x.package == 'fis';
            })[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
            fileName = row.NMARQUIVO;

            window.open(downloadRoute + fileName);
        }
    };

    self.deleteAgendamento = function (widget) {
        widget.currentRow.NRORG = getLocalVar('NRORG');

        ScreenService.confirmMessage(ScreenService.i18n('Deletar Agendamento?'), 'question', function (success) {
            General.callRestEngine('fis_acessorias#/deleteAgendamentoGiaRj', 'Row', widget.currentRow).then(function (success) {
                ScreenService.showMessage('Deletado com sucesso.');
                ScreenService.goBack();
                widget.reload();
            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });
        });
    };

    self.periodicidadeOnChange = function (widget) {
        if (widget.currentRow.IDPERIAGEN == 0) {
            widget.getField('DTREFINI').isVisible = true;
        } else if (widget.currentRow.IDPERIAGEN == 1) {
            widget.getField('DTREFINI').isVisible = false;
            if (widget.currentRow.DTAGENDAMENTO && widget.currentRow.DTAGENDAMENTO != "") {
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').format('DD/MM/YYYY');
            }
        } else if (widget.currentRow.IDPERIAGEN == 2) {
            widget.getField('DTREFINI').isVisible = false;
            if (widget.currentRow.DTAGENDAMENTO && widget.currentRow.DTAGENDAMENTO != "") {
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').subtract(1, 'M').format('DD/MM/YYYY');
            }
        }
        widget.getField('DTREFINI').reload();
    };

    /**
     * Função para a chamada de Exportação
     */
    self.exportarGiaRj = function (giaRjWidget) {
        // Verifica se todos os campos requeridos estão de fato preenchidos
        if (giaRjWidget.isValid()) {
            // Verifica se a parametrização não foi carregada e verificada
            if (!parametrizacaoWasLoaded(giaRjWidget)) {
                return;
            }
            var parametrosWidget = templateManager.container.getWidget('parametrosGeraisGiaRj');
            // Define propriedades na widget principal com valores dos fields
            // da tab de parametrização
            preenhcerPropriedadesWidgetPrincipal(giaRjWidget, parametrosWidget);
            var row = giaRjWidget.currentRow;
            var route = 'fis#/exportarGiaRj';
            var message = Messages_fiscal.EXPORTANDO_GIA_RJ;
            ObrigacoesAcessoriasUtil.exportarArquivo(row, route, message);
        }
    };
    /**
     * Função auxiliar que verifica se a tab de parametrização foi aberta ao exportar,
     * através da propriedade 'empresasLoaded'.
     */
    var parametrizacaoWasLoaded = function parametrizacaoWasLoaded(giaRjWidget) {
        var parametrizacaoWasLoaded;
        var parametrosWidget;
        var cdEmpresa = giaRjWidget.currentRow.CDEMPRESA;
        parametrosWidget = templateManager.container.getWidget('parametrosGeraisGiaRj');
        // Verifica se a propriedade (CDEMPRESA) está setada para a empresa selecionada
        parametrizacaoWasLoaded = parametrosWidget.empresasLoaded[cdEmpresa];

        // Verifica se a widget de parametrização não foi aberta antes de
        // clicar no botão de exportar
        if (!parametrizacaoWasLoaded) {
            // Muda a propriedade para que a parametrização seja obrigatória
            parametrosWidget.parametersRequired = true;
            // Exibe mensagem indicando a obrigatoriedae da verificação dos parametros
            ScreenService.showMessage(Messages_fiscal.PARAMETROS_GERAIS_NAO_INFORMADOS_ERROR).then(function () {
                // Abre a widget/tab de parâmetros
                openTabParametrosGerais(parametrosWidget);
            });
            // Retorna false, indicando que a parametrização não foi previamente aberta
            return false;
        }
        // Retorna true, caso a parametrização já tenha sido aberta
        return true;
    };
    /**
     * Função auxiliar que abre a tab de parâmetros pela primeira vez.
     */
    var openTabParametrosGerais = function openTabParametrosGerais(parametrosWidget) {
        // Recarrega os dados (dataSource) parametrizados
        parametrosWidget.reload().then(function () {
            // Redesenha os dados carregados na tab
            parametrosWidget.redraw();
        });
        // Define a tab de parametricação como ativa
        parametrosWidget.activate();
    };
    /**
     * Função auxiliar que cria e preenche propriedades da widget principal,
     * com os valores das fields da tab de parâmetros
     */
    var preenhcerPropriedadesWidgetPrincipal = function preenhcerPropriedadesWidgetPrincipal(giaRjWidget, parametrosWidget) {
        giaRjWidget.currentRow.MOVOPPR = parametrosWidget.currentRow.MOVOPPR;
        giaRjWidget.currentRow.MOVST = parametrosWidget.currentRow.MOVST;
        giaRjWidget.currentRow.MOVICMS = parametrosWidget.currentRow.MOVICMS;
        giaRjWidget.currentRow.MOVALC = parametrosWidget.currentRow.MOVALC;
        giaRjWidget.currentRow.VERSAO = parametrosWidget.currentRow.VERSAO;
        giaRjWidget.currentRow.RETIFIC = parametrosWidget.currentRow.RETIFIC;
    };
    /**
     * Função para salvar os parâmetros informados - ou caso eles já existam,
     * apenas os confirmam para a exportação
     */
    self.salvarParametrizacao = function (parametrosWidget) {
        // Verifica se todos os campos requeridos estão de fato preenchidos
        if (parametrosWidget.isValid()) {
            var giaRjWidget = templateManager.container.getWidget('gia-rj');
            preencherCamposAbstratosParaSalvar(parametrosWidget);
            var filter = [{
                "name": "P_CDEMPRESA",
                "operator": "=",
                "value": giaRjWidget.currentRow.CDEMPRESA
            }, {
                "name": "P_CDINSCRICAO",
                "operator": "=",
                "value": parametrosWidget.currentRow.CDINSCRICAO
            }, {
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar('NRORG')
            }];

            General.callRestEngine('fis_acessorias#/crud/paramdeclaces_GiaRj', 'FilterData', filter).then(function (result) {
                result = result.dataset.paramdeclaces_GiaRj;

                if (result.length == 0) parametrosWidget.currentRow.__is_new = true;

                parametrosWidget.saveRow().then(function () {
                    // Seta os parametros como verificados pelo usuário
                    setParametersVerified(parametrosWidget);
                    // Ativa a widget principal
                    giaRjWidget.activate();
                    giaRjWidget.currentWidget = giaRjWidget;
                    /**
                     * Verifica se a tela de parâmetros foi exibida devido a uma tentativa
                     * de exportação. Caso positivo, a exportação é efetuada
                     */
                    if (parametrosWidget.parametersRequired) {
                        self.exportarGiaRj(giaRjWidget);
                        // Valida a propriedade para false, caso a tela de parametros seja
                        // novamente aberta. E assim não haverá exportação sempre ao sair
                        parametrosWidget.parametersRequired = false;
                    }
                });
            });
        }
    };

    var preencherCamposAbstratosParaSalvar = function preencherCamposAbstratosParaSalvar(parametrosWidget) {
        parametrosWidget.currentRow.CDCAMPO1 = parametrosWidget.currentRow.MOVOPPR;
        parametrosWidget.currentRow.CDCAMPO2 = parametrosWidget.currentRow.MOVST;
        parametrosWidget.currentRow.CDCAMPO3 = parametrosWidget.currentRow.MOVICMS;
        parametrosWidget.currentRow.CDCAMPO4 = parametrosWidget.currentRow.MOVALC;
        parametrosWidget.currentRow.CDCAMPO5 = parametrosWidget.currentRow.VERSAO;
        parametrosWidget.currentRow.CDCAMPO6 = parametrosWidget.currentRow.RETIFIC;
    };

    /**
     * Função auxiliar que seta na widget de parâmetros a propriedade indicando
     * que a parametrização foi verificada pelo usuário
     */
    var setParametersVerified = function setParametersVerified(parametrosWidget) {
        var currentRow = parametrosWidget.currentRow;
        var giaRjFiscalIsSelected = parametrosWidget.name == "parametrosGeraisGiaRj";
        if (giaRjFiscalIsSelected) {
            // Verifica se o objeto já foi criado pra esta empresa.
            if (!parametrosWidget.empresasLoaded[currentRow.CDEMPRESA]) {
                parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = {};
            }
            // Seta o parâmetro para a empresa selecionada.
            parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = true;
        } else {
            // Modifica a propriedade indicando que a parametrização foi
            // aberta para a empresa selecionada.
            parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = true;
        }
    };
    /**
     * Função que é invocada após o carregamento do dataSource. Caso é 
     * retornado algo, adiciona à currentRow o primeiro indice de data[] - caso
     * contrário, é setada em forma de newRow;
     */
    self.setLoadedParameters = function (parametrosWidget) {
        var giaRjWidget = templateManager.container.getWidget("gia-rj");
        if (parametrosWidget.dataSource.data.length > 0) {
            // Seta a currentRow como sendo o primeiro indice do data[] retornado
            parametrosWidget.moveToFirst();
            // Redesenha na widget principal, os fields com os valores da nova 
            // currentRow
            parametrosWidget.redraw();
        } else {
            // Seta a widget em modo de novo dado, para inserir a parametrização
            parametrosWidget.newRow();
            parametrosWidget.currentRow.CDEMPRESA = giaRjWidget.currentRow.CDEMPRESA;
        }
        // Seta o nome da empresa no campo select de empresa, devido a um
        // comportamento que não exibe o nome da empresa correspondente ao código.
        parametrosWidget.currentRow.NMEMPRESA = giaRjWidget.currentRow.NMEMPRESA;
    };
    /**
     * Função invocada ao sair da widget de parametros, que seta os mesmos como 
     * verificados
     */
    self.beforeExitParametrosGerais = function (parametrosWidget) {
        // Seta a parametrização como verificada somente se a widget não estiver
        // em modo de inserção, mas sim de verificação
        if (!parametrosWidget.isNewRow()) {
            setParametersVerified(parametrosWidget);
        }
    };
    /**
     * Função que é invocada ao alterar o field CDINSCESTA,
     * alterando a propriedade enable da tab de parâmetros
     */
    self.inscricaoOnChange = function (giaRjWidget) {
        var parametrosWidget = templateManager.container.getWidget('parametrosGeraisGiaRj');
        // Variável booleana que é setada como true, caso alguma inscrição seja 
        // selecionada
        var inscricaoIsSelect = !!giaRjWidget.currentRow.CDINSCESTA;
        parametrosWidget.enabled = inscricaoIsSelect;
    };

    self.setLoadedParametersdeclan = function (parametrosWidget) {
        var declan = templateManager.container.getWidget("DECLAN-IPM");
        if (parametrosWidget.dataSource.data.length > 0) {
            // Seta a currentRow como sendo o primeiro indice do data[] retornado
            parametrosWidget.moveToFirst();
            // Redesenha na widget principal, os fields com os valores da nova 
            // currentRow
            parametrosWidget.redraw();
        } else {
            // Seta a widget em modo de novo dado, para inserir a parametrização
            parametrosWidget.newRow();
            parametrosWidget.currentRow.CDEMPRESA = declan.currentRow.CDEMPRESA;
        }
        // Seta o nome da empresa no campo select de empresa, devido a um
        // comportamento que não exibe o nome da empresa correspondente ao código.
        parametrosWidget.currentRow.NMEMPRESA = declan.currentRow.NMEMPRESA;
    };
    /**
     * Função invocada ao sair da widget de parametros, que seta os mesmos como 
     * verificados
     */
    self.beforeExitParametrosGeraisdeclan = function (parametrosWidget) {
        // Seta a parametrização como verificada somente se a widget não estiver
        // em modo de inserção, mas sim de verificação
        if (!parametrosWidget.isNewRow()) {
            setParametersVerified(parametrosWidget);
        }
    };

    self.inscricaoOnChangedeclan = function (declanWidget) {
        var parametrosWidget = templateManager.container.getWidget('parametrosGeraisdeclan');
        // Variável booleana que é setada como true, caso alguma inscrição seja 
        // selecionada
        var inscricaoIsSelect = !!declanWidget.currentRow.CDINSCESTA;
        parametrosWidget.enabled = inscricaoIsSelect;
    };

    var preencherCamposAbstratosParaSalvardeclan = function preencherCamposAbstratosParaSalvardeclan(parametrosWidget) {
        parametrosWidget.currentRow.CDCAMPO1 = parametrosWidget.currentRow.VERSAO;
        parametrosWidget.currentRow.CDCAMPO2 = parametrosWidget.currentRow.CONTRIBU;
        parametrosWidget.currentRow.DTCAMPO1 = parametrosWidget.currentRow.DTENCER;
        parametrosWidget.currentRow.DTCAMPO2 = parametrosWidget.currentRow.DTINICIO;
        parametrosWidget.currentRow.CDCAMPO3 = parametrosWidget.currentRow.RETIFICA;
        parametrosWidget.currentRow.CDCAMPO4 = parametrosWidget.currentRow.STIDREGISTRO;
    };

    self.salvarParametrizacaodeclan = function (parametrosWidget) {
        // Verifica se todos os campos requeridos estão de fato preenchidos
        if (parametrosWidget.isValid()) {
            var inicial = templateManager.container.getWidget('DECLAN-IPM');
            var declan = templateManager.container.getWidget('parametrosGeraisdeclan');
            declan.currentRow.CDINSCESTA = inicial.currentRow.CDINSCESTA;
            declan.currentRow.DTREFINI = inicial.currentRow.DTREFINI;
            declan.currentRow.NMARQUIVO = inicial.currentRow.NMARQUIVO;
            declan.currentRow.NMLIVROMAG = inicial.currentRow.NMLIVROMAG;
            declan.currentRow.CDEMPRESA = inicial.currentRow.CDEMPRESA;
            declan.currentRow.NMREPRINSEST = inicial.currentRow.NMREPRINSEST;
            declan.currentRow.NRINSJURIEST = inicial.currentRow.NRINSJURIEST;
            declan.currentRow.CDLIVROMAG = inicial.currentRow.CDLIVROMAG;
            declan.currentRow.NRORG = getLocalVar('NRORG');
            preencherCamposAbstratosParaSalvardeclan(parametrosWidget);
            var filter = [{
                "name": "P_CDEMPRESA",
                "operator": "=",
                "value": declan.currentRow.CDEMPRESA
            }, {
                "name": "P_CDINSCRICAO",
                "operator": "=",
                "value": parametrosWidget.currentRow.CDINSCRICAO
            }, {
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar('NRORG')
            }];

            General.callRestEngine('fis_acessorias#/savedeclan', 'Row', declan.currentRow).then(function (success) {
                ScreenService.showMessage('Salvo com sucesso.');
                declan.reload();
            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });
        }
    };

    self.exportardeclan = function (widget) {
        var parametrosWidget = templateManager.container.getWidget('parametrosGeraisdeclan');
        // Define propriedades na widget principal com valores dos fields
        // da tab de parametrização
        var inicial = templateManager.container.getWidget('DECLAN-IPM');
        var declan = templateManager.container.getWidget('parametrosGeraisdeclan');
        preencherCamposAbstratosParaSalvardeclan(declan, parametrosWidget);
        declan.currentRow.CDINSCESTA = inicial.currentRow.CDINSCESTA;
        declan.currentRow.DTREFINI = inicial.currentRow.DTREFINI;
        declan.currentRow.NMARQUIVO = inicial.currentRow.NMARQUIVO;
        declan.currentRow.NMLIVROMAG = inicial.currentRow.NMLIVROMAG;
        declan.currentRow.CDEMPRESA = inicial.currentRow.CDEMPRESA;
        declan.currentRow.NMREPRINSEST = inicial.currentRow.NMREPRINSEST;
        declan.currentRow.NRINSJURIEST = inicial.currentRow.NRINSJURIEST;
        declan.currentRow.CDLIVROMAG = inicial.currentRow.CDLIVROMAG;
        declan.currentRow.NRORG = getLocalVar('NRORG');

        var row = declan.currentRow;
        var route = 'fis_acessorias#/exportardeclan';
        var message = Messages_fiscal.EXPORTANDO_DECLAN;
        ObrigacoesAcessoriasUtil.exportarArquivo(row, route, message);
    };
};
Configuration(function (ContextRegister) {
    ContextRegister.register("Fis01900_GiaRj_Controller", Fis01900_GiaRj_Controller);
});

// FILE: ./assets/modules/acessorias/assets/js/controllers/Fis03000_DapiMg_Controller.js
var Fis03000_DapiMg_Controller = function Fis03000_DapiMg_Controller(ScreenService, General, templateManager, Messages_fiscal, ObrigacoesAcessoriasUtil) {
    var self = this;

    self.addAgendamento = function (widget) {
        widget.newRow();
        widget.getField('DTREFINI').isVisible = true;
    };

    self.cancelAgendamento = function (args) {
        General.backOrCancel(args);
        General.changeWidgetAcessibility(args.owner.widget.widgets, true);
        args.owner.widget.getField('DTREFINI').isVisible = true;
    };

    self.editAgendamento = function (widget) {
        General.edit(widget);
        this.periodicidadeOnChange(widget);
    };

    self.saveAgendamento = function (widget) {
        if (widget.isValid()) {
            var d1 = new Date(moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY HH:mm').format('MM/DD/YYYY HH:mm'));
            var d2 = new Date(moment().format('MM/DD/YYYY HH:mm'));

            if (d1.getTime() > d2.getTime() && d1.getHours() > d2.getHours()) {
                if ((widget.currentRow.CDINSCESTA == '' || widget.currentRow.CDINSCESTA == null) && widget.currentRow.CDEMPRESA) {
                    widget.currentRow.CDINSCESTA = "T";
                }

                widget.currentRow.NRORG = getLocalVar('NRORG');

                General.callRestEngine('fis_acessorias#/saveAgendamentoDapiMg', 'Row', widget.currentRow).then(function (success) {
                    General.changeWidgetAcessibility(widget.widgets, true);
                    ScreenService.showMessage('Agendado com sucesso.');
                    ScreenService.goBack();
                    widget.getField('DTREFINI').isVisible = true;
                    widget.reload();
                }, function (error) {
                    ScreenService.showMessage(error.data.error);
                });
            } else {
                ScreenService.showMessage('A Data de Agendamento deve ser maior que a data atual, e não pode ser igual a hora atual!');
            }
        } else {
            // @todo create messages class
            ScreenService.showMessage("Preencha todos os campos corretamente!");
        }
    };

    self.downloadArquivoAgendado = function (dapiWidget) {
        var downloadRoute;
        var fileName;

        if (dapiWidget.hasCheckedRows()) {
            var rows = dapiWidget.getCheckedRows();
            rows.forEach(function (row) {
                downloadRoute = window.serviceUrls.filter(function (x) {
                    return x.package == 'fis';
                })[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
                fileName = row.NMARQUIVO;

                window.open(downloadRoute + fileName);
            });
        } else {
            var row = dapiWidget.currentRow;
            downloadRoute = window.serviceUrls.filter(function (x) {
                return x.package == 'fis';
            })[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
            fileName = row.NMARQUIVO;

            window.open(downloadRoute + fileName);
        }
    };

    self.deleteAgendamento = function (widget) {
        widget.currentRow.NRORG = getLocalVar('NRORG');

        ScreenService.confirmMessage(ScreenService.i18n('Deletar Agendamento?'), 'question', function (success) {
            General.callRestEngine('fis_acessorias#/deleteAgendamentoDapiMg', 'Row', widget.currentRow).then(function (success) {
                ScreenService.showMessage('Deletado com sucesso.');
                ScreenService.goBack();
                widget.reload();
            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });
        });
    };

    self.periodicidadeOnChange = function (widget) {
        if (widget.currentRow.IDPERIAGEN == 0) {
            widget.getField('DTREFINI').isVisible = true;
        } else if (widget.currentRow.IDPERIAGEN == 1) {
            widget.getField('DTREFINI').isVisible = false;
            if (widget.currentRow.DTAGENDAMENTO && widget.currentRow.DTAGENDAMENTO != "") {
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').format('DD/MM/YYYY');
            }
        } else if (widget.currentRow.IDPERIAGEN == 2) {
            widget.getField('DTREFINI').isVisible = false;
            if (widget.currentRow.DTAGENDAMENTO && widget.currentRow.DTAGENDAMENTO != "") {
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').subtract(1, 'M').format('DD/MM/YYYY');
            }
        }
        widget.getField('DTREFINI').reload();
    };
    /**
     * Função para a chamada de Exportação
     */
    self.exportarDapi = function (dapiWidget) {
        // Verifica se todos os campos requeridos estão de fato preenchidos
        if (dapiWidget.isValid()) {
            // Verifica se a parametrização não foi carregada e verificada
            if (!parametrizacaoWasLoaded(dapiWidget)) {
                return;
            }
            var parametrosWidget = templateManager.container.getWidget('parametrosGeraisDapiMg');
            // Define propriedades na widget principal com valores dos fields
            // da tab de parametrização
            preenhcerPropriedadesWidgetPrincipal(dapiWidget, parametrosWidget);
            var row = dapiWidget.currentRow;
            var route = 'fis#/exportarDapiMg';
            var message = Messages_fiscal.EXPORTANDO_DAPI;
            ObrigacoesAcessoriasUtil.exportarArquivo(row, route, message);
        }
    };
    /**
     * Função auxiliar que verifica se a tab de parametrização foi aberta ao exportar,
     * através da propriedade 'empresasLoaded'.
     */
    var parametrizacaoWasLoaded = function parametrizacaoWasLoaded(dapiWidget) {
        var parametrizacaoWasLoaded;
        var parametrosWidget;
        var cdEmpresa = dapiWidget.currentRow.CDEMPRESA;
        parametrosWidget = templateManager.container.getWidget('parametrosGeraisDapiMg');
        // Verifica se a propriedade (CDEMPRESA) está setada para a empresa selecionada
        parametrizacaoWasLoaded = parametrosWidget.empresasLoaded[cdEmpresa];

        // Verifica se a widget de parametrização não foi aberta antes de
        // clicar no botão de exportar
        if (!parametrizacaoWasLoaded) {
            // Muda a propriedade para que a parametrização seja obrigatória
            parametrosWidget.parametersRequired = true;
            // Exibe mensagem indicando a obrigatoriedae da verificação dos parametros
            ScreenService.showMessage(Messages_fiscal.PARAMETROS_GERAIS_NAO_INFORMADOS_ERROR).then(function () {
                // Abre a widget/tab de parâmetros
                openTabParametrosGerais(parametrosWidget);
            });
            // Retorna false, indicando que a parametrização não foi previamente aberta
            return false;
        }
        // Retorna true, caso a parametrização já tenha sido aberta
        return true;
    };
    /**
     * Função auxiliar que abre a tab de parâmetros pela primeira vez.
     */
    var openTabParametrosGerais = function openTabParametrosGerais(parametrosWidget) {
        // Recarrega os dados (dataSource) parametrizados
        parametrosWidget.reload().then(function () {
            // Redesenha os dados carregados na tab
            parametrosWidget.redraw();
        });
        // Define a tab de parametricação como ativa
        parametrosWidget.activate();
    };
    /**
     * Função auxiliar que cria e preenche propriedades da widget principal,
     * com os valores das fields da tab de parâmetros
     */
    var preenhcerPropriedadesWidgetPrincipal = function preenhcerPropriedadesWidgetPrincipal(dapiWidget, parametrosWidget) {
        dapiWidget.currentRow.CDDESMEMCAE = parametrosWidget.currentRow.CDDESMEMCAE;
        dapiWidget.currentRow.CDDESMEMCNAEF = parametrosWidget.currentRow.CDDESMEMCNAEF;
        dapiWidget.currentRow.CDREGESPRECOLHI = parametrosWidget.currentRow.CDREGESPRECOLHI;
        dapiWidget.currentRow.CDOPTFUND = parametrosWidget.currentRow.CDOPTFUND;
        dapiWidget.currentRow.CDMOVCAFE = parametrosWidget.currentRow.CDMOVCAFE;
        dapiWidget.currentRow.CDDAPIMOV = parametrosWidget.currentRow.CDDAPIMOV;
        dapiWidget.currentRow.CDDAPISUB = parametrosWidget.currentRow.CDDAPISUB;
        dapiWidget.currentRow.CDINDENCERR = parametrosWidget.currentRow.CDINDENCERR;
        dapiWidget.currentRow.DTLIMPAG = parametrosWidget.currentRow.DTLIMPAG;
        dapiWidget.currentRow.CDREGIMREC = parametrosWidget.currentRow.CDREGIMREC;
        dapiWidget.currentRow.CDTERMACEIT = parametrosWidget.currentRow.CDTERMACEIT;
    };
    /**
     * Função para salvar os parâmetros informados - ou caso eles já existam,
     * apenas os confirmam para a exportação
     */
    self.salvarParametrizacao = function (parametrosWidget) {
        // Verifica se todos os campos requeridos estão de fato preenchidos
        if (parametrosWidget.isValid()) {
            var dapiWidget = templateManager.container.getWidget('dapi-mg');
            preencherCamposAbstratosParaSalvar(parametrosWidget);

            var filter = [{
                "name": "P_CDEMPRESA",
                "operator": "=",
                "value": dapiWidget.currentRow.CDEMPRESA
            }, {
                "name": "P_CDINSCRICAO",
                "operator": "=",
                "value": parametrosWidget.currentRow.CDINSCRICAO
            }, {
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar('NRORG')
            }];

            General.callRestEngine('fis_acessorias#/crud/paramdeclaces_DapiMg', 'FilterData', filter).then(function (result) {
                result = result.dataset.paramdeclaces_DapiMg;

                if (result.length != 0) parametrosWidget.currentRow.__is_new = false;

                parametrosWidget.saveRow().then(function () {
                    // Seta os parametros como verificados pelo usuário
                    setParametersVerified(parametrosWidget);
                    // Ativa a widget principal
                    dapiWidget.activate();
                    dapiWidget.currentWidget = dapiWidget;
                    /**
                     * Verifica se a tela de parâmetros foi exibida devido a uma tentativa
                     * de exportação. Caso positivo, a exportação é efetuada
                     */
                    if (parametrosWidget.parametersRequired) {
                        self.exportarDapi(dapiWidget);
                        // Valida a propriedade para false, caso a tela de parametros seja
                        // novamente aberta. E assim não haverá exportação sempre ao sair
                        parametrosWidget.parametersRequired = false;
                    }
                });
            });
        }
    };

    var preencherCamposAbstratosParaSalvar = function preencherCamposAbstratosParaSalvar(parametrosWidget) {
        var dapiWidget = templateManager.container.getWidget('dapi-mg');
        parametrosWidget.currentRow.CDCAMPO1 = dapiWidget.currentRow.CDLIVROMAG;
        parametrosWidget.currentRow.CDCAMPO4 = parametrosWidget.currentRow.CDDESMEMCAE;
        parametrosWidget.currentRow.CDCAMPO5 = parametrosWidget.currentRow.CDDESMEMCNAEF;
        parametrosWidget.currentRow.CDCAMPO6 = parametrosWidget.currentRow.CDREGESPRECOLHI;
        parametrosWidget.currentRow.CDCAMPO7 = parametrosWidget.currentRow.CDOPTFUND;
        parametrosWidget.currentRow.CDCAMPO8 = parametrosWidget.currentRow.CDMOVCAFE;
        parametrosWidget.currentRow.CDCAMPO9 = parametrosWidget.currentRow.CDDAPIMOV;
        parametrosWidget.currentRow.CDCAMPO10 = parametrosWidget.currentRow.CDDAPISUB;
        parametrosWidget.currentRow.CDCAMPO11 = parametrosWidget.currentRow.CDINDENCERR;
        parametrosWidget.currentRow.DTCAMPO1 = parametrosWidget.currentRow.DTLIMPAG;
        parametrosWidget.currentRow.CDCAMPO13 = parametrosWidget.currentRow.CDREGIMREC;
        parametrosWidget.currentRow.CDCAMPO14 = parametrosWidget.currentRow.CDTERMACEIT;
    };
    /**
     * Função auxiliar que seta na widget de parâmetros a propriedade indicando
     * que a parametrização foi verificada pelo usuário
     */
    var setParametersVerified = function setParametersVerified(parametrosWidget) {
        var currentRow = parametrosWidget.currentRow;
        var dapiMgIsSelected = parametrosWidget.name == "parametrosGeraisDapiMg";
        if (dapiMgIsSelected) {
            // Verifica se o objeto já foi criado pra esta empresa.
            if (!parametrosWidget.empresasLoaded[currentRow.CDEMPRESA]) {
                parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = {};
            }
            // Seta o parâmetro para a empresa selecionada.
            parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = true;
        } else {
            // Modifica a propriedade indicando que a parametrização foi
            // aberta para a empresa selecionada.
            parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = true;
        }
    };
    /**
     * Função que é invocada após o carregamento do dataSource. Caso é 
     * retornado algo, adiciona à currentRow o primeiro indice de data[] - caso
     * contrário, é setada em forma de newRow;
     */
    self.setLoadedParameters = function (parametrosWidget) {
        var dapiWidget = templateManager.container.getWidget('dapi-mg');
        if (parametrosWidget.dataSource.data.length > 0) {
            // Seta a currentRow como sendo o primeiro indice do data[] retornado
            parametrosWidget.moveToFirst();
            // Redesenha na widget principal, os fields com os valores da nova 
            // currentRow
            parametrosWidget.redraw();
        } else {
            // Seta a widget em modo de novo dado, para inserir a parametrização
            parametrosWidget.newRow();
            parametrosWidget.currentRow.CDEMPRESA = dapiWidget.currentRow.CDEMPRESA;
        }
        // Seta o nome da empresa no campo select de empresa, devido a um
        // comportamento que não exibe o nome da empresa correspondente ao código.
        parametrosWidget.currentRow.NMEMPRESA = dapiWidget.currentRow.NMEMPRESA;
    };
    /**
     * Função invocada ao sair da widget de parametros, que seta os mesmos como 
     * verificados
     */
    self.beforeExitParametrosGerais = function (parametrosWidget) {
        // Seta a parametrização como verificada somente se a widget não estiver
        // em modo de inserção, mas sim de verificação
        if (!parametrosWidget.isNewRow()) {
            setParametersVerified(parametrosWidget);
        }
    };
    /**
     * Função que é invocada ao alterar o field CDINSCESTA,
     * alterando a propriedade enable da tab de parâmetros
     */
    self.inscricaoOnChange = function (dapiWidget) {
        var parametrosWidget = templateManager.container.getWidget('parametrosGeraisDapiMg');
        // Variável booleana que é setada como true, caso alguma inscrição seja 
        // selecionada
        var inscricaoIsSelect = !!dapiWidget.currentRow.CDINSCESTA;
        parametrosWidget.enabled = inscricaoIsSelect;
    };
};
Configuration(function (ContextRegister) {
    ContextRegister.register("Fis03000_DapiMg_Controller", Fis03000_DapiMg_Controller);
});

// FILE: ./assets/modules/acessorias/assets/js/controllers/Fis04800_LivroEletronico_Controller.js
var Fis04800_LivroEletronico_Controller = function Fis04800_LivroEletronico_Controller(General, ScreenService, Messages_fiscal, ObrigacoesAcessoriasUtil) {

    var self = this;

    self.addAgendamento = function (widget) {
        widget.newRow();
        widget.getField('DTREFINI').isVisible = true;
    };

    self.cancelAgendamento = function (args) {
        General.backOrCancel(args);
        General.changeWidgetAcessibility(args.owner.widget.widgets, true);
        args.owner.widget.getField('DTREFINI').isVisible = true;
    };

    self.editAgendamento = function (widget) {
        General.edit(widget);
        this.periodicidadeOnChange(widget);
    };

    self.saveAgendamento = function (widget) {
        if (widget.isValid()) {
            var d1 = new Date(moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY HH:mm').format('MM/DD/YYYY HH:mm'));
            var d2 = new Date(moment().format('MM/DD/YYYY HH:mm'));

            if (d1.getTime() > d2.getTime()) {
                if ((widget.currentRow.CDINSCESTA == '' || widget.currentRow.CDINSCESTA == null) && widget.currentRow.CDEMPRESA) {
                    widget.currentRow.CDINSCESTA = "T";
                }

                widget.currentRow.NRORG = getLocalVar('NRORG');

                General.callRestEngine('fis_acessorias#/saveAgendamentoLivroEletronico', 'Row', widget.currentRow).then(function (success) {
                    General.changeWidgetAcessibility(widget.widgets, true);
                    ScreenService.showMessage('Agendado com sucesso.');
                    ScreenService.goBack();
                    widget.getField('DTREFINI').isVisible = true;
                    widget.reload();
                }, function (error) {
                    ScreenService.showMessage(error.data.error);
                });
            } else {
                ScreenService.showMessage('A Data de Agendamento deve ser maior que a data atual, e não pode ser igual a hora atual!');
            }
        } else {
            // @todo create messages class
            ScreenService.showMessage("Preencha todos os campos corretamente!");
        }
    };

    self.downloadArquivoAgendado = function (spedWidget) {
        var downloadRoute;
        var fileName;

        if (spedWidget.hasCheckedRows()) {
            var rows = spedWidget.getCheckedRows();
            rows.forEach(function (row) {
                downloadRoute = window.serviceUrls.filter(function (x) {
                    return x.package == 'fis';
                })[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
                fileName = row.NMARQUIVO;

                window.open(downloadRoute + fileName);
            });
        } else {
            var row = spedWidget.currentRow;
            downloadRoute = window.serviceUrls.filter(function (x) {
                return x.package == 'fis';
            })[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
            fileName = row.NMARQUIVO;

            window.open(downloadRoute + fileName);
        }
    };

    self.deleteAgendamento = function (widget) {
        widget.currentRow.NRORG = getLocalVar('NRORG');

        ScreenService.confirmMessage(ScreenService.i18n('Deletar Agendamento?'), 'question', function (success) {
            General.callRestEngine('fis_acessorias#/deleteAgendamentoLivroEletronico', 'Row', widget.currentRow).then(function (success) {
                ScreenService.showMessage('Deletado com sucesso.');
                ScreenService.goBack();
                widget.reload();
            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });
        });
    };

    self.periodicidadeOnChange = function (widget) {
        if (widget.currentRow.IDPERIAGEN == 0) {
            widget.getField('DTREFINI').isVisible = true;
        } else if (widget.currentRow.IDPERIAGEN == 1) {
            widget.getField('DTREFINI').isVisible = false;
            if (widget.currentRow.DTAGENDAMENTO && widget.currentRow.DTAGENDAMENTO != "") {
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').format('DD/MM/YYYY');
            }
        } else if (widget.currentRow.IDPERIAGEN == 2) {
            widget.getField('DTREFINI').isVisible = false;
            if (widget.currentRow.DTAGENDAMENTO && widget.currentRow.DTAGENDAMENTO != "") {
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').subtract(1, 'M').format('DD/MM/YYYY');
            }
        }
        widget.getField('DTREFINI').reload();
    };

    /*
     * Função para a chamada da função de exportação.
     */
    this.exportarLivroEletronico = function (livroEletronicoWidget) {
        if (livroEletronicoWidget.isValid()) {
            var row = livroEletronicoWidget.currentRow;

            // Preenche o VALORSTENTR, caso o mesmo esteja vazio.
            if (livroEletronicoWidget.currentRow.VALORSTENTR == "") livroEletronicoWidget.currentRow.VALORSTENTR = "0";
            // Converte valor do field VALORSTENTR para String.
            livroEletronicoWidget.currentRow.VALORSTENTR = livroEletronicoWidget.currentRow.VALORSTENTR.toString();
            var route = "fis#/exportarLivroEletronico";
            var message = Messages_fiscal.EXPORTANDO_LIVRO_ELETRONICO;
            ObrigacoesAcessoriasUtil.exportarArquivo(row, route, message);
        }
    };

    /*
     * Função para alterar a propriedade readOnly dos campos de inscrição,
     * conforme a inserção da empresa.
     */
    this.empresaOnChange = function (livroEletronicoWidget) {
        // Valida inscrição estadual.
        ObrigacoesAcessoriasUtil.empresaOnChange(livroEletronicoWidget);
        // Valida inscrição do substituto.
        this.inscricaoEstadualOnChange(livroEletronicoWidget);
    };

    /*
     * Função para alterar a propriedade readOnly do campo de inscrição 
     * municipal, conforme a inserção da inscrição estadual.
     */
    this.inscricaoEstadualOnChange = function (livroEletronicoWidget) {
        // Variável booleana que é setada como true caso alguma inscrição estadual
        // tenha sido selecionada.
        var inscricaoEstadualIsSelected = !!livroEletronicoWidget.currentRow.CDINSCESTA;
        var inscricaoMunicipalField = livroEletronicoWidget.getField('CDINSCMUNIC');

        // Altera as propriedades do field de inscrição do substituto e
        // reseta seu valor.
        inscricaoMunicipalField.readOnly = !inscricaoEstadualIsSelected;
        inscricaoMunicipalField.setValue(null);
        inscricaoMunicipalField.needReload = true;
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis04800_LivroEletronico_Controller', Fis04800_LivroEletronico_Controller);
});

// FILE: ./assets/modules/acessorias/assets/js/controllers/Fis05500_Dot_Gi_Icms_Controller.js
var Fis05500_Dot_Gi_Icms_Controller = function Fis05500_Dot_Gi_Icms_Controller(General, ScreenService, templateManager, Messages_fiscal, ObrigacoesAcessoriasUtil) {

    var self = this;

    self.addAgendamento = function (widget) {
        widget.newRow();
        widget.getField('DTREFINI').isVisible = true;
    };

    self.cancelAgendamento = function (args) {
        General.backOrCancel(args);
        General.changeWidgetAcessibility(args.owner.widget.widgets, true);
        args.owner.widget.getField('DTREFINI').isVisible = true;
    };

    self.editAgendamento = function (widget) {
        General.edit(widget);
        this.periodicidadeOnChange(widget);
    };

    self.saveAgendamento = function (widget) {
        if (widget.isValid()) {
            var d1 = new Date(moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY HH:mm').format('MM/DD/YYYY HH:mm'));
            var d2 = new Date(moment().format('MM/DD/YYYY HH:mm'));

            if (d1.getTime() > d2.getTime()) {
                if ((widget.currentRow.CDINSCESTA == '' || widget.currentRow.CDINSCESTA == null) && widget.currentRow.CDEMPRESA) {
                    widget.currentRow.CDINSCESTA = "T";
                }

                widget.currentRow.NRORG = getLocalVar('NRORG');

                General.callRestEngine('fis_acessorias#/saveAgendamentoDotGiIcms', 'Row', widget.currentRow).then(function (success) {
                    General.changeWidgetAcessibility(widget.widgets, true);
                    ScreenService.showMessage('Agendado com sucesso.');
                    ScreenService.goBack();
                    widget.getField('DTREFINI').isVisible = true;
                    widget.reload();
                }, function (error) {
                    ScreenService.showMessage(error.data.error);
                });
            } else {
                ScreenService.showMessage('A Data de Agendamento deve ser maior que a data atual, e não pode ser igual a hora atual!');
            }
        } else {
            // @todo create messages class
            ScreenService.showMessage("Preencha todos os campos corretamente!");
        }
    };

    self.downloadArquivoAgendado = function (dotGiIcmsWidget) {
        var downloadRoute;
        var fileName;

        if (dotGiIcmsWidget.hasCheckedRows()) {
            var rows = dotGiIcmsWidget.getCheckedRows();
            rows.forEach(function (row) {
                downloadRoute = window.serviceUrls.filter(function (x) {
                    return x.package == 'fis';
                })[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
                fileName = row.NMARQUIVO;

                window.open(downloadRoute + fileName);
            });
        } else {
            var row = dotGiIcmsWidget.currentRow;
            downloadRoute = window.serviceUrls.filter(function (x) {
                return x.package == 'fis';
            })[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
            fileName = row.NMARQUIVO;

            window.open(downloadRoute + fileName);
        }
    };

    self.deleteAgendamento = function (widget) {
        widget.currentRow.NRORG = getLocalVar('NRORG');

        ScreenService.confirmMessage(ScreenService.i18n('Deletar Agendamento?'), 'question', function (success) {
            General.callRestEngine('fis_acessorias#/deleteAgendamentoDotGiIcms', 'Row', widget.currentRow).then(function (success) {
                ScreenService.showMessage('Deletado com sucesso.');
                ScreenService.goBack();
                widget.reload();
            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });
        });
    };

    self.periodicidadeOnChange = function (widget) {
        if (widget.currentRow.IDPERIAGEN == 0) {
            widget.getField('DTREFINI').isVisible = true;
        } else if (widget.currentRow.IDPERIAGEN == 1) {
            widget.getField('DTREFINI').isVisible = false;
            if (widget.currentRow.DTAGENDAMENTO && widget.currentRow.DTAGENDAMENTO != "") {
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').format('DD/MM/YYYY');
            }
        } else if (widget.currentRow.IDPERIAGEN == 2) {
            widget.getField('DTREFINI').isVisible = false;
            if (widget.currentRow.DTAGENDAMENTO && widget.currentRow.DTAGENDAMENTO != "") {
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').subtract(1, 'M').format('DD/MM/YYYY');
            }
        }
        widget.getField('DTREFINI').reload();
    };

    /**
     * Função para a chamada de Exportação
     */
    self.exportarDotGiIcms = function (dotGiIcmsWidget) {
        // Verifica se todos os campos requeridos estão de fato preenchidos
        if (dotGiIcmsWidget.isValid()) {
            var row = dotGiIcmsWidget.currentRow;
            var route = 'fis#/exportarDotGiIcms';
            var message = Messages_fiscal.EXPORTANDO_DOT_GI_ICMS;
            ObrigacoesAcessoriasUtil.exportarArquivo(row, route, message);
        }
    };
};
Configuration(function (ContextRegister) {
    ContextRegister.register("Fis05500_Dot_Gi_Icms_Controller", Fis05500_Dot_Gi_Icms_Controller);
});

// FILE: ./assets/modules/acessorias/assets/js/controllers/Fis05700_GiIcms_Controller.js
var Fis05700_GiIcms_Controller = function Fis05700_GiIcms_Controller(General, ScreenService, templateManager, Messages_fiscal, ObrigacoesAcessoriasUtil) {

    var self = this;

    self.addAgendamento = function (widget) {
        widget.newRow();
        widget.getField('DTREFINI').isVisible = true;
    };

    self.cancelAgendamento = function (args) {
        General.backOrCancel(args);
        General.changeWidgetAcessibility(args.owner.widget.widgets, true);
        args.owner.widget.getField('DTREFINI').isVisible = true;
    };

    self.editAgendamento = function (widget) {
        General.edit(widget);
        this.periodicidadeOnChange(widget);
    };

    self.saveAgendamento = function (widget) {
        if (widget.isValid()) {
            var d1 = new Date(moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY HH:mm').format('MM/DD/YYYY HH:mm'));
            var d2 = new Date(moment().format('MM/DD/YYYY HH:mm'));

            if (d1.getTime() > d2.getTime()) {
                if ((widget.currentRow.CDINSCESTA == '' || widget.currentRow.CDINSCESTA == null) && widget.currentRow.CDEMPRESA) {
                    widget.currentRow.CDINSCESTA = "T";
                }

                widget.currentRow.NRORG = getLocalVar('NRORG');

                General.callRestEngine('fis_acessorias#/saveAgendamentoGiIcms', 'Row', widget.currentRow).then(function (success) {
                    General.changeWidgetAcessibility(widget.widgets, true);
                    ScreenService.showMessage('Agendado com sucesso.');
                    ScreenService.goBack();
                    widget.getField('DTREFINI').isVisible = true;
                    widget.reload();
                }, function (error) {
                    ScreenService.showMessage(error.data.error);
                });
            } else {
                ScreenService.showMessage('A Data de Agendamento deve ser maior que a data atual, e não pode ser igual a hora atual!');
            }
        } else {
            // @todo create messages class
            ScreenService.showMessage("Preencha todos os campos corretamente!");
        }
    };

    self.downloadArquivoAgendado = function (giIcmsWidget) {
        var downloadRoute;
        var fileName;

        if (giIcmsWidget.hasCheckedRows()) {
            var rows = giIcmsWidget.getCheckedRows();
            rows.forEach(function (row) {
                downloadRoute = window.serviceUrls.filter(function (x) {
                    return x.package == 'fis';
                })[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
                fileName = row.NMARQUIVO;

                window.open(downloadRoute + fileName);
            });
        } else {
            var row = giIcmsWidget.currentRow;
            downloadRoute = window.serviceUrls.filter(function (x) {
                return x.package == 'fis';
            })[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
            fileName = row.NMARQUIVO;

            window.open(downloadRoute + fileName);
        }
    };

    self.deleteAgendamento = function (widget) {
        widget.currentRow.NRORG = getLocalVar('NRORG');

        ScreenService.confirmMessage(ScreenService.i18n('Deletar Agendamento?'), 'question', function (success) {
            General.callRestEngine('fis_acessorias#/deleteAgendamentoGiIcms', 'Row', widget.currentRow).then(function (success) {
                ScreenService.showMessage('Deletado com sucesso.');
                ScreenService.goBack();
                widget.reload();
            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });
        });
    };

    self.periodicidadeOnChange = function (widget) {
        if (widget.currentRow.IDPERIAGEN == 0) {
            widget.getField('DTREFINI').isVisible = true;
        } else if (widget.currentRow.IDPERIAGEN == 1) {
            widget.getField('DTREFINI').isVisible = false;
            if (widget.currentRow.DTAGENDAMENTO && widget.currentRow.DTAGENDAMENTO != "") {
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').format('DD/MM/YYYY');
            }
        } else if (widget.currentRow.IDPERIAGEN == 2) {
            widget.getField('DTREFINI').isVisible = false;
            if (widget.currentRow.DTAGENDAMENTO && widget.currentRow.DTAGENDAMENTO != "") {
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').subtract(1, 'M').format('DD/MM/YYYY');
            }
        }
        widget.getField('DTREFINI').reload();
    };

    /**
     * Função para a chamada de Exportação
     */
    self.exportarGiIcms = function (giIcmsWidget) {
        // Verifica se todos os campos requeridos estão de fato preenchidos
        if (giIcmsWidget.isValid()) {
            // Verifica se a parametrização não foi carregada e verificada
            if (!parametrizacaoWasLoaded(giIcmsWidget)) {
                return;
            }
            var parametrosWidget = templateManager.container.getWidget('parametrosGeraisGiIcms');
            // Define propriedades na widget principal com valores dos fields
            // da tab de parametrização
            preenhcerPropriedadesWidgetPrincipal(giIcmsWidget, parametrosWidget);
            var row = giIcmsWidget.currentRow;
            var route = 'fis#/exportarGiIcms';
            var message = Messages_fiscal.EXPORTANDO_GI_ICMS;
            ObrigacoesAcessoriasUtil.exportarArquivo(row, route, message);
        }
    };
    /**
     * Função auxiliar que verifica se a tab de parametrização foi aberta ao exportar,
     * através da propriedade 'empresasLoaded'.
     */
    var parametrizacaoWasLoaded = function parametrizacaoWasLoaded(giIcmsWidget) {
        var parametrizacaoWasLoaded;
        var parametrosWidget;
        var cdEmpresa = giIcmsWidget.currentRow.CDEMPRESA;
        parametrosWidget = templateManager.container.getWidget('parametrosGeraisGiIcms');
        // Verifica se a propriedade (CDEMPRESA) está setada para a empresa selecionada
        parametrizacaoWasLoaded = parametrosWidget.empresasLoaded[cdEmpresa];

        // Verifica se a widget de parametrização não foi aberta antes de
        // clicar no botão de exportar
        if (!parametrizacaoWasLoaded) {
            // Muda a propriedade para que a parametrização seja obrigatória
            parametrosWidget.parametersRequired = true;
            // Exibe mensagem indicando a obrigatoriedae da verificação dos parametros
            ScreenService.showMessage(Messages_fiscal.PARAMETROS_GERAIS_NAO_INFORMADOS_ERROR).then(function () {
                // Abre a widget/tab de parâmetros
                openTabParametrosGerais(parametrosWidget);
            });
            // Retorna false, indicando que a parametrização não foi previamente aberta
            return false;
        }
        // Retorna true, caso a parametrização já tenha sido aberta
        return true;
    };
    /**
     * Função auxiliar que abre a tab de parâmetros pela primeira vez.
     */
    var openTabParametrosGerais = function openTabParametrosGerais(parametrosWidget) {
        // Recarrega os dados (dataSource) parametrizados
        parametrosWidget.reload().then(function () {
            // Redesenha os dados carregados na tab
            parametrosWidget.redraw();
        });
        // Define a tab de parametricação como ativa
        parametrosWidget.activate();
    };
    /**
     * Função auxiliar que cria e preenche propriedades da widget principal,
     * com os valores das fields da tab de parâmetros
     */
    var preenhcerPropriedadesWidgetPrincipal = function preenhcerPropriedadesWidgetPrincipal(giIcmsWidget, parametrosWidget) {
        giIcmsWidget.currentRow.CDDECLARACAO = parametrosWidget.currentRow.CDDECLARACAO;
        giIcmsWidget.currentRow.CDSITUACAO = parametrosWidget.currentRow.CDSITUACAO;
        giIcmsWidget.currentRow.CFDF = parametrosWidget.currentRow.CFDF;
    };
    /**
     * Função para salvar os parâmetros informados - ou caso eles já existam,
     * apenas os confirmam para a exportação
     */
    self.salvarParametrizacao = function (parametrosWidget) {
        // Verifica se todos os campos requeridos estão de fato preenchidos
        if (parametrosWidget.isValid()) {
            var giIcmsWidget = templateManager.container.getWidget('gi-icms');
            preencherCamposAbstratosParaSalvar(parametrosWidget);
            var filter = [{
                "name": "P_CDEMPRESA",
                "operator": "=",
                "value": giIcmsWidget.currentRow.CDEMPRESA
            }, {
                "name": "P_CDINSCRICAO",
                "operator": "=",
                "value": parametrosWidget.currentRow.CDINSCRICAO
            }, {
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar('NRORG')
            }];

            General.callRestEngine('fis_acessorias#/crud/paramdeclaces_GiIcms', 'FilterData', filter).then(function (result) {
                result = result.dataset.paramdeclaces_GiIcms;

                if (result.length == 0) parametrosWidget.currentRow.__is_new = true;

                parametrosWidget.saveRow().then(function () {
                    // Seta os parametros como verificados pelo usuário
                    setParametersVerified(parametrosWidget);
                    // Ativa a widget principal
                    giIcmsWidget.activate();
                    giIcmsWidget.currentWidget = giIcmsWidget;
                    /**
                     * Verifica se a tela de parâmetros foi exibida devido a uma tentativa
                     * de exportação. Caso positivo, a exportação é efetuada
                     */
                    if (parametrosWidget.parametersRequired) {
                        self.exportarGiIcms(giIcmsWidget);
                        // Valida a propriedade para false, caso a tela de parametros seja
                        // novamente aberta. E assim não haverá exportação sempre ao sair
                        parametrosWidget.parametersRequired = false;
                    }
                });
            });
        }
    };

    var preencherCamposAbstratosParaSalvar = function preencherCamposAbstratosParaSalvar(parametrosWidget) {
        parametrosWidget.currentRow.CDCAMPO1 = parametrosWidget.currentRow.CDDECLARACAO;
        parametrosWidget.currentRow.CDCAMPO2 = parametrosWidget.currentRow.CDSITUACAO;
        parametrosWidget.currentRow.CDCAMPO3 = parametrosWidget.currentRow.CFDF;
    };

    /**
     * Função auxiliar que seta na widget de parâmetros a propriedade indicando
     * que a parametrização foi verificada pelo usuário
     */
    var setParametersVerified = function setParametersVerified(parametrosWidget) {
        var currentRow = parametrosWidget.currentRow;
        var giIcmsFiscalIsSelected = parametrosWidget.name == "parametrosGeraisGiIcms";
        if (giIcmsFiscalIsSelected) {
            // Verifica se o objeto já foi criado pra esta empresa.
            if (!parametrosWidget.empresasLoaded[currentRow.CDEMPRESA]) {
                parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = {};
            }
            // Seta o parâmetro para a empresa selecionada.
            parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = true;
        } else {
            // Modifica a propriedade indicando que a parametrização foi
            // aberta para a empresa selecionada.
            parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = true;
        }
    };
    /**
     * Função que é invocada após o carregamento do dataSource. Caso é 
     * retornado algo, adiciona à currentRow o primeiro indice de data[] - caso
     * contrário, é setada em forma de newRow;
     */
    self.setLoadedParameters = function (parametrosWidget) {
        var giIcmsWidget = templateManager.container.getWidget("gi-icms");
        if (parametrosWidget.dataSource.data.length > 0) {
            // Seta a currentRow como sendo o primeiro indice do data[] retornado
            parametrosWidget.moveToFirst();
            // Redesenha na widget principal, os fields com os valores da nova 
            // currentRow
            parametrosWidget.redraw();
        } else {
            // Seta a widget em modo de novo dado, para inserir a parametrização
            parametrosWidget.newRow();
            parametrosWidget.currentRow.CDEMPRESA = giIcmsWidget.currentRow.CDEMPRESA;
        }
        // Seta o nome da empresa no campo select de empresa, devido a um
        // comportamento que não exibe o nome da empresa correspondente ao código.
        parametrosWidget.currentRow.NMEMPRESA = giIcmsWidget.currentRow.NMEMPRESA;
    };
    /**
     * Função invocada ao sair da widget de parametros, que seta os mesmos como 
     * verificados
     */
    self.beforeExitParametrosGerais = function (parametrosWidget) {
        // Seta a parametrização como verificada somente se a widget não estiver
        // em modo de inserção, mas sim de verificação
        if (!parametrosWidget.isNewRow()) {
            setParametersVerified(parametrosWidget);
        }
    };
    /**
     * Função que é invocada ao alterar o field CDINSCESTA,
     * alterando a propriedade enable da tab de parâmetros
     */
    self.inscricaoOnChange = function (giIcmsWidget) {
        var parametrosWidget = templateManager.container.getWidget('parametrosGeraisGiIcms');
        // Variável booleana que é setada como true, caso alguma inscrição seja 
        // selecionada
        var inscricaoIsSelect = !!giIcmsWidget.currentRow.CDINSCESTA;
        parametrosWidget.enabled = inscricaoIsSelect;
    };
};
Configuration(function (ContextRegister) {
    ContextRegister.register("Fis05700_GiIcms_Controller", Fis05700_GiIcms_Controller);
});

// FILE: ./assets/modules/acessorias/assets/js/controllers/Fis06200_DimeSc_Controller.js
var Fis06200_DimeSc_Controller = function Fis06200_DimeSc_Controller(General, ScreenService, templateManager, Messages_fiscal, ObrigacoesAcessoriasUtil) {

    var self = this;

    self.addAgendamento = function (widget) {
        widget.newRow();
        widget.getField('DTREFINI').isVisible = true;
    };

    self.cancelAgendamento = function (args) {
        General.backOrCancel(args);
        General.changeWidgetAcessibility(args.owner.widget.widgets, true);
        args.owner.widget.getField('DTREFINI').isVisible = true;
    };

    self.editAgendamento = function (widget) {
        General.edit(widget);
        this.periodicidadeOnChange(widget);
    };

    self.saveAgendamento = function (widget) {
        if (widget.isValid()) {
            var d1 = new Date(moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY HH:mm').format('MM/DD/YYYY HH:mm'));
            var d2 = new Date(moment().format('MM/DD/YYYY HH:mm'));

            if (d1.getTime() > d2.getTime()) {
                if ((widget.currentRow.CDINSCESTA == '' || widget.currentRow.CDINSCESTA == null) && widget.currentRow.CDEMPRESA) {
                    widget.currentRow.CDINSCESTA = "T";
                }

                widget.currentRow.NRORG = getLocalVar('NRORG');

                General.callRestEngine('fis_acessorias#/saveAgendamentoDimeSc', 'Row', widget.currentRow).then(function (success) {
                    General.changeWidgetAcessibility(widget.widgets, true);
                    ScreenService.showMessage('Agendado com sucesso.');
                    ScreenService.goBack();
                    widget.getField('DTREFINI').isVisible = true;
                    widget.reload();
                }, function (error) {
                    ScreenService.showMessage(error.data.error);
                });
            } else {
                ScreenService.showMessage('A Data de Agendamento deve ser maior que a data atual, e não pode ser igual a hora atual!');
            }
        } else {
            // @todo create messages class
            ScreenService.showMessage("Preencha todos os campos corretamente!");
        }
    };

    self.downloadArquivoAgendado = function (dimeScWidget) {
        var downloadRoute;
        var fileName;

        if (dimeScWidget.hasCheckedRows()) {
            var rows = dimeScWidget.getCheckedRows();
            rows.forEach(function (row) {
                downloadRoute = window.serviceUrls.filter(function (x) {
                    return x.package == 'fis';
                })[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
                fileName = row.NMARQUIVO;

                window.open(downloadRoute + fileName);
            });
        } else {
            var row = dimeScWidget.currentRow;
            downloadRoute = window.serviceUrls.filter(function (x) {
                return x.package == 'fis';
            })[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
            fileName = row.NMARQUIVO;

            window.open(downloadRoute + fileName);
        }
    };

    self.deleteAgendamento = function (widget) {
        widget.currentRow.NRORG = getLocalVar('NRORG');

        ScreenService.confirmMessage(ScreenService.i18n('Deletar Agendamento?'), 'question', function (success) {
            General.callRestEngine('fis_acessorias#/deleteAgendamentoDimeSc', 'Row', widget.currentRow).then(function (success) {
                ScreenService.showMessage('Deletado com sucesso.');
                ScreenService.goBack();
                widget.reload();
            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });
        });
    };

    self.periodicidadeOnChange = function (widget) {
        if (widget.currentRow.IDPERIAGEN == 0) {
            widget.getField('DTREFINI').isVisible = true;
        } else if (widget.currentRow.IDPERIAGEN == 1) {
            widget.getField('DTREFINI').isVisible = false;
            if (widget.currentRow.DTAGENDAMENTO && widget.currentRow.DTAGENDAMENTO != "") {
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').format('DD/MM/YYYY');
            }
        } else if (widget.currentRow.IDPERIAGEN == 2) {
            widget.getField('DTREFINI').isVisible = false;
            if (widget.currentRow.DTAGENDAMENTO && widget.currentRow.DTAGENDAMENTO != "") {
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').subtract(1, 'M').format('DD/MM/YYYY');
            }
        }
        widget.getField('DTREFINI').reload();
    };

    /**
     * Função para a chamada de Exportação
     */
    self.exportarDimeSc = function (dimeScWidget) {
        // Verifica se todos os campos requeridos estão de fato preenchidos
        if (dimeScWidget.isValid()) {
            // Verifica se a parametrização não foi carregada e verificada
            if (!parametrizacaoWasLoaded(dimeScWidget)) {
                return;
            }
            var parametrosWidget = templateManager.container.getWidget('parametrosGeraisDimeSc');
            // Define propriedades na widget principal com valores dos fields
            // da tab de parametrização
            preenhcerPropriedadesWidgetPrincipal(dimeScWidget, parametrosWidget);
            var row = dimeScWidget.currentRow;
            var route = 'fis#/exportarDimeSc';
            var message = Messages_fiscal.EXPORTANDO_DIME_SC;
            ObrigacoesAcessoriasUtil.exportarArquivo(row, route, message);
        }
    };
    /**
     * Função auxiliar que verifica se a tab de parametrização foi aberta ao exportar,
     * através da propriedade 'empresasLoaded'.
     */
    var parametrizacaoWasLoaded = function parametrizacaoWasLoaded(dimeScWidget) {
        var parametrizacaoWasLoaded;
        var parametrosWidget;
        var cdEmpresa = dimeScWidget.currentRow.CDEMPRESA;
        parametrosWidget = templateManager.container.getWidget('parametrosGeraisDimeSc');
        // Verifica se a propriedade (CDEMPRESA) está setada para a empresa selecionada
        parametrizacaoWasLoaded = parametrosWidget.empresasLoaded[cdEmpresa];

        // Verifica se a widget de parametrização não foi aberta antes de
        // clicar no botão de exportar
        if (!parametrizacaoWasLoaded) {
            // Muda a propriedade para que a parametrização seja obrigatória
            parametrosWidget.parametersRequired = true;
            // Exibe mensagem indicando a obrigatoriedae da verificação dos parametros
            ScreenService.showMessage(Messages_fiscal.PARAMETROS_GERAIS_NAO_INFORMADOS_ERROR).then(function () {
                // Abre a widget/tab de parâmetros
                openTabParametrosGerais(parametrosWidget);
            });
            // Retorna false, indicando que a parametrização não foi previamente aberta
            return false;
        }
        // Retorna true, caso a parametrização já tenha sido aberta
        return true;
    };
    /**
     * Função auxiliar que abre a tab de parâmetros pela primeira vez.
     */
    var openTabParametrosGerais = function openTabParametrosGerais(parametrosWidget) {
        // Recarrega os dados (dataSource) parametrizados
        parametrosWidget.reload().then(function () {
            // Redesenha os dados carregados na tab
            parametrosWidget.redraw();
        });
        // Define a tab de parametricação como ativa
        parametrosWidget.activate();
    };
    /**
     * Função auxiliar que cria e preenche propriedades da widget principal,
     * com os valores das fields da tab de parâmetros
     */
    var preenhcerPropriedadesWidgetPrincipal = function preenhcerPropriedadesWidgetPrincipal(dimeScWidget, parametrosWidget) {
        dimeScWidget.currentRow.STCLASSE = parametrosWidget.currentRow.STCLASSE;
        dimeScWidget.currentRow.STNUMTRAB = parametrosWidget.currentRow.STNUMTRAB;
        dimeScWidget.currentRow.STTIPODECLARACAO = parametrosWidget.currentRow.STTIPODECLARACAO;
        dimeScWidget.currentRow.STTIPOREGIME = parametrosWidget.currentRow.STTIPOREGIME;
        dimeScWidget.currentRow.STCONSOLIDADA = parametrosWidget.currentRow.STCONSOLIDADA;
        dimeScWidget.currentRow.STCENTRALIZADA = parametrosWidget.currentRow.STCENTRALIZADA;
        dimeScWidget.currentRow.STMOVIMENTO = parametrosWidget.currentRow.STMOVIMENTO;
        dimeScWidget.currentRow.STTRIBUTARIO = parametrosWidget.currentRow.STTRIBUTARIO;
        dimeScWidget.currentRow.STESCCONTABIL = parametrosWidget.currentRow.STESCCONTABIL;
        dimeScWidget.currentRow.STINCFISCAL = parametrosWidget.currentRow.STINCFISCAL;
        dimeScWidget.currentRow.STGERINVENTARIO = parametrosWidget.currentRow.STGERINVENTARIO;
        dimeScWidget.currentRow.STTPATIVIDADE = parametrosWidget.currentRow.STTPATIVIDADE;
    };
    /**
     * Função para salvar os parâmetros informados - ou caso eles já existam,
     * apenas os confirmam para a exportação
     */
    self.salvarParametrizacao = function (parametrosWidget) {
        // Verifica se todos os campos requeridos estão de fato preenchidos
        if (parametrosWidget.isValid()) {
            var dimeScWidget = templateManager.container.getWidget('dime-sc');
            preencherCamposAbstratosParaSalvar(parametrosWidget);
            var filter = [{
                "name": "P_CDEMPRESA",
                "operator": "=",
                "value": dimeScWidget.currentRow.CDEMPRESA
            }, {
                "name": "P_CDINSCRICAO",
                "operator": "=",
                "value": parametrosWidget.currentRow.CDINSCRICAO
            }, {
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar('NRORG')
            }];

            General.callRestEngine('fis_acessorias#/crud/paramdeclaces_DimeSc', 'FilterData', filter).then(function (result) {
                result = result.dataset.paramdeclaces_DimeSc;

                if (result.length == 0) parametrosWidget.currentRow.__is_new = true;

                parametrosWidget.saveRow().then(function () {
                    // Seta os parametros como verificados pelo usuário
                    setParametersVerified(parametrosWidget);
                    // Ativa a widget principal
                    dimeScWidget.activate();
                    dimeScWidget.currentWidget = dimeScWidget;
                    /**
                     * Verifica se a tela de parâmetros foi exibida devido a uma tentativa
                     * de exportação. Caso positivo, a exportação é efetuada
                     */
                    if (parametrosWidget.parametersRequired) {
                        self.exportarDimeSc(dimeScWidget);
                        // Valida a propriedade para false, caso a tela de parametros seja
                        // novamente aberta. E assim não haverá exportação sempre ao sair
                        parametrosWidget.parametersRequired = false;
                    }
                });
            });
        }
    };

    var preencherCamposAbstratosParaSalvar = function preencherCamposAbstratosParaSalvar(parametrosWidget) {
        parametrosWidget.currentRow.CDCAMPO1 = parametrosWidget.currentRow.STCLASSE;
        parametrosWidget.currentRow.CDCAMPO2 = parametrosWidget.currentRow.STNUMTRAB;
        parametrosWidget.currentRow.CDCAMPO3 = parametrosWidget.currentRow.STTIPODECLARACAO;
        parametrosWidget.currentRow.CDCAMPO4 = parametrosWidget.currentRow.STTIPOREGIME;
        parametrosWidget.currentRow.CDCAMPO5 = parametrosWidget.currentRow.STCONSOLIDADA;
        parametrosWidget.currentRow.CDCAMPO6 = parametrosWidget.currentRow.STCENTRALIZADA;
        parametrosWidget.currentRow.CDCAMPO7 = parametrosWidget.currentRow.STMOVIMENTO;
        parametrosWidget.currentRow.CDCAMPO8 = parametrosWidget.currentRow.STTRIBUTARIO;
        parametrosWidget.currentRow.CDCAMPO9 = parametrosWidget.currentRow.STESCCONTABIL;
        parametrosWidget.currentRow.CDCAMPO10 = parametrosWidget.currentRow.STINCFISCAL;
        parametrosWidget.currentRow.CDCAMPO12 = parametrosWidget.currentRow.STGERINVENTARIO;
        parametrosWidget.currentRow.CDCAMPO13 = parametrosWidget.currentRow.STTPATIVIDADE;
    };

    /**
     * Função auxiliar que seta na widget de parâmetros a propriedade indicando
     * que a parametrização foi verificada pelo usuário
     */
    var setParametersVerified = function setParametersVerified(parametrosWidget) {
        var currentRow = parametrosWidget.currentRow;
        var dimeScFiscalIsSelected = parametrosWidget.name == "parametrosGeraisDimeSc";
        if (dimeScFiscalIsSelected) {
            // Verifica se o objeto já foi criado pra esta empresa.
            if (!parametrosWidget.empresasLoaded[currentRow.CDEMPRESA]) {
                parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = {};
            }
            // Seta o parâmetro para a empresa selecionada.
            parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = true;
        } else {
            // Modifica a propriedade indicando que a parametrização foi
            // aberta para a empresa selecionada.
            parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = true;
        }
    };
    /**
     * Função que é invocada após o carregamento do dataSource. Caso é 
     * retornado algo, adiciona à currentRow o primeiro indice de data[] - caso
     * contrário, é setada em forma de newRow;
     */
    self.setLoadedParameters = function (parametrosWidget) {
        var dimeScWidget = templateManager.container.getWidget("dime-sc");
        if (parametrosWidget.dataSource.data.length > 0) {
            // Seta a currentRow como sendo o primeiro indice do data[] retornado
            parametrosWidget.moveToFirst();
            // Redesenha na widget principal, os fields com os valores da nova 
            // currentRow
            parametrosWidget.redraw();
        } else {
            // Seta a widget em modo de novo dado, para inserir a parametrização
            parametrosWidget.newRow();
            parametrosWidget.currentRow.CDEMPRESA = dimeScWidget.currentRow.CDEMPRESA;
        }
        // Seta o nome da empresa no campo select de empresa, devido a um
        // comportamento que não exibe o nome da empresa correspondente ao código.
        parametrosWidget.currentRow.NMEMPRESA = dimeScWidget.currentRow.NMEMPRESA;
    };
    /**
     * Função invocada ao sair da widget de parametros, que seta os mesmos como 
     * verificados
     */
    self.beforeExitParametrosGerais = function (parametrosWidget) {
        // Seta a parametrização como verificada somente se a widget não estiver
        // em modo de inserção, mas sim de verificação
        if (!parametrosWidget.isNewRow()) {
            setParametersVerified(parametrosWidget);
        }
    };
    /**
     * Função que é invocada ao alterar o field CDINSCESTA,
     * alterando a propriedade enable da tab de parâmetros
     */
    self.inscricaoOnChange = function (dimeScWidget) {
        var parametrosWidget = templateManager.container.getWidget('parametrosGeraisDimeSc');
        // Variável booleana que é setada como true, caso alguma inscrição seja 
        // selecionada
        var inscricaoIsSelect = !!dimeScWidget.currentRow.CDINSCESTA;
        parametrosWidget.enabled = inscricaoIsSelect;
    };
    /**
     * Função que é invocada ao alterar o field GERAREGISTRO,
     * alterando a propriedade readOnly e validations do fieldGroup dadosContabeis
     */
    self.geraRegistroOnChange = function (dimeScWidget) {
        if (dimeScWidget.currentRow.GERAREGISTRO == "S") {
            dimeScWidget.fields.forEach(function (data) {
                if (data.fieldGroup == "dadosContabeis" && data.name != "GERAREGISTRO") {
                    data.readOnly = false;
                    data.validations.required = true;
                }
            });
        } else {
            dimeScWidget.fields.forEach(function (data) {
                if (data.fieldGroup == "dadosContabeis" && data.name != "GERAREGISTRO") {
                    data.readOnly = true;
                    data.validations = {};
                }
            });
        }
        dimeScWidget.currentRow.CDATIVO = "";
        dimeScWidget.currentRow.CDPASSIVO = "";
        dimeScWidget.currentRow.CDDRE = "";
        dimeScWidget.currentRow.CDDESPESAS = "";
        dimeScWidget.currentRow.DTREFCTB = "";
    };

    self.restauraPadraoDadosContabeis = function (dimeScWidget) {
        dimeScWidget.getField('CDATIVO').readOnly = true;
        dimeScWidget.getField('CDATIVO').validations = {};
        dimeScWidget.getField('CDPASSIVO').readOnly = true;
        dimeScWidget.getField('CDPASSIVO').validations = {};
        dimeScWidget.getField('CDDRE').readOnly = true;
        dimeScWidget.getField('CDDRE').validations = {};
        dimeScWidget.getField('CDDESPESAS').readOnly = true;
        dimeScWidget.getField('CDDESPESAS').validations = {};
        dimeScWidget.getField('DTREFCTB').readOnly = true;
        dimeScWidget.getField('DTREFCTB').validations = {};
    };
};
Configuration(function (ContextRegister) {
    ContextRegister.register("Fis06200_DimeSc_Controller", Fis06200_DimeSc_Controller);
});

// FILE: ./assets/modules/acessorias/assets/js/controllers/Fis07600_ValidaPr_Controller.js
var Fis07600_ValidaPr_Controller = function Fis07600_ValidaPr_Controller(General, ScreenService, templateManager, Messages_fiscal, ObrigacoesAcessoriasUtil) {

    var self = this;

    self.addAgendamento = function (widget) {
        widget.newRow();
        widget.getField('DTREFINI').isVisible = true;
    };

    self.cancelAgendamento = function (args) {
        General.backOrCancel(args);
        General.changeWidgetAcessibility(args.owner.widget.widgets, true);
        args.owner.widget.getField('DTREFINI').isVisible = true;
    };

    self.editAgendamento = function (widget) {
        General.edit(widget);
        this.periodicidadeOnChange(widget);
    };

    self.saveAgendamento = function (widget) {
        if (widget.isValid()) {
            var d1 = new Date(moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY HH:mm').format('MM/DD/YYYY HH:mm'));
            var d2 = new Date(moment().format('MM/DD/YYYY HH:mm'));

            if (d1.getTime() > d2.getTime()) {
                if ((widget.currentRow.CDINSCESTA == '' || widget.currentRow.CDINSCESTA == null) && widget.currentRow.CDEMPRESA) {
                    widget.currentRow.CDINSCESTA = "T";
                }

                widget.currentRow.NRORG = getLocalVar('NRORG');

                General.callRestEngine('fis_acessorias#/saveAgendamentoValidaPr', 'Row', widget.currentRow).then(function (success) {
                    General.changeWidgetAcessibility(widget.widgets, true);
                    ScreenService.showMessage('Agendado com sucesso.');
                    ScreenService.goBack();
                    widget.getField('DTREFINI').isVisible = true;
                    widget.reload();
                }, function (error) {
                    ScreenService.showMessage(error.data.error);
                });
            } else {
                ScreenService.showMessage('A Data de Agendamento deve ser maior que a data atual, e não pode ser igual a hora atual!');
            }
        } else {
            // @todo create messages class
            ScreenService.showMessage("Preencha todos os campos corretamente!");
        }
    };

    self.downloadArquivoAgendado = function (validaPrWidget) {
        var downloadRoute;
        var fileName;

        if (validaPrWidget.hasCheckedRows()) {
            var rows = validaPrWidget.getCheckedRows();
            rows.forEach(function (row) {
                downloadRoute = window.serviceUrls.filter(function (x) {
                    return x.package == 'fis';
                })[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
                fileName = row.NMARQUIVO;

                window.open(downloadRoute + fileName);
            });
        } else {
            var row = validaPrWidget.currentRow;
            downloadRoute = window.serviceUrls.filter(function (x) {
                return x.package == 'fis';
            })[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
            fileName = row.NMARQUIVO;

            window.open(downloadRoute + fileName);
        }
    };

    self.deleteAgendamento = function (widget) {
        widget.currentRow.NRORG = getLocalVar('NRORG');

        ScreenService.confirmMessage(ScreenService.i18n('Deletar Agendamento?'), 'question', function (success) {
            General.callRestEngine('fis_acessorias#/deleteAgendamentoValidaPr', 'Row', widget.currentRow).then(function (success) {
                ScreenService.showMessage('Deletado com sucesso.');
                ScreenService.goBack();
                widget.reload();
            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });
        });
    };

    self.periodicidadeOnChange = function (widget) {
        if (widget.currentRow.IDPERIAGEN == 0) {
            widget.getField('DTREFINI').isVisible = true;
        } else if (widget.currentRow.IDPERIAGEN == 1) {
            widget.getField('DTREFINI').isVisible = false;
            if (widget.currentRow.DTAGENDAMENTO && widget.currentRow.DTAGENDAMENTO != "") {
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').format('DD/MM/YYYY');
            }
        } else if (widget.currentRow.IDPERIAGEN == 2) {
            widget.getField('DTREFINI').isVisible = false;
            if (widget.currentRow.DTAGENDAMENTO && widget.currentRow.DTAGENDAMENTO != "") {
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').subtract(1, 'M').format('DD/MM/YYYY');
            }
        }
        widget.getField('DTREFINI').reload();
    };

    /**
     * Função para a chamada de Exportação
     */
    self.exportarValidaPr = function (validaPrWidget) {
        // Verifica se todos os campos requeridos estão de fato preenchidos
        if (validaPrWidget.isValid()) {
            // Verifica se a parametrização não foi carregada e verificada
            if (!parametrizacaoWasLoaded(validaPrWidget)) {
                return;
            }
            var parametrosWidget = templateManager.container.getWidget('parametrosGeraisValidaPr');

            // Transforma o array em uma string
            if (validaPrWidget.currentRow.SGESTADO) validaPrWidget.currentRow.SGESTADO = validaPrWidget.currentRow.SGESTADO.join("_");
            // Define propriedades na widget principal com valores dos fields
            // da tab de parametrização
            preenhcerPropriedadesWidgetPrincipal(validaPrWidget, parametrosWidget);

            // Seta nulo caso os field não estejam preenchidos
            if (validaPrWidget.currentRow.CDPAIS == "") validaPrWidget.currentRow.CDPAIS = null;
            if (validaPrWidget.currentRow.SGESTADO == "") validaPrWidget.currentRow.SGESTADO = null;

            var row = validaPrWidget.currentRow;
            var route = 'fis#/exportarValidaPr';
            var message = Messages_fiscal.EXPORTANDO_VALIDA_PR;
            ObrigacoesAcessoriasUtil.exportarArquivo(row, route, message);
        }
    };
    /**
     * Função auxiliar que verifica se a tab de parametrização foi aberta ao exportar,
     * através da propriedade 'empresasLoaded'.
     */
    var parametrizacaoWasLoaded = function parametrizacaoWasLoaded(validaPrWidget) {
        var parametrizacaoWasLoaded;
        var parametrosWidget;
        var cdEmpresa = validaPrWidget.currentRow.CDEMPRESA;
        parametrosWidget = templateManager.container.getWidget('parametrosGeraisValidaPr');
        // Verifica se a propriedade (CDEMPRESA) está setada para a empresa selecionada
        parametrizacaoWasLoaded = parametrosWidget.empresasLoaded[cdEmpresa];

        // Verifica se a widget de parametrização não foi aberta antes de
        // clicar no botão de exportar
        if (!parametrizacaoWasLoaded) {
            // Muda a propriedade para que a parametrização seja obrigatória
            parametrosWidget.parametersRequired = true;
            // Exibe mensagem indicando a obrigatoriedae da verificação dos parametros
            ScreenService.showMessage(Messages_fiscal.PARAMETROS_GERAIS_NAO_INFORMADOS_ERROR).then(function () {
                // Abre a widget/tab de parâmetros
                openTabParametrosGerais(parametrosWidget);
            });
            // Retorna false, indicando que a parametrização não foi previamente aberta
            return false;
        }
        // Retorna true, caso a parametrização já tenha sido aberta
        return true;
    };
    /**
     * Função auxiliar que abre a tab de parâmetros pela primeira vez.
     */
    var openTabParametrosGerais = function openTabParametrosGerais(parametrosWidget) {
        // Recarrega os dados (dataSource) parametrizados
        parametrosWidget.reload().then(function () {
            // Redesenha os dados carregados na tab
            parametrosWidget.redraw();
        });
        // Define a tab de parametricação como ativa
        parametrosWidget.activate();
    };
    /**
     * Função auxiliar que cria e preenche propriedades da widget principal,
     * com os valores das fields da tab de parâmetros
     */
    var preenhcerPropriedadesWidgetPrincipal = function preenhcerPropriedadesWidgetPrincipal(validaPrWidget, parametrosWidget) {
        validaPrWidget.currentRow.CDCONVENIO = parametrosWidget.currentRow.CDCONVENIO;
        validaPrWidget.currentRow.CDFINALIDADE = parametrosWidget.currentRow.CDFINALIDADE;
        validaPrWidget.currentRow.CDREGISTRO = parametrosWidget.currentRow.CDREGISTROARRAY;
    };
    /**
     * Função para salvar os parâmetros informados - ou caso eles já existam,
     * apenas os confirmam para a exportação
     */
    self.salvarParametrizacao = function (parametrosWidget) {
        // Verifica se todos os campos requeridos estão de fato preenchidos
        if (parametrosWidget.isValid()) {
            var validaPrWidget = templateManager.container.getWidget('valida-pr');
            var currentRow = parametrosWidget.currentRow;
            // Transforma o conteúdo do  CDREGISTRO em um array
            var registrosArray = ["N", "N", "N", "N", "N", "N", "N", "N", "N", "N", "N", "N"];

            // Para cada obrigatoriedade selecionada, muda o valor no array para "S".
            if (Array.isArray(currentRow.CDREGISTRO)) {
                currentRow.CDREGISTRO.forEach(function (index) {
                    registrosArray[index] = 'S';
                });
            }

            // Transforma o array em uma String e atribui ao campo.
            currentRow.CDREGISTROARRAY = registrosArray.join("");

            preencherCamposAbstratosParaSalvar(parametrosWidget);
            var filter = [{
                "name": "P_CDEMPRESA",
                "operator": "=",
                "value": validaPrWidget.currentRow.CDEMPRESA
            }, {
                "name": "P_CDINSCRICAO",
                "operator": "=",
                "value": parametrosWidget.currentRow.CDINSCRICAO
            }, {
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar('NRORG')
            }];

            General.callRestEngine('fis_acessorias#/crud/paramdeclaces_ValidaPr', 'FilterData', filter).then(function (result) {
                result = result.dataset.paramdeclaces_ValidaPr;

                if (result.length == 0) parametrosWidget.currentRow.__is_new = true;

                parametrosWidget.saveRow().then(function () {
                    // Seta os parametros como verificados pelo usuário
                    setParametersVerified(parametrosWidget);
                    // Ativa a widget principal
                    validaPrWidget.activate();
                    validaPrWidget.currentWidget = validaPrWidget;
                    /**
                     * Verifica se a tela de parâmetros foi exibida devido a uma tentativa
                     * de exportação. Caso positivo, a exportação é efetuada
                     */
                    if (parametrosWidget.parametersRequired) {
                        self.exportarValidaPr(validaPrWidget);
                        // Valida a propriedade para false, caso a tela de parametros seja
                        // novamente aberta. E assim não haverá exportação sempre ao sair
                        parametrosWidget.parametersRequired = false;
                    }
                });
            });
        }
    };

    var preencherCamposAbstratosParaSalvar = function preencherCamposAbstratosParaSalvar(parametrosWidget) {
        parametrosWidget.currentRow.CDCAMPO1 = parametrosWidget.currentRow.CDCONVENIO;
        parametrosWidget.currentRow.CDCAMPO2 = parametrosWidget.currentRow.CDFINALIDADE;
        parametrosWidget.currentRow.CDCAMPO3 = parametrosWidget.currentRow.CDREGISTROARRAY;
    };

    /**
     * Função auxiliar que seta na widget de parâmetros a propriedade indicando
     * que a parametrização foi verificada pelo usuário
     */
    var setParametersVerified = function setParametersVerified(parametrosWidget) {
        var currentRow = parametrosWidget.currentRow;
        var validaPrFiscalIsSelected = parametrosWidget.name == "parametrosGeraisValidaPr";
        if (validaPrFiscalIsSelected) {
            // Verifica se o objeto já foi criado pra esta empresa.
            if (!parametrosWidget.empresasLoaded[currentRow.CDEMPRESA]) {
                parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = {};
            }
            // Seta o parâmetro para a empresa selecionada.
            parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = true;
        } else {
            // Modifica a propriedade indicando que a parametrização foi
            // aberta para a empresa selecionada.
            parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = true;
        }
    };
    /**
     * Função que é invocada após o carregamento do dataSource. Caso é 
     * retornado algo, adiciona à currentRow o primeiro indice de data[] - caso
     * contrário, é setada em forma de newRow;
     */
    self.setLoadedParameters = function (parametrosWidget) {
        var validaPrWidget = templateManager.container.getWidget("valida-pr");
        if (parametrosWidget.dataSource.data.length > 0) {
            // Seta a currentRow como sendo o primeiro indice do data[] retornado
            parametrosWidget.moveToFirst();
            parametrosWidget.currentRow = parametrosWidget.dataSource.data[0];

            // Seta o field CDREGISTRO
            var codigosArray = parametrosWidget.dataSource.data[0].CDREGISTRO.split("");
            // Adiciona no array todos os valores marcados.
            parametrosWidget.currentRow.CDREGISTRO = [];
            if (codigosArray[0] == 'S') {
                // Registro 50.
                parametrosWidget.currentRow.CDREGISTRO.push(0);
            }
            if (codigosArray[1] == 'S') {
                // Registro 51.
                parametrosWidget.currentRow.CDREGISTRO.push(1);
            }
            if (codigosArray[2] == 'S') {
                // Registro 53.
                parametrosWidget.currentRow.CDREGISTRO.push(2);
            }
            if (codigosArray[3] == 'S') {
                // Registro 54.
                parametrosWidget.currentRow.CDREGISTRO.push(3);
            }
            if (codigosArray[4] == 'S') {
                // Registro 55.
                parametrosWidget.currentRow.CDREGISTRO.push(4);
            }
            if (codigosArray[5] == 'S') {
                // Registro 60.
                parametrosWidget.currentRow.CDREGISTRO.push(5);
            }
            if (codigosArray[6] == 'S') {
                // Registro 61.
                parametrosWidget.currentRow.CDREGISTRO.push(6);
            }
            if (codigosArray[7] == 'S') {
                // Registro 70.
                parametrosWidget.currentRow.CDREGISTRO.push(7);
            }
            if (codigosArray[8] == 'S') {
                // Registro 74.
                parametrosWidget.currentRow.CDREGISTRO.push(8);
            }
            if (codigosArray[9] == 'S') {
                // Registro 75.
                parametrosWidget.currentRow.CDREGISTRO.push(9);
            }
            if (codigosArray[10] == 'S') {
                // Registro 76.
                parametrosWidget.currentRow.CDREGISTRO.push(10);
            }
            if (codigosArray[11] == 'S') {
                // Registro 77.
                parametrosWidget.currentRow.CDREGISTRO.push(11);
            }

            // Redesenha na widget principal, os fields com os valores da nova 
            // currentRow
            parametrosWidget.redraw();
        } else {
            // Seta a widget em modo de novo dado, para inserir a parametrização
            parametrosWidget.newRow();
            parametrosWidget.currentRow.CDEMPRESA = validaPrWidget.currentRow.CDEMPRESA;
        }
        // Seta o nome da empresa no campo select de empresa, devido a um
        // comportamento que não exibe o nome da empresa correspondente ao código.
        parametrosWidget.currentRow.NMEMPRESA = validaPrWidget.currentRow.NMEMPRESA;
    };
    /**
     * Função invocada ao sair da widget de parametros, que seta os mesmos como 
     * verificados
     */
    self.beforeExitParametrosGerais = function (parametrosWidget) {
        // Seta a parametrização como verificada somente se a widget não estiver
        // em modo de inserção, mas sim de verificação
        if (!parametrosWidget.isNewRow()) {
            setParametersVerified(parametrosWidget);
        }
    };
    /**
     * Função que é invocada ao alterar o field CDINSCESTA,
     * alterando a propriedade enable da tab de parâmetros
     */
    this.inscricaoOnChange = function (validaPrWidget) {
        var parametrosWidget = templateManager.container.getWidget('parametrosGeraisValidaPr');
        // Variável booleana que é setada como true, caso alguma inscrição seja 
        // selecionada
        var inscricaoIsSelect = !!validaPrWidget.currentRow.CDINSCESTA;
        parametrosWidget.enabled = inscricaoIsSelect;
    };

    /**
     * Função que é invocada ao alterar o field NMPAIS,
     * habilitando o field SGESTADO
     */
    this.paisOnChange = function (validaPrWidget) {
        // Variável booleana que é setada como true caso alguma empresa tenha sido selecionada.
        var paisIsSelected = !!validaPrWidget.currentRow.NMPAIS;
        var estadoField = validaPrWidget.getField('SGESTADO');

        // Altera as propriedades do field de inscrição e reseta seu valor.
        estadoField.readOnly = !paisIsSelected;
        estadoField.setValue(null);
        estadoField.needReload = true;
    };

    /**
     * Função para a chamada de Exportação
     */
    self.exportarADRC = function (widget) {
        // Verifica se todos os campos requeridos estão de fato preenchidos
        if (widget.isValid()) {
            var row = widget.currentRow;
            var route = 'fis#/exportarADRC';
            var message = "Exportando Arquivo Digital da ST - ADRC-ST";
            ObrigacoesAcessoriasUtil.exportarArquivo(row, route, message);
        }
    };

    this.liberacampo = function (widget) {
        var centro = widget.currentRow.IDCENTRDISTR;
        var empresa = widget.getField('CDEMPRESADISTR');
        var inscesta = widget.getField('CDINSCESTADISTR');

        if (centro == 0) {
            empresa.readOnly = false;
            empresa.required = true;
            inscesta.required = true;
        } else {
            empresa.readOnly = true;
            empresa.required = false;
            inscesta.required = false;
        }
    };
};
Configuration(function (ContextRegister) {
    ContextRegister.register("Fis07600_ValidaPr_Controller", Fis07600_ValidaPr_Controller);
});

// FILE: ./assets/modules/acessorias/assets/js/controllers/Fis07700_DiefES_Controller.js
var Fis07700_DiefES_Controller = function Fis07700_DiefES_Controller(General, ScreenService, Messages_fiscal, ObrigacoesAcessoriasUtil) {

    var self = this;

    self.addAgendamento = function (widget) {
        widget.newRow();
        widget.getField('DTREFINI').isVisible = true;
    };

    self.cancelAgendamento = function (args) {
        General.backOrCancel(args);
        General.changeWidgetAcessibility(args.owner.widget.widgets, true);
        args.owner.widget.getField('DTREFINI').isVisible = true;
    };

    self.editAgendamento = function (widget) {
        General.edit(widget);
        this.periodicidadeOnChange(widget);
    };

    self.saveAgendamento = function (widget) {
        if (widget.isValid()) {
            var d1 = new Date(moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY HH:mm').format('MM/DD/YYYY HH:mm'));
            var d2 = new Date(moment().format('MM/DD/YYYY HH:mm'));

            if (d1.getTime() > d2.getTime()) {
                if ((widget.currentRow.CDINSCESTA == '' || widget.currentRow.CDINSCESTA == null) && widget.currentRow.CDEMPRESA) {
                    widget.currentRow.CDINSCESTA = "T";
                }

                widget.currentRow.NRORG = getLocalVar('NRORG');

                General.callRestEngine('fis_acessorias#/saveAgendamentoDiefEs', 'Row', widget.currentRow).then(function (success) {
                    General.changeWidgetAcessibility(widget.widgets, true);
                    ScreenService.showMessage('Agendado com sucesso.');
                    ScreenService.goBack();
                    widget.getField('DTREFINI').isVisible = true;
                    widget.reload();
                }, function (error) {
                    ScreenService.showMessage(error.data.error);
                });
            } else {
                ScreenService.showMessage('A Data de Agendamento deve ser maior que a data atual, e não pode ser igual a hora atual!');
            }
        } else {
            // @todo create messages class
            ScreenService.showMessage("Preencha todos os campos corretamente!");
        }
    };

    self.downloadArquivoAgendado = function (spedWidget) {
        var downloadRoute;
        var fileName;

        if (spedWidget.hasCheckedRows()) {
            var rows = spedWidget.getCheckedRows();
            rows.forEach(function (row) {
                downloadRoute = window.serviceUrls.filter(function (x) {
                    return x.package == 'fis';
                })[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
                fileName = row.NMARQUIVO;

                window.open(downloadRoute + fileName);
            });
        } else {
            var row = spedWidget.currentRow;
            downloadRoute = window.serviceUrls.filter(function (x) {
                return x.package == 'fis';
            })[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
            fileName = row.NMARQUIVO;

            window.open(downloadRoute + fileName);
        }
    };

    self.deleteAgendamento = function (widget) {
        widget.currentRow.NRORG = getLocalVar('NRORG');

        ScreenService.confirmMessage(ScreenService.i18n('Deletar Agendamento?'), 'question', function (success) {
            General.callRestEngine('fis_acessorias#/deleteAgendamentoDiefEs', 'Row', widget.currentRow).then(function (success) {
                ScreenService.showMessage('Deletado com sucesso.');
                ScreenService.goBack();
                widget.reload();
            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });
        });
    };

    self.periodicidadeOnChange = function (widget) {
        if (widget.currentRow.IDPERIAGEN == 0) {
            widget.getField('DTREFINI').isVisible = true;
        } else if (widget.currentRow.IDPERIAGEN == 1) {
            widget.getField('DTREFINI').isVisible = false;
            if (widget.currentRow.DTAGENDAMENTO && widget.currentRow.DTAGENDAMENTO != "") {
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').format('DD/MM/YYYY');
            }
        } else if (widget.currentRow.IDPERIAGEN == 2) {
            widget.getField('DTREFINI').isVisible = false;
            if (widget.currentRow.DTAGENDAMENTO && widget.currentRow.DTAGENDAMENTO != "") {
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').subtract(1, 'M').format('DD/MM/YYYY');
            }
        }
        widget.getField('DTREFINI').reload();
    };

    /*
     * Função para a chamada da função de exportação.
     */
    this.exportarLivroEletronico = function (DiefESWidget) {
        if (DiefESWidget.isValid()) {
            var row = DiefESWidget.currentRow;
            var route = "fis#/exportarDiefES";
            var message = Messages_fiscal.EXPORTANDO_DIEF;
            ObrigacoesAcessoriasUtil.exportarArquivo(row, route, message);
        }
    };

    /*
     * Função para alterar a propriedade readOnly do campo de inscrição,
     * conforme a inserção da empresa.
     */
    this.empresaOnChange = function (DiefESWidget) {
        // Valida inscrição estadual.
        ObrigacoesAcessoriasUtil.empresaOnChange(DiefESWidget);
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis07700_DiefES_Controller', Fis07700_DiefES_Controller);
});

// FILE: ./assets/modules/acessorias/assets/js/controllers/Fis07800_DacAl_Controller.js
var Fis07800_DacAl_Controller = function Fis07800_DacAl_Controller(General, ScreenService, templateManager, Messages_fiscal, ObrigacoesAcessoriasUtil) {

    var self = this;

    self.addAgendamento = function (widget) {
        widget.newRow();
        widget.getField('DTREFINI').isVisible = true;
    };

    self.cancelAgendamento = function (args) {
        General.backOrCancel(args);
        General.changeWidgetAcessibility(args.owner.widget.widgets, true);
        args.owner.widget.getField('DTREFINI').isVisible = true;
    };

    self.editAgendamento = function (widget) {
        General.edit(widget);
        this.periodicidadeOnChange(widget);
    };

    self.saveAgendamento = function (widget) {
        if (widget.isValid()) {
            var d1 = new Date(moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY HH:mm').format('MM/DD/YYYY HH:mm'));
            var d2 = new Date(moment().format('MM/DD/YYYY HH:mm'));

            if (d1.getTime() > d2.getTime()) {
                if ((widget.currentRow.CDINSCESTA == '' || widget.currentRow.CDINSCESTA == null) && widget.currentRow.CDEMPRESA) {
                    widget.currentRow.CDINSCESTA = "T";
                }

                widget.currentRow.NRORG = getLocalVar('NRORG');

                General.callRestEngine('fis_acessorias#/saveAgendamentoDacAl', 'Row', widget.currentRow).then(function (success) {
                    General.changeWidgetAcessibility(widget.widgets, true);
                    ScreenService.showMessage('Agendado com sucesso.');
                    ScreenService.goBack();
                    widget.getField('DTREFINI').isVisible = true;
                    widget.reload();
                }, function (error) {
                    ScreenService.showMessage(error.data.error);
                });
            } else {
                ScreenService.showMessage('A Data de Agendamento deve ser maior que a data atual, e não pode ser igual a hora atual!');
            }
        } else {
            // @todo create messages class
            ScreenService.showMessage("Preencha todos os campos corretamente!");
        }
    };

    self.downloadArquivoAgendado = function (spedWidget) {
        var downloadRoute;
        var fileName;

        if (spedWidget.hasCheckedRows()) {
            var rows = spedWidget.getCheckedRows();
            rows.forEach(function (row) {
                downloadRoute = window.serviceUrls.filter(function (x) {
                    return x.package == 'fis';
                })[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
                fileName = row.NMARQUIVO;

                window.open(downloadRoute + fileName);
            });
        } else {
            var row = spedWidget.currentRow;
            downloadRoute = window.serviceUrls.filter(function (x) {
                return x.package == 'fis';
            })[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
            fileName = row.NMARQUIVO;

            window.open(downloadRoute + fileName);
        }
    };

    self.deleteAgendamento = function (widget) {
        widget.currentRow.NRORG = getLocalVar('NRORG');

        ScreenService.confirmMessage(ScreenService.i18n('Deletar Agendamento?'), 'question', function (success) {
            General.callRestEngine('fis_acessorias#/deleteAgendamentoDacAl', 'Row', widget.currentRow).then(function (success) {
                ScreenService.showMessage('Deletado com sucesso.');
                ScreenService.goBack();
                widget.reload();
            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });
        });
    };

    self.periodicidadeOnChange = function (widget) {
        if (widget.currentRow.IDPERIAGEN == 0) {
            widget.getField('DTREFINI').isVisible = true;
        } else if (widget.currentRow.IDPERIAGEN == 1) {
            widget.getField('DTREFINI').isVisible = false;
            if (widget.currentRow.DTAGENDAMENTO && widget.currentRow.DTAGENDAMENTO != "") {
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').format('DD/MM/YYYY');
            }
        } else if (widget.currentRow.IDPERIAGEN == 2) {
            widget.getField('DTREFINI').isVisible = false;
            if (widget.currentRow.DTAGENDAMENTO && widget.currentRow.DTAGENDAMENTO != "") {
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').subtract(1, 'M').format('DD/MM/YYYY');
            }
        }
        widget.getField('DTREFINI').reload();
    };

    /*
     * Função para a chamada da função de exportação.
     */
    this.exportarDacAl = function (dacAlWidget) {
        // Verifica se todos os campos obrigatórios foram preenchidos.
        if (dacAlWidget.isValid()) {
            // Verifica se a parametrização para exportação foi verificada.
            if (!parametrizacaoWasLoaded(dacAlWidget)) {
                return;
            }

            // Atribui aos fields da widget principal, os vaores da widget
            // 'parametrosGeraidDacAl'
            var parametrosWidget = templateManager.container.getWidget('parametrosGeraisDacAl');
            preencheFieldsOcultosWidgetPrincipal(dacAlWidget, parametrosWidget);
            var row = dacAlWidget.currentRow;
            var route = "fis#/exportarDacAl";
            var message = Messages_fiscal.EXPORTANDO_DAC_AL;
            ObrigacoesAcessoriasUtil.exportarArquivo(row, route, message);
        }
    };

    var parametrizacaoWasLoaded = function parametrizacaoWasLoaded(dacAlWidget) {
        var parametrizacaoWasLoaded;
        var parametrosWidget;
        var cdempresa = dacAlWidget.currentRow.CDEMPRESA;
        parametrosWidget = templateManager.container.getWidget('parametrosGeraisDacAl');
        // Valida se a propriedade está setada para a empresa selecionada.
        parametrizacaoWasLoaded = parametrosWidget.empresasLoaded[cdempresa];

        // Verifica se a widget de parametrização foi aberta antes de exportar o arquivo.
        if (!parametrizacaoWasLoaded) {
            // Muda a propriedade para que seja obrigatório que a parametrização seja informada.
            parametrosWidget.parametersRequired = true;
            // Exibe a mensagem que indica que os parâmetros devem ser verificados.
            ScreenService.showMessage(Messages_fiscal.PARAMETROS_GERAIS_NAO_INFORMADOS_ERROR).then(function () {
                // Abre a swipe da widget de parâmetros.
                openTabParametrosGerais(dacAlWidget);
            });
            // Retorna false, indicando que a parametrização não foi previamente conferida.
            return false;
        }
        // Retorna true caso contrário, indicando que a parametrização foi previamente conferida.
        return true;
    };

    /*
     * Função para abrir o formulário com as parametrizações do DAC-AL.
     * Altera o parâmetro "wasLoaded" da widget, que indica se a parametrização
     * foi revisada antes do arquivo ter sido exportado.
     */
    var openTabParametrosGerais = function openTabParametrosGerais(dacAlWidget) {

        // Seleciona a widget conforme o arquivo selecionado.
        var parametrosWidget = templateManager.container.getWidget('parametrosGeraisDacAl');
        // Recarrega os dados parametrizados.
        parametrosWidget.reload().then(function () {
            // Redesenha a widget, fazendo com que apareçam os dados carregados.
            parametrosWidget.redraw();
        });
        // Abre a widget da tabbed 'parametrosGerais'
        dacAlWidget.currentWidget = parametrosWidget;
        parametrosWidget.activate();
    };

    /*
     * Função para salvar a parametrização informada pelo usuário.
     * Ou apenas confirmar os valores dos Fields, caso já existam os campos
     * gravados.
     */
    this.salvarParametrizacao = function (parametrosWidget) {
        // Verifica se todos os dados requeridos foram preenchidos.
        if (parametrosWidget.isValid()) {
            var dacAlWidget = templateManager.container.getWidget("Dac-Al");
            // Abaixo, é verificado se os 3 fiels abaixo contém números
            var versao = parametrosWidget.currentRow.VERSAO;
            var release = parametrosWidget.currentRow.RELEASE;
            var sbrelease = parametrosWidget.currentRow.SBRELEASE;
            var aidf = parametrosWidget.currentRow.AIDF;
            // Trata aidf caso for 'undefined', se continuar, não será possível compará-lo abaixo.
            if (aidf == undefined) aidf = "";
            // Não é possível saber o tamanho de variável tipo Number. Por isso a conversão.
            aidf = aidf.toString();
            // Validadação especial para o campo numério AIDF.
            if (aidf.length == 0) {
                aidf = true;
            } else {
                if (isNumber(aidf)) {
                    aidf = true;
                } else {
                    aidf = false;
                }
            }
            if (isNumber(versao) && isNumber(release) && isNumber(sbrelease) && aidf) {
                preencheFieldsOcultosWidgetPrincipal(dacAlWidget, parametrosWidget);
                // Chama a função para salvar os dados.
                parametrosWidget.saveRow().then(function () {

                    // Seta os parametros como verificados pelo usuário.
                    setParametersVerified(parametrosWidget);

                    // Altera a widget ativa para a principal.
                    dacAlWidget.activate();
                    dacAlWidget.currentWidget = dacAlWidget;

                    // Verifica se os parâmetros foram exibidos devido a uma
                    // tentativa de exportar o DAC-AL. Em caso positivo, tenta
                    // exportar o DAC-AL novamente.
                    if (parametrosWidget.parametersRequired) {
                        self.exportarDacAl(dacAlWidget);
                        // Retira a necessidade de exportar automaticamente ao
                        // abrir a parametrização novamente.
                        parametrosWidget.parametersRequired = false;
                    }
                });
            } else {
                ScreenService.showMessage("Os campos Versão, Release, Sub-Release e AIDF devem ser numéricos");
            }
        }
    };

    /**
     * Função auxiliar para verificar se fields são numéricos
     */
    var isNumber = function isNumber(n) {
        return !isNaN(parseFloat(n)) && isFinite(n);
    };

    /**
     * Função auxiliar, que preenche os fields ocultos com os valores da 
     * widget 'parametrosGeraisDacAl'
     */
    var preencheFieldsOcultosWidgetPrincipal = function preencheFieldsOcultosWidgetPrincipal(dacAlWidget, parametrosWidget) {
        dacAlWidget.currentRow.CDGRUPPROD = parametrosWidget.currentRow.CDGRUPPROD;
        dacAlWidget.currentRow.VERSAO = parametrosWidget.currentRow.VERSAO;
        dacAlWidget.currentRow.RELEASE = parametrosWidget.currentRow.RELEASE;
        dacAlWidget.currentRow.SBRELEASE = parametrosWidget.currentRow.SBRELEASE;
        dacAlWidget.currentRow.TPDEC = parametrosWidget.currentRow.TPDEC;
        dacAlWidget.currentRow.PDEC = parametrosWidget.currentRow.PDEC;
        dacAlWidget.currentRow.INDMOV = parametrosWidget.currentRow.INDMOV;
        dacAlWidget.currentRow.INDENC = parametrosWidget.currentRow.INDENC;
        dacAlWidget.currentRow.GUIA = parametrosWidget.currentRow.GUIA;
        dacAlWidget.currentRow.APURAC = parametrosWidget.currentRow.APURAC;
        dacAlWidget.currentRow.SISTEMA = parametrosWidget.currentRow.SISTEMA;
        dacAlWidget.currentRow.CALC = parametrosWidget.currentRow.CALC;
        dacAlWidget.currentRow.AIDF = parametrosWidget.currentRow.AIDF;
        dacAlWidget.currentRow.REGANUAL = parametrosWidget.currentRow.REGANUAL;
    };

    /*
     * Função auxiliar que seta na widget de parâmetros a propriedade indicando
     * que a parametrização foi verificada pelo usuário.
     */
    var setParametersVerified = function setParametersVerified(parametrosWidget) {
        var dacAlFiscalIsSelected = parametrosWidget.name == "parametrosGeraisDacAl";
        var currentRow = parametrosWidget.currentRow;
        // Seta a propriedade que indica se a parametrização foi verificada.
        if (dacAlFiscalIsSelected) {
            var dacAlWidget = templateManager.container.getWidget("Dac-Al");
            // Verifica se o objeto já foi criado pra esta empresa.
            if (!parametrosWidget.empresasLoaded[currentRow.CDEMPRESA]) {
                parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = {};
            }
            // Seta o parâmetro para a empresa selecionada.
            parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = true;
            //dacAlWidget.currentRow.REG1400 = (Array.isArray(currentRow.CDOBRIGARRAY) && currentRow.CDOBRIGARRAY.indexOf(4) !== -1);
        } else {
            // Modifica a propriedade indicando que a parametrização foi
            // aberta para a empresa selecionada.
            parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = true;
        }
    };

    /*
     * Função para alterar a propriedade readOnly do campo de inscrição,
     * conforme a inserção da empresa.
     */
    this.empresaOnChange = function (dacAlWidget) {
        // Valida inscrição estadual.
        ObrigacoesAcessoriasUtil.empresaOnChange(dacAlWidget);

        // Variável booleana que é setada como true caso alguma Empresa
        // tenha sido selecionada.
        var inscricaoEmpresaIsSelected = !!dacAlWidget.currentRow.CDEMPRESA;
        var parametrosWidget = templateManager.container.getWidget('parametrosGeraisDacAl');

        // Coloca a visibilidade da tabbed 'parametrosGerais' como true,
        // caso alguma Empresa esteja selecionada.
        parametrosWidget.enabled = inscricaoEmpresaIsSelected;
    };

    /*
     * Função para setar a currentRow da widget de parâmetros após o carregamento dos dados.
     * Altera, também, a propriedade que indica se já havia uma parametrização cadastrada.
     */
    this.setLoadedParameters = function (parametrosWidget) {
        var dacAlWidget = templateManager.container.getWidget("Dac-Al");
        // Verifica se há alguma parametrização retornada.
        if (parametrosWidget.dataSource.data.length > 0) {
            // Seta a currentRow como o primeiro dado no array retornado.
            parametrosWidget.moveToFirst();
            // Seta nas currentRows os valores das colunas originais
            obterValoresColunasOriginais(parametrosWidget);
            // Redesenha, na widget, os fields com os valores
            parametrosWidget.redraw();
        } else {
            // Seta a widget em modo de novo dado, para inserir a parametrização.
            parametrosWidget.newRow();
            parametrosWidget.currentRow.CDEMPRESA = dacAlWidget.currentRow.CDEMPRESA;
        }
        // Seta o nome da empresa no campo select de empresa, devido a um
        // comportamento que não exibe o nome da empresa correspondente ao código.
        parametrosWidget.currentRow.NMEMPRESA = dacAlWidget.currentRow.NMEMPRESA;
    };

    /**
     * Função auxiliar, para atribuir aos fields da widget, os valores das
     * fields genéricas.
     */
    var obterValoresColunasOriginais = function obterValoresColunasOriginais(parametrosWidget) {
        parametrosWidget.currentRow.CDGRUPPROD = parametrosWidget.currentRow.CDCAMPO1;
        parametrosWidget.currentRow.VERSAO = parametrosWidget.currentRow.CDCAMPO2;
        parametrosWidget.currentRow.RELEASE = parametrosWidget.currentRow.CDCAMPO3;
        parametrosWidget.currentRow.SBRELEASE = parametrosWidget.currentRow.CDCAMPO4;
        parametrosWidget.currentRow.TPDEC = parametrosWidget.currentRow.CDCAMPO5;
        parametrosWidget.currentRow.PDEC = parametrosWidget.currentRow.CDCAMPO6;
        parametrosWidget.currentRow.INDMOV = parametrosWidget.currentRow.CDCAMPO7;
        parametrosWidget.currentRow.INDENC = parametrosWidget.currentRow.CDCAMPO8;
        parametrosWidget.currentRow.GUIA = parametrosWidget.currentRow.CDCAMPO9;
        parametrosWidget.currentRow.APURAC = parametrosWidget.currentRow.CDCAMPO10;
        parametrosWidget.currentRow.SISTEMA = parametrosWidget.currentRow.CDCAMPO11;
        parametrosWidget.currentRow.CALC = parametrosWidget.currentRow.CDCAMPO12;
        parametrosWidget.currentRow.REGANUAL = parametrosWidget.currentRow.CDCAMPO13;
    };

    /*
     * Função para setar os parâmetros como verificados ao sair da widget.
     */
    this.beforeExitParametrosGerais = function (parametrosWidget) {
        // Seta a parametrização como verificada somente se a widget não
        // estiver em modo de inserção, mas sim de edição.
        if (!parametrosWidget.isNewRow()) {
            setParametersVerified(parametrosWidget);
        }
    };

    /*
     * Função para salvar o valor de um field com outro nome na currentRow.
     * Chamada pela parametrização do SPED Contribuições, devido ao fato deste
     * utilizar uma tabela genérica e campos com nomes genéricos, sendo necessário
     * salvar o valor com o nome original do campo.
     * Utilizado por fields select-native também devido ao fato do outData não
     * funcionar da maneira devida neste caso.
     */
    this.setCurrentRowValue = function (field) {
        // Seta a propriedade na currentRow com o mesmo valor do field.
        field.widget.currentRow[field.originalColumn] = field.value();
    };

    this.saveEspecDocFisc = function (especDocFiscGrid) {
        if (especDocFiscGrid.backupRow && !especDocFiscGrid.currentRow.__is_new) {
            especDocFiscGrid.currentRow.CDESPECDOCFISC = especDocFiscGrid.backupRow.CDESPECDOCFISC;
        }
        General.saveCrud(especDocFiscGrid);
    };

    this.cdespecdocfiscOnChange = function (cdespecdocfiscField) {
        cdespecdocfiscField.widget.currentRow.CDESPECDOCFISC = General.fill(cdespecdocfiscField.value(), 10);
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis07800_DacAl_Controller', Fis07800_DacAl_Controller);
});

// FILE: ./assets/modules/acessorias/assets/js/controllers/Fis07900_GimPb_Controller.js
var Fis07900_GimPb_Controller = function Fis07900_GimPb_Controller(General, ScreenService, templateManager, Messages_fiscal, ObrigacoesAcessoriasUtil) {

    var self = this;

    self.addAgendamento = function (widget) {
        widget.newRow();
        widget.getField('DTREFINI').isVisible = true;
    };

    self.cancelAgendamento = function (args) {
        General.backOrCancel(args);
        General.changeWidgetAcessibility(args.owner.widget.widgets, true);
        args.owner.widget.getField('DTREFINI').isVisible = true;
    };

    self.editAgendamento = function (widget) {
        General.edit(widget);
        this.periodicidadeOnChange(widget);
    };

    self.saveAgendamento = function (widget) {
        if (widget.isValid()) {
            var d1 = new Date(moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY HH:mm').format('MM/DD/YYYY HH:mm'));
            var d2 = new Date(moment().format('MM/DD/YYYY HH:mm'));

            if (d1.getTime() > d2.getTime()) {
                if ((widget.currentRow.CDINSCESTA == '' || widget.currentRow.CDINSCESTA == null) && widget.currentRow.CDEMPRESA) {
                    widget.currentRow.CDINSCESTA = "T";
                }

                widget.currentRow.NRORG = getLocalVar('NRORG');

                General.callRestEngine('fis_acessorias#/saveAgendamentoGimPb', 'Row', widget.currentRow).then(function (success) {
                    General.changeWidgetAcessibility(widget.widgets, true);
                    ScreenService.showMessage('Agendado com sucesso.');
                    ScreenService.goBack();
                    widget.getField('DTREFINI').isVisible = true;
                    widget.reload();
                }, function (error) {
                    ScreenService.showMessage(error.data.error);
                });
            } else {
                ScreenService.showMessage('A Data de Agendamento deve ser maior que a data atual, e não pode ser igual a hora atual!');
            }
        } else {
            // @todo create messages class
            ScreenService.showMessage("Preencha todos os campos corretamente!");
        }
    };

    self.downloadArquivoAgendado = function (gimPbWidget) {
        var downloadRoute;
        var fileName;

        if (gimPbWidget.hasCheckedRows()) {
            var rows = gimPbWidget.getCheckedRows();
            rows.forEach(function (row) {
                downloadRoute = window.serviceUrls.filter(function (x) {
                    return x.package == 'fis';
                })[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
                fileName = row.NMARQUIVO;

                window.open(downloadRoute + fileName);
            });
        } else {
            var row = gimPbWidget.currentRow;
            downloadRoute = window.serviceUrls.filter(function (x) {
                return x.package == 'fis';
            })[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
            fileName = row.NMARQUIVO;

            window.open(downloadRoute + fileName);
        }
    };

    self.deleteAgendamento = function (widget) {
        widget.currentRow.NRORG = getLocalVar('NRORG');

        ScreenService.confirmMessage(ScreenService.i18n('Deletar Agendamento?'), 'question', function (success) {
            General.callRestEngine('fis_acessorias#/deleteAgendamentoGimPb', 'Row', widget.currentRow).then(function (success) {
                ScreenService.showMessage('Deletado com sucesso.');
                ScreenService.goBack();
                widget.reload();
            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });
        });
    };

    self.periodicidadeOnChange = function (widget) {
        if (widget.currentRow.IDPERIAGEN == 0) {
            widget.getField('DTREFINI').isVisible = true;
        } else if (widget.currentRow.IDPERIAGEN == 1) {
            widget.getField('DTREFINI').isVisible = false;
            if (widget.currentRow.DTAGENDAMENTO && widget.currentRow.DTAGENDAMENTO != "") {
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').format('DD/MM/YYYY');
            }
        } else if (widget.currentRow.IDPERIAGEN == 2) {
            widget.getField('DTREFINI').isVisible = false;
            if (widget.currentRow.DTAGENDAMENTO && widget.currentRow.DTAGENDAMENTO != "") {
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').subtract(1, 'M').format('DD/MM/YYYY');
            }
        }
        widget.getField('DTREFINI').reload();
    };

    /**
     * Função para a chamada de Exportação
     */
    self.exportarGimPb = function (gimPbWidget) {
        // Verifica se todos os campos requeridos estão de fato preenchidos
        if (gimPbWidget.isValid()) {
            // Verifica se a parametrização não foi carregada e verificada
            if (!parametrizacaoWasLoaded(gimPbWidget)) {
                return;
            }
            var parametrosWidget = templateManager.container.getWidget('parametrosGeraisGimPb');

            // Transforma o array em uma string
            if (gimPbWidget.currentRow.SGESTADO) gimPbWidget.currentRow.SGESTADO = gimPbWidget.currentRow.SGESTADO.join("_");
            // Define propriedades na widget principal com valores dos fields
            // da tab de parametrização
            preenhcerPropriedadesWidgetPrincipal(gimPbWidget, parametrosWidget);

            // Seta nulo caso os field não estejam preenchidos
            if (gimPbWidget.currentRow.CDPAIS == "") gimPbWidget.currentRow.CDPAIS = null;
            if (gimPbWidget.currentRow.SGESTADO == "") gimPbWidget.currentRow.SGESTADO = null;

            var row = gimPbWidget.currentRow;
            var route = 'fis#/exportarGimPb';
            var message = Messages_fiscal.EXPORTANDO_GIM_PB;
            ObrigacoesAcessoriasUtil.exportarArquivo(row, route, message);
        }
    };
    /**
     * Função auxiliar que verifica se a tab de parametrização foi aberta ao exportar,
     * através da propriedade 'empresasLoaded'.
     */
    var parametrizacaoWasLoaded = function parametrizacaoWasLoaded(gimPbWidget) {
        var parametrizacaoWasLoaded;
        var parametrosWidget;
        var cdEmpresa = gimPbWidget.currentRow.CDEMPRESA;
        parametrosWidget = templateManager.container.getWidget('parametrosGeraisGimPb');
        // Verifica se a propriedade (CDEMPRESA) está setada para a empresa selecionada
        parametrizacaoWasLoaded = parametrosWidget.empresasLoaded[cdEmpresa];

        // Verifica se a widget de parametrização não foi aberta antes de
        // clicar no botão de exportar
        if (!parametrizacaoWasLoaded) {
            // Muda a propriedade para que a parametrização seja obrigatória
            parametrosWidget.parametersRequired = true;
            // Exibe mensagem indicando a obrigatoriedae da verificação dos parametros
            ScreenService.showMessage(Messages_fiscal.PARAMETROS_GERAIS_NAO_INFORMADOS_ERROR).then(function () {
                // Abre a widget/tab de parâmetros
                openTabParametrosGerais(parametrosWidget);
            });
            // Retorna false, indicando que a parametrização não foi previamente aberta
            return false;
        }
        // Retorna true, caso a parametrização já tenha sido aberta
        return true;
    };
    /**
     * Função auxiliar que abre a tab de parâmetros pela primeira vez.
     */
    var openTabParametrosGerais = function openTabParametrosGerais(parametrosWidget) {
        // Recarrega os dados (dataSource) parametrizados
        parametrosWidget.reload().then(function () {
            // Redesenha os dados carregados na tab
            parametrosWidget.redraw();
        });
        // Define a tab de parametricação como ativa
        parametrosWidget.activate();
    };
    /**
     * Função auxiliar que cria e preenche propriedades da widget principal,
     * com os valores das fields da tab de parâmetros
     */
    var preenhcerPropriedadesWidgetPrincipal = function preenhcerPropriedadesWidgetPrincipal(gimPbWidget, parametrosWidget) {
        gimPbWidget.currentRow.CDCONVENIO = parametrosWidget.currentRow.CDCONVENIO;
        gimPbWidget.currentRow.CDFINALIDADE = parametrosWidget.currentRow.CDFINALIDADE;
        gimPbWidget.currentRow.CDRECIBO = parametrosWidget.currentRow.CDRECIBO;
        gimPbWidget.currentRow.CDREGISTRO = parametrosWidget.currentRow.CDREGISTROARRAY;
    };
    /**
     * Função para salvar os parâmetros informados - ou caso eles já existam,
     * apenas os confirmam para a exportação
     */
    self.salvarParametrizacao = function (parametrosWidget) {
        // Verifica se todos os campos requeridos estão de fato preenchidos
        if (parametrosWidget.isValid()) {
            var gimPbWidget = templateManager.container.getWidget('gim-pb');
            var currentRow = parametrosWidget.currentRow;
            // Transforma o conteúdo do  CDREGISTRO
            var registrosArray = ["N", "N", "N", "N", "N", "N", "N", "N", "N", "N", "N", "N", "N"];

            // Para cada obrigatoriedade selecionada, muda o valor no array para "S".
            if (Array.isArray(currentRow.CDREGISTRO)) {
                currentRow.CDREGISTRO.forEach(function (index) {
                    registrosArray[index] = 'S';
                });
            }

            // Transforma o array em uma String e atribui ao campo.
            currentRow.CDREGISTROARRAY = registrosArray.join("");

            preencherCamposAbstratosParaSalvar(parametrosWidget);
            var filter = [{
                "name": "P_CDEMPRESA",
                "operator": "=",
                "value": gimPbWidget.currentRow.CDEMPRESA
            }, {
                "name": "P_CDINSCRICAO",
                "operator": "=",
                "value": parametrosWidget.currentRow.CDINSCRICAO
            }, {
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar('NRORG')
            }];

            General.callRestEngine('fis_acessorias#/crud/paramdeclaces_GimPb', 'FilterData', filter).then(function (result) {
                result = result.dataset.paramdeclaces_GimPb;

                if (result.length == 0) parametrosWidget.currentRow.__is_new = true;

                parametrosWidget.saveRow().then(function () {
                    // Seta os parametros como verificados pelo usuário
                    setParametersVerified(parametrosWidget);
                    // Ativa a widget principal
                    gimPbWidget.activate();
                    gimPbWidget.currentWidget = gimPbWidget;
                    /**
                     * Verifica se a tela de parâmetros foi exibida devido a uma tentativa
                     * de exportação. Caso positivo, a exportação é efetuada
                     */
                    if (parametrosWidget.parametersRequired) {
                        self.exportarGimPb(gimPbWidget);
                        // Valida a propriedade para false, caso a tela de parametros seja
                        // novamente aberta. E assim não haverá exportação sempre ao sair
                        parametrosWidget.parametersRequired = false;
                    }
                });
            });
        }
    };

    var preencherCamposAbstratosParaSalvar = function preencherCamposAbstratosParaSalvar(parametrosWidget) {
        parametrosWidget.currentRow.CDCAMPO1 = parametrosWidget.currentRow.CDCONVENIO;
        parametrosWidget.currentRow.CDCAMPO2 = parametrosWidget.currentRow.CDFINALIDADE;
        parametrosWidget.currentRow.CDCAMPO3 = parametrosWidget.currentRow.CDRECIBO;
        parametrosWidget.currentRow.CDCAMPO4 = parametrosWidget.currentRow.CDREGISTROARRAY;
    };

    /**
     * Função auxiliar que seta na widget de parâmetros a propriedade indicando
     * que a parametrização foi verificada pelo usuário
     */
    var setParametersVerified = function setParametersVerified(parametrosWidget) {
        var currentRow = parametrosWidget.currentRow;
        var gimPbFiscalIsSelected = parametrosWidget.name == "parametrosGeraisGimPb";
        if (gimPbFiscalIsSelected) {
            // Verifica se o objeto já foi criado pra esta empresa.
            if (!parametrosWidget.empresasLoaded[currentRow.CDEMPRESA]) {
                parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = {};
            }
            // Seta o parâmetro para a empresa selecionada.
            parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = true;
        } else {
            // Modifica a propriedade indicando que a parametrização foi
            // aberta para a empresa selecionada.
            parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = true;
        }
    };
    /**
     * Função que é invocada após o carregamento do dataSource. Caso é 
     * retornado algo, adiciona à currentRow o primeiro indice de data[] - caso
     * contrário, é setada em forma de newRow;
     */
    self.setLoadedParameters = function (parametrosWidget) {
        var gimPbWidget = templateManager.container.getWidget("gim-pb");
        if (parametrosWidget.dataSource.data.length > 0) {
            // Seta a currentRow como sendo o primeiro indice do data[] retornado
            parametrosWidget.moveToFirst();
            parametrosWidget.currentRow = parametrosWidget.dataSource.data[0];

            // Seta o field CDREGISTRO
            var codigosArray = parametrosWidget.dataSource.data[0].CDREGISTRO.split("");
            // Adiciona no array todos os valores marcados.
            parametrosWidget.currentRow.CDREGISTRO = [];
            if (codigosArray[0] == 'S') {
                // Registro 50.
                parametrosWidget.currentRow.CDREGISTRO.push(0);
            }
            if (codigosArray[1] == 'S') {
                // Registro 51.
                parametrosWidget.currentRow.CDREGISTRO.push(1);
            }
            if (codigosArray[2] == 'S') {
                // Registro 53.
                parametrosWidget.currentRow.CDREGISTRO.push(2);
            }
            if (codigosArray[3] == 'S') {
                // Registro 54.
                parametrosWidget.currentRow.CDREGISTRO.push(3);
            }
            if (codigosArray[4] == 'S') {
                // Registro 55.
                parametrosWidget.currentRow.CDREGISTRO.push(4);
            }
            if (codigosArray[5] == 'S') {
                // Registro 60.
                parametrosWidget.currentRow.CDREGISTRO.push(5);
            }
            if (codigosArray[6] == 'S') {
                // Registro 61.
                parametrosWidget.currentRow.CDREGISTRO.push(6);
            }
            if (codigosArray[7] == 'S') {
                // Registro 70.
                parametrosWidget.currentRow.CDREGISTRO.push(7);
            }
            if (codigosArray[8] == 'S') {
                // Registro 74.
                parametrosWidget.currentRow.CDREGISTRO.push(8);
            }
            if (codigosArray[9] == 'S') {
                // Registro 75.
                parametrosWidget.currentRow.CDREGISTRO.push(9);
            }
            if (codigosArray[10] == 'S') {
                // Registro 76.
                parametrosWidget.currentRow.CDREGISTRO.push(10);
            }
            if (codigosArray[11] == 'S') {
                // Registro 77.
                parametrosWidget.currentRow.CDREGISTRO.push(11);
            }
            if (codigosArray[12] == 'S') {
                // Registro 88.
                parametrosWidget.currentRow.CDREGISTRO.push(12);
            }

            // Redesenha na widget principal, os fields com os valores da nova 
            // currentRow
            parametrosWidget.redraw();
        } else {
            // Seta a widget em modo de novo dado, para inserir a parametrização
            parametrosWidget.newRow();
            parametrosWidget.currentRow.CDEMPRESA = gimPbWidget.currentRow.CDEMPRESA;
        }
        // Seta o nome da empresa no campo select de empresa, devido a um
        // comportamento que não exibe o nome da empresa correspondente ao código.
        parametrosWidget.currentRow.NMEMPRESA = gimPbWidget.currentRow.NMEMPRESA;
    };
    /**
     * Função invocada ao sair da widget de parametros, que seta os mesmos como 
     * verificados
     */
    self.beforeExitParametrosGerais = function (parametrosWidget) {
        // Seta a parametrização como verificada somente se a widget não estiver
        // em modo de inserção, mas sim de verificação
        if (!parametrosWidget.isNewRow()) {
            setParametersVerified(parametrosWidget);
        }
    };
    /**
     * Função que é invocada ao alterar o field CDINSCESTA,
     * habilitando o field CDINSCESTAST e 
     * alterando a propriedade enable da tab de parâmetros
     */
    this.inscricaoOnChange = function (gimPbWidget) {
        var parametrosWidget = templateManager.container.getWidget('parametrosGeraisGimPb');
        // Variável booleana que é setada como true caso alguma empresa tenha sido selecionada.
        var inscricaoIsSelected = !!gimPbWidget.currentRow.CDINSCESTA;
        var inscricaoSubsField = gimPbWidget.getField('CDINSCESTAST');

        // Altera as propriedades do field de inscrição e reseta seu valor.
        inscricaoSubsField.readOnly = !inscricaoIsSelected;
        inscricaoSubsField.setValue(null);
        inscricaoSubsField.needReload = true;

        parametrosWidget.enabled = inscricaoIsSelected;
    };
    /**
     * Função que é invocada ao alterar o field NMPAIS,
     * habilitando o field SGESTADO
     */
    this.paisOnChange = function (gimPbWidget) {
        // Variável booleana que é setada como true caso alguma empresa tenha sido selecionada.
        var paisIsSelected = !!gimPbWidget.currentRow.NMPAIS;
        var estadoField = gimPbWidget.getField('SGESTADO');

        // Altera as propriedades do field de inscrição e reseta seu valor.
        estadoField.readOnly = !paisIsSelected;
        estadoField.setValue(null);
        estadoField.needReload = true;
    };
};
Configuration(function (ContextRegister) {
    ContextRegister.register("Fis07900_GimPb_Controller", Fis07900_GimPb_Controller);
});

// FILE: ./assets/modules/acessorias/assets/js/controllers/Fis08300_GiamTo_Controller.js
var Fis08300_GiamTo_Controller = function Fis08300_GiamTo_Controller(General, ScreenService, templateManager, Messages_fiscal, restEngine, ObrigacoesAcessoriasUtil) {

    var self = this;
    var DataSourceArray = [];

    this.tare = function (widget) {
        var portador = widget.currentRow.IDPORTTARE;
        var numero = widget.getField('NRTARE');
        var data = widget.getField('DTVALTARE');

        if (portador == 'S') {
            numero.readOnly = false;
            data.readOnly = false;
            data.validations.required = true;
        } else {
            numero.readOnly = true;
            data.readOnly = true;
            data.validations.required = false;
        }
    };

    var preencherCamposAbstratosParaSalvar = function preencherCamposAbstratosParaSalvar(parametrosWidget) {
        parametrosWidget.currentRow.CDCAMPO1 = parametrosWidget.currentRow.CDREPRES;
        parametrosWidget.currentRow.CDCAMPO2 = parametrosWidget.currentRow.IDRETIFIC;
        parametrosWidget.currentRow.CDCAMPO3 = parametrosWidget.currentRow.IDTPESTAB;
        parametrosWidget.currentRow.CDCAMPO4 = parametrosWidget.currentRow.CDTPESCRITU;
        parametrosWidget.currentRow.VRCAMPO1 = parametrosWidget.currentRow.SALDOINICX;
        parametrosWidget.currentRow.VRCAMPO2 = parametrosWidget.currentRow.SALDOFINCX;
        parametrosWidget.currentRow.CDCAMPO5 = parametrosWidget.currentRow.IDUSUARIOECF;
        parametrosWidget.currentRow.CDCAMPO6 = parametrosWidget.currentRow.CDVERSAO;
        parametrosWidget.currentRow.CDCAMPO7 = parametrosWidget.currentRow.IDPORTTARE;
        parametrosWidget.currentRow.CDCAMPO8 = parametrosWidget.currentRow.NRTARE;
        parametrosWidget.currentRow.DTCAMPO1 = parametrosWidget.currentRow.DTVALTARE;
        parametrosWidget.currentRow.CDCAMPO9 = parametrosWidget.currentRow.IDMUDAMUNI;
        parametrosWidget.currentRow.CDCAMPO10 = parametrosWidget.currentRow.CDMUNIANT;
        parametrosWidget.currentRow.DTCAMPO2 = parametrosWidget.currentRow.DTINIMUNIANT;
        parametrosWidget.currentRow.DTCAMPO3 = parametrosWidget.currentRow.DTFINMUNIANT;
        parametrosWidget.currentRow.DTCAMPO4 = parametrosWidget.currentRow.DTINIMUNIATU;
        parametrosWidget.currentRow.DTCAMPO5 = parametrosWidget.currentRow.DTFINMUNIATU;
    };

    var setParametersVerified = function setParametersVerified(widget) {
        var currentRow = widget.currentRow;
        var giamtoFiscalIsSelected = widget.name == "param_to";
        if (giamtoFiscalIsSelected) {
            // Verifica se o objeto já foi criado pra esta empresa.
            if (!widget.empresasLoaded[currentRow.CDEMPRESA]) {
                widget.empresasLoaded[currentRow.CDEMPRESA] = {};
            }
            // Seta o parâmetro para a empresa selecionada.
            widget.empresasLoaded[currentRow.CDEMPRESA] = true;
        } else {
            // Modifica a propriedade indicando que a parametrização foi
            // aberta para a empresa selecionada.
            widget.empresasLoaded[currentRow.CDEMPRESA] = true;
        }
    };

    this.validadata = function (widget) {
        var data_1 = widget.currentRow.DTINIMUNIANT;
        var data_2 = widget.currentRow.DTFINMUNIANT;
        var data_3 = widget.currentRow.DTINIMUNIATU;
        var data_4 = widget.currentRow.DTFINMUNIATU;
        var Compara01 = parseInt(data_1.split("/")[2].toString() + data_1.split("/")[1].toString() + data_1.split("/")[0].toString());
        var Compara02 = parseInt(data_2.split("/")[2].toString() + data_2.split("/")[1].toString() + data_2.split("/")[0].toString());
        var Compara03 = parseInt(data_3.split("/")[2].toString() + data_3.split("/")[1].toString() + data_3.split("/")[0].toString());
        var Compara04 = parseInt(data_4.split("/")[2].toString() + data_4.split("/")[1].toString() + data_4.split("/")[0].toString());

        if (Compara01 > Compara02) {
            ScreenService.showMessage('Data Inicial não pode ser maior que a data Final!');
        } else {}
    };

    this.mudanca = function (widget) {
        var mudanca = widget.currentRow.IDMUDAMUNI;
        var codigo = widget.getField('NMMUNICIPIO');
        var datainAnter = widget.getField('DTINIMUNIANT');
        var datafiAnter = widget.getField('DTFINMUNIANT');
        var datainAtual = widget.getField('DTINIMUNIATU');
        var datafiAtual = widget.getField('DTFINMUNIATU');

        if (mudanca == 'S') {
            codigo.readOnly = false;
            datainAnter.readOnly = false;
            datafiAnter.readOnly = false;
            datainAtual.readOnly = false;
            datafiAtual.readOnly = false;
            datainAnter.validations.required = true;
            datafiAnter.validations.required = true;
            datainAtual.validations.required = true;
        } else {
            codigo.readOnly = true;
            datainAnter.readOnly = true;
            datafiAnter.readOnly = true;
            datainAtual.readOnly = true;
            datafiAtual.readOnly = true;
            datainAnter.validations.required = false;
            datafiAnter.validations.required = false;
            datainAtual.validations.required = false;
        }
    };

    self.exportarGiam = function (validaToWidget) {
        // Verifica se todos os campos requeridos estão de fato preenchidos
        if (validaToWidget.isValid()) {
            // Verifica se a parametrização não foi carregada e verificada
            if (!parametrizacaoWasLoaded(validaToWidget)) {
                return;
            }
            var parametrosWidget = templateManager.container.getWidget('giamto');
            // Define propriedades na widget principal com valores dos fields
            // da tab de parametrização
            preenhcerPropriedadesWidgetPrincipal(validaToWidget, parametrosWidget);
            var param_to = templateManager.container.getWidget('param_to');
            var row = { current: validaToWidget.currentRow, dataset: param_to.dataSource.data };
            var route = 'fis#/exportar';
            var message = Messages_fiscal.EXPORTANDO_GIA_TO;
            ObrigacoesAcessoriasUtil.exportarArquivo(row, route, message);
        }
    };

    self.exportarDif = function (widget) {

        // Verifica se todos os campos requeridos estão de fato preenchidos
        if (widget.isValid()) {
            var param_dif = templateManager.container.getWidget('param_dif');

            var row = [widget.currentRow, param_dif.currentRow];
            var route = 'fis#/exportardif';
            var message = "Exportando DIF TO";
            ObrigacoesAcessoriasUtil.exportarArquivo(row, route, message);
        }
    };
    /**
     * Função auxiliar que verifica se a tab de parametrização foi aberta ao exportar,
     * através da propriedade 'empresasLoaded'.
     */
    var parametrizacaoWasLoaded = function parametrizacaoWasLoaded(widget) {
        var parametrizacaoWasLoaded;
        var parametrosWidget;
        var cdEmpresa = widget.currentRow.CDEMPRESA;
        parametrosWidget = templateManager.container.getWidget('giamto');

        // Verifica se a widget de parametrização não foi aberta antes de
        // clicar no botão de exportar
        if (!parametrizacaoWasLoaded) {
            // Muda a propriedade para que a parametrização seja obrigatória
            parametrosWidget.parametersRequired = true;
            // Exibe mensagem indicando a obrigatoriedae da verificação dos parametros
            ScreenService.showMessage(Messages_fiscal.PARAMETROS_GERAIS_NAO_INFORMADOS_ERROR).then(function () {
                // Abre a widget/tab de parâmetros
                openTabParametrosGerais(parametrosWidget);
                return true;
            });
        }
        // Retorna true, caso a parametrização já tenha sido aberta
        return true;
    };
    /**
     * Função auxiliar que abre a tab de parâmetros pela primeira vez.
     */
    var openTabParametrosGerais = function openTabParametrosGerais(parametrosWidget) {
        // Recarrega os dados (dataSource) parametrizados
        parametrosWidget.reload().then(function () {
            // Redesenha os dados carregados na tab
            parametrosWidget.redraw();
        });
        // Define a tab de parametricação como ativa
        parametrosWidget.activate();
    };
    /**
     * Função auxiliar que cria e preenche propriedades da widget principal,
     * com os valores das fields da tab de parâmetros
     */
    var preenhcerPropriedadesWidgetPrincipal = function preenhcerPropriedadesWidgetPrincipal(widget, parametrosWidget) {
        widget.currentRow.CDCAMPO1 = parametrosWidget.currentRow.CDREPRES;
        widget.currentRow.CDCAMPO2 = parametrosWidget.currentRow.IDRETIFIC;
        widget.currentRow.CDCAMPO3 = parametrosWidget.currentRow.IDTPESTAB;
        widget.currentRow.CDCAMPO4 = parametrosWidget.currentRow.CDTPESCRITU;
        widget.currentRow.VRCAMPO1 = parametrosWidget.currentRow.SALDOINICX;
        widget.currentRow.VRCAMPO2 = parametrosWidget.currentRow.SALDOFINCX;
        widget.currentRow.CDCAMPO5 = parametrosWidget.currentRow.IDUSUARIOECF;
        widget.currentRow.CDCAMPO6 = parametrosWidget.currentRow.CDVERSAO;
        widget.currentRow.CDCAMPO7 = parametrosWidget.currentRow.IDPORTTARE;
        widget.currentRow.CDCAMPO8 = parametrosWidget.currentRow.NRTARE;
        widget.currentRow.DTCAMPO1 = parametrosWidget.currentRow.DTVALTARE;
        widget.currentRow.CDCAMPO9 = parametrosWidget.currentRow.IDMUDAMUNI;
        widget.currentRow.CDCAMPO10 = parametrosWidget.currentRow.CDMUNIANT;
        widget.currentRow.DTCAMPO2 = parametrosWidget.currentRow.DTINIMUNIANT;
        widget.currentRow.DTCAMPO3 = parametrosWidget.currentRow.DTFINMUNIANT;
        widget.currentRow.DTCAMPO4 = parametrosWidget.currentRow.DTINIMUNIATU;
        widget.currentRow.DTCAMPO5 = parametrosWidget.currentRow.DTFINMUNIATU;
    };

    self.salvarParametrizacao = function (parametrosWidget) {
        // Verifica se todos os campos requeridos estão de fato preenchidos
        if (parametrosWidget.isValid()) {
            var validaToWidget = templateManager.container.getWidget('giamto');

            preencherCamposAbstratosParaSalvar(parametrosWidget);
            var filter = [{
                "name": "CDEMPRESA",
                "operator": "=",
                "value": validaToWidget.currentRow.CDEMPRESA
            }, {
                "name": "CDINSCESTA",
                "operator": "=",
                "value": validaToWidget.currentRow.CDINSCESTA
            }, {
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar('NRORG')
            }];

            General.callRestEngine('fis_acessorias#/crud/paramdeclaces_GiamTo', 'FilterData', filter).then(function (result) {
                result = result.dataset.paramdeclaces_GiamTo;

                if (result.length != 0) parametrosWidget.currentRow.__is_new = false;

                parametrosWidget.saveRow().then(function () {
                    // Seta os parametros como verificados pelo usuário
                    setParametersVerified(parametrosWidget);
                    // Ativa a widget principal
                    validaToWidget.activate();
                    validaToWidget.currentWidget = validaToWidget;

                    DataSourceArray = result.dataset.paramdeclaces_GiamTo;

                    /**
                     * Verifica se a tela de parâmetros foi exibida devido a uma tentativa
                     * de exportação. Caso positivo, a exportação é efetuada
                     */
                    if (parametrosWidget.parametersRequired) {
                        self.exportarGiam(validaToWidget);
                        // Valida a propriedade para false, caso a tela de parametros seja
                        // novamente aberta. E assim não haverá exportação sempre ao sair
                        parametrosWidget.parametersRequired = false;
                    }
                });
            });
        }
    };

    self.setLoadedParameters = function (parametrosWidget) {
        var giamtoWidget = templateManager.container.getWidget("giamto");
        if (DataSourceArray.length > 0) {
            if (DataSourceArray == "" || DataSourceArray[0].CDINSCRICAO == giamtoWidget.currentRow.CDINSCESTA) {
                parametrosWidget.dataSource.data = DataSourceArray[0];
            } else {}
        }
        if (parametrosWidget.dataSource.data.length > 0) {
            // Seta a currentRow como sendo o primeiro indice do data[] retornado
            parametrosWidget.moveToFirst();
            // Redesenha na widget principal, os fields com os valores da nova 
            // currentRow
            parametrosWidget.redraw();
        } else {
            // Seta a widget em modo de novo dado, para inserir a parametrização
            parametrosWidget.newRow();
            parametrosWidget.currentRow.CDEMPRESA = giamtoWidget.currentRow.CDEMPRESA;
        }
        // Seta o nome da empresa no campo select de empresa, devido a um
        // comportamento que não exibe o nome da empresa correspondente ao código.
        parametrosWidget.currentRow.NMEMPRESA = giamtoWidget.currentRow.NMEMPRESA;
    };
    /**
     * Função invocada ao sair da widget de parametros, que seta os mesmos como 
     * verificados
     */
    self.beforeExitParametrosGerais = function (parametrosWidget) {
        // Seta a parametrização como verificada somente se a widget não estiver
        // em modo de inserção, mas sim de verificação
        if (!parametrosWidget.isNewRow()) {
            setParametersVerified(parametrosWidget);
        }
    };

    this.salvar = function (args) {
        var widget = args;
        var validaToWidget = templateManager.container.getWidget('giamto');
        preencherCamposAbstratosParaSalvar(widget);
        var filter = [{
            "name": "CDEMPRESA",
            "operator": "=",
            "value": validaToWidget.currentRow.CDEMPRESA
        }, {
            "name": "CDINSCESTA",
            "operator": "=",
            "value": validaToWidget.currentRow.CDINSCESTA
        }, {
            "name": "NRORG",
            "operator": "=",
            "value": getLocalVar('NRORG')
        }];

        General.saveCrud(widget).then(function (Success) {}.bind(this), function (callback) {
            if (callback.data) {
                ScreenService.showMessage(callback.data.error);
            }
        });
    };

    self.salvarParametrizacao = function (parametrosWidget) {
        var currentRow = parametrosWidget.currentRow;
        var difto = templateManager.container.getWidget('difto');
        var filter = [{
            "name": "CDEMPRESA",
            "operator": "=",
            "value": difto.currentRow.CDEMPRESA
        }, {
            "name": "CDINSCESTA",
            "operator": "=",
            "value": difto.currentRow.CDINSCESTA
        }, {
            "name": "NRORG",
            "operator": "=",
            "value": getLocalVar('NRORG')
        }];
        parametrosWidget.currentRow.CDEMPRESA = difto.currentRow.CDEMPRESA;
        parametrosWidget.currentRow.CDINSCESTA = difto.currentRow.CDINSCESTA;
        if (currentRow.__is_new == false) {
            General.callRestEngine('fis#/updateDifTo', 'Row', parametrosWidget.currentRow).then(function (success) {
                ScreenService.goBack();
                parametrosWidget.reload();
            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });
        } else {
            restEngine.post('fis#/saveDifTo', {
                "requestType": "DataSet",
                "dataset": [currentRow]
            }).then(function (sucesso) {
                parametrosWidget.currentRow.__is_new = false;
            });
        }
    };
};
Configuration(function (ContextRegister) {
    ContextRegister.register("Fis08300_GiamTo_Controller", Fis08300_GiamTo_Controller);
});

// FILE: ./assets/modules/acessorias/assets/js/controllers/Fis11000_CompraLegalBa_Controller.js
var Fis11000_CompraLegalBa_Controller = function Fis11000_CompraLegalBa_Controller(General, ScreenService, templateManager, Messages_fiscal, ObrigacoesAcessoriasUtil, ZhFilterPreferences, ZHPromise, restEngine) {

    var self = this;
    var errorMessageExport = '';

    self.addAgendamento = function (widget) {
        widget.newRow();
        widget.getField('DTREFINI').isVisible = true;
    };

    self.cancelAgendamento = function (args) {
        General.backOrCancel(args);
        General.changeWidgetAcessibility(args.owner.widget.widgets, true);
        args.owner.widget.getField('DTREFINI').isVisible = true;
    };

    self.editAgendamento = function (widget) {
        General.edit(widget);
        this.periodicidadeOnChange(widget);
    };

    self.saveAgendamento = function (widget) {
        if (widget.isValid()) {
            var d1 = new Date(moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY HH:mm').format('MM/DD/YYYY HH:mm'));
            var d2 = new Date(moment().format('MM/DD/YYYY HH:mm'));

            if (d1.getTime() > d2.getTime()) {
                if ((widget.currentRow.CDINSCESTA == '' || widget.currentRow.CDINSCESTA == null) && widget.currentRow.CDEMPRESA) {
                    widget.currentRow.CDINSCESTA = "T";
                }

                widget.currentRow.NRORG = getLocalVar('NRORG');

                General.callRestEngine('fis_acessorias#/saveAgendamentoCompraLegalBa', 'Row', widget.currentRow).then(function (success) {
                    General.changeWidgetAcessibility(widget.widgets, true);
                    ScreenService.showMessage('Agendado com sucesso.');
                    ScreenService.goBack();
                    widget.getField('DTREFINI').isVisible = true;
                    widget.reload();
                }, function (error) {
                    ScreenService.showMessage(error.data.error);
                });
            } else {
                ScreenService.showMessage('A Data de Agendamento deve ser maior que a data atual, e não pode ser igual a hora atual!');
            }
        } else {
            // @todo create messages class
            ScreenService.showMessage("Preencha todos os campos corretamente!");
        }
    };

    self.downloadArquivoAgendado = function (compraLegalBaWidget) {
        var downloadRoute;
        var fileName;

        if (compraLegalBaWidget.hasCheckedRows()) {
            var rows = compraLegalBaWidget.getCheckedRows();
            rows.forEach(function (row) {
                downloadRoute = window.serviceUrls.filter(function (x) {
                    return x.package == 'fis';
                })[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
                fileName = row.NMARQUIVO;

                window.open(downloadRoute + fileName);
            });
        } else {
            var row = compraLegalBaWidget.currentRow;
            downloadRoute = window.serviceUrls.filter(function (x) {
                return x.package == 'fis';
            })[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
            fileName = row.NMARQUIVO;

            window.open(downloadRoute + fileName);
        }
    };

    self.deleteAgendamento = function (widget) {
        widget.currentRow.NRORG = getLocalVar('NRORG');

        ScreenService.confirmMessage(ScreenService.i18n('Deletar Agendamento?'), 'question', function (success) {
            General.callRestEngine('fis_acessorias#/deleteAgendamentoCompraLegalBa', 'Row', widget.currentRow).then(function (success) {
                ScreenService.showMessage('Deletado com sucesso.');
                ScreenService.goBack();
                widget.reload();
            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });
        });
    };

    self.periodicidadeOnChange = function (widget) {
        if (widget.currentRow.IDPERIAGEN == 0) {
            widget.getField('DTREFINI').isVisible = true;
        } else if (widget.currentRow.IDPERIAGEN == 1) {
            widget.getField('DTREFINI').isVisible = false;
            if (widget.currentRow.DTAGENDAMENTO && widget.currentRow.DTAGENDAMENTO != "") {
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').format('DD/MM/YYYY');
            }
        } else if (widget.currentRow.IDPERIAGEN == 2) {
            widget.getField('DTREFINI').isVisible = false;
            if (widget.currentRow.DTAGENDAMENTO && widget.currentRow.DTAGENDAMENTO != "") {
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').subtract(1, 'M').format('DD/MM/YYYY');
            }
        }
        widget.getField('DTREFINI').reload();
    };

    /**
     * Função para a chamada de Exportação
     */
    self.exportarCompraLegalBa = function (compraLegalBaWidgetGrid) {
        errorMessageExport = '';
        var lista = '';

        // Verifica se todos os campos requeridos estão de fato preenchidos
        if (compraLegalBaWidgetGrid.isValid() && compraLegalBaWidgetGrid.getParent().isValid()) {
            if (compraLegalBaWidgetGrid.hasCheckedRows() == true) {
                General.callRestEngine('fis_acessorias#/saveListaCompraLegalBa', 'DataSet', compraLegalBaWidgetGrid.getCheckedRows()).then(function (success) {
                    var distInscEst = [];
                    var map = new Map();
                    compraLegalBaWidgetGrid.getCheckedRows().forEach(function (item) {
                        if (!map.has(item.CDINSCESTA)) {
                            map.set(item.CDINSCESTA, true); // set any value to Map
                            distInscEst.push({
                                CDINSCESTA: item.CDINSCESTA
                            });
                        }
                    });
                    //[...new Set(compraLegalBaWidgetGrid.getCheckedRows().map(row => row.CDINSCESTA))];
                    distInscEst.forEach(function (inscrestad, index, array) {

                        compraLegalBaWidgetGrid.appliedFilter.FILTER_ROW.NRORG = getLocalVar('NRORG');
                        lista = success.dataset.columnsToReturn.NRLISTA;

                        var row = {
                            'header': compraLegalBaWidgetGrid.getParent().currentRow,
                            'filter': compraLegalBaWidgetGrid.appliedFilter.FILTER_ROW,
                            'nrlista': success.dataset.columnsToReturn.NRLISTA,
                            'inscrestad': inscrestad.CDINSCESTA
                        };
                        var route = 'fis#/exportarCompraLegalBa';

                        var message = Messages_fiscal.EXPORTANDO_COMPRA_LEGAL_BA;

                        self.exportarArquivo(row, route, message).then(function (success) {
                            General.callRestEngine('fis_acessorias#/deleteListaCompraLegalBa', 'Row', { 'NRLISTA': lista });
                            if (errorMessageExport !== '') {
                                ScreenService.showMessage(errorMessageExport);
                            }
                        }, function (error) {
                            General.callRestEngine('fis_acessorias#/deleteListaCompraLegalBa', 'Row', { 'NRLISTA': lista });
                            if (errorMessageExport !== '') {
                                ScreenService.showMessage(errorMessageExport);
                            }
                        });
                    });
                }, function (error) {
                    ScreenService.showMessage(error.data.error);
                });
            } else {
                ScreenService.showMessage("Selecione no mínimo uma nota fiscal.");
            }
        }
    };

    self.onChangeEmpresa = function (compraLegalBaWidget) {
        if (compraLegalBaWidget.currentRow.CDEMPRESA) ZhFilterPreferences.openFilterWidget(templateManager.container.getWidget('compra_legal_ba_grid'));
    };

    self.onEnterCompraLegal = function () {
        templateManager.container.getWidget('compra_legal_ba_grid').activate();
    };

    self.aplicaDataSourceFilter = function () {
        var widgetFiltro = templateManager.container.getActiveWidget().currentRow;
        var widgetCompraLegalGrid = templateManager.container.getWidget('compra_legal_ba_grid');

        var cdempresa = widgetCompraLegalGrid.getParent().currentRow.CDEMPRESA;
        var nrnotafisc = !widgetFiltro.NRNOTAFISC ? "" : widgetFiltro.NRNOTAFISC;
        var cdfilial = !widgetFiltro.CDFILIAL ? "" : widgetFiltro.CDFILIAL;
        var nrinsjurclie = !widgetFiltro.NRINSJURCLIE ? "" : widgetFiltro.NRINSJURCLIE;
        var cdinscesta = !widgetFiltro.CDINSCESTA ? "" : widgetFiltro.CDINSCESTA;
        var cdinscmuni = !widgetFiltro.CDINSCMUNI ? "" : widgetFiltro.CDINSCMUNI;
        var cdserie = !widgetFiltro.CDSERIE ? "" : widgetFiltro.CDSERIE;
        var cdtipooper = !widgetFiltro.CDTIPOOPER ? "" : widgetFiltro.CDTIPOOPER;
        var dtinicial = !widgetFiltro.PERIODO.start ? "" : widgetFiltro.PERIODO.start;
        var dtfinal = !widgetFiltro.PERIODO.end ? "" : widgetFiltro.PERIODO.end;
        var idnfcompraleg = !widgetFiltro.IDSTATUS ? "" : widgetFiltro.IDSTATUS;
        var vrnotafisc = !widgetFiltro.VRNOTAFISC || widgetFiltro.VRNOTAFISC == null ? 0 : widgetFiltro.currentRow.VRNOTAFISC;
        var nrorg = getLocalVar('NRORG');

        widgetCompraLegalGrid.dataSourceFilter = [];

        widgetCompraLegalGrid.dataSourceFilter.push({ name: "P_CDEMPRESA", operator: "=", value: cdempresa });
        widgetCompraLegalGrid.dataSourceFilter.push({ name: "P_NRNOTAFISC", operator: "=", value: nrnotafisc });
        widgetCompraLegalGrid.dataSourceFilter.push({ name: "P_TNRNOTAFISC", operator: "=", value: "T" });
        widgetCompraLegalGrid.dataSourceFilter.push({ name: "P_CDFILIEMIT", operator: "=", value: cdfilial });
        widgetCompraLegalGrid.dataSourceFilter.push({ name: "P_TCDFILIEMIT", operator: "=", value: "T" });
        widgetCompraLegalGrid.dataSourceFilter.push({ name: "P_NRINSJURNF", operator: "=", value: nrinsjurclie });
        widgetCompraLegalGrid.dataSourceFilter.push({ name: "P_TNRINSJURNF", operator: "=", value: "T" });
        widgetCompraLegalGrid.dataSourceFilter.push({ name: "P_CDINSCESTA", operator: "=", value: cdinscesta });
        widgetCompraLegalGrid.dataSourceFilter.push({ name: "P_TCDINSCESTA", operator: "=", value: "T" });
        widgetCompraLegalGrid.dataSourceFilter.push({ name: "P_CDINSCMUNI", operator: "=", value: cdinscmuni });
        widgetCompraLegalGrid.dataSourceFilter.push({ name: "P_TCDINSCMUNI", operator: "=", value: "T" });
        widgetCompraLegalGrid.dataSourceFilter.push({ name: "P_CDSERIE", operator: "=", value: cdserie });
        widgetCompraLegalGrid.dataSourceFilter.push({ name: "P_TCDSERIE", operator: "=", value: "T" });
        widgetCompraLegalGrid.dataSourceFilter.push({ name: "P_CDTIPOOPER", operator: "=", value: cdtipooper });
        widgetCompraLegalGrid.dataSourceFilter.push({ name: "P_TCDTIPOOPER", operator: "=", value: "T" });
        widgetCompraLegalGrid.dataSourceFilter.push({ name: "P_DTINICIAL", operator: "=", value: dtinicial });
        widgetCompraLegalGrid.dataSourceFilter.push({ name: "P_DTFINAL", operator: "=", value: dtfinal });
        if (idnfcompraleg != 'A') widgetCompraLegalGrid.dataSourceFilter.push({ name: "P_IDNFCOMPRALEG", operator: "=", value: idnfcompraleg });
        widgetCompraLegalGrid.dataSourceFilter.push({ name: "P_VRNOTAFISC", operator: "=", value: vrnotafisc });
        widgetCompraLegalGrid.dataSourceFilter.push({ name: "NRORG", operator: "=", value: nrorg });

        widgetCompraLegalGrid.reload();
    };

    self.exportarArquivo = function (row, route, message) {
        // Inicializa uma promise.
        var deferred = ZHPromise.defer();
        message = message || Messages_fiscal.EXPORTANDO;

        // Muda a mensagem de carregamento para uma mensagem personalizada.
        ScreenService.changeLoadingMessage(message);

        // Chama a rota para efetuar a exportação.
        restEngine.request(route, { "requestType": "Row", "row": row }, undefined, undefined, undefined, undefined, 99999999999999999999).then(function (response) {
            // Cria a rota a ser chamada para o download do arquivo exportado.
            var downloadRoute = window.serviceUrls.filter(function (x) {
                return x.package == 'fis';
            })[0].baseUrl + "/downloadArquivo?requestType=Row&row[DSARQUIVO]=";
            var fileName = response.dataset.columnsToReturn.fileName;

            // Abre a rota em uma nova janela, permitindo que o arquivo seja baixado.
            window.open(downloadRoute + fileName);

            // Finaliza a promise com sucesso.
            deferred.resolve(response);
        }).catch(function (error) {
            // Mensagem padrão em caso de timeout.

            // Verifica se houve alguma resposta da requisição.
            if (error.data && error.data.error) {
                // Caso haja alguma resposta, atribui a mensagem de erro.
                errorMessageExport = errorMessageExport + ' Erro na inscrição: ' + row.inscrestad + '. ' + error.data.error + '<br />';
            } else {
                errorMessageExport = errorMessageExport + ' Erro na inscrição: ' + row.inscrestad + '. ' + Messages_fiscal.TIMEOUT_ERROR + '<br />';
            }

            // Imprime a mensagem.
            //ScreenService.showMessage(errorMessageExport);

            // Finaliza a promise retornando o objeto de erro.
            deferred.reject(error);
        }).finally(function () {
            // Restaura a mensagem original.
            ScreenService.restoreDefaultLoadingMessage();
        });

        // Retorna a promise a ser finalizada.
        return deferred;
    };

    self.changeNotaFiscalFilter = function () {
        var agendamentoWidget = templateManager.container.getWidget('compra_legal_ba_agendamento');
        var notaFiscalWidget = agendamentoWidget.widgets[0];

        notaFiscalWidget.dataSourceFilter.forEach(function (filter, index) {
            if (filter.name === 'P_CDEMPRESA') {
                filter.value = agendamentoWidget.currentRow.CDEMPRESA;
            } else if (filter.name === 'P_DTINICIAL') {
                filter.value = agendamentoWidget.currentRow.DTINICIAL.substr(0, 10);
            } else if (filter.name === 'P_DTFINAL') {
                filter.value = agendamentoWidget.currentRow.DTFINAL.substr(0, 10);
            }
            if (filter.name == 'IDSTATUS') {
                notaFiscalWidget.dataSourceFilter.splice(index);
            }
        });
        notaFiscalWidget.reload();
    };
};
Configuration(function (ContextRegister) {
    ContextRegister.register("Fis11000_CompraLegalBa_Controller", Fis11000_CompraLegalBa_Controller);
});

// FILE: ./assets/modules/acessorias/assets/js/controllers/Fis26000_GmaIcmsSt_Controller.js
var Fis26000_GmaIcmsSt_Controller = function Fis26000_GmaIcmsSt_Controller(General, ScreenService, Messages_fiscal, ObrigacoesAcessoriasUtil) {

    var self = this;

    self.addAgendamento = function (widget) {
        widget.newRow();
        widget.getField('DTREFINI').isVisible = true;
    };

    self.cancelAgendamento = function (args) {
        General.backOrCancel(args);
        General.changeWidgetAcessibility(args.owner.widget.widgets, true);
        args.owner.widget.getField('DTREFINI').isVisible = true;
    };

    self.editAgendamento = function (widget) {
        General.edit(widget);
        this.periodicidadeOnChange(widget);
    };

    self.saveAgendamento = function (widget) {
        if (widget.isValid()) {
            var d1 = new Date(moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY HH:mm').format('MM/DD/YYYY HH:mm'));
            var d2 = new Date(moment().format('MM/DD/YYYY HH:mm'));

            if (d1.getTime() > d2.getTime()) {
                if ((widget.currentRow.CDINSCESTA == '' || widget.currentRow.CDINSCESTA == null) && widget.currentRow.CDEMPRESA) {
                    widget.currentRow.CDINSCESTA = "T";
                }

                widget.currentRow.NRORG = getLocalVar('NRORG');

                General.callRestEngine('fis_acessorias#/saveAgendamentoGiaIcmsSt', 'Row', widget.currentRow).then(function (success) {
                    General.changeWidgetAcessibility(widget.widgets, true);
                    ScreenService.showMessage('Agendado com sucesso.');
                    ScreenService.goBack();
                    widget.getField('DTREFINI').isVisible = true;
                    widget.reload();
                }, function (error) {
                    ScreenService.showMessage(error.data.error);
                });
            } else {
                ScreenService.showMessage('A Data de Agendamento deve ser maior que a data atual, e não pode ser igual a hora atual!');
            }
        } else {
            // @todo create messages class
            ScreenService.showMessage("Preencha todos os campos corretamente!");
        }
    };

    self.downloadArquivoAgendado = function (spedWidget) {
        var downloadRoute;
        var fileName;

        if (spedWidget.hasCheckedRows()) {
            var rows = spedWidget.getCheckedRows();
            rows.forEach(function (row) {
                downloadRoute = window.serviceUrls.filter(function (x) {
                    return x.package == 'fis';
                })[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
                fileName = row.NMARQUIVO;

                window.open(downloadRoute + fileName);
            });
        } else {
            var row = spedWidget.currentRow;
            downloadRoute = window.serviceUrls.filter(function (x) {
                return x.package == 'fis';
            })[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
            fileName = row.NMARQUIVO;

            window.open(downloadRoute + fileName);
        }
    };

    self.deleteAgendamento = function (widget) {
        widget.currentRow.NRORG = getLocalVar('NRORG');

        ScreenService.confirmMessage(ScreenService.i18n('Deletar Agendamento?'), 'question', function (success) {
            General.callRestEngine('fis_acessorias#/deleteAgendamentoGiaIcmsSt', 'Row', widget.currentRow).then(function (success) {
                ScreenService.showMessage('Deletado com sucesso.');
                ScreenService.goBack();
                widget.reload();
            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });
        });
    };

    self.periodicidadeOnChange = function (widget) {
        if (widget.currentRow.IDPERIAGEN == 0) {
            widget.getField('DTREFINI').isVisible = true;
        } else if (widget.currentRow.IDPERIAGEN == 1) {
            widget.getField('DTREFINI').isVisible = false;
            if (widget.currentRow.DTAGENDAMENTO && widget.currentRow.DTAGENDAMENTO != "") {
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').format('DD/MM/YYYY');
            }
        } else if (widget.currentRow.IDPERIAGEN == 2) {
            widget.getField('DTREFINI').isVisible = false;
            if (widget.currentRow.DTAGENDAMENTO && widget.currentRow.DTAGENDAMENTO != "") {
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').subtract(1, 'M').format('DD/MM/YYYY');
            }
        }
        widget.getField('DTREFINI').reload();
    };

    /*
     * Função para a chamada da função de exportação.
     */
    this.exportarGia = function (giaicmsWidget) {
        if (giaicmsWidget.isValid()) {
            var row = giaicmsWidget.currentRow;
            var route = "fis#/exportarGiaIcmsSt";
            var message = Messages_fiscal.EXPORTANDO_GIA;
            ObrigacoesAcessoriasUtil.exportarArquivo(row, route, message);
        }
    };

    /*
     * Função para alterar a propriedade readOnly dos campos de inscrição,
     * conforme a inserção da empresa.
     */
    this.empresaOnChange = function (giaicmsWidget) {
        // Valida inscrição estadual.
        ObrigacoesAcessoriasUtil.empresaOnChange(giaicmsWidget);
        // Valida inscrição do substituto.
        this.inscricaoEstadualOnChange(giaicmsWidget);
    };

    /*
     * Função para alterar a propriedade readOnly do campo de inscrição do
     * substituto, conforme a inserção da inscrição estadual.
     */
    this.inscricaoEstadualOnChange = function (giaicmsWidget) {
        // Variável booleana que é setada como true caso alguma inscrição estadual
        // tenha sido selecionada.
        var inscricaoEstadualIsSelected = !!giaicmsWidget.currentRow.CDINSCESTA;
        var inscricaoSubstitutoField = giaicmsWidget.getField('CDINSCESTAST');
        var operacaoField = giaicmsWidget.getField('OPTRANSFER');
        var versaoField = giaicmsWidget.getField('VERSAO');

        // Altera as propriedades do field de inscrição do substituto e
        // reseta seu valor.
        inscricaoSubstitutoField.readOnly = !inscricaoEstadualIsSelected;
        inscricaoSubstitutoField.setValue(null);
        inscricaoSubstitutoField.needReload = true;
        versaoField.readOnly = !inscricaoEstadualIsSelected;
        versaoField.setValue(null);
        operacaoField.readOnly = !inscricaoEstadualIsSelected;
        operacaoField.hideEmptyValue = inscricaoEstadualIsSelected;
        giaicmsWidget.currentRow.OPTRANSFER = "";
        if (inscricaoEstadualIsSelected) {
            this.findLastRowData(giaicmsWidget.name, giaicmsWidget.currentRow);
        }
    };

    this.findLastRowData = function (widgetName, row) {
        ObrigacoesAcessoriasUtil.findLastRowData(widgetName, row).then(function (response) {
            var lastRowData = response.dataset.columnsToReturn.lastRowData;
            if (lastRowData.length > 0) {
                row.OPTRANSFER = lastRowData[0].OPTRANSFER;
                row.VERSAO = lastRowData[0].VERSAO;
            }
        });
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis26000_GmaIcmsSt_Controller', Fis26000_GmaIcmsSt_Controller);
});

// FILE: ./assets/modules/acessorias/assets/js/controllers/Fis41200_Configuracao_Controller.js
var Fis41200_Configuracao_Controller = function Fis41200_Configuracao_Controller(ZhFilterPreferences, ScreenService, templateManager, restEngine, General) {

    // Armazena o escopo atual.
    var self = this;

    self.openConfig = function (widget) {
        ScreenService.openWindow("fis_acessorias#fis41200_configuracao");
    };

    self.changeActions = function (widget) {
        General.callRestEngine('fis#/crud/configurasmtp', 'FilterData', []).then(function (sucesso) {
            if (sucesso.dataset.configurasmtp.length == 0) {
                widget.actions.forEach(function (action) {
                    if (action.name == 'adicionar') {
                        action.isVisible = true;
                    } else if (action.name == 'edit') {
                        action.isVisible = false;
                    }
                });
                widget.reload();
            } else {
                widget.actions.forEach(function (action) {
                    if (action.name == 'adicionar') {
                        action.isVisible = false;
                    } else if (action.name == 'edit') {
                        action.isVisible = true;
                    }
                });
                widget.currentRow = sucesso.dataset.configurasmtp[0];
                widget.reload();
            }
        });
    };

    self.reloadAndMoveToFirst = function (field) {
        var widget = templateManager.container.getWidget('fis75001_parametros_EFD_reinf_form');
        if (!Util.isEmptyOrBlank(field.value())) {
            widget.reload().then(function () {
                var existeData = widget.dataSource.data[0] ? true : false;
                widget.currentRow = existeData ? widget.dataSource.data[0] : {};
                widget.currentRow.CDEMPRESA = field.value();
                widget.getField('DSDIRCERTIFICADO').fileList = widget.currentRow.DSDIRCERTIFICADO;
                widget.getAction('edit').isVisible = existeData;
                widget.getAction('edit').readOnly = !existeData;
                widget.getAction('adicionar').isVisible = !existeData;
                widget.getAction('adicionar').readOnly = existeData;
                widget.redraw();
            }, function (error) {
                ScreenService.errorNotification(error);
                widget.getAction('edit').readOnly = false;
                widget.getAction('adicionar').readOnly = false;
                widget.redraw();
            });
        } else {
            widget.currentRow = {};
            widget.getAction('edit').isVisible = false;
            widget.getAction('edit').readOnly = false;
            widget.getAction('adicionar').isVisible = true;
            widget.getAction('adicionar').readOnly = true;
            widget.redraw();
        }
    };

    self.saveCrud = function (widget) {
        var currentRow = widget.currentRow;
        if (widget.isValid()) {
            General.saveCrud(widget).then(function (sucesso) {
                aftersave(widget);
                widget.currentRow.__is_new = false;
            });
        }
    };

    function aftersave(widget) {
        General.formWidgetSwitchTemplate(widget);
        widget.list();
        widget.reload().then(function () {
            var existeData = widget.dataSource.data[0] ? true : false;
            widget.currentRow = existeData ? widget.dataSource.data[0] : {};
        });
        templateManager.container.getWidget('fis41100_contatos').enabled = true;
        templateManager.container.getWidget('fis41100_contatos').reload();
        templateManager.updateTemplate();
    }

    self.widgetEdit = function (widget, isNew) {
        if (isNew) {
            widget.currentRow.__is_new = true;
            widget.currentRow.IDCRIPTSSL = 'N';
            widget.currentRow.IDCRIPTTLS = 'N';
        }
        General.widgetEdit(widget);
        templateManager.container.getWidget('fis41100_contatos').enabled = false;
        templateManager.container.getWidget('fis41100_contatos').reload();
        templateManager.updateTemplate();
    };

    self.cancel = function (args) {
        General.backOrCancel(args);
        General.formWidgetSwitchTemplate(args.owner.widget);
        args.owner.widget.list();
        templateManager.container.getWidget('fis41100_contatos').enabled = true;
        templateManager.container.getWidget('fis41100_contatos').reload();
        templateManager.updateTemplate();
    };

    self.empresaOnChange = function (widget) {
        if (widget.currentRow.NMEMPRESA && widget.currentRow.NMEMPRESA != '') {
            widget.getField('CDINSCESTA').readOnly = false;
            widget.getField('CDINSCESTA').clearValue();
        } else {
            widget.getField('CDINSCESTA').readOnly = true;
            widget.getField('CDINSCESTA').clearValue();
        }
        widget.getField('CDINSCESTA').reload();
    };

    self.openFilterContatos = function (widget) {
        var rowsToSet = {};
        ZhFilterPreferences.setOriginalFilter(widget.id, rowsToSet);
        ZhFilterPreferences.openFilterWidget(widget, rowsToSet);
    };

    self.newRowContatos = function (widget) {
        widget.newRow();
        widget.currentRow.IDAPURAAUTO = 'N';
        widget.currentRow.IDEXPORTAUTO = 'N';
    };

    self.saveContatos = function (widget) {
        if (widget.isValid()) {
            if (widget.currentRow.CDEMPRESA == '') {
                widget.currentRow.CDEMPRESA = 'T';
            }

            widget.currentRow.NRORG = getLocalVar('NRORG');
            widget.currentRow.CDOPERADOR = getLocalVar('CDOPERADOR');
            General.callRestEngine('fis_acessorias#/saveContatos', 'Row', widget.currentRow).then(function (sucesso) {
                ScreenService.goBack();
                widget.reload();
            }, function (error) {
                ScreenService.showMessage(error.dataset.error);
            });
        }
    };

    self.editContatos = function (widget) {
        if (!Array.isArray(widget.currentRow.CDEMPRESA)) {
            widget.currentRow.CDEMPRESA = [widget.currentRow.CDEMPRESA];
            widget.currentRow.NMEMPRESA = [widget.currentRow.NMEMPRESA];
            widget.getField('CDEMPRESA').reload();
            if (widget.currentRow.CDINSCRICAO && widget.currentRow.CDINSCRICAO != "") {
                widget.currentRow.CDINSCRICAO = [widget.currentRow.CDINSCRICAO];
                widget.getField('CDINSCRICAO').reload();
            }
            General.edit(widget);
        } else {
            General.edit(widget);
        }
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis41200_Configuracao_Controller', Fis41200_Configuracao_Controller);
});

// FILE: ./assets/modules/acessorias/assets/js/controllers/Fis45000_DesissBH_Controller.js
var Fis45000_DesissBH_Controller = function Fis45000_DesissBH_Controller(General, ScreenService, Messages_fiscal, ObrigacoesAcessoriasUtil) {

    var self = this;

    /*
     * Função para a chamada da função de exportação.
     */
    this.exportarDesissBH = function (DESWidget) {
        if (DESWidget.isValid()) {
            var row = DESWidget.currentRow;
            var route = "fis#/exportarDesissBH";
            var message = Messages_fiscal.EXPORTANDO_DES;
            ObrigacoesAcessoriasUtil.exportarArquivo(row, route, message);
        }
    };

    this.VERSAOOnClick = function (field) {
        if (!field.value()) {
            field.setValue(field.defaultValue);
            ScreenService.updateTemplate();
        }
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis45000_DesissBH_Controller', Fis45000_DesissBH_Controller);
});

// FILE: ./assets/modules/acessorias/assets/js/controllers/Fis47000_Sef2_Controller.js
var Fis_Sef2_Controller = function Fis_Sef2_Controller(General, ScreenService, templateManager, Messages_fiscal, ObrigacoesAcessoriasUtil) {

    var self = this;

    self.addAgendamento = function (widget) {
        widget.newRow();
        widget.getField('DTREFINI').isVisible = true;
    };

    self.cancelAgendamento = function (args) {
        General.backOrCancel(args);
        General.changeWidgetAcessibility(args.owner.widget.widgets, true);
        args.owner.widget.getField('DTREFINI').isVisible = true;
    };

    self.editAgendamento = function (widget) {
        General.edit(widget);
        this.periodicidadeOnChange(widget);
    };

    self.saveAgendamento = function (widget) {
        if (widget.isValid()) {
            var d1 = new Date(moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY HH:mm').format('MM/DD/YYYY HH:mm'));
            var d2 = new Date(moment().format('MM/DD/YYYY HH:mm'));

            if (d1.getTime() > d2.getTime()) {
                if ((widget.currentRow.CDINSCESTA == '' || widget.currentRow.CDINSCESTA == null) && widget.currentRow.CDEMPRESA) {
                    widget.currentRow.CDINSCESTA = "T";
                }

                widget.currentRow.NRORG = getLocalVar('NRORG');

                General.callRestEngine('fis_acessorias#/saveAgendamentoSef2', 'Row', widget.currentRow).then(function (success) {
                    General.changeWidgetAcessibility(widget.widgets, true);
                    ScreenService.showMessage('Agendado com sucesso.');
                    ScreenService.goBack();
                    widget.getField('DTREFINI').isVisible = true;
                    widget.reload();
                }, function (error) {
                    ScreenService.showMessage(error.data.error);
                });
            } else {
                ScreenService.showMessage('A Data de Agendamento deve ser maior que a data atual, e não pode ser igual a hora atual!');
            }
        } else {
            // @todo create messages class
            ScreenService.showMessage("Preencha todos os campos corretamente!");
        }
    };

    self.downloadArquivoAgendado = function (spedWidget) {
        var downloadRoute;
        var fileName;

        if (spedWidget.hasCheckedRows()) {
            var rows = spedWidget.getCheckedRows();
            rows.forEach(function (row) {
                downloadRoute = window.serviceUrls.filter(function (x) {
                    return x.package == 'fis';
                })[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
                fileName = row.NMARQUIVO;

                window.open(downloadRoute + fileName);
            });
        } else {
            var row = spedWidget.currentRow;
            downloadRoute = window.serviceUrls.filter(function (x) {
                return x.package == 'fis';
            })[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
            fileName = row.NMARQUIVO;

            window.open(downloadRoute + fileName);
        }
    };

    self.deleteAgendamento = function (widget) {
        widget.currentRow.NRORG = getLocalVar('NRORG');

        ScreenService.confirmMessage(ScreenService.i18n('Deletar Agendamento?'), 'question', function (success) {
            General.callRestEngine('fis_acessorias#/deleteAgendamentoSef2', 'Row', widget.currentRow).then(function (success) {
                ScreenService.showMessage('Deletado com sucesso.');
                ScreenService.goBack();
                widget.reload();
            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });
        });
    };

    self.periodicidadeOnChange = function (widget) {
        if (widget.currentRow.IDPERIAGEN == 0) {
            widget.getField('DTREFINI').isVisible = true;
        } else if (widget.currentRow.IDPERIAGEN == 1) {
            widget.getField('DTREFINI').isVisible = false;
            if (widget.currentRow.DTAGENDAMENTO && widget.currentRow.DTAGENDAMENTO != "") {
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').format('DD/MM/YYYY');
            }
        } else if (widget.currentRow.IDPERIAGEN == 2) {
            widget.getField('DTREFINI').isVisible = false;
            if (widget.currentRow.DTAGENDAMENTO && widget.currentRow.DTAGENDAMENTO != "") {
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').subtract(1, 'M').format('DD/MM/YYYY');
            }
        }
        widget.getField('DTREFINI').reload();
    };

    /**
     * Função para a chamada de Exportação
     */
    self.exportarSef2 = function (sef2Widget) {
        // Verifica se todos os campos requeridos estão de fato preenchidos
        if (sef2Widget.isValid()) {
            // Verifica se a parametrização não foi carregada e verificada
            if (!parametrizacaoWasLoaded(sef2Widget)) {
                return;
            }
            var parametrosWidget = templateManager.container.getWidget('parametrosGeraisSef2');
            // Define propriedades na widget principal com valores dos fields
            // da tab de parametrização
            preenhcerPropriedadesWidgetPrincipal(sef2Widget, parametrosWidget);
            var row = sef2Widget.currentRow;
            var route = 'fis#/exportarSef2';
            var message = Messages_fiscal.EXPORTANDO_SEF_II;
            ObrigacoesAcessoriasUtil.exportarArquivo(row, route, message);
        }
    };
    /**
     * Função auxiliar que verifica se a tab de parametrização foi aberta ao exportar,
     * através da propriedade 'empresasLoaded'.
     */
    var parametrizacaoWasLoaded = function parametrizacaoWasLoaded(sef2Widget) {
        var parametrizacaoWasLoaded;
        var parametrosWidget;
        var cdEmpresa = sef2Widget.currentRow.CDEMPRESA;
        parametrosWidget = templateManager.container.getWidget('parametrosGeraisSef2');
        // Verifica se a propriedade (CDEMPRESA) está setada para a empresa selecionada
        parametrizacaoWasLoaded = parametrosWidget.empresasLoaded[cdEmpresa];

        // Verifica se a widget de parametrização não foi aberta antes de
        // clicar no botão de exportar
        if (!parametrizacaoWasLoaded) {
            // Muda a propriedade para que a parametrização seja obrigatória
            parametrosWidget.parametersRequired = true;
            // Exibe mensagem indicando a obrigatoriedae da verificação dos parametros
            ScreenService.showMessage(Messages_fiscal.PARAMETROS_GERAIS_NAO_INFORMADOS_ERROR).then(function () {
                // Abre a widget/tab de parâmetros
                openTabParametrosGerais(parametrosWidget);
            });
            // Retorna false, indicando que a parametrização não foi previamente aberta
            return false;
        }
        // Retorna true, caso a parametrização já tenha sido aberta
        return true;
    };
    /**
     * Função auxiliar que abre a tab de parâmetros pela primeira vez.
     */
    var openTabParametrosGerais = function openTabParametrosGerais(parametrosWidget) {
        // Recarrega os dados (dataSource) parametrizados
        parametrosWidget.reload().then(function () {
            // Redesenha os dados carregados na tab
            parametrosWidget.redraw();
        });
        // Define a tab de parametricação como ativa
        parametrosWidget.activate();
    };
    /**
     * Função auxiliar que cria e preenche propriedades da widget principal,
     * com os valores das fields da tab de parâmetros
     */
    var preenhcerPropriedadesWidgetPrincipal = function preenhcerPropriedadesWidgetPrincipal(sef2Widget, parametrosWidget) {
        sef2Widget.currentRow.STSUFRAMA = parametrosWidget.currentRow.STSUFRAMA;
        sef2Widget.currentRow.STARQUIVO = parametrosWidget.currentRow.STARQUIVO;
        sef2Widget.currentRow.STVERSAO = parametrosWidget.currentRow.STVERSAO;
        sef2Widget.currentRow.STFINALIDADE = parametrosWidget.currentRow.STFINALIDADE;
        sef2Widget.currentRow.STREGINV = parametrosWidget.currentRow.STREGINV;
        sef2Widget.currentRow.STOPISS = parametrosWidget.currentRow.STOPISS;
        sef2Widget.currentRow.STOPIPI = parametrosWidget.currentRow.STOPIPI;
    };
    /**
     * Função para salvar os parâmetros informados - ou caso eles já existam,
     * apenas os confirmam para a exportação
     */
    self.salvarParametrizacao = function (parametrosWidget) {
        // Verifica se todos os campos requeridos estão de fato preenchidos
        if (parametrosWidget.isValid()) {
            var sef2Widget = templateManager.container.getWidget('Sef-ii');
            var stsuframa = parametrosWidget.currentRow.STSUFRAMA;
            // Valida se o campo Suframa tem apenas números
            if (isNaN(stsuframa)) {
                // Se não, mensagem de alerta é lançada
                ScreenService.showMessage('O campo Suframa deve ser numérico');
                return;
            }
            preencherCamposAbstratosParaSalvar(parametrosWidget);
            parametrosWidget.saveRow().then(function () {
                // Seta os parametros como verificados pelo usuário
                setParametersVerified(parametrosWidget);
                // Ativa a widget principal
                sef2Widget.activate();
                sef2Widget.currentWidget = sef2Widget;
                /**
                 * Verifica se a tela de parâmetros foi exibida devido a uma tentativa
                 * de exportação. Caso positivo, a exportação é efetuada
                 */
                if (parametrosWidget.parametersRequired) {
                    self.exportarSef2(sef2Widget);
                    // Valida a propriedade para false, caso a tela de parametros seja
                    // novamente aberta. E assim não haverá exportação sempre ao sair
                    parametrosWidget.parametersRequired = false;
                }
            });
        }
    };

    var preencherCamposAbstratosParaSalvar = function preencherCamposAbstratosParaSalvar(parametrosWidget) {
        parametrosWidget.currentRow.CDCAMPO1 = parametrosWidget.currentRow.STSUFRAMA;
        parametrosWidget.currentRow.CDCAMPO9 = parametrosWidget.currentRow.STARQUIVO;
        parametrosWidget.currentRow.CDCAMPO2 = parametrosWidget.currentRow.STVERSAO;
        parametrosWidget.currentRow.CDCAMPO3 = parametrosWidget.currentRow.STFINALIDADE;
        parametrosWidget.currentRow.CDCAMPO4 = parametrosWidget.currentRow.STREGINV;
        parametrosWidget.currentRow.CDCAMPO11 = parametrosWidget.currentRow.STOPISS;
        parametrosWidget.currentRow.CDCAMPO7 = parametrosWidget.currentRow.STOPIPI;
    };
    /**
     * Função auxiliar que seta na widget de parâmetros a propriedade indicando
     * que a parametrização foi verificada pelo usuário
     */
    var setParametersVerified = function setParametersVerified(parametrosWidget) {
        var currentRow = parametrosWidget.currentRow;
        var sef2FiscalIsSelected = parametrosWidget.name == "parametrosGeraisSef2";
        if (sef2FiscalIsSelected) {
            var sef2Widget = templateManager.container.getWidget("Dac-Al");
            // Verifica se o objeto já foi criado pra esta empresa.
            if (!parametrosWidget.empresasLoaded[currentRow.CDEMPRESA]) {
                parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = {};
            }
            // Seta o parâmetro para a empresa selecionada.
            parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = true;
            //sef2Widget.currentRow.REG1400 = (Array.isArray(currentRow.CDOBRIGARRAY) && currentRow.CDOBRIGARRAY.indexOf(4) !== -1);
        } else {
            // Modifica a propriedade indicando que a parametrização foi
            // aberta para a empresa selecionada.
            parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = true;
        }
    };
    /**
     * Função que é invocada após o carregamento do dataSource. Caso é 
     * retornado algo, adiciona à currentRow o primeiro indice de data[] - caso
     * contrário, é setada em forma de newRow;
     */
    self.setLoadedParameters = function (parametrosWidget) {
        var sef2Widget = templateManager.container.getWidget("Sef-ii");
        if (parametrosWidget.dataSource.data.length > 0) {
            // Seta a currentRow como sendo o primeiro indice do data[] retornado
            parametrosWidget.moveToFirst();
            // Redesenha na widget principal, os fields com os valores da nova 
            // currentRow
            parametrosWidget.redraw();
        } else {
            // Seta a widget em modo de novo dado, para inserir a parametrização
            parametrosWidget.newRow();
            parametrosWidget.currentRow.CDEMPRESA = sef2Widget.currentRow.CDEMPRESA;
        }
        // Seta o nome da empresa no campo select de empresa, devido a um
        // comportamento que não exibe o nome da empresa correspondente ao código.
        parametrosWidget.currentRow.NMEMPRESA = sef2Widget.currentRow.NMEMPRESA;
    };
    /**
     * Função invocada ao sair da widget de parametros, que seta os mesmos como 
     * verificados
     */
    self.beforeExitParametrosGerais = function (parametrosWidget) {
        // Seta a parametrização como verificada somente se a widget não estiver
        // em modo de inserção, mas sim de verificação
        if (!parametrosWidget.isNewRow()) {
            setParametersVerified(parametrosWidget);
        }
    };
    /**
     * Função que é invocada ao alterar o field CDINSCESTA,
     * alterando a propriedade enable da tab de parâmetros
     */
    self.inscricaoOnChange = function (sef2Widget) {
        var parametrosWidget = templateManager.container.getWidget('parametrosGeraisSef2');
        // Variável booleana que é setada como true, caso alguma inscrição seja 
        // selecionada
        var inscricaoIsSelect = !!sef2Widget.currentRow.CDINSCESTA;
        parametrosWidget.enabled = inscricaoIsSelect;
    };
};
Configuration(function (ContextRegister) {
    ContextRegister.register("Fis_Sef2_Controller", Fis_Sef2_Controller);
});

// FILE: ./assets/modules/acessorias/assets/js/controllers/Fis75000_Efd_Reinf_Controller.js
var Fis75000_Efd_Reinf_Controller = function Fis75000_Efd_Reinf_Controller(ScreenService, templateManager, Messages_fiscal, Fis75000_Efd_Reinf_Service, General, ZhFilterPreferences, Fis55000_ParametrizacaoExportacaoMunicipal_Controller) {

    var self = this;

    var ignoredKeys = ["__rightActions", "__leftActions", "_children", "_parent", "__groupHeaders", "__index", "__isSelected", "__notSelectable", "$$hashKey"];

    //Variavél que auxilia-ra nos processos com os parametros cadastrados
    var parametrosReinf = {};

    var cdempresaEnvio = "";

    // Nomes dos Eventos
    this.R1000 = Fis75000_Efd_Reinf_Service.R1000;
    this.R1070 = Fis75000_Efd_Reinf_Service.R1070;
    this.R2010 = Fis75000_Efd_Reinf_Service.R2010;
    this.R2020 = Fis75000_Efd_Reinf_Service.R2020;
    this.R2060 = Fis75000_Efd_Reinf_Service.R2060;
    this.R2098 = Fis75000_Efd_Reinf_Service.R2098;
    this.R2099 = Fis75000_Efd_Reinf_Service.R2099;
    this.R5001 = Fis75000_Efd_Reinf_Service.R5001;
    this.R5011 = Fis75000_Efd_Reinf_Service.R5011;
    this.R9000 = Fis75000_Efd_Reinf_Service.R9000;

    //Tipos de ambiente
    this.PRODUCAO = Fis75000_Efd_Reinf_Service.ID_AMBIENTE_PRODUCAO;
    this.PRODRESTRITA = Fis75000_Efd_Reinf_Service.ID_AMBIENTE_PRODRESTRITA;

    this.openFilterEventos = function (widget) {
        var rowsToSet = {};
        rowsToSet.IDSTATUS = ["P", "E", "M", "R"];
        var CDEMPRESA = templateManager.container.getWidget('widgetEmpresa').currentRow.CDEMPRESA;
        if (cdempresaEnvio == "" || cdempresaEnvio != CDEMPRESA) {
            ZhFilterPreferences.openFilterWidget(templateManager.container.getWidget('widgetEnvioEventos'), rowsToSet);
            cdempresaEnvio = CDEMPRESA;
        }
    };

    this.salvarEvento = function (widget) {
        if (widget.isValid()) {
            // Realiza algumas validações antes de salvar eventos
            //Fis75000_Efd_Reinf_Service.vericaEvento(widget.currentRow); 

            if (widget.currentRow.NMEVENTO === this.R9000) {
                widget.currentRow.__new_code_column_size = widget.currentRow.NRENVIOEXCLUSAO[0].toString().length;
            }
            General.callRestEngine('fis_acessorias#/salvarEvento', 'Row', widget.currentRow).then(function (response) {
                widget.activate();
                if (widget.currentRow.__is_new) {
                    widget.list(true);
                    ScreenService.goBack();
                    widget.reload();
                } else {
                    widget.computeDescriptionOrder();
                    widget.view();
                }
                if (response.messages[0].message) ScreenService.showMessage(response.messages[0].message);

                if (widget.currentRow.NMEVENTO == 'R-2010' || widget.currentRow.NMEVENTO == 'R-2020') {
                    widget.currentRow.DTINICIAL = widget.currentRow.DTMESCOMPETENC;
                    widget.currentRow.NOVOEVENTO = true;
                    this.controlaWidgetItemsSemParam(widget);
                }
            }.bind(this), function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            }.bind(this));
        }
    };

    this.excluirMultEventos = function (widget) {
        var rows = widget.getCheckedRows();

        var naoPodeSerExcluido = rows.filter(function (row) {
            return !Fis75000_Efd_Reinf_Service.verificarPodeExcluir(row);
        }.bind(this));

        if (naoPodeSerExcluido.length > 0) {
            ScreenService.showMessage(Messages_fiscal.EVENTOS_NAO_PODE_SER_EXCLUIDO);
        } else {
            General.deleteCrudCheckedRows(widget);
        }
    };

    this.consultarEvento = function (widget, totalizador) {
        widget.currentRow.TOTALIZADOR = totalizador;
        widget.currentRow.IDOPERACAO = 'C';
        this.transmitirEvento(widget);
    };

    this.transmitirLoteEvento = function (widget) {
        if (Fis75000_Efd_Reinf_Service.validaTransmissaoLote(widget.getCheckedRows())) {
            widget.getCheckedRows()[0].NRINSJUREMPR = widget.getParent().currentRow.NRINSJUREMPR.replace(/[^0-9]/g, '');
            widget.getCheckedRows()[0].IDTPIJUREMPR = widget.getCheckedRows()[0].NRINSJUREMPR.length === 14 ? '1' : '2';

            Fis75000_Efd_Reinf_Service.transmissao(widget.getCheckedRows()).then(function (response) {
                if (response.messages) {
                    var message = '';
                    response.messages.forEach(function (objMessage) {
                        message += objMessage.message + '<br>';
                    });
                    if (message) {
                        ScreenService.showMessage(message);
                    }
                }

                var oldPage = widget.dataSource.getCurrentPage();
                widget.dataSource.setCurrentPage(1);
                widget.reload().then(function () {
                    widget.dataSource.setCurrentPage(oldPage);
                    widget.unSelectAll();
                });
            }, function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };

    self.reenviarEventoVersao = function (widget) {
        var row = Util.clone(widget.currentRow, ignoredKeys);
        General.callRestEngine('fis_acessorias#/paramempreinf', 'FilterData', [{
            "name": "CDEMPRESA",
            "operator": "=",
            "value": row.CDEMPRESA
        }]).then(function (success) {
            if (success.dataset.paramempreinf[0].CDVERSAO != widget.currentRow.DSVERSAO) {
                if (row.NMEVENTO == this.R1000) {
                    self.reenviarEvento(widget);
                } else if (row.NMEVENTO == this.R2010 || row.NMEVENTO == this.R2020 || row.NMEVENTO == this.R2060) {
                    ScreenService.showCustomDialog('A versão atual difere da versão cadastrada neste envio de evento. Selecione a versão que deseja enviar.', 'CONFIRMATION', null, [{
                        "label": "Versão 1.3",
                        "code": function code() {
                            widget.currentRow.DSVERSAO = "1.3";
                            self.reenviarEvento(widget);
                        }
                    }, {
                        "label": "Versão 1.4",
                        "code": function code() {
                            widget.currentRow.DSVERSAO = "1.4";
                            self.reenviarEvento(widget);
                        }
                    }]);
                }
            } else {
                self.reenviarEvento(widget);
            }
        }.bind(this));
    };

    this.reenviarEvento = function (widget) {
        var row = Util.clone(widget.currentRow, ignoredKeys);

        row.NRINSJUREMPR = widget.getParent().currentRow.NRINSJUREMPR.replace(/[^0-9]/g, '');
        row.IDTPIJUREMPR = row.NRINSJUREMPR.length === 14 ? '1' : '2';

        if (row.NMEVENTO == this.R1000) {
            row.IDOPERACAO = 'A';
        } else if (row.NMEVENTO == this.R2010 || row.NMEVENTO == this.R2020 || row.NMEVENTO == this.R2060) {
            row.IDOPERACAO = 'R';
        }

        Fis75000_Efd_Reinf_Service.transmissao([row]).then(function (response) {
            var message = '';
            response.messages.forEach(function (objMessage) {
                message += objMessage.message + '<br>';
            });
            if (message) {
                ScreenService.showMessage(message);
            }
            var oldPage = widget.dataSource.getCurrentPage();
            widget.dataSource.setCurrentPage(1);
            widget.reload().then(function () {
                widget.dataSource.setCurrentPage(oldPage);
            });
            this.controlaVisibilidadeAction(widget);
            widget.redraw(true);
        }.bind(this), function (callback) {
            if (callback.data) {
                ScreenService.showMessage(callback.data.error);
            }
        });
    };

    this.transmitirEvento = function (widget) {
        widget.currentRow.NRINSJUREMPR = widget.getParent().currentRow.NRINSJUREMPR.replace(/[^0-9]/g, '');
        widget.currentRow.IDTPIJUREMPR = widget.currentRow.NRINSJUREMPR.length === 14 ? '1' : '2';

        Fis75000_Efd_Reinf_Service.transmissao([widget.currentRow]).then(function (response) {
            var message = '';
            response.messages.forEach(function (objMessage) {
                message += objMessage.message + '<br>';
            });
            if (message) {
                ScreenService.showMessage(message);
            }

            if (response.dataset) {
                if (response.dataset.report) {
                    var reportOpened = window.open(response.dataset.report.report_url);
                    if (!reportOpened) {
                        ScreenService.showMessage(ScreenService.i18n('Pop-up Blocker is enabled! Please add this site to your exception list.'));
                    }
                }
            }

            var oldPage = widget.dataSource.getCurrentPage();
            widget.dataSource.setCurrentPage(1);
            widget.reload().then(function () {
                widget.dataSource.setCurrentPage(oldPage);
                this.controlaVisibilidadeAction(widget);
                widget.redraw(true);
            }.bind(this));
        }.bind(this), function (callback) {
            if (callback.data) {
                ScreenService.showMessage(callback.data.error);
            }
        });
    };

    // Realiza os procedimentos para adicionar um evento;
    this.addEnvioEvento = function (widget) {
        var cdempresa = widget.getParent().currentRow.CDEMPRESA;
        General.callRestEngine('fis_acessorias#/getParametrosReinf', 'Row', widget.getParent().currentRow).then(function (response) {
            var parametros = response.dataset.parametros;
            var campoEvento = widget.getField('DSEVENTO');
            // Só é possivel adicionar registros caso exista a paramtrização para a empresa.
            if (parametros.length > 0) {
                parametrosReinf = parametros;
                widget.newRow();
                campoEvento.dataSourceFilter = [{
                    "name": "DSVERSAO",
                    "operator": "=",
                    "value": parametros[0].CDVERSAO
                }, {
                    "name": "NMEVENTO",
                    "operator": "IN",
                    "value": ["R-1000", "R-2010", "R-2020", "R-2098", "R-2099", "R-9000"]
                }];

                //Verifica parametro para ver se a empresa pode adicionar um evento R-2060

                if (parametros[0].IDINDCPRB == '1') {
                    campoEvento.dataSourceFilter[1].value.push("R-2060");
                }
                //Procedimetos para gerar novo código;
                var paramsNewCode = widget.paramsNewCode;
                var keysParamsNewCode = Object.keys(paramsNewCode);
                keysParamsNewCode.forEach(function (value) {
                    widget.currentRow[value] = paramsNewCode[value];
                });

                widget.currentRow.IDAMBIENTE = parametros[0].IDAMBIENTE;
                widget.currentRow.DSVERSAO = parametros[0].CDVERSAO;
                widget.currentRow.CDEMPRESA = cdempresa;
                this.controlaCamposEventos(widget);

                widget.getField('DSEVENTO').reload();
            } else ScreenService.showMessage(Messages_fiscal.PARAMETROS_REINF, 'error');
        }.bind(this), function (callback) {
            if (callback.data) {
                ScreenService.showMessage(callback.data.error);
            }
        });
    };

    /*
        Função para recarregar dataSource de um field e 
        exibir uma mensagem caso esteja vazio.
    */
    this.recarrgarField = function (field, mensagem) {
        field.reload().then(function (response) {
            if (field.dataSource.data.length === 0) ScreenService.showMessage(mensagem);
        });
    };

    /*
        Realiza o controle de quais actions estarão visiveis
        dependendo do status do evento.
    */
    this.controlaVisibilidadeAction = function (widget) {
        var idstatus = widget.currentRow.IDSTATUS;
        var evento = widget.currentRow.NMEVENTO;
        var envio = widget.currentRow.NRENVIO;
        var empresa = widget.currentRow.CDEMPRESA;
        var ambiente = widget.currentRow.IDAMBIENTE;
        var dtinicial = widget.currentRow.DTINIVALIDADE;
        var dtfinal = widget.currentRow.DTFINVALIDADE;
        var recibo = widget.currentRow.NRRECIBO;
        var actionExluirEvento = widget.getAction('DELETAR');
        var actionTransmitirEvento = widget.getAction('transmitir');
        var actionReenvio = widget.getAction('reenvio');
        var actionConsulta = widget.getAction('consultar');
        var actionConsultaTot = widget.getAction('consultarTotalizador');
        var actionReportConsulta = widget.getAction('REPORTCONSULTA');
        var actionViewXml = widget.getAction('VIEWXML');

        actionExluirEvento.isVisible = Fis75000_Efd_Reinf_Service.verificarPodeExcluir(widget.currentRow);
        var visibilidadeEnvio = idstatus === 'P' || idstatus === 'E';
        actionConsultaTot.isVisible = evento == this.R2099 && idstatus == 'M';

        actionReportConsulta.isVisible = evento == this.R2099 && (idstatus == 'C' || idstatus == 'R');
        actionViewXml.isVisible = evento == this.R2099 && (idstatus == 'C' || idstatus == 'R');

        // FIELDS GROUP - So mostra aberto caso o evento já tenha sido enviado.
        widget.fieldGroups.forEach(function (grupo) {
            grupo.opened = widget.currentRow.IDSTATUS != 'P';
        });

        if (evento == this.R1000 && (idstatus === 'C' || idstatus === 'M')) {
            General.callRestEngine('fis_acessorias#/R1000_vigente', 'FilterData', [{
                "name": "CDEMPRESA",
                "operator": "=",
                "value": empresa
            }, {
                "name": "AMBIENTE",
                "operator": "=",
                "value": ambiente
            }, {
                "name": "DTINICIAL",
                "operator": "=",
                "value": dtinicial
            }, {
                "name": "DTFINAL",
                "operator": "=",
                "value": dtfinal
            }]).then(function (success) {
                var nrenvioBack = success.dataset.R1000_vigente.NRENVIO;
                actionReenvio.isVisible = nrenvioBack == envio;
                actionReenvio.label = 'Transmitir Alteração';
            });
        } else if ((evento == this.R2010 || evento == this.R2020 || evento == this.R2060) && (idstatus == 'C' || idstatus == 'E' && widget.currentRow.NRRECIBO)) {
            actionReenvio.isVisible = true;
            actionReenvio.label = 'Transmitir Retificação';
            actionTransmitirEvento.isVisible = false;
        } else {
            actionReenvio.isVisible = false;
            actionTransmitirEvento.isVisible = visibilidadeEnvio;
        }

        if ((evento == this.R1000 || evento == this.R2010 || evento == this.R2020 || evento == this.R2060 || evento == this.R2098 || evento == this.R2099 && idstatus != 'M' && idstatus != 'R') && (idstatus == 'P' || idstatus == 'E' || idstatus == 'C' && widget.currentRow.NRRECIBO)) {
            actionConsulta.isVisible = true;
        }

        if (recibo) {
            actionExluirEvento.isVisible = false;
        } else {
            actionExluirEvento.isVisible = true;
        }
    };

    this.openEFD = function (widget) {
        ScreenService.openWindow("fis_acessorias#fis75001_parametros_EFD_reinf").then(function () {
            var widgetEFD = templateManager.containers["fis_acessorias#fis75001_parametros_EFD_reinf"].getWidget('tabbedWidget');
            widgetEFD.currentRow.CDEMPRESA = widget.currentRow.CDEMPRESA;
            widgetEFD.currentRow.NMEMPRESA = widget.currentRow.NMEMPRESA;
            widgetEFD.currentRow.NRINSJUREMPR = widget.currentRow.NRINSJUREMPR.replace(/[^0-9]/g, '');
            this.atualizaTelaParametrizacao(widgetEFD.getField('CDEMPRESA'));
        }.bind(this));
    };

    this.atualizaTelaParametrizacao = function (field) {
        var widget = templateManager.containers["fis_acessorias#fis75001_parametros_EFD_reinf"].getWidget('fis75001_parametros_EFD_reinf_form');
        if (!Util.isEmptyOrBlank(field.value())) {
            widget.reload().then(function () {
                var existeData = widget.dataSource.data[0] ? true : false;
                widget.currentRow = existeData ? widget.dataSource.data[0] : {};
                widget.currentRow.CDEMPRESA = field.value();
                widget.getField('DSDIRCERTIFICADO').fileList = widget.currentRow.DSDIRCERTIFICADO;
                widget.getAction('edit').isVisible = existeData;
                widget.getAction('edit').readOnly = !existeData;
                widget.getAction('adicionar').isVisible = !existeData;
                widget.getAction('adicionar').readOnly = existeData;
                widget.redraw();
            }, function (error) {
                ScreenService.errorNotification(error);
                widget.getAction('edit').readOnly = false;
                widget.getAction('adicionar').readOnly = false;
                widget.redraw();
            });
        } else {
            widget.currentRow = {};
            widget.getAction('edit').isVisible = false;
            widget.getAction('edit').readOnly = false;
            widget.getAction('adicionar').isVisible = true;
            widget.getAction('adicionar').readOnly = true;
            widget.redraw();
        }
    };

    this.onChangeEvento = function (widget) {
        this.controlaCamposEventos(widget);
        if (widget.currentRow.NMEVENTO === this.R1000) {
            widget.currentRow.DTINIVALIDADE = parametrosReinf[0].DTINIVALIDADE;
            widget.currentRow.DTFINVALIDADE = parametrosReinf[0].DTFINVALIDADE;
            widget.currentRow.DTMESCOMPETENC = null;
        } else {
            widget.currentRow.DTINIVALIDADE = '';
            widget.currentRow.DTFINVALIDADE = '';
        }

        if (widget.currentRow.NMEVENTO === this.R1070) {
            widget.currentRow.DTMESCOMPETENC = null;
            widget.getField('NRPROCESSO').reload();
        }

        widget.currentRow.NRPROCESSO = null;
        widget.currentRow.CDPROCESSO = null;
    };

    /* Esse controle de tela foi separado em dois momentos 
    devido a problemas no zeedhi, que estava atrapalhando a 
    visibilidade de outros campos*/

    /*
        Realiza o Controle dos campos específicos de eventos,
        somente no momento de adicionar.
    */

    this.controlaCamposEventos = function (widget) {
        var nmenvento = widget.currentRow.NMEVENTO;

        //R1000
        var tipoOperacao = widget.getField('IDOPERACAO');
        //R1000 e R1070 
        var dataInicial = widget.getField('DTINIVALIDADE');
        var dataFinal = widget.getField('DTFINVALIDADE');
        //R1070
        var nrprocesso = widget.getField('NRPROCESSO');
        // Todos, exceto R1000 e R1070 e R9000
        var dataCompetencia = widget.getField('DTMESCOMPETENC');
        //R9000
        var eventos = widget.getField('NRENVIOEXCLUSAO');

        dataInicial.showOnForm = widget.currentRow.NMEVENTO === this.R1000 || widget.currentRow.NMEVENTO === this.R1070;
        dataFinal.showOnForm = widget.currentRow.NMEVENTO === this.R1000 || widget.currentRow.NMEVENTO === this.R1070;
        dataCompetencia.showOnForm = widget.currentRow.NMEVENTO != this.R1000 && widget.currentRow.NMEVENTO != this.R1070 && widget.currentRow.NMEVENTO != this.R9000;
        nrprocesso.showOnForm = widget.currentRow.NMEVENTO === this.R1070;
        eventos.showOnForm = widget.currentRow.NMEVENTO === this.R9000;

        // Controle IDOPERACAO
        if (widget.currentRow.NMEVENTO !== this.R1000) {
            widget.currentRow.IDOPERACAO = nmenvento == this.R9000 ? 'E' : 'I';
            tipoOperacao.readOnly = true;
            tipoOperacao.showOnForm = false;
            delete tipoOperacao.validations.required;
        } else {
            tipoOperacao.readOnly = false;
            tipoOperacao.showOnForm = true;
            tipoOperacao.validations.required = true;
        }

        if (widget.currentRow.NMEVENTO === this.R1000 || widget.currentRow.NMEVENTO === this.R1070) {

            dataInicial.validations.required = true;
            delete dataCompetencia.validations.required;
            delete eventos.validations.required;

            //Campo de Processo que somente está visível no evento R1070
            if (widget.currentRow.NMEVENTO === this.R1070) nrprocesso.validations.required = true;else delete nrprocesso.validations.required;
        } else if (widget.currentRow.NMEVENTO === this.R9000) {
            eventos.validations.required = true;
            delete dataCompetencia.validations.required;
            delete dataInicial.validations.required;
            delete nrprocesso.validations.required;
        } else {
            dataCompetencia.validations.required = true;
            delete dataInicial.validations.required;
            delete nrprocesso.validations.required;
            delete eventos.validations.required;
        }

        widget.redraw(true);
    };

    /* 
        Controla a visibilidade de campos que são mostrados apenas 
        para determinado evento. No eventos de After Move Row, mas não
        incluindo o new row.
    */
    this.controleCamposEventosView = function (widget) {
        if (!widget.currentRow.__is_new) {
            var dataInicial = widget.getField('DTINIVALIDADE');
            var dataFinal = widget.getField('DTFINVALIDADE');
            var dataCompetencia = widget.getField('DTMESCOMPETENC');
            var dsestabreinf = widget.getField('DSESTABREINF');
            var nrprocesso = widget.getField('NRPROCESSO');

            //************************ R1000 e R1070 *********************************/
            dataInicial.showOnView = widget.currentRow.NMEVENTO === this.R1000 || widget.currentRow.NMEVENTO === this.R1070;
            dataFinal.showOnView = widget.currentRow.NMEVENTO === this.R1000 || widget.currentRow.NMEVENTO === this.R1070;
            dataCompetencia.showOnView = widget.currentRow.NMEVENTO != this.R1000 && widget.currentRow.NMEVENTO != this.R1070;

            //************************ R1070 *****************************************/

            nrprocesso.showOnView = widget.currentRow.NMEVENTO === this.R1070;

            ///************************ R2010 & R2020 *******************************/
            // Define as máscaras de acordo com o tipo de inscrição
            var mascara = widget.currentRow.TIPOINSCRICAO === 'J' ? '00.000.000/0000-00' : widget.currentRow.TIPOINSCRICAO === 'F' ? '000.000.000-00' : '';
            var isncricao = widget.currentRow.NMEVENTO === this.R2020 || widget.currentRow.NMEVENTO === this.R2010 ? formataCampo(widget.currentRow.INCSESTABREINF, mascara) : widget.currentRow.INCSESTABREINF;

            dsestabreinf.showOnView = widget.currentRow.NMEVENTO === this.R2020 || widget.currentRow.NMEVENTO === this.R2010;
            dsestabreinf.label = widget.currentRow.NMEVENTO === this.R2010 ? 'Tomador' : 'Prestador';
            widget.currentRow.DSESTABREINF = isncricao + ' - ' + widget.currentRow.NMESTABREINF;

            widget.resizeGridColumns(true);
            widget.redraw();
        }
    };

    //formata de forma generica os campos
    function formataCampo(campo, Mascara) {
        var boleanoMascara;
        var exp = /\-|\.|\/|\(|\)| /g;
        var campoSoNumeros = campo.toString().replace(exp, "");
        var posicaoCampo = 0;
        var NovoValorCampo = "";
        var TamanhoMascara = campoSoNumeros.length;

        for (var i = 0; i <= TamanhoMascara; i++) {
            boleanoMascara = Mascara.charAt(i) == "-" || Mascara.charAt(i) == "." || Mascara.charAt(i) == "/";
            boleanoMascara = boleanoMascara || Mascara.charAt(i) == "(" || Mascara.charAt(i) == ")" || Mascara.charAt(i) == " ";
            if (boleanoMascara) {
                NovoValorCampo += Mascara.charAt(i);
                TamanhoMascara++;
            } else {
                NovoValorCampo += campoSoNumeros.charAt(posicaoCampo);
                posicaoCampo++;
            }
        }
        return NovoValorCampo;
    }

    /*
        Faz o controle para exibir a widget do detalhemtno do Envio, 
        que irá mostra informações referentes ao envio do evento.
    */
    this.controlaWidgetDetalhemntoEnvio = function (widget) {
        var widgetDetalhamentoEventoContrPrev = widget.widgets[0];
        var widgetDetalhamentoEventoCPRB = templateManager.container.getWidget('widgetDetalhamentoEventoCPRB');

        switch (widget.currentRow.NMEVENTO) {
            case this.R2010:
            case this.R2020:
                widgetDetalhamentoEventoContrPrev.isVisible = widget.currentRow.NMEVENTO === this.R2020 || widget.currentRow.NMEVENTO === this.R2010;
                widgetDetalhamentoEventoCPRB.isVisible = false;

                if (widget.currentRow.NMEVENTO === this.R2020) {
                    widgetDetalhamentoEventoContrPrev.dataSource.name = 'fis_acessorias#/crud/detalhamentoEnvio_eventoR2020';
                } else {
                    widgetDetalhamentoEventoContrPrev.dataSource.name = 'fis_acessorias#/crud/detalhamentoEnvio_eventoR2010';
                }
                widgetDetalhamentoEventoContrPrev.dataSourceFilter = [{
                    "name": "CDPARTICIPANTE",
                    "operator": "=",
                    "value": widget.currentRow.CDESTABREINF
                }, {
                    "name": "CDIMPOSTO",
                    "operator": "=",
                    "value": widget.currentRow.NMEVENTO === this.R2010 ? '41' : '42'
                }, {
                    "name": "CDEMPRESA",
                    "operator": "=",
                    "value": widget.currentRow.CDEMPRESA
                }, {
                    "name": "DTINICIAL",
                    "operator": "=",
                    "value": moment(widget.currentRow.DTMESCOMPETENC, 'DD/MM/YYYY').format('DD/MM/YYYY')
                }, {
                    "name": "DTFINAL",
                    "operator": "=",
                    "value": moment(widget.currentRow.DTMESCOMPETENC, 'DD/MM/YYYY').endOf('month').format('DD/MM/YYYY')
                }];
                widgetDetalhamentoEventoContrPrev.reload();
                break;

            case this.R2060:
                widgetDetalhamentoEventoContrPrev.isVisible = false;
                widgetDetalhamentoEventoCPRB.isVisible = true;

                General.callRestEngine('fis_acessorias#/detalhamentoR2060', 'Row', widget.currentRow).then(function (success) {
                    widgetDetalhamentoEventoCPRB.currentRow = success.dataset.detalhamentoR2060[0];
                    //widgetDetalhamentoEventoCPRB.reload();
                }, function (callback) {
                    if (callback.data) {
                        ScreenService.showMessage(callback.data.error);
                    }
                });
                break;

            default:
                widgetDetalhamentoEventoContrPrev.isVisible = false;
                widgetDetalhamentoEventoCPRB.isVisible = false;
        }
    };

    this.abreItemsNota = function (widget) {
        var swipe = templateManager.container.getWidget('itens');
        swipe.dataSourceFilter = [{
            "name": "NRLANCTONF",
            "operator": "=",
            "value": widget.currentRow.NRLANCTONF
        }, {
            "name": "CDFILIAL",
            "operator": "=",
            "value": widget.currentRow.CDFILIAL
        }, {
            "name": "CDIMPOSTO",
            "operator": "=",
            "value": widget.getParent().currentRow.NMEVENTO == this.R2010 ? '41' : '42'
        }, {
            "name": "CDINSCMUNI",
            "operator": "=",
            "value": widget.currentRow.CDINSCMUNI
        }, {
            "name": "CDEMPRESA",
            "operator": "=",
            "value": widget.currentRow.CDEMPRESA
        }];
        var tipo;
        switch (widget.getParent().currentRow.NMEVENTO) {
            case this.R2010:
                tipo = 'E';
                break;
            case this.R2020:
                tipo = 'S';
                break;
            default:
                tipo = 'T';
        }
        swipe.dataSourceFilter.push({
            "name": "IDENTRSAIDOP",
            "operator": "=",
            "value": tipo
        });

        ScreenService.openSwipe(swipe);
        swipe.reload();
    };

    /* Control de campos */
    this.regrasAlteracaoOperacao = function (widget) {
        if (widget.currentRow.NMEVENTO == this.R1000 && widget.currentRow.IDOPERACAO != 'E' && widget.currentRow.IDOPERACAO != 'I') {
            ScreenService.showMessage(Messages_fiscal.TIPO_OPERACAO_INVALIDA_PARA_R1000);
            widget.currentRow.IDOPERACAO = null;
        }
    };

    this.geraReport = function (widget) {
        var currentRow = widget.currentRow;
        var rowParent = widget.getParent().currentRow;

        if (currentRow.DSDIRXMLCONSULTA && currentRow.DSDIRXMLCONSULTA !== "") {
            var reportName = 'CONSULTAR2099';
            var params = {
                "EMPRESA": rowParent.CDEMPRESA + ' - ' + rowParent.NMEMPRESA,
                "PERIODO": moment(currentRow.DTMESCOMPETENC, 'DD/MM/YYYY').format('MM/YYYY'),
                "URL_XML": currentRow.DSDIRXMLCONSULTA
            };

            General.openReport('fis#/geraReportConsulta', reportName, params);
        } else {
            widget.currentRow.IDSTATUS = 'M';
            widget.currentRow.NMSTATUS = 'Em Processamento';
            ScreenService.showMessage('Ocorreu um erro ao tentar gerar o relatório.');
            ScreenService.closePopup();
            ScreenService.closeSwipe();
        }
    };

    this.openXML = function (widget) {
        if (widget.currentRow.DSDIRXMLCONSULTA && widget.currentRow.DSDIRXMLCONSULTA !== "") {
            window.open("http://midia.teknisa.com/files/" + widget.currentRow.DSDIRXMLCONSULTA, "_blank");
        } else {
            widget.currentRow.IDSTATUS = 'M';
            widget.currentRow.NMSTATUS = 'Em Processamento';
            ScreenService.showMessage('Ocorreu um erro ao tentar gerar o relatório.');
            ScreenService.closePopup();
            ScreenService.closeSwipe();
        }
    };

    this.openFilterEnvio = function (widget) {
        ZhFilterPreferences.openFilterWidget(widget);
    };

    this.salvarParametrizacao = function (widget) {
        var row = widget.currentRow;
        row.__is_new = true;

        row.CDPRODUTO = row.CDPRODSERV;

        if (widget.isValid()) {
            if (row.ALLINSC == 'Y') {
                var save = {
                    INSCRICOES: ['T', {
                        "CDINSCMUNI": 1,
                        "CDEMPRESA": 1
                    }],
                    PRODUTOS: [row]
                };
                Fis55000_ParametrizacaoExportacaoMunicipal_Controller.cadastroAutomatico(widget, 'NAOSOBREESCREVER', save);
                setTimeout(function () {
                    ScreenService.goBack();
                    widget.reload();
                    templateManager.container.getWidget('widgetDetalhamentoEventoContrPrev').reload();
                    templateManager.container.getWidget('widgetEnvioEventos').reload();
                }, 5000);
            } else {
                General.saveCrud(widget).then(function () {
                    templateManager.container.getWidget('widgetDetalhamentoEventoContrPrev').reload();
                    templateManager.container.getWidget('widgetEnvioEventos').reload();
                });
            }
        }
    };

    this.controlaWidgetItemsSemParam = function (widget) {

        if (widget.currentRow.NMEVENTO === this.R2020 || widget.currentRow.NMEVENTO === this.R2010) {

            if (widget.currentRow.NOVOEVENTO) {
                widget.getParent().widgets[1].dataSourceFilter[2].value = widget.currentRow.NMEVENTO === this.R2010 ? '41' : '42';
                /*if(widget.currentRow.NMEVENTO === this.R2010){
                    widget.getParent().widgets[1].dataSourceFilter[4] =
                    {
                        "name": "CDFORNECED",
                        "operator": "=",
                        "value": widget.currentRow.CDESTABREINF
                    };
                } else if (widget.currentRow.NMEVENTO === this.R2020){
                    widget.getParent().widgets[1].dataSourceFilter[4] =
                    {
                        "name": "CDCLIENTE",
                        "operator": "=",
                        "value": widget.currentRow.CDESTABREINF
                    };
                }*/
                widget.getParent().widgets[1].dataSourceFilter.forEach(function (filter, index) {
                    if (filter.name == 'CDFORNECED' || filter.name == 'CDCLIENTE') {
                        widget.getParent().widgets[1].dataSourceFilter.splice(index, 1);
                    }
                });
                widget.getParent().widgets[1].reload().then(function (data) {
                    if (data.dataset.itemsemparametrizacao[0]) {
                        widget.getParent().widgets[1].isVisible = true;
                        widget.getParent().openTab(widget.getParent().widgets[1].name);
                    } else widget.getParent().widgets[1].isVisible = false;
                });
            } else {
                widget.widgets[1].dataSourceFilter[2].value = widget.currentRow.NMEVENTO === this.R2010 ? '41' : '42';
                if (widget.currentRow.NMEVENTO === this.R2010) {
                    widget.widgets[1].dataSourceFilter[4] = {
                        "name": "CDFORNECED",
                        "operator": "=",
                        "value": widget.currentRow.CDESTABREINF
                    };
                } else if (widget.currentRow.NMEVENTO === this.R2020) {
                    widget.widgets[1].dataSourceFilter[4] = {
                        "name": "CDCLIENTE",
                        "operator": "=",
                        "value": widget.currentRow.CDESTABREINF
                    };
                }
                widget.widgets[1].reload().then(function (data) {
                    if (data.dataset.itemsemparametrizacao[0]) {
                        widget.widgets[1].isVisible = true;
                    } else widget.widgets[1].isVisible = false;
                });
            }
        } else {
            widget.widgets[1].isVisible = false;
        }
    };

    this.openPreViewEnvio = function (widget) {
        var popup = widget.widgets[2];
        popup.currentRow.CDEMPRESA = widget.getParent().currentRow.CDEMPRESA;
        popup.currentRow.NMEMPRESA = widget.getParent().currentRow.NMEMPRESA;
        popup.isVisible = true;
        popup.activate();
        popup.currentRow.IDEVENTO = 'T';
        ScreenService.openPopup(popup);
    };

    this.closePopupPreview = function (widget) {
        widget.isVisible = false;
        ScreenService.closePopup(widget);
        widget.getParent().activate();
    };

    this.previewRelatorio = function (widget) {
        if (widget.isValid()) {
            var currentRow = widget.currentRow;

            var reportName = 'PREVIEWREINF';
            var params = {
                "EMPRESA": currentRow.CDEMPRESA,
                "PERIODO": currentRow.DTMESCOMPETENC,
                "IDEVENTO": currentRow.IDEVENTO
            };

            General.openReport('fis#/previewEnvioReinf', reportName, params);
            ScreenService.closePopup();
        }
    };

    this.limparBase = function (widget) {
        ScreenService.confirmMessage(ScreenService.i18n('Deseja limpar a base de dados para o contribuinte informado?'), 'question', function (success) {

            General.callRestEngine('fis_acessorias#/limparBase', 'Row', widget.currentRow).then(function (response) {
                var message = '';
                response.messages.forEach(function (objMessage) {
                    message += '<br>' + objMessage.message + '<br>';
                });
                if (message) {
                    ScreenService.showMessage(message);
                }
                ScreenService.closePopup();
                templateManager.container.getWidget('widgetEnvioEventos').reload();
            }.bind(this), function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }, function () {
            ScreenService.closePopup();
        });
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register("Fis75000_Efd_Reinf_Controller", Fis75000_Efd_Reinf_Controller);
});

// FILE: ./assets/modules/acessorias/assets/js/controllers/Fis75001_parametrosEfdReinf_Controller.js
var Fis75001_parametrosEfdReinf_Controller = function Fis75001_parametrosEfdReinf_Controller(ScreenService, templateManager, restEngine, General) {

    // Armazena o escopo atual.
    var self = this;
    var BKPRow;

    self.reloadAndMoveToFirst = function (field) {
        var widget = templateManager.container.getWidget('fis75001_parametros_EFD_reinf_form');
        if (!Util.isEmptyOrBlank(field.value())) {
            widget.reload().then(function () {
                var existeData = widget.dataSource.data[0] ? true : false;
                widget.currentRow = existeData ? widget.dataSource.data[0] : {};
                widget.currentRow.CDEMPRESA = field.value();
                widget.getField('DSDIRCERTIFICADO').fileList = widget.currentRow.DSDIRCERTIFICADO;
                widget.getAction('edit').isVisible = existeData;
                widget.getAction('edit').readOnly = !existeData;
                widget.getAction('adicionar').isVisible = !existeData;
                widget.getAction('adicionar').readOnly = existeData;
                widget.redraw();
            }, function (error) {
                ScreenService.errorNotification(error);
                widget.getAction('edit').readOnly = false;
                widget.getAction('adicionar').readOnly = false;
                widget.redraw();
            });
        } else {
            widget.currentRow = {};
            widget.getAction('edit').isVisible = false;
            widget.getAction('edit').readOnly = false;
            widget.getAction('adicionar').isVisible = true;
            widget.getAction('adicionar').readOnly = true;
            widget.redraw();
        }
    };

    self.saveCrud = function (widget) {
        var currentRow = widget.currentRow;
        if (currentRow.DSDIRCERTIFICADO !== undefined) widget.getField('DSDIRCERTIFICADO').validations = {};
        if (widget.isValid()) {
            var BKPRow = widget.backupRow;

            if (!currentRow.__is_new && currentRow.__is_new !== false) {
                currentRow.__is_new = true;
                if (currentRow.CDSENHACERTDIG) currentRow.senhaAlterada = true;else currentRow.senhaAlterada = false;
            } else {
                currentRow.senhaAlterada = currentRow.CDSENHACERTDIG != BKPRow.CDSENHACERTDIG ? true : false;
            }

            if (currentRow.__is_new == false) {
                General.callRestEngine('fis_acessorias#/paramempreinf/updateCrud', 'Row', widget.currentRow).then(function (success) {
                    ScreenService.goBack();
                    widget.reload();
                }, function (error) {
                    ScreenService.showMessage(error.data.error);
                });
            } else {
                restEngine.post('fis_acessorias#/paramempreinf/saveCrud', {
                    "requestType": "DataSet",
                    "dataset": [currentRow]
                }).then(function (sucesso) {
                    aftersave(widget);
                    widget.currentRow.__is_new = false;
                });
            }
        }
        widget.getField('DSDIRCERTIFICADO').validations = {
            "extensions": {
                "value": ["", ".pfx", ".p12"]
            }
        };
    };

    function aftersave(widget) {
        General.formWidgetSwitchTemplate(widget);
        widget.list();
        templateManager.container.getWidget('tabbedWidget').getField('NMEMPRESA').readOnly = false;
        widget.getField('DSDIRCERTIFICADO').isVisible = false;
        widget.getField('CERTIFICADONAME').isVisible = true;
        widget.reload().then(function () {
            var existeData = widget.dataSource.data[0] ? true : false;
            widget.currentRow = existeData ? widget.dataSource.data[0] : {};
        });
    }

    self.widgetEdit = function (widget) {
        General.widgetEdit(widget);
        widget.getField('CERTIFICADONAME').isVisible = false;
        widget.getField('DSDIRCERTIFICADO').isVisible = true;
        templateManager.container.getWidget('tabbedWidget').getField('NMEMPRESA').readOnly = true;
        angular.copy(widget.currentRow, BKPRow);
        widget.reload().then(function () {
            widget.getField('DSDIRCERTIFICADO').fileList = widget.currentRow.DSDIRCERTIFICADO;
            widget.redraw();
        });
    };

    self.cancel = function (args) {
        General.backOrCancel(args);
        General.formWidgetSwitchTemplate(args.owner.widget);
        args.owner.widget.list();
        args.owner.widget.getField('DSDIRCERTIFICADO').isVisible = false;
        args.owner.widget.getField('CERTIFICADONAME').isVisible = true;
        templateManager.container.getWidget('tabbedWidget').getField('NMEMPRESA').readOnly = false;
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis75001_parametrosEfdReinf_Controller', Fis75001_parametrosEfdReinf_Controller);
});

// FILE: ./assets/modules/acessorias/assets/js/controllers/Fis83000_DiefPA_Controller.js
var Fis83000_DiefPA_Controller = function Fis83000_DiefPA_Controller(General, ScreenService, Messages_fiscal, ObrigacoesAcessoriasUtil) {

    var self = this;

    /*
     * Função para a chamada da função de exportação.
     */
    this.exportarLivroEletronico = function (DiefESWidget) {
        if (DiefESWidget.widgets[0].isValid() && DiefESWidget.widgets[1].isValid()) {
            var row = DiefESWidget.widgets[1].currentRow;
            Object.keys(DiefESWidget.widgets[0].currentRow).forEach(function (rowIndex) {
                row[rowIndex] = DiefESWidget.widgets[0].currentRow[rowIndex];
            });
            var route = "fis#/exportarDiefPA";
            var message = Messages_fiscal.EXPORTANDO_DIEF;
            ObrigacoesAcessoriasUtil.exportarArquivo(row, route, message);
        }
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis83000_DiefPA_Controller', Fis83000_DiefPA_Controller);
});

// FILE: ./assets/modules/acessorias/assets/js/controllers/Fis84000_DmaBa_Controller.js
var Fis84000_DmaBa_Controller = function Fis84000_DmaBa_Controller(General, ScreenService, templateManager, Messages_fiscal, ObrigacoesAcessoriasUtil) {

    var self = this;

    var DataSourceArray = [];

    self.addAgendamento = function (widget) {
        widget.newRow();
        widget.getField('DTREFINI').isVisible = true;
    };

    self.cancelAgendamento = function (args) {
        General.backOrCancel(args);
        General.changeWidgetAcessibility(args.owner.widget.widgets, true);
        args.owner.widget.getField('DTREFINI').isVisible = true;
    };

    self.editAgendamento = function (widget) {
        General.edit(widget);
        this.periodicidadeOnChange(widget);
    };

    self.saveAgendamento = function (widget) {
        if (widget.isValid()) {
            var d1 = new Date(moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY HH:mm').format('MM/DD/YYYY HH:mm'));
            var d2 = new Date(moment().format('MM/DD/YYYY HH:mm'));

            if (d1.getTime() > d2.getTime()) {
                if ((widget.currentRow.CDINSCESTA == '' || widget.currentRow.CDINSCESTA == null) && widget.currentRow.CDEMPRESA) {
                    widget.currentRow.CDINSCESTA = "T";
                }

                widget.currentRow.NRORG = getLocalVar('NRORG');

                General.callRestEngine('fis_acessorias#/saveAgendamentoDmaBa', 'Row', widget.currentRow).then(function (success) {
                    General.changeWidgetAcessibility(widget.widgets, true);
                    ScreenService.showMessage('Agendado com sucesso.');
                    ScreenService.goBack();
                    widget.getField('DTREFINI').isVisible = true;
                    widget.reload();
                }, function (error) {
                    ScreenService.showMessage(error.data.error);
                });
            } else {
                ScreenService.showMessage('A Data de Agendamento deve ser maior que a data atual, e não pode ser igual a hora atual!');
            }
        } else {
            // @todo create messages class
            ScreenService.showMessage("Preencha todos os campos corretamente!");
        }
    };

    self.downloadArquivoAgendado = function (dmaBaWidget) {
        var downloadRoute;
        var fileName;

        if (dmaBaWidget.hasCheckedRows()) {
            var rows = dmaBaWidget.getCheckedRows();
            rows.forEach(function (row) {
                downloadRoute = window.serviceUrls.filter(function (x) {
                    return x.package == 'fis';
                })[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
                fileName = row.NMARQUIVO;

                window.open(downloadRoute + fileName);
            });
        } else {
            var row = dmaBaWidget.currentRow;
            downloadRoute = window.serviceUrls.filter(function (x) {
                return x.package == 'fis';
            })[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
            fileName = row.NMARQUIVO;

            window.open(downloadRoute + fileName);
        }
    };

    self.deleteAgendamento = function (widget) {
        widget.currentRow.NRORG = getLocalVar('NRORG');

        ScreenService.confirmMessage(ScreenService.i18n('Deletar Agendamento?'), 'question', function (success) {
            General.callRestEngine('fis_acessorias#/deleteAgendamentoDmaBa', 'Row', widget.currentRow).then(function (success) {
                ScreenService.showMessage('Deletado com sucesso.');
                ScreenService.goBack();
                widget.reload();
            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });
        });
    };

    self.periodicidadeOnChange = function (widget) {
        if (widget.currentRow.IDPERIAGEN == 0) {
            widget.getField('DTREFINI').isVisible = true;
        } else if (widget.currentRow.IDPERIAGEN == 1) {
            widget.getField('DTREFINI').isVisible = false;
            if (widget.currentRow.DTAGENDAMENTO && widget.currentRow.DTAGENDAMENTO != "") {
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').format('DD/MM/YYYY');
            }
        } else if (widget.currentRow.IDPERIAGEN == 2) {
            widget.getField('DTREFINI').isVisible = false;
            if (widget.currentRow.DTAGENDAMENTO && widget.currentRow.DTAGENDAMENTO != "") {
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').subtract(1, 'M').format('DD/MM/YYYY');
            }
        }
        widget.getField('DTREFINI').reload();
    };

    /**
     * Função para a chamada de Exportação
     */
    self.exportarDmaBa = function (dmaBaWidget) {
        // Verifica se todos os campos requeridos estão de fato preenchidos
        if (dmaBaWidget.isValid()) {
            // Verifica se a parametrização não foi carregada e verificada
            if (!parametrizacaoWasLoaded(dmaBaWidget)) {
                return;
            }
            var parametrosWidget = templateManager.container.getWidget('parametrosGeraisDmaBa');
            // Define propriedades na widget principal com valores dos fields
            // da tab de parametrização
            preenhcerPropriedadesWidgetPrincipal(dmaBaWidget, parametrosWidget);
            var row = dmaBaWidget.currentRow;
            var route = 'fis#/exportarDmaBa';
            var message = Messages_fiscal.EXPORTANDO_DMA_BA;
            ObrigacoesAcessoriasUtil.exportarArquivo(row, route, message);
        }
    };
    /**
     * Função auxiliar que verifica se a tab de parametrização foi aberta ao exportar,
     * através da propriedade 'empresasLoaded'.
     */
    var parametrizacaoWasLoaded = function parametrizacaoWasLoaded(dmaBaWidget) {
        var parametrizacaoWasLoaded;
        var parametrosWidget;
        var cdEmpresa = dmaBaWidget.currentRow.CDEMPRESA;
        parametrosWidget = templateManager.container.getWidget('parametrosGeraisDmaBa');
        // Verifica se a propriedade (CDEMPRESA) está setada para a empresa selecionada
        parametrizacaoWasLoaded = parametrosWidget.empresasLoaded[cdEmpresa];

        // Verifica se a widget de parametrização não foi aberta antes de
        // clicar no botão de exportar
        if (!parametrizacaoWasLoaded) {
            // Muda a propriedade para que a parametrização seja obrigatória
            parametrosWidget.parametersRequired = true;
            // Exibe mensagem indicando a obrigatoriedae da verificação dos parametros
            ScreenService.showMessage(Messages_fiscal.PARAMETROS_GERAIS_NAO_INFORMADOS_ERROR).then(function () {
                // Abre a widget/tab de parâmetros
                openTabParametrosGerais(parametrosWidget);
            });
            // Retorna false, indicando que a parametrização não foi previamente aberta
            return false;
        }
        // Retorna true, caso a parametrização já tenha sido aberta
        return true;
    };
    /**
     * Função auxiliar que abre a tab de parâmetros pela primeira vez.
     */
    var openTabParametrosGerais = function openTabParametrosGerais(parametrosWidget) {
        // Recarrega os dados (dataSource) parametrizados
        parametrosWidget.reload().then(function () {
            // Redesenha os dados carregados na tab
            parametrosWidget.redraw();
        });
        // Define a tab de parametricação como ativa
        parametrosWidget.activate();
    };
    /**
     * Função auxiliar que cria e preenche propriedades da widget principal,
     * com os valores das fields da tab de parâmetros
     */
    var preenhcerPropriedadesWidgetPrincipal = function preenhcerPropriedadesWidgetPrincipal(dmaBaWidget, parametrosWidget) {
        dmaBaWidget.currentRow.IDRETIFICADORA = parametrosWidget.currentRow.IDRETIFICADORA;
        dmaBaWidget.currentRow.BAIXAEMPRESA = parametrosWidget.currentRow.BAIXAEMPRESA;
        dmaBaWidget.currentRow.IDINSCUNICA = parametrosWidget.currentRow.IDINSCUNICA;
        dmaBaWidget.currentRow.CODINSPETORIA = parametrosWidget.currentRow.CODINSPETORIA;
        dmaBaWidget.currentRow.CDGRUPPROD = parametrosWidget.currentRow.CDGRUPPROD;
        dmaBaWidget.currentRow.CHECKINFOEST = parametrosWidget.currentRow.CHECKINFOEST;
    };
    /**
     * Função para salvar os parâmetros informados - ou caso eles já existam,
     * apenas os confirmam para a exportação
     */
    self.salvarParametrizacao = function (parametrosWidget) {
        // Verifica se todos os campos requeridos estão de fato preenchidos
        if (parametrosWidget.isValid()) {
            var dmaBaWidget = templateManager.container.getWidget('dma-ba');
            preencherCamposAbstratosParaSalvar(parametrosWidget);
            var filter = [{
                "name": "P_CDEMPRESA",
                "operator": "=",
                "value": dmaBaWidget.currentRow.CDEMPRESA
            }, {
                "name": "P_CDINSCRICAO",
                "operator": "=",
                "value": parametrosWidget.currentRow.CDINSCRICAO
            }, {
                "name": "NRORG",
                "operator": "=",
                "value": getLocalVar('NRORG')
            }];

            General.callRestEngine('fis_acessorias#/crud/paramdeclaces_DmaBa', 'FilterData', filter).then(function (result) {
                result = result.dataset.paramdeclaces_DmaBa;

                if (result.length == 0) parametrosWidget.currentRow.__is_new = true;

                parametrosWidget.saveRow().then(function () {
                    // Seta os parametros como verificados pelo usuário
                    setParametersVerified(parametrosWidget);
                    // Ativa a widget principal
                    dmaBaWidget.activate();
                    dmaBaWidget.currentWidget = dmaBaWidget;

                    DataSourceArray = parametrosWidget.dataSource.data;

                    /**
                     * Verifica se a tela de parâmetros foi exibida devido a uma tentativa
                     * de exportação. Caso positivo, a exportação é efetuada
                     */
                    if (parametrosWidget.parametersRequired) {
                        self.exportarDmaBa(dmaBaWidget);
                        // Valida a propriedade para false, caso a tela de parametros seja
                        // novamente aberta. E assim não haverá exportação sempre ao sair
                        parametrosWidget.parametersRequired = false;
                    }
                });
            });
        }
    };

    var preencherCamposAbstratosParaSalvar = function preencherCamposAbstratosParaSalvar(parametrosWidget) {
        var dmaBaWidget = templateManager.container.getWidget('dma-ba');
        parametrosWidget.currentRow.CDCAMPO1 = dmaBaWidget.currentRow.CDLIVROMAG;
        parametrosWidget.currentRow.CDCAMPO2 = parametrosWidget.currentRow.IDRETIFICADORA;
        parametrosWidget.currentRow.CDCAMPO3 = parametrosWidget.currentRow.BAIXAEMPRESA;
        parametrosWidget.currentRow.CDCAMPO4 = parametrosWidget.currentRow.IDINSCUNICA;
        parametrosWidget.currentRow.CDCAMPO5 = parametrosWidget.currentRow.CODINSPETORIA;
        parametrosWidget.currentRow.CDCAMPO6 = parametrosWidget.currentRow.CDGRUPPROD;
        parametrosWidget.currentRow.CDCAMPO7 = parametrosWidget.currentRow.CHECKINFOEST;
    };

    /**
     * Função auxiliar que seta na widget de parâmetros a propriedade indicando
     * que a parametrização foi verificada pelo usuário
     */
    var setParametersVerified = function setParametersVerified(parametrosWidget) {
        var currentRow = parametrosWidget.currentRow;
        var dmaBaFiscalIsSelected = parametrosWidget.name == "parametrosGeraisDmaBa";
        if (dmaBaFiscalIsSelected) {
            // Verifica se o objeto já foi criado pra esta empresa.
            if (!parametrosWidget.empresasLoaded[currentRow.CDEMPRESA]) {
                parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = {};
            }
            // Seta o parâmetro para a empresa selecionada.
            parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = true;
        } else {
            // Modifica a propriedade indicando que a parametrização foi
            // aberta para a empresa selecionada.
            parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = true;
        }
    };
    /**
     * Função que é invocada após o carregamento do dataSource. Caso é 
     * retornado algo, adiciona à currentRow o primeiro indice de data[] - caso
     * contrário, é setada em forma de newRow;
     */
    self.setLoadedParameters = function (parametrosWidget) {
        var dmaBaWidget = templateManager.container.getWidget("dma-ba");
        if (DataSourceArray.length > 0) {
            if (DataSourceArray == "" || DataSourceArray[0].CDINSCRICAO == dmaBaWidget.currentRow.CDINSCESTA) {
                parametrosWidget.dataSource.data = DataSourceArray[0];
            } else {}
        }
        if (parametrosWidget.dataSource.data.length > 0) {
            // Seta a currentRow como sendo o primeiro indice do data[] retornado
            parametrosWidget.moveToFirst();
            // Redesenha na widget principal, os fields com os valores da nova 
            // currentRow
            parametrosWidget.redraw();
        } else {
            // Seta a widget em modo de novo dado, para inserir a parametrização
            parametrosWidget.newRow();
            parametrosWidget.currentRow.CDEMPRESA = dmaBaWidget.currentRow.CDEMPRESA;
        }
        // Seta o nome da empresa no campo select de empresa, devido a um
        // comportamento que não exibe o nome da empresa correspondente ao código.
        parametrosWidget.currentRow.NMEMPRESA = dmaBaWidget.currentRow.NMEMPRESA;
    };
    /**
     * Função invocada ao sair da widget de parametros, que seta os mesmos como 
     * verificados
     */
    self.beforeExitParametrosGerais = function (parametrosWidget) {
        // Seta a parametrização como verificada somente se a widget não estiver
        // em modo de inserção, mas sim de verificação
        if (!parametrosWidget.isNewRow()) {
            setParametersVerified(parametrosWidget);
        }
    };
    /**
     * Função que é invocada ao alterar o field CDINSCESTA,
     * alterando a propriedade enable da tab de parâmetros
     */
    self.inscricaoOnChange = function (dmaBaWidget) {
        var parametrosWidget = templateManager.container.getWidget('parametrosGeraisDmaBa');
        // Variável booleana que é setada como true, caso alguma inscrição seja 
        // selecionada
        var inscricaoIsSelect = !!dmaBaWidget.currentRow.CDINSCESTA;
        parametrosWidget.enabled = inscricaoIsSelect;
    };
};
Configuration(function (ContextRegister) {
    ContextRegister.register("Fis84000_DmaBa_Controller", Fis84000_DmaBa_Controller);
});

// FILE: ./assets/modules/acessorias/assets/js/controllers/Fis85000_Sped_Controller.js
var Fis85000_Sped_Controller = function Fis85000_Sped_Controller(General, ScreenService, templateManager, Messages_fiscal, ObrigacoesAcessoriasUtil, ZHPromise) {

    // Armazena o escopo atual.
    var self = this;

    self.addAgendamento = function (widget) {
        widget.newRow();
        widget.currentRow.CDARQUIVO = 'ICMS';
        this.arquivoOnChangeAgend(widget);
        widget.getField('DTREFINI').isVisible = true;
    };

    self.cancelAgendamento = function (args) {
        General.backOrCancel(args);
        General.changeWidgetAcessibility(args.owner.widget.widgets, true);
        args.owner.widget.currentRow.CDARQUIVO = 'ICMS';
        this.arquivoOnChangeAgend(args.owner.widget);
        args.owner.widget.getField('DTREFINI').isVisible = true;
    };

    self.editAgendamento = function (widget) {
        if (widget.currentRow.CDTELA == 'FIS85000') {
            widget.currentRow.CDARQUIVO = 'ICMS';
        } else if (widget.currentRow.CDTELA == 'FIS95000') {
            widget.currentRow.CDARQUIVO = 'CONT';
            widget.currentRow.CDEMPRESA = widget.currentRow.CDEMPRESA.substr(1).substr(0, widget.currentRow.CDEMPRESA.length - 2).split('_');
            widget.currentRow.NMEMPRESA_MULT = widget.currentRow.CDEMPRESA;
        }
        General.edit(widget);
        this.arquivoOnChangeAgend(widget);
        this.periodicidadeOnChange(widget);
    };
    /*
     * Função para alterar a visibilidade e a validação required do campo de
     * inscrição, conforme arquivo selecionado.
     */
    this.arquivoOnChange = function (spedWidget) {
        var currentRow = spedWidget.currentRow;
        var empresaIsSelected = !!currentRow.CDEMPRESA;
        var inscricaoIsSelected = !!spedWidget.currentRow.CDINSCESTA;
        // Variável booleana que é setada como true quando o usuário seleciona
        // o arquivo de SPED Fiscal.
        var spedFiscalIsSelected = currentRow.CDARQUIVO == 'ICMS';
        var inscricaoField = spedWidget.getField('CDINSCESTA');

        var parametrosFiscalWidget = templateManager.container.getWidget("parametrosFiscal");
        var parametrosContribuicoesWidget = templateManager.container.getWidget("parametrosContribuicoes");

        // Reseta o nome do arquivo, caso esteja preenchido.
        currentRow.NMARQUIVO = "";

        // Altera as propriedades do field de inscrição conforme arquivo seleiconado.
        inscricaoField.validations = spedFiscalIsSelected ? { required: true } : {};
        inscricaoField.isVisible = spedFiscalIsSelected;

        // Altera a visibilidade das widgets de parametrização conforme o arquivo.
        parametrosFiscalWidget.showAsTab = spedFiscalIsSelected;
        parametrosContribuicoesWidget.showAsTab = !spedFiscalIsSelected;

        // Altera a habilitação da widget de parametrização conforme dados inseridos.
        parametrosFiscalWidget.enabled = spedFiscalIsSelected && empresaIsSelected && inscricaoIsSelected;
        parametrosContribuicoesWidget.enabled = !spedFiscalIsSelected && empresaIsSelected;

        // Altera o nome da widget principal conforme o arquivo.
        spedWidget.label = spedFiscalIsSelected ? "SPED Fiscal ICMS/IPI" : "SPED Contribuições";

        toggleBlocohFieldsVisibility(spedWidget, spedFiscalIsSelected);
    };

    this.arquivoOnChangeAgend = function (spedWidget) {
        var currentRow = spedWidget.currentRow;
        var empresaIsSelected = !!currentRow.CDEMPRESA;
        var inscricaoIsSelected = !!spedWidget.currentRow.CDINSCESTA;

        if (currentRow.CDARQUIVO == 'CONT') {
            spedWidget.getField('NMEMPRESA').isVisible = false;
            spedWidget.getField('NMEMPRESA_MULT').isVisible = true;
            spedWidget.getField('NMEMPRESA').validations = {};
        } else {
            spedWidget.getField('NMEMPRESA').isVisible = true;
            spedWidget.getField('NMEMPRESA_MULT').isVisible = false;
            spedWidget.getField('NMEMPRESA').validations = {
                "required": true
            };
        }
        spedWidget.getField('NMEMPRESA').reload();
        spedWidget.getField('NMEMPRESA_MULT').reload();

        // Variável booleana que é setada como true quando o usuário seleciona
        // o arquivo de SPED Fiscal.
        var spedFiscalIsSelected = currentRow.CDARQUIVO == 'ICMS';
        var inscricaoField = spedWidget.getField('CDINSCESTA');

        var parametrosFiscalWidget = templateManager.container.getWidget("parametrosFiscal");
        var parametrosContribuicoesWidget = templateManager.container.getWidget("parametrosContribuicoes");

        // Reseta o nome do arquivo, caso esteja preenchido.
        currentRow.NMARQUIVO = "";

        // Altera as propriedades do field de inscrição conforme arquivo seleiconado.
        //inscricaoField.validations = spedFiscalIsSelected ? {required: true} : {};
        inscricaoField.isVisible = spedFiscalIsSelected;

        // Altera a visibilidade das widgets de parametrização conforme o arquivo.
        parametrosFiscalWidget.showAsTab = spedFiscalIsSelected;
        parametrosContribuicoesWidget.showAsTab = !spedFiscalIsSelected;

        // Altera a habilitação da widget de parametrização conforme dados inseridos.
        parametrosFiscalWidget.enabled = spedFiscalIsSelected && empresaIsSelected && inscricaoIsSelected;
        parametrosContribuicoesWidget.enabled = !spedFiscalIsSelected && empresaIsSelected;

        // Altera o nome da widget principal conforme o arquivo.
        spedWidget.label = spedFiscalIsSelected ? "Agendamento SPED Fiscal ICMS/IPI" : "Agendamento SPED Contribuições";

        toggleBlocohFieldsVisibility(spedWidget, spedFiscalIsSelected);
    };

    self.periodicidadeOnChange = function (widget) {
        if (widget.currentRow.IDPERIAGEN == 0) {
            widget.getField('DTREFINI').isVisible = true;
        } else if (widget.currentRow.IDPERIAGEN == 1) {
            widget.getField('DTREFINI').isVisible = false;
            if (widget.currentRow.DTAGENDAMENTO && widget.currentRow.DTAGENDAMENTO != "") {
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').format('DD/MM/YYYY');
            }
        } else if (widget.currentRow.IDPERIAGEN == 2) {
            widget.getField('DTREFINI').isVisible = false;
            if (widget.currentRow.DTAGENDAMENTO && widget.currentRow.DTAGENDAMENTO != "") {
                widget.currentRow.DTREFINI = moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY').subtract(1, 'M').format('DD/MM/YYYY');
            }
        }
        widget.getField('DTREFINI').reload();
    };

    self.saveAgendamento = function (widget) {
        if (widget.isValid()) {
            var d1 = new Date(moment(widget.currentRow.DTAGENDAMENTO, 'DD/MM/YYYY HH:mm').format('MM/DD/YYYY HH:mm'));
            var d2 = new Date(moment().format('MM/DD/YYYY HH:mm'));

            if (d1.getTime() > d2.getTime()) {
                if ((widget.currentRow.CDINSCESTA == '' || widget.currentRow.CDINSCESTA == null) && widget.currentRow.CDEMPRESA) {
                    widget.currentRow.CDINSCESTA = "T";
                } else if (widget.currentRow.CDINSCESTA == '' || widget.currentRow.CDINSCESTA == '') {
                    widget.currentRow.CDEMPRESA = "T";
                }

                widget.currentRow.NRORG = getLocalVar('NRORG');

                General.callRestEngine('fis_acessorias#/saveAgendamento', 'Row', widget.currentRow).then(function (success) {
                    General.changeWidgetAcessibility(widget.widgets, true);
                    ScreenService.showMessage('Agendado com sucesso.');
                    ScreenService.goBack();
                    widget.currentRow.CDARQUIVO = 'ICMS';
                    this.arquivoOnChangeAgend(widget);
                    widget.reload();
                }.bind(this), function (error) {
                    ScreenService.showMessage(error.data.error);
                });
            } else {
                ScreenService.showMessage('A Data de Agendamento deve ser maior que a data atual, e não pode ser igual a hora atual!');
            }
        } else {
            // @todo create messages class
            ScreenService.showMessage("Preencha todos os campos corretamente!");
        }
    };

    self.deleteAgendamento = function (widget) {
        widget.currentRow.NRORG = getLocalVar('NRORG');

        ScreenService.confirmMessage(ScreenService.i18n('Deletar Agendamento?'), 'question', function (success) {
            General.callRestEngine('fis_acessorias#/deleteAgendamento', 'Row', widget.currentRow).then(function (success) {
                ScreenService.showMessage('Deletado com sucesso.');
                ScreenService.goBack();
                widget.reload();
            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });
        });
    };

    /*
     * Função para setar os parâmetros como verificados ao sair da widget.
     */
    this.beforeExitParametrosGerais = function (parametrosWidget) {
        // Seta a parametrização como verificada somente se a widget não
        // estiver em modo de inserção, mas sim de edição.
        if (!parametrosWidget.isNewRow()) {
            setParametersVerified(parametrosWidget);
        }
    };

    /*
     * Função auxiliar para a chamada da função de exportação no backend.
     * Criada para os casos onde há validação assíncrona antes da exportação.
     */
    var callExportacao = function callExportacao(spedWidget) {
        spedWidget.currentRow.NRORG = getLocalVar('NRORG');
        var row = spedWidget.currentRow;
        var route = "fis#/exportarSped";
        var message = Messages_fiscal.EXPORTANDO_SPED;
        ObrigacoesAcessoriasUtil.exportarArquivo(row, route, message);
    };

    self.downloadArquivoAgendado = function (spedWidget) {
        var downloadRoute;
        var fileName;
        var serviceUrl;
        General.callRestEngine('fis_acessorias#/getFileServerUrl', 'Row', { 'name': fileName }).then(function (sucess) {
            serviceUrl = sucess.dataset.sucess.fileName;
            //serviceUrl = sessionStorage.getItem('FileServerUrl');
            if (spedWidget.hasCheckedRows()) {
                var rows = spedWidget.getCheckedRows();
                rows.forEach(function (row) {
                    downloadRoute = window.serviceUrls.filter(function (x) {
                        return x.package == 'fis';
                    })[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
                    fileName = row.NMPATHARQ;
                    if (fileName.match('teknisa/fis')) {
                        window.open(downloadRoute + row.NMPATHARQ);
                    } else {
                        downloadRoute = window.serviceUrls.filter(function (x) {
                            return x.package == 'fis';
                        })[0].baseUrl + "/downloadArquivoAgendamentoFileServer?requestType=Row&row[NMARQUIVO]=";
                        var rowDownload = {
                            'NMARQUIVO': row.NMARQUIVO,
                            'PATH': serviceUrl + fileName
                        };
                        window.open(downloadRoute + rowDownload.NMARQUIVO + '&row[PATH]=' + rowDownload.PATH);
                    }
                });
            } else {
                var row = spedWidget.currentRow;
                downloadRoute = window.serviceUrls.filter(function (x) {
                    return x.package == 'fis';
                })[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
                fileName = row.NMPATHARQ;
                if (fileName.match('teknisa/fis')) {
                    window.open(downloadRoute + row.NMPATHARQ);
                } else {
                    downloadRoute = window.serviceUrls.filter(function (x) {
                        return x.package == 'fis';
                    })[0].baseUrl + "/downloadArquivoAgendamentoFileServer?requestType=Row&row[NMARQUIVO]=";
                    var rowDownload = {
                        'NMARQUIVO': row.NMARQUIVO,
                        'PATH': serviceUrl + fileName
                    };
                    window.open(downloadRoute + rowDownload.NMARQUIVO + '&row[PATH]=' + rowDownload.PATH);
                }
            }
        });
    };

    self.deleteArquivoAgendado = function (spedWidget) {
        if (spedWidget.hasCheckedRows()) {
            var rows = spedWidget.getCheckedRows();
            General.callRestEngine('fis_acessorias#/deleteArquivo', 'DataSet', rows).then(function (sucesso) {
                spedWidget.reload();
            }, function (error) {
                ScreenService.showMessage(error.dataset.error);
            });
        }
    };

    /*
     * Função auxiliar chamada ao abrir o swipe de parâmetros para validar as
     * propriedades dos fields que são dependentes dos dados carregados/alterados.
     */
    var callFieldsOnChange = function callFieldsOnChange(parametrosWidget) {
        // Verifica se é a widget de parametrização do SPED Contribuições.
        if (parametrosWidget.name == "parametrosContribuicoes") {
            // Chama as funções de FieldOnChange dessa widget.
            self.finalidadeArquivoContribuicoesOnChange(parametrosWidget, true);
            self.incidenciaTributariaOnChange(parametrosWidget, true);
        } else {
            self.geraBlocoKOnChange(parametrosWidget, true);
            self.controlaClassific(parametrosWidget, true);
            self.controlaInfComplementar(parametrosWidget, true);
        }
    };

    /*
     * Função para atualizar um field select conforme necessidade.
     * Caso algum filtro deste select seja alterado, por exemplo, a propriedade
     * "needReload" do field será setada pra true, indicando que o campo precisa
     * ser atualizado. Alterar a propriedade para false depois impede que o campo
     * sempre seja atualizado sem necessidade.
     */
    this.checkFieldNeedReload = function (field) {
        // Verifica se a propriedade não foi setada como false.
        if (field.needReload !== false) {
            // Caso não tenha, recarrega o field e seta a propriedade como false.
            field.reload();
            field.needReload = false;
        }
    };

    /*
     * Função auxiliar que verifica a parametrização do registro 1400 e a
     * necessidade de preencher dados relacionados em certos estados.
     */
    var checkRegistro1400 = function checkRegistro1400(spedWidget) {
        var currentRow = spedWidget.currentRow;
        // Verifica se a inscrição estadual é de um estado que precisa informar
        // os dados (MG/SP/ES/BA/PR).
        var estadoRequired = currentRow.SGESTADO == "MG" || currentRow.SGESTADO == "SP" || currentRow.SGESTADO == "ES" || currentRow.SGESTADO == "BA" || currentRow.SGESTADO == "PR";

        // Cria um backup e seta os dados na currentRow.
        spedWidget.backupRow = Util.clone(currentRow);
        currentRow.CDLIVROMAGADIC = null;
        currentRow.DTINIVAF = null;
        currentRow.DTFINVAF = null;

        // Se o registro 1400 foi preenchido e for necessário preencher os dados pro estado.
        if (currentRow.REG1400 && estadoRequired) {
            var registro1400TabbedWidget = templateManager.container.getWidget("registro1400Tabbed");
            var registro1400Widget = registro1400TabbedWidget.widgets[0];
            var dataInicial = registro1400Widget.getField("DTINIVAF");
            var dataFinal = registro1400Widget.getField("DTFINVAF");
            var insccentr = registro1400Widget.getField("CDINSCENTR");
            var agrupprod = registro1400Widget.getField("CDGRUPPROD");

            // Verifica se é o estado de Minas Gerais, que tem validação diferente.
            var isMinasGerais = currentRow.SGESTADO == "MG";
            // Verifica se é o estado da Bahia, que tem validação diferente.
            var isBahia = currentRow.SGESTADO == "BA";

            // Seta a currentRow da nova widget igual à da widget principal.
            registro1400Widget.currentRow = currentRow;

            // Verifica as validações dos campos conforme o estado selecionado.
            dataInicial.validations = isMinasGerais ? { required: true } : {};
            dataFinal.validations = isMinasGerais ? { required: true } : {};
            insccentr.validations = isBahia ? { required: true } : {};
            agrupprod.validations = isBahia ? { required: true } : {};

            dataInicial.isVisible = isMinasGerais;
            dataFinal.isVisible = isMinasGerais;
            insccentr.isVisible = isBahia;
            agrupprod.isVisible = isBahia;

            // Se for Minas Gerais, aplica os dados default (as datas).
            if (isMinasGerais) {
                registro1400Widget.applyDefaultValue();
            }

            // Exibe uma notificação pro usuário e abre o swipe com a widget
            // de parametrização do registro.
            ScreenService.showMessage(Messages_fiscal.INFORMAR_DADOS_REGISTRO1400).then(function () {
                registro1400Widget.activate();
                ScreenService.openSwipe(registro1400TabbedWidget);
            });

            return false;
        }
        // Senão, retorna true.
        return true;
    };

    /*
     * Função chamada ao cancelar a inserção dos dados do registro 1400.
     */
    this.cancelRegistro1400 = function () {
        var spedWidget = templateManager.container.getWidget("sped");
        // Retorna a currentRow da widget principal para o estado anterior.
        Util.extend(spedWidget.currentRow, spedWidget.backupRow);

        ScreenService.closeSwipe();
        spedWidget.activate();
    };

    /*
     * Função chamada ao confirmar a inserção dos dados do registro 1400.
     */
    this.confirmRegistro1400 = function (registro1400Widget) {
        if (registro1400Widget.isValid()) {
            var currentRow = registro1400Widget.currentRow;
            var spedWidget = templateManager.container.getWidget("sped");

            // Verifica se há data inserida e se a data final é posterior à inicial.
            if (currentRow.DTINIVAF && moment(currentRow.DTFINVAF, 'DD/MM/YYYY').isBefore(moment(currentRow.DTINIVAF, 'DD/MM/YYYY'))) {
                ScreenService.showMessage(Messages_fiscal.DTINI_POST_DTFIM_ERROR);
                return;
            }
            ScreenService.closeSwipe().then(function () {
                spedWidget.activate();
                // Verifica se as informações do bloco H foram inseridas.
                if (currentRow.IDGERABLOCOH == "N") {
                    ScreenService.showMessage(Messages_fiscal.INVENTARIO_SEM_INFORMACOES).then(function () {
                        // Chama a função de exportação após a confirmação.
                        callExportacao(spedWidget);
                    });
                } else {
                    // Chama a função de exportação sem exibir mensagem.
                    callExportacao(spedWidget);
                }
            });
        }
    };

    /*
     * Função que altera a propriedade readOnly do campo de inscrição conforme
     * a inserção de empresa. Também reseta qualquer valor previamente preenchido.
     * Habilita ou desabilita a tab de Parâmetros Gerais conforme valores preenchidos.
     */
    this.empresaOnChange = function (spedWidget) {
        // Variável booleana que é setada como true caso o SPED selecionado seja o fiscal.
        var spedFiscalIsSelected = spedWidget.currentRow.CDARQUIVO == "ICMS";
        // Variável booleana que é setada como true caso alguma empresa tenha sido selecionada.
        var empresaIsSelected = !!spedWidget.currentRow.CDEMPRESA;
        var inscricaoField = spedWidget.getField('CDINSCESTA');

        // Seleciona a widget de parâmetros conforme SPED escolhido.
        var parametrosWidget = spedFiscalIsSelected ? templateManager.container.getWidget('parametrosFiscal') : templateManager.container.getWidget('parametrosContribuicoes');
        // Altera a habilitação da widget de parâmetros gerais conforme o SPED
        // selecionado for Contribuições e se o campo de empresa tiver sido preenchido.
        parametrosWidget.enabled = empresaIsSelected && !spedFiscalIsSelected;

        // Altera as propriedades do field de inscrição e reseta seu valor.
        inscricaoField.readOnly = !empresaIsSelected;
        inscricaoField.setValue(null);
        inscricaoField.needReload = true;
    };

    /*
     * Função que habilita ou desabilita a tab de Parâmetros Gerais para o SPED
     * Fiscal conforme valores preenchidos.
     */
    this.inscricaoOnChange = function (spedWidget) {
        // Variável booleana que é setada como true caso alguma inscrição tenha sido selecionada.
        var inscricaoIsSelected = !!spedWidget.currentRow.CDINSCESTA;

        // Como o campo de inscrição só é habilitado para o SPED Fiscal,
        // seleciona a widget de parametrização correspondente.
        var parametrosWidget = templateManager.container.getWidget('parametrosFiscal');

        // Altera a habilitação da widget de parâmetros gerais
        // selecionado for Contribuições e se o campo de inscrição tiver sido preenchido.
        parametrosWidget.enabled = inscricaoIsSelected;

        // Chamada para a função que valida o estado da inscrição estadual
        this.toggleInscMunicipalVisibility(spedWidget);
    };

    /*
     * Função chamada ao apertar na action para exportar SPED.
     * Verifica validações e redireciona para a função de exportação.
     */
    this.exportarSped = function (spedWidget) {
        // Verifica se todos os campos obrigatórios foram preenchidos.
        if (spedWidget.isValid()) {
            var currentRow = spedWidget.currentRow;
            // Verifica se há data de inventário fiscal e se a data final é
            // posterior à inicial.
            if (currentRow.DTINIPERFISC && moment(currentRow.DTFINPERFISC, 'DD/MM/YYYY').isBefore(moment(currentRow.DTINIPERFISC, 'DD/MM/YYYY'))) {
                ScreenService.showMessage(Messages_fiscal.DTINI_POST_DTFIM_ERROR);
                return;
            }
            // Verifica se a parametrização para exportação foi verificada.
            if (!parametrizacaoWasLoaded(spedWidget)) {
                return;
            }

            // Verifica se o arquivo é do tipo Fiscal.
            if (currentRow.CDARQUIVO == "ICMS") {
                // Valida a necessidade de inserir as informações sobre valores
                // agregados.
                if (checkRegistro1400(spedWidget)) {
                    // Verifica se as informações do bloco H foram inseridas.
                    if (currentRow.IDGERABLOCOH == "N") {
                        ScreenService.showMessage(Messages_fiscal.INVENTARIO_SEM_INFORMACOES).then(function () {
                            // Chama a função de exportação após a confirmação.
                            callExportacao(spedWidget);
                        });
                    } else {
                        // Chama a função de exportação sem exibir mensagem.
                        callExportacao(spedWidget);
                    }
                }
            }
            // Se não for, chama a exportação do SPED.
            else {
                    callExportacao(spedWidget);
                }
        }
    };

    /*
     * Função chamada ao alterar o valor do campo "Finalidade do Arquivo" da
     * parametrização do SPED Contribuições.
     * Altera as validações do campo "Recibo Anterior".
     */
    this.finalidadeArquivoContribuicoesOnChange = function (args) {
        var widget = args.owner.owner.widget;
        var reciboField = widget.getField("STRECANT");
        var finalidade = widget.getField("STFINALIDADE");

        if (widget.currentRow.STFINALIDADE == "1") {
            reciboField.readOnly = false;
        } else {
            reciboField.readOnly = true;
        }
        finalidade.reload();
    };

    /* as informações sobre a versão (bo
     * Função chamada ao alterar o valor do campo "Gera Bloco K" da
     * parametrização do SPED Fiscal.
     * Altera as validações do campo "Origem Dados (Bloco K)".
     */
    this.geraBlocoKOnChange = function (parametrosWidget, openingSwipe) {
        // Verifica se foi marcada a opção "1" no campo.
        var geraBlocoK = parametrosWidget.currentRow.IDGERABLOCOK == "S";
        var origemDadosField = parametrosWidget.getField("IDORIGBLOCOK");

        // Altera a propriedade readOnly do campo.
        origemDadosField.readOnly = !geraBlocoK;
        origemDadosField.validations = geraBlocoK ? { required: true } : {};
        origemDadosField.reload();

        // Verifica se a função foi chamada pelo evento FieldOnChange e não
        // pela função de abrir o swipe.
        if (!openingSwipe) {
            // Reseta o valor do campo.
            origemDadosField.setValue('2');
        }
    };

    /*
     * Função chamada ao alterar o valor do campo "Incidência Tributária".
     * Altera as validações dos campos "Critério de Escrituração" e "Apropriação do Crédito".
     */
    this.incidenciaTributariaOnChange = function (args) {
        var widget = args.owner.owner.widget;
        var criterioField = widget.getField("STCRTESCRIT");
        var indicador = widget.getField("STINCTRIB");
        if (widget.currentRow.STINCTRIB == "2") {
            criterioField.readOnly = false;
        } else {
            criterioField.readOnly = true;
        }
        indicador.reload();
    };
    /*
     * Função para abrir o formulário com as parametrizações do SPED.
     * Abre uma widget diferente, conforme o arquivo escolhido.
     * Altera o parâmetro "wasLoaded" da widget, que indica se a parametrização
     * foi revisada antes do arquivo ter sido exportado.
     */
    var openTabParametrosGerais = function openTabParametrosGerais(spedWidget) {
        var currentRow = spedWidget.currentRow;
        var spedFiscalIsSelected = currentRow.CDARQUIVO == 'ICMS';

        // Seleciona a widget conforme o arquivo selecionado.
        var parametrosWidget = spedFiscalIsSelected ? templateManager.container.getWidget('parametrosFiscal') : templateManager.container.getWidget('parametrosContribuicoes');

        // Recarrega os dados parametrizados.
        parametrosWidget.reload().then(function () {
            // Redesenha a widget, fazendo com que apareçam os dados carregados.
            parametrosWidget.redraw();
        });

        // Abre a widget de parametrização do arquivo correspondente.
        spedWidget.currentWidget = parametrosWidget;
        parametrosWidget.activate();
    };

    /*
     * Função auxiliar chamada ao tentar exportar um arquivo.
     * Retorna true caso a parametrização tenha sido verificada antes da exportação.
     * Abre a widget de parametrização caso contrário.
     */
    var parametrizacaoWasLoaded = function parametrizacaoWasLoaded(spedWidget) {
        var parametrizacaoWasLoaded;
        var parametrosWidget;
        var cdempresa = spedWidget.currentRow.CDEMPRESA;
        var cdinscesta = spedWidget.currentRow.CDINSCESTA;

        // Seleciona e valida a widget conforme o arquivo selecionado.
        if (spedWidget.currentRow.CDARQUIVO == 'ICMS') {
            parametrosWidget = templateManager.container.getWidget('parametrosFiscal');
            // Valida se a propriedade está setada para a empresa e inscrição estadual selecionados.
            parametrizacaoWasLoaded = parametrosWidget.empresasLoaded[cdempresa] && parametrosWidget.empresasLoaded[cdempresa][cdinscesta];
        } else {
            parametrosWidget = templateManager.container.getWidget('parametrosContribuicoes');
            // Valida se a propriedade está setada para a empresa selecionada.
            parametrizacaoWasLoaded = parametrosWidget.empresasLoaded[cdempresa];
        }

        // Verifica se a widget de parametrização foi aberta antes de exportar o arquivo.
        if (!parametrizacaoWasLoaded) {
            // Muda a propriedade para que seja obrigatório que a parametrização seja informada.
            parametrosWidget.parametersRequired = true;

            // Exibe a mensagem que indica que os parâmetros devem ser verificados.
            ScreenService.showMessage(Messages_fiscal.PARAMETROS_GERAIS_NAO_INFORMADOS_ERROR).then(function () {
                // Abre a swipe da widget de parâmetros.
                openTabParametrosGerais(spedWidget);
            });
            // Retorna false, indicando que a parametrização não foi previamente conferida.
            return false;
        }
        // Retorna true caso contrário, indicando que a parametrização foi previamente conferida.
        return true;
    };

    /*
     * Função para salvar a parametrização informada pelo usuário.
     */
    this.salvarParametrizacao = function (parametrosWidget) {
        // Verifica se todos os dados requeridos foram preenchidos.
        if (parametrosWidget.isValid()) {
            // Configurações específicas para os parâmetros do SPED Fiscal.
            if (parametrosWidget.name == "parametrosFiscal") {
                var currentRow = parametrosWidget.currentRow;

                // se o campo vier vazio, vai deletar ele e vai usar o default
                if (parametrosWidget.currentRow.IDGERACAMPO11ST == "") {
                    delete parametrosWidget.currentRow.IDGERACAMPO11ST;
                }
                if (parametrosWidget.currentRow.IDCLASSIFICESTAB == "") {
                    delete parametrosWidget.currentRow.IDCLASSIFICESTAB;
                }
                // Cria um array com os valores das obrigatoriedades resetados.
                var obrigatoriedadesArray = ["N", "N", "N", "N", "N", "N", "N", "N", "N"];

                // Para cada obrigatoriedade selecionada, muda o valor no array para "S".
                if (Array.isArray(currentRow.CDOBRIGARRAY)) {
                    currentRow.CDOBRIGARRAY.forEach(function (index) {
                        obrigatoriedadesArray[index] = 'S';
                    });
                }

                // Transforma o array em uma String e atribui ao campo.
                currentRow.CDOBRIGAREGBL1 = obrigatoriedadesArray.join("");
            }
            // Chama a função para salvar os dados.
            parametrosWidget.currentRow.CDCAMPO1 = parametrosWidget.currentRow.STFINALIDADE;
            parametrosWidget.currentRow.CDCAMPO5 = parametrosWidget.currentRow.STINCTRIB;
            parametrosWidget.currentRow.CDCAMPO10 = parametrosWidget.currentRow.STCRTESCRIT;

            parametrosWidget.saveRow().then(function () {
                var spedWidget = templateManager.container.getWidget("sped");

                // Seta os parametros como verificados pelo usuário.
                setParametersVerified(parametrosWidget);

                // Altera a widget ativa para a principal.
                spedWidget.activate();
                spedWidget.currentWidget = spedWidget;

                // Verifica se os parâmetros foram exibidos devido a uma
                // tentativa de exportar o SPED. Em caso positivo, tenta
                // exportar o SPED novamente.
                if (parametrosWidget.parametersRequired) {
                    self.exportarSped(spedWidget);
                    // Retira a necessidade de exportar automaticamente ao
                    // abrir a parametrização novamente.
                    parametrosWidget.parametersRequired = false;
                }
            });
        }
    };

    /*
     * Função para salvar o valor de um field com outro nome na currentRow.
     * Chamada pela parametrização do SPED Contribuições, devido ao fato deste
     * utilizar uma tabela genérica e campos com nomes genéricos, sendo necessário
     * salvar o valor com o nome original do campo.
     * Utilizado por fields select-native também devido ao fato do outData não
     * funcionar da maneira devida neste caso.
     */
    this.setCurrentRowValue = function (field) {
        // Seta a propriedade na currentRow com o mesmo valor do field.
        field.widget.currentRow[field.originalColumn] = field.value();
    };

    /*
     * Função para setar a currentRow da widget de parâmetros após o carregamento dos dados.
     * Altera, também, a propriedade que indica se já havia uma parametrização cadastrada.
     */
    this.setLoadedParameters = function (parametrosWidget) {
        var spedWidget = templateManager.container.getWidget("sped");

        // Verifica se há alguma parametrização retornada.
        if (parametrosWidget.dataSource.data.length > 0) {
            // Seta a currentRow como o primeiro dado no array retornado.
            parametrosWidget.moveToFirst();

            // Configurações específicas para os parâmetros do SPED Fiscal.
            if (parametrosWidget.name == "parametrosFiscal") {
                var currentRow = parametrosWidget.currentRow;
                // O campo "CDOBRIGAREGBL1" possui a parametrização da obrigatoriedades dos registros (Bloco 1).
                // Os valores são armazenados em uma String na ordem de aparição dos campos,
                // sendo 'N' para "falso" e 'S' para "verdadeiro".
                var codigosArray = currentRow.CDOBRIGAREGBL1.split("");

                // Adiciona no array todos os valores marcados.
                currentRow.CDOBRIGARRAY = [];
                if (codigosArray[0] == 'S') {
                    // Registro 1100.
                    currentRow.CDOBRIGARRAY.push(0);
                }
                if (codigosArray[1] == 'S') {
                    // Registro 1200.
                    currentRow.CDOBRIGARRAY.push(1);
                }
                if (codigosArray[2] == 'S') {
                    // Registro 1300.
                    currentRow.CDOBRIGARRAY.push(2);
                }
                if (codigosArray[3] == 'S') {
                    // Registro 1390.
                    currentRow.CDOBRIGARRAY.push(3);
                }
                if (codigosArray[4] == 'S') {
                    // Registro 1400.
                    currentRow.CDOBRIGARRAY.push(4);
                }
                if (codigosArray[5] == 'S') {
                    // Registro 1500.
                    currentRow.CDOBRIGARRAY.push(5);
                }
                if (codigosArray[6] == 'S') {
                    // Registro 1600.
                    currentRow.CDOBRIGARRAY.push(6);
                }
                if (codigosArray[7] == 'S') {
                    // Registro 1700.
                    currentRow.CDOBRIGARRAY.push(7);
                }
                if (codigosArray[8] == 'S') {
                    // Registro 1800.
                    currentRow.CDOBRIGARRAY.push(8);
                }
            }
        } else {
            // Seta a widget em modo de novo dado, para inserir a parametrização.
            parametrosWidget.newRow();
            parametrosWidget.currentRow.CDEMPRESA = spedWidget.currentRow.CDEMPRESA;
            parametrosWidget.currentRow.CDINSCESTA = spedWidget.currentRow.CDINSCESTA;
        }

        // Seta o nome da empresa no campo select de empresa, devido a um
        // comportamento que não exibe o nome da empresa correspondente ao código.
        parametrosWidget.currentRow.NMEMPRESA = spedWidget.currentRow.NMEMPRESA;
    };

    /*
     * Função auxiliar que seta na widget de parâmetros a propriedade indicando
     * que a parametrização foi verificada pelo usuário.
     */
    var setParametersVerified = function setParametersVerified(parametrosWidget) {
        var spedFiscalIsSelected = parametrosWidget.name == "parametrosFiscal";
        var currentRow = parametrosWidget.currentRow;
        // Seta a propriedade que indica se a parametrização foi verificada.
        if (spedFiscalIsSelected) {
            var spedWidget = templateManager.container.getWidget("sped");
            // Verifica se o objeto já foi criado pra esta empresa.
            if (!parametrosWidget.empresasLoaded[currentRow.CDEMPRESA]) {
                parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = {};
            }
            // Seta o parâmetro para a empresa e inscrição estadual selecionados.
            parametrosWidget.empresasLoaded[currentRow.CDEMPRESA][currentRow.CDINSCESTA] = true;
            spedWidget.currentRow.REG1400 = Array.isArray(currentRow.CDOBRIGARRAY) && currentRow.CDOBRIGARRAY.indexOf(4) !== -1;
        } else {
            // Modifica a propriedade indicando que a parametrização foi
            // aberta para a empresa selecionada.
            parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = true;
        }
    };

    /*
     * Função chamada ao alterar o campo "Gera informações do Inventário Fiscal".
     * Reseta os valores dos campos do fieldGroup relacionado e altera a propriedade
     * readOnly, conforme opção selecionada.
     */
    this.toggleBlocohFieldsReadonly = function (spedWidget) {
        var dataInicialField = spedWidget.getField("DTINIPERFISC");
        var dataFinalField = spedWidget.getField("DTFINPERFISC");
        var motivoField = spedWidget.getField("CDMOTINVENTARIO");
        var blocohEnabled = spedWidget.currentRow.IDGERABLOCOH == 'S';

        // Altera a propriedade readOnly dos campos, setando como true caso o valor seja 'N'.
        dataInicialField.readOnly = !blocohEnabled;
        dataFinalField.readOnly = !blocohEnabled;
        motivoField.readOnly = !blocohEnabled;

        // Altera a validação required dos campos, sendo requerido caso o valor seja 'S'.
        dataInicialField.validations = blocohEnabled ? { required: true } : {};
        dataFinalField.validations = blocohEnabled ? { required: true } : {};
        motivoField.validations = blocohEnabled ? { required: true } : {};

        // Seta os valores default caso o valor seja 'S'.
        if (blocohEnabled) {
            dataInicialField.applyDefaultValue();
            dataFinalField.applyDefaultValue();
        }
        // Seta os valores como nulos caso o valor seja 'N'.
        else {
                dataInicialField.setValue(null);
                dataFinalField.setValue(null);
            }

        // Reseta o valor do campo de Motivo, que não tem valor default.
        motivoField.setValue(null);
    };

    /*
     * Função auxiliar chamada ao alterar o tipo de arquivo a ser exportado.
     * Muda a visibilidade e as validações dos fields relacionados ao inventário fiscal.
     */
    var toggleBlocohFieldsVisibility = function toggleBlocohFieldsVisibility(spedWidget, isVisible) {
        var gerablocoField = spedWidget.getField("IDGERABLOCOH");
        var dataInicialField = spedWidget.getField("DTINIPERFISC");
        var dataFinalField = spedWidget.getField("DTFINPERFISC");
        var motivoField = spedWidget.getField("CDMOTINVENTARIO");

        // Busca o fieldGroup com os fields do Bloco H e seta a propriedade isVisible..
        spedWidget.fieldGroups.filter(function (fieldGroup) {
            return fieldGroup.name == "blocoh";
        })[0].isVisible = isVisible;

        // Altera a visibilidade dos campos conforme o arquivo selecionado.
        gerablocoField.isVisible = isVisible;
        dataInicialField.isVisible = isVisible;
        dataFinalField.isVisible = isVisible;
        motivoField.isVisible = isVisible;

        // Se for visível, verifica os valores e as propriedades dos fields.
        if (isVisible) {
            self.toggleBlocohFieldsReadonly(spedWidget);
        }
        // Senão, retira as validações dos fields.
        else {
                gerablocoField.validations = {};
                dataInicialField.validations = {};
                // dataFinalField.validations = {};
                motivoField.validations = {};
            }
    };

    /*
     * Função que altera a visibilidade do field CDINSCMUNI,
     * de acordo com o estado da Inscrição Estadual.
     */
    this.toggleInscMunicipalVisibility = function (widget) {
        var estado = widget.currentRow.SGESTADO;
        var arquivo = widget.currentRow.CDARQUIVO;
        var inscmuni = widget.getField('CDINSCMUNI');

        //Se o SPED Fiscal estiver selecionado e o estado selecionado for DF, habilita o field CDINSCMUNI
        if (estado == "DF" && arquivo == "ICMS") {
            inscmuni.validations = { "required": { "message": "Campo obrigatório" } };
            inscmuni.readOnly = false;
        } else {
            inscmuni.validations = {};
            inscmuni.readOnly = true;
            inscmuni.setValue("");
        }
    };

    this.controlaInfComplementar = function (parametrosWidget) {
        var nrdias = parametrosWidget.getField('NRDIAMEDIAEST');
        var geravalor = parametrosWidget.getField('IDGERACAMPO11ST');
        var indicador = parametrosWidget.getField('IDINFCOMPLST');

        nrdias.readOnly = true;
        geravalor.readOnly = true;
        indicador.reload();

        if (parametrosWidget.currentRow.IDINFCOMPLST == "S") {
            nrdias.readOnly = false;
            geravalor.readOnly = false;
            indicador.reload();
        } else {
            nrdias.readOnly = true;
            geravalor.readOnly = true;
            geravalor.clearValue();
            nrdias.clearValue();
            indicador.reload();
        }
        indicador.reload();
    };

    this.controlaClassific = function (parametrosWidget) {
        var classific = parametrosWidget.getField('IDCLASSIFICESTAB');
        var indicador = parametrosWidget.getField('IDINDATIVIDADE');

        classific.readOnly = true;
        indicador.reload();

        if (parametrosWidget.currentRow.IDINDATIVIDADE == "0") {
            classific.readOnly = false;
            indicador.reload();
        } else {
            classific.readOnly = true;
            classific.clearValue();
            indicador.reload();
        }
        indicador.reload();
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis85000_Sped_Controller', Fis85000_Sped_Controller);
});

// FILE: ./assets/modules/acessorias/assets/js/controllers/Fis93000_Dirf_Controller.js
var Fis93000_Dirf_Controller = function Fis93000_Dirf_Controller(General, ScreenService, templateManager, Messages_fiscal, ObrigacoesAcessoriasUtil, ZHPromise) {

    // Armazena o escopo atual.
    var self = this;

    this.exportar = function (widget) {
        // Verifica se todos os campos obrigatórios foram preenchidos.
        if (widget.isValid()) {

            // Atribui aos fields da widget principal, os vaores da widget
            // 'parametrosGeraidDacAl'
            var parametrosWidget = templateManager.container.getWidget('parametrosFiscal');
            preencheFieldsOcultosWidgetPrincipal(widget, parametrosWidget);
            var row = widget.currentRow;
            var route = "fis#/exportardirf";
            var message = Messages_fiscal.EXPORTANDO_DIRF;
            ObrigacoesAcessoriasUtil.exportarArquivo(row, route, message);
        }
    };

    var preencheFieldsOcultosWidgetPrincipal = function preencheFieldsOcultosWidgetPrincipal(widget, parametrosWidget) {
        widget.currentRow.CDTPDECLARACAO = parametrosWidget.currentRow.CDTPDECLARACAO;
        widget.currentRow.NUMRECIBO = parametrosWidget.currentRow.NUMRECIBO;
        widget.currentRow.CDNATDECLARANTE = parametrosWidget.currentRow.CDNATDECLARANTE;
        widget.currentRow.CDINDSOCIO = parametrosWidget.currentRow.CDINDSOCIO;
        widget.currentRow.CDDEPOSITCRED = parametrosWidget.currentRow.CDDEPOSITCRED;
        widget.currentRow.CDTPINVEST = parametrosWidget.currentRow.CDTPINVEST;
        widget.currentRow.CDRENDPGEXT = parametrosWidget.currentRow.CDRENDPGEXT;
        widget.currentRow.CDINDPLANSD = parametrosWidget.currentRow.CDINDPLANSD;
        widget.currentRow.CDPGIMUISE = parametrosWidget.currentRow.CDPGIMUISE;
        widget.currentRow.CDFUNPUBDIRPRIV = parametrosWidget.currentRow.CDFUNPUBDIRPRIV;
        widget.currentRow.CDSITESP = parametrosWidget.currentRow.CDSITESP;
        widget.currentRow.DTEVENTO = parametrosWidget.currentRow.DTEVENTO;
        widget.currentRow.CDREPRES = parametrosWidget.currentRow.CDREPRES;
    };

    /*
     * Função para abrir o formulário com as parametrizações do DAC-AL.
     * Altera o parâmetro "wasLoaded" da widget, que indica se a parametrização
     * foi revisada antes do arquivo ter sido exportado.
     */
    var openTabParametrosGerais = function openTabParametrosGerais(widget) {

        // Seleciona a widget conforme o arquivo selecionado.
        var parametrosWidget = templateManager.container.getWidget('parametrosFiscalDirf');
        // Recarrega os dados parametrizados.
        parametrosWidget.reload().then(function () {
            // Redesenha a widget, fazendo com que apareçam os dados carregados.
            parametrosWidget.redraw();
        });
        // Abre a widget da tabbed 'parametrosGerais'
        widget.currentWidget = parametrosWidget;
        parametrosWidget.activate();
    };

    this.save = function (widget) {
        // Seleciona a widget conforme o arquivo selecionado.
        var parametrosWidget = templateManager.container.getWidget('parametrosFiscalDirf');
        General.callRestEngine('fis_acessorias#/savedirf', 'Row', widget.currentRow).then(function (success) {
            General.changeWidgetAcessibility(widget.widgets, true);
            ScreenService.showMessage('Salvo com sucesso.');
            ScreenService.goBack();
            widget.reload();
        }, function (error) {
            ScreenService.showMessage(error.data.error);
        });
    };

    this.setLoadedParameters = function (parametrosWidget) {
        var dirfwidget = templateManager.container.getWidget("FED_DIRF");

        // Verifica se há alguma parametrização retornada.
        if (parametrosWidget.dataSource.data.length > 0) {
            // Seta a currentRow como o primeiro dado no array retornado.
            parametrosWidget.moveToFirst();

            // Configurações específicas para os parâmetros do SPED Fiscal.
            if (parametrosWidget.name == "parametrosFiscalDirf") {
                var currentRow = parametrosWidget.currentRow;
                // O campo "CDOBRIGAREGBL1" possui a parametrização da obrigatoriedades dos registros (Bloco 1).
                // Os valores são armazenados em uma String na ordem de aparição dos campos,
                // sendo 'N' para "falso" e 'S' para "verdadeiro".
                var codigosArray = currentRow.CDOBRIGAREGBL1.split("");

                // Adiciona no array todos os valores marcados.
                currentRow.CDOBRIGARRAY = [];
                if (codigosArray[0] == 'S') {
                    // Registro 1100.
                    currentRow.CDOBRIGARRAY.push(0);
                }
                if (codigosArray[1] == 'S') {
                    // Registro 1200.
                    currentRow.CDOBRIGARRAY.push(1);
                }
                if (codigosArray[2] == 'S') {
                    // Registro 1300.
                    currentRow.CDOBRIGARRAY.push(2);
                }
                if (codigosArray[3] == 'S') {
                    // Registro 1390.
                    currentRow.CDOBRIGARRAY.push(3);
                }
                if (codigosArray[4] == 'S') {
                    // Registro 1400.
                    currentRow.CDOBRIGARRAY.push(4);
                }
                if (codigosArray[5] == 'S') {
                    // Registro 1500.
                    currentRow.CDOBRIGARRAY.push(5);
                }
                if (codigosArray[6] == 'S') {
                    // Registro 1600.
                    currentRow.CDOBRIGARRAY.push(6);
                }
                if (codigosArray[7] == 'S') {
                    // Registro 1700.
                    currentRow.CDOBRIGARRAY.push(7);
                }
                if (codigosArray[8] == 'S') {
                    // Registro 1800.
                    currentRow.CDOBRIGARRAY.push(8);
                }
                if (codigosArray[9] == 'S') {
                    // Registro 1800.
                    currentRow.CDOBRIGARRAY.push(9);
                }
                if (codigosArray[10] == 'S') {
                    // Registro 1800.
                    currentRow.CDOBRIGARRAY.push(10);
                }
                if (codigosArray[11] == 'S') {
                    // Registro 1800.
                    currentRow.CDOBRIGARRAY.push(11);
                }
                if (codigosArray[12] == 'S') {
                    // Registro 1800.
                    currentRow.CDOBRIGARRAY.push(12);
                }
            }
        } else {
            // Seta a widget em modo de novo dado, para inserir a parametrização.
            parametrosWidget.newRow();
            parametrosWidget.currentRow.CDEMPRESA = dirfwidget.currentRow.CDEMPRESA;
        }

        // Seta o nome da empresa no campo select de empresa, devido a um
        // comportamento que não exibe o nome da empresa correspondente ao código.
        parametrosWidget.currentRow.NMEMPRESA = dirfwidget.currentRow.NMEMPRESA;
    };

    this.beforeExitParametrosGerais = function (parametrosWidget) {
        // Seta a parametrização como verificada somente se a widget não
        // estiver em modo de inserção, mas sim de edição.
        if (!parametrosWidget.isNewRow()) {
            setParametersVerified(parametrosWidget);
        }
    };

    var setParametersVerified = function setParametersVerified(parametrosWidget) {
        var dirfFiscalIsSelected = parametrosWidget.name == "parametrosFiscalDirf";
        var currentRow = parametrosWidget.currentRow;
        // Seta a propriedade que indica se a parametrização foi verificada.
        if (dirfFiscalIsSelected) {
            var spedWidget = templateManager.container.getWidget("FED_DIRF");
            // Verifica se o objeto já foi criado pra esta empresa.
            if (!parametrosWidget.empresasLoaded[currentRow.CDEMPRESA]) {
                parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = {};
            }
            // Seta o parâmetro para a empresa  selecionados.
            parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = true;
            spedWidget.currentRow.REG1400 = Array.isArray(currentRow.CDOBRIGARRAY) && currentRow.CDOBRIGARRAY.indexOf(4) !== -1;
        } else {
            // Modifica a propriedade indicando que a parametrização foi
            // aberta para a empresa selecionada.
            parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = true;
        }
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis93000_Dirf_Controller', Fis93000_Dirf_Controller);
});

// FILE: ./assets/modules/acessorias/assets/js/controllers/Fis97000_dctf_Controller.js
var Fis97000_dctf_Controller = function Fis97000_dctf_Controller(General, ScreenService, templateManager, Messages_fiscal, ObrigacoesAcessoriasUtil, ZHPromise) {

    // Armazena o escopo atual.
    var self = this;

    this.exportar = function (widget) {
        // Verifica se todos os campos obrigatórios foram preenchidos.
        if (widget.isValid()) {

            // Atribui aos fields da widget principal, os vaores da widget
            // 'parametrosGeraidDacAl'
            var DCTF = templateManager.container.getWidget('FED_DCTF');
            var parametrosWidget = templateManager.container.getWidget('parametrosGeraisDCTF');
            parametrosWidget.currentRow.CDEMPRESA = DCTF.currentRow.CDEMPRESA;
            parametrosWidget.currentRow.DTREFINI = DCTF.currentRow.DTREFINI;
            parametrosWidget.currentRow.NMARQUIVO = DCTF.currentRow.NMARQUIVO;
            parametrosWidget.currentRow.NRORG = getLocalVar('NRORG');
            preencheFieldsOcultosWidgetPrincipal(widget, parametrosWidget);
            var row = parametrosWidget.currentRow;
            var route = "fis#/exportarDCTF";
            var message = Messages_fiscal.EXPORTANDO_DIRF;
            ObrigacoesAcessoriasUtil.exportarArquivo(row, route, message);
        }
    };

    var preencheFieldsOcultosWidgetPrincipal = function preencheFieldsOcultosWidgetPrincipal(widget, parametrosWidget) {
        widget.currentRow.CDTPDECLARACAO = parametrosWidget.currentRow.CDTPDECLARACAO;
        widget.currentRow.NUMRECIBO = parametrosWidget.currentRow.NUMRECIBO;
        widget.currentRow.CDNATDECLARANTE = parametrosWidget.currentRow.CDNATDECLARANTE;
        widget.currentRow.CDINDSOCIO = parametrosWidget.currentRow.CDINDSOCIO;
        widget.currentRow.CDDEPOSITCRED = parametrosWidget.currentRow.CDDEPOSITCRED;
        widget.currentRow.CDTPINVEST = parametrosWidget.currentRow.CDTPINVEST;
        widget.currentRow.CDRENDPGEXT = parametrosWidget.currentRow.CDRENDPGEXT;
        widget.currentRow.CDINDPLANSD = parametrosWidget.currentRow.CDINDPLANSD;
        widget.currentRow.CDPGIMUISE = parametrosWidget.currentRow.CDPGIMUISE;
        widget.currentRow.CDFUNPUBDIRPRIV = parametrosWidget.currentRow.CDFUNPUBDIRPRIV;
        widget.currentRow.CDSITESP = parametrosWidget.currentRow.CDSITESP;
        widget.currentRow.DTEVENTO = parametrosWidget.currentRow.DTEVENTO;
        widget.currentRow.CDREPRES = parametrosWidget.currentRow.CDREPRES;
    };

    /*
     * Função para abrir o formulário com as parametrizações do DAC-AL.
     * Altera o parâmetro "wasLoaded" da widget, que indica se a parametrização
     * foi revisada antes do arquivo ter sido exportado.
     */
    var openTabParametrosGerais = function openTabParametrosGerais(widget) {

        // Seleciona a widget conforme o arquivo selecionado.
        var parametrosWidget = templateManager.container.getWidget('parametrosGeraisDCTF');
        // Recarrega os dados parametrizados.
        parametrosWidget.reload().then(function () {
            // Redesenha a widget, fazendo com que apareçam os dados carregados.
            parametrosWidget.redraw();
        });
        // Abre a widget da tabbed 'parametrosGerais'
        widget.currentWidget = parametrosWidget;
        parametrosWidget.activate();
    };

    this.save = function (widget) {
        // Seleciona a widget conforme o arquivo selecionado.
        var DCTF = templateManager.container.getWidget('FED_DCTF');
        var parametrosWidget = templateManager.container.getWidget('parametrosGeraisDCTF');
        parametrosWidget.currentRow.CDEMPRESA = DCTF.currentRow.CDEMPRESA;
        parametrosWidget.currentRow.DTREFINI = DCTF.currentRow.DTREFINI;
        parametrosWidget.currentRow.NMARQUIVO = DCTF.currentRow.NMARQUIVO;
        parametrosWidget.currentRow.NRORG = getLocalVar('NRORG');
        General.callRestEngine('fis_acessorias#/saveDCTF', 'Row', widget.currentRow).then(function (success) {
            General.changeWidgetAcessibility(widget.widgets, true);
            ScreenService.showMessage('Salvo com sucesso.');
            ScreenService.goBack();
            widget.reload();
        }, function (error) {
            ScreenService.showMessage(error.data.error);
        });
    };

    this.setLoadedParameters = function (parametrosWidget) {
        var widget = templateManager.container.getWidget("FED_DCTF");

        // Verifica se há alguma parametrização retornada.
        if (parametrosWidget.dataSource.data.length > 0) {
            // Seta a currentRow como o primeiro dado no array retornado.
            parametrosWidget.moveToFirst();

            // Configurações específicas para os parâmetros do SPED Fiscal.
            if (parametrosWidget.name == "parametrosGeraisDCTF") {
                var currentRow = parametrosWidget.currentRow;
                // O campo "CDOBRIGAREGBL1" possui a parametrização da obrigatoriedades dos registros (Bloco 1).
                // Os valores são armazenados em uma String na ordem de aparição dos campos,
                // sendo 'N' para "falso" e 'S' para "verdadeiro".
                var codigosArray = currentRow.CDOBRIGAREGBL1.split("");

                // Adiciona no array todos os valores marcados.
                currentRow.CDOBRIGARRAY = [];
                if (codigosArray[0] == 'S') {
                    // Registro 1100.
                    currentRow.CDOBRIGARRAY.push(0);
                }
                if (codigosArray[1] == 'S') {
                    // Registro 1200.
                    currentRow.CDOBRIGARRAY.push(1);
                }
                if (codigosArray[2] == 'S') {
                    // Registro 1300.
                    currentRow.CDOBRIGARRAY.push(2);
                }
                if (codigosArray[3] == 'S') {
                    // Registro 1390.
                    currentRow.CDOBRIGARRAY.push(3);
                }
                if (codigosArray[4] == 'S') {
                    // Registro 1400.
                    currentRow.CDOBRIGARRAY.push(4);
                }
                if (codigosArray[5] == 'S') {
                    // Registro 1500.
                    currentRow.CDOBRIGARRAY.push(5);
                }
                if (codigosArray[6] == 'S') {
                    // Registro 1600.
                    currentRow.CDOBRIGARRAY.push(6);
                }
                if (codigosArray[7] == 'S') {
                    // Registro 1700.
                    currentRow.CDOBRIGARRAY.push(7);
                }
                if (codigosArray[8] == 'S') {
                    // Registro 1800.
                    currentRow.CDOBRIGARRAY.push(8);
                }
                if (codigosArray[9] == 'S') {
                    // Registro 1800.
                    currentRow.CDOBRIGARRAY.push(9);
                }
                if (codigosArray[10] == 'S') {
                    // Registro 1800.
                    currentRow.CDOBRIGARRAY.push(10);
                }
                if (codigosArray[11] == 'S') {
                    // Registro 1800.
                    currentRow.CDOBRIGARRAY.push(11);
                }
                if (codigosArray[12] == 'S') {
                    // Registro 1800.
                    currentRow.CDOBRIGARRAY.push(12);
                }
            }
        } else {
            // Seta a widget em modo de novo dado, para inserir a parametrização.
            parametrosWidget.newRow();
            parametrosWidget.currentRow.CDEMPRESA = widget.currentRow.CDEMPRESA;
        }

        // Seta o nome da empresa no campo select de empresa, devido a um
        // comportamento que não exibe o nome da empresa correspondente ao código.
        parametrosWidget.currentRow.NMEMPRESA = widget.currentRow.NMEMPRESA;
    };

    this.beforeExitParametrosGerais = function (parametrosWidget) {
        // Seta a parametrização como verificada somente se a widget não
        // estiver em modo de inserção, mas sim de edição.
        if (!parametrosWidget.isNewRow()) {
            setParametersVerified(parametrosWidget);
        }
    };

    var setParametersVerified = function setParametersVerified(parametrosWidget) {
        var DCTFFiscalIsSelected = parametrosWidget.name == "parametrosGeraisDCTF";
        var currentRow = parametrosWidget.currentRow;
        // Seta a propriedade que indica se a parametrização foi verificada.
        if (DCTFFiscalIsSelected) {
            var spedWidget = templateManager.container.getWidget("FED_DCTF");
            // Verifica se o objeto já foi criado pra esta empresa.
            if (!parametrosWidget.empresasLoaded[currentRow.CDEMPRESA]) {
                parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = {};
            }
            // Seta o parâmetro para a empresa  selecionados.
            parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = true;
            spedWidget.currentRow.REG1400 = Array.isArray(currentRow.CDOBRIGARRAY) && currentRow.CDOBRIGARRAY.indexOf(4) !== -1;
        } else {
            // Modifica a propriedade indicando que a parametrização foi
            // aberta para a empresa selecionada.
            parametrosWidget.empresasLoaded[currentRow.CDEMPRESA] = true;
        }
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis97000_dctf_Controller', Fis97000_dctf_Controller);
});

// FILE: ./assets/modules/apuracoes/assets/js/controllers/Fis00100_ApuracaoDeImposto_Controller.js
var Fis00100_ApuracaoDeImposto_Controller = function Fis00100_ApuracaoDeImposto_Controller(templateManager, General, Fis00100_ApuracaoDeImposto_Service, ScreenService, localStorageEngine, Messages_fiscal, maskEngine, ZhFilterPreferences) {

    var self = this;

    // Códigos dos impostos 
    var impostosInss = ["42"];
    var impostosIrpjCsll = ["25", "70"];
    var impostoIcms = "00";
    var impostosFecp = "01";
    var impostosCargaRj = "03";
    var impostoIpi = "10";
    var impostosIrrfE = "21";
    var impostosIrrfS = "22";
    var impostosPcc = "24";
    var impostosIssqnE = "24";
    var impostoPis = "50";
    var impostoPisRetS = "56";
    var impostosCofins = "60";
    var impostosCofinsRetS = "66";
    var impostoIcmsSt = "80";

    // Variável que armazenam os valores inseridos do filtro.
    var filteredData = {};

    /********************************************************
     *                                                      *
     *                   Funções do Filtro                  *
     *                                                      *
     ********************************************************/

    this.openFilterApuracaoImposto = function (widget) {
        var filterRow = {};
        ZhFilterPreferences.setOriginalFilter(widget.id, filterRow);
        ZhFilterPreferences.openFilterWidget(widget);
    };

    /*
     * Função para alterar o comportamento e exibição da tela conforme filtro
     * selecionado.
     */
    this.alteraExibicaoTela = function (widget, preference) {
        //var filterPopup = widget.appliedFilter;
        var filterPopup = preference;
        var idtipoapura = filterPopup.FILTER_ROW.IDTIPOAPURA;
        var cdimposto = filterPopup.FILTER_ROW.CDIMPOSTO;

        alteraVisibilidadeWidgets(idtipoapura, cdimposto, filterPopup.FILTER_ROW);
        alteraVisibilidadeFields(widget, idtipoapura, cdimposto);
        var notasFiscaisWidget = templateManager.container.getWidget("notasFiscais");
        //alteraVisibilidadeConferencia(widget, cdimposto);

        // Altera o dataSource.name conforme tipo de apuração e imposto selecionados no filtro.

        // Apurção Simples Nacional
        if (simplesNacionalIsSelected(idtipoapura)) {
            // Utiliza filtro somente de empresa.
            widget.dataSourceFilter = [{
                "name": "CDEMPRESA",
                "operator": "=",
                "value": filterPopup.FILTER_ROW.CDEMPRESA
            }];
            widget.dataSource.name = 'fis_apuracoes#/crud/mapaapuracsn_completo';
            // Altera o dataSource para trazer as notas do Simples.
            notasFiscaisWidget.dataSource.name = 'fis_apuracoes#/notasfiscais_apuracaoimposto_simples';
        } else {
            /*
            // Remove o filtro por tipo de apuração.
            widget.dataSourceFilter = widget.dataSourceFilter.filter(function(filter) {
                return filter.name != "IDTIPOAPURA";
            });
            */
            var orgao = filterPopup.FILTER_ROW.IDORGARRECADNFE == 'F' ? null : filterPopup.FILTER_ROW.IDORGARRECADNFE;
            // Verifica se um imposto de contribuições foi selecionado.
            if (contribuicoesIsSelected(cdimposto)) {
                var filtroContribuicoes = [{
                    "name": "CDEMPRESA",
                    "operator": "=",
                    "value": filterPopup.FILTER_ROW.CDEMPRESA
                }, {
                    "name": "CDIMPOSTO",
                    "operator": "=",
                    "value": filterPopup.FILTER_ROW.CDIMPOSTO
                }];
                widget.dataSourceFilter = filtroContribuicoes;
                widget.dataSource.name = 'fis_apuracoes#/crud/mapaapurac_contribuicoes';
                // Altera o dataSource para trazer as notas de mapas gerais.
                notasFiscaisWidget.dataSource.name = 'fis_apuracoes#/notasfiscais_apuracaoimposto_geral';
            } else if (inssIsSelected(cdimposto)) {
                var filtroInss = [{
                    "name": "P_IDORGARRECAD",
                    "operator": "=",
                    "value": orgao
                }, {
                    "name": "P_INSCRICAO",
                    "operator": "=",
                    "value": filterPopup.FILTER_ROW.CDINSCESTA ? filterPopup.FILTER_ROW.CDINSCESTA : filterPopup.FILTER_ROW.CDINSCMUNI
                }, {
                    "name": "CDEMPRESA",
                    "operator": "=",
                    "value": filterPopup.FILTER_ROW.CDEMPRESA
                }, {
                    "name": "CDIMPOSTO",
                    "operator": "=",
                    "value": filterPopup.FILTER_ROW.CDIMPOSTO
                }];
                widget.dataSourceFilter = filtroInss;
                widget.dataSource.name = 'fis_apuracoes#/crud/mapaapurac_inss';
                // Altera o dataSource para trazer as notas de mapas gerais.
                notasFiscaisWidget.dataSource.name = 'fis_apuracoes#/notasfiscais_apuracaoimposto_geral';
                widget.getField('VRSALDOCRED').isVisible = false;
            } else if (irpjCsllIsSelected(cdimposto)) {
                widget.dataSourceFilter = [{
                    "name": "P_EMPRESA",
                    "operator": "=",
                    "value": filterPopup.FILTER_ROW.CDEMPRESA
                }, {
                    "name": "P_IMPOSTO",
                    "operator": "=",
                    "value": filterPopup.FILTER_ROW.CDIMPOSTO
                }];
                widget.dataSource.name = 'fis_apuracoes#/crud/mapaapurac_irpjcsll';
            } else {
                var filtroGeral = [{
                    "name": "P_IDORGARRECAD",
                    "operator": "=",
                    "value": orgao
                }, {
                    "name": "P_INSCRICAO",
                    "operator": "=",
                    "value": filterPopup.FILTER_ROW.CDINSCESTA ? filterPopup.FILTER_ROW.CDINSCESTA : filterPopup.FILTER_ROW.CDINSCMUNI
                }, {
                    "name": "CDEMPRESA",
                    "operator": "=",
                    "value": filterPopup.FILTER_ROW.CDEMPRESA
                }, {
                    "name": "CDIMPOSTO",
                    "operator": "=",
                    "value": filterPopup.FILTER_ROW.CDIMPOSTO
                }];
                widget.dataSourceFilter = filtroGeral;
                widget.dataSource.name = 'fis_apuracoes#/crud/mapaapurac_impostosGerais';
                // Altera o dataSource para trazer as notas de mapas gerais.
                notasFiscaisWidget.dataSource.name = 'fis_apuracoes#/notasfiscais_geral';
                controlaGuiaComplementar(cdimposto, idtipoapura);
                controlaCamposIcms(cdimposto);
                controlaCampoReceitaArrecadacao(idtipoapura);
            }

            /*
            else if(impostosGeraisIsSelected(cdimposto)){
                widget.dataSource.name = 'fis_apuracoes#/crud/mapaapurac_impostosGerais';
            }
            else{
                widget.dataSource.name = 'fis_apuracoes#/crud/apuracao_mapaapurac';
            }*/
        }

        // Correção temporária de erro do framework que não exibe os campos que
        // tiveram a visibilidade alterada.
        widget.resizeGridColumns(true);
        widget.reload();
    };

    /*
     * Função auxiliar para alterar a visibilidade das widgets da tela conforme
     * filtro selecionado.
     */
    var alteraVisibilidadeFields = function alteraVisibilidadeFields(mainWidget, idtipoapura, cdimposto) {
        // Fields que são exibidos ou não quando o tipo de apuração é Simples
        // Nacional.
        var fieldsSimples = ["DTREFERENCIA", "DTREALAPURA"];
        //var fieldsContribuicoes = ["VRSALDOCRED"];
        var fieldsGerais = ["DTINIPERIODO", "DTFIMPERIODO", "VRSALDOCRED"];

        // Verifica o tipo de apuração e imposto selecionados.
        var isSimplesNacional = simplesNacionalIsSelected(idtipoapura);
        //var isContribuicoes   = contribuicoesIsSelected(cdimposto);
        //var isImpostosGerais  = impostosGeraisIsSelected(cdimposto);

        fieldsSimples.forEach(function (fieldName) {
            mainWidget.getField(fieldName).isVisible = isSimplesNacional;
        });

        /*
        fieldsContribuicoes.forEach(function(fieldName) {
            mainWidget.getField(fieldName).isVisible = isContribuicoes;
        });
        
        fieldImpostosGerais.forEach(function(fieldName) {
            mainWidget.getField(fieldName).isVisible = isImpostosGerais;
        });
         */ //

        fieldsGerais.forEach(function (fieldName) {
            mainWidget.getField(fieldName).isVisible = !isSimplesNacional;
        });

        /*
        fieldsGerais.forEach(function(fieldName) {
            mainWidget.getField(fieldName).showOnView  = !isSimplesNacional;
        });
        
        fieldsGerais.forEach(function(fieldName) {
            mainWidget.getField(fieldName).showOnForm  = !isSimplesNacional;
        });
        */
        // Muda o nome do campo de imposto a recolher, conforme tipo de apuração
        // escolhido.
        mainWidget.getField("VRTOTAIMPOS").label = isSimplesNacional ? "Simples a Recolher" : "Imposto a Recolher";

        mainWidget.redraw();
    };

    /*
     * Função auxiliar para alterar a visibilidade das widgets da tela conforme
     * filtro selecionado.
     */
    var alteraVisibilidadeWidgets = function alteraVisibilidadeWidgets(idtipoapura, cdimposto, row) {
        // Widgets que são exibidas quando o tipo de apuração é Simples Nacional.
        var widgetsSimples = ["simplesNacionalTabelaReferencia"];

        // Widgets que são exibidas quando o tipo de apuração é Contribuições.
        var widgetsContribuicoes = ["tabbedContribuicoesDetalhamento", "contribuicoesDetalhamento", "contribuicoesArrecadacao", "contribuicoesDetalhamentoCompetencia", "ajusteContribuicao"];

        // Widgets que são exibidas quando o tipo de apuração é ImpostosGerais.
        var widgetsImpostosGerais = ["detalhamentoGeral", "tabbedArrecadacaoGeral"];

        var widgetsInss = ["detalhamentoInss", "tabbedArrecadacaoGeral"];

        // Widgets que são exibidas quando o imposto é ICMS.
        var widgetsIcms = ["widgetInformacoesAdicionais", "widgetDifalIcms", "tabbedArrecadacaoGeral"];

        var widgetsIcmsSt = ["detalhamentoIcmsSt"];

        // Widgets que são exibidas quando o imposto é IRPJ ou CSLL.
        var widgetsIrpjCsll = ["detalhamentoIrpjCsll", "detalhamentoIrpjCsllLucroRealTrimestral", "detalhamentoIrpjCsllLucroPresumidoCompet", "detalhamentoIrpjCsllLucroPresumidoPag", "detalhamentoIrpjCsllLucroRealMensal", "tabbedArrecadacaoGeral"];

        var widgetNotasFiscais = ["notasFiscais"];

        // Verifica o tipo de apuração e imposto selecionados.
        var isSimplesNacional = simplesNacionalIsSelected(idtipoapura);
        var isContribuicoes = contribuicoesIsSelected(cdimposto);
        var isInss = inssIsSelected(cdimposto);
        var isIcmstSt = icmsStIsSelected(cdimposto);
        var isIrpjCsll = irpjCsllIsSelected(cdimposto);

        if (cdimposto == '80') {
            templateManager.container.getWidget('simplesNacionalTabelaReferencia').isVisible = false;
            templateManager.container.getWidget('detalhamentoIcmsSt').isVisible = true;
            templateManager.container.getWidget('detalhamentoInss').isVisible = false;
            templateManager.container.getWidget('detalhamentoGeral').isVisible = false;
            templateManager.container.getWidget('tabbedContribuicoesDetalhamento').isVisible = false;
            templateManager.container.getWidget('detalhamentoIrpjCsll').isVisible = false;
            templateManager.container.getWidget('ConfAjusteSt').isVisible = true;
            templateManager.container.getWidget('notasFiscais').isVisible = true;
            templateManager.container.getWidget('ajusteContribuicao').isVisible = false;
            templateManager.container.getWidget('widgetDifalIcms').isVisible = false;
            templateManager.container.getWidget('widgetInformacoesAdicionais').isVisible = true;
            templateManager.container.getWidget('contribuicoesArrecadacao').isVisible = false;
            templateManager.container.getWidget('tabbedArrecadacaoGeral').isVisible = true;
        } else if (cdimposto == '42') {
            templateManager.container.getWidget('simplesNacionalTabelaReferencia').isVisible = false;
            templateManager.container.getWidget('detalhamentoIcmsSt').isVisible = false;
            templateManager.container.getWidget('detalhamentoInss').isVisible = true;
            templateManager.container.getWidget('detalhamentoGeral').isVisible = false;
            templateManager.container.getWidget('tabbedContribuicoesDetalhamento').isVisible = false;
            templateManager.container.getWidget('detalhamentoIrpjCsll').isVisible = false;
            templateManager.container.getWidget('ConfAjusteSt').isVisible = false;
            templateManager.container.getWidget('notasFiscais').isVisible = true;
            templateManager.container.getWidget('ajusteContribuicao').isVisible = false;
            templateManager.container.getWidget('widgetDifalIcms').isVisible = false;
            templateManager.container.getWidget('widgetInformacoesAdicionais').isVisible = true;
            templateManager.container.getWidget('contribuicoesArrecadacao').isVisible = false;
            templateManager.container.getWidget('tabbedArrecadacaoGeral').isVisible = true;
        } else if (cdimposto == '25' || cdimposto == '70') {
            templateManager.container.getWidget('simplesNacionalTabelaReferencia').isVisible = false;
            templateManager.container.getWidget('detalhamentoIcmsSt').isVisible = false;
            templateManager.container.getWidget('detalhamentoInss').isVisible = false;
            templateManager.container.getWidget('detalhamentoGeral').isVisible = false;
            templateManager.container.getWidget('tabbedContribuicoesDetalhamento').isVisible = false;
            templateManager.container.getWidget('detalhamentoIrpjCsll').isVisible = true;
            templateManager.container.getWidget('ConfAjusteSt').isVisible = false;
            templateManager.container.getWidget('notasFiscais').isVisible = false;
            templateManager.container.getWidget('ajusteContribuicao').isVisible = false;
            templateManager.container.getWidget('widgetDifalIcms').isVisible = false;
            templateManager.container.getWidget('widgetInformacoesAdicionais').isVisible = false;
            templateManager.container.getWidget('contribuicoesArrecadacao').isVisible = false;
            templateManager.container.getWidget('tabbedArrecadacaoGeral').isVisible = true;
        } else if (cdimposto == '50' || cdimposto == '60') {
            templateManager.container.getWidget('ajusteContribuicao').isVisible = true;
            templateManager.container.getWidget('contribuicoesArrecadacao').isVisible = true;
            templateManager.container.getWidget('notasFiscais').isVisible = true;
            templateManager.container.getWidget('tabbedContribuicoesDetalhamento').isVisible = true;
            templateManager.container.getWidget('tabbedArrecadacaoGeral').isVisible = false;
            templateManager.container.getWidget('widgetInformacoesAdicionais').isVisible = false;
            templateManager.container.getWidget('detalhamentoGeral').isVisible = false;
            templateManager.container.getWidget('simplesNacionalTabelaReferencia').isVisible = false;
            templateManager.container.getWidget('detalhamentoIcmsSt').isVisible = false;
            templateManager.container.getWidget('detalhamentoInss').isVisible = false;
            templateManager.container.getWidget('detalhamentoIrpjCsll').isVisible = false;
            templateManager.container.getWidget('ConfAjusteSt').isVisible = false;
            templateManager.container.getWidget('widgetDifalIcms').isVisible = false;
        } else if (cdimposto == '00') {
            templateManager.container.getWidget('simplesNacionalTabelaReferencia').isVisible = false;
            templateManager.container.getWidget('detalhamentoIcmsSt').isVisible = false;
            templateManager.container.getWidget('detalhamentoInss').isVisible = false;
            templateManager.container.getWidget('detalhamentoGeral').isVisible = true;
            templateManager.container.getWidget('tabbedContribuicoesDetalhamento').isVisible = false;
            templateManager.container.getWidget('detalhamentoIrpjCsll').isVisible = false;
            templateManager.container.getWidget('ConfAjusteSt').isVisible = false;
            templateManager.container.getWidget('notasFiscais').isVisible = true;
            templateManager.container.getWidget('ajusteContribuicao').isVisible = false;
            templateManager.container.getWidget('widgetDifalIcms').isVisible = false;
            templateManager.container.getWidget('widgetInformacoesAdicionais').isVisible = true;
            templateManager.container.getWidget('contribuicoesArrecadacao').isVisible = false;
            templateManager.container.getWidget('tabbedArrecadacaoGeral').isVisible = true;
        } else if (isSimplesNacional) {
            templateManager.container.getWidget('simplesNacionalTabelaReferencia').isVisible = true;
            templateManager.container.getWidget('detalhamentoIcmsSt').isVisible = false;
            templateManager.container.getWidget('detalhamentoInss').isVisible = false;
            templateManager.container.getWidget('detalhamentoGeral').isVisible = false;
            templateManager.container.getWidget('tabbedContribuicoesDetalhamento').isVisible = false;
            templateManager.container.getWidget('detalhamentoIrpjCsll').isVisible = false;
            templateManager.container.getWidget('ConfAjusteSt').isVisible = false;
            templateManager.container.getWidget('notasFiscais').isVisible = true;
            templateManager.container.getWidget('ajusteContribuicao').isVisible = false;
            templateManager.container.getWidget('widgetDifalIcms').isVisible = false;
            templateManager.container.getWidget('widgetInformacoesAdicionais').isVisible = false;
            templateManager.container.getWidget('contribuicoesArrecadacao').isVisible = false;
            templateManager.container.getWidget('tabbedArrecadacaoGeral').isVisible = true;
        } else {
            templateManager.container.getWidget('simplesNacionalTabelaReferencia').isVisible = false;
            templateManager.container.getWidget('detalhamentoIcmsSt').isVisible = false;
            templateManager.container.getWidget('detalhamentoInss').isVisible = false;
            templateManager.container.getWidget('detalhamentoGeral').isVisible = false;
            templateManager.container.getWidget('tabbedContribuicoesDetalhamento').isVisible = false;
            templateManager.container.getWidget('detalhamentoIrpjCsll').isVisible = false;
            templateManager.container.getWidget('ConfAjusteSt').isVisible = false;
            templateManager.container.getWidget('notasFiscais').isVisible = false;
            templateManager.container.getWidget('ajusteContribuicao').isVisible = false;
            templateManager.container.getWidget('widgetDifalIcms').isVisible = false;
            templateManager.container.getWidget('widgetInformacoesAdicionais').isVisible = false;
            templateManager.container.getWidget('contribuicoesArrecadacao').isVisible = false;
            templateManager.container.getWidget('tabbedArrecadacaoGeral').isVisible = false;
        }
    };

    /*
     * Função para controlar o filtro por empresa e a propriedade readOnly do
     * campo de inscrição habilitado no filtro.
     */
    this.checkInscricaoHabilitada = function (filterPopup) {
        var cdempresa = filterPopup.currentRow.CDEMPRESA;
        var cdinscestaField = filterPopup.getField("CDINSCESTA");
        var cdinscmuniField = filterPopup.getField("CDINSCMUNI");

        // Reseta os valores de inscrição do filtro.
        filterPopup.currentRow.CDINSCESTA = '';
        filterPopup.currentRow.CDINSCMUNI = '';

        // Filtro a ser setado no dataSourceFilter do field de inscrição
        // exibido.
        var filter = [{
            "name": "CDEMPRESA",
            "operator": "=",
            "value": cdempresa
        }];

        // Altera a obrigatoriedade dos campos e atualiza os filtros de
        // inscrição quando a empresa for alterada.
        if (cdinscestaField.isVisible) {
            // Seta o campo de inscrição estadual como obrigatório e altera a
            // propriedade readOnly conforme inserção de empresa.
            setCampoObrigatorio(cdinscestaField, !cdempresa);
            cdinscestaField.dataSourceFilter = filter;
            cdinscestaField.needReload = true;
            cdinscestaField.reload();
        }

        if (cdinscmuniField.isVisible) {
            // Seta o campo de inscrição municipal como obrigatório e altera a
            // propriedade readOnly conforme inserção de empresa.
            setCampoObrigatorio(cdinscmuniField, !cdempresa);
            cdinscmuniField.dataSourceFilter = filter;
            cdinscmuniField.needReload = true;
            cdinscmuniField.reload();
        }
    };

    /*
     * Função para alterar exibição e obrigatoriedade de campos no filtro,
     * conforme tipo de apuração inserido.
     */
    this.controlaCamposFiltro = function (filterPopup) {
        var filterRow = filterPopup.currentRow;

        var impostoField = filterPopup.getField("DSIMPOSTONFE");
        var inscricaoEstadualField = filterPopup.getField("CDINSCESTA");
        var inscricaoMunicipalField = filterPopup.getField("CDINSCMUNI");
        var tipoApurac = filterRow.IDTIPOAPURA;

        // Reseta os valores no filtro.
        filterRow.DSIMPOSTONFE = '';
        filterRow.CDIMPOSTO = '';
        filterRow.SGIMPOSTONFE = '';
        filterRow.CDINSCESTA = '';
        filterRow.CDINSCMUNI = '';

        // Valida quais campos deverão ser exibidos no filtro para cada tipo
        // de apuração.
        switch (tipoApurac) {
            case "F":
                setCampoObrigatorio(impostoField, false);
                setCampoInvisible(inscricaoEstadualField);
                setCampoInvisible(inscricaoMunicipalField);
                break;
            case "E":
                setCampoObrigatorio(impostoField, false);
                setCampoObrigatorio(inscricaoEstadualField, true);
                setCampoInvisible(inscricaoMunicipalField);
                break;
            case "M":
                setCampoObrigatorio(impostoField, false);
                setCampoInvisible(inscricaoEstadualField);
                setCampoObrigatorio(inscricaoMunicipalField, true);
                break;
            case "S":
                setCampoInvisible(impostoField);
                setCampoInvisible(inscricaoEstadualField);
                setCampoInvisible(inscricaoMunicipalField);
                break;
        }
        this.checkInscricaoHabilitada(filterPopup);
        // Para as apurações em que o campo Imposto é visível, só devem
        // aparecer nos filtros os impostos dessa apuração.
        if (impostoField.isVisible) {
            impostoField.dataSourceFilter = [{
                "name": "IDORGARRECADNFE",
                "operator": "=",
                "value": tipoApurac
            }];
            impostoField.needReload = true;
            impostoField.reload();
        }
    };

    /*
     * Função para armazenar os dados filtrados em variável dentro do escopo
     * deste controller. Essa variável é utilizada nos demais processos da
     * tela, facilitando-os.
     */
    this.salvaDadosFiltro = function (widget) {
        var filterPopup = widget.appliedFilter;
        // Armazena uma cópia dos valores na variável declarada no controller.
        filteredData = Util.clone(filterPopup.FILTER_ROW);
    };

    /*
     * Função para esconder um campo, removendo quaisquer validações
     * associadas.
     */
    var setCampoInvisible = function setCampoInvisible(field) {
        field.isVisible = false;
        field.readOnly = true;
        field.validations = {};
    };

    /*
     * Função para exibir um campo e setá-lo como obrigatório.
     */
    var setCampoObrigatorio = function setCampoObrigatorio(field, readOnly) {
        field.isVisible = true;
        field.readOnly = !!readOnly;
        field.validations = { required: true };
    };

    /*
     * Função para exibir um campo e sem colocar-lo como obrigatório.
     */
    var setCampoVisible = function setCampoVisible(field, readOnly) {
        field.isVisible = true;
        field.readOnly = !!readOnly;
    };

    /*
     * Função chamada ao alterar o imposto selecionado. Verifica a
     * parametrização de impostos relacionados.
     */
    this.validaImpostosRelacionados = function (filterPopup) {
        var filterRow = filterPopup.currentRow;
        // Verifica se há um valor inserido para o campo de imposto.
        if (filterRow.CDIMPOSTO) {
            Fis00100_ApuracaoDeImposto_Service.vdImpostoRelac({ "CDIMPOSTONFE": filterRow.CDIMPOSTO }).then(function (response) {
                // Verifica se a validação retornou true ou false.
                var impostoIsValid = response.dataset.validation.VDPARAMIMPRELAC;
                if (!impostoIsValid) {
                    // Exibe a mensagem de erro e remove o imposto inserido.
                    ScreenService.showMessage(Messages_fiscal.PARAM_IMPOSTO_RELAC_ERROR, 'error');
                    filterRow.CDIMPOSTO = null;
                    filterRow.SGIMPOSTONFE = null;
                    filterRow.DSIMPOSTONFE = null;
                }
            });
        }
    };

    /*
        Função para controlar elementros que serã visíveis somente
        quando o imposto selecionado for ICMS
    */
    var controlaCamposIcms = function controlaCamposIcms(cdimposto) {
        var widgetDetalhamento = templateManager.container.getWidget('detalhamentoGeral');
        var widgetDetalhamentoICMS = templateManager.container.getWidget('detalhamentoIcmsSt');
        var camposIcmsDetalhamento = ['VRFCPNC', 'VRDIFALNC', 'BUTDIFALIQ', 'VRDIFALIQU', 'VRIMPCARGATRIBM'];
        camposIcmsDetalhamento.forEach(function (field) {
            widgetDetalhamento.getField(field).isVisible = cdimposto === impostoIcms;
            widgetDetalhamentoICMS.isVisible = cdimposto === impostoIcms;
        });
    };

    /*
        Função que controla campos referente a codigo da receita, 
        que são diferente quando o imposto e federal e estadual.
    */
    var controlaCampoReceitaArrecadacao = function controlaCampoReceitaArrecadacao(idtipoapura) {
        var campos = ['CDVARIACAO', 'IDPERIODICREC', 'IDDEBSCPINC'];
        var widgetArrecadacao = templateManager.container.getWidget('guiaFiscalArrecadaoGeral');
        if (idtipoapura === 'E') {
            visibilidadeField(widgetArrecadacao, campos, false);
        } else if (idtipoapura === 'F') {
            visibilidadeField(widgetArrecadacao, campos, true);
        }
    };

    var retornaMensagemApuracaoContribucies = function retornaMensagemApuracaoContribucies(avisos, nomeImpostoReferente) {
        var mensagem = '';
        var mapaAtualApurado = avisos.mapaAtual.apurado;
        var mapaReferenteApurado = avisos.mapaReferente.apurado;

        var mapaAtualMensagens = avisos.mapaAtual.mensagens;
        var mapaReferenteMensagens = avisos.mapaReferente.mensagens;

        var nomeImpostoAtual = nomeImpostoReferente === '60 - COFINS' ? '50 - PIS' : '60 - COFINS';

        if (mapaAtualApurado && mapaReferenteApurado && mapaAtualMensagens.length === 0 && mapaReferenteMensagens.length === 0) return 'Apurações realizadas com sucesso.';else {

            mensagem = nomeImpostoAtual + '<br>';
            if (mapaAtualApurado) mensagem = mensagem + 'Apuração realizada com sucesso.<br>';
            if (mapaAtualMensagens.length > 0) mensagem = mensagem + mapaAtualMensagens;

            mensagem = mensagem + '<br>' + nomeImpostoReferente + '<br>';
            if (mapaReferenteApurado) mensagem = mensagem + 'Apuração realizada com sucesso.<br>';
            if (mapaReferenteMensagens.length > 0) mensagem = mensagem + mapaReferenteMensagens;

            return mensagem;
        }
    };

    /********************************************************
     *                                                      *
     *               Funções de Procedimentos               *
     *                                                      *
     ********************************************************/

    /*
        Função para realizar apuração conjunta dos mapas do
        PIS E COFINS
    */
    this.apuraMapasContribuicoes = function (mainWidget) {
        General.callRestEngine('fis_apuracoes#/apuraMapasContribuicoes', 'Row', mainWidget.currentRow).then(function (response) {
            var avisos = response.dataset.avisos;
            ScreenService.closePopup();
            mainWidget.reload().then(function () {
                this.checkElementsVisibility(mainWidget);
                ScreenService.showMessage(retornaMensagemApuracaoContribucies(avisos, mainWidget.currentRow.impostoReferente));
                var realizavalidacao = localStorage.getItem('realizavalidacao');
                if (realizavalidacao == 'A') {
                    var codimposto = mainWidget.currentRow.CDIMPOSTO;
                    if (codimposto == '00' || codimposto == '80' || codimposto == '10' || codimposto == '50' || codimposto == '60' || codimposto == '41' || codimposto == '42') {
                        var imposto = localStorage.getItem('imposto');
                        var empresa = localStorage.getItem('empresa');
                        var nomeempr = localStorage.getItem('nomeempr');
                        var inscricao = localStorage.getItem('inscricao');
                        var mapa = localStorage.getItem('mapa');
                        var nomemapa = localStorage.getItem('nomemapa');

                        localStorage.setItem("imposto", mainWidget.currentRow.CDIMPOSTO);
                        localStorage.setItem("empresa", mainWidget.currentRow.CDEMPRESA);
                        localStorage.setItem("nomeempr", stripeWidget.currentRow.NMEMPRESA);
                        localStorage.setItem("inscricao", mainWidget.currentRow.CDINSCESTA);
                        localStorage.setItem("mapa", mainWidget.currentRow.NRSEQUMAPAPU);
                        localStorage.setItem("nomemapa", mainWidget.currentRow.NMMAPAAPUR);
                        ScreenService.openWindow('fis#fis22000_pre_validacao_declaracoes_acessorias');
                    }
                }
            }.bind(this));
            templateManager.container.getWidget("notasFiscais").needReload = true;
            templateManager.container.getWidget("apuracao_de_imposto").needReload = true;
            var realizavalidacao = localStorage.getItem('realizavalidacao');
            if (realizavalidacao == 'A') {
                var codimposto = mainWidget.currentRow.CDIMPOSTO;
                if (codimposto == '00' || codimposto == '80' || codimposto == '10' || codimposto == '50' || codimposto == '60' || codimposto == '41' || codimposto == '42') {
                    var imposto = localStorage.getItem('imposto');
                    var empresa = localStorage.getItem('empresa');
                    var nomeempr = localStorage.getItem('nomeempr');
                    var inscricao = localStorage.getItem('inscricao');
                    var mapa = localStorage.getItem('mapa');
                    var nomemapa = localStorage.getItem('nomemapa');

                    localStorage.setItem("imposto", mainWidget.currentRow.CDIMPOSTO);
                    localStorage.setItem("empresa", mainWidget.currentRow.CDEMPRESA);
                    localStorage.setItem("nomeempr", stripeWidget.currentRow.NMEMPRESA);
                    localStorage.setItem("inscricao", mainWidget.currentRow.CDINSCESTA);
                    localStorage.setItem("mapa", mainWidget.currentRow.NRSEQUMAPAPU);
                    localStorage.setItem("nomemapa", mainWidget.currentRow.NMMAPAAPUR);
                    ScreenService.openWindow('fis#fis22000_pre_validacao_declaracoes_acessorias');
                }
            }
        }.bind(this), function (callback) {
            if (callback.data) {
                ScreenService.showMessage(callback.data.error);
            }
        });
    };

    // Apurar Mapa
    this.apurar = function (mainWidget) {
        var self = this;
        var stripeWidget = templateManager.container.getWidget("stripe");
        Fis00100_ApuracaoDeImposto_Service.apurarMapa(mainWidget.currentRow).then(function (response) {
            // Armazena os avisos retornados.
            var avisos = response.dataset.avisos;
            ScreenService.closePopup();
            // Verifica se houve algum aviso retornado.
            if (Array.isArray(avisos) && avisos.length > 0) {
                // Monta a string com os avisos e exibe ao usuário.
                var avisosMessage = avisos.join("\n");
                ScreenService.showMessage(avisosMessage).then(function () {
                    ScreenService.showMessage("Apuração concluída com sucesso. Favor realizar a pré-validação das notas e verificar se existem pendências para a geração da obrigação acessória");
                    var realizavalidacao = localStorage.getItem('realizavalidacao');
                    if (realizavalidacao == 'A') {
                        var codimposto = mainWidget.currentRow.CDIMPOSTO;
                        if (codimposto == '00' || codimposto == '80' || codimposto == '10' || codimposto == '50' || codimposto == '60' || codimposto == '41' || codimposto == '42') {
                            var imposto = localStorage.getItem('imposto');
                            var empresa = localStorage.getItem('empresa');
                            var nomeempr = localStorage.getItem('nomeempr');
                            var inscricao = localStorage.getItem('inscricao');
                            var mapa = localStorage.getItem('mapa');
                            var nomemapa = localStorage.getItem('nomemapa');

                            localStorage.setItem("imposto", mainWidget.currentRow.CDIMPOSTO);
                            localStorage.setItem("empresa", mainWidget.currentRow.CDEMPRESA);
                            localStorage.setItem("nomeempr", stripeWidget.currentRow.NMEMPRESA);
                            localStorage.setItem("inscricao", mainWidget.currentRow.CDINSCESTA);
                            localStorage.setItem("mapa", mainWidget.currentRow.NRSEQUMAPAPU);
                            localStorage.setItem("nomemapa", mainWidget.currentRow.NMMAPAAPUR);
                            ScreenService.openWindow('fis#fis22000_pre_validacao_declaracoes_acessorias');
                        }
                    }
                });
            } else {
                ScreenService.showMessage("Apuração concluída com sucesso. Favor realizar a pré-validação das notas e verificar se existem pendências para a geração da obrigação acessória");
                var realizavalidacao = localStorage.getItem('realizavalidacao');
                if (realizavalidacao == 'A') {
                    var codimposto = mainWidget.currentRow.CDIMPOSTO;
                    if (codimposto == '00' || codimposto == '80' || codimposto == '10' || codimposto == '50' || codimposto == '60' || codimposto == '41' || codimposto == '42') {
                        var imposto = localStorage.getItem('imposto');
                        var empresa = localStorage.getItem('empresa');
                        var nomeempr = localStorage.getItem('nomeempr');
                        var inscricao = localStorage.getItem('inscricao');
                        var mapa = localStorage.getItem('mapa');
                        var nomemapa = localStorage.getItem('nomemapa');

                        localStorage.setItem("imposto", mainWidget.currentRow.CDIMPOSTO);
                        localStorage.setItem("empresa", mainWidget.currentRow.CDEMPRESA);
                        localStorage.setItem("nomeempr", stripeWidget.currentRow.NMEMPRESA);
                        localStorage.setItem("inscricao", mainWidget.currentRow.CDINSCESTA);
                        localStorage.setItem("mapa", mainWidget.currentRow.NRSEQUMAPAPU);
                        localStorage.setItem("nomemapa", mainWidget.currentRow.NMMAPAAPUR);
                        ScreenService.openWindow('fis#fis22000_pre_validacao_declaracoes_acessorias');
                    }
                }
            }

            mainWidget.reload().then(function () {
                self.checkElementsVisibility(mainWidget);
                //self.verificaEdicaoDetalhamento(mainWidget);
            });
            // Seta as widgets que são grids para que sejam recarregadas ao
            // entrar.
            templateManager.container.getWidget("detalhamentoIcmsSt").needReload = true;
            templateManager.container.getWidget("notasFiscais").needReload = true;
            templateManager.container.getWidget("apuracao_de_imposto").needReload = true;
            if (simplesNacionalIsSelected()) {
                templateManager.container.getWidget("simplesNacionalTabelaReferencia").needReload = true;
            }
        }).catch(function (errorResponse) {
            if (errorResponse.data) {
                ScreenService.showMessage(errorResponse.data.error);
            }
        });
    };

    /*
     * Função para apurar um mapa desbloqueado.
     */
    this.apurarMapa = function () {
        var mainWidget = templateManager.container.getWidget("apuracao_de_imposto");
        var cdsitucrt = filteredData.CDSITUCRT;
        var idapuimpgersn = filteredData.IDAPUIMPGERESN;
        var idtipoapura = filteredData.IDTIPOAPURA;
        var cdimposto = mainWidget.currentRow.CDIMPOSTO;
        var stripeWidget = templateManager.container.getWidget("stripe");

        //mainWidget.currentRow.IDTIPOAPURA = idtipoapura;
        // Correção de erro do Zeedhi, que não fecha a popup de actions.
        ScreenService.closePopup();
        if (!Fis00100_ApuracaoDeImposto_Service.bloqueiaMapaRegime(idtipoapura, cdsitucrt, idapuimpgersn)) {
            var self = this;
            if (contribuicoesIsSelected(mainWidget.currentRow.CDIMPOSTO)) {
                var impostoReferente = mainWidget.currentRow.CDIMPOSTO === impostoPis ? '60 - COFINS' : '50 - PIS';
                var cdimpostoReferente = mainWidget.currentRow.CDIMPOSTO === impostoPis ? '60' : '50';
                var nmimpostoReferente = mainWidget.currentRow.CDIMPOSTO === impostoPis ? 'COFINS' : 'PIS';

                mainWidget.currentRow.impostoReferente = impostoReferente;
                mainWidget.currentRow.CDIMPOSTOREFERENTE = cdimpostoReferente;
                mainWidget.currentRow.NMIMPOSTOREFERENTE = nmimpostoReferente;

                ScreenService.confirmMessage(ScreenService.i18n("Deseja apurar também o mapa do '" + impostoReferente + "' para o mesmo período ?"), 'question', function (success) {
                    self.apuraMapasContribuicoes(mainWidget);
                    var realizavalidacao = localStorage.getItem('realizavalidacao');
                    if (realizavalidacao == 'A') {
                        var codimposto = mainWidget.currentRow.CDIMPOSTO;
                        if (codimposto == '00' || codimposto == '80' || codimposto == '10' || codimposto == '50' || codimposto == '60' || codimposto == '41' || codimposto == '42') {
                            var imposto = localStorage.getItem('imposto');
                            var empresa = localStorage.getItem('empresa');
                            var nomeempr = localStorage.getItem('nomeempr');
                            var inscricao = localStorage.getItem('inscricao');
                            var mapa = localStorage.getItem('mapa');
                            var nomemapa = localStorage.getItem('nomemapa');

                            localStorage.setItem("nomemapa", mainWidget.currentRow.NMMAPAAPUR);
                            localStorage.setItem("imposto", mainWidget.currentRow.CDIMPOSTO);
                            localStorage.setItem("empresa", mainWidget.currentRow.CDEMPRESA);
                            localStorage.setItem("nomeempr", stripeWidget.currentRow.NMEMPRESA);
                            localStorage.setItem("inscricao", mainWidget.currentRow.CDINSCESTA);
                            localStorage.setItem("mapa", mainWidget.currentRow.NRSEQUMAPAPU);
                            ScreenService.openWindow('fis#fis22000_pre_validacao_declaracoes_acessorias');
                        }
                    }
                }, function (error) {
                    self.apurar(mainWidget);
                });
            } else {
                self.apurar(mainWidget);
            }
        } else {
            ScreenService.showMessage(Messages_fiscal.MAPA_REGIME_EMPRESA_ERROR, 'error');
        }
    };

    /*
     * Função para bloquear o último mapa de apuração desbloqueado.
     */
    this.bloquearMapa = function () {
        var mainWidget = templateManager.container.getWidget("apuracao_de_imposto");
        var cdsitucrt = filteredData.CDSITUCRT;
        var idapuimpgersn = filteredData.IDAPUIMPGERESN;
        var idtipoapura = filteredData.IDTIPOAPURA;
        var stripeWidget = templateManager.container.getWidget("stripe");

        //mainWidget.currentRow.IDTIPOAPURA = idtipoapura;
        // Correção de erro do Zeedhi, que não fecha a popup de actions.
        ScreenService.closePopup();
        if (!Fis00100_ApuracaoDeImposto_Service.bloqueiaMapaRegime(idtipoapura, cdsitucrt, idapuimpgersn)) {
            var self = this;
            // Executa validação de bloqueio de um mapa de Contribuições.
            if (contribuicoesIsSelected()) {
                var arrecadacaoWidget = templateManager.container.getWidget("contribuicoesArrecadacao");
                if (!arrecadacaoWidget.isValid()) {
                    // Muda para a widget de Arrecadação.
                    arrecadacaoWidget.activate().then(function () {
                        // Executa a função novamente para exibir quais campos estão
                        // inválidos.
                        arrecadacaoWidget.isValid(function (validations) {
                            var invalidFields = validations.filter(function (validation) {
                                return validation.length > 0;
                            });
                            var invalidFieldLabel = invalidFields[0][0].fieldLabel;
                            // Exibe o primeiro field inválido.
                            ScreenService.showMessage(invalidFieldLabel + " deve ser informado.");
                        });
                    });

                    // Sai da função, devido aos dados inválidos.
                    return;
                }
            } else if (impostosGeraisIsSelected(mainWidget.currentRow) && mainWidget.currentRow.CDIMPOSTO !== impostoIcmsSt) {
                var arrecadacaoGeralWidget = templateManager.container.getWidget('guiaFiscalArrecadaoGeral');
                /* Caso o mapa esteja apurado e o valor total for igual a zero
                não é necessário informar o  codigo da natureza e o vencimento
                */
                if (mainWidget.currentRow.IDBLOQMAPAPU === 'A') {
                    if (parseFloat(mainWidget.currentRow.VRTOTAIMPOS) > 0) {
                        if (!arrecadacaoGeralWidget.currentRow.DTVENCGUIA) {
                            arrecadacaoGeralWidget.getParent().activate().then(function () {
                                ScreenService.showMessage('Data de Vencimento deve ser informada.');
                            });
                            return;
                        } else if (!arrecadacaoGeralWidget.currentRow.CDRECEGUIA) {
                            arrecadacaoGeralWidget.getParent().activate().then(function () {
                                ScreenService.showMessage('Código da Receita deve ser informado.');
                            });
                            return;
                        }
                    }
                }
                /* Caso occora uma tentativa de bloquear o mapa sem ele estar apurado, ´
                é necessário informar o codigo da receita e o vencimento
                */
                else {
                        if (!arrecadacaoGeralWidget.currentRow.DTVENCGUIA) {
                            arrecadacaoGeralWidget.getParent().activate().then(function () {
                                ScreenService.showMessage('Data de Vencimento deve ser informada.');
                            });
                            return;
                        } else if (!arrecadacaoGeralWidget.currentRow.CDRECEGUIA) {
                            arrecadacaoGeralWidget.getParent().activate().then(function () {
                                ScreenService.showMessage('Código da Receita deve ser informado.');
                            });
                            return;
                        }
                    }
            }

            Fis00100_ApuracaoDeImposto_Service.bloquearMapa(mainWidget.currentRow).then(function () {
                ScreenService.closePopup();
                ScreenService.showMessage("Mapa Bloqueado com Sucesso! Favor realizar a pré-validação das notas e verificar se existem pendências para a geração da obrigação acessória");
                mainWidget.reload().then(function () {
                    self.checkElementsVisibility(mainWidget);
                    //self.verificaEdicaoDetalhamento(mainWidget);
                });
                // Seta as widgets que são grids para que sejam recarregadas ao
                // entrar.
                templateManager.container.getWidget("detalhamentoIcmsSt").needReload = true;
                templateManager.container.getWidget("notasFiscais").needReload = true;
                if (simplesNacionalIsSelected()) {
                    templateManager.container.getWidget("simplesNacionalTabelaReferencia").needReload = true;
                }
                var realizavalidacao = localStorage.getItem('realizavalidacao');
                if (realizavalidacao == 'B' || realizavalidacao == 'A') {
                    var codimposto = mainWidget.currentRow.CDIMPOSTO;
                    if (codimposto == '00' || codimposto == '80' || codimposto == '10' || codimposto == '50' || codimposto == '60' || codimposto == '41' || codimposto == '42') {
                        var imposto = localStorage.getItem('imposto');
                        var empresa = localStorage.getItem('empresa');
                        var nomeempr = localStorage.getItem('nomeempr');
                        var inscricao = localStorage.getItem('inscricao');
                        var mapa = localStorage.getItem('mapa');
                        var nomemapa = localStorage.getItem('nomemapa');

                        localStorage.setItem("nomemapa", mainWidget.currentRow.NMMAPAAPUR);
                        localStorage.setItem("imposto", mainWidget.currentRow.CDIMPOSTO);
                        localStorage.setItem("empresa", mainWidget.currentRow.CDEMPRESA);
                        localStorage.setItem("nomeempr", stripeWidget.currentRow.NMEMPRESA);
                        localStorage.setItem("inscricao", mainWidget.currentRow.CDINSCESTA);
                        localStorage.setItem("mapa", mainWidget.currentRow.NRSEQUMAPAPU);
                        ScreenService.openWindow('fis#fis22000_pre_validacao_declaracoes_acessorias');
                    }
                }
            }).catch(function (errorResponse) {
                if (errorResponse.data) {

                    //Casso o error for referente a somas do valores do ICMS ST , redireciona para widget correspondente
                    if (errorResponse.data.error.indexOf('O(s) seguinte(s) estado(s)') !== -1) templateManager.container.getWidget('detalhamentoIcmsSt').activate();

                    ScreenService.showMessage(errorResponse.data.error);
                }
            });
        } else {
            ScreenService.showMessage(Messages_fiscal.MAPA_REGIME_EMPRESA_ERROR, 'error');
        }
    };

    /*
     * Função para excluir um item de detalhamento de um mapa de Contribuições.
     */
    this.deleteItemDetalhamentoContribuicoes = function (widget) {
        if (!widget.currentRow.CDLOTE) {
            General.deleteCrud(widget).then(function () {
                var mainWidget = templateManager.container.getWidget("apuracao_de_imposto");
                mainWidget.reload();
            });
        } else {
            ScreenService.showMessage('Exclusão não permitida! Existe um lote associado a esse ajuste.');
        }
    };

    /*
     * Função para excluir o último mapa de apuração, contanto que não esteja
     * bloqueado.
     */
    this.deleteMapa = function (args) {
        var widget = args.owner.widget;
        var cdsitucrt = filteredData.CDSITUCRT;
        var idapuimpgersn = filteredData.IDAPUIMPGERESN;
        var idtipoapura = filteredData.IDTIPOAPURA;
        if (!Fis00100_ApuracaoDeImposto_Service.bloqueiaMapaRegime(idtipoapura, cdsitucrt, idapuimpgersn)) {
            // Exibe uma mensagem de confirmação para o usuário
            ScreenService.confirmMessage(ScreenService.i18n('Excluir Registro?'), 'question', function () {
                widget.currentRow.IDTIPOAPURA = filteredData.IDTIPOAPURA;
                Fis00100_ApuracaoDeImposto_Service.deleteMapa(widget.currentRow).then(function () {
                    ScreenService.closeSwipe().then(function () {
                        ScreenService.showMessage('Deletado com sucesso.');
                        widget.activate();
                        widget.reload();
                    });
                }, function (error) {
                    if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                        ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                    } else {
                        ScreenService.showMessage(error.data.error);
                    }
                });
            });
        } else {
            ScreenService.showMessage(Messages_fiscal.MAPA_REGIME_EMPRESA_ERROR, 'error');
        }
    };

    /*
     * Função para desbloquear um mapa de apuração bloqueado.
     */
    this.desbloquearMapa = function () {
        var mainWidget = templateManager.container.getWidget("apuracao_de_imposto");
        var cdsitucrt = filteredData.CDSITUCRT;
        var idapuimpgersn = filteredData.IDAPUIMPGERESN;
        var idtipoapura = filteredData.IDTIPOAPURA;

        ScreenService.closePopup();
        //mainWidget.currentRow.IDTIPOAPURA = idtipoapura;

        if (!Fis00100_ApuracaoDeImposto_Service.bloqueiaMapaRegime(idtipoapura, cdsitucrt, idapuimpgersn)) {
            var self = this;
            Fis00100_ApuracaoDeImposto_Service.desbloquearMapa(mainWidget.currentRow).then(function () {
                mainWidget.reload().then(function () {
                    self.checkElementsVisibility(mainWidget);
                    //self.verificaEdicaoDetalhamento(mainWidget);
                });
                ScreenService.showMessage(Messages_fiscal.MAPA_DESBLOQUEADO_SUCESSO);
            }).catch(errorHandler);
        } else {
            ScreenService.showMessage(Messages_fiscal.MAPA_REGIME_EMPRESA_ERROR, 'error');
        }
    };

    /*
     * Função para salvar um detalhamento de um mapa de Simples Nacional.
     */
    this.salvarDetalhamentoSimplesNacional = function (widget) {
        // Calcula valores conforme widget selecionada.
        Fis00100_ApuracaoDeImposto_Service.calculaValorTotalDetalhamento(widget.currentRow, widget.name);
        widget.saveRow().then(function () {
            widget.reload();
            widget.template = widget.templateToView;
            widget.view();
            widget.activate();
            widget.getParent().view();
            changeWidgetsEnabledProperty(true);
        }.bind(this), function (callback) {
            if (callback.data) {
                ScreenService.showMessage(callback.data.error);
            }
        });
    };

    /*
     * Função para salvar um mapa de apurações, após realizar as devidas
     * validações.
     */
    this.salvarMapa = function (widget) {
        if (widget.isValid()) {
            var currentRow = widget.currentRow;
            // Verifica se a data final é igual ou maior à data inicial.
            if (currentRow.DTFIMPERIODO && moment(currentRow.DTFIMPERIODO, 'DD/MM/YYYY').isBefore(moment(currentRow.DTINIPERIODO, 'DD/MM/YYYY'))) {
                ScreenService.showMessage(Messages_fiscal.DTINI_POST_DTFIM_ERROR);
                return;
            }
            if (widget.isNewRow()) {
                // Seta na currentRow os valores do paramsNewCode da widget.
                Object.keys(widget.paramsNewCode).forEach(function (value) {
                    currentRow[value] = widget.paramsNewCode[value];
                });

                // Seta os dados filtrados na currentRow.
                currentRow.CDEMPRESA = filteredData.CDEMPRESA;
                currentRow.CDIMPOSTO = filteredData.CDIMPOSTO;
                currentRow.CDINSCESTA = filteredData.CDINSCESTA;
                currentRow.CDINSCMUNI = filteredData.CDINSCMUNI;
                // Se não houver Data Final preenchida, implica que esta não é
                // obrigatória e a data referência está sendo utilizada.
                if (!currentRow.DTFIMPERIODO) {
                    var dataReferencia = moment(currentRow.DTREFERENCIA, 'DD/MM/YYYY');
                    currentRow.DTINIPERIODO = dataReferencia.format('DD/MM/YYYY');
                    currentRow.DTFIMPERIODO = dataReferencia.endOf('month').format('DD/MM/YYYY');
                }
                var self = this;
                Fis00100_ApuracaoDeImposto_Service.saveMapa(currentRow).then(function (response) {
                    currentRow.NRORG = response.dataset.columnsToReturn[0].NRORG;
                    widget.view();
                    widget.reload().then(function () {
                        self.checkElementsVisibility(widget);
                    });
                    widget.reload([], false);
                    changeWidgetsEnabledProperty(true);
                    changeEnabledPropertyGridWidgets(widget);
                    habilitaAjusteContribuicao(widget);
                }).catch(errorHandler);
            } else {
                Fis00100_ApuracaoDeImposto_Service.saveMapa(currentRow).then(function () {
                    widget.view();
                    changeWidgetsEnabledProperty(true);
                    changeEnabledPropertyGridWidgets(widget);
                    habilitaAjusteContribuicao(widget);
                }).catch(errorHandler);
            }
        }
    };

    /*
     * Função para salvar dados na widget de ajustes para um mapa de
     * Contribuições, realizando as devidas validações.
     */
    this.saveAjusteContribuicoes = function (widget) {
        if (widget.isValid()) {
            var currentRow = widget.currentRow;
            var isCredito = currentRow.IDINDICAJUSTE == "C";
            var isRegimeCumulativo = currentRow.IDCUMUPISCOFIL == "N";
            // Se um ajuste for de crédito, o regime não pode ser cumulativo.
            if (isCredito && isRegimeCumulativo) {
                ScreenService.showMessage(Messages_fiscal.AJUSTE_CREDITO_CUMULATIVO_ERROR);
                return;
            }

            if (widget.currentRow.IDAPROPRIACAO == null) {
                widget.currentRow.IDAPROPRIACAO = "01";
            }

            var mainWidget = templateManager.container.getWidget("apuracao_de_imposto");

            // Se for um ajuste novo, deve retornar um sequencial gerado para
            // este ajuste antes de salvá-lo.
            if (widget.isNewRow()) {
                Fis00100_ApuracaoDeImposto_Service.getNextSequencialAjusteContribuicoes(currentRow).then(function (response) {
                    currentRow.NRSEQAJUSTE = response.dataset.codigo.NRSEQAJUSTE;
                    General.saveCrud(widget).then(function () {
                        mainWidget.reload();
                    });
                });
            } else {
                Fis00100_ApuracaoDeImposto_Service.saveAjusteContribuicoes(currentRow).then(function () {
                    //General.saveCrud(widget).then(function() {
                    widget.view();
                    widget.reload();
                    mainWidget.reload();
                });
            }
        }
    };

    this.salvarArrecadacaoGeral = function (widget) {
        if (widget.isValid()) {
            General.callRestEngine('fis_apuracoes#/salvarArrecadacaoGeral', 'Row', widget.currentRow).then(function (success) {
                var mainWidget = templateManager.container.getWidget("apuracao_de_imposto");
                // Muda o template para modo de visualização novamente.
                widget.view();
                General.formWidgetSwitchTemplate(widget);
                changeWidgetsEnabledProperty(true);
                mainWidget.reload();
                widget.getParent().view();
                this.checkElementsVisibility(templateManager.container.getWidget('apuracao_de_imposto'));
            }.bind(this), function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };

    /*
     * Função para salvar alterações realizadas na widget de Arredação Fiscal
     * para mapas de Contribuições.
     */
    this.saveArrecadacaoContribuicoes = function (widget) {
        var currentRow = widget.currentRow;
        // Seta os dados comuns aos dois campos de Código da Receita. Seta o
        // valor de um que não esteja nulo, ou nulo, caso não haja valor
        // inserido em ambos.
        currentRow.CDVARIACAO = currentRow.CDVARIACAO || currentRow.CDVARIACAONC || currentRow.CDVARIACAOC;
        currentRow.CDRECEITACONTR = currentRow.CDRECEITACONTRNC || currentRow.CDRECEITACONTRC;
        currentRow.IDPERIODICREC = currentRow.IDPERIODICRECNC || currentRow.IDPERIODICRECC;
        currentRow.IDDEBSCPINC = currentRow.IDDEBSCPINCNC || currentRow.IDDEBSCPINCC;
        Fis00100_ApuracaoDeImposto_Service.saveArrecadacaoContribuicoes(widget.currentRow).then(function () {
            var mainWidget = templateManager.container.getWidget("apuracao_de_imposto");
            // Muda o template para modo de visualização novamente.
            widget.view();
            General.formWidgetSwitchTemplate(widget);
            changeWidgetsEnabledProperty(true);
            mainWidget.reload();
            this.checkElementsVisibility(templateManager.container.getWidget('apuracao_de_imposto'));
        }.bind(this)).catch(errorHandler);
    };

    /*
     * Função para salvar um item de detalhamento de um mapa de Contribuições.
     * Não altera a propriedade "enabled" das outras widgets por haver somente
     * um widget exibida na tabbed.
     */
    this.saveItemDetalhamentoContribuicoes = function (widget) {
        General.saveCrud(widget).then(function () {
            var mainWidget = templateManager.container.getWidget("apuracao_de_imposto");
            mainWidget.reload();
        });
    };

    /*
        Função para salvar registro da widgte de Guias complementares que 
        só esta disponivél para apuração de Impostos Gerais e caso o imposto seja ICMS
    */
    this.salvarGuiasComplementares = function (widget) {
        var widgetApuracao = templateManager.container.getWidget('apuracao_de_imposto');
        if (widget.isValid()) {
            if (!widget.currentRow.NRPROCESSOGUIA) {
                widget.currentRow.IDORIGEMGUIA = '9';
                widget.currentRow.DSHISTGUIACOMPL = '';
            }

            widget.currentRow.DATASOURCENAME = widget.dataSource.name.substr(20);

            if (widget.currentRow.__is_new) {
                widget.currentRow.NRSEQUMAPAPU = widgetApuracao.currentRow.NRSEQUMAPAPU;
            }
            General.callRestEngine('fis_apuracoes#/salvarGuiasComplementares', 'Row', widget.currentRow).then(function (response) {
                sucessoSalvarGrid(widget);
            }, function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };

    /* Função que realizará o procedimento de save de todas as abas
    que serão abertas apartir dos botões existentes na aba de detalhamento
    da apuração de Impostos Gerais*/
    this.salvarSubDetalhamentoImpostosGerais = function (widget) {
        if (widget.isValid()) {
            var widgetApuracao = templateManager.container.getWidget('apuracao_de_imposto');
            if (widget.currentRow.CDITEMOCOR) widget.currentRow.CDITEMOCOR = widget.currentRow.CDITEMOCOR.replace(/[^0-9]/g, '');

            General.callRestEngine('fis_apuracoes#/salvarSubDetalhamentoImpostosGerais', 'Row', widget.currentRow).then(function (response) {
                widgetApuracao.reload();
                sucessoSalvarGrid(widget);
            }, function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };

    /* Função que realizará o procedimento de save de todas as abas
    que serão abertas apartir dos botões existentes na aba de detalhamento
    da apuração do ICMS (DIFAL/FCP */
    this.salvarSubDetalhamentoIcmsDifalFcp = function (widget) {
        if (widget.isValid()) {
            var widgetApuracao = templateManager.container.getWidget('apuracao_de_imposto');
            var widgetDifalFcp = templateManager.container.getWidget('widgetDifalIcms');

            if (widget.currentRow.__is_new) {
                widget.currentRow.NRSEQMAPAPURESTNC = widgetDifalFcp.currentRow.NRSEQMAPAPURESTNC;
                widget.currentRow.NRSEQUMAPAPU = widgetDifalFcp.currentRow.NRSEQUMAPAPU;
                widget.currentRow.IDTIPOITMAPR = widget.dataSourceFilter[2].value;
                widget.currentRow.IDAJUSTENC = widget.dataSourceFilter[3].value;
                widget.currentRow.NRSEQITMAPRECNC = '';
            }

            General.callRestEngine('fis_apuracoes#/salvarSubDetalhamentoIcmsDifalFcp', 'Row', widget.currentRow).then(function (response) {
                widgetApuracao.reload();
                widgetDifalFcp.reload();
                sucessoSalvarGrid(widget);
            }, function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };

    this.salvarCreditoAnterior = function (widget, dataSource, nomewidgetPai) {
        if (widget.isValid()) {
            var widgetApuracao = templateManager.container.getWidget('apuracao_de_imposto');
            var widgetPai = templateManager.container.getWidget(nomewidgetPai);
            General.callRestEngine(dataSource, 'Row', widget.currentRow).then(function (response) {
                if (widget.name === 'widgetCreditoAnteriorIcmsSt') {
                    widgetApuracao.reload().then(function (response) {
                        widgetPai.reload();
                    });
                } else {
                    widgetApuracao.reload();
                }
                ScreenService.goBack();
                widgetPai.activate();
            }, function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };

    this.salvarCreditoAnteriorDifalFcp = function (widget) {
        if (widget.isValid()) {
            //var widgetApuracao = templateManager.container.getWidget('apuracao_de_imposto');
            var nomewidgetPai = widget.currentRow.TIPO === 'DIFAL' ? 'widgetDetalhamentoIcmsDifal' : 'widgetDetalhamentoIcmsFcp';
            var widgetPai = templateManager.container.getWidget(nomewidgetPai);
            widget.currentRow.IDAJUSTENC = widget.currentRow.TIPO === 'DIFAL' ? 'D' : 'F';
            General.callRestEngine('fis_apuracoes#/salvarCreditoAnteriorDifalFcp', 'Row', widget.currentRow).then(function (response) {
                ScreenService.goBack();
                widgetPai.activate();
                widgetPai.getParent().getParent().reload();
            }, function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };

    this.salvarSubDetalhamentoInss = function (widget) {
        if (widget.isValid()) {
            var widgetApuracao = templateManager.container.getWidget('apuracao_de_imposto');
            if (widget.currentRow.__is_new) {
                widget.currentRow.NRSEQUMAPAPU = widgetApuracao.currentRow.NRSEQUMAPAPU;
                widget.currentRow.IDTIPODETAPU = widget.dataSourceFilter[1].value;
            }
            General.callRestEngine('fis_apuracoes#/salvarSubDetalhamentoInss', 'Row', widget.currentRow).then(function (response) {
                widgetApuracao.reload();
                sucessoSalvarGrid(widget);
            }, function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };

    this.salvarSubDetalhamentoIcmsSt = function (widget) {
        if (widget.isValid()) {
            var widgetApuracao = templateManager.container.getWidget('apuracao_de_imposto');
            var widgetDetalhameto = templateManager.container.getWidget('detalhamentoIcmsSt');

            //valores default
            widget.currentRow.CDFILIAL = widget.currentRow.CDFILIAL ? widget.currentRow.CDFILIAL : '';
            widget.currentRow.NRLANCTONF = widget.currentRow.NRLANCTONF ? widget.currentRow.NRLANCTONF : '';

            if (widget.currentRow.__is_new) {
                if (widget.dataSourceFilter[1].value == 'OC' || widget.dataSourceFilter[1].value == 'DD') {
                    widget.currentRow.IDTPAJUSTEAPSG = 'C';
                } else if (widget.dataSourceFilter[1].value == 'OD' || widget.dataSourceFilter[1].value == 'DE') {
                    widget.currentRow.IDTPAJUSTEAPSG = 'D';
                }
                widget.currentRow.IDTPAJUSTE = widget.dataSourceFilter[1].value;
                widget.currentRow.NRSEQUMAPAPU = widgetDetalhameto.currentRow.NRSEQUMAPAPU;
                widget.currentRow.NRSEQMAPAAPUREST = widgetDetalhameto.currentRow.NRSEQMAPAAPUREST;
                widget.currentRow.CDPAIS = widgetDetalhameto.currentRow.CDPAIS;
                widget.currentRow.SGESTADO = widgetDetalhameto.currentRow.SGESTADO;
            }
            General.callRestEngine('fis_apuracoes#/salvarSubDetalhamentoIcmsSt', 'Row', widget.currentRow).then(function (response) {
                widgetApuracao.reload().then(function (response) {
                    widgetDetalhameto.reload();
                });
                sucessoSalvarGrid(widget);
            }, function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };

    this.salvarDetalhamento = function (widget, dataSource) {
        General.callRestEngine(dataSource, 'Row', widget.currentRow).then(function (sucess) {
            widget.template = widget.templateToView;
            widget.view();
            widget.activate();
            General.changeWidgetAcessibility(widget.getParent().widgets, true);
            templateManager.container.getWidget('apuracao_de_imposto').enabled = true;
            templateManager.container.getWidget('apuracao_de_imposto').reload();
        }.bind(this), function (callback) {
            if (callback.data) {
                ScreenService.showMessage(callback.data.error);
            }
        });
    };

    /*
     Função que realizará o procedimento de exclusão de todas as abas
    que serão abertas apartir dos botões existentes na aba de detalhamento
    da apuração de Impostos Geras.
    */
    this.deletarSubDetalhamentoImpostosGerais = function (widget) {
        if (!widget.currentRow.CDLOTE) {
            ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
                widget.currentRow.CDIMPOSTO = templateManager.container.getWidget('apuracao_de_imposto').currentRow.CDIMPOSTO;
                General.callRestEngine('fis_apuracoes#/deletarSubDetalhamentoImpostosGerais', 'Row', widget.currentRow).then(function (response) {
                    ScreenService.closeSwipe().then(function () {
                        ScreenService.showMessage('Deletado com sucesso.');
                        widget.activate();
                        widget.reload();
                    });
                    var widgetApuracao = templateManager.container.getWidget('apuracao_de_imposto');
                    var widgetDetalhameto = templateManager.container.getWidget('detalhamentoIcmsSt');
                    if (widget.name === 'widgetItensDetalhamentoIcmsSt') {
                        widgetApuracao.reload().then(function (response) {
                            widgetDetalhameto.reload();
                        });
                    } else {
                        widgetApuracao.reload();
                    }
                }, function (callback) {
                    if (callback.data && callback.data.error.indexOf('ORA-02292') !== -1) {
                        ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                    } else {
                        ScreenService.showMessage(callback.data.error);
                    }
                });
            });
        } else {
            ScreenService.showMessage('Exclusão não permitida! Existe um lote associado a esse ajuste.');
        }
    };

    this.editarSubDetalhamentoImpostosGerais = function (widget) {
        if (!widget.currentRow.CDLOTE) {
            General.edit(widget);
        } else {
            ScreenService.showMessage('Edição não permitida! Existe um lote associado a esse ajuste.');
        }
    };

    this.deletarSubDetalhamentoDifalFcp = function (widget) {
        ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
            General.callRestEngine('fis_apuracoes#/deletarSubDetalhamentoDifalFcp', 'Row', widget.currentRow).then(function (response) {
                ScreenService.closeSwipe().then(function () {
                    ScreenService.showMessage('Deletado com sucesso.');
                    widget.activate();
                    widget.reload();
                });
                templateManager.container.getWidget('apuracao_de_imposto').reload();
                templateManager.container.getWidget('widgetDifalIcms').reload();
            }, function (callback) {
                if (callback.data && callback.data.error.indexOf('ORA-02292') !== -1) {
                    ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                } else {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        });
    };

    this.salvarItensComposicoes = function (args) {
        var widget = args.owner.widget;
        if (widget.isValid()) {
            var nomeWidgetDetalhamento = widget.name === 'widgetItensComposicaoIcmsSt' ? 'widgetItensDetalhamentoIcmsSt' : 'widgetItensDetalhamento';
            var nomeCampoValor = widget.name === 'widgetItensComposicaoIcmsSt' ? 'VRAJUSTEAPURSG' : 'VRITEMMAPR';
            var widgetDetalhamento = templateManager.container.getWidget(nomeWidgetDetalhamento);

            //Valores para realizar o calculo do detalahemtno do impostos ICMS ST
            if (widget.name === 'widgetItensComposicaoIcmsSt') {
                widget.currentRow.NRSEQMAPAAPUREST = widgetDetalhamento.currentRow.NRSEQMAPAAPUREST;
                widget.currentRow.CDPAIS = widgetDetalhamento.currentRow.CDPAIS;
                widget.currentRow.SGESTADO = widgetDetalhamento.currentRow.SGESTADO;
            }

            General.callRestEngine('fis_apuracoes#/salvarItensComposicoes', 'Row', widget.currentRow).then(function (response) {

                if (widget.name === 'widgetItensComposicaoIcmsSt') templateManager.container.getWidget('detalhamentoIcmsSt').reload();

                templateManager.container.getWidget('apuracao_de_imposto').reload();
                widgetDetalhamento.reload().then(function () {
                    widgetDetalhamento.currentRow[nomeCampoValor] = response.dataset.soma.VALOR;
                    if (widgetDetalhamento.backupRow) widgetDetalhamento.backupRow[nomeCampoValor] = response.dataset.soma.VALOR;
                });
                sucessoSalvarGrid(widget);
            }, function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };

    /*
    Função que realiza procedimento necessários ao relizar um save em um grid
    */
    var sucessoSalvarGrid = function sucessoSalvarGrid(widget) {
        widget.activate();
        if (widget.currentRow.__is_new) {
            widget.list(true);
            ScreenService.goBack();
            widget.reload();
        } else {
            widget.computeDescriptionOrder();
            widget.view();
        }
        widget.currentRow.__is_new = false;
    };

    this.salvarArrecadacaoIcmsSt = function (widget) {
        if (widget.isValid()) {

            General.callRestEngine('fis_apuracoes#/salvarArrecadacaoIcmsSt', 'Row', widget.currentRow).then(function (response) {
                sucessoSalvarGrid(widget);
            }, function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };

    /********************************************************
     *                                                      *
     *          Funções de Manipulação de Elementos         *
     *                                                      *
     ********************************************************/

    /*
     * Função para validar a abertura do formulário para adição de um mapa de
     * apuração.
     */
    this.addMapa = function (widget) {
        // Verifica se o filtro foi preenchido corretamente, verificando se há
        // uma empresa filtrada.
        if (filteredData.CDEMPRESA) {
            var cdsitucrt = filteredData.CDSITUCRT;
            var idapuimpgersn = filteredData.IDAPUIMPGERESN;
            var idtipoapura = filteredData.IDTIPOAPURA;
            if (!Fis00100_ApuracaoDeImposto_Service.bloqueiaMapaRegime(idtipoapura, cdsitucrt, idapuimpgersn)) {
                Fis00100_ApuracaoDeImposto_Service.buscaPrxDataIniECodigoMapa(filteredData).then(function (response) {
                    var dtreferencia = widget.getField("DTREFERENCIA");
                    var dtiniperiodo = widget.getField("DTINIPERIODO");
                    var result = response.dataset.result;
                    var primeiroMapa = result.IDPRIMEIROMAPA;
                    var prxdtinicial = moment(result.DTINIPERIODO, 'DD/MM/YYYY');

                    widget.newRow();
                    changeWidgetsEnabledProperty(false, widget.name);
                    // Data final e de referência (para o Simples Nacional) só
                    // podem ser alterados se for o primeiro mapa.
                    dtreferencia.readOnly = !primeiroMapa;
                    dtiniperiodo.readOnly = !primeiroMapa;

                    // Seta os valores de data e número sequencial do mapa.
                    widget.currentRow.DTREFERENCIA = prxdtinicial.format('DD/MM/YYYY');
                    widget.currentRow.DTINIPERIODO = prxdtinicial.format('DD/MM/YYYY');
                    widget.currentRow.DTFIMPERIODO = prxdtinicial.endOf('month').format('DD/MM/YYYY');
                    widget.currentRow.NRSEQUMAPAPU = result.NRSEQUMAPAPU;
                    widget.currentRow.IDTIPOAPURA = idtipoapura;
                }).catch(errorHandler);
            } else {
                ScreenService.showMessage(Messages_fiscal.MAPA_REGIME_EMPRESA_ERROR, 'error');
            }
        } else {
            ScreenService.showMessage(Messages_fiscal.FILTRO_INVALIDO_ERROR, 'error');
        }
    };

    /*
     * Função para adicionar um ajuste de um mapa de apuração de contribuições.
     */
    this.adicionarAjusteContribuicoes = function (ajustesDetalhamentoWidget) {
        ajustesDetalhamentoWidget.newRow();
        var currentRow = ajustesDetalhamentoWidget.currentRow;
        var contribuicoesDetalhamentoWidget = templateManager.container.getWidget("contribuicoesDetalhamento");
        // Seta valores necessários para a row.

        currentRow.IDINDICAJUSTE = ajustesDetalhamentoWidget.idindicajuste;
        currentRow.IDTPAJUSTE = ajustesDetalhamentoWidget.idtpajuste;
        currentRow.IDFORMAPUR = ajustesDetalhamentoWidget.idformapur;
        currentRow.NRSEQUMAPAPU = contribuicoesDetalhamentoWidget.currentRow.NRSEQUMAPAPU;

        if (currentRow.IDINDICAJUSTE == 'DB') {
            currentRow.CDAJUSTE = "";
            currentRow.IDAPROPRIACAO = "01";
        }

        // Faz com que o campo "Nº do Processo" só aceite números.
        General.justInteger("#NRPROCESSO");
        General.justInteger("#NRRECIBO");
    };

    /*
     * Função para adicionar um item do detalhamento de um mapa de apuração de
     * contribuições.
     */
    this.adicionarItemDetalhamentoContribuicoes = function (calculosDetalhamentoWidget) {
        calculosDetalhamentoWidget.newRow();
        var currentRow = calculosDetalhamentoWidget.currentRow;
        var contribuicoesDetalhamentoWidget = templateManager.container.getWidget("contribuicoesDetalhamento");
        var isDeducao = calculosDetalhamentoWidget.idtipodetapu == "DD";
        // Seta valores necessários para a row.
        currentRow.IDTIPODETAPU = calculosDetalhamentoWidget.idtipodetapu;
        currentRow.NRSEQUMAPAPU = contribuicoesDetalhamentoWidget.currentRow.NRSEQUMAPAPU;
        // Verifica se está inserindo uma dedução, setando um valor default para
        // o campo, caso contrário.
        if (!isDeducao) {
            currentRow.IDCUMUPISCOFIL = 'S';
        }
    };

    /*
     * Função para alterar a visibilidade da action de editar nas widgets de
     * Simples Nacional conforme bloqueio do mapa.
     */
    this.alteraVisibilidadeActionsMapaBloqueado = function () {
        var filterCont = [{
            "name": "CDEMPRESA",
            "operator": "=",
            "value": templateManager.container.getWidget("apuracao_de_imposto").currentRow.CDEMPRESA
        }];

        General.callRestEngine('fis#/crud/contopectbl', 'FilterData', filterCont).then(function (sucess) {
            var mainWidget = templateManager.container.getWidget("apuracao_de_imposto");
            var mapaBloqueado = mainWidget.isNewRow() ? false : mainWidget.currentRow.IDBLOQMAPAPU == 'S';

            var dtfimperiodo;
            var dtiniintcontfis;
            var dtfinintcontfis;
            var periodoBloqueado = false;
            if (sucess.dataset.contopectbl.length > 0) {

                dtfimperiodo = new Date(moment(mainWidget.currentRow.DTFIMPERIODO, 'DD/MM/YYYY').format('MM/DD/YYYY'));
                dtiniintcontfis = new Date(moment(sucess.dataset.contopectbl[0].DTINIINTCONTFIS, 'DD/MM/YYYY').format('MM/DD/YYYY'));
                dtfinintcontfis = new Date(moment(sucess.dataset.contopectbl[0].DTFININTCONTFIS, 'DD/MM/YYYY').format('MM/DD/YYYY'));

                if (dtfimperiodo.getTime() < dtiniintcontfis.getTime() || dtfimperiodo.getTime() > dtfinintcontfis.getTime()) {
                    periodoBloqueado = true;
                }
            }

            // Declara uma função recursiva para alterar a visibilidade de todas as
            // actions de editar, adicionar e excluir da tela.
            var alteraVisibilidadeActions = function alteraVisibilidadeActions(widget) {
                // Verifica widgets que possuem actions de
                // apuração/bloqueio/desbloqueio de mapas.

                var apurarMapaAction = widget.getAction("apurarMapa");
                var bloquearMapaAction = widget.getAction("bloquearMapa");
                var desbloquearMapaAction = widget.getAction("desbloquearMapa");
                if (apurarMapaAction) {
                    if (periodoBloqueado) {
                        apurarMapaAction.readOnly = periodoBloqueado;
                    } else {
                        apurarMapaAction.readOnly = mapaBloqueado;
                    }
                }
                if (bloquearMapaAction) {
                    if (periodoBloqueado) {
                        bloquearMapaAction.readOnly = periodoBloqueado;
                    } else {
                        bloquearMapaAction.readOnly = mapaBloqueado;
                    }
                }
                if (desbloquearMapaAction) {
                    if (periodoBloqueado) {
                        desbloquearMapaAction.readOnly = periodoBloqueado;
                    } else {
                        desbloquearMapaAction.readOnly = !mapaBloqueado;
                    }
                }
                // Nomes utilizados nas actions das widgets da tela.
                var actionNames = ["adicionar", "editar", "excluir"];
                actionNames.forEach(function (actionName) {
                    var action = widget.getAction(actionName);
                    if (action) {
                        if (periodoBloqueado) {
                            action.readOnly = periodoBloqueado;
                        } else {
                            action.readOnly = mapaBloqueado;
                        }
                    }
                    if (Array.isArray(widget.widgets)) {
                        widget.widgets.forEach(function (childWidget) {
                            alteraVisibilidadeActions(childWidget);
                        });
                    }
                });
            };
            alteraVisibilidadeActions(mainWidget);
        });
    };

    /*
     * Função utilizada em widgets do Simples Nacional para cancelar a edição de
     * um detalhamento.
     */
    this.cancelarForm = function (widget) {
        // Retorna a "currentRow" ao estado anterior.
        for (var i in widget.backupRow) {
            widget.currentRow[i] = widget.backupRow[i];
        }

        widget.template = widget.templateToView;
        widget.view();
        widget.activate();

        widget.getParent().view();

        // As widgets que foram
        changeWidgetsEnabledProperty(true);
        widget.getParent().enabled = true;
    };

    /*
     * Função para cancelar a edição de um mapa de apuração.
     */
    this.cancelarMapa = function (args) {
        General.backOrCancel(args);
        changeWidgetsEnabledProperty(true);
    };

    /*
     * Função para setar dados de cabeçalhos e outros valores em widgets de um
     * mapa de apuração do Simples Nacional.
     */
    this.carregarDataSource = function (widget) {
        var widgetPai = widget.getParent();
        widgetPai.getParent().currentRow.VRIMPOSTOREC = widget.dataSource.data[0].VRIMPOSTOREC;
        setaCabecalhoDetalhamento(widgetPai, widget.dataSource.data[0]);
        widgetPai.widgets.forEach(function (widg) {
            widg.currentRow = widget.dataSource.data[0];
            this.setaMensagemDetalhamento(widg);
        }.bind(this));
    };

    /*
     * Função para alterar a propriedade "enabled" de quaisquer widgets
     * diferentes da atual, modificando a possibilidade de acessá-las.
     */
    var changeWidgetsEnabledProperty = function changeWidgetsEnabledProperty(status, nomeWidgetAtual) {
        var mainWidget = templateManager.container.getWidget("apuracao_de_imposto");

        // Declara uma função recursiva para alterar a propriedade de todas as
        // widgets da tela.
        var changeEnabledProperty = function changeEnabledProperty(widget) {
            // Verifica se o status passado é true. Se não for, utiliza o status
            // passado em todas as widgets que não forem a atual, deixando
            // somente ela habilitada como exceção.
            widget.enabled = status || (widget.name != nomeWidgetAtual ? status : true);
            if (Array.isArray(widget.widgets)) {
                widget.widgets.forEach(function (childWidget) {
                    changeEnabledProperty(childWidget);
                });
            }
        };
        changeEnabledProperty(mainWidget);
    };

    /*
     * Função para verificar se certos campos da widget de Arrecadação Fiscal
     * de um mapa de Contribuições deve ficar required.
     */
    this.checkArrecadacaoContribuicoesFieldsRequired = function (mainWidget) {
        if (contribuicoesIsSelected()) {
            var arrecadacaoWidget = templateManager.container.getWidget("contribuicoesArrecadacao");
            var currentRow = mainWidget.currentRow;
            // Verifica se há contribuições a recolher.
            var hasDebito = currentRow.VRTOTAIMPOS > 0;
            // Verifica se há algum valor de débito cumulativo.
            var hasDebitoCumulativo = currentRow.VRDEBITOSCUM > 0;
            // Verifica se há algum valor de débito não cumulativo.
            var hasDebitoNaoCumulativo = currentRow.VRDEBITOSNC > 0;
            arrecadacaoWidget.getField("DTVENCGUIA").validations = hasDebito ? { required: true } : null;
            arrecadacaoWidget.getField("DESCRECECUMU").validations = hasDebito && hasDebitoCumulativo ? { required: true } : null;
            arrecadacaoWidget.getField("DESCRECENCUMU").validations = hasDebito && hasDebitoNaoCumulativo ? { required: true } : null;
        }
    };

    /*
     * Função chamada ao alterar a nota fiscal de um detalhamento de um mapa de
     * contribuições. Se não houver valor no detalhamento, utiliza o valor da
     * nota escolhida.
     */
    this.checkChangeDetalhamentoValue = function (calculosDetalhamentoWidget) {
        var currentRow = calculosDetalhamentoWidget.currentRow;
        if (!currentRow.VRITEMDETAPU) {
            currentRow.VRITEMDETAPU = currentRow.VRNOTAFISC;
        }
    };

    /*
     * Função para alterar a visibilidade de actions conforme bloqueio ou
     * apuração do mapa de apuração.
     */
    this.checkElementsVisibility = function (widget) {
        this.alteraVisibilidadeActionsMapaBloqueado();
        changeEnabledPropertyGridWidgets(widget);
        habilitaAjusteContribuicao(widget);
    };

    /*
     * Função para fechar as widgets de itens do detalhamento de um mapa de
     * Contribuições, retornando ao próprio detalhamento.
     */
    this.closeDetalhamentoContribuicoesWidgets = function (widget) {
        ScreenService.closeSwipe().then(function () {
            var detalhamentoWidget = templateManager.container.getWidget("contribuicoesDetalhamento");
            detalhamentoWidget.activate();
            detalhamentoWidget.view();
        });
    };

    /*
     * Função para fechar as widgets de itens do detalhamento de um mapa de
     * Contribuições, retornando ao próprio detalhamento.
     */
    /*this.closeDetalhamentoIrpjCsllWidgets = function(widget) {
        var detalhamentoWidget = templateManager.container.getWidget(widget.widgetParent);
        ScreenService.closeSwipe().then(function() {
            detalhamentoWidget.activate();
            detalhamentoWidget.view();
        });
    };*/

    /*
     * Função para alterar a habilitação de certas widgets do Simples Nacional
     * conforme apuração do mapa.
     */
    var changeEnabledPropertyGridWidgets = function changeEnabledPropertyGridWidgets(widget) {
        var widgetSimplesReferencia = templateManager.container.getWidget('simplesNacionalTabelaReferencia');
        var widgetSimplesNF = templateManager.container.getWidget('notasFiscais');
        var idbloqmapapu = widget.currentRow.IDBLOQMAPAPU;
        // Verifica se o mapa está apurado ou bloqueado.
        var enabled = idbloqmapapu == "A" || idbloqmapapu == "S";
        widgetSimplesReferencia.enabled = enabled;
        widgetSimplesNF.enabled = enabled;
    };

    /*
     * Função para colocar uma widget de view para o modo form, executando as
     * validações necessárias que possuem uma widget pai.
     */
    this.editarFormWidgetPai = function (widget) {
        var cdsitucrt = filteredData.CDSITUCRT;
        var idapuimpgersn = filteredData.IDAPUIMPGERESN;
        var idtipoapura = filteredData.IDTIPOAPURA;
        // Verifica se o regime atual parametrizado permite alterações.
        if (!Fis00100_ApuracaoDeImposto_Service.bloqueiaMapaRegime(idtipoapura, cdsitucrt, idapuimpgersn)) {
            widget.template = widget.templateToForm;

            widget.getParent().edit();
            General.edit(widget);

            changeWidgetsEnabledProperty(false, widget.name);
            widget.getParent().enabled = true;
        } else {
            ScreenService.showMessage(Messages_fiscal.MAPA_REGIME_EMPRESA_ERROR, 'error');
        }
    };

    /*
     * Função para editar a widget com as informações principais de um mapa de
     * apuração.
     */
    this.editMapa = function (args) {
        var widget = args.owner.widget;
        var currentRow = widget.currentRow;
        var cdsitucrt = filteredData.CDSITUCRT;
        var idapuimpgersn = filteredData.IDAPUIMPGERESN;
        var idtipoapura = filteredData.IDTIPOAPURA;
        // Verifica se o regime atual parametrizado permite alterações.
        if (!Fis00100_ApuracaoDeImposto_Service.bloqueiaMapaRegime(idtipoapura, cdsitucrt, idapuimpgersn)) {
            Fis00100_ApuracaoDeImposto_Service.checkUltimoMapa(currentRow).then(function (response) {
                // Só é permitido alterar a data final se for o último mapa.
                widget.getField("DTFIMPERIODO").readOnlyOnEdit = !response.dataset.validation.isUltimoMapa;
                General.edit(widget);
                changeWidgetsEnabledProperty(false, widget.name);
            });
        } else {
            ScreenService.showMessage(Messages_fiscal.MAPA_REGIME_EMPRESA_ERROR, 'error');
        }
    };

    /*
     * Função para abrir o grid com informações sobre os detalhamentos de um
     * mapa com imposto de contribuições.
     */
    this.openAjustesWidget = function (fieldClicked) {
        // Busca o tipo de detalhamento associado ao field.
        var idindicajuste = fieldClicked.idindicajuste;
        var idtpajuste = fieldClicked.idtpajuste;
        var idformapur = fieldClicked.idformapur;
        var widgetParent = fieldClicked.widgetParent;
        var currentRow = fieldClicked.widget.currentRow;
        var ajustesTabbedWidget = templateManager.container.getWidget("ajustesDetalhamentoTabbed");
        var ajustesWidget = templateManager.container.getWidget("ajustesDetalhamento");

        // Variável de controle conforme detalhamento escolhido.
        var isCredito = idindicajuste == "C";
        var isReducao = idtpajuste == "0";

        // Atribui o label da widget conforme detalhamento escolhido.
        ajustesWidget.label = "Ajuste " + (isReducao ? "Redução" : "Acréscimo");
        ajustesWidget.label += isCredito ? " - Crédito/Entradas" : " - Débito/Saídas";

        // Verifica se o detalhamento pode ser alterado. Ele não pode ser
        // alterado se o mapa estiver bloqueado.
        var isEditable = currentRow.IDBLOQMAPAPU != 'S';
        ajustesWidget.dataSourceFilter = [{
            "name": "NRSEQUMAPAPU",
            "operator": "=",
            "value": currentRow.NRSEQUMAPAPU
        }, {
            "name": "IDINDICAJUSTE",
            "operator": "=",
            "value": idindicajuste
        }, {
            "name": "IDTPAJUSTE",
            "operator": "=",
            "value": idtpajuste
        }, {
            "name": "IDFORMAPUR",
            "operator": "=",
            "value": idformapur
        }];
        ScreenService.openSwipe(ajustesTabbedWidget);
        // Limpa os dados anteriormente presentes na widget.
        ajustesWidget.dataSource.data = [];
        ajustesWidget.reload();
        ajustesWidget.getAction("editar").isVisible = isEditable;
        ajustesWidget.getAction("adicionar").isVisible = isEditable;
        ajustesWidget.getAction("excluir").isVisible = isEditable;

        // Controla fields exibidos na tela.
        if (isCredito) {
            setCampoInvisible(ajustesWidget.getField("CDSITUTRIBITNFE"));
            setCampoObrigatorio(ajustesWidget.getField("CDTPCREDPICOITE"));

            setCampoInvisible(ajustesWidget.getField("VRBASECALCAJ"));
            setCampoObrigatorio(ajustesWidget.getField("VRAJUSTE"));

            setCampoInvisible(ajustesWidget.getField("CDAJUSTEBC"));
            setCampoObrigatorio(ajustesWidget.getField("CDAJUSTE"));

            setCampoInvisible(ajustesWidget.getField('CDCONTCTBL'));
            setCampoInvisible(ajustesWidget.getField('CDFILIAL'));

            setCampoInvisible(ajustesWidget.getField('NRRECIBO'));
            setCampoInvisible(ajustesWidget.getField('IDAPROPRIACAO'));
        } else {
            setCampoObrigatorio(ajustesWidget.getField("CDSITUTRIBITNFE"));
            setCampoInvisible(ajustesWidget.getField("CDTPCREDPICOITE"));

            if (idindicajuste == 'DI') {
                setCampoInvisible(ajustesWidget.getField("CDAJUSTEBC"));
                setCampoObrigatorio(ajustesWidget.getField("CDAJUSTE"));

                setCampoInvisible(ajustesWidget.getField("VRBASECALCAJ"));
                setCampoObrigatorio(ajustesWidget.getField("VRAJUSTE"));

                setCampoInvisible(ajustesWidget.getField('CDCONTCTBL'));
                setCampoInvisible(ajustesWidget.getField('CDFILIAL'));

                setCampoInvisible(ajustesWidget.getField('NRRECIBO'));
                setCampoInvisible(ajustesWidget.getField('IDAPROPRIACAO'));
            } else if (idindicajuste == 'DB') {
                setCampoObrigatorio(ajustesWidget.getField("CDAJUSTEBC"));
                setCampoInvisible(ajustesWidget.getField("CDAJUSTE"));

                setCampoObrigatorio(ajustesWidget.getField("VRBASECALCAJ"));
                setCampoObrigatorio(ajustesWidget.getField("VRAJUSTE"));

                setCampoVisible(ajustesWidget.getField('CDCONTCTBL'));

                ajustesWidget.getField('CDFILIAL').dataSourceFilter = [{
                    "name": "CDEMPRESA",
                    "operator": "=",
                    "value": currentRow.CDEMPRESA
                }];
                ajustesWidget.getField('CDFILIAL').reload();
                setCampoVisible(ajustesWidget.getField('CDFILIAL'));

                setCampoVisible(ajustesWidget.getField('NRRECIBO'));
                setCampoObrigatorio(ajustesWidget.getField('IDAPROPRIACAO'));
            }
        }
        // Armazena o tipo de detalhamento escolhido.
        ajustesWidget.idindicajuste = idindicajuste;
        ajustesWidget.idtpajuste = idtpajuste;
        ajustesWidget.idformapur = idformapur;
        ajustesWidget.widgetParent = widgetParent;
    };

    /*
     * Função para abrir o grid com informações sobre os detalhamentos de um
     * mapa com imposto de contribuições.
     */
    this.openCalculosWidget = function (fieldClicked) {
        // Busca o tipo de detalhamento associado ao field.
        var idtipodetapu = fieldClicked.idtipodetapu;
        var currentRow = fieldClicked.widget.currentRow;
        var calculosTabbedWidget = templateManager.container.getWidget("calculosDetalhamentoTabbed");
        var calculosWidget = templateManager.container.getWidget("calculosDetalhamento");

        // Variáveis de controle conforme detalhamento escolhido.
        var isCompensacao = idtipodetapu == "CO";
        var isCreditoAnterior = idtipodetapu == "CA";
        var isDeducao = idtipodetapu == "DD";

        // Atribui o label da widget conforme detalhamento escolhido.
        calculosWidget.label = isCreditoAnterior ? "Crédito Anterior" : isCompensacao ? "NF's Compensações - SPED Contribuições" : "Dedução";

        // Verifica se o detalhamento pode ser alterado. Ele não pode ser
        // alterado se o mapa estiver bloqueado, se o detalhamento não for de
        // compensação ou se o detalhamento for de crédito anterior e não for o
        // primeiro mapa de apuração da empresa/imposto.
        var isEditable = currentRow.IDBLOQMAPAPU != 'S' && !isCompensacao && (!isCreditoAnterior || currentRow.IDPRIMEIROMAPA == 'S');
        if (isDeducao) calculosWidget.dataSource.name = 'fis_apuracoes#/itdetapucontr_detalhamento_contribuicoes';else calculosWidget.dataSource.name = 'fis_apuracoes#/itdetapucontr_detalhamentoCompensacoes';

        calculosWidget.dataSourceFilter = [{
            "name": "NRSEQUMAPAPU",
            "operator": "=",
            "value": currentRow.NRSEQUMAPAPU
        }, {
            "name": "IDTIPODETAPU",
            "operator": "=",
            "value": idtipodetapu
        }];
        ScreenService.openSwipe(calculosTabbedWidget);
        // Limpa os dados anteriormente presentes na widget.
        calculosWidget.dataSource.data = [];
        calculosWidget.reload();
        calculosWidget.getAction("editar").isVisible = isEditable;
        calculosWidget.getAction("adicionar").isVisible = isEditable;
        calculosWidget.getAction("excluir").isVisible = isEditable;

        // Controla fields exibidos na tela.
        if (isDeducao) {

            setCampoObrigatorio(calculosWidget.getField("VRBASEITEMDETAPU"));
            setCampoObrigatorio(calculosWidget.getField("IDORIGDEDUC"));
            setCampoObrigatorio(calculosWidget.getField("IDCUMUPISCOFIL"));
            calculosWidget.getField("NRNOTAFISC").isVisibleOnReport = true;
            calculosWidget.getField("NRNOTAFISC").isVisible = true;
            calculosWidget.getField("NRNOTAFISC").readOnly = false;

            calculosWidget.getField("NRSEQITDETAPU").showOnList = true;
            calculosWidget.getField("NRSEQITDETAPU").isVisibleOnReport = true;

            calculosWidget.getField("DSITEMDETAPU").showOnList = true;
            calculosWidget.getField("DSITEMDETAPU").isVisibleOnReport = true;

            calculosWidget.getField("VRITEMDETAPU").isVisible = true;
            calculosWidget.getField("VRITEMDETAPU").isVisibleOnReport = true;

            calculosWidget.getField("VRBASEITEMDETAPU").isVisibleOnReport = true;

            calculosWidget.getField("IDORIGDEDUC").isVisibleOnReport = true;
            calculosWidget.getField("IDCUMUPISCOFIL").isVisibleOnReport = true;

            calculosWidget.getField("NRNOTA").isVisible = false;
            calculosWidget.getField("NRNOTA").isVisibleOnReport = false;

            calculosWidget.getField("DTEMISSAO").isVisible = false;
            calculosWidget.getField("DTEMISSAO").isVisibleOnReport = false;

            calculosWidget.getField("DTPAGAMENTO").isVisible = false;
            calculosWidget.getField("DTPAGAMENTO").isVisibleOnReport = false;

            calculosWidget.getField("VR_COMP").isVisible = false;
            calculosWidget.getField("VR_COMP").isVisibleOnReport = false;

            calculosWidget.getField("NM_FONTE").isVisible = false;
            calculosWidget.getField("NM_FONTE").isVisibleOnReport = false;

            calculosWidget.getField("CNPJ").isVisible = false;
            calculosWidget.getField("CNPJ").isVisibleOnReport = false;

            calculosWidget.getField("VRNOTAFISC").isVisible = false;
            calculosWidget.getField("VRNOTAFISC").isVisibleOnReport = false;
        } else {

            setCampoInvisible(calculosWidget.getField("VRBASEITEMDETAPU"));
            setCampoInvisible(calculosWidget.getField("IDORIGDEDUC"));
            setCampoInvisible(calculosWidget.getField("IDCUMUPISCOFIL"));
            if (isCreditoAnterior) {
                setCampoInvisible(calculosWidget.getField("NRNOTAFISC"));
            }
            calculosWidget.getField("NRSEQITDETAPU").showOnList = false;
            calculosWidget.getField("NRSEQITDETAPU").isVisibleOnReport = false;

            calculosWidget.getField("DSITEMDETAPU").showOnList = false;
            calculosWidget.getField("DSITEMDETAPU").isVisibleOnReport = false;

            calculosWidget.getField("VRITEMDETAPU").isVisible = false;
            calculosWidget.getField("VRITEMDETAPU").isVisibleOnReport = false;

            calculosWidget.getField("VRBASEITEMDETAPU").isVisibleOnReport = false;
            calculosWidget.getField("IDORIGDEDUC").isVisibleOnReport = false;
            calculosWidget.getField("IDCUMUPISCOFIL").isVisibleOnReport = false;

            calculosWidget.getField("DTEMISSAO").isVisible = true;
            calculosWidget.getField("DTEMISSAO").isVisibleOnReport = true;

            calculosWidget.getField("DTPAGAMENTO").isVisible = true;
            calculosWidget.getField("DTPAGAMENTO").isVisibleOnReport = true;

            calculosWidget.getField("VR_COMP").isVisible = true;
            calculosWidget.getField("VR_COMP").isVisibleOnReport = true;

            calculosWidget.getField("NM_FONTE").isVisible = true;
            calculosWidget.getField("NM_FONTE").isVisibleOnReport = true;

            calculosWidget.getField("CNPJ").isVisible = true;
            calculosWidget.getField("CNPJ").isVisibleOnReport = true;

            calculosWidget.getField("VRNOTAFISC").isVisible = true;
            calculosWidget.getField("VRNOTAFISC").isVisibleOnReport = true;

            calculosWidget.getField("NRNOTAFISC").isVisible = false;
            calculosWidget.getField("NRNOTAFISC").isVisibleOnReport = false;

            calculosWidget.getField("NRNOTA").isVisible = true;
            calculosWidget.getField("NRNOTA").isVisibleOnReport = true;
        }

        // Armazena o tipo de detalhamento escolhido.
        calculosWidget.idtipodetapu = idtipodetapu;
        calculosWidget.redraw();
    };

    /*
     * Função para abrir uma widget contendo detalhamentos sobre créditos ou
     * débitos em um mapa de Contribuições.
     */
    this.openDetalhamentoTotalizadorWidget = function (field) {
        var childWidgetTabbed = templateManager.container.getWidget(field.childWidgetName);
        ScreenService.openSwipe(childWidgetTabbed);

        // Seta a currentRow do mapa na widget form a ser aberta.
        childWidgetTabbed.widgets[0].currentRow = field.widget.currentRow;
        childWidgetTabbed.widgets[0].view();
    };

    /*
     * Função para setar os dados do detalhamento do Simples Nacional no
     * cabeçalho, para exibição.
     */
    var setaCabecalhoDetalhamento = function setaCabecalhoDetalhamento(widget, data) {
        var widgetApuracao = widget.getParent().getParent();
        var mesApuracao = moment(widgetApuracao.currentRow.DTINIPERIODO, 'DD/MM/YYYY');
        widget.currentRow.VRFATURA12MESES = data.VRFATURA12MESES;
        widget.currentRow.VRFATUMENSTOTAL = data.VRBCFATUST + data.VRCOMPBCST + data.VRDEDUZBCST + (data.VRBCFATUSEMST + data.VRCOMPBCSEMST + data.VRDEDUZBCSEMST) + (data.VRBCFATUISEN + data.VRCOMPBCISENTO + data.VRDEDUZBCISENTO) + (data.VRBCFATUEXP + data.VRCOMPBCEXP + data.VRDEDUZBCEXP);
        widget.currentRow.MESAPURAC = mesApuracao.format('MMM/YYYY');
        widget.currentRow.VRALIQSIMPLES = data.VRALIQSIMPLES;

        var params = {
            type: "currency",
            params: {
                showSymbol: false,
                precision: 2,
                thousands: ".",
                decimal: ", "
            }
        };
        // Aplica a máscara manualmente nos valores.
        var valorInicial = Util.applyMask(data.VRINIFAIXA, params, maskEngine);
        var valorFinal = Util.applyMask(data.VRFINFAIXA, params, maskEngine);
        widget.currentRow.DSFAIXA = valorInicial + ' - ' + valorFinal;
    };

    /*
     * Função para setar as mensagens que serão exibidas nas widgets do Simples
     * Nacional.
     */
    this.setaMensagemDetalhamento = function (widget) {
        switch (widget.name) {
            case 'widgetFatuMensalTributadoSt':
                widget.currentRow.INFORMACOES = 'É considerado como "Faturamento Mensal Tributado pelo ST" apenas os produtos das Notas Fiscais de Saída que pussuem CSOSN = 500.\n\nNesse faturamento, é aplicada a Alíquota Total correspondente a Faixa de Valores sendo subtraído desta, a alíquota referente ao imposto ICMS.\n\nA Base de Cálculo é calculada automaticamente pelo sistema. Para os casos em que haja necessidade de aumentar ou deduzir valor nesta base, os campos "Compõe B. C. e Deduz B. C." estão disponíveis para digitação.\n\nO campo "Valor do Imposto" é utilizado para calcular o valor do Imposto a Recolher, onde é feita a soma do "Valor do Imposto" de todos os faturamentos + Majoração, com exceção do Valor do Imposto do Faturamento Mensal Retido que é reduzido do Imposto a Recolher.';
                break;

            case 'widgetFatuMensalNaoTributadoSt':
                widget.currentRow.INFORMACOES2 = 'É considerado como "Faturamento Mensal não Tributado pelo ST" apenas os produtos das Notas Fiscais de Saída que NÃO possuem CSOSN = 103, 300, 400 e 500.\n\nNesse faturamento, é aplicada a Alíquota Total correspondente a Faixa de Valores.\n\nA Base de Cálculo é calculada automaticamente pelo sistema. Para os casos em que haja necessidade de aumentar ou deduzir valor nesta base, os campos "Compõe B. C. e Deduz B. C." estão disponíveis para digitação.\n\nO campo "Valor do Imposto" é utilizado para calcular o valor do Imposto a Recolher, onde é feita a soma do "Valor do Imposto" de todos os faturamentos + Majoração, com exceção do Valor do Imposto do Faturamento Mensal Retido que é reduzido do Imposto a Recolher.';
                break;

            case 'widgetFatuMensalIsentoIcms':
                widget.currentRow.INFORMACOES_ICMS = 'É considerado como "Faturamento Mensal Isento (ICMS)" apenas os produtos das Notas Fiscais de Saída que possuem CSOSN = 103 e 300.\n\nNesse faturamento, é aplicada a Alíquota Total correspondente a Faixa de Valores sendo subtraído desta, a alíquota referente ao imposto ICMS.\n\nA Base de Cálculo é calculada automaticamente pelo sistema. Para os casos em que haja necessidade de aumentar ou deduzir valor nesta base, os campos "Compõe B. C. e Deduz B. C." estão disponíveis para digitação.\n\nO campo "Valor do Imposto" é utilizado para calcular o valor do Imposto a Recolher, onde é feita a soma do "Valor do Imposto" de todos os faturamentos + Majoração, com exceção do Valor do Imposto do Faturamento Mensal Retido que é reduzido do Imposto a Recolher.';
                break;

            case 'widgetFatuExportacao':
                widget.currentRow.INFORMACOES_FATURAMENTO = 'É considerado como "Fatu. Exportação" apenas os produtos das Notas Fiscais de Saída que possuem CFOP iniciados por "7".\n\nNesse faturamento, é aplicada a Alíquota Total correspondente a Faixa de Valores sendo subtraído desta, a alíquota referente ao imposto IPI, ICMS, PIS, COFINS E ISS.\n\nA Base de Cálculo é calculada automaticamente pelo sistema. Para os casos em que haja necessidade de aumentar ou deduzir valor nesta base, os campos "Compõe B. C. e Deduz B. C." estão disponíveis para digitação.\n\nO campo "Valor do Imposto" é utilizado para calcular o valor do Imposto a Recolher, onde é feita a soma do "Valor do Imposto" de todos os faturamentos + Majoração, com exceção do Valor do Imposto do Faturamento Mensal Retido que é reduzido do Imposto a Recolher.';
                break;

            case 'widgetFatuMensalRetido':
                widget.currentRow.INFORMACOES_RETIDO = 'É considerado como "Faturamento Mensal Retido" apenas os produtos das Notas Fiscais de Saída que possuem impostos parametrizados para Reter na Fonte.\n\nNesse faturamento, é aplicada a Alíquota correspondente aos impostos retidos pertinentes a faixa de valores.\n\nPara os casos em que haja necessidade de acrescer o valor do imposto calculado automaticamente pelo sistema, o campo "Valor Não Provisionado" está disponível para digitação.\n\nO campo "Valor do Imposto" é utilizado para calcular o valor do Imposto a Recolher, onde é feita a soma do "Valor do Imposto" de todos os faturamentos + Majoração, com exceção do Valor do Imposto do Faturamento Mensal Retido que é reduzido do Imposto a Recolher.';
                break;

            case 'widgetMajoracao':
                widget.currentRow.INFORMACOES_MAJORACAO = 'A Majoração é realizada quando a Receita Bruta Anual (RBA) da empresa ultrapassa o valor final da última faixa de valores da tabela do simples nacional. O cálculo é feito da seguinte forma:\n\nAlíquota Majorada = Alíquota Maxima + 20%\nParcela Excedente = Receita Bruta Anual (RBA) - Valor Final Faixa\nAlíquota Majorada * Parcela Excedente = Valor do Imposto \n\nO campo "Valor do Imposto" é utilizado para calcular o valor do Imposto a Recolher, onde é feita a soma do "Valor do Imposto" de todos os faturamentos + Majoração, com exceção do Valor do Imposto do Faturamento Mensal Retido que é reduzido do Imposto a Recolher.';
                break;
        }
    };

    this.editarWidgetForm = function (widget, validaCampos, nomesCampos) {
        var cdsitucrt = filteredData.CDSITUCRT;
        var idapuimpgersn = filteredData.IDAPUIMPGERESN;
        var idtipoapura = filteredData.IDTIPOAPURA;
        // Verifica se o regime atual parametrizado permite alterações.
        if (!Fis00100_ApuracaoDeImposto_Service.bloqueiaMapaRegime(idtipoapura, cdsitucrt, idapuimpgersn)) {
            General.widgetEdit(widget);
            if (validaCampos) {
                this.bloqueiaCampos(widget, nomesCampos, true);
            }
        } else {
            ScreenService.showMessage(Messages_fiscal.MAPA_REGIME_EMPRESA_ERROR, 'error');
        }
    };

    /*
     *  Função que controla se é permitido ou não a edição da widget de detalhamento.
     *  Só é permitido editar o primeiro mapa e caso ele não esteja bloqueado
     */
    this.verificaEdicaoDetalhamento = function (widget) {
        var verifica = false;
        var widgetDetalhamento;
        if (impostosGeraisIsSelected(widget.currentRow)) {
            widgetDetalhamento = templateManager.container.getWidget('detalhamentoGeral');
            verifica = true;
        } else if (contribuicoesIsSelected(widget.currentRow.CDIMPOSTO)) {
            widgetDetalhamento = templateManager.container.getWidget('contribuicoesDetalhamento');
            verifica = true;
        }
        //So Apuração de Impostos Gerais e Contribuições Possuem Detalhamento
        if (verifica) {
            var editar = widgetDetalhamento.getAction('editar');
            if (widget.currentRow.IDBLOQMAPAPU === 'S') {
                editar.readOnly = true;
            } else {
                if (widget.currentRow.IDPRIMEIROMAPA === 'S') editar.readOnly = false;else editar.readOnly = true;
            }
        }
    };

    /*
     *  Função que controla a visibilidade da aba de Guias Complementares
     *  que está contida na aba de Arrecadação Fiscal existente apenas para 
     *  Apuração de Impostos Gerais
     */
    var controlaGuiaComplementar = function controlaGuiaComplementar(cdimposto, idtipoapura) {
        var exibe = cdimposto === impostoIcms || cdimposto === impostoIpi || cdimposto === impostoIcmsSt || cdimposto === impostosFecp || cdimposto === impostosCargaRj || cdimposto === impostosIrrfE || cdimposto === impostosIrrfS || cdimposto === impostosPcc || cdimposto === impostosIssqnE || cdimposto === impostoPisRetS || cdimposto === impostosCofinsRetS;
        var widgetGuia = templateManager.container.getWidget('widgetGuiasComplementares');
        var widgetGuiaContrib = templateManager.container.getWidget('widgetGuiasComplementaresContrib');
        if (exibe) {
            if (cdimposto === impostoPisRetS || cdimposto === impostosCofinsRetS) {
                widgetGuia.isVisible = false;
                widgetGuiaContrib.isVisible = true;
            } else {
                widgetGuia.isVisible = true;
                widgetGuiaContrib.isVisible = false;
            }
        } else {
            widgetGuia.isVisible = false;
            widgetGuiaContrib.isVisible = false;
        }
    };

    /*
     *  Função que irá controlar o field código de receita.
     *  Ela buscará informações estaduais caso o imposto seja estadual ou 
     *  federal caso o imposto seja federal.
     */
    this.controlaTipoReceita = function (widget, nomeWidget, nomeCampoGuia) {
        //var campoReceita = widget.getField('CDRECEITAGUIA');
        //var widgetPopupReceita = templateManager.container.getActiveWidget();
        var widgetPopupReceita = templateManager.container.getWidget(nomeWidget).getField(nomeCampoGuia).selectWidget;
        var idtipoapura = filteredData.IDTIPOAPURA;

        if (idtipoapura === 'E') {
            widgetPopupReceita.fields[0].showOnList = true;
            widgetPopupReceita.fields[1].showOnList = true;

            widgetPopupReceita.fields[2].showOnList = false;
            widgetPopupReceita.fields[3].showOnList = false;
            widgetPopupReceita.fields[4].showOnList = false;
            widgetPopupReceita.fields[5].showOnList = false;
            widgetPopupReceita.fields[6].showOnList = false;

            widgetPopupReceita.order = 'CDRECEITAEST';
        } else if (idtipoapura === 'F') {
            widgetPopupReceita.fields[0].showOnList = false;
            widgetPopupReceita.fields[1].showOnList = false;

            widgetPopupReceita.fields[2].showOnList = true;
            widgetPopupReceita.fields[3].showOnList = true;
            widgetPopupReceita.fields[4].showOnList = true;
            widgetPopupReceita.fields[5].showOnList = true;
            widgetPopupReceita.fields[6].showOnList = true;

            widgetPopupReceita.order = 'CDRECEITACONTR';
        }
        // widgetPopupReceita.redraw();
    };

    this.dataSourceTipoReceita = function (widget) {
        var campoReceita = widget.getField('CDRECEGUIA');
        var idtipoapura = filteredData.IDTIPOAPURA;
        if (idtipoapura === 'E' || idtipoapura === 'F') {
            campoReceita.fields = [{
                "label": "Código",
                "name": "CDRECEITAEST",
                "class": "4",
                "showOnList": true,
                "template": "field/text-edit.html"
            }, {
                "label": "Nome",
                "name": "NMRECEITAEST",
                "class": "8",
                "showOnList": true,
                "template": "field/text-edit.html"
            }, {
                "label": "Código",
                "name": "CDRECEITACONTR",
                "class": "4",
                "showOnList": true,
                "template": "field/text-edit.html"
            }, {
                "label": "Nome",
                "name": "NMRECEITACONTR",
                "class": "8",
                "showOnList": true,
                "template": "field/text-edit.html"
            }, {
                "label": "Variação",
                "name": "CDVARIACAO",
                "class": "6",
                "showOnList": true,
                "template": "field/text-edit.html"
            }, {
                "label": "Periodicidade",
                "name": "IDPERIODICREC",
                "class": "6",
                "showOnList": true,
                "template": "field/text-edit.html",
                "options": {
                    "D": "Diária",
                    "S": "Semanal",
                    "X": "Decendial",
                    "Q": "Quinzenal",
                    "M": "Mensal",
                    "B": "Bimestral",
                    "T": "Trimestral",
                    "U": "Quadrimestral",
                    "E": "Semestral",
                    "A": "Anual"
                }
            }, {
                "label": "Débito de SCP/INC",
                "name": "IDDEBSCPINC",
                "class": "6",
                "showOnList": true,
                "template": "field/text-edit.html",
                "options": {
                    "0": "Não é SCP nem INC",
                    "1": "SCP",
                    "2": "INC"
                }
            }];
            campoReceita.events = [{
                "name": "FieldAfterSelectOpen",
                "code": "Fis00100_ApuracaoDeImposto_Controller.controlaTipoReceita(args.owner.field.widget,'guiaFiscalArrecadaoGeral','CDRECEGUIA')"
            }, {
                "name": "FieldOnClick",
                "code": "args.owner.field.initializeField()"
            }];
            delete campoReceita.maxlength;
            if (idtipoapura === 'E') {
                campoReceita.template = "zh-select-autocomplete#field/select-autocomplete.html";
                campoReceita.displayedFields = ["CDRECEITAEST", "NMRECEITAEST"];
                campoReceita.searchableFields = ["CDRECEITAEST", "NMRECEITAEST"];
                campoReceita.valueField = 'CDRECEITAEST';
                campoReceita.descriptionField = 'NMRECEITAEST';
                campoReceita.showSelectAs = "grid";
                campoReceita.outData = {
                    "CDRECEITAEST": "CDRECEGUIA",
                    "NMRECEITAEST": "NMRECEITAEST"
                };
                campoReceita.dataSourceFilter = [{
                    "name": "CDPAIS",
                    "operator": "=",
                    "value": filteredData.CDPAIS
                }, {
                    "name": "SGESTADO",
                    "operator": "=",
                    "value": filteredData.SGESTADO
                }];
            } else if (idtipoapura === 'F') {
                campoReceita.template = "zh-select-autocomplete#field/select-autocomplete.html";
                campoReceita.displayedFields = ["CDRECEITACONTR", "NMRECEITACONTR"];
                campoReceita.searchableFields = ["CDRECEITACONTR", "NMRECEITACONTR"];
                campoReceita.valueField = 'CDRECEITACONTR';
                campoReceita.descriptionField = 'NMRECEITACONTR';
                campoReceita.showSelectAs = "grid";
                campoReceita.dataSource = {
                    "name": "fis#/crud/codreceitacontr",
                    "lazyLoad": true,
                    "rest": true
                };
                campoReceita.outData = {
                    "CDRECEITACONTR": "CDRECEGUIA",
                    "NMRECEITACONTR": "NMRECEITACONTR",
                    "CDVARIACAO": "CDVARIACAO",
                    "IDPERIODICREC": "IDPERIODICREC",
                    "IDDEBSCPINC": "IDDEBSCPINC"
                };
                campoReceita.dataSourceFilter = [{
                    "name": "CDIMPOSTO",
                    "operator": "=",
                    "value": filteredData.CDIMPOSTO
                }];
            }
        } else if (idtipoapura === 'M') {
            campoReceita.template = "field/text-edit.html";
            delete campoReceita.displayedFields;
            delete campoReceita.searchableFields;
            delete campoReceita.valueField;
            delete campoReceita.descriptionField;
            delete campoReceita.showSelectAs;
            campoReceita.dataSource = {};
            delete campoReceita.outData;
            campoReceita.fields = [];
            campoReceita.events = [];
            campoReceita.maxlength = 20;
        }

        // campoReceita.reload();
    };

    /*
        Função que ira abrir um swipe, para exibir informações complementares.
        Funcina somente na aba de detalhamento e quando for apuração de Impostos Gerais.
        Recebe como parâmetro o field(botão que o usuário clica-rá), e nele possui propriedades que 
        identificam o label e o filtro da widget que será aberta
    */
    this.openDetalhamentoGeral = function (field, nomeTabbedDetalhamento) {
        var tabbedDetalhamento = templateManager.container.getWidget(nomeTabbedDetalhamento);
        var widgetItensDetalhamento = tabbedDetalhamento.widgets[0];

        widgetItensDetalhamento.label = field.childWidgetLabel;
        widgetItensDetalhamento.dataSourceFilter[1].value = field.childWidgetFiltro;

        if (nomeTabbedDetalhamento === 'tabbedItensDetalhamento') this.controlaCamposDetalhamentoGeralItens(widgetItensDetalhamento);

        if (widgetItensDetalhamento.name === 'widgetItensDetalhamentoIcmsSt') {
            var substituto = widgetItensDetalhamento.getField('IDSUBSTSOLIDST');
            if (field.childWidgetFiltro === 'D') substituto.isVisible = true;else substituto.isVisible = false;
        }

        if (filteredData.SGESTADO == 'SP' && widgetItensDetalhamento.name !== 'widgetItensDetalhamentoIcmsSt') {

            widgetItensDetalhamento.getField('DSITEMOCOR').class = "6";
            widgetItensDetalhamento.getField('DSITEMOCOR').readOnly = false;
            widgetItensDetalhamento.getField('DSFLEGALOCOR').class = "6";
            widgetItensDetalhamento.getField('DSFLEGALOCOR').readOnly = false;
            widgetItensDetalhamento.getField('CDITEMOCOR').class = "6";
            widgetItensDetalhamento.getField('CDITEMOCOR').template = "field/text-edit.html";
            widgetItensDetalhamento.getField('CDITEMOCOR').events = [{
                "id": "63224560732920089361231",
                "name": "FieldOnChange",
                "code": "Fis00100_ApuracaoDeImposto_Controller.controlaCampoCodigoSubItem(args.owner.field.widget)"
            }];
            widgetItensDetalhamento.getField('CDITEMOCOR').mask = {
                "type": "fix",
                "params": {
                    "mask": "999.99"
                }
            };
            delete widgetItensDetalhamento.getField('CDITEMOCOR').displayedFields;
            delete widgetItensDetalhamento.getField('CDITEMOCOR').searchableFields;
            delete widgetItensDetalhamento.getField('CDITEMOCOR').showSelectAs;
            delete widgetItensDetalhamento.getField('CDITEMOCOR').valueField;
            delete widgetItensDetalhamento.getField('CDITEMOCOR').order;
            delete widgetItensDetalhamento.getField('CDITEMOCOR').outData;
            delete widgetItensDetalhamento.getField('CDITEMOCOR').fields;
            delete widgetItensDetalhamento.getField('CDITEMOCOR').dataSource;
            delete widgetItensDetalhamento.getField('CDITEMOCOR').dataSourceFilter;
            /*{
                "id": "63224560716265511161230",
                "name": "CDITEMOCOR",
                "label": "Código do Sub-Ítem",
                "isVisible": true,
                "fieldGroup": "occorrencia_gia",
                "maxlength": 5,
                "showOnList": true,
                "showOnForm": true,
                "showOnView": true,
                "class": "6",
                "template": "field/text-edit.html",
                "events": [
                    {
                        "id": "63224560732920089361231",
                        "name": "FieldOnChange",
                        "code": "Fis00100_ApuracaoDeImposto_Controller.controlaCampoCodigoSubItem(args.owner.field.widget)"
                    }
                ],
                "mask": {
                    "type": "fix",
                    "params": {
                        "mask": "999.99"
                    }
                }
            };*/
        } else if (filteredData.SGESTADO == 'RJ') {
            //widgetItensDetalhamento.getField('CDITEMOCOR').template = "zh-select-autocomplete#field/select-autocomplete.html";
            General.callRestEngine('fis#/crud/ocorrenciagiarj', 'FilterData', []).then(function (response) {

                widgetItensDetalhamento.getField('DSITEMOCOR').class = "12";
                widgetItensDetalhamento.getField('DSITEMOCOR').readOnly = true;
                widgetItensDetalhamento.getField('DSFLEGALOCOR').class = "12";
                widgetItensDetalhamento.getField('DSFLEGALOCOR').readOnly = true;
                widgetItensDetalhamento.getField('CDITEMOCOR').template = "field/select.html";
                widgetItensDetalhamento.getField('CDITEMOCOR').class = "12";
                widgetItensDetalhamento.getField('CDITEMOCOR').events = [];
                delete widgetItensDetalhamento.getField('CDITEMOCOR').mask;
                /*widgetItensDetalhamento.getField('CDITEMOCOR').displayedFields = [
                    "CDINSCESTA",
                    "SGESTADO"
                ];
                widgetItensDetalhamento.getField('CDITEMOCOR').searchableFields = [
                    "CDINSCESTA",
                    "SGESTADO"
                ];*/
                widgetItensDetalhamento.getField('CDITEMOCOR').showSelectAs = "grid";
                widgetItensDetalhamento.getField('CDITEMOCOR').valueField = "NRSEQUENCIAL";
                widgetItensDetalhamento.getField('CDITEMOCOR').descriptionField = "NRSEQUENCIAL";
                widgetItensDetalhamento.getField('CDITEMOCOR').order = "NRSEQUENCIAL";
                widgetItensDetalhamento.getField('CDITEMOCOR').outData = {
                    "NRSEQUENCIAL": "NRSEQUENCIAL",
                    "CDNUMEROOCOR": "CDITEMOCOR",
                    "DSOCORRENCIA": "DSITEMOCOR",
                    "DSLEGISLACAO": "DSFLEGALOCOR"
                };
                widgetItensDetalhamento.getField('CDITEMOCOR').fields = [{
                    "name": "NRSEQUENCIAL",
                    "label": "Sequencial",
                    "template": "field/text-edit.html",
                    "isVisible": true,
                    "showOnList": true,
                    "events": []
                }, {
                    "name": "IDTIPO",
                    "label": "Sub-tipo",
                    "template": "field/text-edit.html",
                    "isVisible": true,
                    "showOnList": true,
                    "events": []
                }, {
                    "name": "CDNUMEROOCOR",
                    "label": "Número",
                    "template": "field/text-edit.html",
                    "isVisible": true,
                    "showOnList": true,
                    "events": []
                }, {
                    "name": "DSOCORRENCIA",
                    "label": "Descrição",
                    "template": "field/text-edit.html",
                    "isVisible": true,
                    "showOnList": true,
                    "events": []
                }, {
                    "name": "DTINIVALIDADE",
                    "label": "Validade Inicial",
                    "template": "field/text-edit.html",
                    "isVisible": true,
                    "showOnList": true,
                    "events": []
                }, {
                    "name": "DTFINVALIDADE",
                    "label": "Validade Final",
                    "template": "field/text-edit.html",
                    "isVisible": true,
                    "showOnList": true,
                    "events": []
                }, {
                    "name": "DSLEGISLACAO",
                    "label": "Descrição da Legislação",
                    "template": "field/text-edit.html",
                    "isVisible": true,
                    "showOnList": true,
                    "events": []
                }];
                widgetItensDetalhamento.getField('CDITEMOCOR').dataSource = {
                    "name": "fis#/crud/ocorrenciagiarj",
                    "rest": true,
                    "lazyLoad": true
                };
                widgetItensDetalhamento.getField('CDITEMOCOR').dataSource.data = response.dataset.ocorrenciagiarj;
            });
            /*{
                "id": "63224560716265511161230",
                "name": "CDITEMOCOR",
                "label": "Código do Sub-Ítem",
                "isVisible": true,
                "fieldGroup": "occorrencia_gia",
                "maxlength": 5,
                "showOnList": true,
                "showOnForm": true,
                "showOnView": true,
                "class": "6",
                "template": "zh-select-autocomplete#field/select-autocomplete.html",
                "displayedFields": [
                    "CDINSCESTA",
                    "SGESTADO"
                ],
                "searchableFields": [
                    "CDINSCESTA",
                    "SGESTADO"
                ],
                "showSelectAs": "grid",
                "valueField": "CDINSCESTA",
                "descriptionField": "",
                "order": "CDINSCESTA",
                "outData": {
                    "CDPAIS": "CDPAIS",
                    "SGESTADO": "SGESTADO",
                    "CDINSCESTA": "CDINSCESTA"
                },
                "fields": [
                    {
                        "name": "CDINSCESTA",
                        "label": "Inscrição Estadual",
                        "template": "field/text-edit.html",
                        "isVisible": true,
                        "showOnList": true,
                        "events": []
                    },
                    {
                        "name": "SGESTADO",
                        "label": "Estado",
                        "template": "field/text-edit.html",
                        "isVisible": true,
                        "showOnList": true,
                        "events": []
                    }
                ],
                "dataSource": {
                    "name": "fis#/crud/inscrestad",
                    "rest": true,
                    "lazyLoad": true
                },
                "dataSourceFilter": {
                    "name": "CDEMPRESA",
                    "operator": "=",
                    "value": ""
                }
            },
            */
        }

        widgetItensDetalhamento.reload();

        ScreenService.openSwipe(tabbedDetalhamento).then(function (success) {
            widgetItensDetalhamento.reload();
        });
    };

    this.openDetalhamento = function (field, nomeTabbedDetalhamento) {
        var widget = field.widget;
        var tabbedDetalhamento = templateManager.container.getWidget(nomeTabbedDetalhamento);
        var widgetItensDetalhamento = tabbedDetalhamento.widgets[0];
        var tipo = widget.name === 'widgetItensDetalhamentoIcmsSt' ? widget.currentRow.IDTPAJUSTEAPSG : widget.currentRow.IDTIPOITMAPR;
        tipo = tipo === 'C' ? tipo = 'OC' : tipo === 'D' ? tipo = 'OD' : tipo = tipo;
        widgetItensDetalhamento.dataSourceFilter = [{
            "name": "P_CDFILIAL",
            "operator": "=",
            "value": widget.currentRow.CDFILIAL
        }, {
            "name": "P_IDTIPOITMAPR",
            "operator": "=",
            "value": tipo
        }, {
            "name": "P_NRSEQUMAPAPU",
            "operator": "=",
            "value": widget.currentRow.NRSEQUMAPAPU
        }, {
            "name": "P_CDIMPOSTO",
            "operator": "=",
            "value": templateManager.container.getWidget('apuracao_de_imposto').currentRow.CDIMPOSTO
        }, {
            "name": "P_NRLANCTONF",
            "operator": "=",
            "value": widget.currentRow.NRLANCTONF
        }];
        if (widgetItensDetalhamento.name === 'widgetItensComposicaoIcmsSt') {
            widgetItensDetalhamento.dataSource.name = 'fis_apuracoes#/crud/itensComposicao_icmsSt';
            widgetItensDetalhamento.dataSourceFilter.push({
                "name": "P_IDSUBSTSOLIDST",
                "operator": "=",
                "value": widget.currentRow.IDSUBSTSOLIDST
            }, {
                "name": "P_NRSEQITMAPR",
                "operator": "=",
                "value": widget.currentRow.NRSEQAJUSAPURSG
            });
        } else {
            widgetItensDetalhamento.dataSource.name = 'fis_apuracoes#/crud/itensComposicao_detalhamentoGeral';
            var filtroICMS = {
                "name": "P_NRSEQITMAPR",
                "operator": "=",
                "value": widget.currentRow.NRSEQITMAPR
            };

            widgetItensDetalhamento.dataSourceFilter.push(filtroICMS);
        }
        ScreenService.openSwipe(tabbedDetalhamento).then(function (success) {
            widgetItensDetalhamento.reload();
        });
    };

    this.openDetalhamentoCreditoAnterior = function (field) {
        var widget = field.widget;
        var tabbedDetalhamento = templateManager.container.getWidget(field.childWidgetName);
        var widgetItensDetalhamento = tabbedDetalhamento.widgets[0];
        var campoCredito = widgetItensDetalhamento.getField(field.nameField);
        var actionSalvar = widgetItensDetalhamento.getAction('salvar');

        if (widget.currentRow.IDBLOQMAPAPU === 'S') {
            campoCredito.readOnly = true;
            actionSalvar.readOnly = true;
        } else {
            if (widget.currentRow.IDPRIMEIROMAPA === 'S') {
                campoCredito.readOnly = false;
                actionSalvar.readOnly = false;
            } else {
                campoCredito.readOnly = true;
                actionSalvar.readOnly = true;
            }
        }
        widgetItensDetalhamento.currentRow = Util.clone(field.widget.currentRow);
        ScreenService.openSwipe(tabbedDetalhamento);
    };

    this.openDetalhamentoCreditoAnteriorDifalFcp = function (field, tipo) {
        var widgetMapa = templateManager.container.getWidget('apuracao_de_imposto');
        var widget = field.widget;
        var tabbedDetalhamento = templateManager.container.getWidget('tabbedCreditoAnteriorDifalFcp');
        var widgetItensDetalhamento = tabbedDetalhamento.widgets[0];

        var actionSalvar = widgetItensDetalhamento.getAction('salvar');
        var creditoDifal = widgetItensDetalhamento.getField('VRSLDCRANTEDIFAL');
        var creditoFCP = widgetItensDetalhamento.getField('VRSLDCRANTEFCP');

        var primeiroMapa = !(widgetMapa.currentRow.IDBLOQMAPAPU != 'S' && widget.currentRow.IDPRIMEIROMAPA === 'S');
        actionSalvar.readOnly = primeiroMapa;
        creditoDifal.readOnly = primeiroMapa;
        creditoFCP.readOnly = primeiroMapa;

        creditoDifal.isVisible = tipo === 'DIFAL';
        creditoFCP.isVisible = tipo === 'FCP';

        widgetItensDetalhamento.currentRow = Util.clone(field.widget.currentRow);
        widgetItensDetalhamento.currentRow.TIPO = tipo;
        ScreenService.openSwipe(tabbedDetalhamento);
    };

    this.voltarCreditoAnterior = function (nomeWidget) {
        var widget = templateManager.container.getWidget(nomeWidget);
        ScreenService.goBack();
        widget.activate();
        //widget.currentRow = templateManager.container.getWidget('apuracao_de_imposto').currentRow;
    };

    this.voltarCreditoAnteriorDifalFcp = function (widget) {
        var nomeWidget = widget.currentRow.TIPO === 'DIFAL' ? 'widgetDetalhamentoIcmsDifal' : 'widgetDetalhamentoIcmsFcp';
        var widgetAtiva = templateManager.container.getWidget(nomeWidget);
        ScreenService.goBack();
        widgetAtiva.activate();
    };

    /*
        Função que ira controlar campos que só serão exibido caso o mapa
        seja de determinado imposto e respeitando condições de Estado, pois existem campos
        que são exibidos somente para um estado específico.
        Aba de detalhamento Impostos Gerais.
    */
    this.controlaCamposDetalhamentoGeralItens = function (widgetItens) {
        var widgetApuracao = templateManager.container.getWidget('apuracao_de_imposto');
        var camposImpostosICMS = ['IDCOMPOEC197'];
        var camposGerais = ['CDAJUSTEITMAPA'];
        var campoMt = ['CDITPROCEDENCIA'];
        var campoSc = ['CDITEDCIPMAPA'];
        var campoPe = ['CDAJUSTEITSEF'];
        var camposRjSp = ['CDITEMOCOR', 'DSITEMOCOR', 'DSFLEGALOCOR'];

        camposImpostosICMS.forEach(function (field) {
            widgetItens.getField(field).isVisible = widgetApuracao.currentRow.CDIMPOSTO === impostoIcms && filteredData.SGESTADO !== 'DF';
        });

        campoMt.forEach(function (field) {
            widgetItens.getField(field).isVisible = filteredData.SGESTADO === 'MT' && widgetApuracao.currentRow.CDIMPOSTO === impostoIcms;
        });

        campoSc.forEach(function (field) {
            widgetItens.getField(field).isVisible = filteredData.SGESTADO === 'SC' && widgetApuracao.currentRow.CDIMPOSTO === impostoIcms;
        });

        campoPe.forEach(function (field) {
            widgetItens.getField(field).isVisible = filteredData.SGESTADO === 'PE' && widgetApuracao.currentRow.CDIMPOSTO === impostoIcms;
        });

        camposRjSp.forEach(function (field) {
            widgetItens.getField(field).isVisible = (filteredData.SGESTADO === 'RJ' || filteredData.SGESTADO === 'SP') && widgetApuracao.currentRow.CDIMPOSTO === impostoIcms;
        });

        camposGerais.forEach(function (field) {
            widgetItens.getField(field).isVisible = (widgetApuracao.currentRow.CDIMPOSTO === impostoIcms || widgetApuracao.currentRow.CDIMPOSTO === impostoIpi) && (filteredData.IDTIPOAPURA === 'E' || filteredData.IDTIPOAPURA != 'E');
        });
    };

    this.controlaCampoComporSped = function (widget) {
        var campoNota = widget.getField('NRNOTAFISC');
        //var nomeCampoAjuste = widget.name ==='widgetItensDetalhamento' ? 'CDAJUSTEITMAPA' :'CDAJUSTEAPURSG'; 

        if (widget.currentRow.IDCOMPOEC197 === 'I' || widget.currentRow.IDCOMPOEC197 === 'D') {
            campoNota.validations.required = true;
        } else {
            delete campoNota.validations.required;
            //widget.getField('VRITEMMAPR').readOnly = false;
        }
        //widget.getField(nomeCampoAjuste).value('');
    };

    this.avisoComporSpeed = function (field) {
        var valor = field.value();
        if (valor === 'D') {
            ScreenService.showMessage('Atenção! As informações serão geradas somente no registro C197 do SPED FISCAL e desconsiderada do registro E111. Será considerado o valor digitado para a nota, e os campos de Base e Alíquotas serão zerados.');
        } else if (valor == 'I') {
            ScreenService.showMessage('Atenção! As informações serão geradas somente no registro C197 do SPED FISCAL e desconsiderada do registro E111. Serão considerados os valores de Base de Cálculo, Alíquota e Valor do Imposto presente nos itens da nota. Os itens selecionados para gerar o C197 serão zerados nos registros C190 e C100.');
        }
    };

    this.controlaCampoCodigoSubItem = function (widget) {
        var field = widget.getField('CDITEMOCOR');
        var campoDescricao = widget.getField('DSITEMOCOR');
        var campoFundamentacao = widget.getField('DSFLEGALOCOR');
        if (field.value()) {
            var campoCodigo = field.value().replace(/[^0-9]/g, '');
            if (campoCodigo.substr(3, 4) === '99') {
                campoDescricao.readOnly = false;
                campoDescricao.validations.required = true;

                campoFundamentacao.readOnly = false;
                campoFundamentacao.validations.required = true;
            } else {
                campoDescricao.readOnly = true;
                campoDescricao.value('');
                delete campoDescricao.validations.required;

                campoFundamentacao.readOnly = true;
                campoFundamentacao.value('');
                delete campoFundamentacao.validations.required;
            }
        } else {
            campoDescricao.readOnly = true;
            campoDescricao.value('');
            delete campoDescricao.validations.required;

            campoFundamentacao.readOnly = true;
            campoFundamentacao.value('');
            delete campoFundamentacao.validations.required;
        }
    };

    /*
        Função que ira controlar campos que dependem do campo
        número do processo na aba de guias complementares
        na apurção de  impostos gerais.
    */
    this.controlaCampoNumeroProcesso = function (widget) {
        var nomeProceso = widget.name === 'widgetArrecadacaoFiscalIcmsSt' ? 'NRPROCESSO' : 'NRPROCESSOGUIA';
        var nomeOrigem = widget.name === 'widgetArrecadacaoFiscalIcmsSt' ? 'IDORIGEMDET' : 'IDORIGEMGUIA';
        var nomeHistorico = widget.name === 'widgetArrecadacaoFiscalIcmsSt' ? 'DSHISTORICO' : 'DSHISTGUIACOMPL';

        var campoProcesso = widget.getField(nomeProceso);
        var campoOrigem = widget.getField(nomeOrigem);
        var campoHistorico = widget.getField(nomeHistorico);

        if (campoProcesso.value()) {
            campoOrigem.readOnly = false;
            campoHistorico.readOnly = false;
        } else {
            campoOrigem.readOnly = true;
            campoHistorico.readOnly = true;
        }
    };

    /*
        Controla os filtros do campo codigo de ajuste
    */
    this.controlaCampoCodigoAjuste = function (field) {
        var widget = field.widget;
        if (field.name === 'CDAJUSTEITSEF') {
            field.dataSourceFilter = [{
                "name": "IDTPCODRECEITA",
                "operator": "=",
                "value": 'E'
            }, {
                "name": "SGESTADO",
                "operator": "=",
                "value": filteredData.SGESTADO
            }, {
                "name": "IDTPAJUSTE",
                "operator": "=",
                "value": 'D'
            }];
            field.reload();
        } else {
            if (filteredData.IDTIPOAPURA === 'E') {
                var tipoAjuste = widget.currentRow.IDCOMPOEC197 === 'I' || widget.currentRow.IDCOMPOEC197 === 'D' ? 'D' : 'A';
                field.dataSourceFilter = [{
                    "name": "IDTPCODRECEITA",
                    "operator": "=",
                    "value": filteredData.IDTIPOAPURA
                }, {
                    "name": "SGESTADO",
                    "operator": "=",
                    "value": filteredData.SGESTADO
                }, {
                    "name": "IDTPAJUSTE",
                    "operator": "=",
                    "value": tipoAjuste
                }];
            } else if (filteredData.IDTIPOAPURA === 'F') {
                field.dataSourceFilter = [{
                    "name": "IDTPCODRECEITA",
                    "operator": "=",
                    "value": filteredData.IDTIPOAPURA
                }, {
                    "name": "SGESTADO",
                    "operator": "IS_NULL"
                }, {
                    "name": "IDTPAJUSTE",
                    "operator": "=",
                    "value": 'A'
                }];
            }
            field.reload();
        }
    };

    this.controlaComporC197Itens = function (widget) {
        var condicao = filteredData.IDTIPOAPURA === 'E' && (filteredData.CDIMPOSTO === impostoIcms || filteredData.CDIMPOSTO === impostoIcmsSt) && widget.currentRow.IDCOMPOEC197 === 'I' && filteredData.SGESTADO !== 'PE' && filteredData.SGESTADO !== 'DF';
        var nomeCampoValor = widget.name === 'widgetItensDetalhamento' ? 'VRITEMMAPR' : 'VRAJUSTEAPURSG';

        widget.getField(nomeCampoValor).readOnly = condicao;
        widget.getField('BUTITENS').isVisible = condicao;

        if (widget.name === 'widgetItensDetalhamentoIcmsSt') this.controlaCampoSubstitutoSolidario(widget);
    };

    this.addSubDetalhamento = function (widget) {
        var widgetApuracao = templateManager.container.getWidget('apuracao_de_imposto');
        widget.newRow();
        widget.currentRow.NRSEQUMAPAPU = widgetApuracao.currentRow.NRSEQUMAPAPU;
        widget.currentRow.IDTIPOITMAPR = widget.dataSourceFilter[1].value;

        if (widget.name === 'widgetItensDetalhamento') this.controlaCampoComporSped(widget);
    };

    /*
        Funcação que pega a soma de todos os Itens da 
        Nota quando o campo compor c197 speed tem o valor dos Itens.
        Verifica as notas marcadas e as tabelas relacionadas para retornar o
        valor correta da soma
        Executada somente no onChange cos Campos que influenciam a soma(NOTA FISCAL e COMPOR C197) 
        Sub-detalhamento da apuração de impostos geral.
    */

    this.controlaValorItensComposicao = function (widget) {

        var nomeCampoValor = widget.name === 'widgetItensDetalhamento' ? 'VRITEMMAPR' : 'VRAJUSTEAPURSG';
        widget.currentRow.CDIMPOSTO = templateManager.container.getWidget('apuracao_de_imposto').currentRow.CDIMPOSTO;

        //valores default
        widget.currentRow.CDFILIAL = widget.currentRow.CDFILIAL ? widget.currentRow.CDFILIAL : '';
        widget.currentRow.NRLANCTONF = widget.currentRow.NRLANCTONF ? widget.currentRow.NRLANCTONF : '';

        General.callRestEngine('fis_apuracoes#/controlaValorItensComposicao', 'Row', widget.currentRow).then(function (success) {
            widget.currentRow[nomeCampoValor] = success.dataset.soma.VRIMPOSTO;
        }.bind(this), function (callback) {
            if (callback.data) {
                ScreenService.showMessage(callback.data.error);
            }
        });
    };

    this.onChangeComporC197Speed = function (field) {
        var widget = field.widget;
        var nomeCampoAjuste = widget.name === 'widgetItensDetalhamento' ? 'CDAJUSTEITMAPA' : 'CDAJUSTEAPURSG';

        widget.getField(nomeCampoAjuste).value('');
        if (widget.currentRow.IDCOMPOEC197 === 'I' && !widget.currentRow.NRNOTAFISC) {
            widget.currentRow.IDCOMPOEC197 = 'N';
            ScreenService.showMessage(Messages_fiscal.COMPOR_ITENS);
        }

        this.controlaCampoComporSped(widget);
        this.avisoComporSpeed(field);
        this.controlaComporC197Itens(widget);
        this.controlaValorItensComposicao(widget);
    };

    /*  Procedimento para inserir um novo registro na aba de Inforações
        Adicionais, exibida com o imposto selecionado for o ICMS.
    */
    this.salvarInformacoesAdicionais = function (widget) {
        if (widget.isValid()) {
            var widgetMapa = templateManager.container.getWidget('apuracao_de_imposto');
            if (widget.currentRow.__is_new) widget.currentRow.NRSEQUMAPAPU = widgetMapa.currentRow.NRSEQUMAPAPU;
            General.callRestEngine('fis_apuracoes#/salvarInformacoesAdicionais', 'Row', widget.currentRow).then(function (response) {
                sucessoSalvarGrid(widget);
            }, function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };

    this.replicarInformacoesAdicionais = function (widget) {
        ScreenService.confirmMessage(ScreenService.i18n(Messages_fiscal.REPLICAR_INFORMACOES_ADICIONAIS), 'question', function (success) {
            General.callRestEngine('fis_apuracoes#/replicarInformacoesAdicionais', 'Row', templateManager.container.getWidget('apuracao_de_imposto').currentRow).then(function (response) {
                ScreenService.closePopup();
                widget.reload();
            }, function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        });
    };

    this.addGuiasFiscaisIcms = function (widget) {
        var widgetDifalIcms = templateManager.container.getWidget('widgetDifalIcms');
        widget.newRow();
        General.justInteger('#CDOBRIGAGUIA, #NRPROCESSOGUIA');

        //Procedimetos para gerar novo código;
        var paramsNewCode = widget.paramsNewCode;
        var keysParamsNewCode = Object.keys(paramsNewCode);
        keysParamsNewCode.forEach(function (value) {
            widget.currentRow[value] = paramsNewCode[value];
        });

        widget.currentRow.NRSEQUMAPAPU = widgetDifalIcms.currentRow.NRSEQUMAPAPU;
        widget.currentRow.NRSEQMAPAPURESTNC = widgetDifalIcms.currentRow.NRSEQMAPAPURESTNC;
    };

    /*
     *   Função que controla os sub detlahemnto da aba de DIFAL/FCP.
     */
    this.openDetalhamentoDifalFcp = function (field) {
        var tabbedDetalhamento = templateManager.container.getWidget('tabbedItensDetalhamentoDifalFcp');
        var widgetItensDetalhamento = tabbedDetalhamento.widgets[0];

        widgetItensDetalhamento.label = field.childWidgetLabel;
        widgetItensDetalhamento.dataSourceFilter[2].value = field.childWidgetFiltro;
        widgetItensDetalhamento.dataSourceFilter[3].value = field.tipoWidget;

        ScreenService.openSwipe(tabbedDetalhamento).then(function (success) {
            widgetItensDetalhamento.reload();
        });
    };

    this.voltarDetalhamentoDifalFcp = function (widget) {
        var nomeWidget = widget.dataSourceFilter[3].value === 'D' ? 'widgetDetalhamentoIcmsDifal' : 'widgetDetalhamentoIcmsFcp';
        ScreenService.goBack();
        templateManager.container.getWidget(nomeWidget).activate();
    };

    this.addArrecadacaoFiscalIcmsSt = function (widget) {
        widget.newRow();
        General.justInteger('#CDOBRIGACAO, #NRPROCESSO');
        this.controlaCampoNumeroProcesso(widget);
        widget.currentRow.NRSEQUDETUF = '';
        widget.currentRow.NRSEQUMAPAPU = widget.getParent().currentRow.NRSEQUMAPAPU;
        widget.currentRow.NRSEQMAPAAPUREST = widget.getParent().currentRow.NRSEQMAPAAPUREST;
        widget.currentRow.SGESTADO = widget.getParent().currentRow.SGESTADO;
        widget.currentRow.CDPAIS = widget.getParent().currentRow.CDPAIS;
    };

    this.controlaCampoSubstitutoSolidario = function (widget) {
        var campoSolidario = widget.getField('IDSUBSTSOLIDST');
        if (widget.currentRow.IDCOMPOEC197 === 'I') {
            campoSolidario.readOnly = false;
        } else {
            campoSolidario.readOnly = true;
            campoSolidario.value('N');
        }
    };

    /*
        Caso os itens sejam do substituto solidario E compoem C197,
        é permitido alterar o valor do imposto e da base de cálculo.
    */
    this.controlaValorItensSubstituto = function (widget) {
        var widgetDetalhamento = templateManager.container.getWidget('widgetItensDetalhamentoIcmsSt');
        var campoValor = widget.getField('VRIMPOSTO');
        var condicao = widgetDetalhamento.currentRow.IDSUBSTSOLIDST === 'S' && widget.currentRow.IDCOMPOE === 'S';

        campoValor.readOnly = !condicao;
    };

    /********************************************************
     *                                                      *
     *                  Funções Auxiliares                  *
     *                                                      *
     ********************************************************/

    /*  Função que dispara todas outras funções necessária
    que são executadas quando ocorre o evento de after moveRow do
    grid de apuração de imposto;
        
    */
    this.afterMoveRowApuracaoImposto = function (args) {
        var widget = args.owner;
        this.setChildGridsNeedReload(widget);
        this.checkElementsVisibility(widget);
        this.setSameCurrentRowChildWidgets(widget);
        this.alteraVisibilidadeActionsMapaBloqueado();
        this.checkArrecadacaoContribuicoesFieldsRequired(widget);
        if (widget.currentRow.CDIMPOSTO === impostoIcms) this.recarregarWidget('widgetDifalIcms');

        if (icmsStIsSelected(widget.currentRow.CDIMPOSTO)) this.recarregarWidget('detalhamentoIcmsSt');

        //this.verificaEdicaoDetalhamento(widget);
    };

    /*
     * Função para recarregar um elemento conforme propriedade "needReload" que
     * é setado neste de acordo com alterações realizadas na tela.
     */
    this.checkElementNeedReload = function (element) {
        if (element.needReload) {
            element.needReload = false;
            element.reload();
        }
    };

    /*
     * Função para verificar se um número sequencial inserido pelo usuário é
     * único.
     */
    this.checkValidSequencialDetalhamento = function (calculosDetalhamentoWidget) {
        var currentRow = calculosDetalhamentoWidget.currentRow;
        if (currentRow.NRSEQITDETAPU) {
            Fis00100_ApuracaoDeImposto_Service.checkValidSequencialDetalhamento(currentRow).then(function (response) {
                if (!response.dataset.validation.isValid) {
                    ScreenService.showMessage(Messages_fiscal.SEQUENCIAL_JA_CADASTRADO).then(function () {
                        currentRow.NRSEQITDETAPU = null;
                    });
                }
            }).catch(function (errorResponse) {
                var errorMessage = Messages_fiscal.TIMEOUT_ERROR;
                if (errorResponse && errorResponse.data && errorResponse.data.error) {
                    errorMessage = errorResponse.data.error;
                }
                ScreenService.showMessage(errorMessage);
            });
        }
    };

    /*
     * Função para verificar se um imposto é de Contribuições. Utiliza o imposto
     * filtrado, caso nenhum parâmetro seja passado.
     */
    var contribuicoesIsSelected = function contribuicoesIsSelected(cdimposto) {
        cdimposto = cdimposto || filteredData.CDIMPOSTO;
        var impostosContribuicoes = [].concat(impostoPis, impostosCofins);
        return impostosContribuicoes.indexOf(cdimposto) !== -1;
    };

    /*
     * Função padrão para tratamento de erros de requisições.
     */
    var errorHandler = function errorHandler(errorResponse) {
        // Utiliza mensagem padrão, caso não haja mensagem de erro retornada.
        var errorMessage = Messages_fiscal.TIMEOUT_ERROR;
        if (errorResponse && errorResponse.data && errorResponse.data.error) {
            errorMessage = errorResponse.data.error;
        }
        ScreenService.showMessage(errorMessage);
    };

    /*
     * Função para fazer setar a propriedade "needReload" como true em todas as
     * widgets filhas de uma principal. Ela só afeta aquelas widgets que tenham
     * o evento chamando a função "checkElementNeedReload", que recarregará
     * a widget.
     */
    this.setChildGridsNeedReload = function (mainWidget) {
        mainWidget.widgets.forEach(function (childWidget) {
            childWidget.needReload = true;
        });
    };

    /*
     * Função para fazer a currentRow de todas as filhas apontarem para a row
     * selecionada no grid principal. Assim as informações compartilhadas entre
     * as widgets podem ser sincronizadas e exibidas de forma simultânea.
     * Widgets que sejam grids não serão afetados, pois continuarão com o
     * comportamento padrão.
     */
    this.setSameCurrentRowChildWidgets = function (mainWidget) {
        // Verifica se o imposto filtrado é de contribuições.
        var widgetsGerais = ["guiaFiscalArrecadaoGeral", "detalhamentoGeral"];
        var widgetsInss = ["detalhamentoInss", "guiaFiscalArrecadaoGeral"];
        var mainRow = mainWidget.currentRow;

        if (contribuicoesIsSelected()) {
            mainWidget.widgets.forEach(function (childWidget) {
                if (childWidget.name == "tabbedContribuicoesDetalhamento") {
                    childWidget.widgets.forEach(function (newChildWidget) {
                        newChildWidget.currentRow = mainRow;
                    });
                } else {
                    childWidget.currentRow = mainRow;
                }
            });
        } else if (inssIsSelected(mainRow.CDIMPOSTO)) {
            widgetsInss.forEach(function (nomeWidget) {
                templateManager.container.getWidget(nomeWidget).currentRow = mainRow;
            });
        } else if (impostosGeraisIsSelected(mainRow)) {
            widgetsGerais.forEach(function (nomeWidget) {
                templateManager.container.getWidget(nomeWidget).currentRow = mainRow;
            });
        }
    };

    /*
     * Função para verificar se um tipo de apuração é de Simples Nacional.
     * Utiliza o tipo de apuração filtrado, caso nenhum parâmetro seja passado.
     */
    var simplesNacionalIsSelected = function simplesNacionalIsSelected(idtipoapura) {
        idtipoapura = idtipoapura || filteredData.IDTIPOAPURA;
        return idtipoapura == "S";
    };

    /*
     * Função para verificar se um tipo de apuração é de Impostos Gerais.
     * Utiliza o imposto filtrado, caso nenhum parâmetro seja passado.
     */
    var impostosGeraisIsSelected = function impostosGeraisIsSelected(row) {
        var todosImpostos = [];
        var cdimposto = row.CDIMPOSTO;
        var tipoApurac = row.IDTIPOAPURA;
        todosImpostos = todosImpostos.concat(impostosCofins, impostoPis, impostosInss, impostosIrpjCsll);
        //Caso não seja nenhum dos impostos infornmados o Tipo de Apuração e de impostos Gerais;
        if (!simplesNacionalIsSelected(tipoApurac)) return todosImpostos.indexOf(cdimposto) == -1;else return false;
    };

    /*
    * Função para verificar se um imposto é INSS. Utiliza o imposto
    * filtrado, caso nenhum parâmetro seja passado.
    */
    var inssIsSelected = function inssIsSelected(cdimposto) {
        cdimposto = cdimposto || filteredData.CDIMPOSTO;
        return impostosInss.indexOf(cdimposto) !== -1;
    };

    /*
     * Função para verificar se um imposto é INSS. Utiliza o imposto
     * filtrado, caso nenhum parâmetro seja passado.
     */
    var icmsStIsSelected = function icmsStIsSelected(cdimposto) {
        cdimposto = cdimposto || filteredData.CDIMPOSTO;
        return cdimposto === impostoIcmsSt;
    };

    /*
        Função para alterar a visibilidade da widget 
        recebendo um array com os nomes das widgets e a visibilidade desejada
    */
    var visibilidadeWidget = function visibilidadeWidget(widgets, visibilidade) {
        widgets.forEach(function (widget) {
            templateManager.container.getWidget(widget).isVisible = visibilidade;
        });
    };

    /*
        Função para alterar a visibilidade da filds 
        recebendo um array com os nomes dos fields e a visibilidade desejada
    */
    var visibilidadeField = function visibilidadeField(widget, fields, visibilidade) {
        fields.forEach(function (field) {
            widget.getField(field).isVisible = visibilidade;
        });
    };

    this.bloqueiaCampos = function (widget, campoExecao, status) {
        widget.fields.forEach(function (field) {
            if (field.name.indexOf(campoExecao) !== -1) field.readOnly = !status;else field.readOnly = status;
        });
    };

    /*
        Recarrega uma widget para atualizar os dados, exceto se estiver abrindo um
        swipe para adicionar um novo registro
    */
    this.recarregarWidget = function (nomeWidget) {
        var widget = templateManager.container.getWidget(nomeWidget);
        if (!widget.currentRow.__is_new) {
            widget.reload();
        }
        //QUAL WID?
        if (filteredData.SGESTADO == 'RS') {
            widget.actions.forEach(function (action) {
                if (action.name == 'GERA_GIA_RS') {
                    action.isVisible = true;
                }
            });
        } else {
            widget.actions.forEach(function (action) {
                if (action.name == 'GERA_GIA_RS') {
                    action.isVisible = false;
                }
            });
        }
    };

    this.setCurrentRow = function (widget, nomesWidget) {
        nomesWidget.forEach(function (nome) {
            templateManager.container.getWidget(nome).currentRow = widget.currentRow;
        });
    };

    self.openGeraGiaRs = function () {
        var widgetGiaRs = templateManager.container.getWidget('widgetGeraGiaRs');
        ScreenService.openPopup(widgetGiaRs);
        widgetGiaRs.activate();
    };

    self.geraGiaRs = function (widget) {
        if (widget.isValid()) {
            //GERA_INFADIC_GIA_RS(:P_NRSEQUMAPAPU, :P_CDLIVROMAG, :P_NREMPREGADOS, :P_VRFOLHA, :P_INSCRCENTRAL, :P_ATODECLARA);
            //var row = widget.getParent().currentRow;
            widget.currentRow.NRSEQUMAPAPU = widget.getParent().getParent().currentRow.NRSEQUMAPAPU;
            General.callRestEngine('fis_apuracoes#/geraGiaRs', 'Row', widget.currentRow).then(function (success) {
                ScreenService.closePopup();
                templateManager.container.getWidget('widgetInformacoesAdicionais').reload();
                ScreenService.closePopup();
            }, function (error) {
                ScreenService.showMessage(error.data.error);
            });
        }
    };

    self.controlaAtoDecl = function (widget) {
        if (widget.currentRow.INSCRCENTRAL == 'N') {
            widget.getField('ATODECLARA').readOnly = true;
        } else if (widget.currentRow.INSCRCENTRAL == 'S') {
            widget.getField('ATODECLARA').readOnly = false;
        }
        widget.getField('ATODECLARA').reload();
    };

    /*
     * Função para alterar a habilitação da widget de Ajuste de Contribuição
     * conforme apuração do mapa.
     */
    var habilitaAjusteContribuicao = function habilitaAjusteContribuicao(widget) {
        var widgetAjuste = templateManager.container.getWidget('ajusteContribuicao');
        var idbloqmapapu = widget.currentRow.IDBLOQMAPAPU;
        // Verifica se o mapa está apurado ou bloqueado.
        var enabled = idbloqmapapu == "A" || idbloqmapapu == "S";
        widgetAjuste.enabled = enabled;
    };

    /*
     * Função para alterar a visibilidade de campos da widget de Ajuste de Contribuição
     * conforme o tipo de ajuste selecionado.
     */
    self.onChangeTipoAjuste = function () {
        var widget = templateManager.container.getWidget('ajusteContribuicao');
        var tipoAjuste = widget.currentRow.IDINDICAJUSTE;
        // Verifica se qual o tipo de ajuste selecionado
        if (tipoAjuste == 'C') {
            widget.currentRow.IDCUMUPISCOFIL = "S";

            widget.getField('CDTPCREDPICOITE').validations = { "required": { "message": "Campo obrigatório" } };
            widget.getField('CDAJUSTE').validations = { "required": { "message": "Campo obrigatório" } };

            widget.getField('CDSITUTRIBITNFE').validations = {};
            widget.getField('CDCONTCTBL').validations = {};
            widget.getField('NMFILIAL').validations = {};
            widget.getField('CDAJUSTEBC').validations = {};
            widget.getField('VRBASECALCAJ').validations = {};
            widget.getField('NRRECIBO').validations = {};

            widget.getField('CDTPCREDPICOITE').readOnly = false;
            widget.getField('CDAJUSTE').readOnly = false;
            widget.getField('IDAPROPRIACAO').readOnly = false;
            widget.getField('CDSITUTRIBITNFE').readOnly = true;
            widget.getField('CDCONTCTBL').readOnly = true;
            widget.getField('NMFILIAL').readOnly = true;
            widget.getField('CDAJUSTEBC').readOnly = true;
            widget.getField('VRBASECALCAJ').readOnly = true;
            widget.getField('NRRECIBO').readOnly = true;
            widget.getField('IDCUMUPISCOFIL').readOnly = true;
        } else if (tipoAjuste == 'DI') {

            widget.getField('CDSITUTRIBITNFE').validations = { "required": { "message": "Campo obrigatório" } };
            widget.getField('CDAJUSTE').validations = { "required": { "message": "Campo obrigatório" } };

            widget.getField('CDTPCREDPICOITE').validations = {};
            widget.getField('CDCONTCTBL').validations = {};
            widget.getField('NMFILIAL').validations = {};
            widget.getField('CDAJUSTEBC').validations = {};
            widget.getField('VRBASECALCAJ').validations = {};
            widget.getField('NRRECIBO').validations = {};

            widget.getField('CDSITUTRIBITNFE').readOnly = false;
            widget.getField('CDAJUSTE').readOnly = false;
            widget.getField('IDCUMUPISCOFIL').readOnly = false;
            widget.getField('IDAPROPRIACAO').readOnly = false;
            widget.getField('CDTPCREDPICOITE').readOnly = true;
            widget.getField('CDCONTCTBL').readOnly = true;
            widget.getField('NMFILIAL').readOnly = true;
            widget.getField('CDAJUSTEBC').readOnly = true;
            widget.getField('VRBASECALCAJ').readOnly = true;
            widget.getField('NRRECIBO').readOnly = true;
        } else if (tipoAjuste == 'DB') {

            widget.getField('CDSITUTRIBITNFE').validations = { "required": { "message": "Campo obrigatório" } };
            widget.getField('CDCONTCTBL').validations = { "required": { "message": "Campo obrigatório" } };
            widget.getField('NMFILIAL').validations = { "required": { "message": "Campo obrigatório" } };
            widget.getField('CDAJUSTEBC').validations = { "required": { "message": "Campo obrigatório" } };
            widget.getField('VRBASECALCAJ').validations = { "required": { "message": "Campo obrigatório" } };
            widget.getField('NRRECIBO').validations = { "required": { "message": "Campo obrigatório" } };

            widget.getField('CDAJUSTE').validations = {};
            widget.getField('CDSITUTRIBITNFE').validations = {};
            widget.getField('CDTPCREDPICOITE').validations = {};

            widget.getField('CDSITUTRIBITNFE').readOnly = false;
            widget.getField('CDCONTCTBL').readOnly = false;
            widget.getField('NMFILIAL').readOnly = false;
            widget.getField('CDAJUSTEBC').readOnly = false;
            widget.getField('VRBASECALCAJ').readOnly = false;
            widget.getField('IDAPROPRIACAO').readOnly = false;
            widget.getField('NRRECIBO').readOnly = false;
            widget.getField('IDCUMUPISCOFIL').readOnly = false;
            widget.getField('CDAJUSTE').readOnly = true;
            widget.getField('CDSITUTRIBITNFE').readOnly = true;
            widget.getField('CDTPCREDPICOITE').readOnly = true;
        }
    };

    /*
     * Função que calcula automaticamente o valor do ajuste 
     * conforme o Valor Base de Cálculo. 
     */
    self.onChangeVlrBaseCalculo = function () {
        var widgetAjusteContibuicao = templateManager.container.getWidget('ajusteContribuicao');
        var regime = widgetAjusteContibuicao.currentRow.IDCUMUPISCOFIL;
        var imposto = General.getFieldValue('CDIMPOSTO', 'apuracao_de_imposto');
        var aliquota;

        if (widgetAjusteContibuicao.currentRow.VRBASECALCAJ && regime) {
            //PIS e Regime Cumulativo
            if (imposto == "50" && regime == "N") aliquota = 1.65;

            //PIS e Regime Não Cumulativo
            else if (imposto == "50" && regime == "S") aliquota = 0.65;

                //COFINS e Regime Cumulativo
                else if (imposto == "60" && regime == "N") aliquota = 7.6;

                    //COFINS e Regime Não Cumulativo
                    else if (imposto == "60" && regime == "S") aliquota = 3;

            widgetAjusteContibuicao.currentRow.VRAJUSTE = widgetAjusteContibuicao.currentRow.VRBASECALCAJ * aliquota / 100;
            widgetAjusteContibuicao.reload();
        }
    };

    /*
     * Função que aplica o readOnly padrão nos campos.
     */
    self.aplicaReadOnly = function () {
        var widgetAjusteContibuicao = templateManager.container.getWidget('ajusteContribuicao');
        widgetAjusteContibuicao.fields.forEach(function (field) {
            if (field.name != "IDINDICAJUSTE" && field.name != "IDTPAJUSTE" && field.name != "IDCUMUPISCOFIL" && field.name != "VRAJUSTE" && field.name != "NRPROCESSO" && field.name != "DSAJUSTE" && field.name != "DTAJUSTE") field.readOnly = true;else field.readOnly = false;
        });
    };

    /*
     * Função salva o Ajuste de Contribuição
     */
    self.salvar = function () {
        var widgetAjusteContibuicao = templateManager.container.getWidget('ajusteContribuicao');
        if (widgetAjusteContibuicao.isValid()) widgetAjusteContibuicao.currentRow.NRSEQUMAPAPU = General.getFieldValue('NRSEQUMAPAPU', 'apuracao_de_imposto');
        if (widgetAjusteContibuicao.currentRow.__is_new) {
            General.callRestEngine('fis#/crud/ajusteapurcontr_max', 'FilterData').then(function (result) {
                var ajusteapurcontr = result.dataset.ajusteapurcontr_max[0];

                if (result.dataset.ajusteapurcontr_max.length > 0) {
                    var nrseqajuste = ('000000000' + (parseInt(ajusteapurcontr.NRSEQAJUSTE) + 1)).slice(-10);
                    widgetAjusteContibuicao.currentRow.NRSEQAJUSTE = nrseqajuste;
                } else widgetAjusteContibuicao.currentRow.NRSEQAJUSTE = "0000000001";

                General.saveCrud(widgetAjusteContibuicao).then(function (result) {
                    ScreenService.showMessage("Ajuste salvo com sucesso!");
                });
            }).catch(function (erro) {
                ScreenService.showMessage(erro.data.error);
            });
        } else {
            General.saveCrud(widgetAjusteContibuicao).then(function (result) {
                ScreenService.showMessage("Ajuste salvo com sucesso!");
            });
        }
    };

    /*
     * Função que limpa o conteúdo dos campos,
     * conforme o onChange do campo Tipo de Ajuste.
     */
    self.limpaCamposAjusteContribuicao = function (widget) {
        var currentrow = widget.currentRow;
        currentrow.CDSITUTRIBITNFE = "";
        currentrow.CDTPCREDPICOITE = "";
        currentrow.VRBASECALCAJ = "";
        currentrow.CDAJUSTEBC = "";
        currentrow.CDCONTCTBL = "";
        currentrow.NMFILIAL = "";
        currentrow.NRRECIBO = "";
        currentrow.CDAJUSTE = "";
    };

    /*
     * Função que altera a visibilidade da aba de Detalhamento - Competência,
     * conforme o campo IDFORMAPUREMPR da empresa selecionada.
     */
    self.alteraVisibilidadeDetalhamento = function () {
        var widgetFiltro = templateManager.container.getActiveWidget();
        var widgetDetalhamento = templateManager.container.getWidget("contribuicoesDetalhamento");
        var widgetDetalhamentoCompetencia = templateManager.container.getWidget("contribuicoesDetalhamentoCompetencia");
        var widgetDetalhamentoIrpjCsll = templateManager.container.getWidget("detalhamentoIrpjCsllLucroRealTrimestral");
        var detalhamentoIrpjCsllLucroPresumidoCompet = templateManager.container.getWidget("detalhamentoIrpjCsllLucroPresumidoCompet");
        var detalhamentoIrpjCsllLucroPresumidoPag = templateManager.container.getWidget("detalhamentoIrpjCsllLucroPresumidoPag");
        var detalhamentoIrpjCsllLucroRealMensal = templateManager.container.getWidget("detalhamentoIrpjCsllLucroRealMensal");
        var cdimposto = widgetFiltro.currentRow.CDIMPOSTO;
        var filter = [];

        this.alteraVisibilidadeRateio();

        if (contribuicoesIsSelected(cdimposto)) {
            if (widgetFiltro.currentRow.IDFORMAPUREMPR == "P") {
                widgetDetalhamento.label = "Detalhamento - Pagamento";
                widgetDetalhamentoCompetencia.isVisible = true;
            } else {
                filter = [{
                    "name": "CDIMPOSTO",
                    "operator": "=",
                    "value": cdimposto
                }];
                General.callRestEngine('fis#/crud/imposto', 'FilterData', filter).then(function (result) {
                    result = result.dataset.imposto[0];
                    if (result.IDFORMAPUR == "P") {
                        widgetDetalhamento.label = "Detalhamento - Pagamento";
                        widgetDetalhamentoCompetencia.isVisible = true;
                    } else {
                        widgetDetalhamento.label = "Detalhamento";
                        widgetDetalhamentoCompetencia.isVisible = false;
                    }
                });
            }
        } else {
            widgetDetalhamento.label = "Detalhamento";
            widgetDetalhamentoCompetencia.isVisible = false;
        }

        if (irpjCsllIsSelected(cdimposto)) {
            self.toggleAliquotaDetalhamentoIrpjCsll(cdimposto, widgetDetalhamentoIrpjCsll);
            self.toggleAliquotaDetalhamentoIrpjCsll(cdimposto, detalhamentoIrpjCsllLucroPresumidoCompet);
            self.toggleAliquotaDetalhamentoIrpjCsll(cdimposto, detalhamentoIrpjCsllLucroPresumidoPag);
            self.toggleAliquotaDetalhamentoIrpjCsll(cdimposto, detalhamentoIrpjCsllLucroRealMensal);
            filter = [{
                "name": "CDEMPRESA",
                "operator": "=",
                "value": widgetFiltro.currentRow.CDEMPRESA
            }];
            General.callRestEngine('fis#/crud/empresa', 'FilterData', filter).then(function (result) {
                result = result.dataset.empresa[0];
                switch (result.IDFORMAPUR) {
                    case 'LRT':
                        widgetDetalhamentoIrpjCsll.isVisible = true;
                        widgetDetalhamentoIrpjCsll.activate();
                        detalhamentoIrpjCsllLucroPresumidoCompet.isVisible = false;
                        detalhamentoIrpjCsllLucroPresumidoPag.isVisible = false;
                        detalhamentoIrpjCsllLucroRealMensal.isVisible = false;
                        break;

                    case 'LRM':
                        widgetDetalhamentoIrpjCsll.isVisible = false;
                        detalhamentoIrpjCsllLucroPresumidoCompet.isVisible = false;
                        detalhamentoIrpjCsllLucroPresumidoPag.isVisible = false;
                        detalhamentoIrpjCsllLucroRealMensal.isVisible = true;
                        detalhamentoIrpjCsllLucroRealMensal.activate();
                        break;

                    case 'LPM':
                    case 'LPT':
                        widgetDetalhamentoIrpjCsll.isVisible = false;
                        detalhamentoIrpjCsllLucroPresumidoCompet.isVisible = true;
                        detalhamentoIrpjCsllLucroPresumidoCompet.activate();
                        detalhamentoIrpjCsllLucroPresumidoPag.isVisible = true;
                        detalhamentoIrpjCsllLucroRealMensal.isVisible = false;
                        break;
                }
            }).catch(function (erro) {
                ScreenService.showMessage(erro.data.error);
            });
        }
    };

    /*
     * Altera visibilidade dos campos de mapeamento de rateio seguindo IDCONTCTBL da PARAMFISCAL
     */
    self.alteraVisibilidadeRateio = function () {
        var nomesWidgetDetalhamento = ['detalhamentoGeral', 'widgetItensDetalhamentoIcmsSt', 'widgetItensDetalhamento', 'widgetDetalhamentoIcmsDifal', 'widgetItensDetalhamentoDifalFcp'];
        var nomesCamposMapeamento = ["CDLOTE", "CDCONTRATEIO"];
        var nomesGruposMapeamento = ["integracao_cont"];

        General.callRestEngine('fis#/crud/paramfiscal', 'FilterData', []).then(function (result) {
            result = result.dataset.paramfiscal[0] ? result.dataset.paramfiscal[0] : [];
            var camposVisiveis = result.IDCONTCTBL == 'S';
            nomesWidgetDetalhamento.forEach(function (nomeWidget) {
                var widgetDetalhamentoAtual = templateManager.container.getWidget(nomeWidget);
                nomesCamposMapeamento.forEach(function (nomeCampo) {
                    var campoMapeamentoAtual = widgetDetalhamentoAtual.getField(nomeCampo) || {};
                    campoMapeamentoAtual.isVisible = camposVisiveis;
                });
                // nomesGruposMapeamento.forEach(function(nomeGrupo){
                //     var grupoMapeamentoAtual = widgetDetalhamentoAtual.getField(nomeGrupo);
                //     grupoMapeamentoAtual.isVisible = camposVisiveis;
                // });
            });
        });
    };

    self.activeIsvisibleWidget = function (widgets) {
        var widget = widgets.filter(function (widget) {
            if (widget.isVisible == true) {
                return widget;
            }
        })[0];

        widget.activate();
    };

    self.editDetalhamentoLRM = function (widget) {
        General.edit(widget);
        widget.fields.forEach(function (field) {
            if (field.template == "field/label-with-icon.html") {
                field.isVisible = false;
            }
        });
    };

    self.cancelDetalhamentoLRM = function (args) {
        var widget = args.owner.widget;

        General.backOrCancel(args);
        widget.fields.forEach(function (field) {
            if (field.template == "field/label-with-icon.html") {
                field.isVisible = true;
            }
        });
    };

    self.saveDetalhamentoLRM = function (widget) {
        widget.fields.forEach(function (field) {
            if (field.template == "field/label-with-icon.html") {
                field.isVisible = true;
            }
        });
        widget.view();
        this.changeBalanceteVisibility(widget);
    };

    self.changeBalanceteVisibility = function (widget) {
        if (Object.keys(widget.currentRow).length == 0) {
            widget.currentRow = widget.dataSource.data[0];
        }
        if (!widget.currentRow.IDBALANCETE) {
            widget.currentRow.IDBALANCETE = "N";
        }

        if (widget.currentRow.IDBALANCETE == "S") {
            widget.fieldGroups.forEach(function (group) {
                if (group.name == "balancete") {
                    group.isVisible = true;
                }
            });
            widget.actions.forEach(function (action) {
                if (action.name == "gerarBalancete") {
                    action.isVisible = true;
                }
            });
        } else if (widget.currentRow.IDBALANCETE == "N") {
            widget.fieldGroups.forEach(function (group) {
                if (group.name == "balancete") {
                    group.isVisible = false;
                }
            });
            widget.actions.forEach(function (action) {
                if (action.name == "gerarBalancete") {
                    action.isVisible = false;
                }
            });
        }
        widget.redraw();
    };

    self.gerarBalancete = function () {};

    /**
     * Seta Data Souce Stripe
     * @param widget
     */
    self.setStripeData = function (widget) {
        var currentRow = widget.appliedFilter.FILTER_ROW;
        var stripeWidget = templateManager.container.getWidget("stripe");

        stripeWidget.currentRow = {};

        if (currentRow.IDTIPOAPURA == 'F') {
            stripeWidget.fields.forEach(function (field) {
                if (field.name != "DSIMPOSTONFE" && field.name != "NMEMPRESA") field.isVisible = false;else field.isVisible = true;
            });
            stripeWidget.currentRow.DSIMPOSTONFE = currentRow.DSIMPOSTONFE;
        } else if (currentRow.IDTIPOAPURA == 'E') {
            stripeWidget.fields.forEach(function (field) {
                if (field.name != "DSIMPOSTONFE" && field.name != "NMEMPRESA" && field.name != "CDINSCESTA") field.isVisible = false;else field.isVisible = true;
            });
            stripeWidget.currentRow.DSIMPOSTONFE = currentRow.DSIMPOSTONFE;
            stripeWidget.currentRow.CDINSCESTA = currentRow.CDINSCESTA;
        } else if (currentRow.IDTIPOAPURA == 'M') {
            stripeWidget.fields.forEach(function (field) {
                if (field.name != "DSIMPOSTONFE" && field.name != "NMEMPRESA" && field.name != "CDINSCMUNI") field.isVisible = false;else field.isVisible = true;
            });
            stripeWidget.currentRow.DSIMPOSTONFE = currentRow.DSIMPOSTONFE;
            stripeWidget.currentRow.CDINSCMUNI = currentRow.CDINSCMUNI;
        } else if (currentRow.IDTIPOAPURA == 'S') {
            stripeWidget.fields.forEach(function (field) {
                if (field.name != "NMEMPRESA") field.isVisible = false;else field.isVisible = true;
            });
        }
        stripeWidget.currentRow.NMEMPRESA = currentRow.CDEMPRESA + ' - ' + currentRow.NMEMPRESA;
    };

    /*
     * Função para fechar as widgets de itens do detalhamento - competência de um mapa de
     * Contribuições, retornando ao próprio detalhamento.
     */
    this.closeDetalhamentoContribuicoesCompetenciaWidgets = function () {
        ScreenService.closeSwipe().then(function () {
            var detalhamentoCompetenciaWidget = templateManager.container.getWidget("contribuicoesDetalhamentoCompetencia");
            detalhamentoCompetenciaWidget.activate();
            detalhamentoCompetenciaWidget.view();
        });
    };

    /*
     * Função para verificar se um imposto é IRPJ/CSLL. Utiliza o imposto
     * filtrado, caso nenhum parâmetro seja passado.
     */
    var irpjCsllIsSelected = function irpjCsllIsSelected(cdimposto) {
        cdimposto = cdimposto || filteredData.CDIMPOSTO;
        return impostosIrpjCsll.indexOf(cdimposto) !== -1;
    };

    /*
     * Função para habilitar os campos de Cálculo do Valor Adicional
     * de acordo com o imposto da tela.
     */
    this.toggleVrAdicional = function (widget) {
        // Se o imposto for CSLL, desabilita os campos do fieldGroup de Cálculo Valor Adicional
        var bool = templateManager.container.getWidget("apuracao_de_imposto").appliedFilter.FILTER_ROW.CDIMPOSTO == impostosIrpjCsll[1];
        widget.fields.forEach(function (field) {
            if (field.fieldGroup == "vlradicional") {
                field.isVisible = !bool;
            }
            if (field.name == "VRADICIONALPRES") {
                field.isVisible = !bool;
            }
            if (field.name == "VRADICIONALPRESPAG") {
                field.isVisible = !bool;
            }
            if (field.name == "VRADICIONALREAL") {
                field.isVisible = !bool;
            }
            if (field.name == "VRADICIONAL") {
                field.isVisible = !bool;
            }
        });
    };

    /*
     * Função para que aplica o resultado do dataSource 
     * na currentRow da widget informada.
     */
    this.aplicaFiltroWidget = function (widget) {
        widget.currentRow = widget.dataSource.data[0];
    };

    /*
     *   Função que controla as abas de Lucro Real Trimestral IRPJ/CSLL.
     */
    this.openDetalhamentoLucroRealTrimestral = function (field) {
        var tabbedDetalhamentoLucro = templateManager.container.getWidget('calculosDetalhamentoLucroTabbed');
        var cdempresa = templateManager.container.getWidget('apuracao_de_imposto').currentRow.CDEMPRESA;
        var widgetItensDetalhamento = tabbedDetalhamentoLucro.widgets[0];
        var idformapur = self.buscaApuracaoDataDePagamentoEmpresa(cdempresa) ? "P" : "C";

        widgetItensDetalhamento.label = field.childWidgetLabel;

        widgetItensDetalhamento.dataSourceFilter[1].value = field.childWidgetFiltro;
        widgetItensDetalhamento.getField("IDTIPODETAPU").setValue(field.childWidgetFiltro);

        widgetItensDetalhamento.dataSourceFilter[2].value = idformapur;
        widgetItensDetalhamento.getField("IDFORMAPUR").setValue(idformapur);

        ScreenService.openSwipe(tabbedDetalhamentoLucro).then(function (success) {
            widgetItensDetalhamento.reload();
        });
    };

    /*
     *   Função que controla as abas de Lucro Presumido IRPJ/CSLL.
     */
    this.openDetalhamentoPresumido = function (field, widgetParent) {
        var tabbedDetalhamentoLucro = templateManager.container.getWidget('calculosDetalhamentoLucroTabbed');
        var widgetItensDetalhamento = tabbedDetalhamentoLucro.widgets[0];

        widgetItensDetalhamento.label = field.childWidgetLabel;

        widgetItensDetalhamento.dataSourceFilter[1].value = field.childWidgetFiltro;
        widgetItensDetalhamento.getField("IDTIPODETAPU").setValue(field.childWidgetFiltro);

        widgetItensDetalhamento.dataSourceFilter[2].value = field.idformapur;
        widgetItensDetalhamento.getField("IDFORMAPUR").setValue(field.idformapur);

        ScreenService.openSwipe(tabbedDetalhamentoLucro).then(function (success) {
            widgetItensDetalhamento.reload();
            widgetItensDetalhamento.widgetParent = widgetParent;
        });
    };

    /*
     * Função para abrir uma widget contendo detalhamentos sobre créditos ou
     * débitos em um mapa de Contribuições.
     */
    this.openDetalhamentoVrfatbrutopresuWidget = function (field, widgetParent) {
        var childWidgetTabbed = templateManager.container.getWidget(field.childWidgetName);
        var childWidgetDetalhamento = childWidgetTabbed.widgets[0];

        childWidgetDetalhamento.dataSourceFilter[1].value = field.idformapuritem;
        childWidgetDetalhamento.reload().then(function (success) {
            ScreenService.openSwipe(childWidgetTabbed);
            childWidgetDetalhamento.moveToFirst();
            childWidgetDetalhamento.view();
            childWidgetDetalhamento.widgetParent = widgetParent;
        });
    };

    this.gerarBalancete = function (widget) {
        var widgetBalanceteTabbed = widget.widgets[2];
        var widgetBalancete = widgetBalanceteTabbed.widgets[0];

        widgetBalancete.reload().then(function () {
            ScreenService.closePopup();
            ScreenService.openSwipe(widgetBalanceteTabbed);
            widgetBalancete.activate();
        });
        widgetBalancete.widgetParent = widget.name;
    };

    /*
     *   Função que controla as abas de Lucro Presumido IRPJ/CSLL.
     */
    this.openWidgetBalanceteCalc = function (field, widget, widgetParent) {
        var widgetItensDetalhamentoTabbed = templateManager.container.getWidget('calculosWidgetBalanceteTabbed');
        var widgetItensDetalhamento = widgetItensDetalhamentoTabbed.widgets[0];

        widgetItensDetalhamento.label = field.childWidgetLabel;

        widgetItensDetalhamento.dataSourceFilter[1].value = field.childWidgetFiltro;
        widgetItensDetalhamento.getField("IDTIPODETAPUIRPJ").setValue(field.childWidgetFiltro);

        ScreenService.openSwipe(widgetItensDetalhamentoTabbed).then(function (success) {
            widgetItensDetalhamento.activate();
            widgetItensDetalhamento.reload();
        });
        widgetItensDetalhamento.widgetParent = widgetParent;
    };

    this.closeWidgetBalanceteCalc = function (widget) {
        var detalhamentoWidget = templateManager.container.getWidget(widget.widgetParent);
        ScreenService.closeSwipe().then(function () {
            detalhamentoWidget.activate();
            //detalhamentoWidget.view();
        });
    };

    /*
     * Função booleana que retorna verdadeiro caso a empresa informada apure por 
     *  Data de Pagamento e falso, caso contrário. 
     */
    self.buscaApuracaoDataDePagamentoEmpresa = function (widget) {
        var widgetFiltro = templateManager.container.getActiveWidget();
        var filter = [{
            "name": "CDEMPRESA",
            "operator": "=",
            "value": widgetFiltro.currentRow.CDEMPRESA
        }];
        General.callRestEngine('fis#/crud/empresa', 'FilterData', filter).then(function (result) {
            result = result.dataset.empresa[0];

            if (result.IDFORMAPUREMPR == "P") return true;else return false;
        }).catch(function (erro) {
            ScreenService.showMessage(erro.data.error);
        }.bind(this));
    };

    /*
     * Função que retorna a forma de apuração de uma empresa.
     */
    self.buscaFormaDeApuraçaoEmpresa = function (widget) {
        var cdempresa = widget.currentRow.CDEMPRESA;
        var filter = [{
            "name": "CDEMPRESA",
            "operator": "=",
            "value": cdempresa
        }];
        General.callRestEngine('fis#/crud/empresa', 'FilterData', filter).then(function (result) {
            result = result.dataset.empresa[0];
            return result.IDFORMAPUR;
        }).catch(function (erro) {
            ScreenService.showMessage(erro.data.error);
        });
    };

    /*
     * Função para adicionar um item no Detalhamento IRPJ/CSLL.
     */
    this.adicionarItemDetalhamentoIrpjCsll = function (calculosDetalhamentoLucroWidget) {
        var widgetApuracao = templateManager.container.getWidget('apuracao_de_imposto');
        calculosDetalhamentoLucroWidget.newRow();
        calculosDetalhamentoLucroWidget.currentRow.NRSEQUMAPAPU = widgetApuracao.currentRow.NRSEQUMAPAPU;
        calculosDetalhamentoLucroWidget.currentRow.IDTIPODETAPU = calculosDetalhamentoLucroWidget.dataSourceFilter[1].value;
        calculosDetalhamentoLucroWidget.currentRow.IDFORMAPUR = calculosDetalhamentoLucroWidget.dataSourceFilter[2].value;
        calculosDetalhamentoLucroWidget.currentRow.IDITDETAMANUAL = "S";
    };

    /*
     * Função para salvar um item no Detalhamento IRPJ/CSLL.
     */
    this.saveItemDetalhamentoIrpjCsll = function (widget) {
        General.saveCrud(widget).then(function () {
            var tipoapurac = widget.dataSourceFilter[1].value;
            var widgetLucroReal = templateManager.container.getWidget(widget.widgetParent);
            var widgetApuracao = templateManager.container.getWidget("apuracao_de_imposto");
            if (widgetApuracao.appliedFilter.FILTER_ROW.IDFORMAPUR == 'LRT') {
                if (tipoapurac == "AD") {
                    widgetLucroReal.currentRow.VRADICREAL = parseFloat(widgetLucroReal.currentRow.VRADICREAL) + parseFloat(widget.currentRow.VRITEMDETAPU);
                } else if (tipoapurac == "EX") {
                    widgetLucroReal.currentRow.VREXCLREAL = parseFloat(widgetLucroReal.currentRow.VREXCLREAL) + parseFloat(widget.currentRow.VRITEMDETAPU);
                } else if (tipoapurac == "DE") {
                    widgetLucroReal.currentRow.VRDEDUCAOREAL = parseFloat(widgetLucroReal.currentRow.VRDEDUCAOREAL) + parseFloat(widget.currentRow.VRITEMDETAPU);
                }
            } else {
                if (widget.currentRow.IDFORMAPUR === 'C') {
                    if (tipoapurac == "AD") {
                        widgetLucroReal.currentRow.VRADICPRESU = parseFloat(widgetLucroReal.currentRow.VRADICPRESU) + parseFloat(widget.currentRow.VRITEMDETAPU);
                    } else if (tipoapurac == "EX") {
                        widgetLucroReal.currentRow.VREXCLPRESU = parseFloat(widgetLucroReal.currentRow.VREXCLPRESU) + parseFloat(widget.currentRow.VRITEMDETAPU);
                    } else if (tipoapurac == "DE") {
                        widgetLucroReal.currentRow.VRDEDUCAOPRESU = parseFloat(widgetLucroReal.currentRow.VRDEDUCAOPRESU) + parseFloat(widget.currentRow.VRITEMDETAPU);
                    }
                } else if (widget.currentRow.IDFORMAPUR === 'P') {
                    if (tipoapurac == "AD") {
                        widgetLucroReal.currentRow.VRADICPRESUPAG = parseFloat(widgetLucroReal.currentRow.VRADICPRESUPAG) + parseFloat(widget.currentRow.VRITEMDETAPU);
                    } else if (tipoapurac == "EX") {
                        widgetLucroReal.currentRow.VREXCLPRESUPAG = parseFloat(widgetLucroReal.currentRow.VREXCLPRESUPAG) + parseFloat(widget.currentRow.VRITEMDETAPU);
                    } else if (tipoapurac == "DE") {
                        widgetLucroReal.currentRow.VRDEDUCAOPRESUPAG = parseFloat(widgetLucroReal.currentRow.VRDEDUCAOPRESUPAG) + parseFloat(widget.currentRow.VRITEMDETAPU);
                    }
                }
            }
            // Chama função que recalcula os valores da aba de detalhamento do IRPJ/CSLL 
            self.calculaDetalhamentoLucroTrimestral(widgetLucroReal, widgetApuracao.currentRow.CDIMPOSTO);
            if (widgetApuracao.currentRow.CDIMPOSTO == impostosIrpjCsll[0]) {
                self.calculaDetalhamentoLucroTrimestralValorAdicional(widgetLucroReal);
            }
            General.saveCrud(widgetLucroReal).then(function () {
                widget.activate();
            });
        });
    };

    /*
     * Função para deletar um item no Detalhamento IRPJ/CSLL.
     */
    this.deleteItemDetalhamentoIrpjCsll = function (widget) {
        General.deleteCrud(widget).then(function () {
            var tipoapurac = widget.dataSourceFilter[1].value;
            var widgetLucroReal = templateManager.container.getWidget(widget.widgetParent);
            var widgetApuracao = templateManager.container.getWidget("apuracao_de_imposto");

            if (widgetApuracao.appliedFilter.FILTER_ROW.IDFORMAPUR == 'LRT') {
                if (tipoapurac == "AD") {
                    widgetLucroReal.currentRow.VRADICREAL = parseFloat(widgetLucroReal.currentRow.VRADICREAL) - parseFloat(widget.currentRow.VRITEMDETAPU);
                } else if (tipoapurac == "EX") {
                    widgetLucroReal.currentRow.VREXCLREAL = parseFloat(widgetLucroReal.currentRow.VREXCLREAL) - parseFloat(widget.currentRow.VRITEMDETAPU);
                } else if (tipoapurac == "DE") {
                    widgetLucroReal.currentRow.VRDEDUCAOREAL = parseFloat(widgetLucroReal.currentRow.VRDEDUCAOREAL) - parseFloat(widget.currentRow.VRITEMDETAPU);
                }
            } else {
                if (widget.currentRow.IDFORMAPUR === 'C') {
                    if (tipoapurac == "AD") {
                        widgetLucroReal.currentRow.VRADICPRESU = parseFloat(widgetLucroReal.currentRow.VRADICPRESU) - parseFloat(widget.currentRow.VRITEMDETAPU);
                    } else if (tipoapurac == "EX") {
                        widgetLucroReal.currentRow.VREXCLPRESU = parseFloat(widgetLucroReal.currentRow.VREXCLPRESU) - parseFloat(widget.currentRow.VRITEMDETAPU);
                    } else if (tipoapurac == "DE") {
                        widgetLucroReal.currentRow.VRDEDUCAOPRESU = parseFloat(widgetLucroReal.currentRow.VRDEDUCAOPRESU) - parseFloat(widget.currentRow.VRITEMDETAPU);
                    }
                } else if (widget.currentRow.IDFORMAPUR === 'P') {
                    if (tipoapurac == "AD") {
                        widgetLucroReal.currentRow.VRADICPRESUPAG = parseFloat(widgetLucroReal.currentRow.VRADICPRESUPAG) - parseFloat(widget.currentRow.VRITEMDETAPU);
                    } else if (tipoapurac == "EX") {
                        widgetLucroReal.currentRow.VREXCLPRESUPAG = parseFloat(widgetLucroReal.currentRow.VREXCLPRESUPAG) - parseFloat(widget.currentRow.VRITEMDETAPU);
                    } else if (tipoapurac == "DE") {
                        widgetLucroReal.currentRow.VRDEDUCAOPRESUPAG = parseFloat(widgetLucroReal.currentRow.VRDEDUCAOPRESUPAG) - parseFloat(widget.currentRow.VRITEMDETAPU);
                    }
                }
            }
            // Chama função que recalcula os valores da aba de detalhamento do IRPJ/CSLL 
            self.calculaDetalhamentoLucroTrimestral(widgetLucroReal, widgetApuracao.currentRow.CDIMPOSTO, widgetApuracao.IDFORMAPUR);
            if (widgetApuracao.currentRow.CDIMPOSTO == impostosIrpjCsll[0]) {
                self.calculaDetalhamentoLucroTrimestralValorAdicional(widgetLucroReal);
            }
            General.saveCrud(widgetLucroReal).then(function () {
                widget.activate();
            });
        });
    };

    self.calculaDetalhamentoLucroTrimestral = function (widget, cdimposto, idformapur) {
        var aliquota = cdimposto == impostosIrpjCsll[0] ? parseFloat(widget.currentRow.VRALIQIRPJ) : parseFloat(widget.currentRow.VRALIQCSLL);
        if (idformapur == 'LRT') {
            widget.currentRow.VRLUCROLIQTOT = parseFloat(widget.currentRow.VRLUCROOPERAC) + parseFloat(widget.currentRow.VRLUCRONAOOPERAC);
            widget.currentRow.VRLUCROLIQREAL = widget.currentRow.VRLUCROLIQTOT + parseFloat(widget.currentRow.VRADICREAL) - parseFloat(widget.currentRow.VREXCLREAL);
            widget.currentRow.VRDEBLUCREAL = widget.currentRow.VRLUCROLIQREAL * (aliquota / 100);
            widget.currentRow.VRDEBLUCREALTOT = widget.currentRow.VRDEBLUCREAL + parseFloat(widget.currentRow.VRADICIONALREAL) - parseFloat(widget.currentRow.VRDEDUCAOREAL);
            widget.currentRow.VRTOTAIMPOS = widget.currentRow.VRDEBLUCREALTOT;
        } else {
            widget.currentRow.VRFATBRUTOREAL = parseFloat(widget.currentRow.VRFATBRUTOPRESU) + parseFloat(widget.currentRow.VRADICPRESU) - parseFloat(widget.currentRow.VREXCLPRESU);
            widget.currentRow.VRIMPOSAPURPRESU = widget.currentRow.VRFATBRUTOREAL * (aliquota / 100);
            widget.currentRow.VRDEBITOTPRESU = widget.currentRow.VRIMPOSAPURPRESU + parseFloat(widget.currentRow.VRADICIONALPRES) - parseFloat(widget.currentRow.VRDEDUCAOPRESU);
        }
    };

    self.calculaDetalhamentoLucroTrimestralValorAdicional = function (widget) {
        widget.currentRow.VRPARCEXCEDREAL = parseFloat(widget.currentRow.VRLUCROLIQTOT) - parseFloat(widget.currentRow.VRLIMITEADIC);
        widget.currentRow.VRADICIONALREAL = widget.currentRow.VRPARCEXCEDREAL * parseFloat(widget.currentRow.VRALIQADICIR);
    };

    /*
     * Função para alterar a visibilidade dos fields VRALIQIRPJ e VRALIQCSLL
     * conforme o imposto filtrado.
     */
    self.toggleAliquotaDetalhamentoIrpjCsll = function (cdimposto, widgetDetalhamento) {
        var bool = cdimposto == impostosIrpjCsll[0] ? true : false;
        widgetDetalhamento.getField("VRALIQIRPJ").isVisible = bool;
        widgetDetalhamento.getField("VRALIQCSLL").isVisible = !bool;
    };

    self.mudaVisibilidadeRegimeApuracao = function (widget) {
        if (widget.currentRow.IDCUMUPISCOFIL && widget.currentRow.IDCUMUPISCOFIL != "") {
            widget.getField('VRBASECALCAJ').readOnly = false;
        } else {
            widget.getField('VRBASECALCAJ').readOnly = true;
        }
        self.calculoValorAjustePorValorBase(widget);
    };

    self.calculoValorAjustePorValorBase = function (widget) {
        var cdimposto = templateManager.container.getWidget('apuracao_de_imposto').appliedFilter.FILTER_ROW.CDIMPOSTO;
        if (widget.currentRow.VRBASECALCAJ && widget.currentRow.VRBASECALCAJ != "") {
            if (widget.currentRow.IDCUMUPISCOFIL == 'N') {
                if (cdimposto == '50') {
                    widget.currentRow.VRAJUSTE = 0.0065 * parseFloat(widget.currentRow.VRBASECALCAJ.replace(",", "."));
                } else if (cdimposto == '60') {
                    widget.currentRow.VRAJUSTE = 0.03 * parseFloat(widget.currentRow.VRBASECALCAJ.replace(",", "."));
                }
            } else if (widget.currentRow.IDCUMUPISCOFIL == 'S') {
                if (cdimposto == '50') {
                    widget.currentRow.VRAJUSTE = 0.0165 * parseFloat(widget.currentRow.VRBASECALCAJ.replace(",", "."));
                } else if (cdimposto == '60') {
                    widget.currentRow.VRAJUSTE = 0.076 * parseFloat(widget.currentRow.VRBASECALCAJ.replace(",", "."));
                }
            }
        }
    };

    self.checkFormaApurac = function (widget) {
        var imposto = widget.currentRow.CDIMPOSTO;
        var formaApuracap = widget.currentRow.IDFORMAPUR;

        if (imposto && imposto.match(/^(25|70)$/) && formaApuracap == "I") {
            ScreenService.showMessage('Forma de Apuração da Empresa deve ser informada para o Imposto selecionado');
            widget.getField('NMEMPRESA').clearValue();
        }
    };

    self.verificaImpostoWidgetBalancete = function (widget) {
        var imposto = widget.dataSourceFilter[0].value;

        widget.fields.forEach(function (field) {
            if (field.name == "VRALIQBALCTIRPJ") {
                if (imposto == "25") {
                    field.label = "(x) Alíq. IRPJ";
                } else {
                    field.label = "(x) Alíq. CSLL";
                }
            }
        });
    };

    this.conferencia = function (args) {
        var conferencia = templateManager.container.getWidget('ConfAjusteSt');
        var imposto = args.dataSourceFilter.filter(function (filter) {
            return filter.name === 'P_IMPOSTO' || filter.name == 'CDIMPOSTO';
        });
        //bem caso não ache o field por algum motivo, não vai dar erro, mas vai mostrar o campo de conferencia na tela
        imposto = imposto.length ? imposto[0].value : 0;
        if (imposto === '80') {
            conferencia.isVisible = true;
        } else {
            conferencia.isVisible = false;
        }
    };
};
Configuration(function (ContextRegister) {
    ContextRegister.register('Fis00100_ApuracaoDeImposto_Controller', Fis00100_ApuracaoDeImposto_Controller);
});

// FILE: ./assets/modules/apuracoes/assets/js/controllers/Fis41000_Apuracao_Automatica_Controller.js
var Fis41000_Apuracao_Automatica_Controller = function Fis41000_Apuracao_Automatica_Controller(ZhFilterPreferences, ScreenService, templateManager, restEngine, General) {

    // Armazena o escopo atual.
    var self = this;
    var MESSAGE_SAVE_EDIT = 'Ao salvar a edição de uma Apuração, todos os arquivos existentes da mesma serão excluídos. Deseja realmente salvar?';

    self.openConfig = function (widget) {
        ScreenService.openWindow("fis_acessorias#fis41200_configuracao");
    };

    self.editApuracao = function (widget) {
        widget.getField('NMEMPRESA').readOnly = true;
        widget.getField('NMIMPOSTO').readOnly = true;
        widget.getField('NMEMPRESA').reload();
        widget.getField('NMIMPOSTO').reload();
        General.edit(widget);
    };

    self.filtroApuracAuto = function (widget, preference) {
        var currentRowFiltro = preference.FILTER_ROW;

        var cdempresa = currentRowFiltro.CDEMPRESA;
        var cdimposto = currentRowFiltro.CDIMPOSTO;
        var cdinscesta = currentRowFiltro.CDINSCESTA;

        /*widget.dataSourceFilter = widget.dataSourceFilter.filter(function(filter) {
            return (filter.operator !== 'LIKE_I' && (filter.name.search('VR') < 0) || filter.static == false);
        });*/

        widget.dataSourceFilter.forEach(function (filtro) {
            switch (filtro.name) {
                case 'P_CDEMPRESA':
                    filtro.value = cdempresa;
                    break;
                case 'P_CDIMPOSTO':
                    filtro.value = cdimposto;
                    break;
                case 'P_CDINSCESTA':
                    filtro.value = cdinscesta && cdinscesta != "" ? cdinscesta : null;
                    break;
            }
        });
    };

    self.empresaOnChange = function (widget) {
        if (widget.currentRow.NMEMPRESA && widget.currentRow.NMEMPRESA != '') {
            widget.getField('CDINSCESTA').dataSourceFilter[0].value = widget.currentRow.CDEMPRESA;
            widget.getField('CDINSCESTA').readOnly = false;
            widget.getField('CDINSCESTA').clearValue();
        } else {
            widget.getField('CDINSCESTA').dataSourceFilter = [];
            widget.getField('CDINSCESTA').readOnly = true;
            widget.getField('CDINSCESTA').clearValue();
        }
        widget.getField('CDINSCESTA').reload();
    };

    self.addApuracaoAutomatica = function (widget) {
        widget.getField('NMEMPRESA').readOnly = true;
        widget.getField('NMIMPOSTO').readOnly = true;
        widget.newRow();
        widget.currentRow.CDEMPRESA = widget.appliedFilter.FILTER_ROW.CDEMPRESA;
        widget.currentRow.NMEMPRESA = widget.appliedFilter.FILTER_ROW.NMEMPRESA;
        widget.currentRow.CDIMPOSTO = widget.appliedFilter.FILTER_ROW.CDIMPOSTO;
        widget.currentRow.NMIMPOSTO = widget.appliedFilter.FILTER_ROW.NMIMPOSTO;
        widget.currentRow.IDTPAPAUTO = 'T';
        widget.getField('CDINSCESTA').isVisible = false;
        widget.getField('NMGRUPINSCESTA').isVisible = false;
        widget.getField('CDINSCESTA').dataSourceFilter[0].value = widget.appliedFilter.FILTER_ROW.CDEMPRESA;
        widget.getField('NMGRUPINSCESTA').dataSourceFilter[0].value = widget.appliedFilter.FILTER_ROW.CDEMPRESA;
        if (widget.appliedFilter.FILTER_ROW.CDINSCESTA && widget.appliedFilter.FILTER_ROW.CDINSCESTA != "") {
            widget.currentRow.CDINSCESTA = widget.appliedFilter.FILTER_ROW.CDINSCESTA;
            widget.currentRow.NMREPRINSEST = widget.appliedFilter.FILTER_ROW.NMREPRINSEST;
            widget.currentRow.SGESTADO = widget.appliedFilter.FILTER_ROW.SGESTADO;
        }
    };

    self.changeTipoApura = function (widget) {
        if (widget.currentRow.IDTPAPAUTO == 'T') {
            widget.getField('CDINSCESTA').isVisible = false;
            widget.getField('NMGRUPINSCESTA').isVisible = false;
            widget.currentRow.CDINSCESTA = "";
        } else if (widget.currentRow.IDTPAPAUTO == 'L') {
            widget.getField('CDINSCESTA').isVisible = true;
            widget.getField('NMGRUPINSCESTA').isVisible = false;
            widget.getField('CDINSCESTA').clearValue();
            widget.getField('NMGRUPINSCESTA').clearValue();
        } else if (widget.currentRow.IDTPAPAUTO == 'A') {
            widget.getField('CDINSCESTA').isVisible = false;
            widget.getField('NMGRUPINSCESTA').isVisible = true;
            widget.getField('CDINSCESTA').clearValue();
            widget.getField('NMGRUPINSCESTA').clearValue();
        }
        widget.getField('CDINSCESTA').reload();
        widget.getField('NMGRUPINSCESTA').reload();
    };

    self.onMoveRowTipoApura = function (widget) {
        if (widget.currentRow.IDTPAPAUTO == 'T') {
            widget.getField('CDINSCESTA').isVisible = false;
            widget.getField('NMGRUPINSCESTA').isVisible = false;
        } else if (widget.currentRow.IDTPAPAUTO == 'L') {
            widget.getField('CDINSCESTA').isVisible = true;
            widget.getField('NMGRUPINSCESTA').isVisible = false;
        } else if (widget.currentRow.IDTPAPAUTO == 'A') {
            widget.getField('CDINSCESTA').isVisible = false;
            widget.getField('NMGRUPINSCESTA').isVisible = true;
        }
        widget.getField('CDINSCESTA').reload();
        widget.getField('NMGRUPINSCESTA').reload();
    };

    self.salvarApuracAutomatica = function (widget) {
        if (widget.currentRow.__is_new == false) {
            ScreenService.confirmMessage(ScreenService.i18n(MESSAGE_SAVE_EDIT), 'question', function (success) {
                self.saveApuracAuto(widget);
            });
        } else {
            self.saveApuracAuto(widget);
        }
    };

    self.saveApuracAuto = function (widget) {
        if (widget.isValid()) {
            var dt2 = new Date(moment(widget.currentRow.DTJOBAPURAC, 'DD/MM/YYYY HH:mm').format('MM/DD/YYYY HH:mm'));
            var dtAtual = new Date(moment().format('MM/DD/YYYY HH:mm'));

            if (dt2.getTime() > dtAtual.getTime()) {
                if (widget.currentRow.DTVDPERIODO && widget.currentRow.DTVDPERIODO != "") {
                    var dt1 = new Date(moment(widget.currentRow.DTVDPERIODO, 'DD/MM/YYYY HH:mm').format('MM/DD/YYYY HH:mm'));
                    if (dt2.getTime() > dt1.getTime() && dt1.getTime() > dtAtual.getTime()) {
                        widget.currentRow.CDOPERADOR = getLocalVar('CDOPERADOR');
                        widget.currentRow.NRORG = getLocalVar('NRORG');
                        widget.currentRow.DTINCLUSAO = moment().format('DD/MM/YYYY');

                        General.callRestEngine('fis_apuracoes#/salvarApuracAutomatica', 'Row', widget.currentRow).then(function (sucess) {
                            widget.getField('NMEMPRESA').readOnlyOnEdit = false;
                            widget.getField('NMIMPOSTO').readOnlyOnEdit = false;
                            widget.getField('NMEMPRESA').reload();
                            widget.getField('NMIMPOSTO').reload();
                            ScreenService.goBack();
                            General.changeWidgetAcessibility(widget.widgets, true);
                            ScreenService.showMessage('Apuração salva com sucesso.');
                            ScreenService.goBack();
                            widget.reload();
                        }, function (error) {
                            ScreenService.showMessage(error.dataset.error);
                        });
                    } else {
                        ScreenService.showMessage('A Data de Validade deve ser maior que a data atual, não pode ser igual a hora atual, e não pode ser maior que a Data de Apuração!');
                    }
                } else {
                    widget.currentRow.CDOPERADOR = getLocalVar('CDOPERADOR');
                    widget.currentRow.NRORG = getLocalVar('NRORG');
                    widget.currentRow.DTINCLUSAO = moment().format('DD/MM/YYYY');

                    General.callRestEngine('fis_apuracoes#/salvarApuracAutomatica', 'Row', widget.currentRow).then(function (sucess) {
                        widget.getField('NMEMPRESA').readOnlyOnEdit = false;
                        widget.getField('NMIMPOSTO').readOnlyOnEdit = false;
                        widget.getField('NMEMPRESA').reload();
                        widget.getField('NMIMPOSTO').reload();
                        ScreenService.goBack();
                        General.changeWidgetAcessibility(widget.widgets, true);
                        ScreenService.showMessage('Apuração salva com sucesso.');
                        ScreenService.goBack();
                        widget.reload();
                    }, function (error) {
                        ScreenService.showMessage(error.dataset.error);
                    });
                }
            } else {
                ScreenService.showMessage('A Data de Apuração deve ser maior que a data atual, e não pode ser igual a hora atual!');
            }
        }
    };

    self.downloadArquivo = function (spedWidget) {
        var downloadRoute;
        var fileName;
        var serviceUrl;
        General.callRestEngine('fis_acessorias#/getFileServerUrl', 'Row', { 'name': fileName }).then(function (sucess) {
            serviceUrl = sucess.dataset.sucess.fileName;
            //serviceUrl = sessionStorage.getItem('FileServerUrl');
            if (spedWidget.hasCheckedRows()) {
                var rows = spedWidget.getCheckedRows();
                rows.forEach(function (row) {
                    downloadRoute = window.serviceUrls.filter(function (x) {
                        return x.package == 'fis';
                    })[0].baseUrl + "/downloadArquivoApuracao?requestType=Row&row[NMARQUIVO]=";
                    if (row.NMPATHARQ.match('tmp')) {
                        window.open(downloadRoute + row.NMARQUIVO + '&row[NMPATHARQ]=' + row.NMPATHARQ);
                    } else {
                        downloadRoute = window.serviceUrls.filter(function (x) {
                            return x.package == 'fis';
                        })[0].baseUrl + "/downloadArquivoApuracaoFileServer?requestType=Row&row[NMARQUIVO]=";
                        var rowDownload = {
                            'NMARQUIVO': row.NMARQUIVO,
                            'PATH': serviceUrl + row.NMPATHARQ
                        };
                        window.open(downloadRoute + rowDownload.NMARQUIVO + '&row[PATH]=' + rowDownload.PATH);
                    }
                });
            } else {
                var row = spedWidget.currentRow;
                downloadRoute = window.serviceUrls.filter(function (x) {
                    return x.package == 'fis';
                })[0].baseUrl + "/downloadArquivoAgendamento?requestType=Row&row[DSARQUIVO]=";
                fileName = row.NMPATHARQ;
                if (fileName.match('tmp')) {
                    window.open(downloadRoute + row.NMARQUIVO);
                } else {
                    downloadRoute = window.serviceUrls.filter(function (x) {
                        return x.package == 'fis';
                    })[0].baseUrl + "/downloadArquivoAgendamentoFileServer?requestType=Row&row[NMARQUIVO]=";
                    var rowDownload = {
                        'NMARQUIVO': row.NMARQUIVO,
                        'PATH': serviceUrl + fileName
                    };
                    window.open(downloadRoute + rowDownload.NMARQUIVO + '&row[PATH]=' + rowDownload.PATH);
                }
            }
        });
    };

    self.deleteArquivo = function (spedWidget) {
        if (spedWidget.hasCheckedRows()) {
            var rows = spedWidget.getCheckedRows();
            General.callRestEngine('fis_apuracoes#/deleteArquivo', 'DataSet', rows).then(function (sucesso) {
                spedWidget.reload();
            }, function (error) {
                ScreenService.showMessage(error.dataset.error);
            });
        }
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis41000_Apuracao_Automatica_Controller', Fis41000_Apuracao_Automatica_Controller);
});

// FILE: ./assets/modules/guias/assets/js/controllers/Fis00200_DocumentoDeArrecadacao_Controller.js
var Fis00200_DocumentoDeArrecadacao_Controller = function Fis00200_DocumentoDeArrecadacao_Controller(ScreenService, templateManager, Messages_fiscal, General, Fis00200_DocumentoDeArrecadacao_Service, ZhFilterPreferences) {

    var self = this;

    this.service = Fis00200_DocumentoDeArrecadacao_Service;

    var showGuiaRj = false; //usada nas funções verificaEstadoEmissao e salvarEdicaoGuia

    // Variável que armazenam os valores inseridos do filtro.
    var filteredData = {};

    /*#############################################################
    #                                                             #
    #                   Funções do Filtro                         #
    #                                                             #
    #############################################################*/

    /*
        Abertura do filtro da tela de Documento de Arrecação com o padrão
        novo de implementação.
    */
    this.abreFiltroDocArrecadacao = function (widget) {
        ZhFilterPreferences.setOriginalFilter(widget.id);
        ZhFilterPreferences.openFilterWidget(widget);
    };

    /*
        Caso o estado da emissão da guia seja o RJ, existe um processo de 
        tranimissão e consulta. Então realizar o controle da tela para
        exibit os elementos necessários.
    */
    this.verificaEstadoEmissao = function () {
        var widget = templateManager.container.getWidget('widgetDocumentos');

        showGuiaRj = filteredData.IDORGARRECADNFE == 'E' && (filteredData.OPCGUIA == 'G' ? filteredData.UFFAVORECIDO : filteredData.SGESTADO) == 'RJ';

        var receita = widget.getField('CDRECEITA');
        var natureza = widget.getField('CDNATUREZA');

        /*
            IMPORTANTE - POR ENQUANTO A TRANSMISSAO ESTÁ SENDO APENAS POR UMA LINHA
            POIS NO RETORNO DO XML ESTÁ RETORNANDO SOMENTE UM CÓDIGO DE BARRAS PARA TODAS
            GUIAS TRANSMITIDAS
        */
        //widget.getAction ('transmitirLote').isVisible     = showGuiaRj;
        //widget.showCheckbox                               = showGuiaRj;

        widget.getAction('consultarLote').isVisible = !!(showGuiaRj || filteredData.IDORGARRECADNFE === 'E' && filteredData.OPCGUIA === 'G' && !['RJ', 'SP', 'ES'].includes(filteredData.SGESTADO));

        widget.getField('IDTRANSMISSAO').isVisible = showGuiaRj;
        widget.getField('IDTRANSMISSAO').showOnList = showGuiaRj;

        widget.getField('NRSEQLOTE').isVisible = showGuiaRj;
        widget.getField('NRSEQLOTE').showOnList = showGuiaRj;

        widget.getField('CDDETRECEITA').isVisible = !!(filteredData.IDORGARRECADNFE === 'E' && filteredData.OPCGUIA === 'G' && !['RJ', 'SP', 'ES'].includes(filteredData.SGESTADO));

        receita.isVisible = !showGuiaRj;
        natureza.isVisible = showGuiaRj;
        natureza.showOnList = showGuiaRj;

        if (showGuiaRj) {
            delete receita.validations.required;
            natureza.validations.required = true;
            widget.getField('IDTRANSMISSAO').dataSource.data.forEach(function (field) {
                if (field.value === 'P') {
                    field.description = 'Erro no Processamento';
                }
            });
        } else {
            delete natureza.validations.required;
            receita.validations.required = true;
            widget.getField('IDTRANSMISSAO').dataSource.data.forEach(function (field) {
                if (field.value === 'P') {
                    field.description = 'Invalidada pelo Portal';
                }
            });
        }

        widget.resizeGridColumns();
        widget.redraw(true);
    };

    /*
        Preparação do filtro da tela com a passagem de parametros necessárias
        para a execução do datasource da tela.
    */
    this.preparaFiltro = function (widget, preference) {
        var filterRow = preference.FILTER_ROW;
        var widgetPagamento = templateManager.container.getWidget('tabbedDocumentosArrecação');
        var actionEmitirGnreTxt = widget.getAction('emitirGnreTxt');

        widget.dataSourceFilter = [{
            "name": "DTINIPERIODO",
            "operator": "=",
            "value": filterRow.DTPERIODO.start
        }, {
            "name": "DTFIMPERIODO",
            "operator": "=",
            "value": filterRow.DTPERIODO.end
        }, {
            "name": "CDEMPRESA",
            "operator": "=",
            "value": filterRow.CDEMPRESA
        }, {
            "name": "CDIMPOSTO",
            "operator": "=",
            "value": filterRow.CDIMPOSTO
        }];

        /*Ajusta o datasource, o datasourcefilter e os Checkbox de acordo com o tipo de emissão de guia*/
        if (filterRow.IDTIPOEMISSAO == 'D') {
            //Guia por documento 
            if (filterRow.OPCGUIA == '') {
                //TODO Verificar pelo tipo de imposto é mais claro e lógico que esta. Mudar quando possível.
                //Imposto Federal
                widget.dataSource.name = "fis_guias#/crud/guia_documentoArrecadDocFederal";
            } else {
                //GNRE ou Guia do Estado
                widget.dataSource.name = "fis_guias#/crud/guia_documentoArrecadDoc";
                widget.dataSourceFilter.push({
                    "name": "CDINSCRICAO",
                    "operator": "=",
                    "value": filterRow.IDORGARRECADNFE === 'F' ? 'T' : filterRow.IDORGARRECADNFE === 'E' ? filterRow.CDINSCESTA : filterRow.CDINSCMUNI
                });
                widget.dataSourceFilter.push({
                    "name": "SGESTADO",
                    "operator": "=",
                    "value": filterRow.UFFAVORECIDO
                });
                widget.dataSourceFilter.push({
                    "name": "P_TPGUIA",
                    "operator": "=",
                    "value": filterRow.OPCGUIA
                });
            }
            Fis00200_DocumentoDeArrecadacao_Service.ajustaCamposApuracaoOuDocumento('D', widget);
            widget.showCheckbox = true;
        } else {
            //Guia por apuração
            widget.dataSource.name = "fis_guias#/crud/guia_documentoArrecadacao";
            widget.dataSourceFilter.push({
                "name": "CDINSCRICAO",
                "operator": "=",
                "value": filterRow.IDORGARRECADNFE === 'F' ? 'T' : filterRow.IDORGARRECADNFE === 'E' ? filterRow.CDINSCESTA : filterRow.CDINSCMUNI
            });
            //Opção do GNRE, há UF do Favorecido
            if (filterRow.OPCGUIA == 'G') {
                widget.dataSourceFilter.push({
                    "name": "SGESTADO",
                    "operator": "=",
                    "value": filterRow.UFFAVORECIDO
                });
            }
            Fis00200_DocumentoDeArrecadacao_Service.ajustaCamposApuracaoOuDocumento('A', widget);
            widget.showCheckbox = !['SP'].includes(filterRow.UFFAVORECIDO);
        }

        widgetPagamento.dataSourceFilter = [{
            "name": "CDEMPRESA",
            "operator": "=",
            "value": filterRow.CDEMPRESA
        }];

        widget.fields.forEach(function (field) {
            if (field.name == 'DTPERIODO' || field.name == 'IDTIPOEMISSAO') field.filterProperties.isVisible = false;
        });

        this.setStripeData(filterRow);
        this.salvaDadosFiltro(filterRow);
        this.setaValoresDefaultPagamento();
        this.verificaEstadoEmissao();

        //Tratativa da action da GNRE TXT
        actionEmitirGnreTxt.isVisible = filterRow.OPCGUIA == 'G' || filterRow.OPCGUIA == 'E' && (filterRow.SGESTADO == 'RJ' || filterRow.SGESTADO == 'ES');
        if (filterRow.SGESTADO == 'RJ' && filterRow.OPCGUIA == 'E') {
            actionEmitirGnreTxt.label = 'Emitir DARJ';
        } else if (filterRow.SGESTADO == 'RJ' && filterRow.OPCGUIA == 'G') {
            actionEmitirGnreTxt.label = 'Emitir GNRE RJ';
        } else if (filterRow.SGESTADO == 'ES' && filterRow.OPCGUIA == 'E' || filterRow.UFFAVORECIDO == 'ES' && filterRow.OPCGUIA == 'G') {
            actionEmitirGnreTxt.label = 'Emitir DUA - ES';
        } else if (filterRow.UFFAVORECIDO == 'SP' && filterRow.OPCGUIA == 'G') {
            actionEmitirGnreTxt.label = 'Emitir GNRE TXT';
        } else {
            actionEmitirGnreTxt.label = 'Emitir GNRE';
        }

        widget.redraw(true);
    };

    /*
     * Função para alterar exibição e obrigatoriedade de campos no filtro,
     * conforme tipo do imposto(Orgão Arrecadador).
     */
    this.controlaCamposFiltro = function (widget) {
        var filterRow = widget.currentRow;
        var inscrestad = widget.getField('CDINSCESTA');
        var inscrmunicip = widget.getField('CDINSCMUNI');
        var orgaoArrecador = filterRow.IDORGARRECADNFE;

        if (widget.currentRow.CDIMPOSTO) {
            // Valida quais campos deverão ser exibidos no filtro para cada imposto
            switch (orgaoArrecador) {
                case "F":
                    setCampoInvisible(inscrestad);
                    setCampoInvisible(inscrmunicip);
                    break;
                case "E":
                    setCampoObrigatorio(inscrestad, false);
                    setCampoInvisible(inscrmunicip);
                    break;
                case "M":
                    setCampoObrigatorio(inscrmunicip, false);
                    setCampoInvisible(inscrestad);
                    break;
                default:
                    setCampoInvisible(inscrestad);
                    setCampoInvisible(inscrmunicip);
                    widget.currentRow.SGESTADO = '';
                    widget.currentRow.CDPAIS = '';
                    break;
            }
            this.checkInscricaoHabilitada(widget);
        } else {
            setCampoInvisible(inscrestad);
            setCampoInvisible(inscrmunicip);
            widget.currentRow.SGESTADO = '';
            widget.currentRow.CDPAIS = '';
        }
        //Se o tipo de guia for apuração o imposto simples nacional é permitido no campo
        widget.getField("DSIMPOSTONFE").dataSourceFilter[0].value = widget.currentRow.IDTIPOEMISSAO == 'A' ? 'S' : 'N';
        this.controlaCamposFiltroGnre(widget);
    };

    /*Altera a exibição dos campos e actions relacionados à GNRE*/
    this.controlaCamposFiltroGnre = function (widget) {
        var opc_idtipoemissao = widget.currentRow.IDTIPOEMISSAO;
        var opc_cdimposto = widget.currentRow.CDIMPOSTO;
        var opc_opcguia = widget.currentRow.OPCGUIA;
        var opcaoguia = widget.getField('OPCGUIA');
        var uffavorecido = widget.getField('UFFAVORECIDO');

        //Se o tipo de guia for 'documento' este oferece opção para GNER ou Guia do estado e se for ICMS Estadual ou ICMS ST Estadual
        if ( /*opc_idtipoemissao == 'D' && */opc_cdimposto == '00' || opc_cdimposto == '80') {
            setCampoObrigatorio(opcaoguia, false);
            if (opc_opcguia == 'G') {
                //Guia por GNRE
                setCampoObrigatorio(uffavorecido, false);
            } else {
                setCampoInvisible(uffavorecido);
            }
        } else {
            setCampoInvisible(opcaoguia);
            setCampoInvisible(uffavorecido);
        }
    };

    /*
     * Função para controlar o filtro por empresa e a propriedade readOnly do
     * campo de inscrição habilitado no filtro.
     */
    this.checkInscricaoHabilitada = function (filterPopup) {
        var cdempresa = filterPopup.currentRow.CDEMPRESA;
        var cdinscestaField = filterPopup.getField("CDINSCESTA");
        var cdinscmuniField = filterPopup.getField("CDINSCMUNI");

        // Reseta os valores de inscrição do filtro.
        filterPopup.currentRow.CDINSCESTA = '';
        filterPopup.currentRow.CDINSCMUNI = '';
        filterPopup.currentRow.SGESTADO = '';
        filterPopup.currentRow.CDPAIS = '';

        // Filtro a ser setado no dataSourceFilter do field de inscrição
        // exibido.
        var filter = [{
            "name": "CDEMPRESA",
            "operator": "=",
            "value": cdempresa
        }];

        // Altera a obrigatoriedade dos campos e atualiza os filtros de
        // inscrição quando a empresa for alterada.
        if (cdinscestaField.isVisible) {
            setCampoObrigatorio(cdinscestaField, !cdempresa);
            cdinscestaField.dataSourceFilter = filter;
            cdinscestaField.reload();
        }

        if (cdinscmuniField.isVisible) {
            setCampoObrigatorio(cdinscmuniField, !cdempresa);
            cdinscmuniField.dataSourceFilter = filter;
            cdinscmuniField.reload();
        }
    };

    this.setStripeData = function (filterRow) {
        var stripeWidget = templateManager.container.getWidget("stripe");

        stripeWidget.currentRow = {};
        stripeWidget.currentRow.IDTIPOEMISSAO = filterRow.IDTIPOEMISSAO.toString() === 'A' ? 'Apuração' : 'Documento';
        stripeWidget.currentRow.DSIMPOSTONFE = filterRow.DSIMPOSTONFE.toString();
        stripeWidget.currentRow.DTPERIODO = 'De ' + filterRow.DTPERIODO.start + ' até ' + filterRow.DTPERIODO.end;
        stripeWidget.currentRow.DESCEMPRESA = filterRow.DESCEMPRESA.toString();
        stripeWidget.currentRow.CDINSCESTA = filterRow.CDINSCESTA.toString() + ' - ' + filterRow.SGESTADO.toString();
        stripeWidget.currentRow.CDINSCMUNI = filterRow.CDINSCMUNI.toString() + ' - ' + filterRow.SGESTADO.toString();

        stripeWidget.getField('CDINSCESTA').isVisible = filterRow.IDORGARRECADNFE === 'E';
        stripeWidget.getField('CDINSCMUNI').isVisible = filterRow.IDORGARRECADNFE === 'M';
    };

    /*
     * Função para armazenar os dados filtrados em variável dentro do escopo
     * deste controller. Essa variável é utilizada nos demais processos da
     * tela, facilitando-os.
     */
    this.salvaDadosFiltro = function (filterRow) {
        filteredData = Util.clone(filterRow);
    };

    this.controlaCampoImposto = function (args) {
        var widget = args.owner.field.widget;
        var imposto = widget.getField('DSIMPOSTONFE');
        widget.currentRow.CDIMPOSTO = '';
        widget.currentRow.IDORGARRECADNFE = '';
        imposto.clearValue(); //imposto.value('');
        this.controlaCamposFiltro(widget);
        /*imposto.reload().then(
                function(response) {
                    this.adicionaImpostoSimples(imposto,widget.currentRow.IDTIPOEMISSAO);
                }.bind(this)
        );*/
    };

    /*#############################################################
    #                                                             #
    #           Funções de Maninupalção de Elementos              #
    #                                                             #
    #############################################################*/

    /*
     * Função para esconder um campo, removendo quaisquer validações
     * associadas.
     */
    var setCampoInvisible = function setCampoInvisible(field) {
        field.isVisible = false;
        field.readOnly = true;
        field.validations = {};
        field.value('');
    };

    /*
     * Função para exibir um campo e setá-lo como obrigatório.
     */
    var setCampoObrigatorio = function setCampoObrigatorio(field, readOnly) {
        field.isVisible = true;
        field.readOnly = !!readOnly;
        field.validations = { required: true };
    };

    /*
        Função que ira controlar o Campo código de receita.
        Ele buscará informações estaduais caso o imposto seja estadual ou 
        federal caso o imposto seja federal.
    */
    this.controlaTipoReceita = function (widget, nomeWidget, nomeCampoGuia) {
        var widgetPopupReceita = templateManager.container.getWidget(nomeWidget).getField(nomeCampoGuia).selectWidget;
        var idtipoimp = filteredData.IDORGARRECADNFE;

        if (idtipoimp === 'E') {
            widgetPopupReceita.fields[0].showOnList = true;
            widgetPopupReceita.fields[1].showOnList = true;

            widgetPopupReceita.fields[2].showOnList = false;
            widgetPopupReceita.fields[3].showOnList = false;
            widgetPopupReceita.fields[4].showOnList = false;
            widgetPopupReceita.fields[5].showOnList = false;
            widgetPopupReceita.fields[6].showOnList = false;

            widgetPopupReceita.order = 'CDRECEITAEST';
        } else if (idtipoimp === 'F') {
            widgetPopupReceita.fields[0].showOnList = false;
            widgetPopupReceita.fields[1].showOnList = false;

            widgetPopupReceita.fields[2].showOnList = true;
            widgetPopupReceita.fields[3].showOnList = true;
            widgetPopupReceita.fields[4].showOnList = true;
            widgetPopupReceita.fields[5].showOnList = true;
            widgetPopupReceita.fields[6].showOnList = true;

            widgetPopupReceita.order = 'CDRECEITACONTR';
        }
        //widgetPopupReceita.redraw();
    };

    this.dataSourceTipoReceita = function (widget, nomeCampoReceita) {
        var campoReceita = widget.getField(nomeCampoReceita);
        var idtipoimp = filteredData.IDORGARRECADNFE;

        if (idtipoimp === 'E') {
            campoReceita.template = 'zh-select-autocomplete#field/select-autocomplete.html';
            campoReceita.events = [{
                "name": "FieldAfterSelectOpen",
                "code": "Fis00200_DocumentoDeArrecadacao_Controller.controlaTipoReceita(args.owner.field.widget,'widgetDocumentos','CDRECEITA')"
            }, {
                "name": "FieldOnClick",
                "code": "args.owner.field.initializeField()"
            }];
            campoReceita.dataSource.name = 'fis#/crud/codreceitaest';
            campoReceita.valueField = 'CDRECEITAEST';
            campoReceita.descriptionField = 'NMRECEITAEST';
            campoReceita.displayedFields = ["CDRECEITAEST", "NMRECEITAEST"];
            campoReceita.searchableFields = ["CDRECEITAEST", "NMRECEITAEST"];
            campoReceita.outData = {
                "CDRECEITAEST": nomeCampoReceita,
                "NMRECEITAEST": "NMRECEITAEST"
            };
            campoReceita.dataSourceFilter = [{
                "name": "CDPAIS",
                "operator": "=",
                "value": filteredData.CDPAIS
            }, {
                "name": "SGESTADO",
                "operator": "=",
                "value": filteredData.SGESTADO
            }];
            campoReceita.reload();
        } else if (idtipoimp === 'F') {
            campoReceita.template = 'zh-select-autocomplete#field/select-autocomplete.html';
            campoReceita.valueField = 'CDRECEITACONTR';
            campoReceita.descriptionField = 'NMRECEITACONTR';
            campoReceita.displayedFields = ["CDRECEITACONTR", "NMRECEITACONTR"];
            campoReceita.searchableFields = ["CDRECEITACONTR", "NMRECEITACONTR"];
            campoReceita.dataSource.name = 'fis#/crud/codreceitacontr';
            campoReceita.outData = {
                "CDRECEITACONTR": nomeCampoReceita,
                "NMRECEITACONTR": "NMRECEITACONTR",
                "CDVARIACAO": "CDVARIACAO",
                "IDPERIODICREC": "IDPERIODICREC",
                "IDDEBSCPINC": "IDDEBSCPINC"
            };
            campoReceita.dataSourceFilter = [{
                "name": "CDIMPOSTO",
                "operator": "=",
                "value": filteredData.CDIMPOSTO
            }];
            campoReceita.events = [{
                "name": "FieldAfterSelectOpen",
                "code": "Fis00200_DocumentoDeArrecadacao_Controller.controlaTipoReceita(args.owner.field.widget,'widgetDocumentos','CDRECEITA')"
            }, {
                "name": "FieldOnClick",
                "code": "args.owner.field.initializeField()"
            }];
            campoReceita.reload();
        } else {
            campoReceita.template = "field/text-edit.html";
            campoReceita.events = [];
        }
    };

    self.controlaDetalhamentoGnre = function (widget) {
        widget.getField('CDDETRECEITA').dataSourceFilter = [{
            "name": "CDRECEITA",
            "operator": "=",
            "value": widget.currentRow.CDRECEITA
        }, {
            "name": "SGESTADO",
            "operator": "=",
            "value": filteredData.SGESTADO
        }];

        widget.getField('CDDETRECEITA').reload();
    };

    /*
        Função que ira controlar a visibilade das actions na tela
        de acordo com o status da guia.
    */
    this.controlaActions = function (widget) {
        var idTipoEmissao = widget.appliedFilter.FILTER_ROW.IDTIPOEMISSAO;
        var editar = widget.getAction('EDITAR');
        var prepararPag = widget.getAction('prepararPagamento');
        var desfazerPrep = widget.getAction('desfazerPreparacao');
        var campoReceita = widget.getField('CDRECEITA');
        var imposto = widget.currentRow.CDIMPOSTO;

        var condicaoEditar;
        var condicaoPag;
        var condicaoDesf;

        if (idTipoEmissao == 'D') {
            //Emissão por documento
            condicaoEditar = true;
            condicaoPag = true;
            condicaoDesf = true;
        } else {
            //Emissão por apuração (lógica original)
            condicaoEditar = widget.currentRow.IDBLOQMAPAPU === 'S' && widget.currentRow.IDSTATBPAG === 'P';
            condicaoPag = widget.currentRow.IDBLOQMAPAPU === 'S' && widget.currentRow.IDSTATBPAG === 'P';
            condicaoDesf = widget.currentRow.IDBLOQMAPAPU === 'S' && (widget.currentRow.IDSTATBPAG === 'B' || widget.currentRow.IDSTATBPAG === 'A');
        }
        editar.readOnly = !condicaoEditar;
        prepararPag.readOnly = !condicaoPag;
        desfazerPrep.readOnly = !condicaoDesf;

        if (imposto == 'SN') {
            //Para o Simples Nacional o campo de código de receita não é obrigatório
            campoReceita.validations = {};
        } else {
            campoReceita.validations = { "required": true };
        }
    };

    /*this.adicionaImpostoSimples = function (field, tipoGuia){
        var data = field.dataSource.data;
         // Se a opção para emissão do documento for por mapa
        // adicionar a opção do simples nacional
        
        if(tipoGuia ==='A'){
            var simples  = {
                    "CDIMPOSTONFE":"SN",
                    "DSIMPOSTONFE":"Simples Nacional",
                    "IDORGARRECADNFE":null,
                    "SGIMPOSTONFE":"Simples Nacional"
                };
            //Verifica se Ja existe o simples nacional
            if(data.indexOf(simples) === -1)
                data.unshift(simples);
        }
    };*/

    /*#############################################################
    #                                                             #
    #                    Funções de Controle                      #
    #                                                             #
    #############################################################*/

    this.setaValoresDefaultPagamento = function () {
        var widgetPagamento = templateManager.container.getWidget('tabbedDocumentosArrecação');
        General.callRestEngine('fis_guias#/valoresDefaultPagamento', 'Row', filteredData).then(function (response) {
            var dadosPagamento = response.dataset.dadosPagamento;
            if (dadosPagamento.length > 0) {
                widgetPagamento.currentRow.CDFILIAL = dadosPagamento[0].CDFILIAL;
                widgetPagamento.currentRow.CDRATEIO = dadosPagamento[0].CDRATEIO;

                widgetPagamento.getField('NMFILIAL').value(dadosPagamento[0].NMFILIAL);
                widgetPagamento.getField('NMRATEIO').value(dadosPagamento[0].NMRATEIO);
            } else {
                widgetPagamento.currentRow.CDFILIAL = null;
                widgetPagamento.currentRow.CDRATEIO = null;

                widgetPagamento.currentRow.NMFILIAL = null;
                widgetPagamento.currentRow.NMRATEIO = null;
            }
            widgetPagamento.redraw(true);
        }, function (callback) {
            if (callback.data) {
                ScreenService.showMessage(callback.data.error);
            }
        });
    };

    this.openPopupConsultaLote = function (widget) {
        var widgetConsulta = templateManager.container.getWidget('widgetConsultarLote');
        var lote = widgetConsulta.getField('NRSEQLOTE');
        ScreenService.openPopup(widgetConsulta);
        widgetConsulta.currentRow.NRSEQLOTE = '';
        widgetConsulta.currentRow.DTHRRECIBO = '';
        widgetConsulta.currentRow.IDSTATUSLOTE = '';

        lote.dataSourceFilter = [{
            "name": "CDEMPRESA",
            "operator": "=",
            "value": filteredData.CDEMPRESA
        }, {
            "name": "CDINSCESTA",
            "operator": "=",
            "value": filteredData.CDINSCESTA
        }, {
            "name": "SGESTADO",
            "operator": "=",
            "value": filteredData.SGESTADO
        }];
        lote.reload();
    };

    /*#############################################################
    #                                                             #
    #                    Funções de Validações                    #
    #                                                             #
    #############################################################*/
    /*
     * Função chamada ao alterar o imposto selecionado. Verifica a
     * parametrização de impostos relacionados.
     */
    this.validaImpostosRelacionados = function (filterPopup) {
        var filterRow = filterPopup.currentRow;
        // Verifica se há um valor inserido para o campo de imposto.
        if (filterRow.CDIMPOSTO && filterRow.CDIMPOSTO !== 'SN') {
            General.callRestEngine('fis_guias#/vdImpostoRelac', 'Row', { "CDIMPOSTONFE": filterRow.CDIMPOSTO }).then(function (response) {
                // Verifica se a validação retornou true ou false.
                var impostoIsValid = response.dataset.validation.VDPARAMIMPRELAC;
                if (!impostoIsValid) {
                    // Exibe a mensagem de erro e remove o imposto inserido.
                    ScreenService.showMessage(Messages_fiscal.PARAM_IMPOSTO_RELAC_ERROR, 'error');
                    filterRow.CDIMPOSTO = null;
                    filterRow.SGIMPOSTONFE = null;
                    filterRow.DSIMPOSTONFE = null;
                }
            }, function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };

    this.verifcaStatusLote = function (lote) {
        var widget = lote.widget;
        if (widget.currentRow.IDSTATUSLOTE === 'S' || widget.currentRow.IDSTATUSLOTE === 'E') {
            ScreenService.showMessage(Messages_fiscal.LOTE_CONSULTADO);
            lote.value('');
            widget.currentRow.DTHRRECIBO = '';
            widget.currentRow.IDSTATUSLOTE = '';
        }
    };

    /*#############################################################
    #                                                             #
    #                    Funções de Processos                     #
    #                                                             #
    #############################################################*/

    this.salvarEdicaoGuia = function (widget) {
        var verificaRJ = self.verificaNaturezaRJ(widget);
        if (verificaRJ[0]) {
            if (widget.isValid()) {
                //Esta campo indica como a rotina deverá persistir os dados (para guia apuração e documento) e nas suas respectivas tabelas
                //widget.currentRow.IDTIPOEMISSAO = widget.appliedFilter.FILTER_ROW.IDTIPOEMISSAO;
                General.callRestEngine('fis_guias#/salvarEdicaoGuia', 'Row', Fis00200_DocumentoDeArrecadacao_Service.preparaRow(widget.currentRow)).then(function (response) {
                    widget.computeDescriptionOrder();
                    widget.view();
                    ScreenService.closeSwipe();
                    widget.reload();
                    General.changeWidgetAcessibility(widget.widgets, true);
                }, function (callback) {
                    if (callback.data) {
                        ScreenService.showMessage(callback.data.error);
                    }
                });
            }
        } else {
            ScreenService.showMessage(verificaRJ[1]);
            return;
        }
    };

    self.verificaNaturezaRJ = function (widget) {
        if (filteredData.SGESTADO == 'RJ') {
            if (filteredData.OPCGUIA == 'D') {
                if (filteredData.IDTIPOEMISSAO == 'D') {
                    if (!['4', '5', '7', '58'].includes(widget.currentRow.CDNATUREZA)) return [false, 'Documento DARJ só pode receber as naturezas 4, 5, 7 ou 58'];
                } else if (filteredData.IDTIPOEMISSAO == 'A') {
                    if (!['1', '2', '3', '4', '6', '56', '60', '61'].includes(widget.currentRow.CDNATUREZA)) return [false, 'Apuração DARJ só pode receber as naturezas 1, 2, 3, 4, 6, 56, 60 ou 61'];
                }
            } else if (filteredData.OPCGUIA == 'G') {
                if (filteredData.IDTIPOEMISSAO == 'D') {
                    if (!['4', '5', '59'].includes(widget.currentRow.CDNATUREZA)) return [false, 'Documento GNRE só pode receber as naturezas 4, 5, ou 59'];
                } else if (filteredData.IDTIPOEMISSAO == 'A') {
                    if (!['1', '2', '4', '57', '60'].includes(widget.currentRow.CDNATUREZA)) return [false, 'Apuração GNRE só pode receber as naturezas 1, 2, 4, 57 ou 60'];
                }
            }
        }
        return [true];
    };

    self.preparaPagamentoQuestion = function (widget) {
        var rows = widget.getCheckedRows();

        switch (self.verificaPreparaPagamento(rows)) {
            case 1:
                self.preparaPagamento(widget);
                break;

            case 2:
                ScreenService.confirmMessage(ScreenService.i18n('Essa preparação de pagamento não ira gerar um codigo de barras, por que a guia não foi enviada ou por sua consulta apresentar erros. Deseja continuar?'), 'question', function (success) {
                    self.preparaPagamento(widget);
                });
                break;

            case 0:
                ScreenService.showMessage('Não é possivel preparar pagamento de um lote não consultado. Consulte o lote antes de preparar o pagamento.');
                break;
        }
    };

    self.verificaPreparaPagamento = function (rows) {
        rows.forEach(function (row) {
            if (['N', 'P', 'U', 'C'].includes(row.IDTRANSMISSAO)) {
                return 2;
            } else if (row.IDTRANSMISSAO === 'L') {
                return 0;
            }
        });
        return 1;
    };

    self.preparaPagamento = function (widget) {

        var info = {};

        info.CDEMPRESA = filteredData.CDEMPRESA;
        info.CDIMPOSTO = filteredData.CDIMPOSTO;
        info.IDTIPOEMISSAO = filteredData.IDTIPOEMISSAO;
        info.CDMUNICIPIO = filteredData.CDMUNICIPIO;
        info.SGESTADO = filteredData.SGESTADO;
        info.IDTIPOEMISSAO = filteredData.IDTIPOEMISSAO;
        info.CDINSCESTA = filteredData.CDINSCESTA;
        info.CDINSCMUNI = filteredData.CDINSCMUNI;
        info.IDORGARRECADNFE = filteredData.IDORGARRECADNFE;
        info.DSIMPOSTONFE = filteredData.DSIMPOSTONFE;
        info.CDINSCRICAO = filteredData.IDORGARRECADNFE === 'M' ? filteredData.CDINSCESTA : filteredData.IDORGARRECADNFE === 'E' ? filteredData.CDINSCESTA : 'T';

        var widgetPagamento = templateManager.container.getWidget('tabbedDocumentosArrecação').currentRow;

        var nrseqloteArray = self.removeDups(widget.getCheckedRows().map(function (row) {
            return row.NRSEQLOTE;
        })).filter(function (el) {
            return el != null;
        });

        var dataset = [];
        if (nrseqloteArray.length > 0) {
            nrseqloteArray.forEach(function (NRSEQLOTE) {
                dataset.push.apply(dataset, _toConsumableArray(widget.dataSource.data.filter(function (row) {
                    return NRSEQLOTE === row.NRSEQLOTE;
                })));
            });
        }

        var resul;
        if (dataset.length > 0) {
            dataset.forEach(function (row) {
                row.SGESTADO = filteredData.SGESTADO;
                resul = Fis00200_DocumentoDeArrecadacao_Service.validaPreparacaoPagamento(widgetPagamento, row);
                if (!resul) {
                    return;
                }
            });
        }

        if (resul === true) {
            var row = {
                "row": Fis00200_DocumentoDeArrecadacao_Service.preparaRow(dataset),
                "dadosPagamento": widgetPagamento,
                "info": info
            };

            General.callRestEngine('fis_guias#/preparaPagamento', 'Row', row).then(function (response) {

                ScreenService.closeSwipe();
                ScreenService.closePopup();
                widget.reload().then(function (response) {
                    this.controlaActions(widget);
                }.bind(this));
                if (response.dataset.response[0].length === 0) {
                    ScreenService.showMessage(Messages_fiscal.SUCESSO_PREPARACAO);
                } else {
                    var responseToString = Object.values(response.dataset.response).map(function (nrseqlote) {
                        return '<br />' + nrseqlote;
                    }).join(' ');
                    ScreenService.showMessage('Não foi realizado a preparação de pagamento para os seguintes lotes:' + responseToString);
                }
            }.bind(this), function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        } else ScreenService.showMessage(resul);
    };

    this.cancelaDadosFinanceiro = function (widget) {

        var info = {};
        info.CDINSCRICAO = filteredData.IDORGARRECADNFE === 'M' ? filteredData.CDINSCESTA : filteredData.IDORGARRECADNFE === 'E' ? filteredData.CDINSCESTA : 'T';
        info.CDIMPOSTO = filteredData.CDIMPOSTO;
        info.CDEMPRESA = filteredData.CDEMPRESA;

        var nrseqloteArray = self.removeDups(widget.getCheckedRows().map(function (row) {
            return row.NRSEQLOTE;
        })).filter(function (el) {
            return el != null;
        });

        var dataset = [];
        if (nrseqloteArray.length > 0) {
            nrseqloteArray.forEach(function (NRSEQLOTE) {
                dataset.push.apply(dataset, _toConsumableArray(widget.dataSource.data.filter(function (row) {
                    return NRSEQLOTE === row.NRSEQLOTE;
                })));
            });
        }

        var row = {
            "row": Fis00200_DocumentoDeArrecadacao_Service.preparaRow(dataset),
            "info": info
        };
        General.callRestEngine('fis_guias#/cancelaDadosFinanceiro', 'Row', row).then(function (response) {
            ScreenService.closeSwipe();
            ScreenService.closePopup();
            widget.reload().then(function (response) {
                this.controlaActions(widget);
            }.bind(this));
            if (response.dataset.response[0].length === 0) {
                ScreenService.showMessage(Messages_fiscal.SUCESSO_CANCELAMENTO);
            } else {
                var responseToString = Object.values(response.dataset.response).map(function (nrseqlote) {
                    return '<br />' + nrseqlote;
                }).join(' ');
                ScreenService.showMessage('Não foi possivel desfazer a preparação de pagamento para os seguintes lotes:' + responseToString);
            }
        }.bind(this), function (callback) {
            if (callback.data) {
                ScreenService.showMessage(callback.data.error);
            }
        });
    };

    this.transmitirLote = function (args) {
        self.emitirGnreTxt(args, false);
    };

    self.removeDups = function (names) {
        var unique = {};
        names.forEach(function (i) {
            if (!unique[i]) {
                unique[i] = true;
            }
        });
        return Object.keys(unique);
    };

    self.transmitirLoteRj = function (widget) {
        var rows = widget.getCheckedRows();
        var infoRow = {};

        infoRow.CDEMPRESA = filteredData.CDEMPRESA;
        infoRow.CDMUNICIPIO = filteredData.CDMUNICIPIO;
        infoRow.SGESTADO = filteredData.SGESTADO;
        infoRow.IDTIPOEMISSAO = filteredData.IDTIPOEMISSAO;
        infoRow.TipoDocumento = filteredData.OPCGUIA == 'G' ? 2 : 1;
        infoRow.TipoApuracao = filteredData.IDTIPOEMISSAO == 'D' ? 2 : 1;
        infoRow.CDINSCESTA = filteredData.CDINSCESTA;
        infoRow.CDINSCMUNI = filteredData.CDINSCMUNI;
        infoRow.IDORGARRECADNFE = filteredData.IDORGARRECADNFE;
        infoRow.DSIMPOSTONFE = filteredData.DSIMPOSTONFE;
        infoRow.CDINSCRICAO = filteredData.IDORGARRECADNFE === 'M' ? filteredData.CDINSCESTA : filteredData.IDORGARRECADNFE === 'E' ? filteredData.CDINSCESTA : 'T';

        var dataLimtPagArray = self.removeDups(rows.map(function (row) {
            return row.DTLIMITEPAG;
        }));

        var dataset = [Fis00200_DocumentoDeArrecadacao_Service.preparaRow(rows), infoRow, dataLimtPagArray];

        var resul = Fis00200_DocumentoDeArrecadacao_Service.validaTransmissaoLoteRj(rows);

        if (resul === true) {
            General.callRestEngine('fis_guias#/transmitirLoteRj', 'DataSet', dataset).then(function (response) {
                ScreenService.closeSwipe();
                ScreenService.closePopup();
                widget.reload().then(function (response) {
                    this.controlaActions(widget);
                }.bind(this));

                var screenServiceMenssage = '';
                response.messages[0].message.forEach(function (envio) {
                    screenServiceMenssage = screenServiceMenssage + ' ' + envio.mensagem + ' Lote: ' + envio.nrseqlote + '.<br /><br />';
                });
                ScreenService.showMessage(screenServiceMenssage);
            }.bind(this), function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        } else ScreenService.showMessage(resul);
    };

    self.transmitirLoteEs = function (widget) {
        var rows = widget.getCheckedRows();
        var infoRow = {};

        infoRow.UFFAVORECIDO = filteredData.UFFAVORECIDO;
        infoRow.CDEMPRESA = filteredData.CDEMPRESA;
        infoRow.CDMUNICIPIO = filteredData.CDMUNICIPIO;
        infoRow.CDIMPOSTO = filteredData.CDIMPOSTO;
        infoRow.SGESTADO = filteredData.SGESTADO;
        infoRow.IDTIPOEMISSAO = filteredData.IDTIPOEMISSAO;
        infoRow.OPCGUIA = filteredData.OPCGUIA;
        infoRow.IDTIPOEMISSAO = filteredData.IDTIPOEMISSAO;
        infoRow.CDINSCESTA = filteredData.CDINSCESTA;
        infoRow.CDINSCMUNI = filteredData.CDINSCMUNI;
        infoRow.IDORGARRECADNFE = filteredData.IDORGARRECADNFE;
        infoRow.DSIMPOSTONFE = filteredData.DSIMPOSTONFE;
        infoRow.CDINSCRICAO = filteredData.IDORGARRECADNFE === 'M' ? filteredData.CDINSCESTA : filteredData.IDORGARRECADNFE === 'E' ? filteredData.CDINSCESTA : 'T';

        var dataset = [Fis00200_DocumentoDeArrecadacao_Service.preparaRow(rows), infoRow];

        General.callRestEngine('fis_guias#/transmitirLoteEs', 'DataSet', dataset).then(function (response) {
            ScreenService.closeSwipe();
            ScreenService.closePopup();
            widget.reload().then(function (response) {
                this.controlaActions(widget);
            }.bind(this));

            var screenServiceMenssage = '';
            response.messages[0].message.forEach(function (envio) {
                screenServiceMenssage = screenServiceMenssage + ' ' + envio.mensagem + ' Lote: ' + envio.nrseqlote + '.<br /><br />';
            });
            ScreenService.showMessage(screenServiceMenssage);
        }.bind(this), function (callback) {
            if (callback.data) {
                ScreenService.showMessage(callback.data.error);
            }
        });
    };

    self.emitirGnreOnline = function (widget) {
        var rows = widget.getCheckedRows();
        var infoRow = {};

        infoRow.CDEMPRESA = filteredData.CDEMPRESA;
        infoRow.CDMUNICIPIO = filteredData.CDMUNICIPIO;
        infoRow.SGESTADO = filteredData.SGESTADO;
        infoRow.CDIMPOSTO = filteredData.CDIMPOSTO;
        infoRow.UFFAVORECIDO = filteredData.UFFAVORECIDO;
        infoRow.IDTIPOEMISSAO = filteredData.IDTIPOEMISSAO;
        infoRow.TipoDocumento = filteredData.OPCGUIA == 'G' ? 2 : 1;
        infoRow.TipoApuracao = filteredData.IDTIPOEMISSAO == 'D' ? 2 : 1;
        infoRow.CDINSCESTA = filteredData.CDINSCESTA;
        infoRow.CDINSCMUNI = filteredData.CDINSCMUNI;
        infoRow.IDORGARRECADNFE = filteredData.IDORGARRECADNFE;
        infoRow.DSIMPOSTONFE = filteredData.DSIMPOSTONFE;
        infoRow.CDINSCRICAO = filteredData.IDORGARRECADNFE === 'M' ? filteredData.CDINSCESTA : filteredData.IDORGARRECADNFE === 'E' ? filteredData.CDINSCESTA : 'T';

        var dataset = [Fis00200_DocumentoDeArrecadacao_Service.preparaRow(rows), infoRow];

        General.callRestEngine('fis_guias#/emitirGnreOnline', 'DataSet', dataset).then(function (response) {
            ScreenService.closeSwipe();
            ScreenService.closePopup();
            widget.reload().then(function (response) {
                this.controlaActions(widget);
            }.bind(this));

            var screenServiceMenssage = '';
            response.messages[0].message.forEach(function (envio) {
                screenServiceMenssage = envio.status ? screenServiceMenssage + ' ' + envio.mensagem + ' <br />Lote: ' + envio.nrseqlote + '.<br /><br />' : screenServiceMenssage + ' ' + envio.mensagem + '.<br /><br />';
            });
            ScreenService.showMessage(screenServiceMenssage);
        }.bind(this), function (callback) {
            if (callback.data) {
                ScreenService.showMessage(callback.data.error);
            }
        });
    };

    self.consultarLote = function (widget) {
        if (filteredData.IDORGARRECADNFE == 'E' && (filteredData.OPCGUIA == 'G' ? filteredData.UFFAVORECIDO : filteredData.SGESTADO) == 'RJ') {
            self.consultarLoteRj(widget);
        }
        if (filteredData.IDORGARRECADNFE == 'E' && filteredData.OPCGUIA == 'G' && !['RJ', 'SP', 'ES'].includes(filteredData.SGESTADO)) {
            self.consultarLoteGnreOnline(widget);
        }
    };

    self.consultarLoteRj = function (widget) {
        if (widget.isValid()) {
            widget.currentRow.CDMUNICIPIO = filteredData.CDMUNICIPIO;
            widget.currentRow.SGESTADO = filteredData.SGESTADO;
            widget.currentRow.IDTIPOEMISSAO = filteredData.IDTIPOEMISSAO;
            widget.currentRow.CDINSCESTA = filteredData.CDINSCESTA;
            widget.currentRow.CDINSCMUNI = filteredData.CDINSCMUNI;
            widget.currentRow.IDORGARRECADNFE = filteredData.IDORGARRECADNFE;

            var nomeArquivo = this.service.nomeArquivoDatetime;

            General.callRestEngine('fis_guias#/consultarLoteRj', 'Row', Fis00200_DocumentoDeArrecadacao_Service.preparaRow(widget.currentRow)).then(function (response) {
                var consulta = response.dataset.consulta;
                ScreenService.closeSwipe();
                ScreenService.closePopup();

                ScreenService.showMessage(consulta.mensagem).then(function () {
                    if (consulta.xml !== false) {
                        var blob = new Blob([response.dataset.consulta.xml], { type: "application/xml" });
                        saveAs(blob, nomeArquivo('gnre_consulta', '_', 'xml'));
                    }
                });
                templateManager.container.getWidget('widgetDocumentos').reload();
            }.bind(this), function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };

    self.consultarLoteGnreOnline = function (widget) {
        if (widget.isValid()) {
            widget.currentRow.CDMUNICIPIO = filteredData.CDMUNICIPIO;
            widget.currentRow.SGESTADO = filteredData.SGESTADO;
            widget.currentRow.IDTIPOEMISSAO = filteredData.IDTIPOEMISSAO;
            widget.currentRow.CDINSCESTA = filteredData.CDINSCESTA;
            widget.currentRow.CDINSCMUNI = filteredData.CDINSCMUNI;
            widget.currentRow.CDEMPRESA = filteredData.CDEMPRESA;
            widget.currentRow.IDORGARRECADNFE = filteredData.IDORGARRECADNFE;

            var nomeArquivo = this.service.nomeArquivoDatetime;

            General.callRestEngine('fis_guias#/consultarLoteGnreOnline', 'Row', Fis00200_DocumentoDeArrecadacao_Service.preparaRow(widget.currentRow)).then(function (response) {
                var consulta = response.dataset.consulta;
                ScreenService.closeSwipe();
                ScreenService.closePopup();

                ScreenService.showMessage(consulta.mensagem).then(function () {
                    if (consulta.xml !== false) {
                        var blob = new Blob([response.dataset.consulta.xml], { type: "application/xml" });
                        saveAs(blob, nomeArquivo('gnre_consulta', '_', 'xml'));
                    }
                });
                templateManager.container.getWidget('widgetDocumentos').reload();
            }.bind(this), function (callback) {
                if (callback.data) {
                    ScreenService.showMessage(callback.data.error);
                }
            });
        }
    };

    /*#############################################################
    #                                                             #
    #                    Funções de Emissão de Guias              #
    #                                                             #
    #############################################################*/

    this.emitirGuia = function (widget) {
        var widgetGuia = templateManager.container.getWidget('widgetDocumentos');
        widget.currentRow.CDMUNICIPIO = filteredData.CDMUNICIPIO;
        widget.currentRow.SGESTADO = filteredData.SGESTADO;
        widget.currentRow.IDTIPOEMISSAO = filteredData.IDTIPOEMISSAO;
        widget.currentRow.CDINSCESTA = filteredData.CDINSCESTA;
        widget.currentRow.CDINSCMUNI = filteredData.CDINSCMUNI;
        widget.currentRow.IDORGARRECADNFE = filteredData.IDORGARRECADNFE;
        widget.currentRow.UFFAVORECIDO = filteredData.UFFAVORECIDO;
        widget.currentRow.OPCGUIA = filteredData.OPCGUIA;
        widget.currentRow.CDIMPOSTO = filteredData.CDIMPOSTO;

        var resul = this.service.validaEmiisaoGuia(widgetGuia.currentRow);

        var row = Util.clone(widget.currentRow, ["__rightActions", "__leftActions", "_children", "_parent", "__groupHeaders", "__index", "__isSelected", "__notSelectable", "$$hashKey"]);

        if (resul === true) {
            widget.currentRow.DataHoraSubmissao = this.service.DataHoraFim(0, 0, 0);

            switch (widget.currentRow.IDTIPOEMISSAO) {
                case 'A':
                    //Apuração
                    //Simples Nacional
                    if (widget.currentRow.CDIMPOSTO == 'SN') {
                        this.service.emitirGuia(widget, row, null, null, 'http://www8.receita.fazenda.gov.br/SIMPLESNACIONAL/aplicacoes.aspx?id=19');
                    } else {
                        //Demais impostos
                        if (widget.currentRow.IDORGARRECADNFE == 'E') {
                            switch (widget.currentRow.SGESTADO) {
                                case 'AC':
                                    this.service.emitirGuia(widget, row, null, null, 'http://www.sefaznet.ac.gov.br/sefazonline/servlet/hpfdaemn');
                                    break; //Acre
                                case 'AL':
                                    this.service.emitirGuia(widget, row, null, null, 'http://apl03.sefaz.al.gov.br/darcb/');
                                    break; //Alagoas
                                case 'AP':
                                    this.service.emitirGuia(widget, row, null, null, 'http://www.sefaz.ap.gov.br/sate/');
                                    break; //Amapá
                                case 'AM':
                                    this.service.emitirGuia(widget, row, null, null, 'http://online.sefaz.am.gov.br/daravulso/darOpcao.asp');
                                    break; //Amazonas
                                case 'BA':
                                    this.service.emitirGuia(widget, row, null, null, 'https://sistemas.sefaz.ba.gov.br/sistemas/arasp/pagamento/modulos/dae/pagamento/dae_pagamento.aspx');
                                    break; //Bahia
                                case 'CE':
                                    this.service.emitirGuia(widget, row, null, null, 'https://servicos.sefaz.ce.gov.br/internet/dae/taxas/default.asp');
                                    break; //Ceará
                                case 'DF':
                                    this.service.emitirGuia(widget, row, null, null, 'http://www.fazenda.df.gov.br/area.cfm?id_area=1075');
                                    break; //Distrito Federal
                                case 'ES':
                                    this.service.emitirGuia(widget, row, null, null, 'http://e-dua.sefaz.es.gov.br/');
                                    break; //Espírito Santo
                                case 'GO':
                                    this.service.emitirGuia(widget, row, null, null, 'https://app.sefaz.go.gov.br/arr-www/view/entradaContribuinte.jsf');
                                    break; //Goiás
                                case 'MA':
                                    this.service.emitirGuia(widget, row, null, null, 'http://aplicacoes.ma.gov.br/dare/');
                                    break; //Maranhão
                                case 'MT':
                                    this.service.emitirGuia(widget, row, null, null, 'https://www.sefaz.mt.gov.br/arrecadacao/darlivre/menudarlivre');
                                    break; //Mato Grosso
                                case 'MS':
                                    this.service.emitirGuia(widget, row, Messages_fiscal.EMITIR_DAEMS, 'daems', 'https://servicos.efazenda.ms.gov.br/sgae/EmissaoDAEMSdeICMS');
                                    break; //Mato Grosso do Sul
                                case 'MG':
                                    this.service.emitirGuia(widget, row, null, null, 'https://www2.fazenda.mg.gov.br/arrecadacao/ctrl/ARRECADA/ARRECADA/DOCUMENTO_ARRECADACAO?ACAO=VISUALIZAR');
                                    break; //Minas Gerais
                                case 'PA':
                                    this.service.emitirGuia(widget, row, null, null, 'https://app.sefa.pa.gov.br/emissao-dae-avulso/#/inicio');
                                    break; //Pará
                                case 'PB':
                                    this.service.emitirGuia(widget, row, null, null, 'https://www4.receita.pb.gov.br/atf/seg/SEGf_AcessarFuncao.jsp?cdFuncao=ARR_305');
                                    break; //Paraíba
                                case 'PR':
                                    this.service.emitirGuia(widget, row, Messages_fiscal.EMITIR_GRPR, 'grpr', 'http://www.fazenda.pr.gov.br/modules/conteudo/conteudo.php?conteudo=271');
                                    break; //Paraná
                                case 'PE':
                                    this.service.emitirGuia(widget, row, null, null, 'http://efisco.sefaz.pe.gov.br/sfi_trb_gae/PRGerarDAE');
                                    break; //Pernambuco
                                case 'PI':
                                    this.service.emitirGuia(widget, row, null, null, 'https://webas.sefaz.pi.gov.br/darweb/');
                                    break; //Piauí
                                case 'RJ':
                                    this.service.emitirGuia(widget, row, null, 'darj', null);
                                    break; //Rio de Janeiro
                                case 'RN':
                                    this.service.emitirGuia(widget, row, null, null, 'https://uvt.set.rn.gov.br/#/home');
                                    break; //Rio Grande do Norte
                                case 'RS':
                                    this.service.emitirGuia(widget, row, null, null, 'https://www.sefaz.rs.gov.br/EmissorGA/SAR/EmissorGaIcms.aspx');
                                    break; //Rio Grande do Sul
                                case 'RO':
                                    this.service.emitirGuia(widget, row, null, null, 'https://dareavulso.sefin.ro.gov.br/');
                                    break; //Rondônia
                                case 'RR':
                                    this.service.emitirGuia(widget, row, null, null, 'https://portalapp.sefaz.rr.gov.br/siate/servlet/wp_siate_dareavulso');
                                    break; //Roraima
                                case 'SC':
                                    this.service.emitirGuia(widget, row, Messages_fiscal.EMITIR_DARE_SC, 'dare-sc', 'https://tributario.sef.sc.gov.br/tax.NET/Sat.Arrecadacao.Web/DARE_online/EmissaoDareOnline.aspx');
                                    break; //Santa Catarina
                                case 'SP':
                                    this.service.emitirGuia(widget, row, Messages_fiscal.EMITIR_GARE, 'gare', 'https://www.fazenda.sp.gov.br/guiasinternet/gare/paginas/gare.aspx');
                                    break; //São Paulo
                                case 'SE':
                                    this.service.emitirGuia(widget, row, null, null, 'http://www.sefaz.se.gov.br/conteudo/267');
                                    break; //Sergipe
                                case 'TO':
                                    this.service.emitirGuia(widget, row, null, null, 'http://www.sefaz.to.gov.br/dare/servlet/hnetccwkda');
                                    break; //Tocantins
                                default:
                                    ScreenService.showMessage(Messages_fiscal.RELATORIO_NAO_DISPONIVEL);
                            } //fim do switch SGESTADO
                        } else {
                            //Emissão da guia via sistema da receita, caso a guia esteja vencida este encaminha para o site/birt
                            this.service.guiaDarfReceitaOuBirt(widgetGuia, widget, row, filteredData);
                        }
                    }
                    break;
                case 'D':
                    //Documento
                    if (widget.currentRow.IDORGARRECADNFE == 'E') {
                        switch (widget.currentRow.OPCGUIA) {
                            case 'E':
                                //Guia do Estado
                                switch (widget.currentRow.SGESTADO) {
                                    case 'AC':
                                        this.service.emitirGuia(widget, row, null, null, 'http://www.sefaznet.ac.gov.br/sefazonline/servlet/hpfdaemn');
                                        break; //Acre
                                    case 'AL':
                                        this.service.emitirGuia(widget, row, null, null, 'http://apl03.sefaz.al.gov.br/darcb/');
                                        break; //Alagoas
                                    case 'AP':
                                        this.service.emitirGuia(widget, row, null, null, 'http://www.sefaz.ap.gov.br/sate/');
                                        break; //Amapá
                                    case 'AM':
                                        this.service.emitirGuia(widget, row, null, null, 'http://online.sefaz.am.gov.br/daravulso/darOpcao.asp');
                                        break; //Amazonas
                                    case 'BA':
                                        this.service.emitirGuia(widget, row, null, null, 'https://sistemas.sefaz.ba.gov.br/sistemas/arasp/pagamento/modulos/dae/pagamento/dae_pagamento.aspx');
                                        break; //Bahia
                                    case 'CE':
                                        this.service.emitirGuia(widget, row, null, null, 'https://servicos.sefaz.ce.gov.br/internet/dae/taxas/default.asp');
                                        break; //Ceará
                                    case 'DF':
                                        this.service.emitirGuia(widget, row, null, null, 'http://www.fazenda.df.gov.br/area.cfm?id_area=1075');
                                        break; //Distrito Federal
                                    case 'ES':
                                        this.service.emitirGuia(widget, row, null, null, 'http://e-dua.sefaz.es.gov.br/');
                                        break; //Espírito Santo
                                    case 'GO':
                                        this.service.emitirGuia(widget, row, null, null, 'https://app.sefaz.go.gov.br/arr-www/view/entradaContribuinte.jsf');
                                        break; //Goiás
                                    case 'MA':
                                        this.service.emitirGuia(widget, row, null, null, 'http://aplicacoes.ma.gov.br/dare/');
                                        break; //Maranhão
                                    case 'MT':
                                        this.service.emitirGuia(widget, row, null, null, 'https://www.sefaz.mt.gov.br/arrecadacao/darlivre/menudarlivre');
                                        break; //Mato Grosso
                                    // case 'MS': this.service.emitirGuia( widget, row, Messages_fiscal.EMITIR_DAEMS,   'daems',   'https://servicos.efazenda.ms.gov.br/sgae/EmissaoDAEMSdeICMS'                                     ); break; //Mato Grosso do Sul
                                    case 'MS':
                                        this.service.emitirGuia(widget, row, null, null, 'https://servicos.efazenda.ms.gov.br/sgae/EmissaoDAEMSdeICMS');
                                        break; //Mato Grosso do Sul
                                    case 'MG':
                                        this.service.emitirGuia(widget, row, null, null, 'https://www2.fazenda.mg.gov.br/arrecadacao/ctrl/ARRECADA/ARRECADA/DOCUMENTO_ARRECADACAO?ACAO=VISUALIZAR');
                                        break; //Minas Gerais
                                    case 'PA':
                                        this.service.emitirGuia(widget, row, null, null, 'https://app.sefa.pa.gov.br/emissao-dae-avulso/#/inicio');
                                        break; //Pará
                                    case 'PB':
                                        this.service.emitirGuia(widget, row, null, null, 'https://www4.receita.pb.gov.br/atf/seg/SEGf_AcessarFuncao.jsp?cdFuncao=ARR_305');
                                        break; //Paraíba
                                    // case 'PR': this.service.emitirGuia( widget, row, Messages_fiscal.EMITIR_GRPR,    'grpr',    'http://www.fazenda.pr.gov.br/modules/conteudo/conteudo.php?conteudo=271'                         ); break; //Paraná
                                    case 'PR':
                                        this.service.emitirGuia(widget, row, null, null, 'http://www.fazenda.pr.gov.br/modules/conteudo/conteudo.php?conteudo=271');
                                        break; //Paraná
                                    case 'PE':
                                        this.service.emitirGuia(widget, row, null, null, 'http://efisco.sefaz.pe.gov.br/sfi_trb_gae/PRGerarDAE');
                                        break; //Pernambuco
                                    case 'PI':
                                        this.service.emitirGuia(widget, row, null, null, 'https://webas.sefaz.pi.gov.br/darweb/');
                                        break; //Piauí
                                    //case 'RJ': this.service.emitirGuia( widget, row, null,                           'darj',     null                                                                                             ); break; //Rio de Janeiro
                                    case 'RJ':
                                        this.service.emitirGuia(widget, row, null, null, 'http://www1.fazenda.rj.gov.br/projetoGCTBradesco/br/gov/rj/sef/gct/web/emitirdocumentoarrecadacao/DocumentoArrecadacaoController.jpf');
                                        break; //Rio de Janeiro
                                    case 'RN':
                                        this.service.emitirGuia(widget, row, null, null, 'https://uvt.set.rn.gov.br/#/home');
                                        break; //Rio Grande do Norte
                                    case 'RS':
                                        this.service.emitirGuia(widget, row, null, null, 'https://www.sefaz.rs.gov.br/EmissorGA/SAR/EmissorGaIcms.aspx');
                                        break; //Rio Grande do Sul
                                    case 'RO':
                                        this.service.emitirGuia(widget, row, null, null, 'https://dareavulso.sefin.ro.gov.br/');
                                        break; //Rondônia
                                    case 'RR':
                                        this.service.emitirGuia(widget, row, null, null, 'https://portalapp.sefaz.rr.gov.br/siate/servlet/wp_siate_dareavulso');
                                        break; //Roraima
                                    // case 'SC': this.service.emitirGuia( widget, row, Messages_fiscal.EMITIR_DARE_SC, 'dare-sc', 'https://tributario.sef.sc.gov.br/tax.NET/Sat.Arrecadacao.Web/DARE_online/EmissaoDareOnline.aspx' ); break; //Santa Catarina
                                    case 'SC':
                                        this.service.emitirGuia(widget, row, null, null, 'https://tributario.sef.sc.gov.br/tax.NET/Sat.Arrecadacao.Web/DARE_online/EmissaoDareOnline.aspx');
                                        break; //Santa Catarina
                                    // case 'SP': this.service.emitirGuia( widget, row, Messages_fiscal.EMITIR_GARE,    'gare',    'https://www.fazenda.sp.gov.br/guiasinternet/gare/paginas/gare.aspx'                              ); break; //São Paulo
                                    case 'SP':
                                        this.service.emitirGuia(widget, row, null, null, 'https://www.fazenda.sp.gov.br/guiasinternet/gare/paginas/gare.aspx');
                                        break; //São Paulo
                                    case 'SE':
                                        this.service.emitirGuia(widget, row, null, null, 'http://www.sefaz.se.gov.br/conteudo/267');
                                        break; //Sergipe
                                    case 'TO':
                                        this.service.emitirGuia(widget, row, null, null, 'http://www.sefaz.to.gov.br/dare/servlet/hnetccwkda');
                                        break; //Tocantins
                                    default:
                                        ScreenService.showMessage(Messages_fiscal.RELATORIO_NAO_DISPONIVEL);
                                } //fim do switch SGESTADO
                                break;
                            case 'G':
                                //GNRE
                                switch (widget.currentRow.SGESTADO) {
                                    case 'SP':
                                        this.service.emitirGuia(widget, row, Messages_fiscal.EMITIR_GNRE_SP, 'gnre-sp', 'https://www.fazenda.sp.gov.br/guiasinternet/Gare/Paginas/Gare.aspx');
                                        break;
                                    default:
                                        ScreenService.showMessage(Messages_fiscal.RELATORIO_NAO_DISPONIVEL);
                                }
                                break;
                        } //fim do switch OPCGUIA
                    } else {
                        //Emissão da guia via sistema da receita, caso a guia esteja vencida este encaminha para o site/birt
                        this.service.guiaDarfReceitaOuBirt(widgetGuia, widget, row, filteredData); //TODO VER CAMPOS!!
                    }
                    break;
                default:
                    ScreenService.showMessage(Messages_fiscal.OPCAO_INVALIDA_GUIA);
            } //fim do switch IDTIPOEMISSAO
        } else ScreenService.showMessage(resul);
    };

    this.emitirGnreTxt = function (args) {
        var checkedRows = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

        //Somente as rows selecionadas
        var rows = checkedRows ? args.owner.widget.getCheckedRows() : [args.owner.widget.currentRow];

        if (!checkedRows) args.owner.widget.dataSource.addCheckedRows(rows[0]);

        var estado = filteredData.SGESTADO;
        //O this.service não está visível no escopo do function do response abaixo. Isto resolve este problema
        var nomeArquivo = this.service.nomeArquivoDatetime;

        //Somente prossegue com a geração se as rows selecionadas estiverem preenchidas
        if (this.service.validaCamposGnreTxt(rows, estado)) {
            //Requisição da string do texto do arquivo
            if (filteredData.OPCGUIA === 'E') {
                if (estado === 'RJ') {
                    self.transmitirLoteRj(args.owner.widget);
                } else if (estado === 'ES') {
                    self.transmitirLoteEs(args.owner.widget);
                }
            } else if (filteredData.OPCGUIA === 'G') {
                if (estado === 'RJ') {
                    self.transmitirLoteRj(args.owner.widget);
                } else if (filteredData.UFFAVORECIDO === 'ES') {
                    self.transmitirLoteEs(args.owner.widget);
                } else if (filteredData.UFFAVORECIDO === 'SP') {
                    General.callRestEngine('fis_guias#/emitirGnreTxt', 'Row', this.service.preparaRow(rows)).then(function (response) {
                        //Criação e download do arquivo texto proveniente da string retornada
                        var blob = new Blob([response.dataset.arquivo[0]], { type: "text/plain" });
                        saveAs(blob, nomeArquivo('gnre', '_', 'txt'));
                    }, function (callback) {
                        if (callback.data) {
                            ScreenService.showMessage(callback.data.error);
                        }
                    });
                } else if (!['RJ', 'SP' /*, 'ES'*/].includes(filteredData.UFFAVORECIDO)) {
                    // teste ES usando IE de PE
                    // self.transmitirLoteEs(args.owner.widget);
                    self.emitirGnreOnline(args.owner.widget);
                }
            }
        }
    };

    self.controlaWidgetErro = function (widget) {
        var widgetErros = templateManager.container.getWidget('widgetErroConsultaLote');
        if (['P', 'U', 'C'].includes(widget.currentRow.IDTRANSMISSAO)) {
            widgetErros.isVisible = true;
        } else {
            widgetErros.isVisible = false;
        }
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register("Fis00200_DocumentoDeArrecadacao_Controller", Fis00200_DocumentoDeArrecadacao_Controller);
});

// FILE: ./assets/modules/relatorios/assets/js/controllers/Fis00098_RelatorioCustomizavelContribuicoes_Controller.js
var Fis00098_RelatorioCustomizavelContribuicoes_Controller = function Fis00098_RelatorioCustomizavelContribuicoes_Controller(General, templateManager, ZhFilterPreferences, metaDataFactory) {

    this.vendasSATNFCe = '1';
    this.vendasECF = '2';
    this.registroEntradasPorItem = '3';
    this.devolucaoComprasPorItem = '4';
    this.devolucaoVendasPorItem = '5';
    this.registroSaidasPorItemNFS = '6';

    this.preparaFiltroEFields = function (relatorioContribuicoes) {
        this.setFieldsGerais(relatorioContribuicoes);
        var rowsToSet = {};
        rowsToSet.RELATORIO = "1";
        rowsToSet.REGIME = null;
        rowsToSet.IDTPEMISVEND = "T";
        ZhFilterPreferences.openFilterWidget(relatorioContribuicoes, rowsToSet);
    };

    this.setFieldsGerais = function (relatorioContribuicoes) {
        templateManager.container.fieldsGerais = relatorioContribuicoes.fields.map(function (field) {
            return field.name;
        });
    };

    this.preparaFiltroPorTipoRelatorio = function (filtro) {
        var tipoRelatorio = filtro.currentRow.RELATORIO;
        var tipoOperacao = filtro.getField('NMTIPOOPER');

        if ([this.vendasSATNFCe, this.vendasECF].includes(tipoRelatorio)) {
            tipoOperacao.readOnly = true;
        } else {
            tipoOperacao.readOnly = false;
        }

        if (this.vendasSATNFCe == tipoRelatorio) {
            filtro.getField('IDTPEMISVEND').isVisible = true;
            filtro.getField('IDTPEMISVEND').class = '4';
            filtro.getField('NMTIPOOPER').class = '4';
            filtro.getField('CDFILIAL').class = '4';
        } else {
            filtro.getField('IDTPEMISVEND').isVisible = false;
            filtro.getField('NMTIPOOPER').class = '6';
            filtro.getField('CDFILIAL').class = '6';
        }
    };

    this.getTipoRelatorio = function (preference) {
        var relatorioContribuicoes = templateManager.container.getWidget('relatorioContribuicoes');
        this.preparaWidgetPorTipoRelatorio(preference, relatorioContribuicoes);
    };

    this.preparaWidgetPorTipoRelatorio = function (preference, relatorioContribuicoes) {
        var tipoRelatorio = preference.FILTER_ROW.RELATORIO;
        var widgetRelatorio = '';
        switch (tipoRelatorio) {
            case this.vendasSATNFCe:
                widgetRelatorio = templateManager.container.getWidget('vendasSATNFCe');
                break;
            case this.vendasECF:
                widgetRelatorio = templateManager.container.getWidget('vendasECF');
                break;
            case this.registroEntradasPorItem:
                widgetRelatorio = templateManager.container.getWidget('registroEntradasPorItem');
                break;
            case this.devolucaoComprasPorItem:
                widgetRelatorio = templateManager.container.getWidget('devolucaoComprasPorItem');
                break;
            case this.devolucaoVendasPorItem:
                widgetRelatorio = templateManager.container.getWidget('devolucaoVendasPorItem');
                break;
            case this.registroSaidasPorItemNFS:
                widgetRelatorio = templateManager.container.getWidget('registroSaidasPorItemNFS');
                break;
        }
        this.setContribuicoesVendasSATNFCe(relatorioContribuicoes, widgetRelatorio);
    };

    this.setContribuicoesVendasSATNFCe = function (relatorioContribuicoes, widgetRelatorio) {
        relatorioContribuicoes.label = widgetRelatorio.label;
        templateManager.container.label = widgetRelatorio.label;
        relatorioContribuicoes.dataSource.name = widgetRelatorio.dataSource.name;
        relatorioContribuicoes.floatingControl.xlsAction.dataSourceName = widgetRelatorio.floatingControl.xlsAction.dataSourceName;
        var fieldsGerais = templateManager.container.fieldsGerais;
        var fieldsDelete = [];
        for (var i = 0; relatorioContribuicoes.fields.length > i; i++) {
            if (!fieldsGerais.includes(relatorioContribuicoes.fields[i].name)) {
                fieldsDelete.push(i);
            }
        }
        fieldsDelete.sort();
        for (var j = fieldsDelete.length - 1; j >= 0; j--) {
            relatorioContribuicoes.fields.splice(fieldsDelete[j], 1);
        }

        widgetRelatorio.fields.forEach(function (field) {
            relatorioContribuicoes.fields.push(field);
        });

        relatorioContribuicoes.redraw();
    };

    this.completaProduto = function (produto) {
        var mask = getLocalVar('CDPICTPROD');
        var length = 0;

        for (var i = mask.length - 1; i >= 0; i--) {
            if (mask[i] === '9' || mask[i] === '*') {
                length++;
            }
        }

        for (i = produto.length; i < length; i++) {
            produto += 'Z';
        }

        return produto;
    };

    this.preparaFiltroContribuicoes = function (widget, preference) {
        var produtoInicial = preference.FILTER_ROW.PRODUTOINI;
        var produtoFinal = this.completaProduto(preference.FILTER_ROW.PRODUTOFIN);
        var filial = preference.FILTER_ROW.CDFILIAL;
        widget.dataSourceFilter.forEach(function (filter) {
            switch (filter.name) {
                case 'CDFILIAL':
                    filter.value = Array.isArray(filial.value) ? filial.value.toString().replace(/,/g, '_') : null;
                    break;
                case 'REGIME':
                    filter.value = preference.FILTER_ROW.REGIME ? preference.FILTER_ROW.REGIME : null;
                    break;
                case 'CDIMPOSTO':
                    filter.value = preference.FILTER_ROW.CDIMPOSTO;
                    break;
                case 'PRODUTOINI':
                    filter.value = produtoInicial;
                    break;
                case 'PRODUTOFIN':
                    filter.value = produtoFinal;
                    break;
                case 'DTINICIO':
                    filter.value = preference.FILTER_ROW.DTINICIO.substr(0, 10);
                    break;
                case 'DTFINAL':
                    filter.value = preference.FILTER_ROW.DTFINAL.substr(0, 10);
                    break;
            }
        });

        var dataSourceFilter = widget.dataSourceFilter;

        preference.CUSTOM_FILTER_ROW = Util.clone(preference.FILTER_ROW);
        var tipoRelatorio = preference.FILTER_ROW.RELATORIO;
        for (var t = dataSourceFilter.length - 1; t >= 0; t--) {
            if (dataSourceFilter[t].name === 'NMTIPOOPER') {
                dataSourceFilter.splice(t, 1);
            }
            if (dataSourceFilter[t].name === 'CDTIPOOPER') {
                dataSourceFilter.splice(t, 1);
            }
        }
        if ([this.vendasSATNFCe, this.vendasECF].includes(tipoRelatorio)) {
            if (preference.CUSTOM_FILTER_ROW.hasOwnProperty('NMTIPOOPER')) {
                delete preference.CUSTOM_FILTER_ROW.NMTIPOOPER;
            }
            if (preference.CUSTOM_FILTER_ROW.hasOwnProperty('CDTIPOOPER')) {
                delete preference.CUSTOM_FILTER_ROW.CDTIPOOPER;
            }
        } else {
            dataSourceFilter.push({
                "name": "CDTIPOOPER",
                "operator": "=",
                "value": preference.FILTER_ROW.IDENTRSAIDOP + preference.FILTER_ROW.CDTIPOOPER
            });
            preference.CUSTOM_FILTER_ROW.CDTIPOOPER = preference.FILTER_ROW.IDENTRSAIDOP + preference.FILTER_ROW.CDTIPOOPER;
        }

        if (this.vendasSATNFCe == tipoRelatorio) {
            dataSourceFilter.push({
                "name": "IDTPEMISVEND",
                "operator": "=",
                "value": preference.FILTER_ROW.IDTPEMISVEND
            });
            preference.CUSTOM_FILTER_ROW.IDTPEMISVEND = preference.FILTER_ROW.IDTPEMISVEND;
        } else {
            if (preference.CUSTOM_FILTER_ROW.hasOwnProperty('IDTPEMISVEND')) {
                delete preference.CUSTOM_FILTER_ROW.IDTPEMISVEND;
            }

            dataSourceFilter.forEach(function (filter, index) {
                if (filter.name == 'IDTPEMISVEND') {
                    dataSourceFilter.splice(index, 1);
                }
            });
        }

        for (var i = dataSourceFilter.length - 1; i >= 0; i--) {
            if (dataSourceFilter[i].name === 'NRSEQUMAPAPU') {
                dataSourceFilter.splice(i, 1);
            }
            if (dataSourceFilter[i].name === 'RELATORIO') {
                dataSourceFilter.splice(i, 1);
            }
        }

        this.getTipoRelatorio(preference);

        if (preference.CUSTOM_FILTER_ROW.hasOwnProperty('NRSEQUMAPAPU')) {
            delete preference.CUSTOM_FILTER_ROW.NRSEQUMAPAPU;
        }
        if (preference.CUSTOM_FILTER_ROW.hasOwnProperty('RELATORIO')) {
            delete preference.CUSTOM_FILTER_ROW.RELATORIO;
        }
    };

    this.setValuesFilter = function (field, widget) {
        field.dataSourceFilter.forEach(function (filter) {
            switch (filter.name) {
                case 'CDEMPRESA':
                    filter.value = widget.currentRow.CDEMPRESA;
                    break;
                case 'CDIMPOSTO':
                    filter.value = widget.currentRow.CDIMPOSTO;
                    break;
            }
        });
    };

    this.filterRules = function (widget) {
        var empresa = widget.currentRow.CDEMPRESA;
        var imposto = widget.currentRow.CDIMPOSTO;
        var fieldMapa = widget.getField('NMMAPAAPUR');

        if (empresa && imposto) {
            fieldMapa.readOnly = false;
            fieldMapa.value(null);
            this.setValuesFilter(fieldMapa, widget);
        } else {
            fieldMapa.readOnly = true;
            widget.currentRow.NMMAPAAPUR = null;
            widget.currentRow.NRSEQUMAPAPU = null;
            widget.currentRow.DTINIPERIODO = null;
            widget.currentRow.DTFIMPERIODO = null;
        }
    };

    this.getCdnvproduto = function () {
        var levelMask = General.getLevelByMask('CDPICTPROD', 1);
        return levelMask.length;
    };

    this.setPlaceholder = function (widget) {
        var maxValue = this.getCdnvproduto;
        var field = widget.getField('NVTOT');
        field.placeholder = 'O nível máximo de totalização é '.maxValue;
    };

    this.validaTotniv = function (widget) {
        var NVTOT = widget.currentRow.NVTOT;
        if (NVTOT > this.getCdnvproduto()) {
            widget.currentRow.NVTOT = null;
        }
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis00098_RelatorioCustomizavelContribuicoes_Controller', Fis00098_RelatorioCustomizavelContribuicoes_Controller);
});

// FILE: ./assets/modules/relatorios/assets/js/controllers/Fis00111_RelatorioCustomizavelEmissaoLancamentosNF_Controller.js
var Fis00111_RelatorioCustomizavelEmissaoLancamentosNF_Controller = function Fis00111_RelatorioCustomizavelEmissaoLancamentosNF_Controller(ZHPromise, General, templateManager, ScreenService, ZhFilterPreferences) {
    /* Variável de Inicialização */
    var self = this;
    var CDTIPOOPER = false; // Armazena o tipo de operação do filtro atual. Serve para se transferir os valores para o próximo filtro
    var IDENTRSAIDOP_AR = false;

    /* Abre Filtro */
    self.openFilter = function (widget) {
        self.searchUnidadeSession(widget).then(function (filial) {
            var rowSetFilter = {
                'CDFILIAL': widget.filial.CDFILIAL,
                'NMFILIAL': widget.filial.NMFILIAL,
                'IDENTRSAIDOP': widget.filial.IDENTRSAIDOP
            };
            ZhFilterPreferences.setOriginalFilter(widget.id, rowSetFilter);
            ZhFilterPreferences.openFilterWidget(widget, rowSetFilter);
        }).catch(function () {
            ZhFilterPreferences.setOriginalFilter(widget.id);
            ZhFilterPreferences.openFilterWidget(widget);
        });
    };

    /* Busca Unidade Sessão */
    self.searchUnidadeSession = function (widget) {
        var deferred = ZHPromise.defer();

        var filter = [{
            "name": "CDFILIAL",
            "operator": "=",
            "value": getLocalVar('CDFILIAL')
        }];

        General.callRestEngine('fis#/crud/filial', 'FilterData', filter).then(function (response) {
            widget.filial = response.dataset.filial[0];
            deferred.resolve();
        });

        return deferred.promise;
    };

    /* Aplica Filtro */
    self.applyFilter = function (widget, filterRow) {

        var cdfilial = filterRow.CDFILIAL;
        var identrsaidop = filterRow.ENTRSAID;
        var cdtipooper = filterRow.CDTIPOOPER;
        var dtentrsaid = filterRow.DTENTRSAID;
        var idstatus = filterRow.IDSTATUS;
        var idstatusnfe = filterRow.IDSTATUSNFE;

        if (identrsaidop == 'E') {
            widget.dataSource.name = 'fis_relatorios#/crud/notafiscal_entrada_emissaoLancNF';
            widget.floatingControl.xlsAction.dataSourceName = "notafiscal_entrada_emissaoLancNF";
            widget.floatingControl.pdfAction.dataSourceName = "notafiscal_entrada_emissaoLancNF";
        } else {
            widget.dataSource.name = 'fis_relatorios#/crud/notafiscal_saida_emissaoLancNF';
            widget.floatingControl.xlsAction.dataSourceName = "notafiscal_saida_emissaoLancNF";
            widget.floatingControl.pdfAction.dataSourceName = "notafiscal_saida_emissaoLancNF";
        }

        widget.dataSourceFilter.forEach(function (filtro) {
            switch (filtro.name) {
                case 'P_CDTIPOOPER':
                    filtro.value = cdtipooper ? cdtipooper.length > 0 ? '_' + cdtipooper.join('_') + '_' : null : null;
                    break;
                case 'P_DTINI':
                    filtro.value = dtentrsaid.start;
                    break;
                case 'P_DTFIN':
                    filtro.value = dtentrsaid.end;
                    break;
                case 'P_FILIAL':
                    filtro.value = cdfilial;
                    break;
                case 'P_TCDTIPOOPER':
                    filtro.value = cdtipooper ? cdtipooper.length > 0 ? null : 'T' : 'T';
                    break;
                case 'P_IDSTATUS':
                    filtro.value = idstatus ? idstatus.length > 0 ? '_' + idstatus.join('_') + '_' : null : null;
                    break;
                case 'P_TIDSTATUS':
                    filtro.value = idstatus ? idstatus.length > 0 ? null : 'T' : 'T';
                    break;
                case 'P_IDSTATUSNFE':
                    filtro.value = idstatusnfe ? idstatusnfe.length > 0 ? '_' + idstatusnfe.join('_') + '_' : null : null;
                    break;
                case 'P_TIDSTATUSNFE':
                    filtro.value = idstatusnfe ? idstatusnfe.length > 0 ? null : 'T' : 'T';
                    break;
            }
        });

        widget.getField('CDFILIAL').filterProperties.isVisible = false;
        widget.getField('NMFILIAL').filterProperties.isVisible = false;
        widget.getField('DTENTRSAID').filterProperties.isVisible = false;
        widget.getField('ENTRSAID').filterProperties.isVisible = false;
        widget.getField('CDTIPOOPER').filterProperties.isVisible = false;
        widget.getField('IDSTATUS').filterProperties.isVisible = false;
    };

    /* Altera Tipo de Nota Fiscal */
    self.changeTipoNF = function (widget) {
        //self.reloadTipoOper(widget);
        self.reloadStatus(widget);
    };

    /* Recarrega Tipo de Operação 
    self.reloadTipoOper = function(widget){
        // Field CDTIPOOPER
        widget.fields[10].value('');
        
        // Field NMTIPOOPER c/ nome no filtro de CDTIPOOPER
        widget.fields[10].value('');
        widget.fields[10].dataSourceFilter[0].value = widget.getField('IDENTRSAIDOP').value();
        widget.fields[10].reload();
    };*/

    /* Recarrega Status */
    self.reloadStatus = function (widget) {
        widget.getField('IDSTATUSNFE').value('');

        if (widget.getField('ENTRSAID').value() == 'S') widget.getField('IDSTATUSNFE').isVisible = true;else widget.getField('IDSTATUSNFE').isVisible = false;
    };

    this.tipoRules = function (widget) {
        var tipo = widget.currentRow.ENTRSAID;
        var field = widget.getField('CDTIPOOPER');

        if (tipo) {
            field.readOnly = false;
            field.dataSourceFilter = [{
                "name": "IDENTRSAIDOP",
                "operator": "=",
                "value": tipo
            }];
            field.reload();
        } else {
            //field.readOnly = true;
            field.dataSourceFilter = [];
        }
        widget.currentRow.IDENTRSAIDOP = null;
    };
    this.statusDaNota = function (widget) {
        var status = widget.currentRow.IDSTATUSNFE;

        if (status == 'P') {
            status.dataSourceFilter = 'P';
        } else if (status == 'A') {
            status.dataSourceFilter = 'A';
        } else if (status == 'D') {
            status.dataSourceFilter = 'D';
        } else if (status == 'T') {
            status.dataSourceFilter = 'T';
        } else if (status == 'R') {
            status.dataSourceFilter = 'R';
        } else {
            status.dataSourceFilter = 'C';
        }
    };
};

/* global Configuration */
Configuration(function (ContextRegister) {
    ContextRegister.register('Fis00111_RelatorioCustomizavelEmissaoLancamentosNF_Controller', Fis00111_RelatorioCustomizavelEmissaoLancamentosNF_Controller);
});

// FILE: ./assets/modules/relatorios/assets/js/controllers/Fis00811_RelatorioImpostosPorNota_Controller.js
var Fis00811_RelatorioImpostosPorNota_Controller = function Fis00811_RelatorioImpostosPorNota_Controller(templateManager, ZhFilterPreferences, ScreenService) {

    this.IMPOSTO_FEDERAL = 'F';
    this.IMPOSTO_ESTADUAL = 'E';
    this.IMPOSTO_MUNICIPAL = 'M';

    this.openFilter = function (widget) {
        var rowsToSet = {};
        rowsToSet.IDENTRSAIDOP = "E";
        ZhFilterPreferences.openFilterWidget(widget, rowsToSet);
    };

    this.filtraTipoOperacao = function (widget) {
        widget.getField('CDTIPOOPER').dataSourceFilter[0].value = widget.getField('IDENTRSAIDOP').value();
        widget.getField('CDTIPOOPER').reload();
    };

    this.filterMapaApuracao = function (widget, field) {
        var mapa = widget.getField('NRSEQUMAPAPU');
        mapa.dataSourceFilter.forEach(function (filter) {
            switch (filter.name) {
                case 'CDINSCESTA':
                    filter.value = widget.currentRow.CDINSCESTA ? widget.currentRow.CDINSCESTA : null;
                    break;
                case 'CDINSCMUNI':
                    filter.value = widget.currentRow.CDINSCMUNI ? widget.currentRow.CDINSCMUNI : null;
                    break;
            }
        });
        if (field) {
            mapa.readOnly = field.value() ? false : true;
        }
    };

    this.preparaFiltroImpostoNota = function (widget, preference) {
        var filial = Array.isArray(preference.FILTER_ROW.CDFILIAL) ? preference.FILTER_ROW.CDFILIAL.join('_') : preference.FILTER_ROW.CDFILIAL;
        var cdtipooper = Array.isArray(preference.FILTER_ROW.CDTIPOOPER) ? preference.FILTER_ROW.CDTIPOOPER.join('_') : preference.FILTER_ROW.CDTIPOOPER;
        var valuesCustomFilter = { 'CDFILIAL': filial, 'CDTIPOOPER': cdtipooper };
        widget.dataSourceFilter.forEach(function (filter) {
            switch (filter.name) {
                case 'CDTIPOOPER':
                    filter.value = cdtipooper ? cdtipooper : null;
                    break;
                case 'NRSEQUMAPAPU':
                    filter.value = preference.FILTER_ROW.NRSEQUMAPAPU ? preference.FILTER_ROW.NRSEQUMAPAPU : null;
                    break;
                case 'CDFILIAL':
                    filter.value = filial ? filial : null;
                    break;
                case 'IDENTRSAIDOP':
                    filter.value = preference.FILTER_ROW.IDENTRSAIDOP ? preference.FILTER_ROW.IDENTRSAIDOP : null;
                    break;
            }
        });
        this.removeFieldsClausulaWhere(widget, preference, valuesCustomFilter);
    };

    this.removeFieldsClausulaWhere = function (widget, preference, valuesCustomFilter) {
        var filtrosRemoviveis = ['CDEMPRESA', 'NMFILIAL'];
        var dataSourceFilter = widget.dataSourceFilter;
        for (var i = dataSourceFilter.length - 1; i >= 0; i--) {
            if (filtrosRemoviveis.includes(dataSourceFilter[i].name)) {
                dataSourceFilter.splice(i, 1);
            }
        }
        preference.CUSTOM_FILTER_ROW = Util.clone(preference.FILTER_ROW);
        for (var key in preference.CUSTOM_FILTER_ROW) {
            if (filtrosRemoviveis.includes(key)) {
                delete preference.CUSTOM_FILTER_ROW[key];
            }
            if (valuesCustomFilter.hasOwnProperty(key)) {
                preference.CUSTOM_FILTER_ROW[key] = valuesCustomFilter[key];
            }
        }
    };

    this.validaCompetenciaSobreImposto = function (widget) {
        var empresa = widget.currentRow.CDEMPRESA;
        var imposto = widget.currentRow.CDIMPOSTO;
        var fieldMapa = widget.getField('NRSEQUMAPAPU');
        var inscricaoEstadual = widget.getField('CDINSCESTA');
        var inscricaoMunicipal = widget.getField('CDINSCMUNI');
        if (empresa && imposto) {
            fieldMapa.value(null);
            this.setValuesFilter(fieldMapa, widget);
            inscricaoEstadual.dataSourceFilter[0].value = widget.currentRow.CDEMPRESA;
            inscricaoMunicipal.dataSourceFilter[0].value = widget.currentRow.CDEMPRESA;
            if (widget.currentRow.IDORGARRECADNFE == this.IMPOSTO_FEDERAL) {
                inscricaoEstadual.readOnly = true;
                inscricaoMunicipal.readOnly = true;
                inscricaoEstadual.validations = {};
                inscricaoMunicipal.validations = {};
                widget.currentRow.CDINSCESTA = null;
                widget.currentRow.CDINSCMUNI = null;
                fieldMapa.readOnly = false;
                fieldMapa.clearValue();
            } else if (widget.currentRow.IDORGARRECADNFE == this.IMPOSTO_ESTADUAL) {
                inscricaoEstadual.readOnly = false;
                inscricaoEstadual.validations = { 'required': true };
                inscricaoMunicipal.readOnly = true;
                inscricaoMunicipal.validations = {};
                widget.currentRow.CDINSCMUNI = null;
                fieldMapa.readOnly = true;
                fieldMapa.clearValue();
            } else if (widget.currentRow.IDORGARRECADNFE == this.IMPOSTO_MUNICIPAL) {
                inscricaoEstadual.readOnly = true;
                inscricaoEstadual.validations = {};
                inscricaoMunicipal.readOnly = false;
                inscricaoMunicipal.validations = { 'required': true };
                widget.currentRow.CDINSCESTA = null;
                fieldMapa.readOnly = true;
                fieldMapa.clearValue();
            }
        } else {
            fieldMapa.readOnly = true;
            widget.currentRow.NMMAPAAPUR = null;
            widget.currentRow.NRSEQUMAPAPU = null;
            widget.currentRow.DTINIPERIODO = null;
            widget.currentRow.DTFIMPERIODO = null;
            inscricaoEstadual.readOnly = true;
            inscricaoEstadual.validations = {};
            inscricaoMunicipal.readOnly = true;
            inscricaoMunicipal.validations = {};
            widget.currentRow.CDINSCESTA = null;
            widget.currentRow.CDINSCMUNI = null;
        }
        this.filterMapaApuracao(widget);
    };

    this.setValuesFilter = function (field, widget) {
        field.dataSourceFilter.forEach(function (filter) {
            switch (filter.name) {
                case 'CDEMPRESA':
                    filter.value = widget.currentRow.CDEMPRESA;
                    break;
                case 'CDIMPOSTO':
                    filter.value = widget.currentRow.CDIMPOSTO;
                    break;
            }
        });
    };

    this.setNameLayout = function (args) {
        var widget = args.owner;
        if (!widget.hasOwnProperty('labelPrincipal')) {
            widget.labelPrincipal = widget.label;
        }
        if (args.e.layout.ID == 'ORIGINAL') {
            widget.container.label = widget.labelPrincipal;
            widget.label = widget.labelPrincipal;
        } else {
            widget.container.label = args.e.layout.LABEL_TO_PREFERENCE;
            widget.label = args.e.layout.LABEL_TO_PREFERENCE;
        }
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis00811_RelatorioImpostosPorNota_Controller', Fis00811_RelatorioImpostosPorNota_Controller);
});

// FILE: ./assets/modules/relatorios/assets/js/controllers/Fis20600_RelatoriosCustomizavelImpostosProdutoMapaApuracao_Controller.js
var Fis20600_RelatoriosCustomizavelImpostosProdutoMapaApuracao_Controller = function Fis20600_RelatoriosCustomizavelImpostosProdutoMapaApuracao_Controller(templateManager, ZhFilterPreferences) {

    this.IMPOSTO_FEDERAL = 'F';
    this.IMPOSTO_ESTADUAL = 'E';
    this.IMPOSTO_MUNICIPAL = 'M';

    this.openFilter = function (widget) {
        var rowsToSet = {};
        rowsToSet.IDENTRSAIDOP = "E";
        ZhFilterPreferences.openFilterWidget(widget, rowsToSet);
    };

    this.filtraTipoOperacao = function (widget) {
        widget.getField('CDTIPOOPER').dataSourceFilter[0].value = widget.getField('IDENTRSAIDOP').value();
        widget.getField('CDTIPOOPER').reload();
    };

    this.filterMapaApuracao = function (widget, field) {
        var mapa = widget.getField('NMMAPAAPUR');
        mapa.dataSourceFilter.forEach(function (filter) {
            switch (filter.name) {
                case 'CDINSCESTA':
                    filter.value = widget.currentRow.CDINSCESTA ? widget.currentRow.CDINSCESTA : null;
                    break;
                case 'CDINSCMUNI':
                    filter.value = widget.currentRow.CDINSCMUNI ? widget.currentRow.CDINSCMUNI : null;
                    break;
            }
        });
        if (field) {
            mapa.readOnly = field.value() ? false : true;
        }
    };

    this.preparaFiltroImpostoMapaApuracao = function (widget, preference) {
        var filial = Array.isArray(preference.FILTER_ROW.CDFILIAL) ? preference.FILTER_ROW.CDFILIAL.join('_') : preference.FILTER_ROW.CDFILIAL;
        var cdtipooper = Array.isArray(preference.FILTER_ROW.CDTIPOOPER) ? preference.FILTER_ROW.CDTIPOOPER.join('_') : preference.FILTER_ROW.CDTIPOOPER;
        var valuesCustomFilter = { 'CDFILIAL': filial, 'CDTIPOOPER': cdtipooper };
        widget.dataSourceFilter.forEach(function (filter) {
            switch (filter.name) {
                case 'CDEMPRESA':
                    filter.value = preference.FILTER_ROW.CDEMPRESA ? preference.FILTER_ROW.CDEMPRESA : null;
                    break;
                case 'CDIMPOSTO':
                    filter.value = preference.FILTER_ROW.CDIMPOSTO;
                    break;
                case 'CDINSCESTA':
                    filter.value = preference.FILTER_ROW.CDINSCESTA ? preference.FILTER_ROW.CDINSCESTA : null;
                    break;
                case 'CDTIPOOPER':
                    filter.value = cdtipooper ? cdtipooper : null;
                    break;
                case 'CDINSCMUNI':
                    filter.value = preference.FILTER_ROW.CDINSCMUNI ? preference.FILTER_ROW.CDINSCMUNI : null;
                    break;
                case 'CDFILIAL':
                    filter.value = filial ? filial : null;
                    break;
                case 'DTINICIAL':
                    filter.value = preference.FILTER_ROW.DTINICIAL.substr(0, 10);
                    break;
                case 'DTFINAL':
                    filter.value = preference.FILTER_ROW.DTFINAL.substr(0, 10);
                    break;
                case 'IDENTRSAIDOP':
                    filter.value = preference.FILTER_ROW.IDENTRSAIDOP ? preference.FILTER_ROW.IDENTRSAIDOP : null;
                    break;
            }
        });
        this.removeFieldsClausulaWhere(widget, preference, valuesCustomFilter);
    };

    this.removeFieldsClausulaWhere = function (widget, preference, valuesCustomFilter) {
        var filtrosRemoviveis = ['NRSEQUMAPAPU', 'NMTIPOOPER', 'NMFILIAL'];
        var dataSourceFilter = widget.dataSourceFilter;
        for (var i = dataSourceFilter.length - 1; i >= 0; i--) {
            if (filtrosRemoviveis.includes(dataSourceFilter[i].name)) {
                dataSourceFilter.splice(i, 1);
            }
        }
        preference.CUSTOM_FILTER_ROW = Util.clone(preference.FILTER_ROW);
        for (var key in preference.CUSTOM_FILTER_ROW) {
            if (filtrosRemoviveis.includes(key)) {
                delete preference.CUSTOM_FILTER_ROW[key];
            }
            if (valuesCustomFilter.hasOwnProperty(key)) {
                preference.CUSTOM_FILTER_ROW[key] = valuesCustomFilter[key];
            }
        }
    };

    this.validaCompetenciaSobreImposto = function (widget) {
        var empresa = widget.currentRow.CDEMPRESA;
        var imposto = widget.currentRow.CDIMPOSTO;
        var fieldMapa = widget.getField('NMMAPAAPUR');
        var inscricaoEstadual = widget.getField('CDINSCESTA');
        var inscricaoMunicipal = widget.getField('CDINSCMUNI');
        if (empresa && imposto) {
            fieldMapa.value(null);
            this.setValuesFilter(fieldMapa, widget);
            inscricaoEstadual.dataSourceFilter[0].value = widget.currentRow.CDEMPRESA;
            inscricaoMunicipal.dataSourceFilter[0].value = widget.currentRow.CDEMPRESA;
            if (widget.currentRow.IDORGARRECADNFE == this.IMPOSTO_FEDERAL) {
                inscricaoEstadual.readOnly = true;
                inscricaoMunicipal.readOnly = true;
                inscricaoEstadual.validations = {};
                inscricaoMunicipal.validations = {};
                widget.currentRow.CDINSCESTA = null;
                widget.currentRow.CDINSCMUNI = null;
                fieldMapa.readOnly = false;
                fieldMapa.clearValue();
            } else if (widget.currentRow.IDORGARRECADNFE == this.IMPOSTO_ESTADUAL) {
                inscricaoEstadual.readOnly = false;
                inscricaoEstadual.validations = { 'required': true };
                inscricaoMunicipal.readOnly = true;
                inscricaoMunicipal.validations = {};
                widget.currentRow.CDINSCMUNI = null;
                fieldMapa.readOnly = true;
                fieldMapa.clearValue();
            } else if (widget.currentRow.IDORGARRECADNFE == this.IMPOSTO_MUNICIPAL) {
                inscricaoEstadual.readOnly = true;
                inscricaoEstadual.validations = {};
                inscricaoMunicipal.readOnly = false;
                inscricaoMunicipal.validations = { 'required': true };
                widget.currentRow.CDINSCESTA = null;
                fieldMapa.readOnly = true;
                fieldMapa.clearValue();
            }
        } else {
            fieldMapa.readOnly = true;
            widget.currentRow.NMMAPAAPUR = null;
            widget.currentRow.NRSEQUMAPAPU = null;
            widget.currentRow.DTINIPERIODO = null;
            widget.currentRow.DTFIMPERIODO = null;
            inscricaoEstadual.readOnly = true;
            inscricaoEstadual.validations = {};
            inscricaoMunicipal.readOnly = true;
            inscricaoMunicipal.validations = {};
            widget.currentRow.CDINSCESTA = null;
            widget.currentRow.CDINSCMUNI = null;
        }
        this.filterMapaApuracao(widget);
    };

    this.setValuesFilter = function (field, widget) {
        field.dataSourceFilter.forEach(function (filter) {
            switch (filter.name) {
                case 'CDEMPRESA':
                    filter.value = widget.currentRow.CDEMPRESA;
                    break;
                case 'CDIMPOSTO':
                    filter.value = widget.currentRow.CDIMPOSTO;
                    break;
            }
        });
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis20600_RelatoriosCustomizavelImpostosProdutoMapaApuracao_Controller', Fis20600_RelatoriosCustomizavelImpostosProdutoMapaApuracao_Controller);
});

// FILE: ./assets/modules/relatorios/assets/js/controllers/Fis20600_RelatoriosCustomizavelImpostosProduto_Controller.js
var Fis20600_RelatoriosCustomizavelImpostosProduto_Controller = function Fis20600_RelatoriosCustomizavelImpostosProduto_Controller(templateManager, ZhFilterPreferences) {

    this.openFilter = function (widget) {
        var rowsToSet = {};
        rowsToSet.REPORT = "DC";
        ZhFilterPreferences.openFilterWidget(widget, rowsToSet);
    };

    this.reloadFields = function (widget) {
        widget.getField('CDINSCMUNI').reload();
        widget.getField('CDINSCESTA').reload();
    };

    this.filter = function (args) {
        //var filterRow = args.e.preference.FILTER_ROW;
        var widget = args.owner;
        var filterRow = widget.appliedFilter.FILTER_ROW;
        var filtro = [];
        filtro = [{
            'name': 'CDINSCESTA',
            'operator': '=',
            'value': filterRow.CDINSCESTA && filterRow.CDINSCESTA != '' ? filterRow.CDINSCESTA : null
        }, {
            'name': 'CDINSCMUNI',
            'operator': '=',
            'value': filterRow.CDINSCMUNI && filterRow.CDINSCMUNI != '' ? filterRow.CDINSCMUNI : null
        }, {
            'name': 'ENTRSAID',
            'operator': '=',
            'value': filterRow.ENTRSAID && filterRow.ENTRSAID != '' ? filterRow.ENTRSAID : null
        }, {
            'name': 'DTINICIAL',
            'operator': '=',
            'value': filterRow.DATEINTERVAL.start && filterRow.DATEINTERVAL.start != '' ? filterRow.DATEINTERVAL.start : null
        }, {
            'name': 'DTFINAL',
            'operator': '=',
            'value': filterRow.DATEINTERVAL.end && filterRow.DATEINTERVAL.end != '' ? filterRow.DATEINTERVAL.end : null
        }, {
            'name': 'CDFILIAL',
            'operator': '=',
            'value': filterRow.CDFILIAL && filterRow.CDFILIAL != '' ? filterRow.CDFILIAL : null
        }, {
            'name': 'CDEMPRESA',
            'operator': '=',
            'value': filterRow.CDEMPRESA && filterRow.CDEMPRESA != '' ? filterRow.CDEMPRESA : null
        }];

        if (filterRow.CDIMPOSTO) {
            if (filterRow.CDIMPOSTO.length > 0) {
                var filtroCdimposto = '_';
                filterRow.CDIMPOSTO.forEach(function (cdimposto) {
                    filtroCdimposto = filtroCdimposto + cdimposto + '_';
                });
                filtro.push({
                    "name": "CDIMPOSTO",
                    "operator": "=",
                    "value": filtroCdimposto
                });
            }
        }

        if (filterRow.CDTIPOOPER) {
            var filtroCdtipooper = '_';
            for (var i = 0; i < filterRow.CDTIPOOPER.length; ++i) {
                filtroCdtipooper = filtroCdtipooper + filterRow.IDENTRSAIDOP[i] + filterRow.CDTIPOOPER[i] + '_';
            }
            filtro.push({
                "name": "CDTIPOOPER",
                "operator": "=",
                "value": filtroCdtipooper
            });
        }

        widget.dataSourceFilter = filtro;

        delete filterRow.DATEINTERVAL;
        delete filterRow.REPORT;

        widget.reload();
    };

    /*  this.filter = function(args) {
          args.e.preventDefault();
          var widget = args.owner;
          var widgetFilter = widget.appliedFilter;
          var filtro = widget.dataSourceFilter;
          widget.getField('CDTIPOOPER').reload();
          widget.getField('CDIMPOSTO').reload();
          
          for (var i = filtro.length - 1; i >= 0; i--) {
              if (filtro[i].name === 'period') {
                  filtro.splice(i, 1);
              }
          }
           for (var j = filtro.length - 1; j >= 0; j--) {
              if (filtro[j].name === 'REPORT') {
                  filtro.splice(j, 1);
              }
          }
           for (var k = filtro.length - 1; k >= 0; k--) {
              if (filtro[k].name === 'CDIMPOSTO') {
                  filtro.splice(k, 1);
              }
          }
           for (var m = filtro.length - 1; m >= 0; m--) {
              if (filtro[m].name === 'CDFILIAL') {
                  filtro.splice(m, 1);
              }
          }
           for (var l = filtro.length - 1; l >= 0; l--) {
              if (filtro[l].name === 'NMFILIAL') {
                  filtro.splice(l, 1);
              }
          }
           var cdtipooper = widgetFilter.FILTER_ROW.CDTIPOOPER;
          var identrsaidop = widgetFilter.FILTER_ROW.IDENTRSAIDOP;
          var cdtipooperFilter = [];
          
          var entrsaid = false;
          var cdinscmuni = false;
          var cdinscesta = false;
          
          
          if(cdtipooper){
              for (i = 0; i < cdtipooper.length; i++) {
                  cdtipooperFilter.push(identrsaidop[i]+cdtipooper[i]);
              }
              cdtipooperFilter = cdtipooperFilter.toString().replace(/,/g, '_');
          }else{
              cdtipooper = false;
          }
           filtro.forEach(function(element) {
              if (element.name === 'ENTRSAID') {
                  entrsaid = true;
              } else if (element.name === 'CDINSCMUNI') {
                  cdinscmuni = true;
              } else if (element.name === 'CDINSCESTA') {
                  cdinscesta = true;
              } else if (element.name === 'start') {
                  element.name = 'DTINICIAL';
              } else if (element.name === 'end') {
                  element.name = 'DTFINAL';
              } else if (element.name === 'CDTIPOOPER') {
                  element.value = cdtipooperFilter;
              }
          });
          
          
           if (!entrsaid && widgetFilter.FILTER_ROW.REPORT === 'DC') {
              filtro.push(
                  {
                      "name": "ENTRSAID",
                      "operator": "=",
                      "value": null    
                  }
              );
          } else if (widgetFilter.FILTER_ROW.REPORT !== 'DC') {
              for (var s = filtro.length - 1; s >= 0; s--) {
                  if (filtro[s].name === 'ENTRSAID') {
                      filtro.splice(s, 1);
                  }
              }
          }
           if (!cdinscmuni) {
              filtro.push(
                  {
                      "name": "CDINSCMUNI",
                      "operator": "=",
                      "value": null    
                  }
              );
          }
          
          if (!cdtipooper){
              filtro.push(
                  {
                      "name": "CDTIPOOPER",
                      "operator": "=",
                      "value": null    
                  }
              );
          }
           if (!cdinscesta) {
              filtro.push(
                  {
                      "name": "CDINSCESTA",
                      "operator": "=",
                      "value": null    
                  }
              );
          }
           filtro.push(
              {
                  "name": "CDIMPOSTO",
                  "operator": "=",
                  "value": widgetFilter.FILTER_ROW.CDIMPOSTO ? widgetFilter.FILTER_ROW.CDIMPOSTO.toString().replace(/,/g, '_') : null
              }
          );
           filtro.push(
              {
                  "name": "CDFILIAL",
                  "operator": "=",
                  "value": widgetFilter.FILTER_ROW.CDFILIAL ? widgetFilter.FILTER_ROW.CDFILIAL.toString().replace(/,/g, '_') : null
              }
          );
          
          widget.getField('DATEINTERVAL').isVisible = false;
          
          widget.reload();
      };
    */
    this.filterRules = function (widget) {
        var empresa = widget.currentRow.CDEMPRESA;
        var fieldMuni = widget.getField('CDINSCMUNI');
        var fieldEstadu = widget.getField('CDINSCESTA');

        if (empresa) {
            fieldMuni.readOnly = false;
            fieldEstadu.readOnly = false;
            fieldMuni.reload();
            fieldEstadu.reload();
            fieldMuni.dataSourceFilter[0].value = empresa;
            fieldEstadu.dataSourceFilter[0].value = empresa;
        } else {
            fieldMuni.readOnly = true;
            fieldEstadu.readOnly = true;
            widget.currentRow.CDINSCMUNI = null;
            widget.currentRow.CDINSCESTA = null;
            fieldMuni.dataSourceFilter[0].value = '';
            fieldEstadu.dataSourceFilter[0].value = '';
        }

        this.inscrFilterRules(widget);
    };

    this.inscrFilterRules = function (widget) {
        widget.getField('CDINSCESTA').dataSourceFilter = [{
            "name": "CDEMPRESA",
            "operator": "=",
            "value": widget.currentRow.CDEMPRESA
        }];

        widget.getField('CDINSCMUNI').dataSourceFilter = [{
            "name": "CDEMPRESA",
            "operator": "=",
            "value": widget.currentRow.CDEMPRESA
        }];
    };

    this.reportRules = function (widget) {
        var widgetGrid = templateManager.container.getWidget('fis20600_grid');
        var report = widget.currentRow.REPORT;
        var fieldTipo = widget.getField('ENTRSAID');
        var fieldImposto = widget.getField('CDIMPOSTO');
        var fieldTipoOpe = widget.getField('CDTIPOOPER');

        if (report === 'DC') {
            fieldTipo.readOnly = false;
            //fieldTipoOpe.readOnly = true;

            fieldImposto.dataSourceFilter = [{
                "name": "IDFORMAPURNFE",
                "operator": "<>",
                "value": "P"
            }];
            widget.currentRow.CDIMPOSTO = null;
            widget.currentRow.SGIMPOSTONFE = null;
            fieldImposto.reload();

            widgetGrid.dataSource.name = 'fis_relatorios#/impostos_produto';
            widgetGrid.floatingControl.dataSourceName = 'impostos_produto';
        } else {
            if (report === 'DCE') {
                widgetGrid.dataSource.name = 'fis_relatorios#/impostos_produto_entrada';
                widgetGrid.floatingControl.dataSourceName = 'impostos_produto_entrada';
                fieldTipoOpe.dataSourceFilter = [{
                    "name": "IDENTRSAIDOP",
                    "operator": "=",
                    "value": "E"
                }];
            } else if (report === 'DCS') {
                widgetGrid.dataSource.name = 'fis_relatorios#/impostos_produto_saida';
                widgetGrid.floatingControl.dataSourceName = 'impostos_produto_saida';
                fieldTipoOpe.dataSourceFilter = [{
                    "name": "IDENTRSAIDOP",
                    "operator": "=",
                    "value": "S"
                }];
            }

            fieldImposto.dataSourceFilter = [{
                "name": "IDFORMAPURNFE",
                "operator": "=",
                "value": "P"
            }];
            widget.currentRow.CDIMPOSTO = null;
            widget.currentRow.SGIMPOSTONFE = null;
            fieldImposto.reload();

            fieldTipoOpe.readOnly = false;
            fieldTipoOpe.reload();

            fieldTipo.readOnly = true;
            widget.currentRow.ENTRSAID = null;
        }
        if (widgetGrid.dataSource.data.length === 500) delete widgetGrid.floatingControl;
    };

    this.tipoRules = function (widget) {
        var tipo = widget.currentRow.ENTRSAID;
        var field = widget.getField('CDTIPOOPER');

        if (tipo) {
            field.readOnly = false;
            field.dataSourceFilter = [{
                "name": "IDENTRSAIDOP",
                "operator": "=",
                "value": tipo
            }];
            field.reload();
        } else {
            //field.readOnly = true;
            field.dataSourceFilter = [];
        }
        widget.currentRow.CDTIPOOPER = null;
        widget.currentRow.NMTIPOOPER = null;
        widget.currentRow.IDENTRSAIDOP = null;
    };
};

Configuration(function (ContextRegister) {
    ContextRegister.register('Fis20600_RelatoriosCustomizavelImpostosProduto_Controller', Fis20600_RelatoriosCustomizavelImpostosProduto_Controller);
});

// FILE: ./assets/modules/relatorios/assets/js/controllers/fis00700_documentos_fiscais_Controller.js
function fis00700_documentos_fiscais_Controller(General, ScreenService, templateManager) {
    /**
    * Seta na tela o nome do fieldGrup para cada tipo de apuração selecionada
    * 
    * @param {object} widget widget de 
    * Documentos Fiscais 
    */
    this.setLabel = function (widget) {
        var WdgDocumentoFiscais = templateManager.container.widgets[0];
        var tipo = widget.widget.currentRow.TIPODEAPURACAO;
        if (tipo) {
            if (tipo == "1") {
                WdgDocumentoFiscais.fieldGroups[1].label = "Tipo de Apuração Federal";
                WdgDocumentoFiscais.currentRow.REPORT_NAME = null;
                this.limpaTela(WdgDocumentoFiscais);
                this.limpaCampos(WdgDocumentoFiscais);
            } else if (tipo == "2") {
                WdgDocumentoFiscais.fieldGroups[1].label = "Tipo de Apuração Estadual";
                WdgDocumentoFiscais.currentRow.REPORT_NAME = null;
                this.limpaTela(WdgDocumentoFiscais);
                this.limpaCampos(WdgDocumentoFiscais);
            } else {
                WdgDocumentoFiscais.fieldGroups[1].label = "Tipo de Apuração Nacional Simples";
                WdgDocumentoFiscais.currentRow.REPORT_NAME = null;
                this.limpaTela(WdgDocumentoFiscais);
                this.limpaCampos(WdgDocumentoFiscais);
            }
        } else {
            WdgDocumentoFiscais.fieldGroups[1].label = "Escolha Apuração";
            WdgDocumentoFiscais.currentRow.REPORT_NAME = null;
            this.limpaTela(WdgDocumentoFiscais);
            this.limpaCampos(WdgDocumentoFiscais);
        }
    };
    this.setFiltroImposto = function (tipo, widget) {
        if (tipo == "1") {
            widget.getField("SGIMPOSTONFE").dataSourceFilter[0].value = "F";
        } else if (tipo == "2") {
            widget.getField("SGIMPOSTONFE").dataSourceFilter[0].value = "E";
        } else {
            widget.getField("SGIMPOSTONFE").dataSourceFilter[0].operator = "IN";
            widget.getField("SGIMPOSTONFE").dataSourceFilter[0].value = ["M", "E"];
        }
    };

    /**
    * Fecha o popupa de tipo de Apuração
    * 
    * @param {object} widget widget de 
    * tipoRelatorioApuracao 
    */
    this.fecharPesquisa = function (widget) {
        ScreenService.closePopup();
    };

    /**
    *  Seta a listas de relatorios para cada tipo de apuração
    * 
    * @param {object} widget widget de 
    * Documentos Fiscais 
    */
    this.setDataRelatorio = function (widget) {
        var tipoApuracao = widget.currentRow.TIPODEAPURACAO;
        var WdgDocumentoFiscais = templateManager.container.getWidget("fis00700_documentos_fiscais");
        var data = this.datasRelatorio(tipoApuracao);
        this.setFiltroImposto(tipoApuracao, WdgDocumentoFiscais);

        WdgDocumentoFiscais.fields.forEach(function (field) {
            if (field.name == "REPORT_NAME") {
                field.dataSource.data = data;
            }
        });
        this.fecharPesquisa(widget);
    };
    /**
    *  Torna visível os campos para o relatório selecionado
    * 
    * @param {object} widget widget de 
    * Documentos Fiscais 
    */
    this.abreCamposRelatorio = function (widget) {
        this.limpaCampos(widget);
        var WdgFiltro = templateManager.container.getWidget("tipoRelatorioApuracao");
        var tipo = WdgFiltro.currentRow.TIPODEAPURACAO;
        var relatorio = widget.currentRow.REPORT_CODE;
        var campos = [];
        var camposNaoObrigat = [];
        if (!relatorio) {
            this.setaCampos(campos, widget);
        } else {
            if (tipo == "1") {
                this.layoutFederal(relatorio, widget, campos, camposNaoObrigat);
            }
            if (tipo == "2") {
                this.layoutEstadual(relatorio, widget, campos, camposNaoObrigat);
            }
            if (tipo == "3") {
                this.layoutNacionalSimples(relatorio, widget, campos, camposNaoObrigat);
            }
        }
    };
    /**
    *  Recarrega o popup para cada campo select simples
    * 
    * @param {object} field da widget de 
    * Documentos Fiscais 
    */

    this.reloadData = function (campo) {
        campo.reload();
    };
    /**
    *  Reseta os campo de cada relatorio apos selecionar novo relatório
    * 
    * @param {object} widget da widget de 
    * Documentos Fiscais 
    */
    this.limpaCamposPoEmpresa = function (widget) {
        widget.fields.forEach(function (field) {
            if (field.name != "REPORT_NAME") {
                if (field.name != "SGIMPOSTONFE") {
                    if (field.isVisible) {
                        this.clearCampo(field);
                    }
                }
            }
        }.bind(this));
        //this.setFiltroCampoDTINIPERIODO(widget);
    };

    this.limpaCampos = function (widget) {
        widget.fields.forEach(function (field) {
            if (field.name != "REPORT_NAME") {
                this.clearCampo(field);
            }
        }.bind(this));
    };
    /**
    *  Limpa os campo para qualquer tipo de field
    * 
    * @param {object} widget da widget de 
    * Documentos Fiscais 
    */
    this.clearCampo = function (field) {
        field.widget.currentRow[field.name] = "";
        field.formattedValue = "";
        field.currentDate = moment().startOf('month').startOf('day');
        if (field.change) {
            field.change();
        }
    };
    /**
    * Configura o campo obrigatorio por tipo de relatório
    * 
    * @param {object, string, string} widget da widget de 
    * Documentos Fiscais 
    */
    this.configCampos = function (relatorio, field, camposNaoObrigat) {
        var isRequired = camposNaoObrigat.includes(field.name);
        if (!isRequired) {
            field.validations = { "required": true };
        }
    };
    /**
    *  Seta campo de acordo com a regras para cada relatório
    * 
    * @param {object, object, array, int} widget da widget de 
    * Documentos Fiscais 
    */
    this.setaCampos = function (campos, widget) {
        var camposNaoObrigat = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
        var tipo = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 1;

        var ativo = false;
        var estadual = false;
        var federal = false;
        var relatorio = widget.currentRow.REPORT_CODE;
        if (relatorio) {
            campos.forEach(function (campo) {
                widget.fields.forEach(function (field) {
                    if (campo == field.name) {
                        field.isVisible = true;
                        this.configCampos(relatorio, field, camposNaoObrigat);
                        switch (tipo) {
                            case 1:
                                this.paramsFederal(widget);
                                break;
                            case 2:
                                this.paramsNacSimpEstadual(widget);
                                break;
                            case 3:
                                this.paramsNacSimples(widget);
                        }
                        // nessas horas que queria teste funcional.
                        // como não sei se da pra salvar algo disso daqui vou deixar comentado até validar a tela
                        // lua was here
                        /*ativo = field.widget.getField("CDINSCMUNI").isVisible;
                        if(ativo){
                             this.paramsMunicipal(widget);
                        }else{
                            estadual = field.widget.getField("CDINSCESTA").isVisible;
                        if(estadual){
                             this.paramsNacSimpEstadual(widget);
                        }else{
                            federal = field.widget.getField("NMLIVROMAG").isVisible;
                            if(federal){
                                 this.paramsFederal(widget);
                            }else{
                                 this.paramsNacSimples(widget);
                            }
                        }
                        }
                        if(campo == "NMLIVROMAG" && field.isVisible){
                         ativo = field.widget.getField("SGIMPOSTONFE").isVisible;
                        if(ativo){
                             this.paramsNacSimpEstadual(widget);
                        }else{
                             
                        }
                        }*/
                    }
                }.bind(this));
            }.bind(this));
        } else {
            this.limpaTela(widget);
        }
    };
    /**
    *  Busca o parametros por tipo de dataSources
    * 
    * @param {object} widget da widget de 
    * Documentos Fiscais 
    */
    this.paramsMunicipal = function (widget) {
        this.setFiltroMunicipal(widget, "DTINICIO");
        this.setFiltroMunicipal(widget, "DTFINAL");
    };
    /**
    *  Busca o parametros por tipo de dataSources
    * 
    * @param {object} widget da widget de 
    * Documentos Fiscais 
    */
    this.paramsNacSimpEstadual = function (widget) {
        this.setFiltroNacSimpEstadual(widget, "DTINICIO");
        this.setFiltroNacSimpEstadual(widget, "DTFINAL");
    };
    /**
    *  Busca o parametros por tipo de dataSources
    * 
    * @param {object} widget da widget de 
    * Documentos Fiscais 
    */
    this.paramsNacSimples = function (widget) {
        this.setFiltroSimples(widget, "DTINICIO");
        this.setFiltroSimples(widget, "DTFINAL");
    };
    /**
    *  Busca o parametros por tipo de dataSources
    * 
    * @param {object} widget da widget de 
    * Documentos Fiscais 
    */
    this.paramsFederal = function (widget) {
        this.setFiltroPadrao(widget, "DTINICIO");
        this.setFiltroPadrao(widget, "DTFINAL");
    };
    /**
    *  Realiza um tratamento e string retirando espaços em branco
    * 
    * @param {string} variavel da função do 
    * setFiltroIsento 
    */
    this.trataString = function (string) {
        var novaString = "";
        for (var i = 0; i < string.length; i++) {
            if (string[i] != " ") novaString = novaString + string[i];
        }
        return novaString;
    };
    /**
    * Seta o filtro dos fields de acordo com o relatorio selecionado
    * 
    * @param {object} widget da widget de 
    * Documentos Fiscais 
    */
    this.setFiltroNacSimpEstadual = function (widget, campo) {
        if (widget.getField(campo).dataSource.name != "fis#/crud/mapa_Estadual") {
            widget.getField(campo).dataSource.name = "fis#/crud/mapa_Estadual";
            widget.getField(campo).dataSourceFilter = [];
            var name = ["CDEMPRESA", "CDIMPOSTO", "CDINSCESTA"];
            var operator = ["=", "=", "="];
            var campoFiltro = ['CDEMPRESA', 'CDIMPOSTONFE', 'CDINSCESTA'];
            this.sintetizaFiltro(widget, campo, name, operator, campoFiltro);
        }
    };
    /**
    * Seta o filtro dos fields de acordo com o relatorio selecionado
    * 
    * @param {object} widget da widget de 
    * Documentos Fiscais 
    */
    this.setFiltroMunicipal = function (widget, campo) {
        if (widget.getField(campo).dataSource.name != "fis#/crud/mapa_Municipal") {
            widget.getField(campo).dataSource.name = "fis#/crud/mapa_Municipal";
            widget.getField(campo).dataSourceFilter = [];
            var name = ["CDEMPRESA"];
            var operator = ["="];
            var campoFiltro = ['CDEMPRESA'];
            this.sintetizaFiltro(widget, campo, name, operator, campoFiltro);
        }
    };
    /**
    * Seta o filtro dos fields de acordo com o relatorio selecionado
    * 
    * @param {object} widget da widget de 
    * Documentos Fiscais 
    */
    this.setFiltroSimples = function (widget, campo) {
        if (widget.getField(campo).dataSource.name != "fis#/crud/mapa_NacionalSimples") {
            widget.getField(campo).dataSource.name = "fis#/crud/mapa_NacionalSimples";
            widget.getField(campo).dataSourceFilter = [];
            var name = ["CDEMPRESA"];
            var operator = ["="];
            var campoFiltro = ['CDEMPRESA'];
            this.sintetizaFiltro(widget, campo, name, operator, campoFiltro);
        }
    };

    this.sintetizaFiltro = function (widget, campo, name, operator, campoFiltro) {
        var filtro = [];
        var str1 = "@General.getFieldValue(";
        var str2 = ", 'fis00700_documentos_fiscais')@";
        for (var i = 0; i < name.length; i++) {
            filtro = {
                "name": name[i],
                "operator": operator[i],
                "value": str1.concat('"' + campoFiltro[i] + '"').concat(str2)
            };
            widget.getField(campo).dataSourceFilter.push(filtro);
            filtro = [];
        }
    };

    this.setFiltroDTFINAL = function (widget) {
        var qtdFiltro = widget.getField("DTFINAL").dataSourceFilter.length;
        if (widget.getField("DTFINAL").dataSourceFilter[qtdFiltro - 1].name == "DTFIMPERIODO") {
            widget.getField("DTFINAL").dataSourceFilter.pop();
        }
        var name = ["DTFIMPERIODO"];
        var operator = [">"];
        var campoFiltro = ['DTINICIO'];
        this.sintetizaFiltro(widget, "DTFINAL", name, operator, campoFiltro);
    };
    /**
    * Seta o filtro dos fields de acordo com o relatorio selecionado
    * 
    * @param {object} widget da widget de 
    * Documentos Fiscais 
    */
    this.setFiltroPadrao = function (widget, campo) {
        //if(widget.getField(campo).dataSource.name != "fis#/crud/mapa_padrao"){
        widget.getField(campo).dataSource.name = "fis#/crud/mapa_padrao";
        widget.getField(campo).dataSourceFilter = [];
        var name = ["P_CDEMPRESA", "P_CDLIVROMAG"];
        var operator = ["=", "="];
        var campoFiltro = ['CDEMPRESA', "CDLIVROMAG"];
        this.sintetizaFiltro(widget, campo, name, operator, campoFiltro);
        //}
    };
    /**
    * Retira dos os fields se nenhum relatório for selecionado
    * 
    * @param {object} widget da widget de 
    * Documentos Fiscais 
    */
    this.limpaTela = function (widget) {
        widget.fields.forEach(function (field) {
            if (field.name != "REPORT_NAME") {
                field.isVisible = false;
                field.validations = {};
            }
        });
    };
    /**
    * Abre o popup para selecionar o tipo de apuração
    * 
    * @param {null}  
    */
    this.abriFiltro = function () {
        var fltro = templateManager.container.getWidget("tipoRelatorioApuracao");
        fltro.isVisible = true;
        ScreenService.openPopup(fltro);
    };

    /**
    * Trata o formato da data retirando a parte de horas
    * 
    * @param {object} widget da widget de 
    * Documentos Fiscais 
    */
    this.formataDataInicio = function (widget) {
        var data = widget.currentRow.DTINICIO;
        var corte = data.substring(0, 10);
        widget.currentRow.DTINICIO = corte;
    };
    /**
    * Trata o formato da data retirando a parte de horas
    * 
    * @param {object} widget da widget de 
    * Documentos Fiscais 
    */
    this.formataDataFinal = function (widget) {
        var data = widget.currentRow.DTFINAL;
        var corte = data.substring(0, 10);
        widget.currentRow.DTFINAL = corte;
    };
    /**
    * Verifica se a datra inicial é maior que a data final
    * 
    * @param {object} widget da widget de 
    * Documentos Fiscais 
    */
    this.validaData = function (currentRow) {
        var dataInicial = currentRow.DTINIPERIODO ? moment(currentRow.DTINIPERIODO, 'DD/MM/YYYY').format("DD/MM/YYYY") : null;
        var dataFinal = currentRow.DTFIMPERIODO ? moment(currentRow.DTFIMPERIODO, 'DD/MM/YYYY').format("DD/MM/YYYY") : null;
        var mensagem = "A data inicial deve ser menor ou igual a data final.";

        if (dataInicial && dataFinal && dataFinal < dataInicial) {
            ScreenService.showMessage(mensagem);
            return false;
        }
        return true;
    };
    /**
      * Realisa validação dos fiels da widget
      * 
      * @param {object, object, object} widget da widget de 
      * Documentos Fiscais 
      */
    this.validaCampos = function (currentRow, widget, args) {
        if (this.validaData(currentRow)) {
            if (widget.isValid()) {
                var row = currentRow.REPORT_CODE;
                General.openReportPopup(widget, this.abreRelatorio, [currentRow, args]);
                //this.abreRelatorio(currentRow, args);
            }
        }
    };
    /**
    * Gera o relatorio em PDF
    * 
    * @param {object, object widget da widget de 
    * Documentos Fiscais 
    */
    this.abreRelatorio = function (currentRow, args) {
        var relatorio = currentRow.REPORT_CODE;
        args.row.NRORG = getLocalVar('NRORG');
        General.openReport('fis_relatorios#/documentos_fiscais', relatorio, args.row);
    }.bind(this);
    /**
    * Configurações do realtorio por tipo de apuiração
    * 
    * @param {object, object, object}, object} widget da widget de 
    * Documentos Fiscais 
    */
    this.layoutFederal = function (relatorio, widget, campos, camposNaoObrigat) {
        if (relatorio == "FIS98001") {
            this.limpaTela(widget);
            campos = ["NMEMPRESA", "NMLIVROMAG", "DTINICIO", "DTFINAL", "NMPRODUTOINICIAL", "NMPRODUTOFINAL", "REGIME"];
            camposNaoObrigat = ["REGIME"];
            this.setaCampos(campos, widget, camposNaoObrigat, 1);
        }
        if (relatorio == "FIS98002") {
            this.limpaTela(widget);
            campos = ["NMEMPRESA", "NMLIVROMAG", "DTINICIO", "DTFINAL", "NMPRODUTOINICIAL", "NMPRODUTOFINAL", "REGIME"];
            camposNaoObrigat = ["REGIME"];
            this.setaCampos(campos, widget, camposNaoObrigat, 1);
        }
        if (relatorio == "FIS98003") {
            this.limpaTela(widget);
            campos = ["NMEMPRESA", "NMLIVROMAG", "DTINICIO", "DTFINAL", "NMPRODUTOINICIALFAMILIA", "NMPRODUTOFINALFAMILIA", "NVTOT", "LISTARPROD", "REGIME"];
            camposNaoObrigat = ["REGIME", "LISTARPROD"];
            this.setaCampos(campos, widget, camposNaoObrigat, 1);
        }
        if (relatorio == "FIS98004") {
            this.limpaTela(widget);
            campos = ["NMEMPRESA", "NMLIVROMAG", "DTINICIO", "DTFINAL", "NMPRODUTOINICIALFAMILIA", "NMPRODUTOFINALFAMILIA", "NVTOT", "LISTARPROD", "REGIME"];
            camposNaoObrigat = ["REGIME", "LISTARPROD"];
            this.setaCampos(campos, widget, camposNaoObrigat, 1);
        }
        if (relatorio == "FIS98005") {
            this.limpaTela(widget);
            campos = ["NMEMPRESA", "NMLIVROMAG", "DTINICIO", "DTFINAL"];
            this.setaCampos(campos, widget, camposNaoObrigat, 1);
        }
        if (relatorio == "FIS98006") {
            this.limpaTela(widget);
            campos = ["NMEMPRESA", "NMLIVROMAG", "DTINICIO", "DTFINAL", "REGIME"];
            camposNaoObrigat = ["REGIME"];
            this.setaCampos(campos, widget, camposNaoObrigat, 1);
        }
        if (relatorio == "FIS98007") {
            this.limpaTela(widget);
            campos = ["NMEMPRESA", "NMLIVROMAG", "DTINICIO", "DTFINAL", "REGIME"];
            camposNaoObrigat = ["REGIME"];
            this.setaCampos(campos, widget, camposNaoObrigat, 1);
        }
        if (relatorio == "FIS98009") {
            this.limpaTela(widget);
            campos = ["NMEMPRESA", "NMLIVROMAG", "DTINICIO", "DTFINAL"];
            camposNaoObrigat = ["REGIME"];
            this.setaCampos(campos, widget, camposNaoObrigat, 1);
        }
        if (relatorio == "FIS98011") {
            this.limpaTela(widget);
            campos = ["NMEMPRESA", "NMLIVROMAG", "DTINICIO", "DTFINAL", "NMPRODUTOINICIAL", "NMPRODUTOFINAL", "REGIME"];
            camposNaoObrigat = ["REGIME"];
            this.setaCampos(campos, widget, camposNaoObrigat, 1);
        }
    };
    /**
    * Configurações do realtorio por tipo de apuiração
    * 
    * @param {object, object, object}, object} widget da widget de 
    * Documentos Fiscais 
    */
    this.layoutEstadual = function (relatorio, widget, campos, camposNaoObrigat) {
        if (relatorio == "FII00100") {
            this.limpaTela(widget);
            campos = ["NMEMPRESA", "CDINSCESTA", "SGIMPOSTONFE", "DTINICIO", "DTFINAL", "NRPAGINA"];
            camposNaoObrigat = [];
            this.setaCampos(campos, widget, camposNaoObrigat, 2);
        }
        if (relatorio == "FII00300") {
            this.limpaTela(widget);
            campos = ["NMEMPRESA", "CDINSCESTA", "SGIMPOSTONFE", "DTINICIO", "DTFINAL", "NRPAGINA"];
            camposNaoObrigat = [];
            this.setaCampos(campos, widget, camposNaoObrigat, 2);
        }
        if (relatorio == "FII00303") {
            this.limpaTela(widget);
            campos = ["NMEMPRESA", "CDINSCESTA", "SGIMPOSTONFE", "DTINICIO", "DTFINAL"];
            camposNaoObrigat = [];
            this.setaCampos(campos, widget, camposNaoObrigat, 2);
        }
        if (relatorio == "FII00325") {
            this.limpaTela(widget);
            campos = ["NMEMPRESA", "CDINSCESTA", "SGIMPOSTONFE", "DTINICIO", "DTFINAL", "NRPAGINA"];
            camposNaoObrigat = [];
            this.setaCampos(campos, widget, camposNaoObrigat, 2);
        }
        if (relatorio == "FII00500") {
            this.limpaTela(widget);
            campos = ["NMEMPRESA", "CDINSCESTA", "SGIMPOSTONFE", "DTINICIO", "DTFINAL", "NRPAGINA", "NRLIVRO"];
            camposNaoObrigat = [];
            this.setaCampos(campos, widget, camposNaoObrigat, 2);
        }
        if (relatorio == "FII00600") {
            this.limpaTela(widget);
            campos = ["NMEMPRESA", "CDINSCESTA", "SGIMPOSTONFE", "DTINICIO", "DTFINAL", "NRPAGINA"];
            camposNaoObrigat = [];
            this.setaCampos(campos, widget, camposNaoObrigat, 2);
        }
        if (relatorio == "FII00800") {
            this.limpaTela(widget);
            campos = ["NMEMPRESA", "CDINSCESTA", "SGIMPOSTONFE", "DTINICIO", "DTFINAL", "NRPAGINA"];
            camposNaoObrigat = [];
            this.setaCampos(campos, widget, camposNaoObrigat, 2);
        }
        if (relatorio == "FII00802") {
            this.limpaTela(widget);
            campos = ["NMEMPRESA", "CDINSCESTA", "SGIMPOSTONFE", "DTINICIO", "DTFINAL"];
            camposNaoObrigat = [];
            this.setaCampos(campos, widget, camposNaoObrigat, 2);
        }
        if (relatorio == "FII00890") {
            this.limpaTela(widget);
            campos = ["NMEMPRESA", "CDINSCESTA", "SGIMPOSTONFE", "DTINICIO", "DTFINAL", "NRPAGINA"];
            camposNaoObrigat = [];
            this.setaCampos(campos, widget, camposNaoObrigat, 2);
        }
    };
    /**
    * Configurações do realtorio por tipo de apuiração
    * 
    * @param {object, object, object}, object} widget da widget de 
    * Documentos Fiscais 
    */
    this.layoutNacionalSimples = function (relatorio, widget, campos, camposNaoObrigat) {
        if (relatorio == "FIS60000") {
            this.limpaTela(widget);
            campos = ["NMEMPRESA", "CDINSCESTA", "SGIMPOSTONFE", "DTINICIO", "DTFINAL", "NRPAGINA", "NRLIVRO"];
            camposNaoObrigat = [];
            this.setaCampos(campos, widget, camposNaoObrigat, 3);
        }
        if (relatorio == "FIS60001") {
            this.limpaTela(widget);
            campos = ["NMEMPRESA", "CDINSCESTA", "SGIMPOSTONFE", "DTINICIO", "DTFINAL", "NRPAGINA", "NRLIVRO"];
            camposNaoObrigat = [];
            this.setaCampos(campos, widget, camposNaoObrigat, 3);
        }
        if (relatorio == "FIS60002") {
            this.limpaTela(widget);
            campos = ["NMEMPRESA", "CDINSCMUNI", "DTINICIO", "DTFINAL", "NRPAGINA"];
            camposNaoObrigat = [];
            this.setaCampos(campos, widget, camposNaoObrigat, 3);
        }
        if (relatorio == "FIS60003") {
            this.limpaTela(widget);
            campos = ["NMEMPRESA", "CDINSCMUNI", "DTINICIO", "DTFINAL", "NRPAGINA"];
            camposNaoObrigat = [];
            this.setaCampos(campos, widget, camposNaoObrigat, 3);
        }
        if (relatorio == "FIS60004") {
            this.limpaTela(widget);
            campos = ["NMEMPRESA", "CDINSCESTA", "SGIMPOSTONFE", "DTINICIO", "DTFINAL", "NRPAGINA"];
            camposNaoObrigat = [];
            this.setaCampos(campos, widget, camposNaoObrigat, 3);
        }
        if (relatorio == "FIS60005") {
            this.limpaTela(widget);
            campos = ["NMEMPRESA", "SGIMPOSTONFE", "DTINICIO", "DTFINAL", "NRPAGINA"];
            camposNaoObrigat = [];
            this.setaCampos(campos, widget, camposNaoObrigat, 3);
        }
    };
    /**
    * Seta o datasource do campo relatório por tipo de Apuração
    * 
    * @param {object} widget da widget de 
    * Documentos Fiscais 
    */
    this.datasRelatorio = function (tipo) {
        var federal = [{
            "name": "Registro de Entradas - Contribuições [Produtos]",
            "value": "FIS98001"
        }, {
            "name": "Registro de Saídas - Contribuições [Produtos]",
            "value": "FIS98002"
        }, {
            "name": "Registro de Entradas - Contribuições [Família de Produtos]",
            "value": "FIS98003"
        }, {
            "name": "Registro de Saídas - Contribuições [Família de Produtos]",
            "value": "FIS98004"
        }, {
            "name": "Registro de Apuração Contribuições",
            "value": "FIS98005"
        }, {
            "name": "Registro de Entradas - Contribuições",
            "value": "FIS98006"
        }, {
            "name": "Registro de Saídas - Contribuições",
            "value": "FIS98007"
        }, {
            "name": "Benfeitoria/Amortização por Periodo",
            "value": "FIS98009"
        }, {
            "name": "Natureza da Receita por Produto",
            "value": "FIS98011"
        }];
        var estadual = [{
            "name": "Registro de Entradas",
            "value": "FII00100"
        }, {
            "name": "Registro de Saídas",
            "value": "FII00300"
        }, {
            "name": "Registro de Saídas - Crédito Presumido",
            "value": "FII00303"
        }, {
            "name": "Registro de Saídas - Carga Tributária",
            "value": "FII00325"
        }, {
            "name": "Registro de Entradas (Industria)",
            "value": "FII00500"
        }, {
            "name": "Registro de Saídas (Industria)",
            "value": "FII00600"
        }, {
            "name": "Registro de Apuração de ICMS",
            "value": "FII00800"
        }, {
            "name": "Registro de Apuração Não Contribuinte (FCP e DIFAL)",
            "value": "FII00802"
        }, {
            "name": "Registro de Apuração - Carga Tributária",
            "value": "FII00890"
        }];
        var nacionalSimples = [{
            "name": "Registro de Entradas",
            "value": "FIS60000"
        }, {
            "name": "Registro de Saídas",
            "value": "FIS60001"
        }, {
            "name": "Registro de Serviços Tomados",
            "value": "FIS60002"
        }, {
            "name": "Registro de Serviços Prestados",
            "value": "FIS60003"
        }, {
            "name": "Registro de Apuração ICMS",
            "value": "FIS60004"
        }, {
            "name": "Resumo de Apuração do Simples Nacional",
            "value": "FIS60005"
        }];
        if (tipo == "1") {
            return federal;
        } else if (tipo == "2") {
            return estadual;
        } else if (tipo == "3") {
            return nacionalSimples;
        } else {
            return [];
        }
    };
}
Configuration(function (ContextRegister) {
    ContextRegister.register('fis00700_documentos_fiscais_Controller', fis00700_documentos_fiscais_Controller);
});

// FILE: ./assets/modules/relatorios/assets/js/controllers/fis96000_conferencia_fiscal_Controller.js
var fis96000_conferencia_fiscal_Controller = function fis96000_conferencia_fiscal_Controller(ZHPromise, General, templateManager, ScreenService, ZhFilterPreferences, Messages_fiscal) {
    var self = this; // Variável para guardar o escopo atual nas funções.
    var windowCurrentlyOpen = false; // Variável de controle para o armazenamento da widget atualmente aberta.
    var PERIODO = false; // Armazena o período do filtro atual. Serve para se transferir os valores para o próximo filtro
    var CDTIPOOPER = false; // Armazena o tipo de operação do filtro atual. Serve para se transferir os valores para o próximo filtro
    var IDENTRSAIDOP_AR = false;
    var APPLIEDFILTER = false; // Armazena o filtro aplicado

    /*
     * Função que verifica o clique em uma das opções disponíveis na widget
     * principal. Determina se um swipe será aberto ou não, dependendo da
     * opção selecionada.
     */
    this.mainWidgetAfterMoveRow = function (widget) {
        // Guarda o nome da widget relacionada à opção clicada, se houver.
        var windowToOpen = widget.currentRow.WINDOW;
        // Guarda a propriedade "ENABLED" da opção selecionada.
        var windowEnabled = widget.currentRow.ENABLED;

        // Verifica se há uma widget associada (não for um submenu) e se esta está habilitada (a tela estiver disponível para ser utilizada).
        if (windowToOpen && windowEnabled) {
            // Verifica se já há uma widget aberta e se esta é diferente da selecionada.
            if (windowCurrentlyOpen && windowCurrentlyOpen != windowToOpen) {
                // Fecha o swipe com a widget já aberta.
                self.closeSwipe(templateManager.container.getWidget(windowCurrentlyOpen)).then(function () {
                    // Abre o swipe na widget selecionada.
                    ScreenService.openSwipe(templateManager.container.getWidget(windowToOpen));
                });
            } else {
                // Senão, abre o swipe na opção selecionada.
                // Abre o swipe na widget selecionada.
                ScreenService.openSwipe(templateManager.container.getWidget(windowToOpen));
            }
            // Altera a variável de controle da widget atualmente aberta.
            windowCurrentlyOpen = windowToOpen;
        } else // Senão, verifica se não há a propriedade "ENABLED" na opção selecionada, indicando que é um submenu.
            if (windowEnabled !== false) {
                // Altera o estado aberto/fechado do submenu.
                widget.currentRow._opened = !widget.currentRow._opened;
            }
    };

    /* Função para sair de uma "tela" e retornar à widget principal. */
    this.closeSwipe = function (widget) {
        // Prepara uma promise para esta função.
        var deferred = ZHPromise.defer();
        var mainWidget = templateManager.container.getWidget("mainWidget");

        // Desativa a widget atualmente aberta.
        widget.deactivate();

        // Limpa a variável que indica qual a widget atualmente aberta.
        windowCurrentlyOpen = false;

        // Fecha o swipe.
        ScreenService.goBack().then(function () {
            // Ativa a widget principal.
            mainWidget.activate();
            // Finaliza a promise retornada.
            deferred.resolve();
        });
        // Retorna a promise preparada.
        return deferred.promise;
    };

    /*Abre o filtro*/
    this.openFilter = function (args, nmWidget) {
        //todo fazer genérica
        var filteredWidget = templateManager.container.getWidget(nmWidget);
        var rowsToSet = filteredWidget.appliedFilter || { FILTER_ROW: {} };
        rowsToSet.FILTER_ROW.IDENTRSAIDOP = null;

        ZhFilterPreferences.openFilterWidget(filteredWidget, rowsToSet.FILTER_ROW);
    };

    /*Ajusta Campos após filtro aplicado - apenas para Pendências de Fechamento*/
    this.filter = function (args, widgetIndex) {
        var dataSourceFilter = args.owner.dataSourceFilter;
        var filterPende = []; //nf_pendente_aprovacao_transmissao
        var filterCupom = []; //fechamento_cupom_pendente
        var filterIncid = []; //conferencia_nf_sem_incidencia
        var i;

        //Percorre o filtro principal a procura de campos correspondentes
        for (i = 0; i < dataSourceFilter.length; ++i) {
            //Adiciona somente os filtros de interesse para a query de coferencia de cupom fechado
            switch (dataSourceFilter[i].name) {
                //Filtros comuns para todos
                case "PERIODO":

                    filterPende.push({ "name": "DTINIPERIODO", "operator": "=", "value": dataSourceFilter[i].value[0] });
                    filterPende.push({ "name": "DTFIMPERIODO", "operator": "=", "value": dataSourceFilter[i].value[1] });

                    filterCupom.push({ "name": "DTINIPERIODO", "operator": "=", "value": dataSourceFilter[i].value[0] });
                    filterCupom.push({ "name": "DTFIMPERIODO", "operator": "=", "value": dataSourceFilter[i].value[1] });

                    filterIncid.push({ "name": "DTINIPERIODO", "operator": "=", "value": dataSourceFilter[i].value[0] });
                    filterIncid.push({ "name": "DTFIMPERIODO", "operator": "=", "value": dataSourceFilter[i].value[1] });

                    break;
                case "CDEMPRESA":
                case "CDIMPOSTONFE":
                case "CDINSCESTA":
                case "CDINSCMUNI":
                    filterPende.push(dataSourceFilter[i]);
                    filterCupom.push(dataSourceFilter[i]);
                    filterIncid.push(dataSourceFilter[i]);
                    break;
                //Filtros exlusivos do nf_pendente_aprovacao_transmissao
                case "CDMODDOCFISC":
                    //case "CDTIPOOPER":
                    filterPende.push(dataSourceFilter[i]);
                    break;
                case "IDENTRSAIDOP":
                    filterPende.push(dataSourceFilter[i]);
                    filterIncid.push(dataSourceFilter[i]);
                    break;
            }
        }

        //*Aquisição de widgets
        var widgetOrigem = args.owner.getParent().widgets[widgetIndex];
        var widgetPende = templateManager.container.getWidget('nf_pendente_aprovacao_transmissao'); //nf_pendente_aprovacao_transmissao
        var widgetCupom = templateManager.container.getWidget('fechamento_cupom_pendente'); //fechamento_cupom_pendente
        var widgetIncid = templateManager.container.getWidget('conferencia_nf_sem_incidencia'); //conferencia_nf_sem_incidencia

        widgetCupom.appliedFilter = widgetOrigem.appliedFilter;
        widgetPende.appliedFilter = widgetOrigem.appliedFilter;
        widgetIncid.appliedFilter = widgetOrigem.appliedFilter;

        //Atualiza e ajusta os demais filtros de acorda com a widget de oprigem
        switch (widgetIndex) {
            case 0:
                //nf_pendente_aprovacao_transmissao
                //Cupom
                widgetCupom.appliedFilter = widgetOrigem.appliedFilter;
                widgetCupom.dataSourceFilter = filterCupom;
                //widgetCupom.reload();

                widgetCupom.getField("CDINSCESTA").readOnly = !widgetOrigem.appliedFilter.FILTER_ROW.CDINSCESTA;
                widgetCupom.getField("CDINSCESTA").dataSourceFilter = [{ name: "CDEMPRESA", operator: "=", value: widgetOrigem.appliedFilter.FILTER_ROW.CDEMPRESA }];
                widgetCupom.getField("CDINSCESTA").reload();

                widgetCupom.getField("CDINSCMUNI").readOnly = !widgetOrigem.appliedFilter.FILTER_ROW.CDINSCMUNI;
                widgetCupom.getField("CDINSCMUNI").dataSourceFilter = [{ name: "CDEMPRESA", operator: "=", value: widgetOrigem.appliedFilter.FILTER_ROW.CDEMPRESA }];
                widgetCupom.getField("CDINSCMUNI").reload();
                //Incid
                widgetIncid.appliedFilter = widgetOrigem.appliedFilter;
                widgetIncid.dataSourceFilter = filterIncid;
                //widgetIncid.reload();

                widgetIncid.getField("CDINSCESTA").readOnly = false; //!widgetOrigem.appliedFilter.FILTER_ROW.CDINSCESTA;
                widgetIncid.getField("CDINSCESTA").dataSourceFilter = [{ name: "CDEMPRESA", operator: "=", value: widgetOrigem.appliedFilter.FILTER_ROW.CDEMPRESA }];
                widgetIncid.getField("CDINSCESTA").reload();

                widgetIncid.getField("CDINSCMUNI").readOnly = false; //!widgetOrigem.appliedFilter.FILTER_ROW.CDINSCMUNI;
                widgetIncid.getField("CDINSCMUNI").dataSourceFilter = [{ name: "CDEMPRESA", operator: "=", value: widgetOrigem.appliedFilter.FILTER_ROW.CDEMPRESA }];
                widgetIncid.getField("CDINSCMUNI").reload();

                widgetOrigem.dataSourceFilter = filterPende;
                widgetOrigem.reload();
                break;
            case 1:
                //fechamento_cupom_pendente
                //Pende
                widgetPende.appliedFilter = widgetOrigem.appliedFilter;
                widgetPende.dataSourceFilter = filterPende;
                //widgetPende.reload();

                widgetPende.getField("CDINSCESTA").readOnly = !widgetOrigem.appliedFilter.FILTER_ROW.CDINSCESTA;
                widgetPende.getField("CDINSCESTA").dataSourceFilter = [{ name: "CDEMPRESA", operator: "=", value: widgetOrigem.appliedFilter.FILTER_ROW.CDEMPRESA }];
                widgetPende.getField("CDINSCESTA").reload();

                widgetPende.getField("CDINSCMUNI").readOnly = !widgetOrigem.appliedFilter.FILTER_ROW.CDINSCMUNI;
                widgetPende.getField("CDINSCMUNI").dataSourceFilter = [{ name: "CDEMPRESA", operator: "=", value: widgetOrigem.appliedFilter.FILTER_ROW.CDEMPRESA }];
                widgetPende.getField("CDINSCMUNI").reload();
                //Incid
                widgetIncid.appliedFilter = widgetOrigem.appliedFilter;
                widgetIncid.dataSourceFilter = filterIncid;
                //widgetIncid.reload();

                widgetIncid.getField("CDINSCESTA").readOnly = false; //!widgetOrigem.appliedFilter.FILTER_ROW.CDINSCESTA;
                widgetIncid.getField("CDINSCESTA").dataSourceFilter = [{ name: "CDEMPRESA", operator: "=", value: widgetOrigem.appliedFilter.FILTER_ROW.CDEMPRESA }];
                widgetIncid.getField("CDINSCESTA").reload();

                widgetIncid.getField("CDINSCMUNI").readOnly = false; //!widgetOrigem.appliedFilter.FILTER_ROW.CDINSCMUNI;
                widgetIncid.getField("CDINSCMUNI").dataSourceFilter = [{ name: "CDEMPRESA", operator: "=", value: widgetOrigem.appliedFilter.FILTER_ROW.CDEMPRESA }];
                widgetIncid.getField("CDINSCMUNI").reload();

                widgetOrigem.dataSourceFilter = filterCupom;
                widgetOrigem.reload();
                break;
            case 2:
                //conferencia_nf_sem_incidencia
                //Cupom
                widgetCupom.appliedFilter = widgetOrigem.appliedFilter;
                widgetCupom.dataSourceFilter = filterCupom;
                //widgetCupom.reload();

                widgetCupom.getField("CDINSCESTA").readOnly = !widgetOrigem.appliedFilter.FILTER_ROW.CDINSCESTA;
                widgetCupom.getField("CDINSCESTA").dataSourceFilter = [{ name: "CDEMPRESA", operator: "=", value: widgetOrigem.appliedFilter.FILTER_ROW.CDEMPRESA }];
                widgetCupom.getField("CDINSCESTA").reload();

                widgetCupom.getField("CDINSCMUNI").readOnly = !widgetOrigem.appliedFilter.FILTER_ROW.CDINSCMUNI;
                widgetCupom.getField("CDINSCMUNI").dataSourceFilter = [{ name: "CDEMPRESA", operator: "=", value: widgetOrigem.appliedFilter.FILTER_ROW.CDEMPRESA }];
                widgetCupom.getField("CDINSCMUNI").reload();
                //Pende
                widgetPende.appliedFilter = widgetOrigem.appliedFilter;
                widgetPende.dataSourceFilter = filterPende;
                //widgetPende.reload();

                widgetPende.getField("CDINSCESTA").readOnly = !widgetOrigem.appliedFilter.FILTER_ROW.CDINSCESTA;
                widgetPende.getField("CDINSCESTA").dataSourceFilter = [{ name: "CDEMPRESA", operator: "=", value: widgetOrigem.appliedFilter.FILTER_ROW.CDEMPRESA }];
                widgetPende.getField("CDINSCESTA").reload();

                widgetPende.getField("CDINSCMUNI").readOnly = !widgetOrigem.appliedFilter.FILTER_ROW.CDINSCMUNI;
                widgetPende.getField("CDINSCMUNI").dataSourceFilter = [{ name: "CDEMPRESA", operator: "=", value: widgetOrigem.appliedFilter.FILTER_ROW.CDEMPRESA }];
                widgetPende.getField("CDINSCMUNI").reload();

                widgetOrigem.dataSourceFilter = filterIncid;
                widgetOrigem.reload();
                break;
        }

        //Remove o CDTIPOOPER para evitar conflitos no filtro
        /*for( i = dataSourceFilter.length - 1; i >= 0; i-- )
          if ( dataSourceFilter[i].name == 'CDTIPOOPER')
            dataSourceFilter.splice( i, 1 );*/
        //args.e.preference.FILTER_ROW.CDTIPOOPER = [];

        args.e.preference.FILTER_ROW.CDTIPOOPER = CDTIPOOPER; //Recupera o Valor do Filtro
        args.e.preference.FILTER_ROW.IDENTRSAIDOP_AR = IDENTRSAIDOP_AR; //Recupera o Valor do Filtro
        widgetOrigem.reload();
    };

    /*Trata o 'IN' para o tipo operação vs entr/saida (não relacio0nado ao campo Entrada / Saída IDENTRSAIDOP )*/
    this.ajustaCdtipooper = function (args) {
        var Filter = args.e.preference.FILTER_ROW;
        var TipooperEntrsaid = [];

        CDTIPOOPER = Filter.CDTIPOOPER; //Salva o filtro para os filtros da demais widgets
        IDENTRSAIDOP_AR = Filter.IDENTRSAIDOP_AR; //Salva o filtro para os filtros da demais widgets

        if (Filter.hasOwnProperty('CDTIPOOPER')) {
            //Verifica a existência deste campo
            if (Filter.CDTIPOOPER && Filter.CDTIPOOPER.length != 0) {
                //Verifica se houve alhguma opção selecionado (este campo não é required)
                for (var i = 0; i < Filter.CDTIPOOPER.length; ++i) {
                    //Monta o array concatenado
                    TipooperEntrsaid[i] = Filter.IDENTRSAIDOP_AR[i] + Filter.CDTIPOOPER[i];
                }
                Filter.CDTIPOOPER = TipooperEntrsaid;
            }
        }
    };

    /*Adiciona as datas de inio e fim a partir do campo PERIODO e o remove*/
    this.manipulaFilter = function (args) {
        var Filter = args.e.preference.FILTER_ROW;
        var DataSourceFilter = [];

        //Trata o filtro de período de datas
        if (Filter.hasOwnProperty('PERIODO')) {
            /*args.owner.dataSourceFilter[1] = {"name": "DTINIPERIODO", "operator": "=", "value": Filter.PERIODO.start};
            args.owner.dataSourceFilter[2] = {"name": "DTFIMPERIODO", "operator": "=", "value": Filter.PERIODO.end  };*/
            DataSourceFilter.push({ "name": "DTINIPERIODO", "operator": "=", "value": Filter.PERIODO.start });
            DataSourceFilter.push({ "name": "DTFIMPERIODO", "operator": "=", "value": Filter.PERIODO.end });
            PERIODO = Filter.PERIODO;
            delete Filter.PERIODO;
        }

        //Trata o 'IN' para o tipo operação vs entr/saida (não relacio0nado ao campo Entrada / Saída IDENTRSAIDOP )
        var TipooperEntrsaid = [];
        if (Filter.hasOwnProperty('CDTIPOOPER')) {
            //Verifica a existência deste campo
            if (Filter.CDTIPOOPER.length == 0) {
                //Verifica se houve alguma opção selecionado (este campo não é required)
                CDTIPOOPER = false;
                IDENTRSAIDOP_AR = false;
            } else {
                for (var i = 0; i < Filter.CDTIPOOPER.length; ++i) {
                    //Monta o array concatenado
                    TipooperEntrsaid[i] = Filter.IDENTRSAIDOP_AR[i] + Filter.CDTIPOOPER[i];
                }
                CDTIPOOPER = Filter.CDTIPOOPER; //Salva o filtro para os filtros da demais widgets
                IDENTRSAIDOP_AR = Filter.IDENTRSAIDOP_AR; //Salva o filtro para os filtros da demais widgets
                DataSourceFilter.push({ "name": "TIPOOPER_ENTRSAID", "operator": "IN", "value": TipooperEntrsaid });
            }
            delete Filter.CDTIPOOPER;
            delete Filter.IDENTRSAIDOP_AR;
            delete Filter.NMTIPOOPER;
        }

        args.owner.dataSourceFilter = DataSourceFilter;
    };

    /*Realiza o filtro da tela/relatório nf_periodo_mapa*/
    this.filtra_nf_periodo_mapa = function (args, widgetIndex) {
        APPLIEDFILTER = args.owner.appliedFilter;

        //Aquisição de widgets nf_periodo_mapa_nf_fora_periodo e nf_periodo_mapa_nf_sem_mapa
        var widgetOrigem = args.owner.getParent().widgets[widgetIndex];
        var widgetDestino = args.owner.getParent().widgets[widgetIndex == 0 ? 1 : 0];

        widgetDestino.appliedFilter = widgetOrigem.appliedFilter;
        if (PERIODO) {
            //Adiciona o período informado no filtro anterior para este vir preechido no filtro seguinte.
            widgetDestino.appliedFilter.FILTER_ROW.PERIODO = PERIODO;
        }
        if (CDTIPOOPER) {
            widgetDestino.appliedFilter.FILTER_ROW.CDTIPOOPER = CDTIPOOPER;
        }
        if (IDENTRSAIDOP_AR) {
            widgetDestino.appliedFilter.FILTER_ROW.IDENTRSAIDOP_AR = IDENTRSAIDOP_AR;
        }
        widgetDestino.dataSourceFilter = args.owner.dataSourceFilter;
        widgetDestino.reload();

        //widgetDestino.getField( "CDINSCESTA" ).readOnly = false;
        widgetDestino.getField("CDINSCESTA").readOnly = !widgetOrigem.appliedFilter.FILTER_ROW.CDINSCESTA;
        widgetDestino.getField("CDINSCESTA").dataSourceFilter = [{ name: "CDEMPRESA", operator: "=", value: widgetOrigem.appliedFilter.FILTER_ROW.CDEMPRESA }];
        widgetDestino.getField("CDINSCESTA").reload();

        //widgetDestino.getField( "CDINSCMUNI" ).readOnly = false;
        widgetDestino.getField("CDINSCMUNI").readOnly = !widgetOrigem.appliedFilter.FILTER_ROW.CDINSCMUNI;
        widgetDestino.getField("CDINSCMUNI").dataSourceFilter = [{ name: "CDEMPRESA", operator: "=", value: widgetOrigem.appliedFilter.FILTER_ROW.CDEMPRESA }];
        widgetDestino.getField("CDINSCMUNI").reload();
    };

    /*Controla os campos de inscrição estadual e municipal de acordo com a empresa e o imposto*/
    this.controlaCampoInscricao = function (args) {
        var cdEmpresa = args.owner.field.widget.currentRow.CDEMPRESA || "";
        var cdImposto = args.owner.field.widget.currentRow.CDIMPOSTONFE || "";

        var widget = args.owner.field.widget;

        var sgImposto = args.owner.field.widget.getField('SGIMPOSTONFE');

        var ativa = function ativa(widget, nmField) {
            var field = widget.getField(nmField);
            field.readOnly = false;
            field.validations = { required: true };
        };
        var desativa = function desativa(widget, nmField) {
            var field = widget.getField(nmField);
            field.clearValue();
            field.readOnly = true;
            field.validations = {};
            widget.currentRow[nmField] = "";
        };
        var setFilter = function setFilter(nmField, cdEmpresa) {
            var field = widget.getField(nmField);
            if (cdEmpresa) {
                field.dataSourceFilter = [{ name: "CDEMPRESA", operator: "=", value: cdEmpresa }];
                field.reload();
            } else {
                field.clearValue();
            }
        };

        //Verifica se ambos campos estão preenchido para prosseguir
        if (cdEmpresa && cdImposto) {
            //Os campos IDORGARRECADNFE e IDFORMAPURNFE devem estar preenchidos
            var tpInscr = widget.currentRow.IDORGARRECADNFE || "";
            var idFApur = widget.currentRow.IDFORMAPURNFE || "";
            if (!idFApur || !tpInscr) {
                var imp = widget.currentRow.CDIMPOSTONFE + " - " + widget.currentRow.SGIMPOSTONFE;
                var msg = Messages_fiscal.IMPOSTO_REL_SEM_PARAM.replace("#1", imp);
                ScreenService.showMessage(msg);
                sgImposto.clearValue();
            }
            //Seta o campo correspondente ao tipo de imposto
            switch (tpInscr) {
                case 'M':
                    //Inscrição Municipal
                    ativa(widget, 'CDINSCMUNI');
                    desativa(widget, 'CDINSCESTA');
                    setFilter('CDINSCMUNI', cdEmpresa);
                    break;
                case 'E':
                    //Inscrição Estadual
                    ativa(widget, 'CDINSCESTA');
                    desativa(widget, 'CDINSCMUNI');
                    setFilter('CDINSCESTA', cdEmpresa);
                    break;
                default:
                    desativa(widget, 'CDINSCESTA');
                    desativa(widget, 'CDINSCMUNI');
            }
        } else {
            desativa(widget, 'CDINSCESTA');
            desativa(widget, 'CDINSCMUNI');
        }
    };
    this.controlaCampoInscricao2 = function (args) {
        var cdEmpresa = args.owner.field.widget.currentRow.CDEMPRESA || "";
        var widget = args.owner.field.widget;

        var setFilter = function setFilter(nmField, cdEmpresa) {
            var field = widget.getField(nmField);
            if (cdEmpresa) {
                field.dataSourceFilter = [{ name: "CDEMPRESA", operator: "=", value: cdEmpresa }];
                field.reload();
            } else {
                field.clearValue();
            }
        };

        //Seta o campo correspondente ao tipo de imposto
        setFilter('CDINSCMUNI', cdEmpresa);
        setFilter('CDINSCESTA', cdEmpresa);
    };

    this.entradaSaida = function (args) {
        var entsaid = args.row.IDENTRSAIDOP;
        var cdtipooper = args.owner.getParent().getParent().getField('CDTIPOOPER');

        if (entsaid != "A") {
            cdtipooper.dataSourceFilter = [{
                "name": "IDENTRSAIDOP",
                "operator": "=",
                "value": entsaid
            }];
        } else {
            cdtipooper.dataSourceFilter = [];
        }

        cdtipooper.reload();
    };

    /**
    * Verifica se a datra inicial é maior que a data final
    * 
    * @param {object} widget da widget de 
    * Documentos Fiscais 
    */
    this.validaData = function (currentRow) {
        var dataInicial = currentRow.DTINIPERIODO ? moment(currentRow.DTINIPERIODO, 'DD/MM/YYYY').format("DD/MM/YYYY") : null;
        var dataFinal = currentRow.DTFIMPERIODO ? moment(currentRow.DTFIMPERIODO, 'DD/MM/YYYY').format("DD/MM/YYYY") : null;
        var mensagem = "A data inicial deve ser menor ou igual a data final.";

        if (dataInicial && dataFinal && dataFinal < dataInicial) {
            ScreenService.showMessage(mensagem);
            return false;
        }
        return true;
    };
    /**
       * Realisa validação dos fiels da widget
       * 
       * @param {object, object, object} widget da widget de 
       * Documentos Fiscais 
       */
    this.validaCampos = function (currentRow, widget, args) {
        currentRow.REPORT_CODE = 'FIS96035';
        currentRow.DTINICIO = currentRow.PERIODO.start;
        currentRow.DTFINAL = currentRow.PERIODO.end;
        if (this.validaData(currentRow)) {
            if (widget.isValid()) {
                General.openReportPopup(widget, this.abreRelatorio, [currentRow, args]);
                //this.abreRelatorio(currentRow, args);
            }
        }
    };
    /**
    * Gera o relatorio em PDF
    * 
    * @param {object, object widget da widget de 
    * Documentos Fiscais 
    */
    this.abreRelatorio = function (currentRow, args) {
        var relatorio = currentRow.REPORT_CODE;
        General.openReport('fis_relatorios#/relatorio_apuracao_imposto', relatorio, args.row);
    }.bind(this);

    /*Ajusta a visibilidade dos campos de inscrição estadual e municipal*/
    /*Fora de uso WidgetOnEnter*/
    /*this.ajsutaInscReadOnly = function( args ) {
        if( APPLIEDFILTER ) {
            args.owner.appliedFilter = APPLIEDFILTER;
            if( PERIODO ){ //Adiciona o período informado no filtro anterior para este vir preechido no filtro seguinte.
                args.owner.appliedFilter.FILTER_ROW.PERIODO = PERIODO;
            }
            
            args.owner.getField( "CDINSCESTA" ).readOnly = !args.owner.appliedFilter.FILTER_ROW.CDINSCESTA;
            args.owner.getField( "CDINSCESTA" ).dataSourceFilter = 
                [ { name: "CDEMPRESA", operator: "=", value: args.owner.appliedFilter.FILTER_ROW.CDEMPRESA } ];
            args.owner.getField( "CDINSCESTA" ).reload();
            
            args.owner.getField( "CDINSCMUNI" ).readOnly = !args.owner.appliedFilter.FILTER_ROW.CDINSCMUNI;
            args.owner.getField( "CDINSCMUNI" ).dataSourceFilter = 
                [ { name: "CDINSCMUNI", operator: "=", value: args.owner.appliedFilter.FILTER_ROW.CDEMPRESA } ];
            args.owner.getField( "CDINSCMUNI" ).reload();
        }
    };*/
};

/* global Configuration */
Configuration(function (ContextRegister) {
    ContextRegister.register('fis96000_conferencia_fiscal_Controller', fis96000_conferencia_fiscal_Controller);
});
//# sourceMappingURL=app.js.map
